/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Y=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/path","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/base/common/errors","vs/base/common/uri","vs/base/common/network","vs/base/common/platform","vs/base/node/pfs","vs/platform/instantiation/common/instantiation","vs/base/common/types","vs/base/common/event","vs/platform/log/common/log","vs/base/common/buffer","vs/platform/files/common/files","vs/base/common/objects","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/strings","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/arrays","vs/platform/registry/common/platform","vs/base/common/cancellation","vs/platform/configuration/common/configuration","vs/base/common/errorMessage","vs/base/common/uuid","vs/platform/configuration/common/configurationRegistry","vs/base/common/extpath","os","child_process","vs/base/common/process","vs/platform/product/common/product","vs/platform/telemetry/common/telemetry","vs/base/common/stream","fs","vs/base/parts/ipc/common/ipc","vs/platform/extensions/common/extensions","vs/base/common/semver/semver","vs/platform/product/common/productService","vs/base/node/zip","vs/base/common/decorators","vs/base/common/map","vs/base/node/decoder","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/node/watcher/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/localizations/common/localizations","vs/platform/files/common/io","vs/platform/request/common/request","vs/platform/telemetry/common/telemetryUtils","vs/base/common/assert","vs/base/common/json","vs/base/common/console","vs/base/common/marshalling","vs/base/common/glob","vs/base/common/labels","vs/base/node/extpath","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/storage/common/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensionManagement/node/extensionsScanner","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","path","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/files/node/watcher/win32/csharpWatcherService","vs/platform/files/node/watcher/win32/watcherService","vs/platform/instantiation/common/graph","vs/platform/download/common/download","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/environment/node/shellEnv","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/localizations/node/localizations","vs/platform/log/node/spdlogLog","vs/platform/files/common/fileService","vs/platform/files/node/diskFileSystemProvider","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/storage/common/storage","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/telemetry/node/appInsightsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionsScanner","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","string_decoder","vs/base/common/normalization","vs/platform/environment/node/argvHelper","crypto","vs/base/common/iterator","vs/base/common/performance","yauzl","yazl","zlib","vs/code/node/cliProcessMain","graceful-fs"],ee=function(q){for(var t=[],O=0,D=q.length;O<D;O++)t[O]=Y[q[O]];return t};define(Y[57],ee([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ok=void 0;function O(D,w){if(!D)throw new Error(w?`Assertion failed (${w})`:"Assertion Failed")}t.ok=O}),define(Y[44],ee([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function O(F){return(L,u,h)=>{let g=null,p=null;if(typeof h.value=="function"?(g="value",p=h.value):typeof h.get=="function"&&(g="get",p=h.get),!p)throw new Error("not supported");h[g]=F(p,u)}}t.createDecorator=O;function D(F,L,u){let h=null,g=null;if(typeof u.value=="function"?(h="value",g=u.value,g.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof u.get=="function"&&(h="get",g=u.get),!g)throw new Error("not supported");const p=`$memoize$${L}`;u[h]=function(...m){return this.hasOwnProperty(p)||Object.defineProperty(this,p,{configurable:!1,enumerable:!1,writable:!1,value:g.apply(this,m)}),this[p]}}t.memoize=D;function w(F,L,u){return O((h,g)=>{const p=`$debounce$${g}`,m=`$debounce$result$${g}`;return function(...R){this[m]||(this[m]=u?u():void 0),clearTimeout(this[p]),L&&(this[m]=L(this[m],...R),R=[this[m]]),this[p]=setTimeout(()=>{h.apply(this,R),this[m]=u?u():void 0},F)}})}t.debounce=w;function A(F,L,u){return O((h,g)=>{const p=`$throttle$timer$${g}`,m=`$throttle$result$${g}`,R=`$throttle$lastRun$${g}`,a=`$throttle$pending$${g}`;return function(...c){if(this[m]||(this[m]=u?u():void 0),(this[R]===null||this[R]===void 0)&&(this[R]=-Number.MAX_VALUE),L&&(this[m]=L(this[m],...c)),this[a])return;const S=this[R]+F;S<=Date.now()?(this[R]=Date.now(),h.apply(this,[this[m]]),this[m]=u?u():void 0):(this[a]=!0,this[p]=setTimeout(()=>{this[a]=!1,this[R]=Date.now(),h.apply(this,[this[m]]),this[m]=u?u():void 0},S-Date.now()))}})}t.throttle=A}),define(Y[24],ee([0,1,7]),function(q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayQueue=t.maxIndex=t.minIndex=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.firstOrDefault=t.lastIndex=t.uniqueFilter=t.distinctES6=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch=t.equals=t.tail2=t.tail=void 0;function D(E,C=0){return E[E.length-(1+C)]}t.tail=D;function w(E){if(E.length===0)throw new Error("Invalid tail call");return[E.slice(0,E.length-1),E[E.length-1]]}t.tail2=w;function A(E,C,T=(j,B)=>j===B){if(E===C)return!0;if(!E||!C||E.length!==C.length)return!1;for(let j=0,B=E.length;j<B;j++)if(!T(E[j],C[j]))return!1;return!0}t.equals=A;function F(E,C,T){let j=0,B=E.length-1;for(;j<=B;){const $=(j+B)/2|0,K=T(E[$],C);if(K<0)j=$+1;else if(K>0)B=$-1;else return $}return-(j+1)}t.binarySearch=F;function L(E,C){let T=0,j=E.length;if(j===0)return 0;for(;T<j;){const B=Math.floor((T+j)/2);C(E[B])?j=B:T=B+1}return T}t.findFirstInSorted=L;function u(E,C,T){if(E=E|0,E>=C.length)throw new TypeError("invalid index");let j=C[Math.floor(C.length*Math.random())],B=[],$=[],K=[];for(let te of C){const ne=T(te,j);ne<0?B.push(te):ne>0?$.push(te):K.push(te)}return E<B.length?u(E,B,T):E<B.length+K.length?K[0]:u(E-(B.length+K.length),$,T)}t.quickSelect=u;function h(E,C){const T=[];let j;for(const B of E.slice(0).sort(C))!j||C(j[0],B)!==0?(j=[B],T.push(j)):j.push(B);return T}t.groupBy=h;function g(E,C,T){const j=[];function B(te,ne,oe){if(ne===0&&oe.length===0)return;const le=j[j.length-1];le&&le.start+le.deleteCount===te?(le.deleteCount+=ne,le.toInsert.push(...oe)):j.push({start:te,deleteCount:ne,toInsert:oe})}let $=0,K=0;for(;;){if($===E.length){B($,0,C.slice(K));break}if(K===C.length){B($,E.length-$,[]);break}const te=E[$],ne=C[K],oe=T(te,ne);oe===0?($+=1,K+=1):oe<0?(B($,1,[]),$+=1):oe>0&&(B($,0,[ne]),K+=1)}return j}t.sortedDiff=g;function p(E,C,T){const j=g(E,C,T),B=[],$=[];for(const K of j)B.push(...E.slice(K.start,K.start+K.deleteCount)),$.push(...K.toInsert);return{removed:B,added:$}}t.delta=p;function m(E,C,T){if(T===0)return[];const j=E.slice(0,T).sort(C);return a(E,C,j,T,E.length),j}t.top=m;function R(E,C,T,j,B){return T===0?Promise.resolve([]):new Promise(($,K)=>{(async()=>{const te=E.length,ne=E.slice(0,T).sort(C);for(let oe=T,le=Math.min(T+j,te);oe<te;oe=le,le=Math.min(le+j,te)){if(oe>T&&await new Promise(pe=>setTimeout(pe)),B&&B.isCancellationRequested)throw(0,O.canceled)();a(E,C,ne,oe,le)}return ne})().then($,K)})}t.topAsync=R;function a(E,C,T,j,B){for(const $=T.length;j<B;j++){const K=E[j];if(C(K,T[$-1])<0){T.pop();const te=L(T,ne=>C(K,ne)<0);T.splice(te,0,K)}}}function c(E){return E.filter(C=>!!C)}t.coalesce=c;function S(E){let C=0;for(let T=0;T<E.length;T++)E[T]&&(E[C]=E[T],C+=1);E.length=C}t.coalesceInPlace=S;function v(E,C,T){E.splice(T,0,E.splice(C,1)[0])}t.move=v;function y(E){return!Array.isArray(E)||E.length===0}t.isFalsyOrEmpty=y;function f(E){return Array.isArray(E)&&E.length>0}t.isNonEmptyArray=f;function s(E,C){if(!C)return E.filter((j,B)=>E.indexOf(j)===B);const T=Object.create(null);return E.filter(j=>{const B=C(j);return T[B]?!1:(T[B]=!0,!0)})}t.distinct=s;function o(E){const C=new Set;return E.filter(T=>C.has(T)?!1:(C.add(T),!0))}t.distinctES6=o;function e(E){const C=Object.create(null);return T=>{const j=E(T);return C[j]?!1:(C[j]=!0,!0)}}t.uniqueFilter=e;function i(E,C){for(let T=E.length-1;T>=0;T--){const j=E[T];if(C(j))return T}return-1}t.lastIndex=i;function n(E,C){return E.length>0?E[0]:C}t.firstOrDefault=n;function r(E,C,T=(j,B)=>j===B){let j=0;for(let B=0,$=Math.min(E.length,C.length);B<$&&T(E[B],C[B]);B++)j++;return j}t.commonPrefixLength=r;function l(E){return[].concat(...E)}t.flatten=l;function d(E,C){let T=typeof C=="number"?E:0;typeof C=="number"?T=E:(T=0,C=E);const j=[];if(T<=C)for(let B=T;B<C;B++)j.push(B);else for(let B=T;B>C;B--)j.push(B);return j}t.range=d;function P(E,C,T){return E.reduce((j,B)=>(j[C(B)]=T?T(B):B,j),Object.create(null))}t.index=P;function U(E,C){return E.push(C),()=>b(E,C)}t.insert=U;function b(E,C){const T=E.indexOf(C);if(T>-1)return E.splice(T,1),C}t.remove=b;function k(E,C,T){const j=E.slice(0,C),B=E.slice(C);return j.concat(T,B)}t.arrayInsert=k;function V(E,C){let T;if(typeof C=="number"){let j=C;T=()=>{const B=Math.sin(j++)*179426549;return B-Math.floor(B)}}else T=Math.random;for(let j=E.length-1;j>0;j-=1){const B=Math.floor(T()*(j+1)),$=E[j];E[j]=E[B],E[B]=$}}t.shuffle=V;function G(E,C){const T=E.indexOf(C);T>-1&&(E.splice(T,1),E.unshift(C))}t.pushToStart=G;function Q(E,C){const T=E.indexOf(C);T>-1&&(E.splice(T,1),E.push(C))}t.pushToEnd=Q;function ie(E,C){return Array.isArray(E)?E.map(C):C(E)}t.mapArrayOrNot=ie;function re(E){return Array.isArray(E)?E:[E]}t.asArray=re;function Z(E){return E[Math.floor(Math.random()*E.length)]}t.getRandomElement=Z;function J(E,C){for(const T of E){const j=C(T);if(j!==void 0)return j}}t.mapFind=J;function W(E,C,T){const j=_(E,C),B=E.length,$=T.length;E.length=B+$;for(let K=B-1;K>=j;K--)E[K+$]=E[K];for(let K=0;K<$;K++)E[K+j]=T[K]}t.insertInto=W;function x(E,C,T,j){const B=_(E,C),$=E.splice(B,T);return W(E,B,j),$}t.splice=x;function _(E,C){return C<0?Math.max(C+E.length,0):Math.min(C,E.length)}function M(E,C){let T=Number.MAX_SAFE_INTEGER,j=0;return E.forEach((B,$)=>{const K=C(B);K<T&&(T=K,j=$)}),j}t.minIndex=M;function I(E,C){let T=Number.MIN_SAFE_INTEGER,j=0;return E.forEach((B,$)=>{const K=C(B);K>T&&(T=K,j=$)}),j}t.maxIndex=I;class N{constructor(C){this.items=C,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(C){let T=this.firstIdx;for(;T<this.items.length&&C(this.items[T]);)T++;const j=T===this.firstIdx?null:this.items.slice(this.firstIdx,T);return this.firstIdx=T,j}takeFromEndWhile(C){let T=this.lastIdx;for(;T>=0&&C(this.items[T]);)T--;const j=T===this.lastIdx?null:this.items.slice(T+1,this.lastIdx+1);return this.lastIdx=T,j}}t.ArrayQueue=N}),define(Y[58],ee([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var O;(function(e){e[e.None=0]="None",e[e.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=2]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",e[e.InvalidUnicode=4]="InvalidUnicode",e[e.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",e[e.InvalidCharacter=6]="InvalidCharacter"})(O=t.ScanError||(t.ScanError={}));var D;(function(e){e[e.OpenBraceToken=1]="OpenBraceToken",e[e.CloseBraceToken=2]="CloseBraceToken",e[e.OpenBracketToken=3]="OpenBracketToken",e[e.CloseBracketToken=4]="CloseBracketToken",e[e.CommaToken=5]="CommaToken",e[e.ColonToken=6]="ColonToken",e[e.NullKeyword=7]="NullKeyword",e[e.TrueKeyword=8]="TrueKeyword",e[e.FalseKeyword=9]="FalseKeyword",e[e.StringLiteral=10]="StringLiteral",e[e.NumericLiteral=11]="NumericLiteral",e[e.LineCommentTrivia=12]="LineCommentTrivia",e[e.BlockCommentTrivia=13]="BlockCommentTrivia",e[e.LineBreakTrivia=14]="LineBreakTrivia",e[e.Trivia=15]="Trivia",e[e.Unknown=16]="Unknown",e[e.EOF=17]="EOF"})(D=t.SyntaxKind||(t.SyntaxKind={}));var w;(function(e){e[e.InvalidSymbol=1]="InvalidSymbol",e[e.InvalidNumberFormat=2]="InvalidNumberFormat",e[e.PropertyNameExpected=3]="PropertyNameExpected",e[e.ValueExpected=4]="ValueExpected",e[e.ColonExpected=5]="ColonExpected",e[e.CommaExpected=6]="CommaExpected",e[e.CloseBraceExpected=7]="CloseBraceExpected",e[e.CloseBracketExpected=8]="CloseBracketExpected",e[e.EndOfFileExpected=9]="EndOfFileExpected",e[e.InvalidCommentToken=10]="InvalidCommentToken",e[e.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",e[e.UnexpectedEndOfString=12]="UnexpectedEndOfString",e[e.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",e[e.InvalidUnicode=14]="InvalidUnicode",e[e.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",e[e.InvalidCharacter=16]="InvalidCharacter"})(w=t.ParseErrorCode||(t.ParseErrorCode={}));var A;(function(e){e.DEFAULT={allowTrailingComma:!0}})(A=t.ParseOptions||(t.ParseOptions={}));function F(e,i=!1){let n=0,r=e.length,l="",d=0,P=16,U=0;function b(Z){let J=0,W=0;for(;J<Z;){const x=e.charCodeAt(n);if(x>=48&&x<=57)W=W*16+x-48;else if(x>=65&&x<=70)W=W*16+x-65+10;else if(x>=97&&x<=102)W=W*16+x-97+10;else break;n++,J++}return J<Z&&(W=-1),W}function k(Z){n=Z,l="",d=0,P=16,U=0}function V(){const Z=n;if(e.charCodeAt(n)===48)n++;else for(n++;n<e.length&&h(e.charCodeAt(n));)n++;if(n<e.length&&e.charCodeAt(n)===46)if(n++,n<e.length&&h(e.charCodeAt(n)))for(n++;n<e.length&&h(e.charCodeAt(n));)n++;else return U=3,e.substring(Z,n);let J=n;if(n<e.length&&(e.charCodeAt(n)===69||e.charCodeAt(n)===101))if(n++,(n<e.length&&e.charCodeAt(n)===43||e.charCodeAt(n)===45)&&n++,n<e.length&&h(e.charCodeAt(n))){for(n++;n<e.length&&h(e.charCodeAt(n));)n++;J=n}else U=3;return e.substring(Z,J)}function G(){let Z="",J=n;for(;;){if(n>=r){Z+=e.substring(J,n),U=2;break}const W=e.charCodeAt(n);if(W===34){Z+=e.substring(J,n),n++;break}if(W===92){if(Z+=e.substring(J,n),n++,n>=r){U=2;break}switch(e.charCodeAt(n++)){case 34:Z+='"';break;case 92:Z+="\\";break;case 47:Z+="/";break;case 98:Z+="\b";break;case 102:Z+="\f";break;case 110:Z+=`
`;break;case 114:Z+="\r";break;case 116:Z+="	";break;case 117:const _=b(4);_>=0?Z+=String.fromCharCode(_):U=4;break;default:U=5}J=n;continue}if(W>=0&&W<=31)if(u(W)){Z+=e.substring(J,n),U=2;break}else U=6;n++}return Z}function Q(){if(l="",U=0,d=n,n>=r)return d=r,P=17;let Z=e.charCodeAt(n);if(L(Z)){do n++,l+=String.fromCharCode(Z),Z=e.charCodeAt(n);while(L(Z));return P=15}if(u(Z))return n++,l+=String.fromCharCode(Z),Z===13&&e.charCodeAt(n)===10&&(n++,l+=`
`),P=14;switch(Z){case 123:return n++,P=1;case 125:return n++,P=2;case 91:return n++,P=3;case 93:return n++,P=4;case 58:return n++,P=6;case 44:return n++,P=5;case 34:return n++,l=G(),P=10;case 47:const J=n-1;if(e.charCodeAt(n+1)===47){for(n+=2;n<r&&!u(e.charCodeAt(n));)n++;return l=e.substring(J,n),P=12}if(e.charCodeAt(n+1)===42){n+=2;const W=r-1;let x=!1;for(;n<W;){if(e.charCodeAt(n)===42&&e.charCodeAt(n+1)===47){n+=2,x=!0;break}n++}return x||(n++,U=1),l=e.substring(J,n),P=13}return l+=String.fromCharCode(Z),n++,P=16;case 45:if(l+=String.fromCharCode(Z),n++,n===r||!h(e.charCodeAt(n)))return P=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return l+=V(),P=11;default:for(;n<r&&ie(Z);)n++,Z=e.charCodeAt(n);if(d!==n){switch(l=e.substring(d,n),l){case"true":return P=8;case"false":return P=9;case"null":return P=7}return P=16}return l+=String.fromCharCode(Z),n++,P=16}}function ie(Z){if(L(Z)||u(Z))return!1;switch(Z){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function re(){let Z;do Z=Q();while(Z>=12&&Z<=15);return Z}return{setPosition:k,getPosition:()=>n,scan:i?re:Q,getToken:()=>P,getTokenValue:()=>l,getTokenOffset:()=>d,getTokenLength:()=>n-d,getTokenError:()=>U}}t.createScanner=F;function L(e){return e===32||e===9||e===11||e===12||e===160||e===5760||e>=8192&&e<=8203||e===8239||e===8287||e===12288||e===65279}function u(e){return e===10||e===13||e===8232||e===8233}function h(e){return e>=48&&e<=57}var g;(function(e){e[e.nullCharacter=0]="nullCharacter",e[e.maxAsciiCharacter=127]="maxAsciiCharacter",e[e.lineFeed=10]="lineFeed",e[e.carriageReturn=13]="carriageReturn",e[e.lineSeparator=8232]="lineSeparator",e[e.paragraphSeparator=8233]="paragraphSeparator",e[e.nextLine=133]="nextLine",e[e.space=32]="space",e[e.nonBreakingSpace=160]="nonBreakingSpace",e[e.enQuad=8192]="enQuad",e[e.emQuad=8193]="emQuad",e[e.enSpace=8194]="enSpace",e[e.emSpace=8195]="emSpace",e[e.threePerEmSpace=8196]="threePerEmSpace",e[e.fourPerEmSpace=8197]="fourPerEmSpace",e[e.sixPerEmSpace=8198]="sixPerEmSpace",e[e.figureSpace=8199]="figureSpace",e[e.punctuationSpace=8200]="punctuationSpace",e[e.thinSpace=8201]="thinSpace",e[e.hairSpace=8202]="hairSpace",e[e.zeroWidthSpace=8203]="zeroWidthSpace",e[e.narrowNoBreakSpace=8239]="narrowNoBreakSpace",e[e.ideographicSpace=12288]="ideographicSpace",e[e.mathematicalSpace=8287]="mathematicalSpace",e[e.ogham=5760]="ogham",e[e._=95]="_",e[e.$=36]="$",e[e._0=48]="_0",e[e._1=49]="_1",e[e._2=50]="_2",e[e._3=51]="_3",e[e._4=52]="_4",e[e._5=53]="_5",e[e._6=54]="_6",e[e._7=55]="_7",e[e._8=56]="_8",e[e._9=57]="_9",e[e.a=97]="a",e[e.b=98]="b",e[e.c=99]="c",e[e.d=100]="d",e[e.e=101]="e",e[e.f=102]="f",e[e.g=103]="g",e[e.h=104]="h",e[e.i=105]="i",e[e.j=106]="j",e[e.k=107]="k",e[e.l=108]="l",e[e.m=109]="m",e[e.n=110]="n",e[e.o=111]="o",e[e.p=112]="p",e[e.q=113]="q",e[e.r=114]="r",e[e.s=115]="s",e[e.t=116]="t",e[e.u=117]="u",e[e.v=118]="v",e[e.w=119]="w",e[e.x=120]="x",e[e.y=121]="y",e[e.z=122]="z",e[e.A=65]="A",e[e.B=66]="B",e[e.C=67]="C",e[e.D=68]="D",e[e.E=69]="E",e[e.F=70]="F",e[e.G=71]="G",e[e.H=72]="H",e[e.I=73]="I",e[e.J=74]="J",e[e.K=75]="K",e[e.L=76]="L",e[e.M=77]="M",e[e.N=78]="N",e[e.O=79]="O",e[e.P=80]="P",e[e.Q=81]="Q",e[e.R=82]="R",e[e.S=83]="S",e[e.T=84]="T",e[e.U=85]="U",e[e.V=86]="V",e[e.W=87]="W",e[e.X=88]="X",e[e.Y=89]="Y",e[e.Z=90]="Z",e[e.ampersand=38]="ampersand",e[e.asterisk=42]="asterisk",e[e.at=64]="at",e[e.backslash=92]="backslash",e[e.bar=124]="bar",e[e.caret=94]="caret",e[e.closeBrace=125]="closeBrace",e[e.closeBracket=93]="closeBracket",e[e.closeParen=41]="closeParen",e[e.colon=58]="colon",e[e.comma=44]="comma",e[e.dot=46]="dot",e[e.doubleQuote=34]="doubleQuote",e[e.equals=61]="equals",e[e.exclamation=33]="exclamation",e[e.greaterThan=62]="greaterThan",e[e.lessThan=60]="lessThan",e[e.minus=45]="minus",e[e.openBrace=123]="openBrace",e[e.openBracket=91]="openBracket",e[e.openParen=40]="openParen",e[e.percent=37]="percent",e[e.plus=43]="plus",e[e.question=63]="question",e[e.semicolon=59]="semicolon",e[e.singleQuote=39]="singleQuote",e[e.slash=47]="slash",e[e.tilde=126]="tilde",e[e.backspace=8]="backspace",e[e.formFeed=12]="formFeed",e[e.byteOrderMark=65279]="byteOrderMark",e[e.tab=9]="tab",e[e.verticalTab=11]="verticalTab"})(g||(g={}));function p(e,i){const n=[],r=new Object;let l;const d={value:{},offset:0,length:0,type:"object",parent:void 0};let P=!1;function U(b,k,V,G){d.value=b,d.offset=k,d.length=V,d.type=G,d.colonOffset=void 0,l=d}try{f(e,{onObjectBegin:(b,k)=>{if(i<=b)throw r;l=void 0,P=i>b,n.push("")},onObjectProperty:(b,k,V)=>{if(i<k||(U(b,k,V,"property"),n[n.length-1]=b,i<=k+V))throw r},onObjectEnd:(b,k)=>{if(i<=b)throw r;l=void 0,n.pop()},onArrayBegin:(b,k)=>{if(i<=b)throw r;l=void 0,n.push(0)},onArrayEnd:(b,k)=>{if(i<=b)throw r;l=void 0,n.pop()},onLiteralValue:(b,k,V)=>{if(i<k||(U(b,k,V,o(b)),i<=k+V))throw r},onSeparator:(b,k,V)=>{if(i<=k)throw r;if(b===":"&&l&&l.type==="property")l.colonOffset=k,P=!1,l=void 0;else if(b===","){const G=n[n.length-1];typeof G=="number"?n[n.length-1]=G+1:(P=!0,n[n.length-1]=""),l=void 0}}})}catch(b){if(b!==r)throw b}return{path:n,previousNode:l,isAtPropertyKey:P,matches:b=>{let k=0;for(let V=0;k<b.length&&V<n.length;V++)if(b[k]===n[V]||b[k]==="*")k++;else if(b[k]!=="**")return!1;return k===b.length}}}t.getLocation=p;function m(e,i=[],n=A.DEFAULT){let r=null,l=[];const d=[];function P(b){Array.isArray(l)?l.push(b):r!==null&&(l[r]=b)}return f(e,{onObjectBegin:()=>{const b={};P(b),d.push(l),l=b,r=null},onObjectProperty:b=>{r=b},onObjectEnd:()=>{l=d.pop()},onArrayBegin:()=>{const b=[];P(b),d.push(l),l=b,r=null},onArrayEnd:()=>{l=d.pop()},onLiteralValue:P,onError:(b,k,V)=>{i.push({error:b,offset:k,length:V})}},n),l[0]}t.parse=m;function R(e,i=[],n=A.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function l(b){r.type==="property"&&(r.length=b-r.offset,r=r.parent)}function d(b){return r.children.push(b),b}f(e,{onObjectBegin:b=>{r=d({type:"object",offset:b,length:-1,parent:r,children:[]})},onObjectProperty:(b,k,V)=>{r=d({type:"property",offset:k,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:b,offset:k,length:V,parent:r})},onObjectEnd:(b,k)=>{r.length=b+k-r.offset,r=r.parent,l(b+k)},onArrayBegin:(b,k)=>{r=d({type:"array",offset:b,length:-1,parent:r,children:[]})},onArrayEnd:(b,k)=>{r.length=b+k-r.offset,r=r.parent,l(b+k)},onLiteralValue:(b,k,V)=>{d({type:o(b),offset:k,length:V,parent:r,value:b}),l(k+V)},onSeparator:(b,k,V)=>{r.type==="property"&&(b===":"?r.colonOffset=k:b===","&&l(k))},onError:(b,k,V)=>{i.push({error:b,offset:k,length:V})}},n);const U=r.children[0];return U&&delete U.parent,U}t.parseTree=R;function a(e,i){if(!e)return;let n=e;for(let r of i)if(typeof r=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let l=!1;for(const d of n.children)if(Array.isArray(d.children)&&d.children[0].value===r){n=d.children[1],l=!0;break}if(!l)return}else{const l=r;if(n.type!=="array"||l<0||!Array.isArray(n.children)||l>=n.children.length)return;n=n.children[l]}return n}t.findNodeAtLocation=a;function c(e){if(!e.parent||!e.parent.children)return[];const i=c(e.parent);if(e.parent.type==="property"){const n=e.parent.children[0].value;i.push(n)}else if(e.parent.type==="array"){const n=e.parent.children.indexOf(e);n!==-1&&i.push(n)}return i}t.getNodePath=c;function S(e){switch(e.type){case"array":return e.children.map(S);case"object":const i=Object.create(null);for(let n of e.children){const r=n.children[1];r&&(i[n.children[0].value]=S(r))}return i;case"null":case"string":case"number":case"boolean":return e.value;default:return}}t.getNodeValue=S;function v(e,i,n=!1){return i>=e.offset&&i<e.offset+e.length||n&&i===e.offset+e.length}t.contains=v;function y(e,i,n=!1){if(v(e,i,n)){const r=e.children;if(Array.isArray(r))for(let l=0;l<r.length&&r[l].offset<=i;l++){const d=y(r[l],i,n);if(d)return d}return e}}t.findNodeAtOffset=y;function f(e,i,n=A.DEFAULT){const r=F(e,!1);function l(T){return T?()=>T(r.getTokenOffset(),r.getTokenLength()):()=>!0}function d(T){return T?j=>T(j,r.getTokenOffset(),r.getTokenLength()):()=>!0}const P=l(i.onObjectBegin),U=d(i.onObjectProperty),b=l(i.onObjectEnd),k=l(i.onArrayBegin),V=l(i.onArrayEnd),G=d(i.onLiteralValue),Q=d(i.onSeparator),ie=l(i.onComment),re=d(i.onError),Z=n&&n.disallowComments,J=n&&n.allowTrailingComma;function W(){for(;;){const T=r.scan();switch(r.getTokenError()){case 4:x(14);break;case 5:x(15);break;case 3:x(13);break;case 1:Z||x(11);break;case 2:x(12);break;case 6:x(16);break}switch(T){case 12:case 13:Z?x(10):ie();break;case 16:x(1);break;case 15:case 14:break;default:return T}}}function x(T,j=[],B=[]){if(re(T),j.length+B.length>0){let $=r.getToken();for(;$!==17;){if(j.indexOf($)!==-1){W();break}else if(B.indexOf($)!==-1)break;$=W()}}}function _(T){const j=r.getTokenValue();return T?G(j):U(j),W(),!0}function M(){switch(r.getToken()){case 11:let T=0;try{T=JSON.parse(r.getTokenValue()),typeof T!="number"&&(x(2),T=0)}catch(j){x(2)}G(T);break;case 7:G(null);break;case 8:G(!0);break;case 9:G(!1);break;default:return!1}return W(),!0}function I(){return r.getToken()!==10?(x(3,[],[2,5]),!1):(_(!1),r.getToken()===6?(Q(":"),W(),C()||x(4,[],[2,5])):x(5,[],[2,5]),!0)}function N(){P(),W();let T=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(T||x(4,[],[]),Q(","),W(),r.getToken()===2&&J)break}else T&&x(6,[],[]);I()||x(4,[],[2,5]),T=!0}return b(),r.getToken()!==2?x(7,[2],[]):W(),!0}function E(){k(),W();let T=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(T||x(4,[],[]),Q(","),W(),r.getToken()===4&&J)break}else T&&x(6,[],[]);C()||x(4,[],[4,5]),T=!0}return V(),r.getToken()!==4?x(8,[4],[]):W(),!0}function C(){switch(r.getToken()){case 3:return E();case 1:return N();case 10:return _(!0);default:return M()}}return W(),r.getToken()===17?n.allowEmptyContent?!0:(x(4,[],[]),!1):C()?(r.getToken()!==17&&x(9,[],[]),!0):(x(4,[],[]),!1)}t.visit=f;function s(e,i){let n=F(e),r=[],l,d=0,P;do switch(P=n.getPosition(),l=n.scan(),l){case 12:case 13:case 17:d!==P&&r.push(e.substring(d,P)),i!==void 0&&r.push(n.getTokenValue().replace(/[^\r\n]/g,i)),d=n.getPosition();break}while(l!==17);return r.join("")}t.stripComments=s;function o(e){switch(typeof e){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(e){if(Array.isArray(e))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=o}),function(){function q(w){const A=[];typeof w=="number"&&A.push("code/timeOrigin",w);function F(u){A.push(u,Date.now())}function L(){const u=[];for(let h=0;h<A.length;h+=2)u.push({name:A[h],startTime:A[h+1]});return u}return{mark:F,getMarks:L}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?q():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const F of performance.getEntriesByType("mark"))A.push({name:F.name,startTime:Math.round(w+F.startTime)});return A}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return q(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),q()}function O(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=t()),w.MonacoPerformanceMarks}var D;typeof global=="object"?D=global:typeof self=="object"?D=self:D={},typeof define=="function"?define("vs/base/common/performance",[],function(){return O(D)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=O(D):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),D.perf=O(D))}(),function(q,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var O=t();for(var D in O)(typeof exports=="object"?exports:q)[D]=O[D]}}(typeof self!="undefined"?self:this,function(){return function(q){var t={};function O(D){if(t[D])return t[D].exports;var w=t[D]={i:D,l:!1,exports:{}};return q[D].call(w.exports,w,w.exports,O),w.l=!0,w.exports}return O.m=q,O.c=t,O.d=function(D,w,A){O.o(D,w)||Object.defineProperty(D,w,{enumerable:!0,get:A})},O.r=function(D){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(D,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(D,"__esModule",{value:!0})},O.t=function(D,w){if(1&w&&(D=O(D)),8&w||4&w&&typeof D=="object"&&D&&D.__esModule)return D;var A=Object.create(null);if(O.r(A),Object.defineProperty(A,"default",{enumerable:!0,value:D}),2&w&&typeof D!="string")for(var F in D)O.d(A,F,function(L){return D[L]}.bind(null,F));return A},O.n=function(D){var w=D&&D.__esModule?function(){return D.default}:function(){return D};return O.d(w,"a",w),w},O.o=function(D,w){return Object.prototype.hasOwnProperty.call(D,w)},O.p="",O(O.s=0)}([function(q,t,O){(function(D){var w;t=q.exports=B,w=typeof D=="object"&&D.env&&D.env.NODE_DEBUG&&/\bsemver\b/i.test(D.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var A=256,F=Number.MAX_SAFE_INTEGER||9007199254740991,L=t.re=[],u=t.src=[],h=0,g=h++;u[g]="0|[1-9]\\d*";var p=h++;u[p]="[0-9]+";var m=h++;u[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var R=h++;u[R]="("+u[g]+")\\.("+u[g]+")\\.("+u[g]+")";var a=h++;u[a]="("+u[p]+")\\.("+u[p]+")\\.("+u[p]+")";var c=h++;u[c]="(?:"+u[g]+"|"+u[m]+")";var S=h++;u[S]="(?:"+u[p]+"|"+u[m]+")";var v=h++;u[v]="(?:-("+u[c]+"(?:\\."+u[c]+")*))";var y=h++;u[y]="(?:-?("+u[S]+"(?:\\."+u[S]+")*))";var f=h++;u[f]="[0-9A-Za-z-]+";var s=h++;u[s]="(?:\\+("+u[f]+"(?:\\."+u[f]+")*))";var o=h++,e="v?"+u[R]+u[v]+"?"+u[s]+"?";u[o]="^"+e+"$";var i="[v=\\s]*"+u[a]+u[y]+"?"+u[s]+"?",n=h++;u[n]="^"+i+"$";var r=h++;u[r]="((?:<|>)?=?)";var l=h++;u[l]=u[p]+"|x|X|\\*";var d=h++;u[d]=u[g]+"|x|X|\\*";var P=h++;u[P]="[v=\\s]*("+u[d]+")(?:\\.("+u[d]+")(?:\\.("+u[d]+")(?:"+u[v]+")?"+u[s]+"?)?)?";var U=h++;u[U]="[v=\\s]*("+u[l]+")(?:\\.("+u[l]+")(?:\\.("+u[l]+")(?:"+u[y]+")?"+u[s]+"?)?)?";var b=h++;u[b]="^"+u[r]+"\\s*"+u[P]+"$";var k=h++;u[k]="^"+u[r]+"\\s*"+u[U]+"$";var V=h++;u[V]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var G=h++;u[G]="(?:~>?)";var Q=h++;u[Q]="(\\s*)"+u[G]+"\\s+",L[Q]=new RegExp(u[Q],"g");var ie=h++;u[ie]="^"+u[G]+u[P]+"$";var re=h++;u[re]="^"+u[G]+u[U]+"$";var Z=h++;u[Z]="(?:\\^)";var J=h++;u[J]="(\\s*)"+u[Z]+"\\s+",L[J]=new RegExp(u[J],"g");var W=h++;u[W]="^"+u[Z]+u[P]+"$";var x=h++;u[x]="^"+u[Z]+u[U]+"$";var _=h++;u[_]="^"+u[r]+"\\s*("+i+")$|^$";var M=h++;u[M]="^"+u[r]+"\\s*("+e+")$|^$";var I=h++;u[I]="(\\s*)"+u[r]+"\\s*("+i+"|"+u[P]+")",L[I]=new RegExp(u[I],"g");var N=h++;u[N]="^\\s*("+u[P]+")\\s+-\\s+("+u[P]+")\\s*$";var E=h++;u[E]="^\\s*("+u[U]+")\\s+-\\s+("+u[U]+")\\s*$";var C=h++;u[C]="(<|>)?=?\\s*\\*";for(var T=0;T<35;T++)w(T,u[T]),L[T]||(L[T]=new RegExp(u[T]));function j(z,H){if(z instanceof B)return z;if(typeof z!="string"||z.length>A||!(H?L[n]:L[o]).test(z))return null;try{return new B(z,H)}catch(X){return null}}function B(z,H){if(z instanceof B){if(z.loose===H)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>A)throw new TypeError("version is longer than "+A+" characters");if(!(this instanceof B))return new B(z,H);w("SemVer",z,H),this.loose=H;var X=z.trim().match(H?L[n]:L[o]);if(!X)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+X[1],this.minor=+X[2],this.patch=+X[3],this.major>F||this.major<0)throw new TypeError("Invalid major version");if(this.minor>F||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>F||this.patch<0)throw new TypeError("Invalid patch version");X[4]?this.prerelease=X[4].split(".").map(function(se){if(/^[0-9]+$/.test(se)){var ae=+se;if(ae>=0&&ae<F)return ae}return se}):this.prerelease=[],this.build=X[5]?X[5].split("."):[],this.format()}t.parse=j,t.valid=function(z,H){var X=j(z,H);return X?X.version:null},t.clean=function(z,H){var X=j(z.trim().replace(/^[=v]+/,""),H);return X?X.version:null},t.SemVer=B,B.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},B.prototype.toString=function(){return this.version},B.prototype.compare=function(z){return w("SemVer.compare",this.version,this.loose,z),z instanceof B||(z=new B(z,this.loose)),this.compareMain(z)||this.comparePre(z)},B.prototype.compareMain=function(z){return z instanceof B||(z=new B(z,this.loose)),K(this.major,z.major)||K(this.minor,z.minor)||K(this.patch,z.patch)},B.prototype.comparePre=function(z){if(z instanceof B||(z=new B(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var H=0;do{var X=this.prerelease[H],se=z.prerelease[H];if(w("prerelease compare",H,X,se),X===void 0&&se===void 0)return 0;if(se===void 0)return 1;if(X===void 0)return-1;if(X!==se)return K(X,se)}while(++H)},B.prototype.inc=function(z,H){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var X=this.prerelease.length;--X>=0;)typeof this.prerelease[X]=="number"&&(this.prerelease[X]++,X=-2);X===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},t.inc=function(z,H,X,se){typeof X=="string"&&(se=X,X=void 0);try{return new B(z,X).inc(H,se).version}catch(ae){return null}},t.diff=function(z,H){if(le(z,H))return null;var X=j(z),se=j(H);if(X.prerelease.length||se.prerelease.length){for(var ae in X)if((ae==="major"||ae==="minor"||ae==="patch")&&X[ae]!==se[ae])return"pre"+ae;return"prerelease"}for(var ae in X)if((ae==="major"||ae==="minor"||ae==="patch")&&X[ae]!==se[ae])return ae},t.compareIdentifiers=K;var $=/^[0-9]+$/;function K(z,H){var X=$.test(z),se=$.test(H);return X&&se&&(z=+z,H=+H),X&&!se?-1:se&&!X?1:z<H?-1:z>H?1:0}function te(z,H,X){return new B(z,X).compare(new B(H,X))}function ne(z,H,X){return te(z,H,X)>0}function oe(z,H,X){return te(z,H,X)<0}function le(z,H,X){return te(z,H,X)===0}function pe(z,H,X){return te(z,H,X)!==0}function De(z,H,X){return te(z,H,X)>=0}function ke(z,H,X){return te(z,H,X)<=0}function Te(z,H,X,se){var ae;switch(H){case"===":typeof z=="object"&&(z=z.version),typeof X=="object"&&(X=X.version),ae=z===X;break;case"!==":typeof z=="object"&&(z=z.version),typeof X=="object"&&(X=X.version),ae=z!==X;break;case"":case"=":case"==":ae=le(z,X,se);break;case"!=":ae=pe(z,X,se);break;case">":ae=ne(z,X,se);break;case">=":ae=De(z,X,se);break;case"<":ae=oe(z,X,se);break;case"<=":ae=ke(z,X,se);break;default:throw new TypeError("Invalid operator: "+H)}return ae}function we(z,H){if(z instanceof we){if(z.loose===H)return z;z=z.value}if(!(this instanceof we))return new we(z,H);w("comparator",z,H),this.loose=H,this.parse(z),this.semver===Fe?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}t.rcompareIdentifiers=function(z,H){return K(H,z)},t.major=function(z,H){return new B(z,H).major},t.minor=function(z,H){return new B(z,H).minor},t.patch=function(z,H){return new B(z,H).patch},t.compare=te,t.compareLoose=function(z,H){return te(z,H,!0)},t.rcompare=function(z,H,X){return te(H,z,X)},t.sort=function(z,H){return z.sort(function(X,se){return t.compare(X,se,H)})},t.rsort=function(z,H){return z.sort(function(X,se){return t.rcompare(X,se,H)})},t.gt=ne,t.lt=oe,t.eq=le,t.neq=pe,t.gte=De,t.lte=ke,t.cmp=Te,t.Comparator=we;var Fe={};function ve(z,H){if(z instanceof ve)return z.loose===H?z:new ve(z.raw,H);if(z instanceof we)return new ve(z.value,H);if(!(this instanceof ve))return new ve(z,H);if(this.loose=H,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(X){return this.parseRange(X.trim())},this).filter(function(X){return X.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function Re(z){return!z||z.toLowerCase()==="x"||z==="*"}function je(z,H,X,se,ae,Se,de,Le,ye,Pe,Ae,Ee,be){return((H=Re(X)?"":Re(se)?">="+X+".0.0":Re(ae)?">="+X+"."+se+".0":">="+H)+" "+(Le=Re(ye)?"":Re(Pe)?"<"+(+ye+1)+".0.0":Re(Ae)?"<"+ye+"."+(+Pe+1)+".0":Ee?"<="+ye+"."+Pe+"."+Ae+"-"+Ee:"<="+Le)).trim()}function Be(z,H){for(var X=0;X<z.length;X++)if(!z[X].test(H))return!1;if(H.prerelease.length){for(X=0;X<z.length;X++)if(w(z[X].semver),z[X].semver!==Fe&&z[X].semver.prerelease.length>0){var se=z[X].semver;if(se.major===H.major&&se.minor===H.minor&&se.patch===H.patch)return!0}return!1}return!0}function xe(z,H,X){try{H=new ve(H,X)}catch(se){return!1}return H.test(z)}function ze(z,H,X,se){var ae,Se,de,Le,ye;switch(z=new B(z,se),H=new ve(H,se),X){case">":ae=ne,Se=ke,de=oe,Le=">",ye=">=";break;case"<":ae=oe,Se=De,de=ne,Le="<",ye="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(xe(z,H,se))return!1;for(var Pe=0;Pe<H.set.length;++Pe){var Ae=H.set[Pe],Ee=null,be=null;if(Ae.forEach(function(Ce){Ce.semver===Fe&&(Ce=new we(">=0.0.0")),Ee=Ee||Ce,be=be||Ce,ae(Ce.semver,Ee.semver,se)?Ee=Ce:de(Ce.semver,be.semver,se)&&(be=Ce)}),Ee.operator===Le||Ee.operator===ye||(!be.operator||be.operator===Le)&&Se(z,be.semver)||be.operator===ye&&de(z,be.semver))return!1}return!0}we.prototype.parse=function(z){var H=this.loose?L[_]:L[M],X=z.match(H);if(!X)throw new TypeError("Invalid comparator: "+z);this.operator=X[1],this.operator==="="&&(this.operator=""),X[2]?this.semver=new B(X[2],this.loose):this.semver=Fe},we.prototype.toString=function(){return this.value},we.prototype.test=function(z){return w("Comparator.test",z,this.loose),this.semver===Fe||(typeof z=="string"&&(z=new B(z,this.loose)),Te(z,this.operator,this.semver,this.loose))},we.prototype.intersects=function(z,H){if(!(z instanceof we))throw new TypeError("a Comparator is required");var X;if(this.operator==="")return X=new ve(z.value,H),xe(this.value,X,H);if(z.operator==="")return X=new ve(this.value,H),xe(z.semver,X,H);var se=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),ae=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Se=this.semver.version===z.semver.version,de=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Le=Te(this.semver,"<",z.semver,H)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),ye=Te(this.semver,">",z.semver,H)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return se||ae||Se&&de||Le||ye},t.Range=ve,ve.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},ve.prototype.toString=function(){return this.range},ve.prototype.parseRange=function(z){var H=this.loose;z=z.trim(),w("range",z,H);var X=H?L[E]:L[N];z=z.replace(X,je),w("hyphen replace",z),z=z.replace(L[I],"$1$2$3"),w("comparator trim",z,L[I]),z=(z=(z=z.replace(L[Q],"$1~")).replace(L[J],"$1^")).split(/\s+/).join(" ");var se=H?L[_]:L[M],ae=z.split(" ").map(function(Se){return function(de,Le){return w("comp",de),de=function(ye,Pe){return ye.trim().split(/\s+/).map(function(Ae){return function(Ee,be){w("caret",Ee,be);var Ce=be?L[x]:L[W];return Ee.replace(Ce,function(Oe,ce,he,ge,me){var Ie;return w("caret",Ee,Oe,ce,he,ge,me),Re(ce)?Ie="":Re(he)?Ie=">="+ce+".0.0 <"+(+ce+1)+".0.0":Re(ge)?Ie=ce==="0"?">="+ce+"."+he+".0 <"+ce+"."+(+he+1)+".0":">="+ce+"."+he+".0 <"+(+ce+1)+".0.0":me?(w("replaceCaret pr",me),me.charAt(0)!=="-"&&(me="-"+me),Ie=ce==="0"?he==="0"?">="+ce+"."+he+"."+ge+me+" <"+ce+"."+he+"."+(+ge+1):">="+ce+"."+he+"."+ge+me+" <"+ce+"."+(+he+1)+".0":">="+ce+"."+he+"."+ge+me+" <"+(+ce+1)+".0.0"):(w("no pr"),Ie=ce==="0"?he==="0"?">="+ce+"."+he+"."+ge+" <"+ce+"."+he+"."+(+ge+1):">="+ce+"."+he+"."+ge+" <"+ce+"."+(+he+1)+".0":">="+ce+"."+he+"."+ge+" <"+(+ce+1)+".0.0"),w("caret return",Ie),Ie})}(Ae,Pe)}).join(" ")}(de,Le),w("caret",de),de=function(ye,Pe){return ye.trim().split(/\s+/).map(function(Ae){return function(Ee,be){var Ce=be?L[re]:L[ie];return Ee.replace(Ce,function(Oe,ce,he,ge,me){var Ie;return w("tilde",Ee,Oe,ce,he,ge,me),Re(ce)?Ie="":Re(he)?Ie=">="+ce+".0.0 <"+(+ce+1)+".0.0":Re(ge)?Ie=">="+ce+"."+he+".0 <"+ce+"."+(+he+1)+".0":me?(w("replaceTilde pr",me),me.charAt(0)!=="-"&&(me="-"+me),Ie=">="+ce+"."+he+"."+ge+me+" <"+ce+"."+(+he+1)+".0"):Ie=">="+ce+"."+he+"."+ge+" <"+ce+"."+(+he+1)+".0",w("tilde return",Ie),Ie})}(Ae,Pe)}).join(" ")}(de,Le),w("tildes",de),de=function(ye,Pe){return w("replaceXRanges",ye,Pe),ye.split(/\s+/).map(function(Ae){return function(Ee,be){Ee=Ee.trim();var Ce=be?L[k]:L[b];return Ee.replace(Ce,function(Oe,ce,he,ge,me,Ie){w("xRange",Ee,Oe,ce,he,ge,me,Ie);var Ve=Re(he),Me=Ve||Re(ge),Ue=Me||Re(me);return ce==="="&&Ue&&(ce=""),Ve?Oe=ce===">"||ce==="<"?"<0.0.0":"*":ce&&Ue?(Me&&(ge=0),Ue&&(me=0),ce===">"?(ce=">=",Me?(he=+he+1,ge=0,me=0):Ue&&(ge=+ge+1,me=0)):ce==="<="&&(ce="<",Me?he=+he+1:ge=+ge+1),Oe=ce+he+"."+ge+"."+me):Me?Oe=">="+he+".0.0 <"+(+he+1)+".0.0":Ue&&(Oe=">="+he+"."+ge+".0 <"+he+"."+(+ge+1)+".0"),w("xRange return",Oe),Oe})}(Ae,Pe)}).join(" ")}(de,Le),w("xrange",de),de=function(ye,Pe){return w("replaceStars",ye,Pe),ye.trim().replace(L[C],"")}(de,Le),w("stars",de),de}(Se,H)}).join(" ").split(/\s+/);return this.loose&&(ae=ae.filter(function(Se){return!!Se.match(se)})),ae=ae.map(function(Se){return new we(Se,H)})},ve.prototype.intersects=function(z,H){if(!(z instanceof ve))throw new TypeError("a Range is required");return this.set.some(function(X){return X.every(function(se){return z.set.some(function(ae){return ae.every(function(Se){return se.intersects(Se,H)})})})})},t.toComparators=function(z,H){return new ve(z,H).set.map(function(X){return X.map(function(se){return se.value}).join(" ").trim().split(" ")})},ve.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new B(z,this.loose));for(var H=0;H<this.set.length;H++)if(Be(this.set[H],z))return!0;return!1},t.satisfies=xe,t.maxSatisfying=function(z,H,X){var se=null,ae=null;try{var Se=new ve(H,X)}catch(de){return null}return z.forEach(function(de){Se.test(de)&&(se&&ae.compare(de)!==-1||(ae=new B(se=de,X)))}),se},t.minSatisfying=function(z,H,X){var se=null,ae=null;try{var Se=new ve(H,X)}catch(de){return null}return z.forEach(function(de){Se.test(de)&&(se&&ae.compare(de)!==1||(ae=new B(se=de,X)))}),se},t.validRange=function(z,H){try{return new ve(z,H).range||"*"}catch(X){return null}},t.ltr=function(z,H,X){return ze(z,H,"<",X)},t.gtr=function(z,H,X){return ze(z,H,">",X)},t.outside=ze,t.prerelease=function(z,H){var X=j(z,H);return X&&X.prerelease.length?X.prerelease:null},t.intersects=function(z,H,X){return z=new ve(z,X),H=new ve(H,X),z.intersects(H)},t.coerce=function(z){if(z instanceof B)return z;if(typeof z!="string")return null;var H=z.match(L[V]);return H==null?null:j((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,O(1))},function(q,t){var O,D,w=q.exports={};function A(){throw new Error("setTimeout has not been defined")}function F(){throw new Error("clearTimeout has not been defined")}function L(S){if(O===setTimeout)return setTimeout(S,0);if((O===A||!O)&&setTimeout)return O=setTimeout,setTimeout(S,0);try{return O(S,0)}catch(v){try{return O.call(null,S,0)}catch(y){return O.call(this,S,0)}}}(function(){try{O=typeof setTimeout=="function"?setTimeout:A}catch(S){O=A}try{D=typeof clearTimeout=="function"?clearTimeout:F}catch(S){D=F}})();var u,h=[],g=!1,p=-1;function m(){g&&u&&(g=!1,u.length?h=u.concat(h):p=-1,h.length&&R())}function R(){if(!g){var S=L(m);g=!0;for(var v=h.length;v;){for(u=h,h=[];++p<v;)u&&u[p].run();p=-1,v=h.length}u=null,g=!1,function(y){if(D===clearTimeout)return clearTimeout(y);if((D===F||!D)&&clearTimeout)return D=clearTimeout,clearTimeout(y);try{D(y)}catch(f){try{return D.call(null,y)}catch(s){return D.call(this,y)}}}(S)}}function a(S,v){this.fun=S,this.array=v}function c(){}w.nextTick=function(S){var v=new Array(arguments.length-1);if(arguments.length>1)for(var y=1;y<arguments.length;y++)v[y-1]=arguments[y];h.push(new a(S,v)),h.length!==1||g||L(R)},a.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=c,w.addListener=c,w.once=c,w.off=c,w.removeListener=c,w.removeAllListeners=c,w.emit=c,w.prependListener=c,w.prependOnceListener=c,w.listeners=function(S){return[]},w.binding=function(S){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(S){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(Y[37],ee([0,1,7,2]),function(q,t,O,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=void 0;function w(f){const s=f;return s?[s.on,s.pause,s.resume,s.destroy].every(o=>typeof o=="function"):!1}t.isReadableStream=w;function A(f){const s=f;return s?w(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}t.isReadableBufferedStream=A;function F(f,s){return new L(f,s)}t.newWriteableStream=F;class L{constructor(s,o){this.reducer=s,this.options=o,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(o=>this.pendingWritePromises.push(o))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(o=>o(s))}emitError(s){this.listeners.error.length===0?(0,O.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(o=>o(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,o){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(o),this.resume();break;case"end":this.listeners.end.push(o),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(o),this.state.flowing&&this.flowErrors();break}}removeListener(s,o){if(this.state.destroyed)return;let e;switch(s){case"data":e=this.listeners.data;break;case"end":e=this.listeners.end;break;case"error":e=this.listeners.error;break}if(e){const i=e.indexOf(o);i>=0&&e.splice(i,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const o=[...this.pendingWritePromises];this.pendingWritePromises.length=0,o.forEach(e=>e())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function u(f,s){const o=[];let e;for(;(e=f.read())!==null;)o.push(e);return s(o)}t.consumeReadable=u;function h(f,s,o){const e=[];let i;for(;(i=f.read())!==null&&e.length<o;)e.push(i);return i===null&&e.length>0?s(e):{read:()=>{if(e.length>0)return e.shift();if(typeof i!="undefined"){const n=i;return i=void 0,n}return f.read()}}}t.peekReadable=h;function g(f,s){return new Promise((o,e)=>{const i=[];p(f,{onData:n=>{s&&i.push(n)},onError:n=>{s?e(n):o(void 0)},onEnd:()=>{o(s?s(i):void 0)}})})}t.consumeStream=g;function p(f,s){f.on("error",o=>s.onError(o)),f.on("end",()=>s.onEnd()),f.on("data",o=>s.onData(o))}t.listenStream=p;function m(f,s){return new Promise((o,e)=>{const i=new D.DisposableStore,n=[],r=P=>{if(n.push(P),n.length>s)return i.dispose(),f.pause(),o({stream:f,buffer:n,ended:!1})},l=P=>e(P),d=()=>o({stream:f,buffer:n,ended:!0});i.add((0,D.toDisposable)(()=>f.removeListener("error",l))),f.on("error",l),i.add((0,D.toDisposable)(()=>f.removeListener("end",d))),f.on("end",d),i.add((0,D.toDisposable)(()=>f.removeListener("data",r))),f.on("data",r)})}t.peekStream=m;function R(f,s){const o=F(s);return o.end(f),o}t.toStream=R;function a(){const f=F(()=>{throw new Error("not supported")});return f.end(),f}t.emptyStream=a;function c(f){let s=!1;return{read:()=>s?null:(s=!0,f)}}t.toReadable=c;function S(f,s,o){const e=F(o);return p(f,{onData:i=>e.write(s.data(i)),onError:i=>e.error(s.error?s.error(i):i),onEnd:()=>e.end()}),e}t.transform=S;function v(f,s,o){let e=!1;return{read:()=>{const i=s.read();return e?i:(e=!0,i!==null?o([f,i]):f)}}}t.prefixedReadable=v;function y(f,s,o){let e=!1;const i=F(o);return p(s,{onData:n=>e?i.write(n):(e=!0,i.write(o([f,n]))),onError:n=>i.error(n),onEnd:()=>{e||(e=!0,i.write(f)),i.end()}}),i}t.prefixedStream=y}),define(Y[16],ee([0,1,37]),function(q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const D=typeof Buffer!="undefined";let w,A;class F{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return D?new F(Buffer.allocUnsafe(r)):new F(new Uint8Array(r))}static wrap(r){return D&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new F(r)}static fromString(r,l){return!(l?.dontUseNodeBuffer||!1)&&D?new F(Buffer.from(r)):(w||(w=new TextEncoder),new F(w.encode(r)))}static concat(r,l){if(typeof l=="undefined"){l=0;for(let U=0,b=r.length;U<b;U++)l+=r[U].byteLength}const d=F.alloc(l);let P=0;for(let U=0,b=r.length;U<b;U++){const k=r[U];d.set(k,P),P+=k.byteLength}return d}toString(){return D?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(r,l){return new F(this.buffer.subarray(r,l))}set(r,l){r instanceof F?this.buffer.set(r.buffer,l):this.buffer.set(r,l)}readUInt32BE(r){return h(this.buffer,r)}writeUInt32BE(r,l){g(this.buffer,r,l)}readUInt32LE(r){return p(this.buffer,r)}writeUInt32LE(r,l){m(this.buffer,r,l)}readUInt8(r){return R(this.buffer,r)}writeUInt8(r,l){a(this.buffer,r,l)}}t.VSBuffer=F;function L(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0}t.readUInt16LE=L;function u(n,r,l){n[l+0]=r&255,r=r>>>8,n[l+1]=r&255}t.writeUInt16LE=u;function h(n,r){return n[r]*2**24+n[r+1]*2**16+n[r+2]*2**8+n[r+3]}t.readUInt32BE=h;function g(n,r,l){n[l+3]=r,r=r>>>8,n[l+2]=r,r=r>>>8,n[l+1]=r,r=r>>>8,n[l]=r}t.writeUInt32BE=g;function p(n,r){return n[r+0]<<0>>>0|n[r+1]<<8>>>0|n[r+2]<<16>>>0|n[r+3]<<24>>>0}t.readUInt32LE=p;function m(n,r,l){n[l+0]=r&255,r=r>>>8,n[l+1]=r&255,r=r>>>8,n[l+2]=r&255,r=r>>>8,n[l+3]=r&255}t.writeUInt32LE=m;function R(n,r){return n[r]}t.readUInt8=R;function a(n,r,l){n[l]=r}t.writeUInt8=a;function c(n){return O.consumeReadable(n,r=>F.concat(r))}t.readableToBuffer=c;function S(n){return O.toReadable(n)}t.bufferToReadable=S;function v(n){return O.consumeStream(n,r=>F.concat(r))}t.streamToBuffer=v;async function y(n){return n.ended?F.concat(n.buffer):F.concat([...n.buffer,await v(n.stream)])}t.bufferedStreamToBuffer=y;function f(n){return O.toStream(n,r=>F.concat(r))}t.bufferToStream=f;function s(n){return O.transform(n,{data:r=>typeof r=="string"?F.fromString(r):F.wrap(r)},r=>F.concat(r))}t.streamToBufferReadableStream=s;function o(n){return O.newWriteableStream(r=>F.concat(r),n)}t.newWriteableBufferStream=o;function e(n,r){return O.prefixedReadable(n,r,l=>F.concat(l))}t.prefixedBufferReadable=e;function i(n,r){return O.prefixedStream(n,r,l=>F.concat(l))}t.prefixedBufferStream=i}),define(Y[18],ee([0,1,13]),function(q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.filter=t.getCaseInsensitive=t.distinct=t.getOrDefault=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function D(c){if(!c||typeof c!="object"||c instanceof RegExp)return c;const S=Array.isArray(c)?[]:{};return Object.keys(c).forEach(v=>{c[v]&&typeof c[v]=="object"?S[v]=D(c[v]):S[v]=c[v]}),S}t.deepClone=D;function w(c){if(!c||typeof c!="object")return c;const S=[c];for(;S.length>0;){const v=S.shift();Object.freeze(v);for(const y in v)if(A.call(v,y)){const f=v[y];typeof f=="object"&&!Object.isFrozen(f)&&S.push(f)}}return c}t.deepFreeze=w;const A=Object.prototype.hasOwnProperty;function F(c,S){return L(c,S,new Set)}t.cloneAndChange=F;function L(c,S,v){if((0,O.isUndefinedOrNull)(c))return c;const y=S(c);if(typeof y!="undefined")return y;if((0,O.isArray)(c)){const f=[];for(const s of c)f.push(L(s,S,v));return f}if((0,O.isObject)(c)){if(v.has(c))throw new Error("Cannot clone recursive data-structure");v.add(c);const f={};for(let s in c)A.call(c,s)&&(f[s]=L(c[s],S,v));return v.delete(c),f}return c}function u(c,S,v=!0){return(0,O.isObject)(c)?((0,O.isObject)(S)&&Object.keys(S).forEach(y=>{y in c?v&&((0,O.isObject)(c[y])&&(0,O.isObject)(S[y])?u(c[y],S[y],v):c[y]=S[y]):c[y]=S[y]}),c):S}t.mixin=u;function h(c,S){if(c===S)return!0;if(c==null||S===null||S===void 0||typeof c!=typeof S||typeof c!="object"||Array.isArray(c)!==Array.isArray(S))return!1;let v,y;if(Array.isArray(c)){if(c.length!==S.length)return!1;for(v=0;v<c.length;v++)if(!h(c[v],S[v]))return!1}else{const f=[];for(y in c)f.push(y);f.sort();const s=[];for(y in S)s.push(y);if(s.sort(),!h(f,s))return!1;for(v=0;v<f.length;v++)if(!h(c[f[v]],S[f[v]]))return!1}return!0}t.equals=h;function g(c){const S=new Set;return JSON.stringify(c,(v,y)=>{if((0,O.isObject)(y)||Array.isArray(y)){if(S.has(y))return"[Circular]";S.add(y)}return y})}t.safeStringify=g;function p(c,S,v){const y=S(c);return typeof y=="undefined"?v:y}t.getOrDefault=p;function m(c,S){const v=Object.create(null);return!c||!S||Object.keys(S).forEach(f=>{const s=c[f],o=S[f];h(s,o)||(v[f]=o)}),v}t.distinct=m;function R(c,S){const v=S.toLowerCase(),y=Object.keys(c).find(f=>f.toLowerCase()===v);return y?c[y]:c[S]}t.getCaseInsensitive=R;function a(c,S){const v=Object.create(null);for(const y of Object.keys(c))S(y,c[y])&&(v[y]=c[y]);return v}t.filter=a}),define(Y[59],ee([0,1,8]),function(q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function D(h){const g=h;return g&&typeof g.type=="string"&&typeof g.severity=="string"}t.isRemoteConsoleLog=D;function w(h){const g=[];let p;try{const m=JSON.parse(h.arguments),R=m[m.length-1];R&&R.__$stack&&(m.pop(),p=R.__$stack),g.push(...m)}catch(m){g.push("Unable to log remote console arguments",h.arguments)}return{args:g,stack:p}}t.parse=w;function A(h){if(typeof h!="string")return A(w(h).stack);const g=h;if(g){const p=F(g),m=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(p||"");if(m&&m.length===4)return{uri:O.URI.file(m[1]),line:Number(m[2]),column:Number(m[3])}}}t.getFirstFrame=A;function F(h){if(!h)return h;const g=h.indexOf(`
`);return g===-1?h:h.substring(0,g)}function L(h,g){const{args:p,stack:m}=w(h),R=typeof p[0]=="string"&&p.length===1;let a=F(m);a&&(a=`(${a.trim()})`);let c=[];if(typeof p[0]=="string"?a&&R?c=[`%c[${g}] %c${p[0]} %c${a}`,u("blue"),u(""),u("grey")]:c=[`%c[${g}] %c${p[0]}`,u("blue"),u(""),...p.slice(1)]:c=[`%c[${g}]%`,u("blue"),...p],a&&!R&&c.push(a),typeof console[h.severity]!="function")throw new Error("Unknown console method");console[h.severity].apply(console,c)}t.log=L;function u(h){return`color: ${h}`}}),define(Y[60],ee([0,1,16,21,8]),function(q,t,O,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.MarshalledId=t.parse=t.stringify=void 0;function A(g){return JSON.stringify(g,u)}t.stringify=A;function F(g){let p=JSON.parse(g);return p=h(p),p}t.parse=F;var L;(function(g){g[g.Uri=1]="Uri",g[g.Regexp=2]="Regexp",g[g.ScmResource=3]="ScmResource",g[g.ScmResourceGroup=4]="ScmResourceGroup",g[g.ScmProvider=5]="ScmProvider",g[g.CommentController=6]="CommentController",g[g.CommentThread=7]="CommentThread",g[g.CommentThreadReply=8]="CommentThreadReply",g[g.CommentNode=9]="CommentNode",g[g.CommentThreadNode=10]="CommentThreadNode",g[g.TimelineActionContext=11]="TimelineActionContext",g[g.NotebookCellActionContext=12]="NotebookCellActionContext",g[g.TestItemContext=13]="TestItemContext"})(L=t.MarshalledId||(t.MarshalledId={}));function u(g,p){return p instanceof RegExp?{$mid:2,source:p.source,flags:(0,D.regExpFlags)(p)}:p}function h(g,p=0){if(!g||p>200)return g;if(typeof g=="object"){switch(g.$mid){case 1:return w.URI.revive(g);case 2:return new RegExp(g.source,g.flags)}if(g instanceof O.VSBuffer||g instanceof Uint8Array)return g;if(Array.isArray(g))for(let m=0;m<g.length;++m)g[m]=h(g[m],p+1);else for(const m in g)Object.hasOwnProperty.call(g,m)&&(g[m]=h(g[m],p+1))}return g}t.revive=h}),define(Y[61],ee([0,1,3,31,45,4,21]),function(q,t,O,D,w,A,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPathTerms=t.getBasenameTerms=t.isRelativePattern=t.hasSiblingFn=t.hasSiblingPromiseFn=t.parse=t.match=t.splitGlobAware=t.getEmptyExpression=void 0;function L(){return Object.create(null)}t.getEmptyExpression=L;const u="**",h="/",g="[/\\\\]",p="[^/\\\\]",m=/\//g;function R(I){switch(I){case 0:return"";case 1:return`${p}*?`;default:return`(?:${g}|${p}+${g}|${g}${p}+)*?`}}function a(I,N){if(!I)return[];const E=[];let C=!1,T=!1,j="";for(const B of I){switch(B){case N:if(!C&&!T){E.push(j),j="";continue}break;case"{":C=!0;break;case"}":C=!1;break;case"[":T=!0;break;case"]":T=!1;break}j+=B}return j&&E.push(j),E}t.splitGlobAware=a;function c(I){if(!I)return"";let N="";const E=a(I,h);if(E.every(C=>C===u))N=".*";else{let C=!1;E.forEach((T,j)=>{if(T===u){C||(N+=R(2),C=!0);return}let B=!1,$="",K=!1,te="";for(const ne of T){if(ne!=="}"&&B){$+=ne;continue}if(K&&(ne!=="]"||!te)){let oe;ne==="-"?oe=ne:(ne==="^"||ne==="!")&&!te?oe="^":ne===h?oe="":oe=F.escapeRegExpCharacters(ne),te+=oe;continue}switch(ne){case"{":B=!0;continue;case"[":K=!0;continue;case"}":N+=`(?:${a($,",").map(pe=>c(pe)).join("|")})`,B=!1,$="";break;case"]":N+="["+te+"]",K=!1,te="";break;case"?":N+=p;continue;case"*":N+=R(1);continue;default:N+=F.escapeRegExpCharacters(ne)}}j<E.length-1&&(E[j+1]!==u||j+2<E.length)&&(N+=g),C=!1})}return N}const S=/^\*\*\/\*\.[\w\.-]+$/,v=/^\*\*\/([\w\.-]+)\/?$/,y=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,f=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,s=/^\*\*((\/[\w\.-]+)+)\/?$/,o=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,e=new w.LRUCache(1e4),i=function(){return!1},n=function(){return null};function r(I,N){if(!I)return n;let E;typeof I!="string"?E=I.pattern:E=I,E=E.trim();const C=`${E}_${!!N.trimForExclusions}`;let T=e.get(C);if(T)return l(T,I);let j;if(S.test(E)){const B=E.substr(4);T=function($,K){return typeof $=="string"&&$.endsWith(B)?E:null}}else(j=v.exec(d(E,N)))?T=P(j[1],E):(N.trimForExclusions?f:y).test(E)?T=U(E,N):(j=s.exec(d(E,N)))?T=b(j[1].substr(1),E,!0):(j=o.exec(d(E,N)))?T=b(j[1],E,!1):T=k(E);return e.set(C,T),l(T,I)}function l(I,N){return typeof N=="string"?I:function(E,C){return D.isEqualOrParent(E,N.base)?I(A.relative(N.base,E),C):null}}function d(I,N){return N.trimForExclusions&&I.endsWith("/**")?I.substr(0,I.length-2):I}function P(I,N){const E=`/${I}`,C=`\\${I}`,T=function(B,$){return typeof B!="string"?null:$?$===I?N:null:B===I||B.endsWith(E)||B.endsWith(C)?N:null},j=[I];return T.basenames=j,T.patterns=[N],T.allBasenames=j,T}function U(I,N){const E=M(I.slice(1,-1).split(",").map($=>r($,N)).filter($=>$!==n),I),C=E.length;if(!C)return n;if(C===1)return E[0];const T=function($,K){for(let te=0,ne=E.length;te<ne;te++)if(E[te]($,K))return I;return null},j=E.find($=>!!$.allBasenames);j&&(T.allBasenames=j.allBasenames);const B=E.reduce(($,K)=>K.allPaths?$.concat(K.allPaths):$,[]);return B.length&&(T.allPaths=B),T}function b(I,N,E){const C=A.sep===A.posix.sep,T=C?I:I.replace(m,A.sep),j=A.sep+T,B=A.posix.sep+I,$=E?function(K,te){return typeof K=="string"&&(K===T||K.endsWith(j)||!C&&(K===I||K.endsWith(B)))?N:null}:function(K,te){return typeof K=="string"&&(K===T||!C&&K===I)?N:null};return $.allPaths=[(E?"*/":"./")+I],$}function k(I){try{const N=new RegExp(`^${c(I)}$`);return function(E){return N.lastIndex=0,typeof E=="string"&&N.test(E)?I:null}}catch(N){return n}}function V(I,N,E){return!I||typeof N!="string"?!1:G(I)(N,void 0,E)}t.match=V;function G(I,N={}){if(!I)return i;if(typeof I=="string"||Z(I)){const E=r(I,N);if(E===n)return i;const C=function(T,j){return!!E(T,j)};return E.allBasenames&&(C.allBasenames=E.allBasenames),E.allPaths&&(C.allPaths=E.allPaths),C}return x(I,N)}t.parse=G;function Q(I){if(!I)return;let N;return E=>(N||(N=(I()||Promise.resolve([])).then(C=>C?re(C):{})),N.then(C=>!!C[E]))}t.hasSiblingPromiseFn=Q;function ie(I){if(!I)return;let N;return E=>{if(!N){const C=I();N=C?re(C):{}}return!!N[E]}}t.hasSiblingFn=ie;function re(I){const N={};for(const E of I)N[E]=!0;return N}function Z(I){const N=I;return N&&typeof N.base=="string"&&typeof N.pattern=="string"}t.isRelativePattern=Z;function J(I){return I.allBasenames||[]}t.getBasenameTerms=J;function W(I){return I.allPaths||[]}t.getPathTerms=W;function x(I,N){const E=M(Object.getOwnPropertyNames(I).map($=>_($,I[$],N)).filter($=>$!==n)),C=E.length;if(!C)return n;if(!E.some($=>!!$.requiresSiblings)){if(C===1)return E[0];const $=function(ne,oe){for(let le=0,pe=E.length;le<pe;le++){const De=E[le](ne,oe);if(De)return De}return null},K=E.find(ne=>!!ne.allBasenames);K&&($.allBasenames=K.allBasenames);const te=E.reduce((ne,oe)=>oe.allPaths?ne.concat(oe.allPaths):ne,[]);return te.length&&($.allPaths=te),$}const T=function($,K,te){let ne;for(let oe=0,le=E.length;oe<le;oe++){const pe=E[oe];pe.requiresSiblings&&te&&(K||(K=A.basename($)),ne||(ne=K.substr(0,K.length-A.extname($).length)));const De=pe($,K,ne,te);if(De)return De}return null},j=E.find($=>!!$.allBasenames);j&&(T.allBasenames=j.allBasenames);const B=E.reduce(($,K)=>K.allPaths?$.concat(K.allPaths):$,[]);return B.length&&(T.allPaths=B),T}function _(I,N,E){if(N===!1)return n;const C=r(I,E);if(C===n)return n;if(typeof N=="boolean")return C;if(N){const T=N.when;if(typeof T=="string"){const j=(B,$,K,te)=>{if(!te||!C(B,$))return null;const ne=T.replace("$(basename)",K),oe=te(ne);return(0,O.isThenable)(oe)?oe.then(le=>le?I:null):oe?I:null};return j.requiresSiblings=!0,j}}return C}function M(I,N){const E=I.filter($=>!!$.basenames);if(E.length<2)return I;const C=E.reduce(($,K)=>{const te=K.basenames;return te?$.concat(te):$},[]);let T;if(N){T=[];for(let $=0,K=C.length;$<K;$++)T.push(N)}else T=E.reduce(($,K)=>{const te=K.patterns;return te?$.concat(te):$},[]);const j=function($,K){if(typeof $!="string")return null;if(!K){let ne;for(ne=$.length;ne>0;ne--){const oe=$.charCodeAt(ne-1);if(oe===47||oe===92)break}K=$.substr(ne)}const te=C.indexOf(K);return te!==-1?T[te]:null};j.basenames=C,j.patterns=T,j.allBasenames=C;const B=I.filter($=>!$.basenames);return B.push(j),B}}),define(Y[62],ee([0,1,31,9,4,10,19,21,8]),function(q,t,O,D,w,A,F,L,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.splitName=t.unmnemonicLabel=t.mnemonicButtonLabel=t.mnemonicMenuLabel=t.template=t.shorten=t.untildify=t.tildify=t.normalizeDriveLetter=t.getBaseLabel=t.getPathLabel=void 0;function h(r,l,d){if(typeof r=="string"&&(r=u.URI.file(r)),d){const U=d.getWorkspaceFolder(r);if(U){const b=d.getWorkspace().folders.length>1;let k;if((0,F.isEqual)(U.uri,r)?k="":k=(0,F.relativePath)(U.uri,r),b){const V=U.name?U.name:(0,F.basename)(U.uri);k=k?V+" \u2022 "+k:V}return k}}if(r.scheme!==D.Schemas.file&&r.scheme!==D.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,O.hasDriveLetter)(r.fsPath))return(0,w.normalize)(p(r.fsPath));let P=(0,w.normalize)(r.fsPath);return!A.isWindows&&l?.userHome&&(P=R(P,l.userHome.fsPath)),P}t.getPathLabel=h;function g(r){if(!r)return;typeof r=="string"&&(r=u.URI.file(r));const l=(0,F.basename)(r)||(r.scheme===D.Schemas.file?r.fsPath:r.path);return A.isWindows&&(0,O.isRootOrDriveLetter)(l)?p(l):l}t.getBaseLabel=g;function p(r){return(0,O.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}t.normalizeDriveLetter=p;let m=Object.create(null);function R(r,l){if(A.isWindows||!r||!l)return r;let d=m.original===l?m.normalized:void 0;return d||(d=`${(0,L.rtrim)(l,w.posix.sep)}${w.posix.sep}`,m={original:l,normalized:d}),(A.isLinux?r.startsWith(d):(0,L.startsWithIgnoreCase)(r,d))&&(r=`~/${r.substr(d.length)}`),r}t.tildify=R;function a(r,l){return r.replace(/^~($|\/|\\)/,`${l}$1`)}t.untildify=a;const c="\u2026",S="\\\\",v="~";function y(r,l=w.sep){const d=new Array(r.length);let P=!1;for(let U=0;U<r.length;U++){let b=r[U];if(b===""){d[U]=`.${l}`;continue}if(!b){d[U]=b;continue}P=!0;let k="";b.indexOf(S)===0?(k=b.substr(0,b.indexOf(S)+S.length),b=b.substr(b.indexOf(S)+S.length)):b.indexOf(l)===0?(k=b.substr(0,b.indexOf(l)+l.length),b=b.substr(b.indexOf(l)+l.length)):b.indexOf(v)===0&&(k=b.substr(0,b.indexOf(v)+v.length),b=b.substr(b.indexOf(v)+v.length));const V=b.split(l);for(let G=1;P&&G<=V.length;G++)for(let Q=V.length-G;P&&Q>=0;Q--){P=!1;let ie=V.slice(Q,Q+G).join(l);for(let re=0;!P&&re<r.length;re++)if(re!==U&&r[re]&&r[re].indexOf(ie)>-1){const Z=Q+G===V.length,J=Q>0&&r[re].indexOf(l)>-1?l+ie:ie,W=r[re].endsWith(J);P=!Z||W}if(!P){let re="";(V[0].endsWith(":")||k!=="")&&(Q===1&&(Q=0,G++,ie=V[0]+l+ie),Q>0&&(re=V[0]+l),re=k+re),Q>0&&(re=re+c+l),re=re+ie,Q+G<V.length&&(re=re+l+c),d[U]=re}}P&&(d[U]=b)}return d}t.shorten=y;var f;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(f||(f={}));function s(r,l=Object.create(null)){const d=[];let P=!1,U="";for(const b of r)if(b==="$"||P&&b==="{")U&&d.push({value:U,type:f.TEXT}),U="",P=!0;else if(b==="}"&&P){const k=l[U];if(typeof k=="string")k.length&&d.push({value:k,type:f.VARIABLE});else if(k){const V=d[d.length-1];(!V||V.type!==f.SEPARATOR)&&d.push({value:k.label,type:f.SEPARATOR})}U="",P=!1}else U+=b;return U&&!P&&d.push({value:U,type:f.TEXT}),d.filter((b,k)=>{if(b.type===f.SEPARATOR){const V=d[k-1],G=d[k+1];return[V,G].every(Q=>Q&&(Q.type===f.VARIABLE||Q.type===f.TEXT)&&Q.value.length>0)}return!0}).map(b=>b.value).join("")}t.template=s;function o(r,l){return A.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):r.replace(/&&|&/g,d=>d==="&"?"&&":"&")}t.mnemonicMenuLabel=o;function e(r,l){return A.isMacintosh||l?r.replace(/\(&&\w\)|&&/g,""):A.isWindows?r.replace(/&&|&/g,d=>d==="&"?"&&":"&"):r.replace(/&&/g,"_")}t.mnemonicButtonLabel=e;function i(r){return r.replace(/&/g,"&&")}t.unmnemonicLabel=i;function n(r){const l=r.indexOf("/")!==-1?w.posix:w.win32,d=l.basename(r),P=l.dirname(r);return d.length?{name:d,parentPath:P}:{name:P,parentPath:""}}t.splitName=n}),define(Y[46],ee([0,1,126]),function(q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LineDecoder=void 0;class D{constructor(A="utf8"){this.stringDecoder=new O.StringDecoder(A),this.remaining=null}write(A){const F=[],L=this.remaining?this.remaining+this.stringDecoder.write(A):this.stringDecoder.write(A);if(L.length<1)return F;let u=0,h,g=u;for(;g<L.length;)if(h=L.charCodeAt(g),h===13||h===10){if(F.push(L.substring(u,g)),g++,g<L.length){const p=h;h=L.charCodeAt(g),(p===13&&h===10||p===10&&h===13)&&g++}u=g}else g++;return this.remaining=u<L.length?L.substr(u):null,F}end(){return this.remaining}}t.LineDecoder=D}),define(Y[63],ee([0,1,38,4,21,11]),function(q,t,O,D,w,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.realpathSync=t.realpath=t.realcaseSync=void 0;function F(g){const p=(0,D.dirname)(g);if(g===p)return g;const m=((0,D.basename)(g)||g).toLowerCase();try{const a=(0,A.readdirSync)(p).filter(c=>c.toLowerCase()===m);if(a.length===1){const c=F(p);if(c)return(0,D.join)(c,a[0])}else if(a.length>1){const c=a.indexOf(m);if(c>=0){const S=F(p);if(S)return(0,D.join)(S,a[c])}}}catch(R){}return null}t.realcaseSync=F;async function L(g){try{return await A.Promises.realpath(g)}catch(p){const m=h(g);return await A.Promises.access(m,O.constants.R_OK),m}}t.realpath=L;function u(g){try{return O.realpathSync(g)}catch(p){const m=h(g);return O.accessSync(m,O.constants.R_OK),m}}t.realpathSync=u;function h(g){return(0,w.rtrim)((0,D.normalize)(g),D.sep)}}),define(Y[64],ee([0,1,32,4,11]),function(q,t,O,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const A=/^\d+$/,F=/^Microsoft.PowerShell_.*/,L=/^Microsoft.PowerShellPreview_.*/;var u;(function(s){s[s.x64=0]="x64",s[s.x86=1]="x86",s[s.ARM=2]="ARM"})(u||(u={}));let h;switch(process.arch){case"ia32":case"x32":h=1;break;case"arm":case"arm64":h=2;break;default:h=0;break}let g;process.env.PROCESSOR_ARCHITEW6432?g=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?g=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?g=1:g=0;class p{constructor(o,e,i){this.exePath=o,this.displayName=e,this.knownToExist=i}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await w.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function m({useAlternateBitness:s=!1}={}){return s?h===0?process.env["ProgramFiles(x86)"]||null:g===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function R({useAlternateBitness:s=!1,findPreview:o=!1}={}){const e=m({useAlternateBitness:s});if(!e)return null;const i=D.join(e,"PowerShell");if(!await w.SymlinkSupport.existsDirectory(i))return null;let n=-1,r=null;for(const P of await w.Promises.readdir(i)){let U=-1;if(o){const k=P.indexOf("-");if(k<0)continue;const V=P.substring(0,k);if(!A.test(V)||P.substring(k+1)!=="preview")continue;U=parseInt(V,10)}else{if(!A.test(P))continue;U=parseInt(P,10)}if(U<=n)continue;const b=D.join(i,P,"pwsh.exe");!await w.SymlinkSupport.existsFile(b)||(r=b,n=U)}if(!r)return null;const l=e.includes("x86")?" (x86)":"",d=o?" Preview":"";return new p(r,`PowerShell${d}${l}`,!0)}async function a({findPreview:s}={}){if(!process.env.LOCALAPPDATA)return null;const o=D.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await w.SymlinkSupport.existsDirectory(o))return null;const{pwshMsixDirRegex:e,pwshMsixName:i}=s?{pwshMsixDirRegex:L,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:F,pwshMsixName:"PowerShell (Store)"};for(const n of await w.Promises.readdir(o))if(e.test(n)){const r=D.join(o,n,"pwsh.exe");return new p(r,i)}return null}function c(){const s=D.join(O.homedir(),".dotnet","tools","pwsh.exe");return new p(s,".NET Core PowerShell Global Tool")}function S(){const s=D.join(process.env.windir,h===1&&g!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new p(s,"Windows PowerShell",!0)}async function*v(){let s=await R();s&&(yield s),s=await R({useAlternateBitness:!0}),s&&(yield s),s=await a(),s&&(yield s),s=c(),s&&(yield s),s=await R({findPreview:!0}),s&&(yield s),s=await a({findPreview:!0}),s&&(yield s),s=await R({useAlternateBitness:!0,findPreview:!0}),s&&(yield s),s=S(),s&&(yield s)}async function*y(){for await(const s of v())await s.exists()&&(yield s)}t.enumeratePowerShellInstallations=y;async function f(){for await(const s of y())return s;return null}t.getFirstAvailablePowerShellInstallation=f}),define(Y[65],ee([0,1,38,31,2,127,4,10,11]),function(q,t,O,D,w,A,F,L,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CHANGE_BUFFER_DELAY=t.watchFolder=t.watchFile=void 0;function h(m,R,a){return p({path:m,isDirectory:!1},R,a)}t.watchFile=h;function g(m,R,a){return p({path:m,isDirectory:!0},R,a)}t.watchFolder=g,t.CHANGE_BUFFER_DELAY=100;function p(m,R,a){if(L.isMacintosh&&(0,D.isEqualOrParent)(m.path,"/Volumes/"))return a(`Refusing to watch ${m.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),w.Disposable.None;const c=(0,F.basename)(m.path),S=new Map;let v=!1,y=[(0,w.toDisposable)(()=>{S.forEach(f=>(0,w.dispose)(f)),S.clear()})];try{const f=(0,O.watch)(m.path);y.push((0,w.toDisposable)(()=>{f.removeAllListeners(),f.close()}));const s=new Set;m.isDirectory&&u.Promises.readdir(m.path).then(o=>o.forEach(e=>s.add(e))),f.on("error",(o,e)=>{v||a(`Failed to watch ${m.path} for changes using fs.watch() (${o}, ${e})`)}),f.on("change",(o,e)=>{if(v)return;let i="";if(e&&(i=e.toString(),L.isMacintosh&&(i=(0,A.normalizeNFC)(i))),!i||o!=="change"&&o!=="rename")return;const n=m.isDirectory?(0,F.join)(m.path,i):m.path;if(m.isDirectory)if(o==="rename"){const r=S.get(n);r&&(0,w.dispose)(r);const l=setTimeout(async()=>{S.delete(n);const d=await u.Promises.exists(n);if(v)return;let P;d?s.has(i)?P="changed":(P="added",s.add(i)):(s.delete(i),P="deleted"),R(P,n)},t.CHANGE_BUFFER_DELAY);S.set(n,(0,w.toDisposable)(()=>clearTimeout(l)))}else{let r;s.has(i)?r="changed":(r="added",s.add(i)),R(r,n)}else if(o==="rename"||i!==c){const r=setTimeout(async()=>{const l=await u.Promises.exists(n);v||(l?(R("changed",n),y=[p(m,R,a)]):R("deleted",n))},t.CHANGE_BUFFER_DELAY);(0,w.dispose)(y),y=[(0,w.toDisposable)(()=>clearTimeout(r))]}else R("changed",n)})}catch(f){u.Promises.exists(m.path).then(s=>{s&&!v&&a(`Failed to watch ${m.path} for changes using fs.watch() (${f.toString()})`)})}return(0,w.toDisposable)(()=>{v=!0,y=(0,w.dispose)(y)})}});var ue=this&&this.__decorate||function(q,t,O,D){var w=arguments.length,A=w<3?t:D===null?D=Object.getOwnPropertyDescriptor(t,O):D,F;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(q,t,O,D);else for(var L=q.length-1;L>=0;L--)(F=q[L])&&(A=(w<3?F(A):w>3?F(t,O,A):F(t,O))||A);return w>3&&A&&Object.defineProperty(t,O,A),A};define(Y[39],ee([0,1,24,3,16,26,44,7,14,2,60,21,13]),function(q,t,O,D,w,A,F,L,u,h,g,p,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var R;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(R=t.RequestType||(t.RequestType={}));function a(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var c;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(c=t.ResponseType||(t.ResponseType={}));function S(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(v||(v={}));class y{constructor(I){this.buffer=I,this.pos=0}read(I){const N=this.buffer.slice(this.pos,this.pos+I);return this.pos+=N.byteLength,N}}class f{constructor(){this.buffers=[]}get buffer(){return w.VSBuffer.concat(this.buffers)}write(I){this.buffers.push(I)}}var s;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(s||(s={}));function o(M){const I=w.VSBuffer.alloc(4);return I.writeUInt32BE(M,0),I}function e(M){return M.read(4).readUInt32BE(0)}function i(M){const I=w.VSBuffer.alloc(1);return I.writeUInt8(M,0),I}const n={Undefined:i(s.Undefined),String:i(s.String),Buffer:i(s.Buffer),VSBuffer:i(s.VSBuffer),Array:i(s.Array),Object:i(s.Object)},r=typeof Buffer!="undefined";function l(M,I){if(typeof I=="undefined")M.write(n.Undefined);else if(typeof I=="string"){const N=w.VSBuffer.fromString(I);M.write(n.String),M.write(o(N.byteLength)),M.write(N)}else if(r&&Buffer.isBuffer(I)){const N=w.VSBuffer.wrap(I);M.write(n.Buffer),M.write(o(N.byteLength)),M.write(N)}else if(I instanceof w.VSBuffer)M.write(n.VSBuffer),M.write(o(I.byteLength)),M.write(I);else if(Array.isArray(I)){M.write(n.Array),M.write(o(I.length));for(const N of I)l(M,N)}else{const N=w.VSBuffer.fromString(JSON.stringify(I));M.write(n.Object),M.write(o(N.byteLength)),M.write(N)}}function d(M){switch(M.read(1).readUInt8(0)){case s.Undefined:return;case s.String:return M.read(e(M)).toString();case s.Buffer:return M.read(e(M)).buffer;case s.VSBuffer:return M.read(e(M));case s.Array:{const N=e(M),E=[];for(let C=0;C<N;C++)E.push(d(M));return E}case s.Object:return JSON.parse(M.read(e(M)).toString())}}class P{constructor(I,N,E=null,C=1e3){this.protocol=I,this.ctx=N,this.logger=E,this.timeoutDelay=C,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(T=>this.onRawMessage(T)),this.sendResponse({type:200})}registerChannel(I,N){this.channels.set(I,N),setTimeout(()=>this.flushPendingRequests(I),0)}sendResponse(I){switch(I.type){case 200:{const N=this.send([I.type]);this.logger&&this.logger.logOutgoing(N,0,1,S(I.type));return}case 201:case 202:case 204:case 203:{const N=this.send([I.type,I.id],I.data);this.logger&&this.logger.logOutgoing(N,I.id,1,S(I.type),I.data);return}}}send(I,N=void 0){const E=new f;return l(E,I),l(E,N),this.sendBuffer(E.buffer)}sendBuffer(I){try{return this.protocol.send(I),I.byteLength}catch(N){return 0}}onRawMessage(I){const N=new y(I),E=d(N),C=d(N),T=E[0];switch(T){case 100:return this.logger&&this.logger.logIncoming(I.byteLength,E[1],1,`${a(T)}: ${E[2]}.${E[3]}`,C),this.onPromise({type:T,id:E[1],channelName:E[2],name:E[3],arg:C});case 102:return this.logger&&this.logger.logIncoming(I.byteLength,E[1],1,`${a(T)}: ${E[2]}.${E[3]}`,C),this.onEventListen({type:T,id:E[1],channelName:E[2],name:E[3],arg:C});case 101:return this.logger&&this.logger.logIncoming(I.byteLength,E[1],1,`${a(T)}`),this.disposeActiveRequest({type:T,id:E[1]});case 103:return this.logger&&this.logger.logIncoming(I.byteLength,E[1],1,`${a(T)}`),this.disposeActiveRequest({type:T,id:E[1]})}}onPromise(I){const N=this.channels.get(I.channelName);if(!N){this.collectPendingRequest(I);return}const E=new A.CancellationTokenSource;let C;try{C=N.call(this.ctx,I.name,I.arg,E.token)}catch(B){C=Promise.reject(B)}const T=I.id;C.then(B=>{this.sendResponse({id:T,data:B,type:201}),this.activeRequests.delete(I.id)},B=>{B instanceof Error?this.sendResponse({id:T,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.sendResponse({id:T,data:B,type:203}),this.activeRequests.delete(I.id)});const j=(0,h.toDisposable)(()=>E.cancel());this.activeRequests.set(I.id,j)}onEventListen(I){const N=this.channels.get(I.channelName);if(!N){this.collectPendingRequest(I);return}const E=I.id,T=N.listen(this.ctx,I.name,I.arg)(j=>this.sendResponse({id:E,data:j,type:204}));this.activeRequests.set(I.id,T)}disposeActiveRequest(I){const N=this.activeRequests.get(I.id);N&&(N.dispose(),this.activeRequests.delete(I.id))}collectPendingRequest(I){let N=this.pendingRequests.get(I.channelName);N||(N=[],this.pendingRequests.set(I.channelName,N));const E=setTimeout(()=>{console.error(`Unknown channel: ${I.channelName}`),I.type===100&&this.sendResponse({id:I.id,data:{name:"Unknown channel",message:`Channel name '${I.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);N.push({request:I,timeoutTimer:E})}flushPendingRequests(I){const N=this.pendingRequests.get(I);if(N){for(const E of N)switch(clearTimeout(E.timeoutTimer),E.request.type){case 100:this.onPromise(E.request);break;case 102:this.onEventListen(E.request);break}this.pendingRequests.delete(I)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(I=>I.dispose()),this.activeRequests.clear()}}t.ChannelServer=P;var U;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(U=t.RequestInitiator||(t.RequestInitiator={}));class b{constructor(I,N=null){this.protocol=I,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new u.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(E=>this.onBuffer(E)),this.logger=N}getChannel(I){const N=this;return{call(E,C,T){return N.isDisposed?Promise.reject(L.canceled()):N.requestPromise(I,E,C,T)},listen(E,C){return N.isDisposed?Promise.reject(L.canceled()):N.requestEvent(I,E,C)}}}requestPromise(I,N,E,C=A.CancellationToken.None){const T=this.lastRequestId++,B={id:T,type:100,channelName:I,name:N,arg:E};if(C.isCancellationRequested)return Promise.reject(L.canceled());let $;return new Promise((te,ne)=>{if(C.isCancellationRequested)return ne(L.canceled());const oe=()=>{const ke=Te=>{switch(Te.type){case 201:this.handlers.delete(T),te(Te.data);break;case 202:this.handlers.delete(T);const we=new Error(Te.data.message);we.stack=Te.data.stack,we.name=Te.data.name,ne(we);break;case 203:this.handlers.delete(T),ne(Te.data);break}};this.handlers.set(T,ke),this.sendRequest(B)};let le=null;this.state===v.Idle?oe():(le=(0,D.createCancelablePromise)(ke=>this.whenInitialized()),le.then(()=>{le=null,oe()}));const pe=()=>{le?(le.cancel(),le=null):this.sendRequest({id:T,type:101}),ne(L.canceled())},De=C.onCancellationRequested(pe);$=(0,h.combinedDisposable)((0,h.toDisposable)(pe),De),this.activeRequests.add($)}).finally(()=>{this.activeRequests.delete($)})}requestEvent(I,N,E){const C=this.lastRequestId++,j={id:C,type:102,channelName:I,name:N,arg:E};let B=null;const $=new u.Emitter({onFirstListenerAdd:()=>{B=(0,D.createCancelablePromise)(te=>this.whenInitialized()),B.then(()=>{B=null,this.activeRequests.add($),this.sendRequest(j)})},onLastListenerRemove:()=>{B?(B.cancel(),B=null):(this.activeRequests.delete($),this.sendRequest({id:C,type:103}))}}),K=te=>$.fire(te.data);return this.handlers.set(C,K),$.event}sendRequest(I){switch(I.type){case 100:case 102:{const N=this.send([I.type,I.id,I.channelName,I.name],I.arg);this.logger&&this.logger.logOutgoing(N,I.id,0,`${a(I.type)}: ${I.channelName}.${I.name}`,I.arg);return}case 101:case 103:{const N=this.send([I.type,I.id]);this.logger&&this.logger.logOutgoing(N,I.id,0,a(I.type));return}}}send(I,N=void 0){const E=new f;return l(E,I),l(E,N),this.sendBuffer(E.buffer)}sendBuffer(I){try{return this.protocol.send(I),I.byteLength}catch(N){return 0}}onBuffer(I){const N=new y(I),E=d(N),C=d(N),T=E[0];switch(T){case 200:return this.logger&&this.logger.logIncoming(I.byteLength,0,0,S(T)),this.onResponse({type:E[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(I.byteLength,E[1],0,S(T),C),this.onResponse({type:E[0],id:E[1],data:C})}}onResponse(I){if(I.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const N=this.handlers.get(I.id);N&&N(I)}get onDidInitializePromise(){return u.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(I=>I.dispose()),this.activeRequests.clear()}}ue([F.memoize],b.prototype,"onDidInitializePromise",null),t.ChannelClient=b;class k{constructor(I){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new u.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new u.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,I(({protocol:N,onDidClientDisconnect:E})=>{u.Event.once(N.onMessage)(T=>{const j=new y(T),B=d(j),$=new P(N,B),K=new b(N);this.channels.forEach((ne,oe)=>$.registerChannel(oe,ne));const te={channelServer:$,channelClient:K,ctx:B};this._connections.add(te),this._onDidAddConnection.fire(te),E(()=>{$.dispose(),K.dispose(),this._connections.delete(te),this._onDidRemoveConnection.fire(te)})})})}get connections(){const I=[];return this._connections.forEach(N=>I.push(N)),I}getChannel(I,N){const E=this;return{call(C,T,j){let B;if((0,m.isFunction)(N)){let K=(0,O.getRandomElement)(E.connections.filter(N));B=K?Promise.resolve(K):u.Event.toPromise(u.Event.filter(E.onDidAddConnection,N))}else B=N.routeCall(E,C,T);const $=B.then(K=>K.channelClient.getChannel(I));return G($).call(C,T,j)},listen(C,T){if((0,m.isFunction)(N))return E.getMulticastEvent(I,N,C,T);const j=N.routeEvent(E,C,T).then(B=>B.channelClient.getChannel(I));return G(j).listen(C,T)}}}getMulticastEvent(I,N,E,C){const T=this;let j=new h.DisposableStore;const B=new u.Emitter({onFirstListenerAdd:()=>{j=new h.DisposableStore;const $=new u.EventMultiplexer,K=new Map,te=oe=>{const pe=oe.channelClient.getChannel(I).listen(E,C),De=$.add(pe);K.set(oe,De)},ne=oe=>{const le=K.get(oe);!le||(le.dispose(),K.delete(oe))};T.connections.filter(N).forEach(te),u.Event.filter(T.onDidAddConnection,N)(te,void 0,j),T.onDidRemoveConnection(ne,void 0,j),$.event(B.fire,B,j),j.add($)},onLastListenerRemove:()=>{j.dispose()}});return B.event}registerChannel(I,N){this.channels.set(I,N),this._connections.forEach(E=>{E.channelServer.registerChannel(I,N)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=k;class V{constructor(I,N,E=null){const C=new f;l(C,N),I.send(C.buffer),this.channelClient=new b(I,E),this.channelServer=new P(I,N,E)}getChannel(I){return this.channelClient.getChannel(I)}registerChannel(I,N){this.channelServer.registerChannel(I,N)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=V;function G(M){return{call(I,N,E){return M.then(C=>C.call(I,N,E))},listen(I,N){const E=new u.Relay;return M.then(C=>E.input=C.listen(I,N)),E.event}}}t.getDelayedChannel=G;function Q(M){let I=!1;return{call(N,E,C){return I?M.call(N,E,C):(0,D.timeout)(0).then(()=>I=!0).then(()=>M.call(N,E,C))},listen(N,E){if(I)return M.listen(N,E);const C=new u.Relay;return(0,D.timeout)(0).then(()=>I=!0).then(()=>C.input=M.listen(N,E)),C.event}}}t.getNextTickChannel=Q;class ie{constructor(I){this.fn=I}routeCall(I){return this.route(I)}routeEvent(I){return this.route(I)}async route(I){for(const N of I.connections)if(await Promise.resolve(this.fn(N.ctx)))return Promise.resolve(N);return await u.Event.toPromise(I.onDidAddConnection),await this.route(I)}}t.StaticRouter=ie;var re;(function(M){function I(C,T){const j=C,B=T&&T.disableMarshalling,$=new Map;for(const K in j)E(K)&&$.set(K,u.Event.buffer(j[K],!0));return new class{listen(K,te){const ne=$.get(te);if(ne)return ne;throw new Error(`Event not found: ${te}`)}call(K,te,ne){const oe=j[te];if(typeof oe=="function"){if(!B&&Array.isArray(ne))for(let le=0;le<ne.length;le++)ne[le]=(0,g.revive)(ne[le]);return oe.apply(j,ne)}throw new Error(`Method not found: ${te}`)}}}M.fromService=I;function N(C,T){const j=T&&T.disableMarshalling;return new Proxy({},{get(B,$){if(typeof $=="string")return T?.properties?.has($)?T.properties.get($):E($)?C.listen($):async function(...K){let te;T&&!(0,m.isUndefinedOrNull)(T.context)?te=[T.context,...K]:te=K;const ne=await C.call($,te);return j?ne:(0,g.revive)(ne)};throw new Error(`Property not found: ${String($)}`)}})}M.toService=N;function E(C){return C[0]==="o"&&C[1]==="n"&&p.isUpperAsciiLetter(C.charCodeAt(2))}})(re=t.ProxyChannel||(t.ProxyChannel={}));const Z=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function J(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){let I=M.toString();if(I!=="[object Object]")return I}return M}function W(M){return Array.isArray(M)?M.map(J):J(M)}function x(M,I,N,E,C,T,j){j=W(j);const B=Z[C],$=B[E%B.length];let K=[`%c[${M}]%c[${String(I).padStart(7," ")}]%c[len: ${String(N).padStart(5," ")}]%c${String(E).padStart(5," ")} - ${T}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(T)?(K=K.concat(j),K.push(")")):K.push(j),console.log.apply(console,K)}t.logWithColors=x;class _{constructor(I,N){this._outgoingPrefix=I,this._incomingPrefix=N,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(I,N,E,C,T){this._totalOutgoing+=I,x(this._outgoingPrefix,this._totalOutgoing,I,N,E,C,T)}logIncoming(I,N,E,C,T){this._totalIncoming+=I,x(this._incomingPrefix,this._totalIncoming,I,N,E,C,T)}}t.IPCLogger=_}),define(Y[66],ee([0,1,3,14,2,13]),function(q,t,O,D,w,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageHint=void 0;var F;(function(g){g[g.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(F=t.StorageHint||(t.StorageHint={}));var L;(function(g){g[g.None=0]="None",g[g.Initialized=1]="Initialized",g[g.Closed=2]="Closed"})(L||(L={}));class u extends w.Disposable{constructor(p,m=Object.create(null)){super();this.database=p,this.options=m,this._onDidChangeStorage=this._register(new D.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=L.None,this.cache=new Map,this.flushDelayer=new O.ThrottledDelayer(u.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(p=>this.onDidChangeItemsExternal(p)))}onDidChangeItemsExternal(p){p.changed?.forEach((m,R)=>this.accept(R,m)),p.deleted?.forEach(m=>this.accept(m,void 0))}accept(p,m){if(this.state===L.Closed)return;let R=!1;(0,A.isUndefinedOrNull)(m)?R=this.cache.delete(p):this.cache.get(p)!==m&&(this.cache.set(p,m),R=!0),R&&this._onDidChangeStorage.fire(p)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===L.None&&(this.state=L.Initialized,this.options.hint!==F.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(p,m){const R=this.cache.get(p);return(0,A.isUndefinedOrNull)(R)?m:R}getBoolean(p,m){const R=this.get(p);return(0,A.isUndefinedOrNull)(R)?m:R==="true"}getNumber(p,m){const R=this.get(p);return(0,A.isUndefinedOrNull)(R)?m:parseInt(R,10)}async set(p,m){if(this.state===L.Closed)return;if((0,A.isUndefinedOrNull)(m))return this.delete(p);const R=String(m);if(this.cache.get(p)!==R)return this.cache.set(p,R),this.pendingInserts.set(p,R),this.pendingDeletes.delete(p),this._onDidChangeStorage.fire(p),this.flushDelayer.trigger(()=>this.flushPending())}async delete(p){if(!(this.state===L.Closed||!this.cache.delete(p)))return this.pendingDeletes.has(p)||this.pendingDeletes.add(p),this.pendingInserts.delete(p),this._onDidChangeStorage.fire(p),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=L.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(p){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const p={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(p).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(p=>this.whenFlushedCallbacks.push(p))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=u,u.DEFAULT_FLUSH_DELAY=100;class h{constructor(){this.onDidChangeItemsExternal=D.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(p){p.insert&&p.insert.forEach((m,R)=>this.items.set(R,m)),p.delete&&p.delete.forEach(m=>this.items.delete(m))}async close(){}}t.InMemoryStorageDatabase=h}),define(Y[67],ee([5,6]),function(q,t){return q.create("vs/base/common/date",t)}),define(Y[68],ee([0,1,67]),function(q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const D=60,w=D*60,A=w*24,F=A*7,L=A*30,u=A*365;function h(p,m){typeof p!="number"&&(p=p.getTime());const R=Math.round((new Date().getTime()-p)/1e3);if(R<-30)return(0,O.localize)(0,null,h(new Date().getTime()+R*1e3,!1));if(R<30)return(0,O.localize)(1,null);let a;return R<D?(a=R,m?a===1?(0,O.localize)(2,null,a):(0,O.localize)(3,null,a):a===1?(0,O.localize)(4,null,a):(0,O.localize)(5,null,a)):R<w?(a=Math.floor(R/D),m?a===1?(0,O.localize)(6,null,a):(0,O.localize)(7,null,a):a===1?(0,O.localize)(8,null,a):(0,O.localize)(9,null,a)):R<A?(a=Math.floor(R/w),m?a===1?(0,O.localize)(10,null,a):(0,O.localize)(11,null,a):a===1?(0,O.localize)(12,null,a):(0,O.localize)(13,null,a)):R<F?(a=Math.floor(R/A),m?a===1?(0,O.localize)(14,null,a):(0,O.localize)(15,null,a):a===1?(0,O.localize)(16,null,a):(0,O.localize)(17,null,a)):R<L?(a=Math.floor(R/F),m?a===1?(0,O.localize)(18,null,a):(0,O.localize)(19,null,a):a===1?(0,O.localize)(20,null,a):(0,O.localize)(21,null,a)):R<u?(a=Math.floor(R/L),m?a===1?(0,O.localize)(22,null,a):(0,O.localize)(23,null,a):a===1?(0,O.localize)(24,null,a):(0,O.localize)(25,null,a)):(a=Math.floor(R/u),m?a===1?(0,O.localize)(26,null,a):(0,O.localize)(27,null,a):a===1?(0,O.localize)(28,null,a):(0,O.localize)(29,null,a))}t.fromNow=h;function g(p){return p.getFullYear()+"-"+String(p.getMonth()+1).padStart(2,"0")+"-"+String(p.getDate()).padStart(2,"0")+"T"+String(p.getHours()).padStart(2,"0")+":"+String(p.getMinutes()).padStart(2,"0")+":"+String(p.getSeconds()).padStart(2,"0")+"."+(p.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=g}),define(Y[69],ee([5,6]),function(q,t){return q.create("vs/base/common/errorMessage",t)}),define(Y[28],ee([0,1,24,13,69]),function(q,t,O,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toErrorMessage=void 0;function A(h,g){return g&&(h.stack||h.stacktrace)?w.localize(0,null,L(h),F(h.stack)||F(h.stacktrace)):L(h)}function F(h){return Array.isArray(h)?h.join(`
`):h}function L(h){return typeof h.code=="string"&&typeof h.errno=="number"&&typeof h.syscall=="string"?w.localize(1,null,h.message):h.message||w.localize(2,null)}function u(h=null,g=!1){if(!h)return w.localize(3,null);if(Array.isArray(h)){const p=O.coalesce(h),m=u(p[0],g);return p.length>1?w.localize(4,null,m,p.length):m}if(D.isString(h))return h;if(h.detail){const p=h.detail;if(p.error)return A(p.error,g);if(p.exception)return A(p.exception,g)}return h.stack?A(h,g):h.message?h.message:w.localize(5,null)}t.toErrorMessage=u}),define(Y[70],ee([5,6]),function(q,t){return q.create("vs/base/node/processes",t)}),define(Y[47],ee([0,1,33,31,9,18,4,10,34,13,46,11,70]),function(q,t,O,D,w,A,F,L,u,h,g,p,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.LineProcess=t.AbstractProcess=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0;function R(s){switch(s){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function a(s,o){if(L.isWindows)try{const e={stdio:["pipe","pipe","ignore"]};o&&(e.cwd=o);const i=O.execFile("taskkill",["/T","/F","/PID",s.pid.toString()],e);return new Promise(n=>{i.once("error",r=>{n({success:!1,error:r})}),i.once("exit",(r,l)=>{n(r===0?{success:!0}:{success:!1,code:r!==null?r:1})})})}catch(e){return Promise.resolve({success:!1,error:e,code:e.status?R(e.status):1})}else if(L.isLinux||L.isMacintosh)try{const e=w.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",q).fsPath;return new Promise(i=>{O.execFile(e,[s.pid.toString()],{encoding:"utf8",shell:!0},(n,r,l)=>{i(n?{success:!1,error:n}:{success:!0})})})}catch(e){return Promise.resolve({success:!1,error:e})}else s.kill("SIGKILL");return Promise.resolve({success:!0})}function c(s=u.env){return s.comspec||"cmd.exe"}t.getWindowsShell=c;class S{constructor(o,e,i,n){if(e!==void 0&&i!==void 0&&n!==void 0)this.cmd=o,this.args=e,this.shell=i,this.options=n;else{const r=o;this.cmd=r.command,this.shell=r.isShellCommand,this.args=r.args.slice(0),this.options=r.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const r=Object.create(null);Object.keys(u.env).forEach(l=>{r[l]=u.env[l]}),Object.keys(this.options.env).forEach(l=>{r[l]=this.options.env[l]}),this.options.env=r}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const e=o.lastIndexOf(F.sep);return e!==-1&&(o=o.substring(e+1)),S.WellKnowCommands[o]?o:"other"}start(o){return L.isWindows&&(this.options&&this.options.cwd&&D.isUNC(this.options.cwd)||!this.options&&D.isUNC(u.cwd()))?Promise.reject(new Error(m.localize(0,null))):this.useExec().then(e=>{let i,n;const r=new Promise((l,d)=>{i=l,n=d});if(e){let l=this.cmd;this.args&&(l=l+" "+this.args.join(" ")),this.childProcess=O.exec(l,this.options,(d,P,U)=>{this.childProcess=null;const b=d;b&&b.killed?n({killed:this.terminateRequested,stdout:P.toString(),stderr:U.toString()}):this.handleExec(i,o,d,P,U)})}else{let l=null;const d=P=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(P,i,o,n);const U={terminated:this.terminateRequested};h.isNumber(P)&&(U.cmdCode=P),i(U)};if(this.shell&&L.isWindows){const P=A.deepClone(this.options);P.windowsVerbatimArguments=!0,P.detached=!1;let U=!1,b=!1;const k=[];let V=this.ensureQuotes(this.cmd);k.push(V.value),U=V.quoted,this.args&&this.args.forEach(Q=>{V=this.ensureQuotes(Q),k.push(V.value),b=b&&V.quoted});const G=["/s","/c"];U?b?G.push('"'+k.join(" ")+'"'):k.length>1?G.push('"'+k[0]+'" '+k.slice(1).join(" ")):G.push('"'+k[0]+'"'):G.push(k.join(" ")),l=O.spawn(c(),G,P)}else this.cmd&&(l=O.spawn(this.cmd,this.args,this.options));l&&(this.childProcess=l,this.childProcessPromise=Promise.resolve(l),this.pidResolve&&(this.pidResolve(h.isNumber(l.pid)?l.pid:-1),this.pidResolve=void 0),l.on("error",P=>{this.childProcess=null,n({terminated:this.terminateRequested,error:P})}),l.pid&&(this.childProcess.on("close",d),this.handleSpawn(l,i,o,n,!0)))}return r})}handleClose(o,e,i,n){}ensureQuotes(o){return S.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,a(o,this.options.cwd).then(e=>(e.success&&(this.childProcess=null),e))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!L.isWindows)return o(!1);const e=O.spawn(c(),["/s","/c"]);e.on("error",i=>o(!0)),e.on("exit",i=>o(!1))})}}t.AbstractProcess=S,S.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},S.regexp=/^[^"].* .*[^"]/;class v extends S{constructor(o,e,i,n){super(o,e,i,n);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,e,i,n,r){[n,r].forEach((l,d)=>{const P=new g.LineDecoder;P.write(l).forEach(k=>{e({line:k,source:d===0?0:1})});const b=P.end();b&&e({line:b,source:d===0?0:1})}),o({terminated:this.terminateRequested,error:i})}handleSpawn(o,e,i,n,r){const l=new g.LineDecoder,d=new g.LineDecoder;o.stdout.on("data",P=>{l.write(P).forEach(b=>i({line:b,source:0}))}),o.stderr.on("data",P=>{d.write(P).forEach(b=>i({line:b,source:1}))}),this.stdoutLineDecoder=l,this.stderrLineDecoder=d}handleClose(o,e,i,n){const r=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;r&&i({line:r,source:0});const l=this.stderrLineDecoder?this.stderrLineDecoder.end():null;l&&i({line:l,source:1})}}t.LineProcess=v;function y(s){let o=[],e=!1;const i=function(n){if(e){o.push(n);return}(!s.send(n,l=>{if(l&&console.error(l),e=!1,o.length>0){const d=o.slice(0);o=[],d.forEach(P=>i(P))}})||L.isWindows)&&(e=!0)};return{send:i}}t.createQueuedSender=y;var f;(function(s){async function o(e,i,n){if(F.isAbsolute(e))return e;if(i===void 0&&(i=u.cwd()),F.dirname(e)!=="."||(n===void 0&&h.isString(u.env.PATH)&&(n=u.env.PATH.split(F.delimiter)),n===void 0||n.length===0))return F.join(i,e);async function l(d){if(await p.Promises.exists(d)){let P;try{P=await p.Promises.stat(d)}catch(U){U.message.startsWith("EACCES")&&(P=await p.Promises.lstat(d))}return P?!P.isDirectory():!1}return!1}for(let d of n){let P;if(F.isAbsolute(d)?P=F.join(d,e):P=F.join(i,d,e),await l(P))return P;let U=P+".com";if(await l(U)||(U=P+".exe",await l(U)))return U}return F.join(i,e)}s.findExecutable=o})(f=t.win32||(t.win32={}))}),define(Y[71],ee([0,1,32,10,64,47]),function(q,t,O,D,w,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function F(R,a){return R===1?D.isWindows?p():A.getWindowsShell(a):h(R,a)}t.getSystemShell=F;function L(R,a){return R===1?D.isWindows?m(a):A.getWindowsShell(a):h(R,a)}t.getSystemShellSync=L;let u=null;function h(R,a){if(D.isLinux&&R===2||D.isMacintosh&&R===3)return"/bin/bash";if(!u){let c;if(D.isWindows)c="/bin/bash";else{if(c=a.SHELL,!c)try{c=(0,O.userInfo)().shell}catch(S){}c||(c="sh"),c==="/bin/false"&&(c="/bin/bash")}u=c}return u}let g=null;async function p(){return g||(g=(await(0,w.getFirstAvailablePowerShellInstallation)()).exePath),g}function m(R){if(g)return g;const a=D.isWindows&&parseFloat((0,O.release)())>=10,c=R.hasOwnProperty("PROCESSOR_ARCHITEW6432"),S=`${R.windir}\\${c?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return a?S:A.getWindowsShell(R)}}),define(Y[48],ee([0,1,33,3,16,26,59,7,14,2,18,10,47,39]),function(q,t,O,D,w,A,F,L,u,h,g,p,m,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class a extends R.ChannelServer{constructor(v){super({send:y=>{try{process.send&&process.send(y.buffer.toString("base64"))}catch(f){}},onMessage:u.Event.fromNodeEventEmitter(process,"message",y=>w.VSBuffer.wrap(Buffer.from(y,"base64")))},v);process.once("disconnect",()=>this.dispose())}}t.Server=a;class c{constructor(v,y){this.modulePath=v,this.options=y,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new u.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const f=y&&y.timeout?y.timeout:6e4;this.disposeDelayer=new D.Delayer(f),this.child=null,this._client=null}getChannel(v){const y=this;return{call(f,s,o){return y.requestPromise(v,f,s,o)},listen(f,s){return y.requestEvent(v,f,s)}}}requestPromise(v,y,f,s=A.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(s.isCancellationRequested)return Promise.reject(L.canceled());this.disposeDelayer.cancel();const o=this.getCachedChannel(v),e=(0,D.createCancelablePromise)(r=>o.call(y,f,r)),i=s.onCancellationRequested(()=>e.cancel()),n=(0,h.toDisposable)(()=>e.cancel());return this.activeRequests.add(n),e.finally(()=>{i.dispose(),this.activeRequests.delete(n),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),e}requestEvent(v,y,f){if(!this.disposeDelayer)return u.Event.None;this.disposeDelayer.cancel();let s;const o=new u.Emitter({onFirstListenerAdd:()=>{s=this.getCachedChannel(v).listen(y,f)(o.fire,o),this.activeRequests.add(s)},onLastListenerRemove:()=>{this.activeRequests.delete(s),s.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return o.event}get client(){if(!this._client){const v=this.options&&this.options.args?this.options.args:[],y=Object.create(null);y.env={...(0,g.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(y.env={...y.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(y.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(y.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(y.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),y.execArgv===void 0&&(y.execArgv=process.execArgv.filter(l=>!/^--inspect(-brk)?=/.test(l))),p.isMacintosh&&y.env&&delete y.env.DYLD_LIBRARY_PATH,this.child=(0,O.fork)(this.modulePath,v,y);const f=new u.Emitter;u.Event.fromNodeEventEmitter(this.child,"message",l=>l)(l=>{if((0,F.isRemoteConsoleLog)(l)){(0,F.log)(l,`IPC Library: ${this.options.serverName}`);return}f.fire(w.VSBuffer.wrap(Buffer.from(l,"base64")))});const o=this.options.useQueue?(0,m.createQueuedSender)(this.child):this.child,e=l=>this.child&&this.child.connected&&o.send(l.buffer.toString("base64")),i=f.event,n={send:e,onMessage:i};this._client=new R.ChannelClient(n);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",l=>console.warn('IPC "'+this.options.serverName+'" errored with '+l)),this.child.on("exit",(l,d)=>{process.removeListener("exit",r),this.activeRequests.forEach(P=>(0,h.dispose)(P)),this.activeRequests.clear(),l!==0&&d!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+l+" and signal "+d),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:l,signal:d})})}return this._client}getCachedChannel(v){let y=this.channels.get(v);return y||(y=this.client.getChannel(v),this.channels.set(v,y)),y}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=c}),define(Y[72],ee([5,6]),function(q,t){return q.create("vs/base/node/zip",t)}),define(Y[73],ee([5,6]),function(q,t){return q.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Y[74],ee([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Y[75],ee([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Y[76],ee([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Y[77],ee([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Y[78],ee([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Y[79],ee([5,6]),function(q,t){return q.create("vs/platform/extensionManagement/node/extensionsScanner",t)}),define(Y[80],ee([5,6]),function(q,t){return q.create("vs/platform/extensions/common/extensionValidator",t)}),define(Y[81],ee([5,6]),function(q,t){return q.create("vs/platform/files/common/fileService",t)}),define(Y[82],ee([5,6]),function(q,t){return q.create("vs/platform/files/common/io",t)}),define(Y[83],ee([5,6]),function(q,t){return q.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Y[84],ee([5,6]),function(q,t){return q.create("vs/platform/request/common/request",t)}),define(Y[85],ee([5,6]),function(q,t){return q.create("vs/platform/telemetry/common/telemetryService",t)}),define(Y[86],ee([0,1,68,44,9,4,34,19,8]),function(q,t,O,D,w,A,F,L,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class h{constructor(a,c,S){this._args=a,this.paths=c,this.productService=S}get appRoot(){return(0,A.dirname)(w.FileAccess.asFileUri("",q).fsPath)}get userHome(){return u.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return u.URI.file((0,A.join)(this.userDataPath,"User"))}get tmpDir(){return u.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,L.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const a=(0,O.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,A.join)(this.userDataPath,"logs",a)}return this.args.logsPath}get userDataSyncLogResource(){return u.URI.file((0,A.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,L.joinPath)(u.URI.file((0,A.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return u.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return u.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,L.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const a=F.env.VSCODE_PORTABLE;return a?u.URI.file((0,A.join)(a,"argv.json")):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,L.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return u.URI.file((0,A.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,A.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const a=this.args["builtin-extensions-dir"];return a?(0,A.resolve)(a):(0,A.normalize)((0,A.join)(w.FileAccess.asFileUri("",q).fsPath,"..","extensions"))}get extensionsDownloadPath(){const a=this.args["extensions-download-dir"];return a?(0,A.resolve)(a):(0,A.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const a=this.args["extensions-dir"];if(a)return(0,A.resolve)(a);const c=F.env.VSCODE_EXTENSIONS;if(c)return c;const S=F.env.VSCODE_PORTABLE;return S?(0,A.join)(S,"extensions"):(0,L.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const a=this.args.extensionDevelopmentPath;if(Array.isArray(a))return a.map(c=>/^[^:/?#]+?:\/\//.test(c)?u.URI.parse(c):u.URI.file((0,A.normalize)(c)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(a=>a==="ui"||a==="workspace"||a==="web"?a:"workspace")}get extensionTestsLocationURI(){const a=this.args.extensionTestsPath;if(a)return/^[^:/?#]+?:\/\//.test(a)?u.URI.parse(a):u.URI.file((0,A.normalize)(a))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const a=this.args["disable-extension"];if(a){if(typeof a=="string")return[a];if(Array.isArray(a)&&a.length>0)return a}return!1}get debugExtensionHost(){return g(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!F.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,L.joinPath)(u.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return u.URI.file((0,A.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}ue([D.memoize],h.prototype,"appRoot",null),ue([D.memoize],h.prototype,"userHome",null),ue([D.memoize],h.prototype,"userDataPath",null),ue([D.memoize],h.prototype,"appSettingsHome",null),ue([D.memoize],h.prototype,"tmpDir",null),ue([D.memoize],h.prototype,"userRoamingDataHome",null),ue([D.memoize],h.prototype,"settingsResource",null),ue([D.memoize],h.prototype,"userDataSyncHome",null),ue([D.memoize],h.prototype,"userDataSyncLogResource",null),ue([D.memoize],h.prototype,"sync",null),ue([D.memoize],h.prototype,"machineSettingsResource",null),ue([D.memoize],h.prototype,"globalStorageHome",null),ue([D.memoize],h.prototype,"workspaceStorageHome",null),ue([D.memoize],h.prototype,"keybindingsResource",null),ue([D.memoize],h.prototype,"keyboardLayoutResource",null),ue([D.memoize],h.prototype,"argvResource",null),ue([D.memoize],h.prototype,"snippetsHome",null),ue([D.memoize],h.prototype,"isExtensionDevelopment",null),ue([D.memoize],h.prototype,"untitledWorkspacesHome",null),ue([D.memoize],h.prototype,"installSourcePath",null),ue([D.memoize],h.prototype,"builtinExtensionsPath",null),ue([D.memoize],h.prototype,"extensionsPath",null),ue([D.memoize],h.prototype,"extensionDevelopmentLocationURI",null),ue([D.memoize],h.prototype,"extensionDevelopmentKind",null),ue([D.memoize],h.prototype,"extensionTestsLocationURI",null),ue([D.memoize],h.prototype,"debugExtensionHost",null),ue([D.memoize],h.prototype,"serviceMachineIdResource",null),ue([D.memoize],h.prototype,"telemetryLogResource",null),ue([D.memoize],h.prototype,"disableWorkspaceTrust",null),t.AbstractNativeEnvironmentService=h;function g(R,a){return m(R["inspect-extensions"],R["inspect-brk-extensions"],5870,a,R.debugId)}t.parseExtensionHostPort=g;function p(R,a){return m(R["inspect-search"],R["inspect-brk-search"],5876,a)}t.parseSearchPort=p;function m(R,a,c,S,v){const f=Number(a||R)||(S?null:c),s=f?Boolean(!!a):!1;return{port:f,break:s,debugId:v}}}),function(){"use strict";function q(t,O,D,w){function A(L){const u=F(L),h=[u];return t.isAbsolute(u)||h.unshift(w),t.resolve(...h)}function F(L){const u=process.env.VSCODE_PORTABLE;if(u)return t.join(u,"user-data");let h=process.env.VSCODE_APPDATA;if(h)return t.join(h,D);const g=L["user-data-dir"];if(g)return g;switch(process.platform){case"win32":if(h=process.env.APPDATA,!h){const p=process.env.USERPROFILE;if(typeof p!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");h=t.join(p,"AppData","Roaming")}break;case"darwin":h=t.join(O.homedir(),"Library","Application Support");break;case"linux":h=process.env.XDG_CONFIG_HOME||t.join(O.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(h,D)}return{getUserDataPath:A}}if(typeof define=="function")define(Y[87],ee([0,88,32,9,19,34]),function(t,O,D,w,A,F){const L=A.dirname(w.FileAccess.asFileUri("",t)),u=t.__$__nodeRequire(A.joinPath(L,"package.json").fsPath);return q(O,D,u.name,F.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),O=require("path"),D=require("os");module.exports=q(O,D,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Y[89],ee([0,1,32,86,87]),function(q,t,O,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class A extends D.AbstractNativeEnvironmentService{constructor(L,u){super(L,{homeDir:(0,O.homedir)(),tmpDir:(0,O.tmpdir)(),userDataDir:(0,w.getUserDataPath)(L)},u)}}t.NativeEnvironmentService=A}),define(Y[90],ee([0,1,18]),function(q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.localizeManifest=void 0;const D=/^%([\w\d.-]+)%$/i;function w(A,F){const L=u=>{if(typeof u!="string")return;const h=D.exec(u);if(!h)return;const g=F[h[1]]??u;return typeof g=="string"?g:typeof g.message=="string"?g.message:u};return(0,O.cloneAndChange)(A,L)}t.localizeManifest=w}),define(Y[49],ee([0,1,80]),function(q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,w=/^-(\d{4})(\d{2})(\d{2})$/;function A(m){return m=m.trim(),m==="*"||D.test(m)}t.isValidVersionStr=A;function F(m){if(!A(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let R=m.match(D);return R?{hasCaret:R[1]==="^",hasGreaterEquals:R[1]===">=",majorBase:R[2]==="x"?0:parseInt(R[2],10),majorMustEqual:R[2]!=="x",minorBase:R[4]==="x"?0:parseInt(R[4],10),minorMustEqual:R[4]!=="x",patchBase:R[6]==="x"?0:parseInt(R[6],10),patchMustEqual:R[6]!=="x",preRelease:R[8]||null}:null}t.parseVersion=F;function L(m){if(!m)return null;let R=m.majorBase,a=m.majorMustEqual,c=m.minorBase,S=m.minorMustEqual,v=m.patchBase,y=m.patchMustEqual;m.hasCaret&&(R===0||(S=!1),y=!1);let f=0;if(m.preRelease){const s=w.exec(m.preRelease);if(s){const[,o,e,i]=s;f=Date.UTC(Number(o),Number(e)-1,Number(i))}}return{majorBase:R,majorMustEqual:a,minorBase:c,minorMustEqual:S,patchBase:v,patchMustEqual:y,isMinimum:m.hasGreaterEquals,notBefore:f}}t.normalizeVersion=L;function u(m,R,a){let c;typeof m=="string"?c=L(F(m)):c=m;let S;R instanceof Date?S=R.getTime():typeof R=="string"&&(S=new Date(R).getTime());let v;if(typeof a=="string"?v=L(F(a)):v=a,!c||!v)return!1;let y=c.majorBase,f=c.minorBase,s=c.patchBase,o=v.majorBase,e=v.minorBase,i=v.patchBase,n=v.notBefore,r=v.majorMustEqual,l=v.minorMustEqual,d=v.patchMustEqual;return v.isMinimum?y>o?!0:y<o?!1:f>e?!0:f<e||S&&S<n?!1:s>=i:(y===1&&o===0&&(!r||!l||!d)&&(o=1,e=0,i=0,r=!0,l=!1,d=!1),y<o?!1:y>o?!r:f<e?!1:f>e?!l:s<i?!1:s>i?!d:!(S&&S<n))}t.isValidVersion=u;function h(m,R,a,c){return a.isBuiltin||typeof a.main=="undefined"?!0:p(m,R,a.engines.vscode,c)}t.isValidExtensionVersion=h;function g(m,R,a){return m==="*"||p(R,a,m)}t.isEngineValid=g;function p(m,R,a,c=[]){let S=L(F(a));if(!S)return c.push(O.localize(0,null,a)),!1;if(S.majorBase===0){if(!S.majorMustEqual||!S.minorMustEqual)return c.push(O.localize(1,null,a)),!1}else if(!S.majorMustEqual)return c.push(O.localize(2,null,a)),!1;return u(m,R,S)?!0:(c.push(O.localize(3,null,m,a)),!1)}}),define(Y[91],ee([0,1,2,9,39,48]),function(q,t,O,D,w,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class F extends O.Disposable{constructor(u,h,g,p){super();this.folders=u,this.onDidFilesChange=h,this.onLogMessage=g,this.verboseLogging=p,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const u=this._register(new A.Client(D.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(u.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=F.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=w.ProxyChannel.toService((0,w.getNextTickChannel)(u.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(h=>!this.isDisposed&&this.onDidFilesChange(h))),this._register(this.service.onDidLogMessage(h=>this.onLogMessage(h))),this.setFolders(this.folders)}setVerboseLogging(u){this.verboseLogging=u,!this.isDisposed&&this.service&&this.service.setVerboseLogging(u)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${u}`})}setFolders(u){this.folders=u,this.service&&this.service.setRoots(u)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=F,F.MAX_RESTARTS=5}),define(Y[92],ee([0,1,2,9,39,48]),function(q,t,O,D,w,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class F extends O.Disposable{constructor(u,h,g,p,m={}){super();this.folders=u,this.onDidFilesChange=h,this.onLogMessage=g,this.verboseLogging=p,this.watcherOptions=m,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const u=this._register(new A.Client(D.FileAccess.asFileUri("bootstrap-fork",q).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherService"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(u.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=F.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=w.ProxyChannel.toService((0,w.getNextTickChannel)(u.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(h=>!this.isDisposed&&this.onDidFilesChange(h))),this._register(this.service.onDidLogMessage(h=>this.onLogMessage(h))),this.service.setRoots(this.folders)}error(u){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${u}`})}setVerboseLogging(u){this.verboseLogging=u,this.service&&this.service.setVerboseLogging(u)}setFolders(u){this.folders=u,this.service&&this.service.setRoots(u)}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=F,F.MAX_RESTARTS=5}),define(Y[93],ee([0,1,33,61,9,46]),function(q,t,O,D,w,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OutOfProcessWin32FolderWatcher=void 0;class F{constructor(u,h,g,p,m){this.watchedFolder=u,this.eventCallback=g,this.logCallback=p,this.verboseLogging=m,this.restartCounter=0,Array.isArray(h)?this.ignored=h.map(R=>(0,D.parse)(R)):this.ignored=[],this.verboseLogging&&this.log(`Start watching: ${u}, excludes: ${h.join(",")}`),this.startWatcher()}startWatcher(){const u=[this.watchedFolder];this.verboseLogging&&u.push("-verbose"),this.handle=(0,O.spawn)(w.FileAccess.asFileUri("vs/platform/files/node/watcher/win32/CodeHelper.exe",q).fsPath,u);const h=new A.LineDecoder;this.handle.stdout.on("data",g=>{const p=[];for(const m of h.write(g)){const R=m.split("|");if(R.length===2){const a=Number(R[0]),c=R[1];if(a>=0&&a<3){if(this.ignored&&this.ignored.some(S=>S(c))){this.verboseLogging&&this.log(c);continue}p.push({type:F.changeTypeMap[a],path:c})}else this.log(R[1])}}p.length>0&&this.eventCallback(p)}),this.handle.on("error",g=>this.onError(g)),this.handle.stderr.on("data",g=>this.onError(g)),this.handle.on("exit",(g,p)=>this.onExit(g,p))}onError(u){this.error("process error: "+u.toString())}onExit(u,h){this.handle&&(this.error(`terminated unexpectedly (code: ${u}, signal: ${h})`),this.restartCounter<=F.MAX_RESTARTS?(this.error("is restarted again..."),this.restartCounter++,this.startWatcher()):this.error("Watcher failed to start after retrying for some time, giving up. Please report this as a bug report!"))}error(u){this.logCallback({type:"error",message:`[File Watcher (C#)] ${u}`})}log(u){this.logCallback({type:"trace",message:`[File Watcher (C#)] ${u}`})}dispose(){this.handle&&(this.handle.kill(),this.handle=void 0)}}t.OutOfProcessWin32FolderWatcher=F,F.MAX_RESTARTS=5,F.changeTypeMap=[0,1,2]}),define(Y[94],ee([0,1,4,21,93]),function(q,t,O,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class A{constructor(L,u,h,g){this.onDidFilesChange=u,this.onLogMessage=h,this.verboseLogging=g,this.service=void 0,this.folder=L[0],this.folder.path.indexOf("\\\\")===0&&this.folder.path.endsWith(O.posix.sep)&&(this.folder.path=(0,D.rtrim)(this.folder.path,O.posix.sep)),this.service=this.startWatching()}get isDisposed(){return!this.service}startWatching(){return new w.OutOfProcessWin32FolderWatcher(this.folder.path,this.folder.excludes,L=>this.onFileEvents(L),L=>this.onLogMessage(L),this.verboseLogging)}setVerboseLogging(L){this.verboseLogging=L,this.service&&(this.service.dispose(),this.service=this.startWatching())}onFileEvents(L){this.isDisposed||L.length>0&&this.onDidFilesChange(L)}dispose(){this.service&&(this.service.dispose(),this.service=void 0)}}t.FileWatcher=A}),define(Y[50],ee([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class O{constructor(w,A=[],F=!1){this.ctor=w,this.staticArguments=A,this.supportsDelayedInstantiation=F}}t.SyncDescriptor=O}),define(Y[95],ee([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class O{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}t.Node=O;class D{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let F of this._nodes.values())F.outgoing.size===0&&A.push(F);return A}insertEdge(A,F){const L=this.lookupOrInsertNode(A),u=this.lookupOrInsertNode(F);L.outgoing.set(this._hashFn(F),u),u.incoming.set(this._hashFn(A),L)}removeNode(A){const F=this._hashFn(A);this._nodes.delete(F);for(let L of this._nodes.values())L.outgoing.delete(F),L.incoming.delete(F)}lookupOrInsertNode(A){const F=this._hashFn(A);let L=this._nodes.get(F);return L||(L=new O(A),this._nodes.set(F,L)),L}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[F,L]of this._nodes)A.push(`${F}, (incoming)[${[...L.incoming.keys()].join(", ")}], (outgoing)[${[...L.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,F]of this._nodes){const L=new Set([A]),u=this._findCycle(F,L);if(u)return u}}_findCycle(A,F){for(let[L,u]of A.outgoing){if(F.has(L))return[...F,L].join(" -> ");F.add(L);const h=this._findCycle(u,F);if(h)return h;F.delete(L)}}}t.Graph=D}),define(Y[96],ee([0,1,12]),function(q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,O.createDecorator)("downloadService")}),define(Y[20],ee([0,1,12]),function(q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,O.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,O.refineServiceDecorator)(t.IEnvironmentService)}),define(Y[22],ee([0,1,9,75,12]),function(q,t,O,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.DefaultIconPath=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IExtensionManagementService=t.ExtensionManagementError=t.INSTALL_ERROR_INCOMPATIBLE=t.INSTALL_ERROR_MALICIOUS=t.INSTALL_ERROR_NOT_SUPPORTED=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";function A(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}t.isIExtensionIdentifier=A;var F;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=5]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(F=t.SortBy||(t.SortBy={}));var L;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(L=t.SortOrder||(t.SortOrder={}));var u;(function(p){p.Install="install",p.Uninstall="uninstall"})(u=t.StatisticType||(t.StatisticType={}));var h;(function(p){p[p.None=0]="None",p[p.Install=1]="Install",p[p.Update=2]="Update"})(h=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,w.createDecorator)("extensionGalleryService"),t.INSTALL_ERROR_NOT_SUPPORTED="notsupported",t.INSTALL_ERROR_MALICIOUS="malicious",t.INSTALL_ERROR_INCOMPATIBLE="incompatible";class g extends Error{constructor(m,R){super(m);this.code=R,this.name=R}}t.ExtensionManagementError=g,t.IExtensionManagementService=(0,w.createDecorator)("extensionManagementService"),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,w.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,w.createDecorator)("IExtensionTipsService"),t.DefaultIconPath=O.FileAccess.asBrowserUri("./media/defaultIcon.png",q).toString(!0),t.ExtensionsLabel=(0,D.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,D.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,w.createDecorator)("IExtensionManagementCLIService")}),define(Y[40],ee([0,1,21,12]),function(q,t,O,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isAuthenticaionProviderExtension=t.isLanguagePackExtension=t.ExtensionIdentifier=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function w(g){if(typeof g=="object"&&g!==null&&g.supported!==!0)return g.description}t.getWorkspaceSupportTypeMessage=w;function A(g){return g&&typeof g=="object"&&typeof g.id=="string"&&(!g.uuid||typeof g.uuid=="string")}t.isIExtensionIdentifier=A,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var F;(function(g){g[g.System=0]="System",g[g.User=1]="User"})(F=t.ExtensionType||(t.ExtensionType={}));class L{constructor(p){this.value=p,this._lower=p.toLowerCase()}static equals(p,m){if(typeof p=="undefined"||p===null)return typeof m=="undefined"||m===null;if(typeof m=="undefined"||m===null)return!1;if(typeof p=="string"||typeof m=="string"){let R=typeof p=="string"?p:p.value,a=typeof m=="string"?m:m.value;return O.equalsIgnoreCase(R,a)}return p._lower===m._lower}static toKey(p){return typeof p=="string"?p.toLowerCase():p._lower}}t.ExtensionIdentifier=L;function u(g){return g.contributes&&g.contributes.localizations?g.contributes.localizations.length>0:!1}t.isLanguagePackExtension=u;function h(g){return g.contributes&&g.contributes.authentication?g.contributes.authentication.length>0:!1}t.isAuthenticaionProviderExtension=h,t.IBuiltinExtensionsScannerService=(0,D.createDecorator)("IBuiltinExtensionsScannerService")}),define(Y[23],ee([0,1,21,40]),function(q,t,O,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getExtensionDependencies=t.getMaliciousExtensionsSet=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.ExtensionIdentifierWithVersion=t.areSameExtensions=void 0;function w(a,c){return a.uuid&&c.uuid?a.uuid===c.uuid:a.id===c.id?!0:(0,O.compareIgnoreCase)(a.id,c.id)===0}t.areSameExtensions=w;class A{constructor(c,S){this.version=S,this.id=c.id,this.uuid=c.uuid}key(){return`${this.id}-${this.version}`}equals(c){return c instanceof A?w(this,c)&&this.version===c.version:!1}}t.ExtensionIdentifierWithVersion=A;function F(a,c){return`${a}.${c}`}t.getExtensionId=F;function L(a){return a.toLocaleLowerCase()}t.adoptToGalleryExtensionId=L;function u(a,c){return L(F(a,c))}t.getGalleryExtensionId=u;function h(a,c){const S=[],v=y=>{for(const f of S)if(f.some(s=>w(c(s),c(y))))return f;return null};for(const y of a){const f=v(y);f?f.push(y):S.push([y])}return S}t.groupByExtension=h;function g(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=g;function p(a){return{id:a.identifier.id,name:a.name,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),...a.telemetryData}}t.getGalleryExtensionTelemetryData=p,t.BetterMergeId=new D.ExtensionIdentifier("pprice.better-merge");function m(a){const c=new Set;for(const S of a)S.malicious&&c.add(S.id.id);return c}t.getMaliciousExtensionsSet=m;function R(a,c){const S=[],v=c.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const y=v.shift();if(y&&S.every(f=>!w(f.identifier,{id:y}))){const f=a.filter(s=>w(s.identifier,{id:y}));f.length===1&&(S.push(f[0]),v.push(...f[0].manifest.extensionDependencies?.slice(0)??[]))}}return S}t.getExtensionDependencies=R});var fe=this&&this.__param||function(q,t){return function(O,D){t(O,D,q)}};define(Y[97],ee([0,1,26,7,62,9,41,8,76,22,23,40]),function(q,t,O,D,w,A,F,L,u,h,g,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=t.getIdAndVersion=void 0;const m=y=>(0,u.localize)(0,null,y),R=(0,u.localize)(1,null,"ms-dotnettools.csharp");function a(y,f){return f?`${y.publisher}.${y.name}@${y.version}`:`${y.publisher}.${y.name}`}const c=/^([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;function S(y){const f=c.exec(y);return f&&f[1]?[(0,g.adoptToGalleryExtensionId)(f[1]),f[2]]:[(0,g.adoptToGalleryExtensionId)(y),void 0]}t.getIdAndVersion=S;let v=class{constructor(f,s){this.extensionManagementService=f,this.extensionGalleryService=s}get location(){}async listExtensions(f,s,o=console){let e=await this.extensionManagementService.getInstalled(1);const i=p.EXTENSION_CATEGORIES.map(r=>r.toLowerCase());if(s&&s!==""){if(i.indexOf(s.toLowerCase())<0){o.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}e=e.filter(r=>r.manifest.categories?r.manifest.categories.map(d=>d.toLowerCase()).indexOf(s.toLowerCase())>-1:!1)}else if(s===""){o.log("Possible Categories: "),i.forEach(r=>{o.log(r)});return}this.location&&o.log((0,u.localize)(2,null,this.location)),e=e.sort((r,l)=>r.identifier.id.localeCompare(l.identifier.id));let n;for(let r of e)n!==r.identifier.id&&(n=r.identifier.id,o.log(a(r.manifest,f)))}async installExtensions(f,s,o,e,i=console){const n=[],r=[];f.length&&i.log(this.location?(0,u.localize)(3,null,this.location):(0,u.localize)(4,null));const l=await this.extensionManagementService.getInstalled(1),d=(b,k)=>{const V=l.find(G=>(0,g.areSameExtensions)(G.identifier,{id:b}));if(V){if(!k&&!e)return i.log((0,u.localize)(5,null,b,V.manifest.version,b)),!1;if(k&&V.manifest.version===k)return i.log((0,u.localize)(6,null,`${b}@${k}`)),!1}return!0},P=[],U=[];for(const b of f)if(b instanceof L.URI)P.push(b);else{const[k,V]=S(b);d(k,V)&&U.push({id:k,version:V,installOptions:{isBuiltin:!1,isMachineScoped:o}})}for(const b of s){const[k,V]=S(b);d(k,V)&&U.push({id:k,version:V,installOptions:{isBuiltin:!0,isMachineScoped:!1}})}if(P.length&&await Promise.all(P.map(async b=>{try{const k=await this.installVSIX(b,{isBuiltin:!1,isMachineScoped:o},e,i);k&&r.push(k)}catch(k){i.error(k.message||k.stack||k),n.push(b.toString())}})),U.length){const b=await this.getGalleryExtensions(U);await Promise.all(U.map(async k=>{const V=b.get(k.id.toLowerCase());if(V)try{const G=await this.installFromGallery(k,V,l,e,i);G&&r.push(G)}catch(G){i.error(G.message||G.stack||G),n.push(k.id)}else i.error(`${m(k.version?`${k.id}@${k.version}`:k.id)}
${R}`),n.push(k.id)}))}if(n.length)throw new Error((0,u.localize)(7,null,n.join(", ")))}async installVSIX(f,s,o,e){const i=await this.extensionManagementService.getManifest(f);if(!i)throw new Error("Invalid vsix");if(await this.validateVSIX(i,o,e))try{return await this.extensionManagementService.install(f,s),e.log((0,u.localize)(8,null,(0,w.getBaseLabel)(f))),i}catch(r){if((0,D.isPromiseCanceledError)(r))return e.log((0,u.localize)(9,null,(0,w.getBaseLabel)(f))),null;throw r}return null}async getGalleryExtensions(f){const s=f.filter(({version:i})=>i===void 0).map(({id:i})=>i),o=f.filter(({version:i})=>i!==void 0),e=new Map;return await Promise.all([(async()=>{(await this.extensionGalleryService.getExtensions(s,O.CancellationToken.None)).forEach(n=>e.set(n.identifier.id.toLowerCase(),n))})(),Promise.all(o.map(async({id:i,version:n})=>{const r=await this.extensionGalleryService.getCompatibleExtension({id:i},n);r&&e.set(r.identifier.id.toLowerCase(),r)}))]),e}async installFromGallery({id:f,version:s,installOptions:o},e,i,n,r){const l=await this.extensionGalleryService.getManifest(e,O.CancellationToken.None);if(l&&!this.validateExtensionKind(l,r))return null;const d=i.find(P=>(0,g.areSameExtensions)(P.identifier,e.identifier));if(d){if(e.version===d.manifest.version)return r.log((0,u.localize)(10,null,s?`${f}@${s}`:f)),null;r.log((0,u.localize)(11,null,f,e.version))}try{return o.isBuiltin?r.log(s?(0,u.localize)(12,null,f,s):(0,u.localize)(13,null,f)):r.log(s?(0,u.localize)(14,null,f,s):(0,u.localize)(15,null,f)),await this.extensionManagementService.installFromGallery(e,o),r.log((0,u.localize)(16,null,f,e.version)),l}catch(P){if((0,D.isPromiseCanceledError)(P))return r.log((0,u.localize)(17,null,f)),null;throw P}}validateExtensionKind(f,s){return!0}async validateVSIX(f,s,o){const e={id:(0,g.getGalleryExtensionId)(f.publisher,f.name)},n=(await this.extensionManagementService.getInstalled(1)).find(r=>(0,g.areSameExtensions)(e,r.identifier)&&(0,F.gt)(r.manifest.version,f.version));return n&&!s?(o.log((0,u.localize)(18,null,n.identifier.id,n.manifest.version,f.version)),!1):this.validateExtensionKind(f,o)}async uninstallExtensions(f,s,o=console){const e=async n=>{if(n instanceof L.URI){const r=await this.extensionManagementService.getManifest(n);return a(r)}return n},i=[];for(const n of f){const r=await e(n),d=(await this.extensionManagementService.getInstalled()).filter(P=>(0,g.areSameExtensions)(P.identifier,{id:r}));if(!d.length)throw new Error(`${this.notInstalled(r)}
${R}`);if(d.some(P=>P.type===0)){o.log((0,u.localize)(19,null,r));return}if(!s&&d.some(P=>P.isBuiltin)){o.log((0,u.localize)(20,null,r));return}o.log((0,u.localize)(21,null,r));for(const P of d)await this.extensionManagementService.uninstall(P),i.push(P);this.location?o.log((0,u.localize)(22,null,r,this.location)):o.log((0,u.localize)(23,null,r))}}async locateExtension(f,s=console){const o=await this.extensionManagementService.getInstalled();f.forEach(e=>{o.forEach(i=>{if(i.identifier.id===e&&i.location.scheme===A.Schemas.file){s.log(i.location.fsPath);return}})})}notInstalled(f){return this.location?(0,u.localize)(24,null,f,this.location):(0,u.localize)(25,null,f)}};v=ue([fe(0,h.IExtensionManagementService),fe(1,h.IExtensionGalleryService)],v),t.ExtensionManagementCLIService=v}),define(Y[98],ee([0,1,2,4,11,40]),function(q,t,O,D,w,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class F extends O.Disposable{constructor(u,h){super();this.environmentService=u,this.extensionsManifestCache=(0,D.join)(this.environmentService.userDataPath,A.MANIFEST_CACHE_FOLDER,A.USER_MANIFEST_CACHE_FILE),this._register(h.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(h.onDidUninstallExtension(g=>this.onDidUnInstallExtension(g)))}onDidInstallExtensions(u){u.some(h=>!!h.local)&&this.invalidate()}onDidUnInstallExtension(u){u.error||this.invalidate()}invalidate(){w.Promises.rm(this.extensionsManifestCache,w.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=F}),define(Y[99],ee([0,1,33,88,26,28,7,10,29,71,128]),function(q,t,O,D,w,A,F,L,u,h,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveShellEnv=void 0;async function p(a,c,S){return c["force-disable-user-env"]?(a.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):L.isWindows?(a.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,g.isLaunchedFromCli)(S)&&!c["force-user-env"]?(a.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,g.isLaunchedFromCli)(S)?a.trace("resolveShellEnv(): running (--force-user-env)"):a.trace("resolveShellEnv(): running (macOS/Linux)"),m||(m=new Promise(async v=>{const y=new w.CancellationTokenSource,f=setTimeout(()=>{a.error("[resolve shell env] Could not resolve shell environment within 10 seconds. Proceeding without shell environment..."),y.dispose(!0),v({})},1e4);try{const s=await R(a,y.token);v(s)}catch(s){(0,F.isPromiseCanceledError)(s)||a.error(`[resolve shell env] Unable to resolve shell environment (${s}). Proceeding without shell environment...`),v({})}finally{clearTimeout(f),y.dispose()}})),m)}t.resolveShellEnv=p;let m;async function R(a,c){const S=new Promise(async(v,y)=>{const f=process.env.ELECTRON_RUN_AS_NODE;a.trace("getUnixShellEnvironment#runAsNode",f);const s=process.env.ELECTRON_NO_ATTACH_CONSOLE;a.trace("getUnixShellEnvironment#noAttach",s);const o=(0,u.generateUuid)().replace(/-/g,"").substr(0,12),e=new RegExp(o+"(.*)"+o),i={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};a.trace("getUnixShellEnvironment#env",i);const n=await(0,h.getSystemShell)(L.OS,i);if(a.trace("getUnixShellEnvironment#shell",n),c.isCancellationRequested)return y(F.canceled);const r=D.basename(n);let l,d;/^pwsh(-preview)?$/.test(r)?(l=`& '${process.execPath}' -p '''${o}'' + JSON.stringify(process.env) + ''${o}'''`,d=["-Login","-Command"]):(l=`'${process.execPath}' -p '"${o}" + JSON.stringify(process.env) + "${o}"'`,d=["-ilc"]),a.trace("getUnixShellEnvironment#spawn",JSON.stringify(d),l);const P=(0,O.spawn)(n,[...d,l],{detached:!0,stdio:["ignore","pipe","pipe"],env:i});c.onCancellationRequested(()=>(P.kill(),y(F.canceled))),P.on("error",k=>{a.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(k)),v({})});const U=[];P.stdout.on("data",k=>U.push(k));const b=[];P.stderr.on("data",k=>b.push(k)),P.on("close",(k,V)=>{const G=Buffer.concat(U).toString("utf8");a.trace("getUnixShellEnvironment#raw",G);const Q=Buffer.concat(b).toString("utf8");if(Q.trim()&&a.trace("getUnixShellEnvironment#stderr",Q),k||V)return y(new Error(`Failed to get environment (code ${k}, signal ${V})`));const ie=e.exec(G),re=ie?ie[1]:"{}";try{const Z=JSON.parse(re);f?Z.ELECTRON_RUN_AS_NODE=f:delete Z.ELECTRON_RUN_AS_NODE,s?Z.ELECTRON_NO_ATTACH_CONSOLE=s:delete Z.ELECTRON_NO_ATTACH_CONSOLE,delete Z.XDG_RUNTIME_DIR,a.trace("getUnixShellEnvironment#result",Z),v(Z)}catch(Z){a.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(Z)),y(Z)}})});try{return await S}catch(v){return a.error("getUnixShellEnvironment#error",(0,A.toErrorMessage)(v)),{}}}}),define(Y[51],ee([0,1,10,8,17]),function(q,t,O,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeFileChanges=t.toFileChanges=void 0;function A(u){return u.map(h=>({type:h.type,resource:D.URI.file(h.path)}))}t.toFileChanges=A;function F(u){const h=new L;for(const g of u)h.processEvent(g);return h.normalize()}t.normalizeFileChanges=F;class L{constructor(){this.normalized=[],this.mapPathToChange=new Map}processEvent(h){const g=this.mapPathToChange.get(h.path);if(g){const p=g.type,m=h.type;p===1&&m===2?(this.mapPathToChange.delete(h.path),this.normalized.splice(this.normalized.indexOf(g),1)):p===2&&m===1?g.type=0:p===1&&m===0||(g.type=m)}else this.normalized.push(h),this.mapPathToChange.set(h.path,h)}normalize(){const h=[],g=[];return this.normalized.filter(p=>p.type!==2?(h.push(p),!1):!0).sort((p,m)=>p.path.length-m.path.length).filter(p=>g.some(m=>(0,w.isParent)(p.path,m,!O.isLinux))?!1:(g.push(p.path),!0)).concat(h)}}}),define(Y[100],ee([0,1,3,2,4,63,11,65,51]),function(q,t,O,D,w,A,F,L,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileWatcher=void 0;class h extends D.Disposable{constructor(p,m,R,a){super();this.path=p,this.onDidFilesChange=m,this.onLogMessage=R,this.verboseLogging=a,this.fileChangesDelayer=this._register(new O.ThrottledDelayer(L.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(p){this.verboseLogging=p}async startWatching(){try{const{stat:p,symbolicLink:m}=await F.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let R=this.path;if(m)try{R=await(0,A.realpath)(R)}catch(a){if(this.onError(a),m.dangling)return}p.isDirectory()?this._register((0,L.watchFolder)(R,(a,c)=>{this.onFileChange({type:a==="changed"?0:a==="added"?1:2,path:(0,w.join)(this.path,(0,w.basename)(c))})},a=>this.onError(a))):this._register((0,L.watchFile)(R,a=>{this.onFileChange({type:a==="changed"?0:2,path:this.path})},a=>this.onError(a)))}catch(p){p.code!=="ENOENT"&&this.onError(p)}}onFileChange(p){this.fileChangesBuffer.push(p),this.verboseLogging&&this.onVerbose(`${p.type===1?"[ADDED]":p.type===2?"[DELETED]":"[CHANGED]"} ${p.path}`),this.fileChangesDelayer.trigger(async()=>{const m=this.fileChangesBuffer;this.fileChangesBuffer=[];const R=(0,u.normalizeFileChanges)(m);if(this.verboseLogging)for(const a of R)this.onVerbose(`>> normalized ${a.type===1?"[ADDED]":a.type===2?"[DELETED]":"[CHANGED]"} ${a.path}`);R.length>0&&this.onDidFilesChange(R)})}onError(p){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${p}`})}onVerbose(p){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${p}`})}dispose(){this.isDisposed=!0,super.dispose()}}t.FileWatcher=h}),define(Y[52],ee([0,1]),function(q,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class O{constructor(...w){this._entries=new Map;for(let[A,F]of w)this.set(A,F)}set(w,A){const F=this._entries.get(w);return this._entries.set(w,A),F}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}t.ServiceCollection=O}),define(Y[101],ee([0,1,3,7,50,95,12,52]),function(q,t,O,D,w,A,F,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InstantiationService=void 0;const u=!1;class h extends Error{constructor(a){super("cyclic dependency between services");this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class g{constructor(a=new L.ServiceCollection,c=!1,S){this._activeInstantiations=new Set,this._services=a,this._strict=c,this._parent=S,this._services.set(F.IInstantiationService,this)}createChild(a){return new g(a,this._strict,this)}invokeFunction(a,...c){let S=m.traceInvocation(a),v=!1;try{return a({get:(f,s)=>{if(v)throw(0,D.illegalState)("service accessor is only valid during the invocation of its target method");const o=this._getOrCreateServiceInstance(f,S);if(!o&&s!==F.optional)throw new Error(`[invokeFunction] unknown service '${f}'`);return o}},...c)}finally{v=!0,S.stop()}}createInstance(a,...c){let S,v;return a instanceof w.SyncDescriptor?(S=m.traceCreation(a.ctor),v=this._createInstance(a.ctor,a.staticArguments.concat(c),S)):(S=m.traceCreation(a),v=this._createInstance(a,c,S)),S.stop(),v}_createInstance(a,c=[],S){let v=F._util.getServiceDependencies(a).sort((s,o)=>s.index-o.index),y=[];for(const s of v){let o=this._getOrCreateServiceInstance(s.id,S);if(!o&&this._strict&&!s.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${s.id}.`);y.push(o)}let f=v.length>0?v[0].index:c.length;if(c.length!==f){console.warn(`[createInstance] First service dependency of ${a.name} at position ${f+1} conflicts with ${c.length} static arguments`);let s=f-c.length;s>0?c=c.concat(new Array(s)):c=c.slice(0,f)}return new a(...[...c,...y])}_setServiceInstance(a,c){if(this._services.get(a)instanceof w.SyncDescriptor)this._services.set(a,c);else if(this._parent)this._parent._setServiceInstance(a,c);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let c=this._services.get(a);return!c&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):c}_getOrCreateServiceInstance(a,c){let S=this._getServiceInstanceOrDescriptor(a);return S instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,S,c.branch(a,!0)):(c.branch(a,!1),S)}_safeCreateAndCacheServiceInstance(a,c,S){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,c,S)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,c,S){const v=new A.Graph(s=>s.id.toString());let y=0;const f=[{id:a,desc:c,_trace:S}];for(;f.length;){const s=f.pop();if(v.lookupOrInsertNode(s),y++>1e3)throw new h(v);for(let o of F._util.getServiceDependencies(s.desc.ctor)){let e=this._getServiceInstanceOrDescriptor(o.id);if(!e&&!o.optional&&console.warn(`[createInstance] ${a} depends on ${o.id} which is NOT registered.`),e instanceof w.SyncDescriptor){const i={id:o.id,desc:e,_trace:s._trace.branch(o.id,!0)};v.insertEdge(s,i),f.push(i)}}}for(;;){const s=v.roots();if(s.length===0){if(!v.isEmpty())throw new h(v);break}for(const{data:o}of s){if(this._getServiceInstanceOrDescriptor(o.id)instanceof w.SyncDescriptor){const i=this._createServiceInstanceWithOwner(o.id,o.desc.ctor,o.desc.staticArguments,o.desc.supportsDelayedInstantiation,o._trace);this._setServiceInstance(o.id,i)}v.removeNode(o)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,c,S=[],v,y){if(this._services.get(a)instanceof w.SyncDescriptor)return this._createServiceInstance(c,S,v,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,c,S,v,y);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}_createServiceInstance(a,c=[],S,v){if(S){const y=new O.IdleValue(()=>this._createInstance(a,c,v));return new Proxy(Object.create(null),{get(f,s){if(s in f)return f[s];let o=y.value,e=o[s];return typeof e!="function"||(e=e.bind(o),f[s]=e),e},set(f,s,o){return y.value[s]=o,!0}})}else return this._createInstance(a,c,v)}}t.InstantiationService=g;var p;(function(R){R[R.Creation=0]="Creation",R[R.Invocation=1]="Invocation",R[R.Branch=2]="Branch"})(p||(p={}));class m{constructor(a,c){this.type=a,this.name=c,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return u?new m(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(a){return u?new m(0,a.name):m._None}branch(a,c){let S=new m(2,a.toString());return this._dep.push([a,c,S]),S}stop(){let a=Date.now()-this._start;m._totals+=a;let c=!1;function S(y,f){let s=[],o=new Array(y+1).join("	");for(const[e,i,n]of f._dep)if(i&&n){c=!0,s.push(`${o}CREATES -> ${e}`);let r=S(y+1,n);r&&s.push(r)}else s.push(`${o}uses -> ${e}`);return s.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${S(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(a>2||c)&&console.log(v.join(`
`))}}m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(Y[53],ee([0,1,12]),function(q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isValidLocalization=t.ILocalizationsService=void 0,t.ILocalizationsService=(0,O.createDecorator)("localizationsService");function D(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const A of w.translations)if(typeof A.id!="string"||typeof A.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}t.isValidLocalization=D}),define(Y[15],ee([0,1,28,14,2,10,12]),function(q,t,O,D,w,A,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,F.createDecorator)("logService"),t.ILoggerService=(0,F.createDecorator)("loggerService");function L(){return new Date().toISOString()}var u;(function(o){o[o.Trace=0]="Trace",o[o.Debug=1]="Debug",o[o.Info=2]="Info",o[o.Warning=3]="Warning",o[o.Error=4]="Error",o[o.Critical=5]="Critical",o[o.Off=6]="Off"})(u=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=u.Info;class h extends w.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new D.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=h;class g extends h{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...i){this.checkLogLevel(u.Trace)&&this.log(u.Trace,this.format([e,...i]))}debug(e,...i){this.checkLogLevel(u.Debug)&&this.log(u.Debug,this.format([e,...i]))}info(e,...i){this.checkLogLevel(u.Info)&&this.log(u.Info,this.format([e,...i]))}warn(e,...i){this.checkLogLevel(u.Warning)&&this.log(u.Warning,this.format([e,...i]))}error(e,...i){if(this.checkLogLevel(u.Error))if(e instanceof Error){const n=Array.prototype.slice.call(arguments);n[0]=e.stack,this.log(u.Error,this.format(n))}else this.log(u.Error,this.format([e,...i]))}critical(e,...i){this.checkLogLevel(u.Critical)&&this.log(u.Critical,this.format([e,...i]))}flush(){}format(e){let i="";for(let n=0;n<e.length;n++){let r=e[n];if(typeof r=="object")try{r=JSON.stringify(r)}catch(l){}i+=(n>0?" ":"")+r}return i}}t.AbstractMessageLogger=g;class p extends h{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!A.isWindows}trace(e,...i){this.getLevel()<=u.Trace&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}debug(e,...i){this.getLevel()<=u.Debug&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}info(e,...i){this.getLevel()<=u.Info&&(this.useColors?console.log(`[90m[main ${L()}][0m`,e,...i):console.log(`[main ${L()}]`,e,...i))}warn(e,...i){this.getLevel()<=u.Warning&&(this.useColors?console.warn(`[93m[main ${L()}][0m`,e,...i):console.warn(`[main ${L()}]`,e,...i))}error(e,...i){this.getLevel()<=u.Error&&(this.useColors?console.error(`[91m[main ${L()}][0m`,e,...i):console.error(`[main ${L()}]`,e,...i))}critical(e,...i){this.getLevel()<=u.Critical&&(this.useColors?console.error(`[90m[main ${L()}][0m`,e,...i):console.error(`[main ${L()}]`,e,...i))}dispose(){}flush(){}}t.ConsoleMainLogger=p;class m extends h{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...i){this.getLevel()<=u.Trace&&console.log("%cTRACE","color: #888",e,...i)}debug(e,...i){this.getLevel()<=u.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...i)}info(e,...i){this.getLevel()<=u.Info&&console.log("%c INFO","color: #33f",e,...i)}warn(e,...i){this.getLevel()<=u.Warning&&console.log("%c WARN","color: #993",e,...i)}error(e,...i){this.getLevel()<=u.Error&&console.log("%c  ERR","color: #f33",e,...i)}critical(e,...i){this.getLevel()<=u.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...i)}dispose(){}flush(){}}t.ConsoleLogger=m;class R extends h{constructor(e,i=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(i)}trace(e,...i){this.getLevel()<=u.Trace&&this.adapter.log(u.Trace,[this.extractMessage(e),...i])}debug(e,...i){this.getLevel()<=u.Debug&&this.adapter.log(u.Debug,[this.extractMessage(e),...i])}info(e,...i){this.getLevel()<=u.Info&&this.adapter.log(u.Info,[this.extractMessage(e),...i])}warn(e,...i){this.getLevel()<=u.Warning&&this.adapter.log(u.Warning,[this.extractMessage(e),...i])}error(e,...i){this.getLevel()<=u.Error&&this.adapter.log(u.Error,[this.extractMessage(e),...i])}critical(e,...i){this.getLevel()<=u.Critical&&this.adapter.log(u.Critical,[this.extractMessage(e),...i])}extractMessage(e){return typeof e=="string"?e:(0,O.toErrorMessage)(e,this.getLevel()<=u.Trace)}dispose(){}flush(){}}t.AdapterLogger=R;class a extends h{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const i of this.logServices)i.setLevel(e);super.setLevel(e)}trace(e,...i){for(const n of this.logServices)n.trace(e,...i)}debug(e,...i){for(const n of this.logServices)n.debug(e,...i)}info(e,...i){for(const n of this.logServices)n.info(e,...i)}warn(e,...i){for(const n of this.logServices)n.warn(e,...i)}error(e,...i){for(const n of this.logServices)n.error(e,...i)}critical(e,...i){for(const n of this.logServices)n.critical(e,...i)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=a;class c extends w.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...i){this.logger.trace(e,...i)}debug(e,...i){this.logger.debug(e,...i)}info(e,...i){this.logger.info(e,...i)}warn(e,...i){this.logger.warn(e,...i)}error(e,...i){this.logger.error(e,...i)}critical(e,...i){this.logger.critical(e,...i)}flush(){this.logger.flush()}}t.LogService=c;class S extends w.Disposable{constructor(e,i){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(n=>{this.logLevel=n,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(n))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,i){let n=this.loggers.get(e.toString());return n||(n=this.doCreateLogger(e,i?.always?u.Trace:this.logLevel,i),this.loggers.set(e.toString(),n),i?.always||this.logLevelChangeableLoggers.push(n)),n}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=S;class v{constructor(){this.onDidChangeLogLevel=new D.Emitter().event}setLevel(e){}getLevel(){return u.Info}trace(e,...i){}debug(e,...i){}info(e,...i){}warn(e,...i){}error(e,...i){}critical(e,...i){}dispose(){}flush(){}}t.NullLogService=v;function y(o){if(o.verbose)return u.Trace;if(typeof o.logLevel=="string"){const e=f(o.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=y;function f(o){switch(o){case"trace":return u.Trace;case"debug":return u.Debug;case"info":return u.Info;case"warn":return u.Warning;case"error":return u.Error;case"critical":return u.Critical;case"off":return u.Off}}t.parseLogLevel=f;function s(o){switch(o){case u.Trace:return"trace";case u.Debug:return"debug";case u.Info:return"info";case u.Warning:return"warn";case u.Error:return"error";case u.Critical:return"critical";case u.Off:return"off"}}t.LogLevelToString=s}),define(Y[102],ee([0,1,3,7,2,10,19,41,8,29,11,20,22,23,17,15]),function(q,t,O,D,w,A,F,L,u,h,g,p,m,R,a,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)$/;let v=class extends w.Disposable{constructor(f,s,o,e){super();this.fileService=s,this.extensionGalleryService=o,this.logService=e,this.extensionsDownloadDir=u.URI.file(f.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(f,s){await this.cleanUpPromise;const o=this.getName(f),e=(0,F.joinPath)(this.extensionsDownloadDir,o);if(!await this.fileService.exists(e)){const i=(0,F.joinPath)(this.extensionsDownloadDir,`.${(0,h.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(f,i,s);try{await this.rename(i,e,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch(r){}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",f.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,D.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return e}async delete(f){}async rename(f,s,o){try{await g.Promises.rename(f.fsPath,s.fsPath)}catch(e){if(A.isWindows&&e&&e.code==="EPERM"&&Date.now()<o)return this.logService.info(`Failed renaming ${f} to ${s} with 'EPERM' error. Trying again...`),this.rename(f,s,o);throw e}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const f=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(f.children){const s=[],o=[];for(const n of f.children){const r=this.parse(n.name);r&&o.push([r,n])}const e=(0,R.groupByExtension)(o,([n])=>n),i=[];for(const n of e)n.sort((r,l)=>L.rcompare(r[0].version,l[0].version)),s.push(...n.slice(1).map(r=>r[1].resource)),i.push(n[0][1]);i.sort((n,r)=>n.mtime-r.mtime),s.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await O.Promises.settled(s.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(f){this.logService.error(f)}}getName(f){return this.cache?new R.ExtensionIdentifierWithVersion(f.identifier,f.version).key().toLowerCase():(0,h.generateUuid)()}parse(f){const s=S.exec(f);return s&&s[1]&&s[2]?new R.ExtensionIdentifierWithVersion({id:s[1]},s[2]):null}};v=ue([fe(0,p.INativeEnvironmentService),fe(1,a.IFileService),fe(2,m.IExtensionGalleryService),fe(3,c.ILogService)],v),t.ExtensionsDownloader=v}),define(Y[103],ee([0,1,33,3,28,14,2,9,4,11,20,15]),function(q,t,O,D,w,A,F,L,u,h,g,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let m=class extends F.Disposable{constructor(a,c){super();this.environmentService=a,this.logService=c,this.processesLimiter=new D.Limiter(5)}async postUninstall(a){const c=this.parseScript(a,"uninstall");return c&&(this.logService.info(a.identifier.id,a.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(c.script,"uninstall",c.args,!0,a).then(()=>this.logService.info(a.identifier.id,a.manifest.version,"Finished running post uninstall script"),S=>this.logService.error(a.identifier.id,a.manifest.version,`Failed to run post uninstall script: ${S}`)))),h.Promises.rm(this.getExtensionStoragePath(a)).then(void 0,S=>this.logService.error("Error while removing extension storage path",S))}parseScript(a,c){const S=`vscode:${c}`;if(a.location.scheme===L.Schemas.file&&a.manifest&&a.manifest.scripts&&typeof a.manifest.scripts[S]=="string"){const v=a.manifest.scripts[S].split(" ");return v.length<2||v[0]!=="node"||!v[1]?(this.logService.warn(a.identifier.id,a.manifest.version,`${S} should be a node script`),null):{script:(0,u.join)(a.location.fsPath,v[1]),args:v.slice(2)||[]}}return null}runLifecycleHook(a,c,S,v,y){return new Promise((f,s)=>{const o=this.start(a,c,S,y);let e;const i=n=>{e&&(clearTimeout(e),e=null),n?s(n):f(void 0)};o.on("error",n=>{i((0,w.toErrorMessage)(n)||"Unknown")}),o.on("exit",(n,r)=>{i(n?`post-${c} process exited with code ${n}`:void 0)}),v&&(e=setTimeout(()=>{e=null,o.kill(),s("timed out")},5e3))})}start(a,c,S,v){const y={silent:!0,execArgv:void 0},f=(0,O.fork)(a,[`--type=extension-post-${c}`,...S],y);f.stdout.setEncoding("utf8"),f.stderr.setEncoding("utf8");const s=A.Event.fromNodeEventEmitter(f.stdout,"data"),o=A.Event.fromNodeEventEmitter(f.stderr,"data");s(n=>this.logService.info(v.identifier.id,v.manifest.version,`post-${c}`,n)),o(n=>this.logService.error(v.identifier.id,v.manifest.version,`post-${c}`,n));const e=A.Event.any(A.Event.map(s,n=>({data:`%c${n}`,format:[""]})),A.Event.map(o,n=>({data:`%c${n}`,format:["color: red"]})));return A.Event.debounce(e,(n,r)=>n?{data:n.data+r.data,format:[...n.format,...r.format]}:{data:r.data,format:r.format},100)(n=>{console.group(v.identifier.id),console.log(n.data,...n.format),console.groupEnd()}),f}getExtensionStoragePath(a){return(0,u.join)(this.environmentService.globalStorageHome.fsPath,a.identifier.id.toLowerCase())}};m=ue([fe(0,g.IEnvironmentService),fe(1,p.ILogService)],m),t.ExtensionsLifecycle=m}),define(Y[104],ee([0,1,14,2,19,8,20,23,17,15]),function(q,t,O,D,w,A,F,L,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let g=class extends D.Disposable{constructor(m,R,a,c){super();this.extensionsManagementService=m,this.logService=c,this._onDidChangeExtensionsByAnotherSource=this._register(new O.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled(1).then(y=>{this.installedExtensions=y.map(f=>f.identifier),this.startTimestamp=Date.now()}),this._register(m.onInstallExtension(y=>this.onInstallExtension(y))),this._register(m.onDidInstallExtensions(y=>this.onDidInstallExtensions(y))),this._register(m.onDidUninstallExtension(y=>this.onDidUninstallExtension(y)));const S=A.URI.file(a.extensionsPath),v=new w.ExtUri(y=>!R.hasCapability(y,1024));this._register(R.watch(S)),this._register(O.Event.filter(R.onDidChangeFilesRaw,y=>y.changes.some(f=>this.doesChangeAffects(f,S,v)))(()=>this.onDidChange()))}doesChangeAffects(m,R,a){return a.isEqual(a.dirname(m.resource),R)?a.isEqual(m.resource,a.joinPath(R,".obsolete"))?!0:!(m.type!==1&&m.type!==2||a.basename(m.resource).startsWith(".")):!1}onInstallExtension(m){this.addInstallingExtension(m.identifier)}onDidInstallExtensions(m){for(const R of m)this.removeInstallingExtension(R.identifier),R.local&&this.addInstalledExtension(R.identifier)}onDidUninstallExtension(m){m.error||this.removeInstalledExtension(m.identifier)}addInstallingExtension(m){this.removeInstallingExtension(m),this.installingExtensions.push(m)}removeInstallingExtension(m){this.installingExtensions=this.installingExtensions.filter(R=>!(0,L.areSameExtensions)(R,m))}addInstalledExtension(m){this.installedExtensions&&(this.removeInstalledExtension(m),this.installedExtensions.push(m))}removeInstalledExtension(m){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(R=>!(0,L.areSameExtensions)(R,m)))}async onDidChange(){if(this.installedExtensions){const m=await this.extensionsManagementService.getInstalled(1),R=m.filter(c=>[...this.installingExtensions,...this.installedExtensions].some(S=>(0,L.areSameExtensions)(S,c.identifier))?!1:c.installedTimestamp&&c.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",c.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",c.identifier.id),!1)),a=this.installedExtensions.filter(c=>this.installingExtensions.some(S=>(0,L.areSameExtensions)(S,c))?!1:m.every(S=>!(0,L.areSameExtensions)(S.identifier,c))?(this.logService.info("Detected extension removed from another source",c.id),!0):!1);this.installedExtensions=m.map(c=>c.identifier),(R.length||a.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:R,removed:a})}}};g=ue([fe(1,u.IFileService),fe(2,F.INativeEnvironmentService),fe(3,h.ILogService)],g),t.ExtensionsWatcher=g}),define(Y[105],ee([0,1,129,24,3,2,9,4,11,20,22,23,53,15]),function(q,t,O,D,w,A,F,L,u,h,g,p,m,R){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LocalizationsService=void 0;let a=class extends A.Disposable{constructor(v,y,f){super();this.extensionManagementService=v,this.logService=f,this.cache=this._register(new c(y,f)),this.extensionManagementService.registerParticipant({postInstall:async s=>this.postInstallExtension(s),postUninstall:async s=>this.postUninstallExtension(s)})}async getLanguageIds(){const v=await this.cache.getLanguagePacks(),y=["en",...Object.keys(v)];return(0,D.distinct)(y)}async postInstallExtension(v){v&&v.manifest&&v.manifest.contributes&&v.manifest.contributes.localizations&&v.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",v.identifier.id),await this.update())}async postUninstallExtension(v){const y=await this.cache.getLanguagePacks();Object.keys(y).some(f=>y[f]&&y[f].extensions.some(s=>(0,p.areSameExtensions)(s.extensionIdentifier,v.identifier)))&&(this.logService.info("Removing language packs from the extension",v.identifier.id),await this.update())}async update(){const[v,y]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),f=await this.cache.update(y);return!(0,D.equals)(Object.keys(v),Object.keys(f))}};a=ue([fe(0,g.IExtensionManagementService),fe(1,h.INativeEnvironmentService),fe(2,R.ILogService)],a),t.LocalizationsService=a;let c=class extends A.Disposable{constructor(v,y){super();this.logService=y,this.languagePacks={},this.languagePacksFilePath=(0,L.join)(v.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new w.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(v){return this.withLanguagePacks(y=>{Object.keys(y).forEach(f=>delete y[f]),this.createLanguagePacksFromExtensions(y,...v)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(v,...y){for(const f of y)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(v,f);Object.keys(v).forEach(f=>this.updateHash(v[f]))}createLanguagePacksFromExtension(v,y){const f=y.identifier,s=y.manifest.contributes&&y.manifest.contributes.localizations?y.manifest.contributes.localizations:[];for(const o of s)if(y.location.scheme===F.Schemas.file&&(0,m.isValidLocalization)(o)){let e=v[o.languageId];e||(e={hash:"",extensions:[],translations:{}},v[o.languageId]=e);let i=e.extensions.filter(n=>(0,p.areSameExtensions)(n.extensionIdentifier,f))[0];i?i.version=y.manifest.version:e.extensions.push({extensionIdentifier:f,version:y.manifest.version});for(const n of o.translations)e.translations[n.id]=(0,L.join)(y.location.fsPath,n.path)}}updateHash(v){if(v){const y=(0,O.createHash)("md5");for(const f of v.extensions)y.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);v.hash=y.digest("hex")}}withLanguagePacks(v=()=>null){return this.languagePacksFileLimiter.queue(()=>{let y=null;return u.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch(s){return{}}}).then(f=>(y=v(f),f)).then(f=>{for(const o of Object.keys(f))f[o]||delete f[o];this.languagePacks=f,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),u.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>y,f=>this.logService.error(f))})}};c=ue([fe(0,h.INativeEnvironmentService),fe(1,R.ILogService)],c)}),define(Y[106],ee([0,1,17,15]),function(q,t,O,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=t.createRotatingLogger=void 0;async function w(u,h,g,p){try{const m=await new Promise((R,a)=>{q(["spdlog"],R,a)});return m.setFlushOn(D.LogLevel.Trace),m.createAsyncRotatingLogger(u,h,g,p)}catch(m){console.error(m)}return null}function A(u,h,g,p){const m=q.__$__nodeRequire("spdlog");return m.setFlushOn(D.LogLevel.Trace),m.createRotatingLogger(u,h,g,p)}t.createRotatingLogger=A;function F(u,h,g){switch(h){case D.LogLevel.Trace:u.trace(g);break;case D.LogLevel.Debug:u.debug(g);break;case D.LogLevel.Info:u.info(g);break;case D.LogLevel.Warning:u.warn(g);break;case D.LogLevel.Error:u.error(g);break;case D.LogLevel.Critical:u.critical(g);break;default:throw new Error("Invalid log level")}}class L extends D.AbstractMessageLogger{constructor(h,g,p,m){super();this.name=h,this.filepath=g,this.rotating=p,this.buffer=[],this.setLevel(m),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(R=>{this._logger&&this._logger.setLevel(R)}))}_createSpdLogLogger(){const h=this.rotating?6:1,g=30/h*O.ByteSize.MB;return w(this.name,this.filepath,g,h).then(p=>{if(p){this._logger=p,this._logger.setLevel(this.getLevel());for(const{level:m,message:R}of this.buffer)F(this._logger,m,R);this.buffer=[]}})}log(h,g){this._logger?F(this._logger,h,g):this.getLevel()<=h&&this.buffer.push({level:h,message:g})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=L}),define(Y[54],ee([0,1,16,7,82,17,35]),function(q,t,O,D,w,A,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function L(p,m,R,a,c,S){let v;try{await u(p,m,R,a,c,S)}catch(y){v=y}finally{v&&c.errorTransformer&&(v=c.errorTransformer(v)),typeof v!="undefined"&&R.error(v),R.end()}}t.readFileIntoStream=L;async function u(p,m,R,a,c,S){h(S);const v=await p.open(m,{create:!1});try{h(S);let y=0,f=0,s=c&&typeof c.length=="number"?c.length:void 0,o=O.VSBuffer.alloc(Math.min(c.bufferSize,typeof s=="number"?s:c.bufferSize)),e=c&&typeof c.position=="number"?c.position:0,i=0;do f=await p.read(v,e,o.buffer,i,o.byteLength-i),e+=f,i+=f,y+=f,typeof s=="number"&&(s-=f),i===o.byteLength&&(await R.write(a(o)),o=O.VSBuffer.alloc(Math.min(c.bufferSize,typeof s=="number"?s:c.bufferSize)),i=0);while(f>0&&(typeof s!="number"||s>0)&&h(S)&&g(y,c));if(i>0){let n=i;typeof s=="number"&&(n=Math.min(i,s)),R.write(a(o.slice(0,n)))}}catch(y){throw(0,A.ensureFileSystemProviderError)(y)}finally{await p.close(v)}}function h(p){if(p.isCancellationRequested)throw(0,D.canceled)();return!0}function g(p,m){if(m?.limits){if(typeof m.limits.memory=="number"&&p>m.limits.memory)throw(0,A.createFileSystemProviderError)((0,w.localize)(0,null,F.default.nameShort),A.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof m.limits.size=="number"&&p>m.limits.size)throw(0,A.createFileSystemProviderError)((0,w.localize)(1,null),A.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Y[107],ee([0,1,24,3,16,26,14,130,2,45,9,131,19,37,81,17,54,15]),function(q,t,O,D,w,A,F,L,u,h,g,p,m,R,a,c,S,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let y=class Ne extends u.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new F.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new F.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new F.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new F.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new F.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new F.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new F.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new D.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new c.FileChangesEvent(o,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new D.ThrottledWorker(Ne.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ne.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ne.FILE_EVENTS_THROTTLING.coolDownDelay,o=>this._onDidFilesChange.fire(new c.FileChangesEvent(o,!0)))),this.watchedResources=h.TernarySearchTree.forUris(o=>{const e=this.getProvider(o.scheme);return e?!this.isPathCaseSensitive(e):!1}),this.writeQueue=this._register(new D.ResourceQueue)}registerProvider(s,o){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,p.mark)(`code/registerFilesystem/${s}`),this.provider.set(s,o),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:o});const e=new u.DisposableStore;return e.add(o.onDidChangeFile(i=>this.onDidChangeFile(i,this.isPathCaseSensitive(o)))),e.add(o.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:o,scheme:s}))),typeof o.onDidErrorOccur=="function"&&e.add(o.onDidErrorOccur(i=>this._onError.fire(new Error(i)))),(0,u.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:o}),this.provider.delete(s),(0,u.dispose)(e)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const o=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(e){o.push(e)}}),!this.provider.has(s)&&await D.Promises.settled(o)}canHandleResource(s){return this.provider.has(s.scheme)}hasCapability(s,o){const e=this.provider.get(s.scheme);return!!(e&&e.capabilities&o)}listCapabilities(){return L.Iterable.map(this.provider,([s,o])=>({scheme:s,capabilities:o.capabilities}))}async withProvider(s){if(!(0,m.isAbsolutePath)(s))throw new c.FileOperationError((0,a.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const o=this.provider.get(s.scheme);if(!o){const e=new Error;throw e.name="ENOPRO",e.message=(0,a.localize)(1,null,s.toString()),e}return o}async withReadProvider(s){const o=await this.withProvider(s);if((0,c.hasOpenReadWriteCloseCapability)(o)||(0,c.hasReadWriteCapability)(o)||(0,c.hasFileReadStreamCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const o=await this.withProvider(s);if((0,c.hasOpenReadWriteCloseCapability)(o)||(0,c.hasReadWriteCapability)(o))return o;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,o){try{return await this.doResolveFile(s,o)}catch(e){throw(0,c.toFileSystemProviderErrorCode)(e)===c.FileSystemProviderErrorCode.FileNotFound?new c.FileOperationError((0,a.localize)(2,null,this.resourceForError(s)),1):(0,c.ensureFileSystemProviderError)(e)}}async doResolveFile(s,o){const e=await this.withProvider(s),i=this.isPathCaseSensitive(e),n=o?.resolveTo,r=o?.resolveSingleChildDescendants,l=o?.resolveMetadata,d=await e.stat(s);let P;return this.toFileStat(e,s,d,void 0,!!l,(U,b)=>{if(!P&&(P=h.TernarySearchTree.forUris(()=>!i),P.set(s,!0),n))for(const k of n)P.set(k,!0);return P.get(U.resource)||P.findSuperstr(U.resource.with({query:null,fragment:null}))?!0:U.isDirectory&&r?b===1:!1})}async toFileStat(s,o,e,i,n,r){const{providerExtUri:l}=this.getExtUri(s),d={resource:o,name:l.basename(o),isFile:(e.type&c.FileType.File)!=0,isDirectory:(e.type&c.FileType.Directory)!=0,isSymbolicLink:(e.type&c.FileType.SymbolicLink)!=0,mtime:e.mtime,ctime:e.ctime,size:e.size,readonly:Boolean((e.permissions??0)&c.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,c.etag)({mtime:e.mtime,size:e.size})};if(d.isDirectory&&r(d,i)){try{const P=await s.readdir(o),U=await D.Promises.settled(P.map(async([b,k])=>{try{const V=l.joinPath(o,b),G=n?await s.stat(V):{type:k};return await this.toFileStat(s,V,G,P.length,n,r)}catch(V){return this.logService.trace(V),null}}));d.children=(0,O.coalesce)(U)}catch(P){this.logService.trace(P),d.children=[]}return d}return d}async resolveAll(s){return D.Promises.settled(s.map(async o=>{try{return{stat:await this.doResolveFile(o.resource,o.options),success:!0}}catch(e){return this.logService.trace(e),{stat:void 0,success:!1}}}))}async exists(s){const o=await this.withProvider(s);try{return!!await o.stat(s)}catch(e){return!1}}async canCreateFile(s,o){try{await this.doValidateCreateFile(s,o)}catch(e){return e}return!0}async doValidateCreateFile(s,o){if(!o?.overwrite&&await this.exists(s))throw new c.FileOperationError((0,a.localize)(3,null,this.resourceForError(s)),3,o)}async createFile(s,o=w.VSBuffer.fromString(""),e){await this.doValidateCreateFile(s,e);const i=await this.writeFile(s,o);return this._onDidRunOperation.fire(new c.FileOperationEvent(s,0,i)),i}async writeFile(s,o,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:n}=this.getExtUri(i);try{await this.validateWriteFile(i,s,e)||await this.mkdirp(i,n.dirname(s));let l;if((0,c.hasReadWriteCapability)(i)&&!(o instanceof w.VSBuffer))if((0,R.isReadableStream)(o)){const d=await(0,R.peekStream)(o,3);d.ended?l=w.VSBuffer.concat(d.buffer):l=d}else l=(0,R.peekReadable)(o,d=>w.VSBuffer.concat(d),3);else l=o;!(0,c.hasOpenReadWriteCloseCapability)(i)||(0,c.hasReadWriteCapability)(i)&&l instanceof w.VSBuffer?await this.doWriteUnbuffered(i,s,e,l):await this.doWriteBuffered(i,s,e,l instanceof w.VSBuffer?(0,w.bufferToReadable)(l):l)}catch(r){throw new c.FileOperationError((0,a.localize)(4,null,this.resourceForError(s),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),e)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,o,e){if(!!e?.unlock&&!(s.capabilities&8192))throw new Error((0,a.localize)(5,null,this.resourceForError(o)));let n;try{n=await s.stat(o)}catch(r){return}if((n.type&c.FileType.Directory)!=0)throw new c.FileOperationError((0,a.localize)(6,null,this.resourceForError(o)),0,e);if(this.throwIfFileIsReadonly(o,n),typeof e?.mtime=="number"&&typeof e.etag=="string"&&e.etag!==c.ETAG_DISABLED&&typeof n.mtime=="number"&&typeof n.size=="number"&&e.mtime<n.mtime&&e.etag!==(0,c.etag)({mtime:e.mtime,size:n.size}))throw new c.FileOperationError((0,a.localize)(7,null),3,e);return n}async readFile(s,o){const e=await this.withReadProvider(s);return o?.atomic?this.doReadFileAtomic(e,s,o):this.doReadFile(e,s,o)}async doReadFileAtomic(s,o,e){return new Promise((i,n)=>{this.writeQueue.queueFor(o,this.getExtUri(s).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(s,o,e);i(r)}catch(r){n(r)}})})}async doReadFile(s,o,e){const i=await this.doReadFileStream(s,o,{...e,preferUnbuffered:!0});return{...i,value:await(0,w.streamToBuffer)(i.value)}}async readFileStream(s,o){const e=await this.withReadProvider(s);return this.doReadFileStream(e,s,o)}async doReadFileStream(s,o,e){const i=new A.CancellationTokenSource,n=this.validateReadFile(o,e).then(l=>l,l=>{throw i.cancel(),l});let r;try{return typeof e?.etag=="string"&&e.etag!==c.ETAG_DISABLED&&await n,!((0,c.hasOpenReadWriteCloseCapability)(s)||(0,c.hasFileReadStreamCapability)(s))||(0,c.hasReadWriteCapability)(s)&&e?.preferUnbuffered?r=this.readFileUnbuffered(s,o,e):(0,c.hasFileReadStreamCapability)(s)?r=this.readFileStreamed(s,o,i.token,e):r=this.readFileBuffered(s,o,i.token,e),{...await n,value:r}}catch(l){r&&await(0,R.consumeStream)(r);const d=(0,a.localize)(8,null,this.resourceForError(o),(0,c.ensureFileSystemProviderError)(l).toString());throw l instanceof c.NotModifiedSinceFileOperationError?new c.NotModifiedSinceFileOperationError(d,l.stat,e):new c.FileOperationError(d,(0,c.toFileOperationResult)(l),e)}}readFileStreamed(s,o,e,i=Object.create(null)){const n=s.readFileStream(o,i,e);return(0,R.transform)(n,{data:r=>r instanceof w.VSBuffer?r:w.VSBuffer.wrap(r),error:r=>new c.FileOperationError((0,a.localize)(9,null,this.resourceForError(o),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),i)},r=>w.VSBuffer.concat(r))}readFileBuffered(s,o,e,i=Object.create(null)){const n=(0,w.newWriteableBufferStream)();return(0,S.readFileIntoStream)(s,o,n,r=>r,{...i,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new c.FileOperationError((0,a.localize)(10,null,this.resourceForError(o),(0,c.ensureFileSystemProviderError)(r).toString()),(0,c.toFileOperationResult)(r),i)},e),n}readFileUnbuffered(s,o,e){const i=(0,R.newWriteableStream)(n=>w.VSBuffer.concat(n));return(async()=>{try{let n=await s.readFile(o);typeof e?.position=="number"&&(n=n.slice(e.position)),typeof e?.length=="number"&&(n=n.slice(0,e.length)),this.validateReadFileLimits(o,n.byteLength,e),i.end(w.VSBuffer.wrap(n))}catch(n){i.error(n),i.end()}})(),i}async validateReadFile(s,o){const e=await this.resolve(s,{resolveMetadata:!0});if(e.isDirectory)throw new c.FileOperationError((0,a.localize)(11,null,this.resourceForError(s)),0,o);if(typeof o?.etag=="string"&&o.etag!==c.ETAG_DISABLED&&o.etag===e.etag)throw new c.NotModifiedSinceFileOperationError((0,a.localize)(12,null),e,o);return this.validateReadFileLimits(s,e.size,o),e}validateReadFileLimits(s,o,e){if(e?.limits){let i;if(typeof e.limits.memory=="number"&&o>e.limits.memory&&(i=9),typeof e.limits.size=="number"&&o>e.limits.size&&(i=7),typeof i=="number")throw new c.FileOperationError((0,a.localize)(13,null,this.resourceForError(s)),i)}}async canMove(s,o,e){return this.doCanMoveCopy(s,o,"move",e)}async canCopy(s,o,e){return this.doCanMoveCopy(s,o,"copy",e)}async doCanMoveCopy(s,o,e,i){if(s.toString()!==o.toString())try{const n=e==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o);await this.doValidateMoveCopy(n,s,r,o,e,i)}catch(n){return n}return!0}async move(s,o,e){const i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(i,s,n,o,"move",!!e),l=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(s,r==="move"?2:3,l)),l}async copy(s,o,e){const i=await this.withReadProvider(s),n=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(o),o),r=await this.doMoveCopy(i,s,n,o,"copy",!!e),l=await this.resolve(o,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(s,r==="copy"?3:2,l)),l}async doMoveCopy(s,o,e,i,n,r){if(o.toString()===i.toString())return n;const{exists:l,isSameResourceWithDifferentPathCase:d}=await this.doValidateMoveCopy(s,o,e,i,n,r);if(l&&!d&&r&&await this.del(i,{recursive:!0}),await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i)),n==="copy"){if(s===e&&(0,c.hasFileFolderCopyCapability)(s))await s.copy(o,i,{overwrite:r});else{const P=await this.resolve(o);P.isDirectory?await this.doCopyFolder(s,P,e,i):await this.doCopyFile(s,o,e,i)}return n}else return s===e?(await s.rename(o,i,{overwrite:r}),n):(await this.doMoveCopy(s,o,e,i,"copy",r),await this.del(o,{recursive:!0}),"copy")}async doCopyFile(s,o,e,i){if((0,c.hasOpenReadWriteCloseCapability)(s)&&(0,c.hasOpenReadWriteCloseCapability)(e))return this.doPipeBuffered(s,o,e,i);if((0,c.hasOpenReadWriteCloseCapability)(s)&&(0,c.hasReadWriteCapability)(e))return this.doPipeBufferedToUnbuffered(s,o,e,i);if((0,c.hasReadWriteCapability)(s)&&(0,c.hasOpenReadWriteCloseCapability)(e))return this.doPipeUnbufferedToBuffered(s,o,e,i);if((0,c.hasReadWriteCapability)(s)&&(0,c.hasReadWriteCapability)(e))return this.doPipeUnbuffered(s,o,e,i)}async doCopyFolder(s,o,e,i){await e.mkdir(i),Array.isArray(o.children)&&await D.Promises.settled(o.children.map(async n=>{const r=this.getExtUri(e).providerExtUri.joinPath(i,n.name);return n.isDirectory?this.doCopyFolder(s,await this.resolve(n.resource),e,r):this.doCopyFile(s,n.resource,e,r)}))}async doValidateMoveCopy(s,o,e,i,n,r){let l=!1;if(s===e){const{providerExtUri:P,isPathCaseSensitive:U}=this.getExtUri(s);if(U||(l=P.isEqual(o,i)),l&&n==="copy")throw new Error((0,a.localize)(14,null,this.resourceForError(o),this.resourceForError(i)));if(!l&&P.isEqualOrParent(i,o))throw new Error((0,a.localize)(15,null,this.resourceForError(o),this.resourceForError(i)))}const d=await this.exists(i);if(d&&!l){if(!r)throw new c.FileOperationError((0,a.localize)(16,null,this.resourceForError(o),this.resourceForError(i)),4);if(s===e){const{providerExtUri:P}=this.getExtUri(s);if(P.isEqualOrParent(o,i))throw new Error((0,a.localize)(17,null,this.resourceForError(o),this.resourceForError(i)))}}return{exists:d,isSameResourceWithDifferentPathCase:l}}getExtUri(s){const o=this.isPathCaseSensitive(s);return{providerExtUri:o?m.extUri:m.extUriIgnorePathCase,isPathCaseSensitive:o}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const o=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(o,s);const e=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new c.FileOperationEvent(s,0,e)),e}async mkdirp(s,o){const e=[],{providerExtUri:i}=this.getExtUri(s);for(;!i.isEqual(o,i.dirname(o));)try{if(((await s.stat(o)).type&c.FileType.Directory)==0)throw new Error((0,a.localize)(18,null,this.resourceForError(o)));break}catch(n){if((0,c.toFileSystemProviderErrorCode)(n)!==c.FileSystemProviderErrorCode.FileNotFound)throw n;e.push(i.basename(o)),o=i.dirname(o)}for(let n=e.length-1;n>=0;n--){o=i.joinPath(o,e[n]);try{await s.mkdir(o)}catch(r){if((0,c.toFileSystemProviderErrorCode)(r)!==c.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(s,o){try{await this.doValidateDelete(s,o)}catch(e){return e}return!0}async doValidateDelete(s,o){const e=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!o?.useTrash&&!(e.capabilities&4096))throw new Error((0,a.localize)(19,null,this.resourceForError(s)));let n;try{n=await e.stat(s)}catch(l){}if(n)this.throwIfFileIsReadonly(s,n);else throw new c.FileOperationError((0,a.localize)(20,null,this.resourceForError(s)),1);if(!!!o?.recursive){const l=await this.resolve(s);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,a.localize)(21,null,this.resourceForError(s)))}return e}async del(s,o){const e=await this.doValidateDelete(s,o),i=!!o?.useTrash,n=!!o?.recursive;await e.delete(s,{recursive:n,useTrash:i}),this._onDidRunOperation.fire(new c.FileOperationEvent(s,1))}onDidChangeFile(s,o){this._onDidChangeFilesRaw.fire({changes:s});let e,i;{for(const n of s)this.watchedResources.has(n.resource)?(e||(e=[]),e.push(n)):(i||(i=[]),i.push(n));e&&this._onDidFilesChange.fire(new c.FileChangesEvent(e,!o))}if(i){const n=o?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!n.work(i)&&Ne.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${i.length}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),n.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${n.pending}, most recent change: ${i[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(s,o={recursive:!1,excludes:[]}){const e=new u.DisposableStore;{let i=!1,n=()=>{i=!0};e.add((0,u.toDisposable)(()=>n())),this.doWatch(s,o).then(r=>{i?(0,u.dispose)(r):n=()=>(0,u.dispose)(r)},r=>this.logService.error(r))}return o.recursive||(this.watchedResources.set(s,(this.watchedResources.get(s)??0)+1),e.add((0,u.toDisposable)(()=>{const i=this.watchedResources.get(s);typeof i=="number"&&(i<=1?this.watchedResources.delete(s):this.watchedResources.set(s,i-1))}))),e}async doWatch(s,o){const e=await this.withProvider(s),i=this.toWatchKey(e,s,o),n=this.activeWatchers.get(i)||{count:0,disposable:e.watch(s,o)};return this.activeWatchers.has(i)||this.activeWatchers.set(i,n),n.count+=1,(0,u.toDisposable)(()=>{n.count--,n.count===0&&((0,u.dispose)(n.disposable),this.activeWatchers.delete(i))})}toWatchKey(s,o,e){const{providerExtUri:i}=this.getExtUri(s);return[i.getComparisonKey(o),String(e.recursive),e.excludes.join()].join()}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,u.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,o,e,i){return this.writeQueue.queueFor(o,this.getExtUri(s).providerExtUri).queue(async()=>{const n=await s.open(o,{create:!0,unlock:e?.unlock??!1});try{(0,R.isReadableStream)(i)||(0,R.isReadableBufferedStream)(i)?await this.doWriteStreamBufferedQueued(s,n,i):await this.doWriteReadableBufferedQueued(s,n,i)}catch(r){throw(0,c.ensureFileSystemProviderError)(r)}finally{await s.close(n)}})}async doWriteStreamBufferedQueued(s,o,e){let i=0,n;if((0,R.isReadableBufferedStream)(e)){if(e.buffer.length>0){const r=w.VSBuffer.concat(e.buffer);await this.doWriteBuffer(s,o,r,r.byteLength,i,0),i+=r.byteLength}if(e.ended)return;n=e.stream}else n=e;return new Promise(async(r,l)=>{(0,R.listenStream)(n,{onData:async d=>{n.pause();try{await this.doWriteBuffer(s,o,d,d.byteLength,i,0)}catch(P){return l(P)}i+=d.byteLength,setTimeout(()=>n.resume())},onError:d=>l(d),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(s,o,e){let i=0,n;for(;(n=e.read())!==null;)await this.doWriteBuffer(s,o,n,n.byteLength,i,0),i+=n.byteLength}async doWriteBuffer(s,o,e,i,n,r){let l=0;for(;l<i;)l+=await s.write(o,n+l,e.buffer,r+l,i-l)}async doWriteUnbuffered(s,o,e,i){return this.writeQueue.queueFor(o,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,o,e,i))}async doWriteUnbufferedQueued(s,o,e,i){let n;i instanceof w.VSBuffer?n=i:(0,R.isReadableStream)(i)?n=await(0,w.streamToBuffer)(i):(0,R.isReadableBufferedStream)(i)?n=await(0,w.bufferedStreamToBuffer)(i):n=(0,w.readableToBuffer)(i),await s.writeFile(o,n.buffer,{create:!0,overwrite:!0,unlock:e?.unlock??!1})}async doPipeBuffered(s,o,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,o,e,i))}async doPipeBufferedQueued(s,o,e,i){let n,r;try{n=await s.open(o,{create:!1}),r=await e.open(i,{create:!0,unlock:!1});const l=w.VSBuffer.alloc(this.BUFFER_SIZE);let d=0,P=0,U=0;do U=await s.read(n,d,l.buffer,P,l.byteLength-P),await this.doWriteBuffer(e,r,l,U,d,P),d+=U,P+=U,P===l.byteLength&&(P=0);while(U>0)}catch(l){throw(0,c.ensureFileSystemProviderError)(l)}finally{await D.Promises.settled([typeof n=="number"?s.close(n):Promise.resolve(),typeof r=="number"?e.close(r):Promise.resolve()])}}async doPipeUnbuffered(s,o,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,o,e,i))}async doPipeUnbufferedQueued(s,o,e,i){return e.writeFile(i,await s.readFile(o),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,o,e,i){return this.writeQueue.queueFor(i,this.getExtUri(e).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,o,e,i))}async doPipeUnbufferedToBufferedQueued(s,o,e,i){const n=await e.open(i,{create:!0,unlock:!1});try{const r=await s.readFile(o);await this.doWriteBuffer(e,n,w.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,c.ensureFileSystemProviderError)(r)}finally{await e.close(n)}}async doPipeBufferedToUnbuffered(s,o,e,i){const n=await(0,w.streamToBuffer)(this.readFileBuffered(s,o,A.CancellationToken.None));await this.doWriteUnbuffered(e,i,void 0,n)}throwIfFileSystemIsReadonly(s,o){if(s.capabilities&2048)throw new c.FileOperationError((0,a.localize)(22,null,this.resourceForError(o)),6);return s}throwIfFileIsReadonly(s,o){if((o.permissions??0)&c.FilePermission.Readonly)throw new c.FileOperationError((0,a.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===g.Schemas.file?s.fsPath:s.toString(!0)}};y.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},y=ue([fe(0,v.ILogService)],y),t.FileService=y}),define(Y[108],ee([0,1,24,3,16,14,31,2,4,10,19,37,11,83,17,54,100,91,92,51,94,15]),function(q,t,O,D,w,A,F,L,u,h,g,p,m,R,a,c,S,v,y,f,s,o){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0;class e extends L.Disposable{constructor(n,r){super();this.logService=n,this.options=r,this.BUFFER_SIZE=this.options?.bufferSize||64*1024,this.onDidChangeCapabilities=A.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new A.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new A.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new D.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,h.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(n){try{const{stat:r,symbolicLink:l}=await m.SymlinkSupport.stat(this.toFilePath(n));return{type:this.toType(r,l),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(n){try{const r=await m.Promises.readdir(this.toFilePath(n),{withFileTypes:!0}),l=[];return await Promise.all(r.map(async d=>{try{let P;d.isSymbolicLink()?P=(await this.stat((0,g.joinPath)(n,d.name))).type:P=this.toType(d),l.push([d.name,P])}catch(P){this.logService.trace(P)}})),l}catch(r){throw this.toFileSystemProviderError(r)}}toType(n,r){let l;return r?.dangling?l=a.FileType.Unknown:n.isFile()?l=a.FileType.File:n.isDirectory()?l=a.FileType.Directory:l=a.FileType.Unknown,r&&(l|=a.FileType.SymbolicLink),l}async readFile(n){try{const r=this.toFilePath(n);return await m.Promises.readFile(r)}catch(r){throw this.toFileSystemProviderError(r)}}readFileStream(n,r,l){const d=(0,p.newWriteableStream)(P=>w.VSBuffer.concat(P.map(U=>w.VSBuffer.wrap(U))).buffer);return(0,c.readFileIntoStream)(this,n,d,P=>P.buffer,{...r,bufferSize:this.BUFFER_SIZE},l),d}async writeFile(n,r,l){let d;try{const P=this.toFilePath(n);if(!l.create||!l.overwrite){if(await m.Promises.exists(P)){if(!l.overwrite)throw(0,a.createFileSystemProviderError)((0,R.localize)(0,null),a.FileSystemProviderErrorCode.FileExists)}else if(!l.create)throw(0,a.createFileSystemProviderError)((0,R.localize)(1,null),a.FileSystemProviderErrorCode.FileNotFound)}d=await this.open(n,{create:!0,unlock:l.unlock}),await this.write(d,0,r,0,r.byteLength)}catch(P){throw await this.toFileSystemProviderWriteError(n,P)}finally{typeof d=="number"&&await this.close(d)}}async open(n,r){try{const l=this.toFilePath(n);if((0,a.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:U}=await m.SymlinkSupport.stat(l);U.mode&128||await m.Promises.chmod(l,U.mode|128)}catch(U){this.logService.trace(U)}let d;if((0,a.isFileOpenForWriteOptions)(r)){if(h.isWindows)try{await m.Promises.truncate(l,0),d="r+"}catch(U){U.code!=="ENOENT"&&this.logService.trace(U)}d||(d="w")}else d="r";const P=await m.Promises.open(l,d);return this.mapHandleToPos.set(P,0),(0,a.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(P,n),P}catch(l){throw(0,a.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(n,l):this.toFileSystemProviderError(l)}}async close(n){try{if(this.mapHandleToPos.delete(n),this.writeHandles.delete(n)&&this.canFlush)try{await m.Promises.fdatasync(n)}catch(r){this.canFlush=!1,this.logService.error(r)}return await m.Promises.close(n)}catch(r){throw this.toFileSystemProviderError(r)}}async read(n,r,l,d,P){const U=this.normalizePos(n,r);let b=null;try{const k=await m.Promises.read(n,l,d,P,U);return typeof k=="number"?b=k:b=k.bytesRead,b}catch(k){throw this.toFileSystemProviderError(k)}finally{this.updatePos(n,U,b)}}normalizePos(n,r){return r===this.mapHandleToPos.get(n)?null:r}updatePos(n,r,l){const d=this.mapHandleToPos.get(n);typeof d=="number"&&(typeof r=="number"||(typeof l=="number"?this.mapHandleToPos.set(n,d+l):this.mapHandleToPos.delete(n)))}async write(n,r,l,d,P){return(0,D.retry)(()=>this.doWrite(n,r,l,d,P),100,3)}async doWrite(n,r,l,d,P){const U=this.normalizePos(n,r);let b=null;try{const k=await m.Promises.write(n,l,d,P,U);return typeof k=="number"?b=k:b=k.bytesWritten,b}catch(k){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(n),k)}finally{this.updatePos(n,U,b)}}async mkdir(n){try{await m.Promises.mkdir(this.toFilePath(n))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(n,r){try{const l=this.toFilePath(n);await this.doDelete(l,r)}catch(l){throw this.toFileSystemProviderError(l)}}async doDelete(n,r){r.recursive?await m.Promises.rm(n,m.RimRafMode.MOVE):await m.Promises.unlink(n)}async rename(n,r,l){const d=this.toFilePath(n),P=this.toFilePath(r);if(d!==P)try{await this.validateTargetDeleted(n,r,"move",l.overwrite),await m.Promises.move(d,P)}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error((0,R.localize)(2,null,(0,u.basename)(d),(0,u.basename)((0,u.dirname)(P)),U.toString()))),this.toFileSystemProviderError(U)}}async copy(n,r,l){const d=this.toFilePath(n),P=this.toFilePath(r);if(d!==P)try{await this.validateTargetDeleted(n,r,"copy",l.overwrite),await m.Promises.copy(d,P,{preserveSymlinks:!0})}catch(U){throw(U.code==="EINVAL"||U.code==="EBUSY"||U.code==="ENAMETOOLONG")&&(U=new Error((0,R.localize)(3,null,(0,u.basename)(d),(0,u.basename)((0,u.dirname)(P)),U.toString()))),this.toFileSystemProviderError(U)}}async validateTargetDeleted(n,r,l,d){const P=this.toFilePath(n),U=this.toFilePath(r);let b=!1;if(!!(this.capabilities&1024)||(b=(0,F.isEqual)(P,U,!0)),b&&l==="copy")throw(0,a.createFileSystemProviderError)((0,R.localize)(4,null),a.FileSystemProviderErrorCode.FileExists);if(!b&&await m.Promises.exists(U)){if(!d)throw(0,a.createFileSystemProviderError)((0,R.localize)(5,null),a.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}watch(n,r){return r.recursive?this.watchRecursive(n,r.excludes):this.watchNonRecursive(n)}watchRecursive(n,r){const l={path:this.toFilePath(n),excludes:r},d=(0,O.insert)(this.recursiveFoldersToWatch,l);return this.refreshRecursiveWatchers(),(0,L.toDisposable)(()=>{d(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){if(this.recursiveWatcher instanceof v.FileWatcher)this.recursiveWatcher.setFolders(this.recursiveFoldersToWatch);else if((0,L.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,this.recursiveFoldersToWatch.length>0){let n,r;this.options?.watcher?.usePolling?(n=y.FileWatcher,r=this.options?.watcher):this.recursiveFoldersToWatch.length===1?h.isWindows?n=s.FileWatcher:n=y.FileWatcher:n=v.FileWatcher,this.recursiveWatcher=new n(this.recursiveFoldersToWatch,l=>this._onDidChangeFile.fire((0,f.toFileChanges)(l)),l=>{l.type==="error"&&this._onDidWatchErrorOccur.fire(l.message),this.logService[l.type](l.message)},this.logService.getLevel()===o.LogLevel.Trace,r),this.recursiveWatcherLogLevelListener||(this.recursiveWatcherLogLevelListener=this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher&&this.recursiveWatcher.setVerboseLogging(this.logService.getLevel()===o.LogLevel.Trace)}))}}watchNonRecursive(n){const r=new S.FileWatcher(this.toFilePath(n),d=>this._onDidChangeFile.fire((0,f.toFileChanges)(d)),d=>{d.type==="error"&&this._onDidWatchErrorOccur.fire(d.message),this.logService[d.type](d.message)},this.logService.getLevel()===o.LogLevel.Trace),l=this.logService.onDidChangeLogLevel(()=>{r.setVerboseLogging(this.logService.getLevel()===o.LogLevel.Trace)});return(0,L.combinedDisposable)(r,l)}toFilePath(n){return(0,u.normalize)(n.fsPath)}toFileSystemProviderError(n){if(n instanceof a.FileSystemProviderError)return n;let r;switch(n.code){case"ENOENT":r=a.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=a.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=a.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=a.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=a.FileSystemProviderErrorCode.NoPermissions;break;default:r=a.FileSystemProviderErrorCode.Unknown}return(0,a.createFileSystemProviderError)(n,r)}async toFileSystemProviderWriteError(n,r){let l=this.toFileSystemProviderError(r);if(n&&l.code===a.FileSystemProviderErrorCode.NoPermissions)try{const{stat:d}=await m.SymlinkSupport.stat(this.toFilePath(n));d.mode&128||(l=(0,a.createFileSystemProviderError)(r,a.FileSystemProviderErrorCode.FileWriteLocked))}catch(d){this.logService.trace(d)}return l}dispose(){super.dispose(),(0,L.dispose)(this.recursiveWatcher),this.recursiveWatcher=void 0,(0,L.dispose)(this.recursiveWatcherLogLevelListener),this.recursiveWatcherLogLevelListener=void 0}}t.DiskFileSystemProvider=e}),define(Y[42],ee([0,1,12]),function(q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IProductService=void 0,t.IProductService=(0,O.createDecorator)("productService")}),define(Y[25],ee([0,1,57,13]),function(q,t,O,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class w{constructor(){this.data=new Map}add(F,L){O.ok(D.isString(F)),O.ok(D.isObject(L)),O.ok(!this.data.has(F),"There is already an extension with this id"),this.data.set(F,L)}knows(F){return this.data.has(F)}as(F){return this.data.get(F)||null}}t.Registry=new w}),define(Y[109],ee([0,1,14,25]),function(q,t,O,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function w(L){return L.length>0&&L.charAt(L.length-1)==="#"?L.substring(0,L.length-1):L}class A{constructor(){this._onDidChangeSchema=new O.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(u,h){this.schemasById[w(u)]=h,this._onDidChangeSchema.fire(u)}notifySchemaChanged(u){this._onDidChangeSchema.fire(u)}getSchemaContributions(){return{schemas:this.schemasById}}}const F=new A;D.Registry.add(t.Extensions.JSONContribution,F)}),define(Y[30],ee([0,1,14,13,73,109,25]),function(q,t,O,D,w,A,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.overrideIdentifierFromKey=t.OVERRIDE_PROPERTY_PATTERN=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var L;(function(v){v.Multiline="multilineText",v.Singleline="singlelineText"})(L=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var u;(function(v){v[v.APPLICATION=1]="APPLICATION",v[v.MACHINE=2]="MACHINE",v[v.WINDOW=3]="WINDOW",v[v.RESOURCE=4]="RESOURCE",v[v.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",v[v.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(u=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const h=F.Registry.as(A.Extensions.JSONContribution);class g{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new O.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new O.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:w.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},h.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(y,f=!0){this.registerConfigurations([y],f)}registerConfigurations(y,f=!0){const s=[];y.forEach(o=>{s.push(...this.validateAndRegisterProperties(o,f,o.extensionInfo)),this.configurationContributors.push(o),this.registerJSONConfiguration(o)}),h.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(s)}deregisterConfigurations(y){const f=[],s=o=>{if(o.properties)for(const e in o.properties)f.push(e),delete this.configurationProperties[e],this.removeFromSchema(e,o.properties[e]);o.allOf&&o.allOf.forEach(e=>s(e))};for(const o of y){s(o);const e=this.configurationContributors.indexOf(o);e!==-1&&this.configurationContributors.splice(e,1)}h.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}registerDefaultConfigurations(y){const f=[],s=[];for(const o of y)for(const e in o)if(f.push(e),t.OVERRIDE_PROPERTY_PATTERN.test(e)){this.defaultValues[e]={...this.defaultValues[e]||{},...o[e]};const i={type:"object",default:this.defaultValues[e],description:w.localize(1,null,e),$ref:t.resourceLanguageSettingsSchemaId};s.push(m(e)),this.configurationProperties[e]=i,this.defaultLanguageConfigurationOverridesNode.properties[e]=i}else{this.defaultValues[e]=o[e];const i=this.configurationProperties[e];i&&(this.updatePropertyDefaultValue(e,i),this.updateSchema(e,i))}this.registerOverrideIdentifiers(s),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}deregisterDefaultConfigurations(y){const f=[];for(const s of y)for(const o in s)if(f.push(o),delete this.defaultValues[o],t.OVERRIDE_PROPERTY_PATTERN.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const e=this.configurationProperties[o];e&&(this.updatePropertyDefaultValue(o,e),this.updateSchema(o,e))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(f)}notifyConfigurationSchemaUpdated(...y){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(y){for(const f of y)this.overrideIdentifiers.add(f);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(y,f=!0,s,o=3){o=D.isUndefinedOrNull(y.scope)?o:y.scope;let e=[],i=y.properties;if(i)for(let r in i){if(f&&c(r)){delete i[r];continue}const l=i[r];if(this.updatePropertyDefaultValue(r,l),t.OVERRIDE_PROPERTY_PATTERN.test(r)?l.scope=void 0:(l.scope=D.isUndefinedOrNull(l.scope)?o:l.scope,l.restricted=D.isUndefinedOrNull(l.restricted)?!!s?.restrictedConfigurations?.includes(r):l.restricted),i[r].hasOwnProperty("included")&&!i[r].included){this.excludedConfigurationProperties[r]=i[r],delete i[r];continue}else this.configurationProperties[r]=i[r];!i[r].deprecationMessage&&i[r].markdownDeprecationMessage&&(i[r].deprecationMessage=i[r].markdownDeprecationMessage),e.push(r)}let n=y.allOf;if(n)for(let r of n)e.push(...this.validateAndRegisterProperties(r,f,s,o));return e}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(y){const f=s=>{let o=s.properties;if(o)for(const i in o)this.updateSchema(i,o[i]);let e=s.allOf;e&&e.forEach(f)};f(y)}updateSchema(y,f){switch(t.allSettings.properties[y]=f,f.scope){case 1:t.applicationSettings.properties[y]=f;break;case 2:t.machineSettings.properties[y]=f;break;case 6:t.machineOverridableSettings.properties[y]=f;break;case 3:t.windowSettings.properties[y]=f;break;case 4:t.resourceSettings.properties[y]=f;break;case 5:t.resourceSettings.properties[y]=f,this.resourceLanguageSettingsSchema.properties[y]=f;break}}removeFromSchema(y,f){switch(delete t.allSettings.properties[y],f.scope){case 1:delete t.applicationSettings.properties[y];break;case 2:delete t.machineSettings.properties[y];break;case 6:delete t.machineOverridableSettings.properties[y];break;case 3:delete t.windowSettings.properties[y];break;case 4:case 5:delete t.resourceSettings.properties[y];break}}updateOverridePropertyPatternKey(){for(const y of this.overrideIdentifiers.values()){const f=`[${y}]`,s={type:"object",description:w.localize(2,null),errorMessage:w.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(f,s),t.allSettings.properties[f]=s,t.applicationSettings.properties[f]=s,t.machineSettings.properties[f]=s,t.machineOverridableSettings.properties[f]=s,t.windowSettings.properties[f]=s,t.resourceSettings.properties[f]=s}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(y,f){let s=this.defaultValues[y];D.isUndefined(s)&&(s=f.default),D.isUndefined(s)&&(s=R(f.type)),f.default=s}}const p="\\[.*\\]$";t.OVERRIDE_PROPERTY_PATTERN=new RegExp(p);function m(v){return v.substring(1,v.length-1)}t.overrideIdentifierFromKey=m;function R(v){switch(Array.isArray(v)?v[0]:v){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=R;const a=new g;F.Registry.add(t.Extensions.Configuration,a);function c(v){return v.trim()?t.OVERRIDE_PROPERTY_PATTERN.test(v)?w.localize(5,null,v):a.getConfigurationProperties()[v]!==void 0?w.localize(6,null,v):null:w.localize(4,null)}t.validateProperty=c;function S(){const v=[],y=a.getConfigurationProperties();for(const f of Object.keys(y))v.push([f,y[f].scope]);return v.push(["launch",4]),v.push(["task",4]),v}t.getScopes=S}),define(Y[27],ee([0,1,18,13,8,30,12,25]),function(q,t,O,D,w,A,F,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getMigratedSettingValue=t.keyFromOverrideIdentifier=t.getDefaultValues=t.getConfigurationKeys=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.toOverrides=t.compare=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,F.createDecorator)("configurationService");function u(i){return i&&typeof i=="object"&&(!i.overrideIdentifier||typeof i.overrideIdentifier=="string")&&(!i.resource||i.resource instanceof w.URI)}t.isConfigurationOverrides=u;var h;(function(i){i[i.USER=1]="USER",i[i.USER_LOCAL=2]="USER_LOCAL",i[i.USER_REMOTE=3]="USER_REMOTE",i[i.WORKSPACE=4]="WORKSPACE",i[i.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",i[i.DEFAULT=6]="DEFAULT",i[i.MEMORY=7]="MEMORY"})(h=t.ConfigurationTarget||(t.ConfigurationTarget={}));function g(i){switch(i){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}t.ConfigurationTargetToString=g;function p(i,n){const r=n?i?n.keys.filter(V=>i.keys.indexOf(V)===-1):[...n.keys]:[],l=i?n?i.keys.filter(V=>n.keys.indexOf(V)===-1):[...i.keys]:[],d=[];if(n&&i){for(const V of i.keys)if(n.keys.indexOf(V)!==-1){const G=v(i.contents,V),Q=v(n.contents,V);O.equals(G,Q)||d.push(V)}}const P=[],U=V=>{const G={};for(const Q of V)for(const ie of Q.identifiers)G[o(ie)]=Q;return G},b=n?U(n.overrides):{},k=i?U(i.overrides):{};if(Object.keys(b).length)for(const V of r){const G=b[V];G&&P.push([(0,A.overrideIdentifierFromKey)(V),G.keys])}if(Object.keys(k).length)for(const V of l){const G=k[V];G&&P.push([(0,A.overrideIdentifierFromKey)(V),G.keys])}if(Object.keys(b).length&&Object.keys(k).length)for(const V of d){const G=k[V],Q=b[V];if(G&&Q){const ie=p({contents:G.contents,keys:G.keys,overrides:[]},{contents:Q.contents,keys:Q.keys,overrides:[]});P.push([(0,A.overrideIdentifierFromKey)(V),[...ie.added,...ie.removed,...ie.updated]])}}return{added:r,removed:l,updated:d,overrides:P}}t.compare=p;function m(i,n){const r=[];for(const l of Object.keys(i))if(A.OVERRIDE_PROPERTY_PATTERN.test(l)){const d={};for(const P in i[l])d[P]=i[l][P];r.push({identifiers:[(0,A.overrideIdentifierFromKey)(l).trim()],keys:Object.keys(d),contents:R(d,n)})}return r}t.toOverrides=m;function R(i,n){const r=Object.create(null);for(let l in i)a(r,l,i[l],n);return r}t.toValuesTree=R;function a(i,n,r,l){const d=n.split("."),P=d.pop();let U=i;for(let b=0;b<d.length;b++){let k=d[b],V=U[k];switch(typeof V){case"undefined":V=U[k]=Object.create(null);break;case"object":break;default:l(`Ignoring ${n} as ${d.slice(0,b+1).join(".")} is ${JSON.stringify(V)}`);return}U=V}if(typeof U=="object"&&U!==null)try{U[P]=r}catch(b){l(`Ignoring ${n} as ${d.join(".")} is ${JSON.stringify(U)}`)}else l(`Ignoring ${n} as ${d.join(".")} is ${JSON.stringify(U)}`)}t.addToValueTree=a;function c(i,n){const r=n.split(".");S(i,r)}t.removeFromValueTree=c;function S(i,n){const r=n.shift();if(n.length===0){delete i[r];return}if(Object.keys(i).indexOf(r)!==-1){const l=i[r];typeof l=="object"&&!Array.isArray(l)&&(S(l,n),Object.keys(l).length===0&&delete i[r])}}function v(i,n,r){function l(U,b){let k=U;for(const V of b){if(typeof k!="object"||k===null)return;k=k[V]}return k}const d=n.split("."),P=l(i,d);return typeof P=="undefined"?r:P}t.getConfigurationValue=v;function y(i,n,r){Object.keys(n).forEach(l=>{l!=="__proto__"&&(l in i?D.isObject(i[l])&&D.isObject(n[l])?y(i[l],n[l],r):r&&(i[l]=n[l]):i[l]=n[l])})}t.merge=y;function f(){const i=L.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(i)}t.getConfigurationKeys=f;function s(){const i=Object.create(null),n=L.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let r in n){let l=n[r].default;a(i,r,l,d=>console.error(`Conflict in default settings: ${d}`))}return i}t.getDefaultValues=s;function o(i){return`[${i}]`}t.keyFromOverrideIdentifier=o;function e(i,n,r){const l=i.inspect(n),d=i.inspect(r);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:l.defaultValue}t.getMigratedSettingValue=e}),define(Y[110],ee([0,1,24,14,58,2,45,18,13,8,27,30,25]),function(q,t,O,D,w,A,F,L,u,h,g,p,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.DefaultConfigurationModel=t.ConfigurationModel=void 0;class R{constructor(e={},i=[],n=[]){this._contents=e,this._keys=i,this._overrides=n,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(e){return e?(0,g.getConfigurationValue)(this.contents,e):this.contents}getOverrideValue(e,i){const n=this.getContentsForOverrideIdentifer(i);return n?e?(0,g.getConfigurationValue)(n,e):n:void 0}getKeysForOverrideIdentifier(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.keys;return[]}override(e){const i=this.getContentsForOverrideIdentifer(e);if(!i||typeof i!="object"||!Object.keys(i).length)return this;let n={};for(const r of O.distinct([...Object.keys(this.contents),...Object.keys(i)])){let l=this.contents[r],d=i[r];d&&(typeof l=="object"&&typeof d=="object"?(l=L.deepClone(l),this.mergeContents(l,d)):l=d),n[r]=l}return new R(n,this.keys,this.overrides)}merge(...e){const i=L.deepClone(this.contents),n=L.deepClone(this.overrides),r=[...this.keys];for(const l of e){this.mergeContents(i,l.contents);for(const d of l.overrides){const[P]=n.filter(U=>O.equals(U.identifiers,d.identifiers));P?this.mergeContents(P.contents,d.contents):n.push(L.deepClone(d))}for(const d of l.keys)r.indexOf(d)===-1&&r.push(d)}return new R(i,r,n)}freeze(){return this.isFrozen=!0,this}mergeContents(e,i){for(const n of Object.keys(i)){if(n in e&&u.isObject(e[n])&&u.isObject(i[n])){this.mergeContents(e[n],i[n]);continue}e[n]=L.deepClone(i[n])}}checkAndFreeze(e){return this.isFrozen&&!Object.isFrozen(e)?L.deepFreeze(e):e}getContentsForOverrideIdentifer(e){for(const i of this.overrides)if(i.identifiers.indexOf(e)!==-1)return i.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(e,i){this.addKey(e),(0,g.addToValueTree)(this.contents,e,i,n=>{throw new Error(n)})}removeValue(e){this.removeKey(e)&&(0,g.removeFromValueTree)(this.contents,e)}addKey(e){let i=this.keys.length;for(let n=0;n<i;n++)e.indexOf(this.keys[n])===0&&(i=n);this.keys.splice(i,1,e)}removeKey(e){let i=this.keys.indexOf(e);return i!==-1?(this.keys.splice(i,1),!0):!1}}t.ConfigurationModel=R;class a extends R{constructor(){const e=(0,g.getDefaultValues)(),i=(0,g.getConfigurationKeys)(),n=[];for(const r of Object.keys(e))p.OVERRIDE_PROPERTY_PATTERN.test(r)&&n.push({identifiers:[(0,p.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(e[r]),contents:(0,g.toValuesTree)(e[r],l=>console.error(`Conflict in default settings file: ${l}`))});super(e,i,n)}}t.DefaultConfigurationModel=a;class c{constructor(e){this._name=e,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new R}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(e,i){if(!u.isUndefinedOrNull(e)){const n=this.doParseContent(e);this.parseRaw(n,i)}}reparse(e){this._raw&&this.parseRaw(this._raw,e)}parseRaw(e,i){this._raw=e;const{contents:n,keys:r,overrides:l,restricted:d}=this.doParseRaw(e,i);this._configurationModel=new R(n,r,l),this._restrictedConfigurations=d||[]}doParseContent(e){let i={},n=null,r=[],l=[],d=[];function P(b){Array.isArray(r)?r.push(b):n!==null&&(r[n]=b)}let U={onObjectBegin:()=>{let b={};P(b),l.push(r),r=b,n=null},onObjectProperty:b=>{n=b},onObjectEnd:()=>{r=l.pop()},onArrayBegin:()=>{let b=[];P(b),l.push(r),r=b,n=null},onArrayEnd:()=>{r=l.pop()},onLiteralValue:P,onError:(b,k,V)=>{d.push({error:b,offset:k,length:V})}};if(e)try{w.visit(e,U),i=r[0]||{}}catch(b){console.error(`Error while parsing settings file ${this._name}: ${b}`),this._parseErrors=[b]}return i}doParseRaw(e,i){const n=m.Registry.as(p.Extensions.Configuration).getConfigurationProperties(),r=this.filter(e,n,!0,i);e=r.raw;const l=(0,g.toValuesTree)(e,U=>console.error(`Conflict in settings file ${this._name}: ${U}`)),d=Object.keys(e),P=(0,g.toOverrides)(e,U=>console.error(`Conflict in settings file ${this._name}: ${U}`));return{contents:l,keys:d,overrides:P,restricted:r.restricted}}filter(e,i,n,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:e,restricted:[]};const l={},d=[];for(let P in e)if(p.OVERRIDE_PROPERTY_PATTERN.test(P)&&n){const U=this.filter(e[P],i,!1,r);l[P]=U.raw,d.push(...U.restricted)}else{const U=i[P],b=U?typeof U.scope!="undefined"?U.scope:3:void 0;U?.restricted&&d.push(P),(b===void 0||r.scopes===void 0||r.scopes.includes(b))&&(r.skipRestricted&&U?.restricted||(l[P]=e[P]))}return{raw:l,restricted:d}}}t.ConfigurationModelParser=c;class S extends A.Disposable{constructor(e,i,n,r){super();this.userSettingsResource=e,this.scopes=i,this.fileService=r,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new c(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(n.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(D.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const e=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(e.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(e){return new R}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=S;class v{constructor(e,i,n=new R,r=new R,l=new F.ResourceMap,d=new R,P=new F.ResourceMap,U=!0){this._defaultConfiguration=e,this._localUserConfiguration=i,this._remoteUserConfiguration=n,this._workspaceConfiguration=r,this._folderConfigurations=l,this._memoryConfiguration=d,this._memoryConfigurationByResource=P,this._freeze=U,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new F.ResourceMap,this._userConfiguration=null}getValue(e,i,n){return this.getConsolidateConfigurationModel(i,n).getValue(e)}updateValue(e,i,n={}){let r;n.resource?(r=this._memoryConfigurationByResource.get(n.resource),r||(r=new R,this._memoryConfigurationByResource.set(n.resource,r))):r=this._memoryConfiguration,i===void 0?r.removeValue(e):r.setValue(e,i),n.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(e,i,n){const r=this.getConsolidateConfigurationModel(i,n),l=this.getFolderConfigurationModelForResource(i.resource,n),d=i.resource?this._memoryConfigurationByResource.get(i.resource)||this._memoryConfiguration:this._memoryConfiguration,P=i.overrideIdentifier?this._defaultConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._defaultConfiguration.freeze().getValue(e),U=i.overrideIdentifier?this.userConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.userConfiguration.freeze().getValue(e),b=i.overrideIdentifier?this.localUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.localUserConfiguration.freeze().getValue(e),k=i.overrideIdentifier?this.remoteUserConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this.remoteUserConfiguration.freeze().getValue(e),V=n?i.overrideIdentifier?this._workspaceConfiguration.freeze().override(i.overrideIdentifier).getValue(e):this._workspaceConfiguration.freeze().getValue(e):void 0,G=l?i.overrideIdentifier?l.freeze().override(i.overrideIdentifier).getValue(e):l.freeze().getValue(e):void 0,Q=i.overrideIdentifier?d.override(i.overrideIdentifier).getValue(e):d.getValue(e),ie=r.getValue(e),re=O.distinct(O.flatten(r.overrides.map(Z=>Z.identifiers))).filter(Z=>r.getOverrideValue(e,Z)!==void 0);return{defaultValue:P,userValue:U,userLocalValue:b,userRemoteValue:k,workspaceValue:V,workspaceFolderValue:G,memoryValue:Q,value:ie,default:P!==void 0?{value:this._defaultConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,user:U!==void 0?{value:this.userConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userLocal:b!==void 0?{value:this.localUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,userRemote:k!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspace:V!==void 0?{value:this._workspaceConfiguration.freeze().getValue(e),override:i.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,workspaceFolder:G!==void 0?{value:l?.freeze().getValue(e),override:i.overrideIdentifier?l?.freeze().getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,memory:Q!==void 0?{value:d.getValue(e),override:i.overrideIdentifier?d.getOverrideValue(e,i.overrideIdentifier):void 0}:void 0,overrideIdentifiers:re.length?re:void 0}}keys(e){const i=this.getFolderConfigurationModelForResource(void 0,e);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:i?i.freeze().keys:[]}}updateDefaultConfiguration(e){this._defaultConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(e){this._localUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(e){this._remoteUserConfiguration=e,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(e){this._workspaceConfiguration=e,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(e,i){this._folderConfigurations.set(e,i),this._foldersConsolidatedConfigurations.delete(e)}deleteFolderConfiguration(e){this.folderConfigurations.delete(e),this._foldersConsolidatedConfigurations.delete(e)}compareAndUpdateDefaultConfiguration(e,i){const n=i.filter(r=>p.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const l=(0,p.overrideIdentifierFromKey)(r),d=this._defaultConfiguration.getKeysForOverrideIdentifier(l),P=e.getKeysForOverrideIdentifier(l),U=[...P.filter(b=>d.indexOf(b)===-1),...d.filter(b=>P.indexOf(b)===-1),...d.filter(b=>!L.equals(this._defaultConfiguration.override(l).getValue(b),e.override(l).getValue(b)))];return[l,U]});return this.updateDefaultConfiguration(e),{keys:i,overrides:n}}compareAndUpdateLocalUserConfiguration(e){const{added:i,updated:n,removed:r,overrides:l}=(0,g.compare)(this.localUserConfiguration,e),d=[...i,...n,...r];return d.length&&this.updateLocalUserConfiguration(e),{keys:d,overrides:l}}compareAndUpdateRemoteUserConfiguration(e){const{added:i,updated:n,removed:r,overrides:l}=(0,g.compare)(this.remoteUserConfiguration,e);let d=[...i,...n,...r];return d.length&&this.updateRemoteUserConfiguration(e),{keys:d,overrides:l}}compareAndUpdateWorkspaceConfiguration(e){const{added:i,updated:n,removed:r,overrides:l}=(0,g.compare)(this.workspaceConfiguration,e);let d=[...i,...n,...r];return d.length&&this.updateWorkspaceConfiguration(e),{keys:d,overrides:l}}compareAndUpdateFolderConfiguration(e,i){const n=this.folderConfigurations.get(e),{added:r,updated:l,removed:d,overrides:P}=(0,g.compare)(n,i);let U=[...r,...l,...d];return(U.length||!n)&&this.updateFolderConfiguration(e,i),{keys:U,overrides:P}}compareAndDeleteFolderConfiguration(e){const i=this.folderConfigurations.get(e);if(!i)throw new Error("Unknown folder");this.deleteFolderConfiguration(e);const{added:n,updated:r,removed:l,overrides:d}=(0,g.compare)(i,void 0);return{keys:[...n,...r,...l],overrides:d}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(e,i){let n=this.getConsolidatedConfigurationModelForResource(e,i);return e.overrideIdentifier?n.override(e.overrideIdentifier):n}getConsolidatedConfigurationModelForResource({resource:e},i){let n=this.getWorkspaceConsolidatedConfiguration();if(i&&e){const r=i.getFolder(e);r&&(n=this.getFolderConsolidatedConfiguration(r.uri)||n);const l=this._memoryConfigurationByResource.get(e);l&&(n=n.merge(l))}return n}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(e){let i=this._foldersConsolidatedConfigurations.get(e);if(!i){const n=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(e);r?(i=n.merge(r),this._freeze&&(i=i.freeze()),this._foldersConsolidatedConfigurations.set(e,i)):i=n}return i}getFolderConfigurationModelForResource(e,i){if(i&&e){const n=i.getFolder(e);if(n)return this._folderConfigurations.get(n.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((e,i)=>{const{contents:n,overrides:r,keys:l}=this._folderConfigurations.get(i);return e.push([i,{contents:n,overrides:r,keys:l}]),e},[])}}allKeys(){const e=new Set;return this._defaultConfiguration.freeze().keys.forEach(i=>e.add(i)),this.userConfiguration.freeze().keys.forEach(i=>e.add(i)),this._workspaceConfiguration.freeze().keys.forEach(i=>e.add(i)),this._folderConfigurations.forEach(i=>i.freeze().keys.forEach(n=>e.add(n))),[...e.values()]}getAllKeysForOverrideIdentifier(e){const i=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this.userConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._workspaceConfiguration.getKeysForOverrideIdentifier(e).forEach(n=>i.add(n)),this._folderConfigurations.forEach(n=>n.getKeysForOverrideIdentifier(e).forEach(r=>i.add(r))),[...i.values()]}static parse(e){const i=this.parseConfigurationModel(e.defaults),n=this.parseConfigurationModel(e.user),r=this.parseConfigurationModel(e.workspace),l=e.folders.reduce((d,P)=>(d.set(h.URI.revive(P[0]),this.parseConfigurationModel(P[1])),d),new F.ResourceMap);return new v(i,n,new R,r,l,new R,new F.ResourceMap,!1)}static parseConfigurationModel(e){return new R(e.contents,e.keys,e.overrides).freeze()}}t.Configuration=v;function y(...o){if(o.length===0)return{keys:[],overrides:[]};if(o.length===1)return o[0];const e=new Set,i=new Map;for(const r of o)r.keys.forEach(l=>e.add(l)),r.overrides.forEach(([l,d])=>{const P=(0,F.getOrSet)(i,l,new Set);d.forEach(U=>P.add(U))});const n=[];return i.forEach((r,l)=>n.push([l,[...r.values()]])),{keys:[...e.values()],overrides:n}}t.mergeChanges=y;class f{constructor(e,i,n,r){this.change=e,this.previous=i,this.currentConfiguraiton=n,this.currentWorkspace=r,this._previousConfiguration=void 0;const l=new Set;e.keys.forEach(P=>l.add(P)),e.overrides.forEach(([,P])=>P.forEach(U=>l.add(U))),this.affectedKeys=[...l.values()];const d=new R;this.affectedKeys.forEach(P=>d.setValue(P,{})),this.affectedKeysTree=d.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(e,i){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,e)){if(i){const n=this.previousConfiguration?this.previousConfiguration.getValue(e,i,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(e,i,this.currentWorkspace);return!L.equals(n,r)}return!0}return!1}doesAffectedKeysTreeContains(e,i){let n=(0,g.toValuesTree)({[i]:!0},()=>{}),r;for(;typeof n=="object"&&(r=Object.keys(n)[0]);){if(e=e[r],!e)return!1;n=n[r]}return!0}}t.ConfigurationChangeEvent=f;class s extends f{constructor(e,i,n,r){super({keys:e.allKeys(),overrides:[]},void 0,e,i);this.source=n,this.sourceConfig=r}}t.AllKeysConfigurationChangeEvent=s}),define(Y[111],ee([0,1,3,14,2,19,27,110,30,25]),function(q,t,O,D,w,A,F,L,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class g extends w.Disposable{constructor(m,R){super();this.settingsResource=m,this._onDidChangeConfiguration=this._register(new D.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new L.UserSettings(this.settingsResource,void 0,A.extUriBiasedIgnorePathCase,R)),this.configuration=new L.Configuration(new L.DefaultConfigurationModel,new L.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new O.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(h.Registry.as(u.Extensions.Configuration).onDidUpdateConfiguration(a=>this.onDidDefaultConfigurationChange(a))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const m=await this.userConfiguration.loadConfiguration();this.configuration=new L.Configuration(new L.DefaultConfigurationModel,m)}getConfigurationData(){return this.configuration.toData()}getValue(m,R){const a=typeof m=="string"?m:void 0,c=(0,F.isConfigurationOverrides)(m)?m:(0,F.isConfigurationOverrides)(R)?R:{};return this.configuration.getValue(a,c,void 0)}updateValue(m,R,a,c){return Promise.reject(new Error("not supported"))}inspect(m){return this.configuration.inspect(m,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const m=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(m)}onDidChangeUserConfiguration(m){const R=this.configuration.toData(),a=this.configuration.compareAndUpdateLocalUserConfiguration(m);this.trigger(a,R,1)}onDidDefaultConfigurationChange(m){const R=this.configuration.toData(),a=this.configuration.compareAndUpdateDefaultConfiguration(new L.DefaultConfigurationModel,m);this.trigger(a,R,6)}trigger(m,R,a){const c=new L.ConfigurationChangeEvent(m,{data:R},this.configuration);c.source=a,c.sourceConfig=this.getTargetConfiguration(a),this._onDidChangeConfiguration.fire(c)}getTargetConfiguration(m){switch(m){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=g}),define(Y[55],ee([0,1,16,84,30,12,25]),function(q,t,O,D,w,A,F){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,A.createDecorator)("requestService");function L(a){return a.res.statusCode&&a.res.statusCode>=200&&a.res.statusCode<300||a.res.statusCode===1223}t.isSuccess=L;function u(a){return a.res.statusCode===204}async function h(a){if(!L(a))throw new Error("Server returned "+a.res.statusCode);return u(a)?null:(await(0,O.streamToBuffer)(a.stream)).toString()}t.asText=h;async function g(a){if(!L(a))throw new Error("Server returned "+a.res.statusCode);if(u(a))return null;const S=(await(0,O.streamToBuffer)(a.stream)).toString();try{return JSON.parse(S)}catch(v){throw v.message+=`:
`+S,v}}t.asJson=g;function p(a){R(a)}t.updateProxyConfigurationsScope=p;let m;function R(a){const c=F.Registry.as(w.Extensions.Configuration);m&&c.deregisterConfigurations([m]),m={id:"http",order:15,title:(0,D.localize)(0,null),type:"object",scope:a,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,D.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,D.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,D.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,D.localize)(4,null),(0,D.localize)(5,null),(0,D.localize)(6,null),(0,D.localize)(7,null)],default:"override",description:(0,D.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,D.localize)(9,null),restricted:!0}}},c.registerConfiguration(m)}R(2)}),define(Y[112],ee([0,1,113,13]),function(q,t,O,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function w(F,L){return F.protocol==="http:"?L.HTTP_PROXY||L.http_proxy||null:F.protocol==="https:"&&(L.HTTPS_PROXY||L.https_proxy||L.HTTP_PROXY||L.http_proxy)||null}async function A(F,L,u={}){const h=(0,O.parse)(F),g=u.proxyUrl||w(h,L);if(!g)return null;const p=(0,O.parse)(g);if(!/^https?:$/.test(p.protocol||""))return null;const m={host:p.hostname||"",port:p.port||(p.protocol==="https"?"443":"80"),auth:p.auth,rejectUnauthorized:(0,D.isBoolean)(u.strictSSL)?u.strictSSL:!0};return h.protocol==="http:"?new(await new Promise((R,a)=>{q(["http-proxy-agent"],R,a)}))(m):new(await new Promise((R,a)=>{q(["https-proxy-agent"],R,a)}))(m)}t.getProxyAgent=A}),define(Y[114],ee([0,1,16,29]),function(q,t,O,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function w(A,F,L){let u=L&&L.get("storage.serviceMachineId",0)||null;if(u)return u;try{const g=(await F.readFile(A.serviceMachineIdResource)).value.toString();u=(0,D.isUUID)(g)?g:null}catch(h){u=null}if(!u){u=(0,D.generateUuid)();try{await F.writeFile(A.serviceMachineIdResource,O.VSBuffer.fromString(u))}catch(h){}}return L&&L.store("storage.serviceMachineId",u,0,1),u}t.getServiceMachineId=w}),define(Y[115],ee([0,1,3,14,2,13,66,12]),function(q,t,O,D,w,A,F,L){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const u="__$__targetStorageMarker";t.IStorageService=(0,L.createDecorator)("storageService");var h;(function(c){c[c.NONE=0]="NONE",c[c.SHUTDOWN=1]="SHUTDOWN"})(h=t.WillSaveStateReason||(t.WillSaveStateReason={}));var g;(function(c){c[c.GLOBAL=0]="GLOBAL",c[c.WORKSPACE=1]="WORKSPACE"})(g=t.StorageScope||(t.StorageScope={}));var p;(function(c){c[c.USER=0]="USER",c[c.MACHINE=1]="MACHINE"})(p=t.StorageTarget||(t.StorageTarget={}));class m extends w.Disposable{constructor(S={flushInterval:m.DEFAULT_FLUSH_INTERVAL}){super();this.options=S,this._onDidChangeValue=this._register(new D.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new D.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new D.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new O.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new w.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,O.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,w.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(S,v){v===u?(S===0?this._globalKeyTargets=void 0:S===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:S})):this._onDidChangeValue.fire({scope:S,key:v,target:this.getKeyTargets(S)[v]})}emitWillSaveState(S){this._onWillSaveState.fire({reason:S})}get(S,v,y){return this.getStorage(v)?.get(S,y)}getBoolean(S,v,y){return this.getStorage(v)?.getBoolean(S,y)}getNumber(S,v,y){return this.getStorage(v)?.getNumber(S,y)}store(S,v,y,f){if((0,A.isUndefinedOrNull)(v)){this.remove(S,y);return}this.withPausedEmitters(()=>{this.updateKeyTarget(S,y,f),this.getStorage(y)?.set(S,v)})}remove(S,v){this.withPausedEmitters(()=>{this.updateKeyTarget(S,v,void 0),this.getStorage(v)?.delete(S)})}withPausedEmitters(S){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{S()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(S,v){const y=[],f=this.getKeyTargets(S);for(const s of Object.keys(f))f[s]===v&&y.push(s);return y}updateKeyTarget(S,v,y){const f=this.getKeyTargets(v);typeof y=="number"?f[S]!==y&&(f[S]=y,this.getStorage(v)?.set(u,JSON.stringify(f))):typeof f[S]=="number"&&(delete f[S],this.getStorage(v)?.set(u,JSON.stringify(f)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(S){return S===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(S){const v=this.get(u,S);if(v)try{return JSON.parse(v)}catch(y){}return Object.create(null)}isNew(S){return this.getBoolean(t.IS_NEW_KEY,S)===!0}async flush(S=h.NONE){this._onWillSaveState.fire({reason:S}),await O.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const S=this.getStorage(0)?.items??new Map,v=this.getStorage(1)?.items??new Map;return a(S,v,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}t.AbstractStorageService=m,m.DEFAULT_FLUSH_INTERVAL=60*1e3;class R extends m{constructor(){super();this.globalStorage=this._register(new F.Storage(new F.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new F.Storage(new F.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(S=>this.emitDidChangeValue(1,S))),this._register(this.globalStorage.onDidChangeStorage(S=>this.emitDidChangeValue(0,S)))}getStorage(S){return S===0?this.globalStorage:this.workspaceStorage}getLogDetails(S){return S===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(S){}}t.InMemoryStorageService=R;async function a(c,S,v,y){const f=l=>{try{return JSON.parse(l)}catch(d){return l}},s=new Map,o=new Map;c.forEach((l,d)=>{s.set(d,l),o.set(d,f(l))});const e=new Map,i=new Map;S.forEach((l,d)=>{e.set(d,l),i.set(d,f(l))}),console.group(`Storage: Global (path: ${v})`);let n=[];s.forEach((l,d)=>{n.push({key:d,value:l})}),console.table(n),console.groupEnd(),console.log(o),console.group(`Storage: Workspace (path: ${y})`);let r=[];e.forEach((l,d)=>{r.push({key:d,value:l})}),console.table(r),console.groupEnd(),console.log(i)}t.logStorage=a}),define(Y[116],ee([0,1,10,34,8,29]),function(q,t,O,D,w,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function F(h){if(O.platform===2&&/^penguin(\.|$)/i.test(h))return"chromebook"}async function L(h,g,p,m,R,a,c,S,v,y){const f=Object.create(null);f["common.machineId"]=c,f.sessionID=(0,A.generateUuid)()+Date.now(),f.commitHash=R,f.version=a,f["common.platformVersion"]=(g||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),f["common.platform"]=(0,O.PlatformToString)(O.platform),f["common.nodePlatform"]=D.platform,f["common.nodeArch"]=m,f["common.product"]=y||"desktop";const s=u(S||[]);s&&(f["common.msftInternal"]=s);let o=0;const e=Date.now();Object.defineProperties(f,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-e,enumerable:!0},"common.sequence":{get:()=>o++,enumerable:!0}}),O.isLinuxSnap&&(f["common.snap"]="true");const i=F(p);i&&(f["common.platformDetail"]=i);try{const n=await h.readFile(w.URI.file(v));f["common.source"]=n.value.toString().slice(0,30)}catch(n){}return f}t.resolveCommonProperties=L;function u(h){const g=D.env.USERDNSDOMAIN;if(!g)return!1;const p=g.toLowerCase();return h.some(m=>p===m)}t.verifyMicrosoftInternalDomain=u}),define(Y[36],ee([0,1,12]),function(q,t,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.instanceStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,O.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,O.createDecorator)("customEndpointTelemetryService"),t.instanceStorageKey="telemetry.instanceId",t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId"}),define(Y[117],ee([0,1,3,26,7,14,2,10,8,74,22,23,15,35,36]),function(q,t,O,D,w,A,F,L,u,h,g,p,m,R,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=t.INSTALL_ERROR_LOCAL=t.ERROR_UNKNOWN=t.INSTALL_ERROR_VALIDATING=void 0,t.INSTALL_ERROR_VALIDATING="validating",t.ERROR_UNKNOWN="unknown",t.INSTALL_ERROR_LOCAL="local";let c=class extends F.Disposable{constructor(s,o,e){super();this.galleryService=s,this.telemetryService=o,this.logService=e,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,F.toDisposable)(()=>{this.installingExtensions.forEach(i=>i.cancel()),this.uninstallingExtensions.forEach(i=>i.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async installFromGallery(s,o={}){if(!this.galleryService.isEnabled())throw new Error(h.localize(0,null));try{s=await this.checkAndGetCompatibleVersion(s)}catch(i){throw this.logService.error((0,w.getErrorMessage)(i)),v(this.telemetryService,"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(s),void 0,i),i}if(!await this.canInstall(s)){const i=new g.ExtensionManagementError("Not supported",t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Canno install extension as it is not supported.",s.identifier.id,i.message),v(this.telemetryService,"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(s),void 0,i),i}const e=await this.galleryService.getManifest(s,D.CancellationToken.None);if(e===null){const i=new g.ExtensionManagementError(`Missing manifest for extension ${s.identifier.id}`,t.INSTALL_ERROR_VALIDATING);throw this.logService.error("Failed to install extension:",s.identifier.id,i.message),v(this.telemetryService,"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(s),void 0,i),i}return this.installExtension(e,s,o)}async uninstall(s,o={}){return this.logService.trace("ExtensionManagementService#uninstall",s.identifier.id),this.unininstallExtension(s,o)}async reinstallFromGallery(s){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",s.identifier.id),!this.galleryService.isEnabled())throw new Error(h.localize(1,null));const o=await this.findGalleryExtension(s);if(!o)throw new Error(h.localize(2,null));await this.createUninstallExtensionTask(s,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsReport(){const s=new Date().getTime();return(!this.reportedExtensions||s-this.lastReportTimestamp>1e3*60*5)&&(this.reportedExtensions=this.updateReportCache(),this.lastReportTimestamp=s),this.reportedExtensions}registerParticipant(s){this.participants.push(s)}async installExtension(s,o,e){if(!u.URI.isUri(o)){let d=this.installingExtensions.get(new p.ExtensionIdentifierWithVersion(o.identifier,o.version).key());if(d)return this.logService.info("Extensions is already requested to install",o.identifier.id),d.waitUntilTaskIsFinished();e={...e,installOnlyNewlyAddedFromExtensionPack:!0}}const i=[],n=[],r=this.createInstallExtensionTask(s,o,e);u.URI.isUri(o)||this.installingExtensions.set(new p.ExtensionIdentifierWithVersion(r.identifier,s.version).key(),r),this._onInstallExtension.fire({identifier:r.identifier,source:o}),this.logService.info("Installing extension:",r.identifier.id),i.push({task:r,manifest:s});let l=!1;try{if(e.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",r.identifier.id);else try{const P=await this.getAllDepsAndPackExtensionsToInstall(r.identifier,s,!!e.installOnlyNewlyAddedFromExtensionPack);for(const{gallery:U,manifest:b}of P)if(l=l||!!b.extensionDependencies?.some(k=>(0,p.areSameExtensions)({id:k},r.identifier)),this.installingExtensions.has(new p.ExtensionIdentifierWithVersion(U.identifier,U.version).key()))this.logService.info("Extension is already requested to install",U.identifier.id);else{const k=this.createInstallExtensionTask(b,U,{...e,donotIncludePackAndDependencies:!0});this.installingExtensions.set(new p.ExtensionIdentifierWithVersion(k.identifier,b.version).key(),k),this._onInstallExtension.fire({identifier:k.identifier,source:U}),this.logService.info("Installing extension:",k.identifier.id),i.push({task:k,manifest:b})}}catch(P){throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",r.identifier.id),this.logService.error(P),P}const d=i.reduce((P,{task:U,manifest:b})=>(P.set(U.identifier.id.toLowerCase(),{task:U,manifest:b}),P),new Map);for(;d.size;){let P;const U=[...d.values()].filter(({manifest:b})=>!b.extensionDependencies?.some(k=>d.has(k.toLowerCase())));U.length?P=d.size===1?U:U.filter(({task:b})=>!(b===r&&!l)):(this.logService.info("Found extensions with circular dependencies",U.map(({task:b})=>b.identifier.id)),P=[...d.values()]),await this.joinAllSettled(P.map(async({task:b})=>{const k=new Date().getTime();try{const V=await b.run();if(await this.joinAllSettled(this.participants.map(G=>G.postInstall(V,b.source,e,D.CancellationToken.None))),!u.URI.isUri(b.source)&&(v(this.telemetryService,b.operation===2?"extensionGallery:update":"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(b.source),new Date().getTime()-k,void 0),L.isWeb&&b.operation===1))try{await this.galleryService.reportStatistic(V.manifest.publisher,V.manifest.name,V.manifest.version,"install")}catch(G){}n.push({local:V,identifier:b.identifier,operation:b.operation,source:b.source})}catch(V){throw u.URI.isUri(b.source)||v(this.telemetryService,b.operation===2?"extensionGallery:update":"extensionGallery:install",(0,p.getGalleryExtensionTelemetryData)(b.source),new Date().getTime()-k,V),this.logService.error("Error while installing the extension:",b.identifier.id),this.logService.error(V),V}finally{d.delete(b.identifier.id.toLowerCase())}}))}return n.forEach(({identifier:P})=>this.logService.info("Extension installed successfully:",P.id)),this._onDidInstallExtensions.fire(n),n.filter(({identifier:P})=>(0,p.areSameExtensions)(P,r.identifier))[0].local}catch(d){if(i.forEach(({task:P})=>P.cancel()),n.length)try{const P=await Promise.allSettled(n.map(({local:U})=>this.createUninstallExtensionTask(U,{versionOnly:!0}).run()));for(let U=0;U<P.length;U++){const b=P[U],{identifier:k}=n[U];b.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",k.id):this.logService.warn("Rollback: Error while uninstalling extension",k.id,(0,w.getErrorMessage)(b.reason))}}catch(P){this.logService.warn("Error while rolling back extensions",(0,w.getErrorMessage)(P),n.map(({identifier:U})=>U.id))}throw this.logService.error("Failed to install extension:",r.identifier.id,(0,w.getErrorMessage)(d)),this._onDidInstallExtensions.fire(i.map(({task:P})=>({identifier:P.identifier,operation:1,source:P.source}))),d instanceof Error&&(d.name=d&&d.code?d.code:t.ERROR_UNKNOWN),d}finally{for(const{task:d,manifest:P}of i)if(!u.URI.isUri(d.source)){const U=new p.ExtensionIdentifierWithVersion(d.identifier,P.version).key();this.installingExtensions.delete(U)||this.logService.warn("Installation task is not found in the cache",U)}}}async joinAllSettled(s){const o=[],e=[],i=await Promise.allSettled(s);for(const n of i)n.status==="fulfilled"?o.push(n.value):e.push(n.reason);if(e.length)throw S(e);return o}async getAllDepsAndPackExtensionsToInstall(s,o,e){if(!this.galleryService.isEnabled())return[];let i=await this.getInstalled();const n=[s,...i.map(d=>d.identifier)],r=[],l=async(d,P)=>{const U=P.extensionDependencies||[];if(P.extensionPack){const b=e?i.find(k=>(0,p.areSameExtensions)(k.identifier,d)):void 0;for(const k of P.extensionPack)b&&b.manifest.extensionPack&&b.manifest.extensionPack.some(V=>(0,p.areSameExtensions)({id:V},{id:k}))||U.every(V=>!(0,p.areSameExtensions)({id:V},{id:k}))&&U.push(k)}if(U.length){const b=[...n,...r.map(V=>V.gallery.identifier)],k=U.filter(V=>b.every(G=>!(0,p.areSameExtensions)(G,{id:V})));if(k.length){const V=await this.galleryService.query({names:k,pageSize:U.length},D.CancellationToken.None);for(const G of V.firstPage){if(b.find(re=>(0,p.areSameExtensions)(re,G.identifier)))continue;const Q=await this.checkAndGetCompatibleVersion(G);if(!await this.canInstall(Q)){this.logService.info("Skipping the extension as it cannot be installed",Q.identifier.id);continue}const ie=await this.galleryService.getManifest(Q,D.CancellationToken.None);if(ie===null)throw new g.ExtensionManagementError(`Missing manifest for extension ${Q.identifier.id}`,t.INSTALL_ERROR_VALIDATING);r.push({gallery:Q,manifest:ie}),await l(Q.identifier,ie)}}}};return await l(s,o),i=await this.getInstalled(),r.filter(d=>!i.some(P=>(0,p.areSameExtensions)(P.identifier,d.gallery.identifier)))}async checkAndGetCompatibleVersion(s){if(await this.isMalicious(s))throw new g.ExtensionManagementError(h.localize(3,null,s.identifier.id),g.INSTALL_ERROR_MALICIOUS);const o=await this.galleryService.getCompatibleExtension(s);if(!o)throw new g.ExtensionManagementError(h.localize(4,null,s.identifier.id,R.default.version),g.INSTALL_ERROR_INCOMPATIBLE);return o}async isMalicious(s){const o=await this.getExtensionsReport();return(0,p.getMaliciousExtensionsSet)(o).has(s.identifier.id)}async unininstallExtension(s,o){const e=this.uninstallingExtensions.get(s.identifier.id.toLowerCase());if(e)return this.logService.info("Extensions is already requested to uninstall",s.identifier.id),e.waitUntilTaskIsFinished();const i=(d,P)=>{const U=this.createUninstallExtensionTask(d,P);return this.uninstallingExtensions.set(U.extension.identifier.id.toLowerCase(),U),this.logService.info("Uninstalling extension:",d.identifier.id),this._onUninstallExtension.fire(d.identifier),U},n=(d,P)=>{P?this.logService.error("Failed to uninstall extension:",d.identifier.id,P.message):this.logService.info("Successfully uninstalled extension:",d.identifier.id),v(this.telemetryService,"extensionGallery:uninstall",(0,p.getLocalExtensionTelemetryData)(d),void 0,P),this._onDidUninstallExtension.fire({identifier:d.identifier,error:P?.code})},r=[],l=[];try{r.push(i(s,{}));const d=await this.getInstalled(1);if(o.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",s.identifier.id);else{const P=this.getAllPackExtensionsToUninstall(s,d);for(const U of P)this.uninstallingExtensions.has(U.identifier.id.toLowerCase())?this.logService.info("Extensions is already requested to uninstall",U.identifier.id):r.push(i(U,{}))}o.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",s.identifier.id):this.checkForDependents(r.map(P=>P.extension),d,s),await this.joinAllSettled(r.map(async P=>{try{if(await P.run(),await this.joinAllSettled(this.participants.map(U=>U.postUninstall(P.extension,o,D.CancellationToken.None))),P.extension.identifier.uuid)try{await this.galleryService.reportStatistic(P.extension.manifest.publisher,P.extension.manifest.name,P.extension.manifest.version,"uninstall")}catch(U){}n(P.extension)}catch(U){const b=U instanceof g.ExtensionManagementError?U:new g.ExtensionManagementError((0,w.getErrorMessage)(U),t.ERROR_UNKNOWN);throw n(P.extension,b),b}finally{l.push(P)}}))}catch(d){const P=d instanceof g.ExtensionManagementError?d:new g.ExtensionManagementError((0,w.getErrorMessage)(d),t.ERROR_UNKNOWN);for(const U of r){try{U.cancel()}catch(b){}l.includes(U)||n(U.extension,P)}throw P}finally{for(const d of r)this.uninstallingExtensions.delete(d.extension.identifier.id.toLowerCase())||this.logService.warn("Uninstallation task is not found in the cache",d.extension.identifier.id)}}checkForDependents(s,o,e){for(const i of s){const n=this.getDependents(i,o);if(n.length){const r=n.filter(l=>!s.some(d=>(0,p.areSameExtensions)(d.identifier,l.identifier)));if(r.length)throw new Error(this.getDependentsErrorMessage(i,r,e))}}}getDependentsErrorMessage(s,o,e){return e===s?o.length===1?h.localize(5,null,e.manifest.displayName||e.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?h.localize(6,null,e.manifest.displayName||e.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):h.localize(7,null,e.manifest.displayName||e.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):o.length===1?h.localize(8,null,e.manifest.displayName||e.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name):o.length===2?h.localize(9,null,e.manifest.displayName||e.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name):h.localize(10,null,e.manifest.displayName||e.manifest.name,s.manifest.displayName||s.manifest.name,o[0].manifest.displayName||o[0].manifest.name,o[1].manifest.displayName||o[1].manifest.name)}getAllPackExtensionsToUninstall(s,o,e=[]){if(e.indexOf(s)!==-1)return[];e.push(s);const i=s.manifest.extensionPack?s.manifest.extensionPack:[];if(i.length){const n=o.filter(l=>!l.isBuiltin&&i.some(d=>(0,p.areSameExtensions)({id:d},l.identifier))),r=[];for(const l of n)r.push(...this.getAllPackExtensionsToUninstall(l,o,e));return[...n,...r]}return[]}getDependents(s,o){return o.filter(e=>e.manifest.extensionDependencies&&e.manifest.extensionDependencies.some(i=>(0,p.areSameExtensions)({id:i},s.identifier)))}async findGalleryExtension(s){if(s.identifier.uuid){const o=await this.findGalleryExtensionById(s.identifier.uuid);return o||this.findGalleryExtensionByName(s.identifier.id)}return this.findGalleryExtensionByName(s.identifier.id)}async findGalleryExtensionById(s){return(await this.galleryService.query({ids:[s],pageSize:1},D.CancellationToken.None)).firstPage[0]}async findGalleryExtensionByName(s){return(await this.galleryService.query({names:[s],pageSize:1},D.CancellationToken.None)).firstPage[0]}async updateReportCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const s=await this.galleryService.getExtensionsReport();return this.logService.trace(`ExtensionManagementService.refreshReportedCache - got ${s.length} reported extensions from service`),s}catch(s){return this.logService.trace("ExtensionManagementService.refreshReportedCache - failed to get extension report"),[]}}};c=ue([fe(0,g.IExtensionGalleryService),fe(1,a.ITelemetryService),fe(2,m.ILogService)],c),t.AbstractExtensionManagementService=c;function S(f){const s=Array.isArray(f)?f:[f];return s.length===1?s[0]instanceof Error?s[0]:new Error(s[0]):s.reduce((o,e)=>new Error(`${o.message}${o.message?",":""}${e instanceof Error?e.message:e}`),new Error(""))}t.joinErrors=S;function v(f,s,o,e,i){const n=i?i instanceof g.ExtensionManagementError?i.code:t.ERROR_UNKNOWN:void 0;f.publicLogError(s,{...o,success:!i,duration:e,errorcode:n})}t.reportTelemetry=v;class y{constructor(){this.barrier=new O.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(s=>this.doRun(s))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,O.createCancelablePromise)(s=>new Promise((o,e)=>{const i=s.onCancellationRequested(()=>{i.dispose(),e((0,w.canceled)())})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=y}),define(Y[118],ee([0,1,26,7,18,10,20,22,23,49,17,12,15,42,55,114,115,36]),function(q,t,O,D,w,A,F,L,u,h,g,p,m,R,a,c,S,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=t.ExtensionGalleryService=void 0;var y;(function(W){W[W.None=0]="None",W[W.IncludeVersions=1]="IncludeVersions",W[W.IncludeFiles=2]="IncludeFiles",W[W.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",W[W.IncludeSharedAccounts=8]="IncludeSharedAccounts",W[W.IncludeVersionProperties=16]="IncludeVersionProperties",W[W.ExcludeNonValidated=32]="ExcludeNonValidated",W[W.IncludeInstallationTargets=64]="IncludeInstallationTargets",W[W.IncludeAssetUri=128]="IncludeAssetUri",W[W.IncludeStatistics=256]="IncludeStatistics",W[W.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",W[W.Unpublished=4096]="Unpublished"})(y||(y={}));function f(...W){return String(W.reduce((x,_)=>x|_,0))}var s;(function(W){W[W.Tag=1]="Tag",W[W.ExtensionId=4]="ExtensionId",W[W.Category=5]="Category",W[W.ExtensionName=7]="ExtensionName",W[W.Target=8]="Target",W[W.Featured=9]="Featured",W[W.SearchText=10]="SearchText",W[W.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},e={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},n={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:y.None,criteria:[],assetTypes:[]};class r{constructor(x=n){this.state=x}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(x,_=this.state.pageSize){return new r({...this.state,pageNumber:x,pageSize:_})}withFilter(x,..._){const M=[...this.state.criteria,..._.length?_.map(I=>({filterType:x,value:I})):[{filterType:x}]];return new r({...this.state,criteria:M})}withSortBy(x){return new r({...this.state,sortBy:x})}withSortOrder(x){return new r({...this.state,sortOrder:x})}withFlags(...x){return new r({...this.state,flags:x.reduce((_,M)=>_|M,0)})}withAssetTypes(...x){return new r({...this.state,assetTypes:x})}get raw(){const{criteria:x,pageNumber:_,pageSize:M,sortBy:I,sortOrder:N,flags:E,assetTypes:C}=this.state;return{filters:[{criteria:x,pageNumber:_,pageSize:M,sortBy:I,sortOrder:N}],assetTypes:C,flags:E}}get searchText(){const x=this.state.criteria.filter(_=>_.filterType===s.SearchText)[0];return x&&x.value?x.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(x=>String(x.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function l(W,x){const _=(W||[]).filter(M=>M.statisticName===x)[0];return _?_.value:0}function d(W){const x="Microsoft.VisualStudio.Code.Translation.";return W.files.filter(M=>M.assetType.indexOf(x)===0).reduce((M,I)=>{const N=k(W,I.assetType);return N&&M.push([I.assetType.substring(x.length),N]),M},[])}function P(W){if(W.properties){const x=W.properties.filter(I=>I.key===o.Repository),_=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),M=x.filter(I=>_.test(I.value))[0];return M?{uri:M.value,fallbackUri:M.value}:null}return k(W,o.Repository)}function U(W){return{uri:`${W.fallbackAssetUri}/${o.VSIX}?redirect=true`,fallbackUri:`${W.fallbackAssetUri}/${o.VSIX}`}}function b(W){const x=k(W,o.Icon);if(x)return x;const _=L.DefaultIconPath;return{uri:_,fallbackUri:_}}function k(W,x){return W.files.filter(M=>M.assetType===x)[0]?{uri:`${W.assetUri}/${x}`,fallbackUri:`${W.fallbackAssetUri}/${x}`}:null}function V(W,x){const _=W.properties?W.properties.filter(I=>I.key===x):[],M=_.length>0&&_[0].value;return M?M.split(",").map(I=>(0,u.adoptToGalleryExtensionId)(I)):[]}function G(W){const x=W.properties?W.properties.filter(_=>_.key===e.Engine):[];return x.length>0&&x[0].value||""}function Q(W){const x=W.properties?W.properties.filter(M=>M.key===e.LocalizedLanguages):[],_=x.length>0&&x[0].value||"";return _?_.split(","):[]}function ie(W){return W.indexOf("preview")!==-1}function re(W,x,_,M,I){const N={manifest:k(x,o.Manifest),readme:k(x,o.Details),changelog:k(x,o.Changelog),license:k(x,o.License),repository:P(x),download:U(x),icon:b(x),coreTranslations:d(x)};return{identifier:{id:(0,u.getGalleryExtensionId)(W.publisher.publisherName,W.extensionName),uuid:W.extensionId},name:W.extensionName,version:x.version,displayName:W.displayName,publisherId:W.publisher.publisherId,publisher:W.publisher.publisherName,publisherDisplayName:W.publisher.displayName,description:W.shortDescription||"",installCount:l(W.statistics,"install"),rating:l(W.statistics,"averagerating"),ratingCount:l(W.statistics,"ratingcount"),categories:W.categories||[],tags:W.tags||[],releaseDate:Date.parse(W.releaseDate),lastUpdated:Date.parse(W.lastUpdated),webExtension:!!W.tags?.includes(L.WEB_EXTENSION_TAG),assets:N,properties:{dependencies:V(x,e.Dependency),extensionPack:V(x,e.ExtensionPack),engine:G(x),localizedLanguages:Q(x)},telemetryData:{index:(M.pageNumber-1)*M.pageSize+_,querySource:I},preview:ie(W.flags)}}let Z=class{constructor(x,_,M,I,N,E,C){this.requestService=x,this.logService=_,this.environmentService=M,this.telemetryService=I,this.fileService=N,this.productService=E;const T=E.extensionsGallery;this.extensionsGalleryUrl=T&&T.serviceUrl,this.extensionsControlUrl=T&&T.controlUrl,this.commonHeadersPromise=J(E.version,this.environmentService,this.fileService,C)}api(x=""){return`${this.extensionsGalleryUrl}${x}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(x,_){const M=[];let{total:I,firstPage:N,getPage:E}=await this.query({names:x,pageSize:x.length},_);M.push(...N);for(let C=1;M.length<I&&(N=await E(C,_),N.length);C++)M.push(...N);return M}async getCompatibleExtension(x,_){return this.getCompatibleExtensionByEngine(x,_)}async getCompatibleExtensionByEngine(x,_){const M=(0,L.isIExtensionIdentifier)(x)?null:x;if(M&&M.properties.engine&&(0,h.isEngineValid)(M.properties.engine,this.productService.version,this.productService.date))return M;const{id:I,uuid:N}=M?M.identifier:x;let E=new r().withFlags(y.IncludeAssetUri,y.IncludeStatistics,y.IncludeCategoryAndTags,y.IncludeFiles,y.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");N?E=E.withFilter(s.ExtensionId,N):E=E.withFilter(s.ExtensionName,I);const{galleryExtensions:C}=await this.queryGallery(E,O.CancellationToken.None),[T]=C;if(!T||!T.versions.length)return null;if(_){const B=T.versions.filter($=>$.version===_)[0];if(B){const $=re(T,B,0,E);if($.properties.engine&&(0,h.isEngineValid)($.properties.engine,this.productService.version,this.productService.date))return $}return null}const j=await this.getLastValidExtensionVersion(T,T.versions);return j?re(T,j,0,E):null}async query(x,_){const M=O.CancellationToken.isCancellationToken(x)?{}:x,I=O.CancellationToken.isCancellationToken(x)?x:_;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let N=M.text||"";const E=(0,w.getOrDefault)(M,K=>K.pageSize,50);let C=new r().withFlags(y.IncludeLatestVersionOnly,y.IncludeAssetUri,y.IncludeStatistics,y.IncludeCategoryAndTags,y.IncludeFiles,y.IncludeVersionProperties).withPage(1,E).withFilter(s.Target,"Microsoft.VisualStudio.Code");N?(N=N.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(K,te,ne)=>(C=C.withFilter(s.Category,ne||te),"")),N=N.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(K,te,ne)=>(C=C.withFilter(s.Tag,ne||te),"")),N=N.replace(/\bfeatured(\s+|\b|$)/g,()=>(C=C.withFilter(s.Featured),"")),N=N.trim(),N&&(N=N.length<200?N:N.substring(0,200),C=C.withFilter(s.SearchText,N)),C=C.withSortBy(0)):M.ids?C=C.withFilter(s.ExtensionId,...M.ids):M.names?C=C.withFilter(s.ExtensionName,...M.names):C=C.withSortBy(4),typeof M.sortBy=="number"&&(C=C.withSortBy(M.sortBy)),typeof M.sortOrder=="number"&&(C=C.withSortOrder(M.sortOrder));const{galleryExtensions:T,total:j}=await this.queryGallery(C,I),B=T.map((K,te)=>re(K,K.versions[0],te,C,M.source)),$=async(K,te)=>{if(te.isCancellationRequested)throw(0,D.canceled)();const ne=C.withPage(K+1),{galleryExtensions:oe}=await this.queryGallery(ne,te);return oe.map((le,pe)=>re(le,le.versions[0],pe,ne,M.source))};return{firstPage:B,total:j,pageSize:C.pageSize,getPage:$}}async queryGallery(x,_){if(!this.isEnabled())throw new Error("No extension gallery service configured.");x=x.withFlags(x.flags,y.ExcludeNonValidated).withFilter(s.ExcludeWithFlags,f(y.Unpublished));const M=await this.commonHeadersPromise,I=JSON.stringify(x.raw),N={...M,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(I.length)},E=new Date().getTime();let C,T,j=0;try{if(C=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:I,headers:N},_),C.res.statusCode&&C.res.statusCode>=400&&C.res.statusCode<500)return{galleryExtensions:[],total:j};const B=await(0,a.asJson)(C);if(B){const $=B.results[0],K=$.extensions,te=$.resultMetadata&&$.resultMetadata.filter(ne=>ne.metadataType==="ResultCount")[0];return j=te&&te.metadataItems.filter(ne=>ne.name==="TotalCount")[0].count||0,{galleryExtensions:K,total:j}}return{galleryExtensions:[],total:j}}catch(B){throw T=B,B}finally{this.telemetryService.publicLog2("galleryService:query",{...x.telemetryData,requestBodySize:String(I.length),duration:new Date().getTime()-E,success:!!C&&(0,a.isSuccess)(C),responseBodySize:C?.res.headers["Content-Length"],statusCode:C?String(C.res.statusCode):void 0,errorCode:T?(0,D.isPromiseCanceledError)(T)?"canceled":(0,D.getErrorMessage)(T).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(j)})}}async reportStatistic(x,_,M,I){if(!this.isEnabled())return;const N=A.isWeb?this.api(`/itemName/${x}.${_}/version/${M}/statType/${I==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${x}/extensions/${_}/${M}/stats?statType=${I}`),E=A.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",T={...await this.commonHeadersPromise,Accept:E};try{await this.requestService.request({type:"POST",url:N,headers:T},O.CancellationToken.None)}catch(j){}}async download(x,_,M){this.logService.trace("ExtensionGalleryService#download",x.identifier.id);const I=(0,u.getGalleryExtensionTelemetryData)(x),N=new Date().getTime(),E=B=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...I,duration:B}),C=M===1?"install":M===2?"update":"",T=C?{uri:`${x.assets.download.uri}&${C}=true`,fallbackUri:`${x.assets.download.fallbackUri}?${C}=true`}:x.assets.download,j=await this.getAsset(T);await this.fileService.writeFile(_,j.stream),E(new Date().getTime()-N)}async getReadme(x,_){if(x.assets.readme){const M=await this.getAsset(x.assets.readme,{},_);return await(0,a.asText)(M)||""}return""}async getManifest(x,_){if(x.assets.manifest){const M=await this.getAsset(x.assets.manifest,{},_),I=await(0,a.asText)(M);return I?JSON.parse(I):null}return null}async getCoreTranslation(x,_){const M=x.assets.coreTranslations.filter(I=>I[0]===_.toUpperCase())[0];if(M){const I=await this.getAsset(M[1]),N=await(0,a.asText)(I);return N?JSON.parse(N):null}return null}async getChangelog(x,_){if(x.assets.changelog){const M=await this.getAsset(x.assets.changelog,{},_);return await(0,a.asText)(M)||""}return""}async getAllVersions(x,_){let M=new r().withFlags(y.IncludeVersions,y.IncludeCategoryAndTags,y.IncludeFiles,y.IncludeVersionProperties).withPage(1,1).withFilter(s.Target,"Microsoft.VisualStudio.Code");x.identifier.uuid?M=M.withFilter(s.ExtensionId,x.identifier.uuid):M=M.withFilter(s.ExtensionName,x.identifier.id);const I=[],{galleryExtensions:N}=await this.queryGallery(M,O.CancellationToken.None);return N.length&&(_?await Promise.all(N[0].versions.map(async E=>{let C;try{C=await this.getEngine(E)}catch(T){}C&&(0,h.isEngineValid)(C,this.productService.version,this.productService.date)&&I.push({version:E.version,date:E.lastUpdated})})):I.push(...N[0].versions.map(E=>({version:E.version,date:E.lastUpdated})))),I}async getAsset(x,_={},M=O.CancellationToken.None){const I=await this.commonHeadersPromise,N={type:"GET"},E={...I,..._.headers||{}};_={..._,...N,headers:E};const C=x.uri,T=x.fallbackUri,j={..._,url:C};try{const B=await this.requestService.request(j,M);if(B.res.statusCode===200)return B;const $=await(0,a.asText)(B);throw new Error(`Expected 200, got back ${B.res.statusCode} instead.

${$}`)}catch(B){if((0,D.isPromiseCanceledError)(B))throw B;const $=(0,D.getErrorMessage)(B);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:C,message:$});const K={..._,url:T};return this.requestService.request(K,M)}}async getLastValidExtensionVersion(x,_){const M=this.getLastValidExtensionVersionFromProperties(x,_);return M||this.getLastValidExtensionVersionRecursively(x,_)}getLastValidExtensionVersionFromProperties(x,_){for(const M of _){const I=G(M);if(!I)return null;if((0,h.isEngineValid)(I,this.productService.version,this.productService.date))return M}return null}async getEngine(x){const _=G(x);if(_)return _;const M=k(x,o.Manifest);if(!M)throw new Error("Manifest was not found");const I={"Accept-Encoding":"gzip"},N=await this.getAsset(M,{headers:I}),E=await(0,a.asJson)(N);if(E)return E.engines.vscode;throw new Error("Error while reading manifest")}async getLastValidExtensionVersionRecursively(x,_){if(!_.length)return null;const M=_[0],I=await this.getEngine(M);return(0,h.isEngineValid)(I,this.productService.version,this.productService.date)?{...M,properties:[...M.properties||[],{key:e.Engine,value:I}]}:this.getLastValidExtensionVersionRecursively(x,_.slice(1))}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const x=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},O.CancellationToken.None);if(x.res.statusCode!==200)throw new Error("Could not get extensions report.");const _=await(0,a.asJson)(x),M=new Map;if(_)for(const I of _.malicious){const N=M.get(I)||{id:{id:I},malicious:!0,slow:!1};N.malicious=!0,M.set(I,N)}return[...M.values()]}};Z=ue([fe(0,a.IRequestService),fe(1,m.ILogService),fe(2,F.IEnvironmentService),fe(3,v.ITelemetryService),fe(4,g.IFileService),fe(5,R.IProductService),fe(6,(0,p.optional)(S.IStorageService))],Z),t.ExtensionGalleryService=Z;async function J(W,x,_,M){const I={"X-Market-Client-Id":`VSCode ${W}`,"User-Agent":`VSCode ${W}`},N=await(0,c.getServiceMachineId)(x,_,M);return I["X-Market-User-Id"]=N,I}t.resolveMarketplaceHeaders=J}),define(Y[119],ee([0,1,2,18,21,85,27,30,12,35,25]),function(q,t,O,D,w,A,F,L,u,h,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let p=class{constructor(a,c){this._configurationService=c,this._experimentProperties={},this._disposables=new O.DisposableStore,this._cleanupPatterns=[],this._appender=a.appender,this._commonProperties=a.commonProperties||Promise.resolve({}),this._piiPaths=a.piiPaths||[],this._userOptIn=!0,this._enabled=!0,this.sendErrorTelemetry=!!a.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let S of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,w.escapeRegExpCharacters)(S),"gi"));this._configurationService&&(this._updateUserOptIn(),this._configurationService.onDidChangeConfiguration(this._updateUserOptIn,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._userOptIn}),this._commonProperties.then(S=>{const v=/^[a-f0-9]+$/i.test(S["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!v})}))}setExperimentProperty(a,c){this._experimentProperties[a]=c}setEnabled(a){this._enabled=a}_updateUserOptIn(){const a=this._configurationService?.getValue(m);this._userOptIn=a?a.enableTelemetry:this._userOptIn}get isOptedIn(){return this._userOptIn&&this._enabled}async getTelemetryInfo(){const a=await this._commonProperties;let c=a.sessionID,S=a["common.instanceId"],v=a["common.machineId"],y=a["common.firstSessionDate"],f=a["common.msftInternal"];return{sessionId:c,instanceId:S,machineId:v,firstSessionDate:y,msftInternal:f}}dispose(){this._disposables.dispose()}publicLog(a,c,S){return this.isOptedIn?this._commonProperties.then(v=>{c=(0,D.mixin)(c,v),c=(0,D.mixin)(c,this._experimentProperties),c=(0,D.cloneAndChange)(c,y=>{if(typeof y=="string")return this._cleanupInfo(y,S)}),this._appender.log(a,c)},v=>{console.error(v)}):Promise.resolve(void 0)}publicLog2(a,c,S){return this.publicLog(a,c,S)}publicLogError(a,c){return this.sendErrorTelemetry?this.publicLog(a,c,!0):Promise.resolve(void 0)}publicLogError2(a,c){return this.publicLogError(a,c)}_cleanupInfo(a,c){let S=a;if(c){const v=[];for(let o of this._cleanupPatterns)for(;;){const e=o.exec(a);if(!e)break;v.push([e.index,o.lastIndex])}const y=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,f=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let s=0;for(S="";;){const o=f.exec(a);if(!o)break;!y.test(o[0])&&v.every(([e,i])=>o.index<e||o.index>=i)&&(S+=a.substring(s,o.index)+"<REDACTED: user-file-path>",s=f.lastIndex)}s<a.length&&(S+=a.substr(s))}for(let v of this._cleanupPatterns)S=S.replace(v,"");return S}};p.IDLE_START_EVENT_NAME="UserIdleStart",p.IDLE_STOP_EVENT_NAME="UserIdleStop",p=ue([fe(1,(0,u.optional)(F.IConfigurationService))],p),t.TelemetryService=p;const m="telemetry";g.Registry.as(L.Extensions.Configuration).registerConfiguration({id:m,order:110,type:"object",title:(0,A.localize)(0,null),properties:{"telemetry.enableTelemetry":{type:"boolean",markdownDescription:h.default.privacyStatementUrl?(0,A.localize)(2,null,h.default.nameLong,h.default.privacyStatementUrl):(0,A.localize)(1,null,h.default.nameLong),default:!0,restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Y[56],ee([0,1,3,18,13,27]),function(q,t,O,D,w,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.cleanRemoteAuthority=t.validateTelemetryData=t.configurationTelemetry=t.NullAppender=t.combinedAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=void 0,t.NullTelemetryService=new class{constructor(){this.sendErrorTelemetry=!1,this.isOptedIn=!0}publicLog(a,c){return Promise.resolve(void 0)}publicLog2(a,c){return this.publicLog(a,c)}publicLogError(a,c){return Promise.resolve(void 0)}publicLogError2(a,c){return this.publicLogError(a,c)}setExperimentProperty(){}setEnabled(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}};class F{async publicLog(c,S,v){}async publicLogError(c,S,v){}}t.NullEndpointTelemetryService=F;function L(...a){return{log:(c,S)=>a.forEach(v=>v.log(c,S)),flush:()=>O.Promises.settled(a.map(c=>c.flush()))}}t.combinedAppender=L,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function u(a,c){return c.onDidChangeConfiguration(S=>{S.source!==6&&a.publicLog2("updateConfiguration",{configurationSource:(0,A.ConfigurationTargetToString)(S.source),configurationKeys:m(S.sourceConfig)})})}t.configurationTelemetry=u;function h(a){const c=Object.create(null),S=Object.create(null),v=Object.create(null);p(a,v);for(let y in v){y=y.length>150?y.substr(y.length-149):y;const f=v[y];typeof f=="number"?S[y]=f:typeof f=="boolean"?S[y]=f?1:0:typeof f=="string"?c[y]=f.substring(0,1023):typeof f!="undefined"&&f!==null&&(c[y]=f)}return{properties:c,measurements:S}}t.validateTelemetryData=h;function g(a){if(!a)return"none";let c="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(v=>{a.indexOf(`${v}+`)===0&&(c=v)}),c}t.cleanRemoteAuthority=g;function p(a,c,S=0,v){if(!!a)for(let y of Object.getOwnPropertyNames(a)){const f=a[y],s=v?v+y:y;Array.isArray(f)?c[s]=(0,D.safeStringify)(f):f instanceof Date?c[s]=f.toISOString():(0,w.isObject)(f)?S<2?p(f,c,S+1,s+"."):c[s]=(0,D.safeStringify)(f):c[s]=f}}function m(a){if(!a)return[];const c=[];return R(c,"",a),c}function R(a,c,S){S&&typeof S=="object"&&!Array.isArray(S)?Object.keys(S).forEach(v=>R(a,c?`${c}.${v}`:v,S[v])):a.push(c)}}),define(Y[120],ee([0,1,7,18,56]),function(q,t,O,D,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AppInsightsAppender=void 0;async function A(L){const u=await new Promise((g,p)=>{q(["applicationinsights"],g,p)});let h;return u.defaultClient?(h=new u.TelemetryClient(L),h.channel.setUseDiskRetryCaching(!0)):(u.setup(L).setAutoCollectRequests(!1).setAutoCollectPerformance(!1).setAutoCollectExceptions(!1).setAutoCollectDependencies(!1).setAutoDependencyCorrelation(!1).setAutoCollectConsole(!1).setInternalLogging(!1,!1).setUseDiskRetryCaching(!0).start(),h=u.defaultClient),L.indexOf("AIF-")===0&&(h.config.endpointUrl="https://vortex.data.microsoft.com/collect/v1"),h}class F{constructor(u,h,g){this._eventPrefix=u,this._defaultData=h,this._defaultData||(this._defaultData=Object.create(null)),typeof g=="function"?this._aiClient=g():this._aiClient=g,this._asyncAIClient=null}_withAIClient(u){if(!!this._aiClient){if(typeof this._aiClient!="string"){u(this._aiClient);return}this._asyncAIClient||(this._asyncAIClient=A(this._aiClient)),this._asyncAIClient.then(h=>{u(h)},h=>{(0,O.onUnexpectedError)(h),console.error(h)})}}log(u,h){!this._aiClient||(h=(0,D.mixin)(h,this._defaultData),h=(0,w.validateTelemetryData)(h),this._withAIClient(g=>g.trackEvent({name:this._eventPrefix+"/"+u,properties:h.properties,measurements:h.measurements})))}flush(){return this._aiClient?new Promise(u=>{this._withAIClient(h=>{h.flush({callback:()=>{this._aiClient=void 0,u(void 0)}})})}):Promise.resolve(void 0)}}t.AppInsightsAppender=F}),define(Y[121],ee([0,1,4,11]),function(q,t,O,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function w(A,F){const L=Object.create(null),u=(g,p)=>{const m=JSON.parse(g);L[p]=m};if(F){const g=[],p=await D.Promises.readdir(F);for(const R of p)try{(await D.Promises.stat((0,O.join)(F,R))).isDirectory()&&g.push(R)}catch{}const m=[];for(const R of g)(await D.Promises.readdir((0,O.join)(F,R))).filter(c=>c==="telemetry.json").length===1&&m.push(R);for(const R of m){const a=(await D.Promises.readFile((0,O.join)(F,R,"telemetry.json"))).toString();u(a,R)}}let h=(await D.Promises.readFile((0,O.join)(A,"telemetry-core.json"))).toString();return u(h,"vscode-core"),h=(await D.Promises.readFile((0,O.join)(A,"telemetry-extensions.json"))).toString(),u(h,"vscode-extensions"),JSON.stringify(L,null,4)}t.buildTelemetryMessage=w}),define(Y[43],ee([0,1,38,3,4,13,11,72,132,133]),function(q,t,O,D,w,A,F,L,u,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class g extends Error{constructor(e,i){let n=i.message;switch(e){case"CorruptZip":n=`Corrupt ZIP: ${n}`;break}super(n);this.type=e,this.cause=i}}t.ExtractError=g;function p(o){const e=o.externalFileAttributes>>16||33188;return[448,56,7].map(i=>e&i).reduce((i,n)=>i+n,e&61440)}function m(o){if(o instanceof g)return o;let e;return/end of central directory record signature not found/.test(o.message)&&(e="CorruptZip"),new g(e,o)}function R(o,e,i,n,r,l){const d=w.dirname(e),P=w.join(n,d);if(!P.startsWith(n))return Promise.reject(new Error(L.localize(0,null,e)));const U=w.join(n,e);let b;return l.onCancellationRequested(()=>{b&&b.destroy()}),Promise.resolve(F.Promises.mkdir(P,{recursive:!0})).then(()=>new Promise((k,V)=>{if(!l.isCancellationRequested)try{b=(0,O.createWriteStream)(U,{mode:i}),b.once("close",()=>k()),b.once("error",V),o.once("error",V),o.pipe(b)}catch(G){V(G)}}))}function a(o,e,i,n){let r=(0,D.createCancelablePromise)(()=>Promise.resolve()),l=0;return n.onCancellationRequested(()=>{r.cancel(),o.close()}),new Promise((d,P)=>{const U=new D.Sequencer,b=k=>{k.isCancellationRequested||(l++,o.readEntry())};o.once("error",P),o.once("close",()=>r.then(()=>{n.isCancellationRequested||o.entryCount===l?d():P(new g("Incomplete",new Error(L.localize(1,null,l,o.entryCount))))},P)),o.readEntry(),o.on("entry",k=>{if(n.isCancellationRequested)return;if(!i.sourcePathRegex.test(k.fileName)){b(n);return}const V=k.fileName.replace(i.sourcePathRegex,"");if(/\/$/.test(V)){const ie=w.join(e,V);r=(0,D.createCancelablePromise)(re=>F.Promises.mkdir(ie,{recursive:!0}).then(()=>b(re)).then(void 0,P));return}const G=S(o,k),Q=p(k);r=(0,D.createCancelablePromise)(ie=>U.queue(()=>G.then(re=>R(re,V,Q,e,i,ie).then(()=>b(ie)))).then(null,P))})})}function c(o,e=!1){return new Promise((i,n)=>{(0,u.open)(o,e?{lazyEntries:!0}:void 0,(r,l)=>{r?n(m(r)):i((0,A.assertIsDefined)(l))})})}function S(o,e){return new Promise((i,n)=>{o.openReadStream(e,(r,l)=>{r?n(m(r)):i((0,A.assertIsDefined)(l))})})}function v(o,e){return new Promise((i,n)=>{const r=new h.ZipFile;e.forEach(d=>{d.contents?r.addBuffer(typeof d.contents=="string"?Buffer.from(d.contents,"utf8"):d.contents,d.path):d.localPath&&r.addFile(d.localPath,d.path)}),r.end();const l=(0,O.createWriteStream)(o);r.outputStream.pipe(l),r.outputStream.once("error",n),l.once("error",n),l.once("finish",()=>i(o))})}t.zip=v;function y(o,e,i={},n){const r=new RegExp(i.sourcePath?`^${i.sourcePath}`:"");let l=c(o,!0);return i.overwrite&&(l=l.then(d=>F.Promises.rm(e).then(()=>d))),l.then(d=>a(d,e,{sourcePathRegex:r},n))}t.extract=y;function f(o,e){return c(o).then(i=>new Promise((n,r)=>{i.on("entry",l=>{l.fileName===e&&S(i,l).then(d=>n(d),d=>r(d))}),i.once("close",()=>r(new Error(L.localize(2,null,e))))}))}function s(o,e){return f(o,e).then(i=>new Promise((n,r)=>{const l=[];i.once("error",r),i.on("data",d=>l.push(d)),i.on("end",()=>n(Buffer.concat(l)))}))}t.buffer=s}),define(Y[122],ee([0,1,43,78]),function(q,t,O,D){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function w(A){return(0,O.buffer)(A,"extension/package.json").then(F=>{try{return JSON.parse(F.toString("utf8"))}catch(L){throw new Error((0,D.localize)(0,null))}})}t.getManifest=w}),define(Y[123],ee([0,1,24,3,7,2,9,4,10,19,41,8,29,11,43,79,20,22,23,90,17,15,42]),function(q,t,O,D,w,A,F,L,u,h,g,p,m,R,a,c,S,v,y,f,s,o,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScanner=void 0;const i="scanningSystem",n="scanningUser",r="extracting",l="deleting",d="renaming";let P=class extends A.Disposable{constructor(b,k,V,G,Q){super();this.beforeRemovingExtension=b,this.fileService=k,this.logService=V,this.environmentService=G,this.productService=Q,this._devSystemExtensionsPath=null,this.systemExtensionsPath=G.builtinExtensionsPath,this.extensionsPath=G.extensionsPath,this.uninstalledPath=L.join(this.extensionsPath,".obsolete"),this.uninstalledFileLimiter=new D.Queue}async cleanUp(){await this.removeUninstalledExtensions(),await this.removeOutdatedExtensions()}async scanExtensions(b){const k=[];(b===null||b===0)&&k.push(this.scanSystemExtensions().then(null,V=>Promise.reject(new v.ExtensionManagementError(this.joinErrors(V).message,i)))),(b===null||b===1)&&k.push(this.scanUserExtensions(!0).then(null,V=>Promise.reject(new v.ExtensionManagementError(this.joinErrors(V).message,n))));try{const V=await Promise.all(k);return(0,O.flatten)(V)}catch(V){throw this.joinErrors(V)}}async scanUserExtensions(b){this.logService.trace("Started scanning user extensions");let[k,V]=await Promise.all([this.getUninstalledExtensions(),this.scanAllUserExtensions()]);return V=V.filter(G=>!k[new y.ExtensionIdentifierWithVersion(G.identifier,G.manifest.version).key()]),b&&(V=(0,y.groupByExtension)(V,Q=>Q.identifier).map(Q=>Q.sort((ie,re)=>g.rcompare(ie.manifest.version,re.manifest.version))[0])),this.logService.trace("Scanned user extensions:",V.length),V}async scanAllUserExtensions(){return this.scanExtensionsInDir(this.extensionsPath,1)}async extractUserExtension(b,k,V){const G=b.key(),Q=L.join(this.extensionsPath,`.${(0,m.generateUuid)()}`),ie=L.join(this.extensionsPath,G);try{await R.Promises.rm(ie)}catch(Z){try{await R.Promises.rm(ie)}catch(J){}throw new v.ExtensionManagementError((0,c.localize)(0,null,ie,b.id),l)}await this.extractAtLocation(b,k,Q,V);let re=await this.scanExtension(p.URI.file(Q),1);if(!re)throw new Error((0,c.localize)(1,null,Q));await this.storeMetadata(re,{installedTimestamp:Date.now()});try{await this.rename(b,Q,ie,Date.now()+2*60*1e3),this.logService.info("Renamed to",ie)}catch(Z){try{await R.Promises.rm(Q)}catch(J){}if(Z.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",b.id);else throw this.logService.info(`Rename failed because of ${(0,w.getErrorMessage)(Z)}. Deleted from extracted location`,Q),Z}try{re=await this.scanExtension(p.URI.file(ie),1)}catch(Z){}if(re)return re;throw new Error((0,c.localize)(2,null,this.extensionsPath))}async saveMetadataForLocalExtension(b,k){return this.setMetadata(b,k),await this.storeMetadata(b,{...k,installedTimestamp:b.installedTimestamp}),b}async storeMetadata(b,k){k.isMachineScoped=k.isMachineScoped||void 0,k.isBuiltin=k.isBuiltin||void 0,k.installedTimestamp=k.installedTimestamp||void 0;const V=L.join(b.location.fsPath,"package.json"),G=await R.Promises.readFile(V,"utf8"),{manifest:Q}=await this.parseManifest(G);return Q.__metadata=k,await R.Promises.writeFile(V,JSON.stringify(Q,null,"	")),b}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...b){const k=b.map(V=>new y.ExtensionIdentifierWithVersion(V.identifier,V.manifest.version));await this.withUninstalledExtensions(V=>{k.forEach(G=>V[G.key()]=!0)})}async setInstalled(b){await this.withUninstalledExtensions(G=>delete G[b.key()]);const V=(await this.scanExtensions(1)).find(G=>new y.ExtensionIdentifierWithVersion(G.identifier,G.manifest.version).equals(b))||null;return V?(await this.storeMetadata(V,{installedTimestamp:Date.now()}),this.scanExtension(V.location,1)):null}async withUninstalledExtensions(b){return this.uninstalledFileLimiter.queue(async()=>{let k;try{k=await R.Promises.readFile(this.uninstalledPath,"utf8")}catch(G){if(G.code!=="ENOENT")throw G}let V={};if(k)try{V=JSON.parse(k)}catch(G){}return b&&(b(V),Object.keys(V).length?await R.Promises.writeFile(this.uninstalledPath,JSON.stringify(V)):await R.Promises.rm(this.uninstalledPath)),V})}async removeExtension(b,k){this.logService.trace(`Deleting ${k} extension from disk`,b.identifier.id,b.location.fsPath),await R.Promises.rm(b.location.fsPath),this.logService.info("Deleted from disk",b.identifier.id,b.location.fsPath)}async removeUninstalledExtension(b){await this.removeExtension(b,"uninstalled"),await this.withUninstalledExtensions(k=>delete k[new y.ExtensionIdentifierWithVersion(b.identifier,b.manifest.version).key()])}async extractAtLocation(b,k,V,G){this.logService.trace(`Started extracting the extension from ${k} to ${V}`);try{await R.Promises.rm(V)}catch(Q){throw new v.ExtensionManagementError(this.joinErrors(Q).message,l)}try{await(0,a.extract)(k,V,{sourcePath:"extension",overwrite:!0},G),this.logService.info(`Extracted extension to ${V}:`,b.id)}catch(Q){try{await R.Promises.rm(V)}catch(ie){}throw new v.ExtensionManagementError(Q.message,Q instanceof a.ExtractError&&Q.type?Q.type:r)}}async rename(b,k,V,G){try{await R.Promises.rename(k,V)}catch(Q){if(u.isWindows&&Q&&Q.code==="EPERM"&&Date.now()<G)return this.logService.info(`Failed renaming ${k} to ${V} with 'EPERM' error. Trying again...`,b.id),this.rename(b,k,V,G);throw new v.ExtensionManagementError(Q.message||(0,c.localize)(3,null,k,V),Q.code||d)}}async scanSystemExtensions(){this.logService.trace("Started scanning system extensions");const b=this.scanDefaultSystemExtensions();if(this.environmentService.isBuilt)return b;const k=this.scanDevSystemExtensions(),[V,G]=await Promise.all([b,k]);return[...V,...G]}async scanExtensionsInDir(b,k){const V=new D.Limiter(10),G=await this.fileService.resolve(p.URI.file(b));return G.children?(await Promise.all(G.children.filter(ie=>ie.isDirectory).map(ie=>V.queue(async()=>k===1&&(0,h.basename)(ie.resource).indexOf(".")===0?null:this.scanExtension(ie.resource,k))))).filter(ie=>ie&&ie.identifier):[]}async scanExtension(b,k){try{const V=await this.fileService.resolve(b);if(V.children){const{manifest:G,metadata:Q}=await this.readManifest(b.fsPath),ie=V.children.find(({name:W})=>/^readme(\.txt|\.md|)$/i.test(W))?.resource,re=V.children.find(({name:W})=>/^changelog(\.txt|\.md|)$/i.test(W))?.resource,Z={id:(0,y.getGalleryExtensionId)(G.publisher,G.name)},J={type:k,identifier:Z,manifest:G,location:b,readmeUrl:ie,changelogUrl:re,publisherDisplayName:null,publisherId:null,isMachineScoped:!1,isBuiltin:k===0};return Q&&(this.setMetadata(J,Q),J.installedTimestamp=Q.installedTimestamp),J}}catch(V){k!==0&&this.logService.trace(V)}return null}async scanDefaultSystemExtensions(){const b=await this.scanExtensionsInDir(this.systemExtensionsPath,0);return this.logService.trace("Scanned system extensions:",b.length),b}async scanDevSystemExtensions(){const b=this.getDevSystemExtensionsList();if(b.length){const k=await this.scanExtensionsInDir(this.devSystemExtensionsPath,0);return this.logService.trace("Scanned dev system extensions:",k.length),k.filter(V=>b.some(G=>(0,y.areSameExtensions)(V.identifier,{id:G})))}else return[]}setMetadata(b,k){b.publisherDisplayName=k.publisherDisplayName||null,b.publisherId=k.publisherId||null,b.identifier.uuid=k.id,b.isMachineScoped=!!k.isMachineScoped,b.isBuiltin=b.type===0||!!k.isBuiltin}async removeUninstalledExtensions(){const b=await this.getUninstalledExtensions(),k=await this.scanAllUserExtensions(),V=new Set;for(const ie of k)b[new y.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]||V.add(ie.identifier.id.toLowerCase());const G=(0,y.groupByExtension)(k,ie=>ie.identifier);await D.Promises.settled(G.map(async ie=>{const re=ie.sort((Z,J)=>g.rcompare(Z.manifest.version,J.manifest.version))[0];V.has(re.identifier.id.toLowerCase())||await this.beforeRemovingExtension(re)}));const Q=k.filter(ie=>b[new y.ExtensionIdentifierWithVersion(ie.identifier,ie.manifest.version).key()]);await D.Promises.settled(Q.map(ie=>this.removeUninstalledExtension(ie)))}async removeOutdatedExtensions(){const b=await this.scanAllUserExtensions(),k=[],V=(0,y.groupByExtension)(b,G=>G.identifier);k.push(...(0,O.flatten)(V.map(G=>G.sort((Q,ie)=>g.rcompare(Q.manifest.version,ie.manifest.version)).slice(1)))),await D.Promises.settled(k.map(G=>this.removeExtension(G,"outdated")))}getDevSystemExtensionsList(){return(this.productService.builtInExtensions||[]).map(b=>b.name)}joinErrors(b){const k=Array.isArray(b)?b:[b];return k.length===1?k[0]instanceof Error?k[0]:new Error(k[0]):k.reduce((V,G)=>new Error(`${V.message}${V.message?",":""}${G instanceof Error?G.message:G}`),new Error(""))}get devSystemExtensionsPath(){return this._devSystemExtensionsPath||(this._devSystemExtensionsPath=L.normalize(L.join(F.FileAccess.asFileUri("",q).fsPath,"..",".build","builtInExtensions"))),this._devSystemExtensionsPath}async readManifest(b){const k=[R.Promises.readFile(L.join(b,"package.json"),"utf8").then(ie=>this.parseManifest(ie)),R.Promises.readFile(L.join(b,"package.nls.json"),"utf8").then(void 0,ie=>ie.code!=="ENOENT"?Promise.reject(ie):"{}").then(ie=>JSON.parse(ie))],[{manifest:V,metadata:G},Q]=await Promise.all(k);return{manifest:(0,f.localizeManifest)(V,Q),metadata:G}}parseManifest(b){return new Promise((k,V)=>{try{const G=JSON.parse(b),Q=G.__metadata||null;k({manifest:G,metadata:Q})}catch(G){V(new Error((0,c.localize)(4,null)))}})}};P=ue([fe(1,s.IFileService),fe(2,o.ILogService),fe(3,S.INativeEnvironmentService),fe(4,e.IProductService)],P),t.ExtensionsScanner=P}),define(Y[124],ee([0,1,28,9,4,10,19,41,8,29,11,43,77,96,20,117,22,23,102,103,122,98,123,104,49,17,12,15,35,36]),function(q,t,O,D,w,A,F,L,u,h,g,p,m,R,a,c,S,v,y,f,s,o,e,i,n,r,l,d,P,U){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=void 0;const b="unsetUninstalled",k="downloading";let V=class extends c.AbstractExtensionManagementService{constructor(J,W,x,_,M,I,N){super(J,W,x);this.environmentService=_,this.downloadService=M;const E=this._register(I.createInstance(f.ExtensionsLifecycle));this.extensionsScanner=this._register(I.createInstance(e.ExtensionsScanner,T=>E.postUninstall(T))),this.manifestCache=this._register(new o.ExtensionsManifestCache(_,this)),this.extensionsDownloader=this._register(I.createInstance(y.ExtensionsDownloader));const C=this._register(new i.ExtensionsWatcher(this,N,_,x));this._register(C.onDidChangeExtensionsByAnotherSource(({added:T,removed:j})=>{T.length&&this._onDidInstallExtensions.fire(T.map(B=>({identifier:B.identifier,operation:0,local:B}))),j.forEach(B=>this._onDidUninstallExtension.fire({identifier:B}))}))}async zip(J){this.logService.trace("ExtensionManagementService#zip",J.identifier.id);const W=await this.collectFiles(J),x=await(0,p.zip)((0,F.joinPath)(this.environmentService.tmpDir,(0,h.generateUuid)()).fsPath,W);return u.URI.file(x)}async unzip(J){return this.logService.trace("ExtensionManagementService#unzip",J.toString()),(await this.install(J)).identifier}async getManifest(J){const W=await this.downloadVsix(J),x=w.resolve(W.fsPath);return(0,s.getManifest)(x)}getInstalled(J=null){return this.extensionsScanner.scanExtensions(J)}async canInstall(J){return!0}async install(J,W={}){this.logService.trace("ExtensionManagementService#install",J.toString());const x=await this.downloadVsix(J),_=await(0,s.getManifest)(w.resolve(x.fsPath));if(_.engines&&_.engines.vscode&&!(0,n.isEngineValid)(_.engines.vscode,P.default.version,P.default.date))throw new Error(m.localize(0,null,(0,v.getGalleryExtensionId)(_.publisher,_.name),P.default.version));return this.installExtension(_,x,W)}async updateMetadata(J,W){return this.logService.trace("ExtensionManagementService#updateMetadata",J.identifier.id),J=await this.extensionsScanner.saveMetadataForLocalExtension(J,{...J.manifest.__metadata||{},...W}),this.manifestCache.invalidate(),J}async updateExtensionScope(J,W){return this.logService.trace("ExtensionManagementService#updateExtensionScope",J.identifier.id),J=await this.extensionsScanner.saveMetadataForLocalExtension(J,{...J.manifest.__metadata||{},isMachineScoped:W}),this.manifestCache.invalidate(),J}removeDeprecatedExtensions(){return this.extensionsScanner.cleanUp()}async downloadVsix(J){if(J.scheme===D.Schemas.file)return J;if(!this.downloadService)throw new Error("Download service is not available");const W=(0,F.joinPath)(this.environmentService.tmpDir,(0,h.generateUuid)());return await this.downloadService.download(J,W),W}createInstallExtensionTask(J,W,x){return u.URI.isUri(W)?new ie(J,W,x,this.galleryService,this.extensionsScanner,this.logService):new Q(W,x,this.extensionsDownloader,this.extensionsScanner,this.logService)}createUninstallExtensionTask(J,W){return new re(J,W,this.extensionsScanner)}async collectFiles(J){const W=async _=>{let M=await g.Promises.readdir(_);M=M.map(E=>w.join(_,E));const I=await Promise.all(M.map(E=>g.Promises.stat(E)));let N=Promise.resolve([]);return I.forEach((E,C)=>{const T=M[C];E.isFile()&&(N=N.then(j=>[...j,T])),E.isDirectory()&&(N=N.then(j=>W(T).then(B=>[...j,...B])))}),N};return(await W(J.location.fsPath)).map(_=>({path:`extension/${w.relative(J.location.fsPath,_)}`,localPath:_}))}};V=ue([fe(0,S.IExtensionGalleryService),fe(1,U.ITelemetryService),fe(2,d.ILogService),fe(3,a.INativeEnvironmentService),fe(4,(0,l.optional)(R.IDownloadService)),fe(5,l.IInstantiationService),fe(6,r.IFileService)],V),t.ExtensionManagementService=V;class G extends c.AbstractExtensionTask{constructor(J,W,x,_){super();this.identifier=J,this.source=W,this.extensionsScanner=x,this.logService=_,this._operation=1}get operation(){return this._operation}async installExtension(J,W){try{const x=await this.unsetUninstalledAndGetLocal(J.identifierWithVersion);if(x)return J.metadata?this.extensionsScanner.saveMetadataForLocalExtension(x,J.metadata):x}catch(x){throw A.isMacintosh?new S.ExtensionManagementError(m.localize(1,null),b):new S.ExtensionManagementError(m.localize(2,null),b)}return this.extract(J,W)}async unsetUninstalledAndGetLocal(J){if(!await this.isUninstalled(J))return null;this.logService.trace("Removing the extension from uninstalled list:",J.id);const x=await this.extensionsScanner.setInstalled(J);return this.logService.info("Removed the extension from uninstalled list:",J.id),x}async isUninstalled(J){return!!(await this.extensionsScanner.getUninstalledExtensions())[J.key()]}async extract({zipPath:J,identifierWithVersion:W,metadata:x},_){let M=await this.extensionsScanner.extractUserExtension(W,J,_);return this.logService.info("Extracting completed.",W.id),x&&(M=await this.extensionsScanner.saveMetadataForLocalExtension(M,x)),M}}class Q extends G{constructor(J,W,x,_,M){super(J.identifier,J,_,M);this.gallery=J,this.options=W,this.extensionsDownloader=x}async doRun(J){const x=(await this.extensionsScanner.scanExtensions(null)).find(I=>(0,v.areSameExtensions)(I.identifier,this.gallery.identifier));x&&(this._operation=2);const _=await this.downloadInstallableExtension(this.gallery,this._operation);_.metadata.isMachineScoped=this.options.isMachineScoped||x?.isMachineScoped,_.metadata.isBuiltin=this.options.isBuiltin||x?.isBuiltin;const M=await this.installExtension(_,J);x&&L.neq(x.manifest.version,this.gallery.version)&&await this.extensionsScanner.setUninstalled(x);try{await this.extensionsDownloader.delete(u.URI.file(_.zipPath))}catch(I){}return M}async downloadInstallableExtension(J,W){const x={id:J.identifier.uuid,publisherId:J.publisherId,publisherDisplayName:J.publisherDisplayName};let _;try{this.logService.trace("Started downloading extension:",J.identifier.id),_=(await this.extensionsDownloader.downloadExtension(J,W)).fsPath,this.logService.info("Downloaded extension:",J.identifier.id,_)}catch(M){throw new S.ExtensionManagementError((0,c.joinErrors)(M).message,k)}try{const M=await(0,s.getManifest)(_);return{zipPath:_,identifierWithVersion:new v.ExtensionIdentifierWithVersion(J.identifier,M.version),metadata:x}}catch(M){throw new S.ExtensionManagementError((0,c.joinErrors)(M).message,c.INSTALL_ERROR_VALIDATING)}}}class ie extends G{constructor(J,W,x,_,M,I){super({id:(0,v.getGalleryExtensionId)(J.publisher,J.name)},W,M,I);this.manifest=J,this.location=W,this.options=x,this.galleryService=_}async doRun(J){const W=new v.ExtensionIdentifierWithVersion(this.identifier,this.manifest.version),_=(await this.extensionsScanner.scanExtensions(1)).find(I=>(0,v.areSameExtensions)(this.identifier,I.identifier)),M=await this.getMetadata(this.identifier.id,J);if(_)if(M.isMachineScoped=this.options.isMachineScoped||_.isMachineScoped,M.isBuiltin=this.options.isBuiltin||_.isBuiltin,this._operation=2,W.equals(new v.ExtensionIdentifierWithVersion(_.identifier,_.manifest.version)))try{await this.extensionsScanner.removeExtension(_,"existing")}catch(I){throw new Error(m.localize(3,null,this.manifest.displayName||this.manifest.name))}else L.gt(_.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(_);else{const I=await this.unsetUninstalledAndGetLocal(W);if(I)try{await this.extensionsScanner.removeExtension(I,"existing")}catch(N){throw new Error(m.localize(4,null,this.manifest.displayName||this.manifest.name))}}return this.installExtension({zipPath:w.resolve(this.location.fsPath),identifierWithVersion:W,metadata:M},J)}async getMetadata(J,W){try{const x=(await this.galleryService.query({names:[J],pageSize:1},W)).firstPage[0];if(x)return{id:x.identifier.uuid,publisherDisplayName:x.publisherDisplayName,publisherId:x.publisherId}}catch(x){}return{}}}class re extends c.AbstractExtensionTask{constructor(J,W,x){super();this.extension=J,this.options=W,this.extensionsScanner=x}async doRun(J){const W=[],x=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const _=new v.ExtensionIdentifierWithVersion(this.extension.identifier,this.extension.manifest.version);W.push(...x.filter(M=>_.equals(new v.ExtensionIdentifierWithVersion(M.identifier,M.manifest.version))))}else W.push(...x.filter(_=>(0,v.areSameExtensions)(_.identifier,this.extension.identifier)));if(!W.length)throw new Error(m.localize(5,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...W),this.options.remove)for(const _ of W)try{J.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(_)}catch(M){throw new Error(m.localize(6,null,(0,O.toErrorMessage)(M)))}}}}),define(Y[125],ee([0,1,113,16,7,2,13,27,20,99,15,112,134]),function(q,t,O,D,w,A,F,L,u,h,g,p,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let R=class extends A.Disposable{constructor(c,S,v){super();this.environmentService=S,this.logService=v,this.configure(c.getValue()),this._register(c.onDidChangeConfiguration(()=>this.configure(c.getValue()),this))}configure(c){this.proxyUrl=c.http&&c.http.proxy,this.strictSSL=!!(c.http&&c.http.proxyStrictSSL),this.authorization=c.http&&c.http.proxyAuthorization}async request(c,S){this.logService.trace("RequestService#request",c.url);const{proxyUrl:v,strictSSL:y}=this,f={...process.env,...await(0,h.resolveShellEnv)(this.logService,this.environmentService.args,process.env)},s=c.agent?c.agent:await(0,p.getProxyAgent)(c.url||"",f,{proxyUrl:v,strictSSL:y});return c.agent=s,c.strictSSL=y,this.authorization&&(c.headers={...c.headers||{},"Proxy-Authorization":this.authorization}),this._request(c,S)}async getNodeRequest(c){return((0,O.parse)(c.url).protocol==="https:"?await new Promise((y,f)=>{q(["https"],y,f)}):await new Promise((y,f)=>{q(["http"],y,f)})).request}_request(c,S){return new Promise(async(v,y)=>{let f;const s=(0,O.parse)(c.url),o=c.getRawRequest?c.getRawRequest(c):await this.getNodeRequest(c),e={hostname:s.hostname,port:s.port?parseInt(s.port):s.protocol==="https:"?443:80,protocol:s.protocol,path:s.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,F.isBoolean)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(e.auth=c.user+":"+c.password),f=o(e,i=>{const n=(0,F.isNumber)(c.followRedirects)?c.followRedirects:3;if(i.statusCode&&i.statusCode>=300&&i.statusCode<400&&n>0&&i.headers.location)this._request({...c,url:i.headers.location,followRedirects:n-1},S).then(v,y);else{let r=i;i.headers["content-encoding"]==="gzip"&&(r=i.pipe((0,m.createGunzip)())),v({res:i,stream:(0,D.streamToBufferReadableStream)(r)})}}),f.on("error",y),c.timeout&&f.setTimeout(c.timeout),c.data&&typeof c.data=="string"&&f.write(c.data),f.end(),S.onCancellationRequested(()=>{f.abort(),y((0,w.canceled)())})})}async resolveProxy(c){}};R=ue([fe(0,L.IConfigurationService),fe(1,u.INativeEnvironmentService),fe(2,g.ILogService)],R),t.RequestService=R}),define(Y[135],ee([0,1,38,136,32,3,16,28,7,2,9,4,34,8,11,27,111,20,89,118,22,97,124,17,107,108,50,101,52,53,105,15,106,35,42,55,125,116,36,119,56,120,121]),function(q,t,O,D,w,A,F,L,u,h,g,p,m,R,a,c,S,v,y,f,s,o,e,i,n,r,l,d,P,U,b,k,V,G,Q,ie,re,Z,J,W,x,_,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class I extends h.Disposable{constructor(C){super();this.argv=C,(0,D.gracefulify)(O),this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[C,T]=await this.initServices();return C.invokeFunction(async j=>{const B=j.get(k.ILogService),$=j.get(i.IFileService),K=j.get(v.INativeEnvironmentService),te=j.get(s.IExtensionManagementCLIService);return B.info("CLI main",this.argv),this.registerErrorHandler(B),await this.doRun(K,te,$),(0,A.raceTimeout)((0,x.combinedAppender)(...T).flush(),1e3)})}async initServices(){const C=new P.ServiceCollection,T={_serviceBrand:void 0,...G.default};C.set(Q.IProductService,T);const j=new y.NativeEnvironmentService(this.argv,T);C.set(v.INativeEnvironmentService,j),await Promise.all([j.appSettingsHome.fsPath,j.extensionsPath].map(pe=>pe?a.Promises.mkdir(pe,{recursive:!0}):void 0));const B=(0,k.getLogLevel)(j),$=[];$.push(new V.SpdLogLogger("cli",(0,p.join)(j.logsPath,"cli.log"),!0,B)),B===k.LogLevel.Trace&&$.push(new k.ConsoleLogger(B));const K=this._register(new k.MultiplexLogService($));C.set(k.ILogService,K);const te=this._register(new n.FileService(K));C.set(i.IFileService,te);const ne=this._register(new r.DiskFileSystemProvider(K));te.registerProvider(g.Schemas.file,ne);const oe=this._register(new S.ConfigurationService(j.settingsResource,te));C.set(c.IConfigurationService,oe),await oe.initialize(),C.set(ie.IRequestService,new l.SyncDescriptor(re.RequestService)),C.set(s.IExtensionManagementService,new l.SyncDescriptor(e.ExtensionManagementService)),C.set(s.IExtensionGalleryService,new l.SyncDescriptor(f.ExtensionGalleryService)),C.set(s.IExtensionManagementCLIService,new l.SyncDescriptor(o.ExtensionManagementCLIService)),C.set(U.ILocalizationsService,new l.SyncDescriptor(b.LocalizationsService));const le=[];if(j.isBuilt&&!j.isExtensionDevelopment&&!j.disableTelemetry&&T.enableTelemetry){T.aiConfig&&T.aiConfig.asimovKey&&le.push(new _.AppInsightsAppender("monacoworkbench",null,T.aiConfig.asimovKey));const{appRoot:pe,extensionsPath:De,installSourcePath:ke}=j,Te={appender:(0,x.combinedAppender)(...le),sendErrorTelemetry:!1,commonProperties:(async()=>{let we;try{const Fe=await a.Promises.readFile((0,p.join)(j.userDataPath,"storage.json"));we=JSON.parse(Fe.toString())[J.machineIdKey]}catch(Fe){Fe.code!=="ENOENT"&&K.error(Fe)}return(0,Z.resolveCommonProperties)(te,(0,w.release)(),(0,w.hostname)(),process.arch,T.commit,T.version,we,T.msftInternalDomains,ke)})(),piiPaths:[pe,De]};C.set(J.ITelemetryService,new l.SyncDescriptor(W.TelemetryService,[Te]))}else C.set(J.ITelemetryService,x.NullTelemetryService);return[new d.InstantiationService(C),le]}registerErrorHandler(C){(0,u.setUnexpectedErrorHandler)(T=>{const j=(0,L.toErrorMessage)(T,!0);!j||C.error(`[uncaught exception in CLI]: ${j}`)}),process.on("uncaughtException",T=>(0,u.onUnexpectedError)(T)),process.on("unhandledRejection",T=>(0,u.onUnexpectedError)(T))}async doRun(C,T,j){if(this.argv["install-source"])return this.setInstallSource(C,j,this.argv["install-source"]);if(this.argv["list-extensions"])return T.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"])return T.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],!!this.argv["do-not-sync"],!!this.argv.force);if(this.argv["uninstall-extension"])return T.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return T.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,M.buildTelemetryMessage)(C.appRoot,C.extensionsPath))}asExtensionIdOrVSIX(C){return C.map(T=>/\.vsix$/i.test(T)?R.URI.file((0,p.isAbsolute)(T)?T:(0,p.join)((0,m.cwd)(),T)):T)}async setInstallSource(C,T,j){await T.writeFile(R.URI.file(C.installSourcePath),F.VSBuffer.fromString(j.slice(0,30)))}}async function N(E){const C=new I(E);try{await C.run()}finally{C.dispose()}}t.main=N})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/af770c2dc85ef6835197a8bd7eb416fe0a022c44/core/vs/code/node/cliProcessMain.js.map
