/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var be=["require","exports","vs/base/common/uri","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/async","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/arrays","vs/base/common/path","vs/nls","vs/nls!vs/workbench/services/extensions/worker/extensionHostWorker","vs/base/common/map","vs/base/common/cancellation","vs/base/common/objects","vs/base/common/buffer","vs/base/common/resources","vs/platform/extensions/common/extensions","vs/base/common/platform","vs/base/common/glob","vs/platform/registry/common/platform","vs/workbench/api/common/extHostInitDataService","vs/workbench/services/extensions/common/extensions","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/codicons","vs/base/common/severity","vs/base/common/uuid","vs/workbench/api/common/extHostTerminalService","vs/workbench/services/search/common/search","vs/base/common/assert","vs/base/common/extpath","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/platform/theme/common/themeService","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostWebview","vs/base/common/collections","vs/base/common/decorators","vs/base/common/idGenerator","vs/base/common/marshalling","vs/editor/common/modes/languageSelector","vs/base/common/errorMessage","vs/platform/instantiation/common/extensions","vs/base/common/hash","vs/editor/common/modes","vs/platform/files/common/files","vs/platform/instantiation/common/serviceCollection","vs/platform/configuration/common/configurationRegistry","vs/workbench/api/common/cache","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/api/common/shared/webview","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/numbers","vs/base/common/htmlContent","vs/base/common/labels","vs/base/common/mime","vs/editor/common/model","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/markers/common/markers","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configuration","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/contrib/testing/common/testCollection","vs/base/common/process","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostOutput","vs/workbench/api/common/extHostWindow","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/lazy","vs/base/common/stream","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/controller/wordCharacterClassifier","vs/editor/common/model/textModelSearch","vs/editor/common/core/position","vs/editor/common/modes/languageConfiguration","vs/editor/common/modes/tokenizationRegistry","vs/nls!vs/base/common/errorMessage","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/model/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/search/common/queryBuilder","vs/nls!vs/workbench/contrib/tasks/common/taskService","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/editor/common/services/modelService","vs/editor/common/modes/languageFeatureRegistry","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/opener/common/opener","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostNotebookConcatDocument","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/api/common/shared/treeDataTransfer","vs/workbench/api/common/extHostCodeInsets","vs/workbench/common/editor","vs/workbench/common/views","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/tasks/common/taskService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostTreeViews","vs/workbench/contrib/testing/common/ownedTestCollection","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/iterator","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostLogService","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/queryBuilder","vs/workbench/api/common/shared/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/services/extensions/common/extensionHostMain","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/editor/common/core/characterClassifier","vs/editor/common/model/mirrorTextModel","vs/editor/common/viewModel/prefixSumComputer","vs/base/common/marked/marked","vs/base/common/linkedList","vs/editor/common/modes/linkComputer","vs/editor/common/core/selection","vs/base/common/functional","vs/workbench/services/extensions/worker/extensionHostWorker"],Ee=function(re){for(var e=[],h=0,F=re.length;h<F;h++)e[h]=be[re[h]];return e};define(be[39],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function h(F,E){if(!F)throw new Error(E?`Assertion failed (${E})`:"Assertion Failed")}e.ok=h}),define(be[50],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.fromMap=e.groupBy=e.forEach=e.values=void 0;const h=Object.prototype.hasOwnProperty;function F(t){const _=[];for(let r in t)h.call(t,r)&&_.push(t[r]);return _}e.values=F;function E(t,_){for(let r in t)if(h.call(t,r)&&_({key:r,value:t[r]},function(){delete t[r]})===!1)return}e.forEach=E;function A(t,_){const r=Object.create(null);for(const d of t){const a=_(d);let l=r[a];l||(l=r[a]=[]),l.push(d)}return r}e.groupBy=A;function R(t){const _=Object.create(null);return t&&t.forEach((r,d)=>{_[d]=r}),_}e.fromMap=R;function I(t,_){const r=[],d=[];for(let a of t)_.has(a)||r.push(a);for(let a of _)t.has(a)||d.push(a);return{removed:r,added:d}}e.diffSets=I;function y(t,_){const r=[],d=[];for(let[a,l]of t)_.has(a)||r.push(l);for(let[a,l]of _)t.has(a)||d.push(l);return{removed:r,added:d}}e.diffMaps=y;class k{constructor(){this.map=new Map}add(_,r){let d=this.map.get(_);d||(d=new Set,this.map.set(_,d)),d.add(r)}delete(_,r){const d=this.map.get(_);!d||(d.delete(r),d.size===0&&this.map.delete(_))}forEach(_,r){const d=this.map.get(_);!d||d.forEach(r)}}e.SetMap=k}),define(be[51],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function h(R){return(I,y,k)=>{let t=null,_=null;if(typeof k.value=="function"?(t="value",_=k.value):typeof k.get=="function"&&(t="get",_=k.get),!_)throw new Error("not supported");k[t]=R(_,y)}}e.createDecorator=h;function F(R,I,y){let k=null,t=null;if(typeof y.value=="function"?(k="value",t=y.value,t.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof y.get=="function"&&(k="get",t=y.get),!t)throw new Error("not supported");const _=`$memoize$${I}`;y[k]=function(...r){return this.hasOwnProperty(_)||Object.defineProperty(this,_,{configurable:!1,enumerable:!1,writable:!1,value:t.apply(this,r)}),this[_]}}e.memoize=F;function E(R,I,y){return h((k,t)=>{const _=`$debounce$${t}`,r=`$debounce$result$${t}`;return function(...d){this[r]||(this[r]=y?y():void 0),clearTimeout(this[_]),I&&(this[r]=I(this[r],...d),d=[this[r]]),this[_]=setTimeout(()=>{k.apply(this,d),this[r]=y?y():void 0},R)}})}e.debounce=E;function A(R,I,y){return h((k,t)=>{const _=`$throttle$timer$${t}`,r=`$throttle$result$${t}`,d=`$throttle$lastRun$${t}`,a=`$throttle$pending$${t}`;return function(...l){if(this[r]||(this[r]=y?y():void 0),(this[d]===null||this[d]===void 0)&&(this[d]=-Number.MAX_VALUE),I&&(this[r]=I(this[r],...l)),this[a])return;const v=this[d]+R;v<=Date.now()?(this[d]=Date.now(),k.apply(this,[this[r]]),this[r]=y?y():void 0):(this[a]=!0,this[_]=setTimeout(()=>{this[a]=!1,this[d]=Date.now(),k.apply(this,[this[r]]),this[r]=y?y():void 0},v-Date.now()))}})}e.throttle=A}),define(be[16],Ee([0,1,15]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.uniqueFilter=e.distinctES6=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function F(j,le=0){return j[j.length-(1+le)]}e.tail=F;function E(j){if(j.length===0)throw new Error("Invalid tail call");return[j.slice(0,j.length-1),j[j.length-1]]}e.tail2=E;function A(j,le,ae=(ve,Re)=>ve===Re){if(j===le)return!0;if(!j||!le||j.length!==le.length)return!1;for(let ve=0,Re=j.length;ve<Re;ve++)if(!ae(j[ve],le[ve]))return!1;return!0}e.equals=A;function R(j,le,ae){let ve=0,Re=j.length-1;for(;ve<=Re;){const Fe=(ve+Re)/2|0,Ne=ae(j[Fe],le);if(Ne<0)ve=Fe+1;else if(Ne>0)Re=Fe-1;else return Fe}return-(ve+1)}e.binarySearch=R;function I(j,le){let ae=0,ve=j.length;if(ve===0)return 0;for(;ae<ve;){const Re=Math.floor((ae+ve)/2);le(j[Re])?ve=Re:ae=Re+1}return ae}e.findFirstInSorted=I;function y(j,le,ae){if(j=j|0,j>=le.length)throw new TypeError("invalid index");let ve=le[Math.floor(le.length*Math.random())],Re=[],Fe=[],Ne=[];for(let Qe of le){const He=ae(Qe,ve);He<0?Re.push(Qe):He>0?Fe.push(Qe):Ne.push(Qe)}return j<Re.length?y(j,Re,ae):j<Re.length+Ne.length?Ne[0]:y(j-(Re.length+Ne.length),Fe,ae)}e.quickSelect=y;function k(j,le){const ae=[];let ve;for(const Re of j.slice(0).sort(le))!ve||le(ve[0],Re)!==0?(ve=[Re],ae.push(ve)):ve.push(Re);return ae}e.groupBy=k;function t(j,le,ae){const ve=[];function Re(Qe,He,Ke){if(He===0&&Ke.length===0)return;const x=ve[ve.length-1];x&&x.start+x.deleteCount===Qe?(x.deleteCount+=He,x.toInsert.push(...Ke)):ve.push({start:Qe,deleteCount:He,toInsert:Ke})}let Fe=0,Ne=0;for(;;){if(Fe===j.length){Re(Fe,0,le.slice(Ne));break}if(Ne===le.length){Re(Fe,j.length-Fe,[]);break}const Qe=j[Fe],He=le[Ne],Ke=ae(Qe,He);Ke===0?(Fe+=1,Ne+=1):Ke<0?(Re(Fe,1,[]),Fe+=1):Ke>0&&(Re(Fe,0,[He]),Ne+=1)}return ve}e.sortedDiff=t;function _(j,le,ae){const ve=t(j,le,ae),Re=[],Fe=[];for(const Ne of ve)Re.push(...j.slice(Ne.start,Ne.start+Ne.deleteCount)),Fe.push(...Ne.toInsert);return{removed:Re,added:Fe}}e.delta=_;function r(j,le,ae){if(ae===0)return[];const ve=j.slice(0,ae).sort(le);return a(j,le,ve,ae,j.length),ve}e.top=r;function d(j,le,ae,ve,Re){return ae===0?Promise.resolve([]):new Promise((Fe,Ne)=>{(async()=>{const Qe=j.length,He=j.slice(0,ae).sort(le);for(let Ke=ae,x=Math.min(ae+ve,Qe);Ke<Qe;Ke=x,x=Math.min(x+ve,Qe)){if(Ke>ae&&await new Promise(q=>setTimeout(q)),Re&&Re.isCancellationRequested)throw(0,h.canceled)();a(j,le,He,Ke,x)}return He})().then(Fe,Ne)})}e.topAsync=d;function a(j,le,ae,ve,Re){for(const Fe=ae.length;ve<Re;ve++){const Ne=j[ve];if(le(Ne,ae[Fe-1])<0){ae.pop();const Qe=I(ae,He=>le(Ne,He)<0);ae.splice(Qe,0,Ne)}}}function l(j){return j.filter(le=>!!le)}e.coalesce=l;function v(j){let le=0;for(let ae=0;ae<j.length;ae++)j[ae]&&(j[le]=j[ae],le+=1);j.length=le}e.coalesceInPlace=v;function T(j,le,ae){j.splice(ae,0,j.splice(le,1)[0])}e.move=T;function b(j){return!Array.isArray(j)||j.length===0}e.isFalsyOrEmpty=b;function c(j){return Array.isArray(j)&&j.length>0}e.isNonEmptyArray=c;function g(j,le){if(!le)return j.filter((ve,Re)=>j.indexOf(ve)===Re);const ae=Object.create(null);return j.filter(ve=>{const Re=le(ve);return ae[Re]?!1:(ae[Re]=!0,!0)})}e.distinct=g;function S(j){const le=new Set;return j.filter(ae=>le.has(ae)?!1:(le.add(ae),!0))}e.distinctES6=S;function i(j){const le=Object.create(null);return ae=>{const ve=j(ae);return le[ve]?!1:(le[ve]=!0,!0)}}e.uniqueFilter=i;function s(j,le){for(let ae=j.length-1;ae>=0;ae--){const ve=j[ae];if(le(ve))return ae}return-1}e.lastIndex=s;function u(j,le){return j.length>0?j[0]:le}e.firstOrDefault=u;function o(j,le,ae=(ve,Re)=>ve===Re){let ve=0;for(let Re=0,Fe=Math.min(j.length,le.length);Re<Fe&&ae(j[Re],le[Re]);Re++)ve++;return ve}e.commonPrefixLength=o;function f(j){return[].concat(...j)}e.flatten=f;function p(j,le){let ae=typeof le=="number"?j:0;typeof le=="number"?ae=j:(ae=0,le=j);const ve=[];if(ae<=le)for(let Re=ae;Re<le;Re++)ve.push(Re);else for(let Re=ae;Re>le;Re--)ve.push(Re);return ve}e.range=p;function w(j,le,ae){return j.reduce((ve,Re)=>(ve[le(Re)]=ae?ae(Re):Re,ve),Object.create(null))}e.index=w;function C(j,le){return j.push(le),()=>P(j,le)}e.insert=C;function P(j,le){const ae=j.indexOf(le);if(ae>-1)return j.splice(ae,1),le}e.remove=P;function n(j,le,ae){const ve=j.slice(0,le),Re=j.slice(le);return ve.concat(ae,Re)}e.arrayInsert=n;function m(j,le){let ae;if(typeof le=="number"){let ve=le;ae=()=>{const Re=Math.sin(ve++)*179426549;return Re-Math.floor(Re)}}else ae=Math.random;for(let ve=j.length-1;ve>0;ve-=1){const Re=Math.floor(ae()*(ve+1)),Fe=j[ve];j[ve]=j[Re],j[Re]=Fe}}e.shuffle=m;function D(j,le){const ae=j.indexOf(le);ae>-1&&(j.splice(ae,1),j.unshift(le))}e.pushToStart=D;function O(j,le){const ae=j.indexOf(le);ae>-1&&(j.splice(ae,1),j.push(le))}e.pushToEnd=O;function $(j,le){return Array.isArray(j)?j.map(le):le(j)}e.mapArrayOrNot=$;function Q(j){return Array.isArray(j)?j:[j]}e.asArray=Q;function ie(j){return j[Math.floor(Math.random()*j.length)]}e.getRandomElement=ie;function V(j,le){for(const ae of j){const ve=le(ae);if(ve!==void 0)return ve}}e.mapFind=V;function W(j,le,ae){const ve=Y(j,le),Re=j.length,Fe=ae.length;j.length=Re+Fe;for(let Ne=Re-1;Ne>=ve;Ne--)j[Ne+Fe]=j[Ne];for(let Ne=0;Ne<Fe;Ne++)j[Ne+ve]=ae[Ne]}e.insertInto=W;function L(j,le,ae,ve){const Re=Y(j,le),Fe=j.splice(Re,ae);return W(j,Re,ve),Fe}e.splice=L;function Y(j,le){return le<0?Math.max(le+j.length,0):Math.min(le,j.length)}function B(j,le){let ae=Number.MAX_SAFE_INTEGER,ve=0;return j.forEach((Re,Fe)=>{const Ne=le(Re);Ne<ae&&(ae=Ne,ve=Fe)}),ve}e.minIndex=B;function G(j,le){let ae=Number.MIN_SAFE_INTEGER,ve=0;return j.forEach((Re,Fe)=>{const Ne=le(Re);Ne>ae&&(ae=Ne,ve=Fe)}),ve}e.maxIndex=G;class de{constructor(le){this.items=le,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(le){let ae=this.firstIdx;for(;ae<this.items.length&&le(this.items[ae]);)ae++;const ve=ae===this.firstIdx?null:this.items.slice(this.firstIdx,ae);return this.firstIdx=ae,ve}takeFromEndWhile(le){let ae=this.lastIdx;for(;ae>=0&&le(this.items[ae]);)ae--;const ve=ae===this.lastIdx?null:this.items.slice(ae+1,this.lastIdx+1);return this.lastIdx=ae,ve}}e.ArrayQueue=de}),define(be[52],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class h{constructor(E){this._prefix=E,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=h,e.defaultGenerator=new h("id#")}),define(be[102],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var h;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(h=e.ScanError||(e.ScanError={}));var F;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(F=e.SyntaxKind||(e.SyntaxKind={}));var E;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(E=e.ParseErrorCode||(e.ParseErrorCode={}));var A;(function(i){i.DEFAULT={allowTrailingComma:!0}})(A=e.ParseOptions||(e.ParseOptions={}));function R(i,s=!1){let u=0,o=i.length,f="",p=0,w=16,C=0;function P(ie){let V=0,W=0;for(;V<ie;){const L=i.charCodeAt(u);if(L>=48&&L<=57)W=W*16+L-48;else if(L>=65&&L<=70)W=W*16+L-65+10;else if(L>=97&&L<=102)W=W*16+L-97+10;else break;u++,V++}return V<ie&&(W=-1),W}function n(ie){u=ie,f="",p=0,w=16,C=0}function m(){const ie=u;if(i.charCodeAt(u)===48)u++;else for(u++;u<i.length&&k(i.charCodeAt(u));)u++;if(u<i.length&&i.charCodeAt(u)===46)if(u++,u<i.length&&k(i.charCodeAt(u)))for(u++;u<i.length&&k(i.charCodeAt(u));)u++;else return C=3,i.substring(ie,u);let V=u;if(u<i.length&&(i.charCodeAt(u)===69||i.charCodeAt(u)===101))if(u++,(u<i.length&&i.charCodeAt(u)===43||i.charCodeAt(u)===45)&&u++,u<i.length&&k(i.charCodeAt(u))){for(u++;u<i.length&&k(i.charCodeAt(u));)u++;V=u}else C=3;return i.substring(ie,V)}function D(){let ie="",V=u;for(;;){if(u>=o){ie+=i.substring(V,u),C=2;break}const W=i.charCodeAt(u);if(W===34){ie+=i.substring(V,u),u++;break}if(W===92){if(ie+=i.substring(V,u),u++,u>=o){C=2;break}switch(i.charCodeAt(u++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:const Y=P(4);Y>=0?ie+=String.fromCharCode(Y):C=4;break;default:C=5}V=u;continue}if(W>=0&&W<=31)if(y(W)){ie+=i.substring(V,u),C=2;break}else C=6;u++}return ie}function O(){if(f="",C=0,p=u,u>=o)return p=o,w=17;let ie=i.charCodeAt(u);if(I(ie)){do u++,f+=String.fromCharCode(ie),ie=i.charCodeAt(u);while(I(ie));return w=15}if(y(ie))return u++,f+=String.fromCharCode(ie),ie===13&&i.charCodeAt(u)===10&&(u++,f+=`
`),w=14;switch(ie){case 123:return u++,w=1;case 125:return u++,w=2;case 91:return u++,w=3;case 93:return u++,w=4;case 58:return u++,w=6;case 44:return u++,w=5;case 34:return u++,f=D(),w=10;case 47:const V=u-1;if(i.charCodeAt(u+1)===47){for(u+=2;u<o&&!y(i.charCodeAt(u));)u++;return f=i.substring(V,u),w=12}if(i.charCodeAt(u+1)===42){u+=2;const W=o-1;let L=!1;for(;u<W;){if(i.charCodeAt(u)===42&&i.charCodeAt(u+1)===47){u+=2,L=!0;break}u++}return L||(u++,C=1),f=i.substring(V,u),w=13}return f+=String.fromCharCode(ie),u++,w=16;case 45:if(f+=String.fromCharCode(ie),u++,u===o||!k(i.charCodeAt(u)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return f+=m(),w=11;default:for(;u<o&&$(ie);)u++,ie=i.charCodeAt(u);if(p!==u){switch(f=i.substring(p,u),f){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return f+=String.fromCharCode(ie),u++,w=16}}function $(ie){if(I(ie)||y(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function Q(){let ie;do ie=O();while(ie>=12&&ie<=15);return ie}return{setPosition:n,getPosition:()=>u,scan:s?Q:O,getToken:()=>w,getTokenValue:()=>f,getTokenOffset:()=>p,getTokenLength:()=>u-p,getTokenError:()=>C}}e.createScanner=R;function I(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function y(i){return i===10||i===13||i===8232||i===8233}function k(i){return i>=48&&i<=57}var t;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(t||(t={}));function _(i,s){const u=[],o=new Object;let f;const p={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function C(P,n,m,D){p.value=P,p.offset=n,p.length=m,p.type=D,p.colonOffset=void 0,f=p}try{c(i,{onObjectBegin:(P,n)=>{if(s<=P)throw o;f=void 0,w=s>P,u.push("")},onObjectProperty:(P,n,m)=>{if(s<n||(C(P,n,m,"property"),u[u.length-1]=P,s<=n+m))throw o},onObjectEnd:(P,n)=>{if(s<=P)throw o;f=void 0,u.pop()},onArrayBegin:(P,n)=>{if(s<=P)throw o;f=void 0,u.push(0)},onArrayEnd:(P,n)=>{if(s<=P)throw o;f=void 0,u.pop()},onLiteralValue:(P,n,m)=>{if(s<n||(C(P,n,m,S(P)),s<=n+m))throw o},onSeparator:(P,n,m)=>{if(s<=n)throw o;if(P===":"&&f&&f.type==="property")f.colonOffset=n,w=!1,f=void 0;else if(P===","){const D=u[u.length-1];typeof D=="number"?u[u.length-1]=D+1:(w=!0,u[u.length-1]=""),f=void 0}}})}catch(P){if(P!==o)throw P}return{path:u,previousNode:f,isAtPropertyKey:w,matches:P=>{let n=0;for(let m=0;n<P.length&&m<u.length;m++)if(P[n]===u[m]||P[n]==="*")n++;else if(P[n]!=="**")return!1;return n===P.length}}}e.getLocation=_;function r(i,s=[],u=A.DEFAULT){let o=null,f=[];const p=[];function w(P){Array.isArray(f)?f.push(P):o!==null&&(f[o]=P)}return c(i,{onObjectBegin:()=>{const P={};w(P),p.push(f),f=P,o=null},onObjectProperty:P=>{o=P},onObjectEnd:()=>{f=p.pop()},onArrayBegin:()=>{const P=[];w(P),p.push(f),f=P,o=null},onArrayEnd:()=>{f=p.pop()},onLiteralValue:w,onError:(P,n,m)=>{s.push({error:P,offset:n,length:m})}},u),f[0]}e.parse=r;function d(i,s=[],u=A.DEFAULT){let o={type:"array",offset:-1,length:-1,children:[],parent:void 0};function f(P){o.type==="property"&&(o.length=P-o.offset,o=o.parent)}function p(P){return o.children.push(P),P}c(i,{onObjectBegin:P=>{o=p({type:"object",offset:P,length:-1,parent:o,children:[]})},onObjectProperty:(P,n,m)=>{o=p({type:"property",offset:n,length:-1,parent:o,children:[]}),o.children.push({type:"string",value:P,offset:n,length:m,parent:o})},onObjectEnd:(P,n)=>{o.length=P+n-o.offset,o=o.parent,f(P+n)},onArrayBegin:(P,n)=>{o=p({type:"array",offset:P,length:-1,parent:o,children:[]})},onArrayEnd:(P,n)=>{o.length=P+n-o.offset,o=o.parent,f(P+n)},onLiteralValue:(P,n,m)=>{p({type:S(P),offset:n,length:m,parent:o,value:P}),f(n+m)},onSeparator:(P,n,m)=>{o.type==="property"&&(P===":"?o.colonOffset=n:P===","&&f(n))},onError:(P,n,m)=>{s.push({error:P,offset:n,length:m})}},u);const C=o.children[0];return C&&delete C.parent,C}e.parseTree=d;function a(i,s){if(!i)return;let u=i;for(let o of s)if(typeof o=="string"){if(u.type!=="object"||!Array.isArray(u.children))return;let f=!1;for(const p of u.children)if(Array.isArray(p.children)&&p.children[0].value===o){u=p.children[1],f=!0;break}if(!f)return}else{const f=o;if(u.type!=="array"||f<0||!Array.isArray(u.children)||f>=u.children.length)return;u=u.children[f]}return u}e.findNodeAtLocation=a;function l(i){if(!i.parent||!i.parent.children)return[];const s=l(i.parent);if(i.parent.type==="property"){const u=i.parent.children[0].value;s.push(u)}else if(i.parent.type==="array"){const u=i.parent.children.indexOf(i);u!==-1&&s.push(u)}return s}e.getNodePath=l;function v(i){switch(i.type){case"array":return i.children.map(v);case"object":const s=Object.create(null);for(let u of i.children){const o=u.children[1];o&&(s[u.children[0].value]=v(o))}return s;case"null":case"string":case"number":case"boolean":return i.value;default:return}}e.getNodeValue=v;function T(i,s,u=!1){return s>=i.offset&&s<i.offset+i.length||u&&s===i.offset+i.length}e.contains=T;function b(i,s,u=!1){if(T(i,s,u)){const o=i.children;if(Array.isArray(o))for(let f=0;f<o.length&&o[f].offset<=s;f++){const p=b(o[f],s,u);if(p)return p}return i}}e.findNodeAtOffset=b;function c(i,s,u=A.DEFAULT){const o=R(i,!1);function f(ae){return ae?()=>ae(o.getTokenOffset(),o.getTokenLength()):()=>!0}function p(ae){return ae?ve=>ae(ve,o.getTokenOffset(),o.getTokenLength()):()=>!0}const w=f(s.onObjectBegin),C=p(s.onObjectProperty),P=f(s.onObjectEnd),n=f(s.onArrayBegin),m=f(s.onArrayEnd),D=p(s.onLiteralValue),O=p(s.onSeparator),$=f(s.onComment),Q=p(s.onError),ie=u&&u.disallowComments,V=u&&u.allowTrailingComma;function W(){for(;;){const ae=o.scan();switch(o.getTokenError()){case 4:L(14);break;case 5:L(15);break;case 3:L(13);break;case 1:ie||L(11);break;case 2:L(12);break;case 6:L(16);break}switch(ae){case 12:case 13:ie?L(10):$();break;case 16:L(1);break;case 15:case 14:break;default:return ae}}}function L(ae,ve=[],Re=[]){if(Q(ae),ve.length+Re.length>0){let Fe=o.getToken();for(;Fe!==17;){if(ve.indexOf(Fe)!==-1){W();break}else if(Re.indexOf(Fe)!==-1)break;Fe=W()}}}function Y(ae){const ve=o.getTokenValue();return ae?D(ve):C(ve),W(),!0}function B(){switch(o.getToken()){case 11:let ae=0;try{ae=JSON.parse(o.getTokenValue()),typeof ae!="number"&&(L(2),ae=0)}catch(ve){L(2)}D(ae);break;case 7:D(null);break;case 8:D(!0);break;case 9:D(!1);break;default:return!1}return W(),!0}function G(){return o.getToken()!==10?(L(3,[],[2,5]),!1):(Y(!1),o.getToken()===6?(O(":"),W(),le()||L(4,[],[2,5])):L(5,[],[2,5]),!0)}function de(){w(),W();let ae=!1;for(;o.getToken()!==2&&o.getToken()!==17;){if(o.getToken()===5){if(ae||L(4,[],[]),O(","),W(),o.getToken()===2&&V)break}else ae&&L(6,[],[]);G()||L(4,[],[2,5]),ae=!0}return P(),o.getToken()!==2?L(7,[2],[]):W(),!0}function j(){n(),W();let ae=!1;for(;o.getToken()!==4&&o.getToken()!==17;){if(o.getToken()===5){if(ae||L(4,[],[]),O(","),W(),o.getToken()===4&&V)break}else ae&&L(6,[],[]);le()||L(4,[],[4,5]),ae=!0}return m(),o.getToken()!==4?L(8,[4],[]):W(),!0}function le(){switch(o.getToken()){case 3:return j();case 1:return de();case 10:return Y(!0);default:return B()}}return W(),o.getToken()===17?u.allowEmptyContent?!0:(L(4,[],[]),!1):le()?(o.getToken()!==17&&L(9,[],[]),!0):(L(4,[],[]),!1)}e.visit=c;function g(i,s){let u=R(i),o=[],f,p=0,w;do switch(w=u.getPosition(),f=u.scan(),f){case 12:case 13:case 17:p!==w&&o.push(i.substring(p,w)),s!==void 0&&o.push(u.getTokenValue().replace(/[^\r\n]/g,s)),p=u.getPosition();break}while(f!==17);return o.join("")}e.stripComments=g;function S(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=S}),define(be[103],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class h{constructor(E){this.executor=E,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(E){this._error=E}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(E){return new h(()=>E(this.getValue()))}}e.Lazy=h}),function(re,e){typeof exports=="object"&&typeof module!="undefined"?module.exports=e():typeof define=="function"&&define.amd?define("vs/base/common/marked/marked",e):(re=typeof globalThis!="undefined"?globalThis:re||self,re.marked=e())}(this,function(){"use strict";function re(Pe,ye){for(var ke=0;ke<ye.length;ke++){var X=ye[ke];X.enumerable=X.enumerable||!1,X.configurable=!0,"value"in X&&(X.writable=!0),Object.defineProperty(Pe,X.key,X)}}function e(Pe,ye,ke){return ye&&re(Pe.prototype,ye),ke&&re(Pe,ke),Pe}function h(Pe,ye){if(!!Pe){if(typeof Pe=="string")return F(Pe,ye);var ke=Object.prototype.toString.call(Pe).slice(8,-1);if(ke==="Object"&&Pe.constructor&&(ke=Pe.constructor.name),ke==="Map"||ke==="Set")return Array.from(Pe);if(ke==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(ke))return F(Pe,ye)}}function F(Pe,ye){(ye==null||ye>Pe.length)&&(ye=Pe.length);for(var ke=0,X=new Array(ye);ke<ye;ke++)X[ke]=Pe[ke];return X}function E(Pe,ye){var ke=typeof Symbol!="undefined"&&Pe[Symbol.iterator]||Pe["@@iterator"];if(ke)return(ke=ke.call(Pe)).next.bind(ke);if(Array.isArray(Pe)||(ke=h(Pe))||ye&&Pe&&typeof Pe.length=="number"){ke&&(Pe=ke);var X=0;return function(){return X>=Pe.length?{done:!0}:{done:!1,value:Pe[X++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}var A={exports:{}};function R(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}function I(Pe){A.exports.defaults=Pe}A.exports={defaults:R(),getDefaults:R,changeDefaults:I};var y=/[&<>"']/,k=/[&<>"']/g,t=/[<>"']|&(?!#?\w+;)/,_=/[<>"']|&(?!#?\w+;)/g,r={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},d=function(ye){return r[ye]};function a(Pe,ye){if(ye){if(y.test(Pe))return Pe.replace(k,d)}else if(t.test(Pe))return Pe.replace(_,d);return Pe}var l=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(Pe){return Pe.replace(l,function(ye,ke){return ke=ke.toLowerCase(),ke==="colon"?":":ke.charAt(0)==="#"?ke.charAt(1)==="x"?String.fromCharCode(parseInt(ke.substring(2),16)):String.fromCharCode(+ke.substring(1)):""})}var T=/(^|[^\[])\^/g;function b(Pe,ye){Pe=Pe.source||Pe,ye=ye||"";var ke={replace:function(ue,ge){return ge=ge.source||ge,ge=ge.replace(T,"$1"),Pe=Pe.replace(ue,ge),ke},getRegex:function(){return new RegExp(Pe,ye)}};return ke}var c=/[^\w:]/g,g=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function S(Pe,ye,ke){if(Pe){var X;try{X=decodeURIComponent(v(ke)).replace(c,"").toLowerCase()}catch(ue){return null}if(X.indexOf("javascript:")===0||X.indexOf("vbscript:")===0||X.indexOf("data:")===0)return null}ye&&!g.test(ke)&&(ke=f(ye,ke));try{ke=encodeURI(ke).replace(/%25/g,"%")}catch(ue){return null}return ke}var i={},s=/^[^:]+:\/*[^/]*$/,u=/^([^:]+:)[\s\S]*$/,o=/^([^:]+:\/*[^/]*)[\s\S]*$/;function f(Pe,ye){i[" "+Pe]||(s.test(Pe)?i[" "+Pe]=Pe+"/":i[" "+Pe]=P(Pe,"/",!0)),Pe=i[" "+Pe];var ke=Pe.indexOf(":")===-1;return ye.substring(0,2)==="//"?ke?ye:Pe.replace(u,"$1")+ye:ye.charAt(0)==="/"?ke?ye:Pe.replace(o,"$1")+ye:Pe+ye}var p={exec:function(){}};function w(Pe){for(var ye=1,ke,X;ye<arguments.length;ye++){ke=arguments[ye];for(X in ke)Object.prototype.hasOwnProperty.call(ke,X)&&(Pe[X]=ke[X])}return Pe}function C(Pe,ye){var ke=Pe.replace(/\|/g,function(ge,me,Ie){for(var Ue=!1,Me=me;--Me>=0&&Ie[Me]==="\\";)Ue=!Ue;return Ue?"|":" |"}),X=ke.split(/ \|/),ue=0;if(X[0].trim()||X.shift(),X[X.length-1].trim()||X.pop(),X.length>ye)X.splice(ye);else for(;X.length<ye;)X.push("");for(;ue<X.length;ue++)X[ue]=X[ue].trim().replace(/\\\|/g,"|");return X}function P(Pe,ye,ke){var X=Pe.length;if(X===0)return"";for(var ue=0;ue<X;){var ge=Pe.charAt(X-ue-1);if(ge===ye&&!ke)ue++;else if(ge!==ye&&ke)ue++;else break}return Pe.substr(0,X-ue)}function n(Pe,ye){if(Pe.indexOf(ye[1])===-1)return-1;for(var ke=Pe.length,X=0,ue=0;ue<ke;ue++)if(Pe[ue]==="\\")ue++;else if(Pe[ue]===ye[0])X++;else if(Pe[ue]===ye[1]&&(X--,X<0))return ue;return-1}function m(Pe){Pe&&Pe.sanitize&&!Pe.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function D(Pe,ye){if(ye<1)return"";for(var ke="";ye>1;)ye&1&&(ke+=Pe),ye>>=1,Pe+=Pe;return ke+Pe}var O={escape:a,unescape:v,edit:b,cleanUrl:S,resolveUrl:f,noopTest:p,merge:w,splitCells:C,rtrim:P,findClosingBracket:n,checkSanitizeDeprecation:m,repeatString:D},$=A.exports.defaults,Q=O.rtrim,ie=O.splitCells,V=O.escape,W=O.findClosingBracket;function L(Pe,ye,ke,X){var ue=ye.href,ge=ye.title?V(ye.title):null,me=Pe[1].replace(/\\([\[\]])/g,"$1");return Pe[0].charAt(0)!=="!"?(X.state.inLink=!0,{type:"link",raw:ke,href:ue,title:ge,text:me,tokens:X.inlineTokens(me,[])}):{type:"image",raw:ke,href:ue,title:ge,text:V(me)}}function Y(Pe,ye){var ke=Pe.match(/^(\s+)(?:```)/);if(ke===null)return ye;var X=ke[1];return ye.split(`
`).map(function(ue){var ge=ue.match(/^\s+/);if(ge===null)return ue;var me=ge[0];return me.length>=X.length?ue.slice(X.length):ue}).join(`
`)}var B=function(){function Pe(ke){this.options=ke||$}var ye=Pe.prototype;return ye.space=function(X){var ue=this.rules.block.newline.exec(X);if(ue)return ue[0].length>1?{type:"space",raw:ue[0]}:{raw:`
`}},ye.code=function(X){var ue=this.rules.block.code.exec(X);if(ue){var ge=ue[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:ue[0],codeBlockStyle:"indented",text:this.options.pedantic?ge:Q(ge,`
`)}}},ye.fences=function(X){var ue=this.rules.block.fences.exec(X);if(ue){var ge=ue[0],me=Y(ge,ue[3]||"");return{type:"code",raw:ge,lang:ue[2]?ue[2].trim():ue[2],text:me}}},ye.heading=function(X){var ue=this.rules.block.heading.exec(X);if(ue){var ge=ue[2].trim();if(/#$/.test(ge)){var me=Q(ge,"#");(this.options.pedantic||!me||/ $/.test(me))&&(ge=me.trim())}var Ie={type:"heading",raw:ue[0],depth:ue[1].length,text:ge,tokens:[]};return this.lexer.inline(Ie.text,Ie.tokens),Ie}},ye.hr=function(X){var ue=this.rules.block.hr.exec(X);if(ue)return{type:"hr",raw:ue[0]}},ye.blockquote=function(X){var ue=this.rules.block.blockquote.exec(X);if(ue){var ge=ue[0].replace(/^ *> ?/gm,"");return{type:"blockquote",raw:ue[0],tokens:this.lexer.blockTokens(ge,[]),text:ge}}},ye.list=function(X){var ue=this.rules.block.list.exec(X);if(ue){var ge,me,Ie,Ue,Me,je,Je,te,pe,oe,U=ue[1].trim(),De=U.length>1,Se={type:"list",raw:"",ordered:De,start:De?+U.slice(0,-1):"",loose:!1,items:[]};U=De?"\\d{1,9}\\"+U.slice(-1):"\\"+U,this.options.pedantic&&(U=De?U:"[*+-]");for(var qe=new RegExp("^( {0,3}"+U+")((?: [^\\n]*| *)(?:\\n[^\\n]*)*(?:\\n|$))");X&&!(this.rules.block.hr.test(X)||!(ue=qe.exec(X)));){pe=ue[2].split(`
`),this.options.pedantic?(Ue=2,oe=pe[0].trimLeft()):(Ue=ue[2].search(/[^ ]/),Ue=ue[1].length+(Ue>4?1:Ue),oe=pe[0].slice(Ue-ue[1].length)),je=!1,ge=ue[0],!pe[0]&&/^ *$/.test(pe[1])&&(ge=ue[1]+pe.slice(0,2).join(`
`)+`
`,Se.loose=!0,pe=[]);var ze=new RegExp("^ {0,"+Math.min(3,Ue-1)+"}(?:[*+-]|\\d{1,9}[.)])");for(Me=1;Me<pe.length;Me++){if(te=pe[Me],this.options.pedantic&&(te=te.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),ze.test(te)){ge=ue[1]+pe.slice(0,Me).join(`
`)+`
`;break}if(!je){te.trim()||(je=!0),te.search(/[^ ]/)>=Ue?oe+=`
`+te.slice(Ue):oe+=`
`+te;continue}if(te.search(/[^ ]/)>=Ue||!te.trim()){oe+=`
`+te.slice(Ue);continue}else{ge=ue[1]+pe.slice(0,Me).join(`
`)+`
`;break}}Se.loose||(Je?Se.loose=!0:/\n *\n *$/.test(ge)&&(Je=!0)),this.options.gfm&&(me=/^\[[ xX]\] /.exec(oe),me&&(Ie=me[0]!=="[ ] ",oe=oe.replace(/^\[[ xX]\] +/,""))),Se.items.push({type:"list_item",raw:ge,task:!!me,checked:Ie,loose:!1,text:oe}),Se.raw+=ge,X=X.slice(ge.length)}Se.items[Se.items.length-1].raw=ge.trimRight(),Se.items[Se.items.length-1].text=oe.trimRight(),Se.raw=Se.raw.trimRight();var it=Se.items.length;for(Me=0;Me<it;Me++)this.lexer.state.top=!1,Se.items[Me].tokens=this.lexer.blockTokens(Se.items[Me].text,[]),Se.items[Me].tokens.some(function(vt){return vt.type==="space"})&&(Se.loose=!0,Se.items[Me].loose=!0);return Se}},ye.html=function(X){var ue=this.rules.block.html.exec(X);if(ue){var ge={type:"html",raw:ue[0],pre:!this.options.sanitizer&&(ue[1]==="pre"||ue[1]==="script"||ue[1]==="style"),text:ue[0]};return this.options.sanitize&&(ge.type="paragraph",ge.text=this.options.sanitizer?this.options.sanitizer(ue[0]):V(ue[0]),ge.tokens=[],this.lexer.inline(ge.text,ge.tokens)),ge}},ye.def=function(X){var ue=this.rules.block.def.exec(X);if(ue){ue[3]&&(ue[3]=ue[3].substring(1,ue[3].length-1));var ge=ue[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:ge,raw:ue[0],href:ue[2],title:ue[3]}}},ye.table=function(X){var ue=this.rules.block.table.exec(X);if(ue){var ge={type:"table",header:ie(ue[1]).map(function(Je){return{text:Je}}),align:ue[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:ue[3]?ue[3].replace(/\n$/,"").split(`
`):[]};if(ge.header.length===ge.align.length){ge.raw=ue[0];var me=ge.align.length,Ie,Ue,Me,je;for(Ie=0;Ie<me;Ie++)/^ *-+: *$/.test(ge.align[Ie])?ge.align[Ie]="right":/^ *:-+: *$/.test(ge.align[Ie])?ge.align[Ie]="center":/^ *:-+ *$/.test(ge.align[Ie])?ge.align[Ie]="left":ge.align[Ie]=null;for(me=ge.rows.length,Ie=0;Ie<me;Ie++)ge.rows[Ie]=ie(ge.rows[Ie],ge.header.length).map(function(Je){return{text:Je}});for(me=ge.header.length,Ue=0;Ue<me;Ue++)ge.header[Ue].tokens=[],this.lexer.inlineTokens(ge.header[Ue].text,ge.header[Ue].tokens);for(me=ge.rows.length,Ue=0;Ue<me;Ue++)for(je=ge.rows[Ue],Me=0;Me<je.length;Me++)je[Me].tokens=[],this.lexer.inlineTokens(je[Me].text,je[Me].tokens);return ge}}},ye.lheading=function(X){var ue=this.rules.block.lheading.exec(X);if(ue){var ge={type:"heading",raw:ue[0],depth:ue[2].charAt(0)==="="?1:2,text:ue[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.paragraph=function(X){var ue=this.rules.block.paragraph.exec(X);if(ue){var ge={type:"paragraph",raw:ue[0],text:ue[1].charAt(ue[1].length-1)===`
`?ue[1].slice(0,-1):ue[1],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.text=function(X){var ue=this.rules.block.text.exec(X);if(ue){var ge={type:"text",raw:ue[0],text:ue[0],tokens:[]};return this.lexer.inline(ge.text,ge.tokens),ge}},ye.escape=function(X){var ue=this.rules.inline.escape.exec(X);if(ue)return{type:"escape",raw:ue[0],text:V(ue[1])}},ye.tag=function(X){var ue=this.rules.inline.tag.exec(X);if(ue)return!this.lexer.state.inLink&&/^<a /i.test(ue[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(ue[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(ue[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(ue[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:ue[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ue[0]):V(ue[0]):ue[0]}},ye.link=function(X){var ue=this.rules.inline.link.exec(X);if(ue){var ge=ue[2].trim();if(!this.options.pedantic&&/^</.test(ge)){if(!/>$/.test(ge))return;var me=Q(ge.slice(0,-1),"\\");if((ge.length-me.length)%2==0)return}else{var Ie=W(ue[2],"()");if(Ie>-1){var Ue=ue[0].indexOf("!")===0?5:4,Me=Ue+ue[1].length+Ie;ue[2]=ue[2].substring(0,Ie),ue[0]=ue[0].substring(0,Me).trim(),ue[3]=""}}var je=ue[2],Je="";if(this.options.pedantic){var te=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(je);te&&(je=te[1],Je=te[3])}else Je=ue[3]?ue[3].slice(1,-1):"";return je=je.trim(),/^</.test(je)&&(this.options.pedantic&&!/>$/.test(ge)?je=je.slice(1):je=je.slice(1,-1)),L(ue,{href:je&&je.replace(this.rules.inline._escapes,"$1"),title:Je&&Je.replace(this.rules.inline._escapes,"$1")},ue[0],this.lexer)}},ye.reflink=function(X,ue){var ge;if((ge=this.rules.inline.reflink.exec(X))||(ge=this.rules.inline.nolink.exec(X))){var me=(ge[2]||ge[1]).replace(/\s+/g," ");if(me=ue[me.toLowerCase()],!me||!me.href){var Ie=ge[0].charAt(0);return{type:"text",raw:Ie,text:Ie}}return L(ge,me,ge[0],this.lexer)}},ye.emStrong=function(X,ue,ge){ge===void 0&&(ge="");var me=this.rules.inline.emStrong.lDelim.exec(X);if(!!me&&!(me[3]&&ge.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u08A0-\u08B4\u08B6-\u08C7\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u170C\u170E-\u1711\u1720-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4B\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2C2E\u2C30-\u2C5E\u2C60-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\u9FFC\uA000-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7BF\uA7C2-\uA7CA\uA7F5-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEC0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82C[\uDC00-\uDD1E\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDD\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF34\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Ie=me[1]||me[2]||"";if(!Ie||Ie&&(ge===""||this.rules.inline.punctuation.exec(ge))){var Ue=me[0].length-1,Me,je,Je=Ue,te=0,pe=me[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(pe.lastIndex=0,ue=ue.slice(-1*X.length+Ue);(me=pe.exec(ue))!=null;)if(Me=me[1]||me[2]||me[3]||me[4]||me[5]||me[6],!!Me){if(je=Me.length,me[3]||me[4]){Je+=je;continue}else if((me[5]||me[6])&&Ue%3&&!((Ue+je)%3)){te+=je;continue}if(Je-=je,!(Je>0)){if(je=Math.min(je,je+Je+te),Math.min(Ue,je)%2){var oe=X.slice(1,Ue+me.index+je);return{type:"em",raw:X.slice(0,Ue+me.index+je+1),text:oe,tokens:this.lexer.inlineTokens(oe,[])}}var U=X.slice(2,Ue+me.index+je-1);return{type:"strong",raw:X.slice(0,Ue+me.index+je+1),text:U,tokens:this.lexer.inlineTokens(U,[])}}}}}},ye.codespan=function(X){var ue=this.rules.inline.code.exec(X);if(ue){var ge=ue[2].replace(/\n/g," "),me=/[^ ]/.test(ge),Ie=/^ /.test(ge)&&/ $/.test(ge);return me&&Ie&&(ge=ge.substring(1,ge.length-1)),ge=V(ge,!0),{type:"codespan",raw:ue[0],text:ge}}},ye.br=function(X){var ue=this.rules.inline.br.exec(X);if(ue)return{type:"br",raw:ue[0]}},ye.del=function(X){var ue=this.rules.inline.del.exec(X);if(ue)return{type:"del",raw:ue[0],text:ue[2],tokens:this.lexer.inlineTokens(ue[2],[])}},ye.autolink=function(X,ue){var ge=this.rules.inline.autolink.exec(X);if(ge){var me,Ie;return ge[2]==="@"?(me=V(this.options.mangle?ue(ge[1]):ge[1]),Ie="mailto:"+me):(me=V(ge[1]),Ie=me),{type:"link",raw:ge[0],text:me,href:Ie,tokens:[{type:"text",raw:me,text:me}]}}},ye.url=function(X,ue){var ge;if(ge=this.rules.inline.url.exec(X)){var me,Ie;if(ge[2]==="@")me=V(this.options.mangle?ue(ge[0]):ge[0]),Ie="mailto:"+me;else{var Ue;do Ue=ge[0],ge[0]=this.rules.inline._backpedal.exec(ge[0])[0];while(Ue!==ge[0]);me=V(ge[0]),ge[1]==="www."?Ie="http://"+me:Ie=me}return{type:"link",raw:ge[0],text:me,href:Ie,tokens:[{type:"text",raw:me,text:me}]}}},ye.inlineText=function(X,ue){var ge=this.rules.inline.text.exec(X);if(ge){var me;return this.lexer.state.inRawBlock?me=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(ge[0]):V(ge[0]):ge[0]:me=V(this.options.smartypants?ue(ge[0]):ge[0]),{type:"text",raw:ge[0],text:me}}},Pe}(),G=O.noopTest,de=O.edit,j=O.merge,le={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:- *){3,}|(?:_ *){3,}|(?:\* *){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)( [^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *\n? *<?([^\s>]+)>?(?:(?: +\n? *| *\n *)(title))? *(?:\n+|$)/,table:G,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html| +\n)[^\n]+)*)/,text:/^[^\n]+/};le._label=/(?!\s*\])(?:\\[\[\]]|[^\[\]])+/,le._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,le.def=de(le.def).replace("label",le._label).replace("title",le._title).getRegex(),le.bullet=/(?:[*+-]|\d{1,9}[.)])/,le.listItemStart=de(/^( *)(bull) */).replace("bull",le.bullet).getRegex(),le.list=de(le.list).replace(/bull/g,le.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+le.def.source+")").getRegex(),le._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",le._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,le.html=de(le.html,"i").replace("comment",le._comment).replace("tag",le._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),le.paragraph=de(le._paragraph).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.blockquote=de(le.blockquote).replace("paragraph",le.paragraph).getRegex(),le.normal=j({},le),le.gfm=j({},le.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)\\|?(?:\\n *((?:(?!\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),le.gfm.table=de(le.gfm.table).replace("hr",le.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",le._tag).getRegex(),le.pedantic=j({},le.normal,{html:de(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",le._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:G,paragraph:de(le.normal._paragraph).replace("hr",le.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",le.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ae={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:G,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(?!\s*\])((?:\\[\[\]]?|[^\[\]\\])+)\]/,nolink:/^!?\[(?!\s*\])((?:\[[^\[\]]*\]|\\[\[\]]|[^\[\]])*)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/\_\_[^_*]*?\*[^_*]*?\_\_|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/\*\*[^_*]*?\_[^_*]*?\*\*|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:G,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ae._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ae.punctuation=de(ae.punctuation).replace(/punctuation/g,ae._punctuation).getRegex(),ae.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ae.escapedEmSt=/\\\*|\\_/g,ae._comment=de(le._comment).replace("(?:-->|$)","-->").getRegex(),ae.emStrong.lDelim=de(ae.emStrong.lDelim).replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimAst=de(ae.emStrong.rDelimAst,"g").replace(/punct/g,ae._punctuation).getRegex(),ae.emStrong.rDelimUnd=de(ae.emStrong.rDelimUnd,"g").replace(/punct/g,ae._punctuation).getRegex(),ae._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ae._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ae._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ae.autolink=de(ae.autolink).replace("scheme",ae._scheme).replace("email",ae._email).getRegex(),ae._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ae.tag=de(ae.tag).replace("comment",ae._comment).replace("attribute",ae._attribute).getRegex(),ae._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ae._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ae._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ae.link=de(ae.link).replace("label",ae._label).replace("href",ae._href).replace("title",ae._title).getRegex(),ae.reflink=de(ae.reflink).replace("label",ae._label).getRegex(),ae.reflinkSearch=de(ae.reflinkSearch,"g").replace("reflink",ae.reflink).replace("nolink",ae.nolink).getRegex(),ae.normal=j({},ae),ae.pedantic=j({},ae.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:de(/^!?\[(label)\]\((.*?)\)/).replace("label",ae._label).getRegex(),reflink:de(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ae._label).getRegex()}),ae.gfm=j({},ae.normal,{escape:de(ae.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ae.gfm.url=de(ae.gfm.url,"i").replace("email",ae.gfm._extended_email).getRegex(),ae.breaks=j({},ae.gfm,{br:de(ae.br).replace("{2,}","*").getRegex(),text:de(ae.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});var ve={block:le,inline:ae},Re=B,Fe=A.exports.defaults,Ne=ve.block,Qe=ve.inline,He=O.repeatString;function Ke(Pe){return Pe.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function x(Pe){var ye="",ke,X,ue=Pe.length;for(ke=0;ke<ue;ke++)X=Pe.charCodeAt(ke),Math.random()>.5&&(X="x"+X.toString(16)),ye+="&#"+X+";";return ye}var q=function(){function Pe(ke){this.tokens=[],this.tokens.links=Object.create(null),this.options=ke||Fe,this.options.tokenizer=this.options.tokenizer||new Re,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var X={block:Ne.normal,inline:Qe.normal};this.options.pedantic?(X.block=Ne.pedantic,X.inline=Qe.pedantic):this.options.gfm&&(X.block=Ne.gfm,this.options.breaks?X.inline=Qe.breaks:X.inline=Qe.gfm),this.tokenizer.rules=X}Pe.lex=function(X,ue){var ge=new Pe(ue);return ge.lex(X)},Pe.lexInline=function(X,ue){var ge=new Pe(ue);return ge.inlineTokens(X)};var ye=Pe.prototype;return ye.lex=function(X){X=X.replace(/\r\n|\r/g,`
`).replace(/\t/g,"    "),this.blockTokens(X,this.tokens);for(var ue;ue=this.inlineQueue.shift();)this.inlineTokens(ue.src,ue.tokens);return this.tokens},ye.blockTokens=function(X,ue){var ge=this;ue===void 0&&(ue=[]),this.options.pedantic&&(X=X.replace(/^ +$/gm,""));for(var me,Ie,Ue,Me;X;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Je){return(me=Je.call({lexer:ge},X,ue))?(X=X.substring(me.raw.length),ue.push(me),!0):!1}))){if(me=this.tokenizer.space(X)){X=X.substring(me.raw.length),me.type&&ue.push(me);continue}if(me=this.tokenizer.code(X)){X=X.substring(me.raw.length),Ie=ue[ue.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(me);continue}if(me=this.tokenizer.fences(X)){X=X.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.heading(X)){X=X.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.hr(X)){X=X.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.blockquote(X)){X=X.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.list(X)){X=X.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.html(X)){X=X.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.def(X)){X=X.substring(me.raw.length),Ie=ue[ue.length-1],Ie&&(Ie.type==="paragraph"||Ie.type==="text")?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.raw,this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):this.tokens.links[me.tag]||(this.tokens.links[me.tag]={href:me.href,title:me.title});continue}if(me=this.tokenizer.table(X)){X=X.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.lheading(X)){X=X.substring(me.raw.length),ue.push(me);continue}if(Ue=X,this.options.extensions&&this.options.extensions.startBlock&&function(){var Je=Infinity,te=X.slice(1),pe=void 0;ge.options.extensions.startBlock.forEach(function(oe){pe=oe.call({lexer:this},te),typeof pe=="number"&&pe>=0&&(Je=Math.min(Je,pe))}),Je<Infinity&&Je>=0&&(Ue=X.substring(0,Je+1))}(),this.state.top&&(me=this.tokenizer.paragraph(Ue))){Ie=ue[ue.length-1],Me&&Ie.type==="paragraph"?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(me),Me=Ue.length!==X.length,X=X.substring(me.raw.length);continue}if(me=this.tokenizer.text(X)){X=X.substring(me.raw.length),Ie=ue[ue.length-1],Ie&&Ie.type==="text"?(Ie.raw+=`
`+me.raw,Ie.text+=`
`+me.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Ie.text):ue.push(me);continue}if(X){var je="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(je);break}else throw new Error(je)}}return this.state.top=!0,ue},ye.inline=function(X,ue){this.inlineQueue.push({src:X,tokens:ue})},ye.inlineTokens=function(X,ue){var ge=this;ue===void 0&&(ue=[]);var me,Ie,Ue,Me=X,je,Je,te;if(this.tokens.links){var pe=Object.keys(this.tokens.links);if(pe.length>0)for(;(je=this.tokenizer.rules.inline.reflinkSearch.exec(Me))!=null;)pe.includes(je[0].slice(je[0].lastIndexOf("[")+1,-1))&&(Me=Me.slice(0,je.index)+"["+He("a",je[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(je=this.tokenizer.rules.inline.blockSkip.exec(Me))!=null;)Me=Me.slice(0,je.index)+"["+He("a",je[0].length-2)+"]"+Me.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(je=this.tokenizer.rules.inline.escapedEmSt.exec(Me))!=null;)Me=Me.slice(0,je.index)+"++"+Me.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;X;)if(Je||(te=""),Je=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(U){return(me=U.call({lexer:ge},X,ue))?(X=X.substring(me.raw.length),ue.push(me),!0):!1}))){if(me=this.tokenizer.escape(X)){X=X.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.tag(X)){X=X.substring(me.raw.length),Ie=ue[ue.length-1],Ie&&me.type==="text"&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ue.push(me);continue}if(me=this.tokenizer.link(X)){X=X.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.reflink(X,this.tokens.links)){X=X.substring(me.raw.length),Ie=ue[ue.length-1],Ie&&me.type==="text"&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ue.push(me);continue}if(me=this.tokenizer.emStrong(X,Me,te)){X=X.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.codespan(X)){X=X.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.br(X)){X=X.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.del(X)){X=X.substring(me.raw.length),ue.push(me);continue}if(me=this.tokenizer.autolink(X,x)){X=X.substring(me.raw.length),ue.push(me);continue}if(!this.state.inLink&&(me=this.tokenizer.url(X,x))){X=X.substring(me.raw.length),ue.push(me);continue}if(Ue=X,this.options.extensions&&this.options.extensions.startInline&&function(){var U=Infinity,De=X.slice(1),Se=void 0;ge.options.extensions.startInline.forEach(function(qe){Se=qe.call({lexer:this},De),typeof Se=="number"&&Se>=0&&(U=Math.min(U,Se))}),U<Infinity&&U>=0&&(Ue=X.substring(0,U+1))}(),me=this.tokenizer.inlineText(Ue,Ke)){X=X.substring(me.raw.length),me.raw.slice(-1)!=="_"&&(te=me.raw.slice(-1)),Je=!0,Ie=ue[ue.length-1],Ie&&Ie.type==="text"?(Ie.raw+=me.raw,Ie.text+=me.text):ue.push(me);continue}if(X){var oe="Infinite loop on byte: "+X.charCodeAt(0);if(this.options.silent){console.error(oe);break}else throw new Error(oe)}}return ue},e(Pe,null,[{key:"rules",get:function(){return{block:Ne,inline:Qe}}}]),Pe}(),Z=A.exports.defaults,se=O.cleanUrl,H=O.escape,ne=function(){function Pe(ke){this.options=ke||Z}var ye=Pe.prototype;return ye.code=function(X,ue,ge){var me=(ue||"").match(/\S*/)[0];if(this.options.highlight){var Ie=this.options.highlight(X,me);Ie!=null&&Ie!==X&&(ge=!0,X=Ie)}return X=X.replace(/\n$/,"")+`
`,me?'<pre><code class="'+this.options.langPrefix+H(me,!0)+'">'+(ge?X:H(X,!0))+`</code></pre>
`:"<pre><code>"+(ge?X:H(X,!0))+`</code></pre>
`},ye.blockquote=function(X){return`<blockquote>
`+X+`</blockquote>
`},ye.html=function(X){return X},ye.heading=function(X,ue,ge,me){return this.options.headerIds?"<h"+ue+' id="'+this.options.headerPrefix+me.slug(ge)+'">'+X+"</h"+ue+`>
`:"<h"+ue+">"+X+"</h"+ue+`>
`},ye.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},ye.list=function(X,ue,ge){var me=ue?"ol":"ul",Ie=ue&&ge!==1?' start="'+ge+'"':"";return"<"+me+Ie+`>
`+X+"</"+me+`>
`},ye.listitem=function(X){return"<li>"+X+`</li>
`},ye.checkbox=function(X){return"<input "+(X?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},ye.paragraph=function(X){return"<p>"+X+`</p>
`},ye.table=function(X,ue){return ue&&(ue="<tbody>"+ue+"</tbody>"),`<table>
<thead>
`+X+`</thead>
`+ue+`</table>
`},ye.tablerow=function(X){return`<tr>
`+X+`</tr>
`},ye.tablecell=function(X,ue){var ge=ue.header?"th":"td",me=ue.align?"<"+ge+' align="'+ue.align+'">':"<"+ge+">";return me+X+"</"+ge+`>
`},ye.strong=function(X){return"<strong>"+X+"</strong>"},ye.em=function(X){return"<em>"+X+"</em>"},ye.codespan=function(X){return"<code>"+X+"</code>"},ye.br=function(){return this.options.xhtml?"<br/>":"<br>"},ye.del=function(X){return"<del>"+X+"</del>"},ye.link=function(X,ue,ge){if(X=se(this.options.sanitize,this.options.baseUrl,X),X===null)return ge;var me='<a href="'+H(X)+'"';return ue&&(me+=' title="'+ue+'"'),me+=">"+ge+"</a>",me},ye.image=function(X,ue,ge){if(X=se(this.options.sanitize,this.options.baseUrl,X),X===null)return ge;var me='<img src="'+X+'" alt="'+ge+'"';return ue&&(me+=' title="'+ue+'"'),me+=this.options.xhtml?"/>":">",me},ye.text=function(X){return X},Pe}(),fe=function(){function Pe(){}var ye=Pe.prototype;return ye.strong=function(X){return X},ye.em=function(X){return X},ye.codespan=function(X){return X},ye.del=function(X){return X},ye.html=function(X){return X},ye.text=function(X){return X},ye.link=function(X,ue,ge){return""+ge},ye.image=function(X,ue,ge){return""+ge},ye.br=function(){return""},Pe}(),Te=function(){function Pe(){this.seen={}}var ye=Pe.prototype;return ye.serialize=function(X){return X.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},ye.getNextSafeSlug=function(X,ue){var ge=X,me=0;if(this.seen.hasOwnProperty(ge)){me=this.seen[X];do me++,ge=X+"-"+me;while(this.seen.hasOwnProperty(ge))}return ue||(this.seen[X]=me,this.seen[ge]=0),ge},ye.slug=function(X,ue){ue===void 0&&(ue={});var ge=this.serialize(X);return this.getNextSafeSlug(ge,ue.dryrun)},Pe}(),xe=ne,$e=fe,we=Te,Xe=A.exports.defaults,z=O.unescape,K=function(){function Pe(ke){this.options=ke||Xe,this.options.renderer=this.options.renderer||new xe,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new $e,this.slugger=new we}Pe.parse=function(X,ue){var ge=new Pe(ue);return ge.parse(X)},Pe.parseInline=function(X,ue){var ge=new Pe(ue);return ge.parseInline(X)};var ye=Pe.prototype;return ye.parse=function(X,ue){ue===void 0&&(ue=!0);var ge="",me,Ie,Ue,Me,je,Je,te,pe,oe,U,De,Se,qe,ze,it,vt,ht,ot,st,ut=X.length;for(me=0;me<ut;me++){if(U=X[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[U.type]&&(st=this.options.extensions.renderers[U.type].call({parser:this},U),st!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(U.type))){ge+=st||"";continue}switch(U.type){case"space":continue;case"hr":{ge+=this.renderer.hr();continue}case"heading":{ge+=this.renderer.heading(this.parseInline(U.tokens),U.depth,z(this.parseInline(U.tokens,this.textRenderer)),this.slugger);continue}case"code":{ge+=this.renderer.code(U.text,U.lang,U.escaped);continue}case"table":{for(pe="",te="",Me=U.header.length,Ie=0;Ie<Me;Ie++)te+=this.renderer.tablecell(this.parseInline(U.header[Ie].tokens),{header:!0,align:U.align[Ie]});for(pe+=this.renderer.tablerow(te),oe="",Me=U.rows.length,Ie=0;Ie<Me;Ie++){for(Je=U.rows[Ie],te="",je=Je.length,Ue=0;Ue<je;Ue++)te+=this.renderer.tablecell(this.parseInline(Je[Ue].tokens),{header:!1,align:U.align[Ue]});oe+=this.renderer.tablerow(te)}ge+=this.renderer.table(pe,oe);continue}case"blockquote":{oe=this.parse(U.tokens),ge+=this.renderer.blockquote(oe);continue}case"list":{for(De=U.ordered,Se=U.start,qe=U.loose,Me=U.items.length,oe="",Ie=0;Ie<Me;Ie++)it=U.items[Ie],vt=it.checked,ht=it.task,ze="",it.task&&(ot=this.renderer.checkbox(vt),qe?it.tokens.length>0&&it.tokens[0].type==="paragraph"?(it.tokens[0].text=ot+" "+it.tokens[0].text,it.tokens[0].tokens&&it.tokens[0].tokens.length>0&&it.tokens[0].tokens[0].type==="text"&&(it.tokens[0].tokens[0].text=ot+" "+it.tokens[0].tokens[0].text)):it.tokens.unshift({type:"text",text:ot}):ze+=ot),ze+=this.parse(it.tokens,qe),oe+=this.renderer.listitem(ze,ht,vt);ge+=this.renderer.list(oe,De,Se);continue}case"html":{ge+=this.renderer.html(U.text);continue}case"paragraph":{ge+=this.renderer.paragraph(this.parseInline(U.tokens));continue}case"text":{for(oe=U.tokens?this.parseInline(U.tokens):U.text;me+1<ut&&X[me+1].type==="text";)U=X[++me],oe+=`
`+(U.tokens?this.parseInline(U.tokens):U.text);ge+=ue?this.renderer.paragraph(oe):oe;continue}default:{var kt='Token with "'+U.type+'" type was not found.';if(this.options.silent){console.error(kt);return}else throw new Error(kt)}}}return ge},ye.parseInline=function(X,ue){ue=ue||this.renderer;var ge="",me,Ie,Ue,Me=X.length;for(me=0;me<Me;me++){if(Ie=X[me],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Ie.type]&&(Ue=this.options.extensions.renderers[Ie.type].call({parser:this},Ie),Ue!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Ie.type))){ge+=Ue||"";continue}switch(Ie.type){case"escape":{ge+=ue.text(Ie.text);break}case"html":{ge+=ue.html(Ie.text);break}case"link":{ge+=ue.link(Ie.href,Ie.title,this.parseInline(Ie.tokens,ue));break}case"image":{ge+=ue.image(Ie.href,Ie.title,Ie.text);break}case"strong":{ge+=ue.strong(this.parseInline(Ie.tokens,ue));break}case"em":{ge+=ue.em(this.parseInline(Ie.tokens,ue));break}case"codespan":{ge+=ue.codespan(Ie.text);break}case"br":{ge+=ue.br();break}case"del":{ge+=ue.del(this.parseInline(Ie.tokens,ue));break}case"text":{ge+=ue.text(Ie.text);break}default:{var je='Token with "'+Ie.type+'" type was not found.';if(this.options.silent){console.error(je);return}else throw new Error(je)}}}return ge},Pe}(),he=q,Le=K,Ve=B,tt=ne,lt=fe,ft=Te,St=O.merge,Pt=O.checkSanitizeDeprecation,dt=O.escape,bt=A.exports.getDefaults,mt=A.exports.changeDefaults,Et=A.exports.defaults;function Ye(Pe,ye,ke){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");if(typeof ye=="function"&&(ke=ye,ye=null),ye=St({},Ye.defaults,ye||{}),Pt(ye),ke){var X=ye.highlight,ue;try{ue=he.lex(Pe,ye)}catch(Ue){return ke(Ue)}var ge=function(Me){var je;if(!Me)try{ye.walkTokens&&Ye.walkTokens(ue,ye.walkTokens),je=Le.parse(ue,ye)}catch(Je){Me=Je}return ye.highlight=X,Me?ke(Me):ke(null,je)};if(!X||X.length<3||(delete ye.highlight,!ue.length))return ge();var me=0;Ye.walkTokens(ue,function(Ue){Ue.type==="code"&&(me++,setTimeout(function(){X(Ue.text,Ue.lang,function(Me,je){if(Me)return ge(Me);je!=null&&je!==Ue.text&&(Ue.text=je,Ue.escaped=!0),me--,me===0&&ge()})},0))}),me===0&&ge();return}try{var Ie=he.lex(Pe,ye);return ye.walkTokens&&Ye.walkTokens(Ie,ye.walkTokens),Le.parse(Ie,ye)}catch(Ue){if(Ue.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+dt(Ue.message+"",!0)+"</pre>";throw Ue}}Ye.options=Ye.setOptions=function(Pe){return St(Ye.defaults,Pe),mt(Ye.defaults),Ye},Ye.getDefaults=bt,Ye.defaults=Et,Ye.use=function(){for(var Pe=this,ye=arguments.length,ke=new Array(ye),X=0;X<ye;X++)ke[X]=arguments[X];var ue=St.apply(void 0,[{}].concat(ke)),ge=Ye.defaults.extensions||{renderers:{},childTokens:{}},me;ke.forEach(function(Ie){if(Ie.extensions&&(me=!0,Ie.extensions.forEach(function(Me){if(!Me.name)throw new Error("extension name required");if(Me.renderer){var je=ge.renderers?ge.renderers[Me.name]:null;je?ge.renderers[Me.name]=function(){for(var Je=arguments.length,te=new Array(Je),pe=0;pe<Je;pe++)te[pe]=arguments[pe];var oe=Me.renderer.apply(this,te);return oe===!1&&(oe=je.apply(this,te)),oe}:ge.renderers[Me.name]=Me.renderer}if(Me.tokenizer){if(!Me.level||Me.level!=="block"&&Me.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");ge[Me.level]?ge[Me.level].unshift(Me.tokenizer):ge[Me.level]=[Me.tokenizer],Me.start&&(Me.level==="block"?ge.startBlock?ge.startBlock.push(Me.start):ge.startBlock=[Me.start]:Me.level==="inline"&&(ge.startInline?ge.startInline.push(Me.start):ge.startInline=[Me.start]))}Me.childTokens&&(ge.childTokens[Me.name]=Me.childTokens)})),Ie.renderer&&function(){var Me=Ye.defaults.renderer||new tt,je=function(pe){var oe=Me[pe];Me[pe]=function(){for(var U=arguments.length,De=new Array(U),Se=0;Se<U;Se++)De[Se]=arguments[Se];var qe=Ie.renderer[pe].apply(Me,De);return qe===!1&&(qe=oe.apply(Me,De)),qe}};for(var Je in Ie.renderer)je(Je);ue.renderer=Me}(),Ie.tokenizer&&function(){var Me=Ye.defaults.tokenizer||new Ve,je=function(pe){var oe=Me[pe];Me[pe]=function(){for(var U=arguments.length,De=new Array(U),Se=0;Se<U;Se++)De[Se]=arguments[Se];var qe=Ie.tokenizer[pe].apply(Me,De);return qe===!1&&(qe=oe.apply(Me,De)),qe}};for(var Je in Ie.tokenizer)je(Je);ue.tokenizer=Me}(),Ie.walkTokens){var Ue=Ye.defaults.walkTokens;ue.walkTokens=function(Me){Ie.walkTokens.call(Pe,Me),Ue&&Ue(Me)}}me&&(ue.extensions=ge),Ye.setOptions(ue)})},Ye.walkTokens=function(Pe,ye){for(var ke=function(){var me=ue.value;switch(ye(me),me.type){case"table":{for(var Ie=E(me.header),Ue;!(Ue=Ie()).done;){var Me=Ue.value;Ye.walkTokens(Me.tokens,ye)}for(var je=E(me.rows),Je;!(Je=je()).done;)for(var te=Je.value,pe=E(te),oe;!(oe=pe()).done;){var U=oe.value;Ye.walkTokens(U.tokens,ye)}break}case"list":{Ye.walkTokens(me.items,ye);break}default:Ye.defaults.extensions&&Ye.defaults.extensions.childTokens&&Ye.defaults.extensions.childTokens[me.type]?Ye.defaults.extensions.childTokens[me.type].forEach(function(De){Ye.walkTokens(me[De],ye)}):me.tokens&&Ye.walkTokens(me.tokens,ye)}},X=E(Pe),ue;!(ue=X()).done;)ke()},Ye.parseInline=function(Pe,ye){if(typeof Pe=="undefined"||Pe===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Pe!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Pe)+", string expected");ye=St({},Ye.defaults,ye||{}),Pt(ye);try{var ke=he.lexInline(Pe,ye);return ye.walkTokens&&Ye.walkTokens(ke,ye.walkTokens),Le.parseInline(ke,ye)}catch(X){if(X.message+=`
Please report this to https://github.com/markedjs/marked.`,ye.silent)return"<p>An error occurred:</p><pre>"+dt(X.message+"",!0)+"</pre>";throw X}},Ye.Parser=Le,Ye.parser=Le.parse,Ye.Renderer=tt,Ye.TextRenderer=lt,Ye.Lexer=he,Ye.lexer=he.lex,Ye.Tokenizer=Ve,Ye.Slugger=ft,Ye.parse=Ye;var Ct=Ye;return Ct}),define(be[75],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function h(R,I,y){return Math.min(Math.max(R,I),y)}e.clamp=h;function F(R,I){return(I+R%I)%I}e.rot=F;class E{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=E;class A{constructor(){this._n=1,this._val=0}update(I){return this._val=this._val+(I-this._val)/this._n,this._n+=1,this}get value(){return this._val}}e.MovingAverage=A}),function(){function re(E){const A=[];typeof E=="number"&&A.push("code/timeOrigin",E);function R(y){A.push(y,Date.now())}function I(){const y=[];for(let k=0;k<A.length;k+=2)y.push({name:A[k],startTime:A[k+1]});return y}return{mark:R,getMarks:I}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?re():{mark(E){performance.mark(E)},getMarks(){let E=performance.timeOrigin;typeof E!="number"&&(E=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const A=[{name:"code/timeOrigin",startTime:Math.round(E)}];for(const R of performance.getEntriesByType("mark"))A.push({name:R.name,startTime:Math.round(E+R.startTime)});return A}};if(typeof process=="object"){const E=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return re(E)}else return console.trace("perf-util loaded in UNKNOWN environment"),re()}function h(E){return E.MonacoPerformanceMarks||(E.MonacoPerformanceMarks=e()),E.MonacoPerformanceMarks}var F;typeof global=="object"?F=global:typeof self=="object"?F=self:F={},typeof define=="function"?define("vs/base/common/performance",[],function(){return h(F)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=h(F):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),F.perf=h(F))}(),define(be[34],Ee([0,1,3]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class F{constructor(){this._icons=new Map,this._onDidRegister=new h.Emitter}add(_){const r=this._icons.get(_.id);r?_.description?r.description=_.description:console.error(`Duplicate registration of codicon ${_.id}`):(this._icons.set(_.id,_),this._onDidRegister.fire(_))}get(_){return this._icons.get(_)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const E=new F;e.iconRegistry=E;function A(t,_){return new I(t,_)}e.registerCodicon=A;function R(t){return t?t.replace(/\$\((.*?)\)/g,(_,r)=>` ${r} `).trim():""}e.getCodiconAriaLabel=R;class I{constructor(_,r,d){this.id=_,this.definition=r,this.description=d,E.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=I;function y(t,_){const r=["codicon","codicon-"+t];return _&&r.push("codicon-modifier-"+_),r}e.getClassNamesArray=y;var k;(function(t){t.iconNameSegment="[A-Za-z0-9]+",t.iconNameExpression="[A-Za-z0-9\\-]+",t.iconModifierExpression="~[A-Za-z]+";const _=new RegExp(`^(${t.iconNameExpression})(${t.iconModifierExpression})?$`);function r(l){if(l instanceof I)return["codicon","codicon-"+l.id];const v=_.exec(l.id);if(!v)return r(I.error);let[,T,b]=v;const c=["codicon","codicon-"+T];return b&&c.push("codicon-modifier-"+b.substr(1)),c}t.asClassNameArray=r;function d(l){return r(l).join(" ")}t.asClassName=d;function a(l){return"."+r(l).join(".")}t.asCSSSelector=a})(k=e.CSSIcon||(e.CSSIcon={})),function(t){t.add=new t("add",{fontCharacter:"\\ea60"}),t.plus=new t("plus",{fontCharacter:"\\ea60"}),t.gistNew=new t("gist-new",{fontCharacter:"\\ea60"}),t.repoCreate=new t("repo-create",{fontCharacter:"\\ea60"}),t.lightbulb=new t("lightbulb",{fontCharacter:"\\ea61"}),t.lightBulb=new t("light-bulb",{fontCharacter:"\\ea61"}),t.repo=new t("repo",{fontCharacter:"\\ea62"}),t.repoDelete=new t("repo-delete",{fontCharacter:"\\ea62"}),t.gistFork=new t("gist-fork",{fontCharacter:"\\ea63"}),t.repoForked=new t("repo-forked",{fontCharacter:"\\ea63"}),t.gitPullRequest=new t("git-pull-request",{fontCharacter:"\\ea64"}),t.gitPullRequestAbandoned=new t("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),t.recordKeys=new t("record-keys",{fontCharacter:"\\ea65"}),t.keyboard=new t("keyboard",{fontCharacter:"\\ea65"}),t.tag=new t("tag",{fontCharacter:"\\ea66"}),t.tagAdd=new t("tag-add",{fontCharacter:"\\ea66"}),t.tagRemove=new t("tag-remove",{fontCharacter:"\\ea66"}),t.person=new t("person",{fontCharacter:"\\ea67"}),t.personFollow=new t("person-follow",{fontCharacter:"\\ea67"}),t.personOutline=new t("person-outline",{fontCharacter:"\\ea67"}),t.personFilled=new t("person-filled",{fontCharacter:"\\ea67"}),t.gitBranch=new t("git-branch",{fontCharacter:"\\ea68"}),t.gitBranchCreate=new t("git-branch-create",{fontCharacter:"\\ea68"}),t.gitBranchDelete=new t("git-branch-delete",{fontCharacter:"\\ea68"}),t.sourceControl=new t("source-control",{fontCharacter:"\\ea68"}),t.mirror=new t("mirror",{fontCharacter:"\\ea69"}),t.mirrorPublic=new t("mirror-public",{fontCharacter:"\\ea69"}),t.star=new t("star",{fontCharacter:"\\ea6a"}),t.starAdd=new t("star-add",{fontCharacter:"\\ea6a"}),t.starDelete=new t("star-delete",{fontCharacter:"\\ea6a"}),t.starEmpty=new t("star-empty",{fontCharacter:"\\ea6a"}),t.comment=new t("comment",{fontCharacter:"\\ea6b"}),t.commentAdd=new t("comment-add",{fontCharacter:"\\ea6b"}),t.alert=new t("alert",{fontCharacter:"\\ea6c"}),t.warning=new t("warning",{fontCharacter:"\\ea6c"}),t.search=new t("search",{fontCharacter:"\\ea6d"}),t.searchSave=new t("search-save",{fontCharacter:"\\ea6d"}),t.logOut=new t("log-out",{fontCharacter:"\\ea6e"}),t.signOut=new t("sign-out",{fontCharacter:"\\ea6e"}),t.logIn=new t("log-in",{fontCharacter:"\\ea6f"}),t.signIn=new t("sign-in",{fontCharacter:"\\ea6f"}),t.eye=new t("eye",{fontCharacter:"\\ea70"}),t.eyeUnwatch=new t("eye-unwatch",{fontCharacter:"\\ea70"}),t.eyeWatch=new t("eye-watch",{fontCharacter:"\\ea70"}),t.circleFilled=new t("circle-filled",{fontCharacter:"\\ea71"}),t.primitiveDot=new t("primitive-dot",{fontCharacter:"\\ea71"}),t.closeDirty=new t("close-dirty",{fontCharacter:"\\ea71"}),t.debugBreakpoint=new t("debug-breakpoint",{fontCharacter:"\\ea71"}),t.debugBreakpointDisabled=new t("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),t.debugHint=new t("debug-hint",{fontCharacter:"\\ea71"}),t.primitiveSquare=new t("primitive-square",{fontCharacter:"\\ea72"}),t.edit=new t("edit",{fontCharacter:"\\ea73"}),t.pencil=new t("pencil",{fontCharacter:"\\ea73"}),t.info=new t("info",{fontCharacter:"\\ea74"}),t.issueOpened=new t("issue-opened",{fontCharacter:"\\ea74"}),t.gistPrivate=new t("gist-private",{fontCharacter:"\\ea75"}),t.gitForkPrivate=new t("git-fork-private",{fontCharacter:"\\ea75"}),t.lock=new t("lock",{fontCharacter:"\\ea75"}),t.mirrorPrivate=new t("mirror-private",{fontCharacter:"\\ea75"}),t.close=new t("close",{fontCharacter:"\\ea76"}),t.removeClose=new t("remove-close",{fontCharacter:"\\ea76"}),t.x=new t("x",{fontCharacter:"\\ea76"}),t.repoSync=new t("repo-sync",{fontCharacter:"\\ea77"}),t.sync=new t("sync",{fontCharacter:"\\ea77"}),t.clone=new t("clone",{fontCharacter:"\\ea78"}),t.desktopDownload=new t("desktop-download",{fontCharacter:"\\ea78"}),t.beaker=new t("beaker",{fontCharacter:"\\ea79"}),t.microscope=new t("microscope",{fontCharacter:"\\ea79"}),t.vm=new t("vm",{fontCharacter:"\\ea7a"}),t.deviceDesktop=new t("device-desktop",{fontCharacter:"\\ea7a"}),t.file=new t("file",{fontCharacter:"\\ea7b"}),t.fileText=new t("file-text",{fontCharacter:"\\ea7b"}),t.more=new t("more",{fontCharacter:"\\ea7c"}),t.ellipsis=new t("ellipsis",{fontCharacter:"\\ea7c"}),t.kebabHorizontal=new t("kebab-horizontal",{fontCharacter:"\\ea7c"}),t.mailReply=new t("mail-reply",{fontCharacter:"\\ea7d"}),t.reply=new t("reply",{fontCharacter:"\\ea7d"}),t.organization=new t("organization",{fontCharacter:"\\ea7e"}),t.organizationFilled=new t("organization-filled",{fontCharacter:"\\ea7e"}),t.organizationOutline=new t("organization-outline",{fontCharacter:"\\ea7e"}),t.newFile=new t("new-file",{fontCharacter:"\\ea7f"}),t.fileAdd=new t("file-add",{fontCharacter:"\\ea7f"}),t.newFolder=new t("new-folder",{fontCharacter:"\\ea80"}),t.fileDirectoryCreate=new t("file-directory-create",{fontCharacter:"\\ea80"}),t.trash=new t("trash",{fontCharacter:"\\ea81"}),t.trashcan=new t("trashcan",{fontCharacter:"\\ea81"}),t.history=new t("history",{fontCharacter:"\\ea82"}),t.clock=new t("clock",{fontCharacter:"\\ea82"}),t.folder=new t("folder",{fontCharacter:"\\ea83"}),t.fileDirectory=new t("file-directory",{fontCharacter:"\\ea83"}),t.symbolFolder=new t("symbol-folder",{fontCharacter:"\\ea83"}),t.logoGithub=new t("logo-github",{fontCharacter:"\\ea84"}),t.markGithub=new t("mark-github",{fontCharacter:"\\ea84"}),t.github=new t("github",{fontCharacter:"\\ea84"}),t.terminal=new t("terminal",{fontCharacter:"\\ea85"}),t.console=new t("console",{fontCharacter:"\\ea85"}),t.repl=new t("repl",{fontCharacter:"\\ea85"}),t.zap=new t("zap",{fontCharacter:"\\ea86"}),t.symbolEvent=new t("symbol-event",{fontCharacter:"\\ea86"}),t.error=new t("error",{fontCharacter:"\\ea87"}),t.stop=new t("stop",{fontCharacter:"\\ea87"}),t.variable=new t("variable",{fontCharacter:"\\ea88"}),t.symbolVariable=new t("symbol-variable",{fontCharacter:"\\ea88"}),t.array=new t("array",{fontCharacter:"\\ea8a"}),t.symbolArray=new t("symbol-array",{fontCharacter:"\\ea8a"}),t.symbolModule=new t("symbol-module",{fontCharacter:"\\ea8b"}),t.symbolPackage=new t("symbol-package",{fontCharacter:"\\ea8b"}),t.symbolNamespace=new t("symbol-namespace",{fontCharacter:"\\ea8b"}),t.symbolObject=new t("symbol-object",{fontCharacter:"\\ea8b"}),t.symbolMethod=new t("symbol-method",{fontCharacter:"\\ea8c"}),t.symbolFunction=new t("symbol-function",{fontCharacter:"\\ea8c"}),t.symbolConstructor=new t("symbol-constructor",{fontCharacter:"\\ea8c"}),t.symbolBoolean=new t("symbol-boolean",{fontCharacter:"\\ea8f"}),t.symbolNull=new t("symbol-null",{fontCharacter:"\\ea8f"}),t.symbolNumeric=new t("symbol-numeric",{fontCharacter:"\\ea90"}),t.symbolNumber=new t("symbol-number",{fontCharacter:"\\ea90"}),t.symbolStructure=new t("symbol-structure",{fontCharacter:"\\ea91"}),t.symbolStruct=new t("symbol-struct",{fontCharacter:"\\ea91"}),t.symbolParameter=new t("symbol-parameter",{fontCharacter:"\\ea92"}),t.symbolTypeParameter=new t("symbol-type-parameter",{fontCharacter:"\\ea92"}),t.symbolKey=new t("symbol-key",{fontCharacter:"\\ea93"}),t.symbolText=new t("symbol-text",{fontCharacter:"\\ea93"}),t.symbolReference=new t("symbol-reference",{fontCharacter:"\\ea94"}),t.goToFile=new t("go-to-file",{fontCharacter:"\\ea94"}),t.symbolEnum=new t("symbol-enum",{fontCharacter:"\\ea95"}),t.symbolValue=new t("symbol-value",{fontCharacter:"\\ea95"}),t.symbolRuler=new t("symbol-ruler",{fontCharacter:"\\ea96"}),t.symbolUnit=new t("symbol-unit",{fontCharacter:"\\ea96"}),t.activateBreakpoints=new t("activate-breakpoints",{fontCharacter:"\\ea97"}),t.archive=new t("archive",{fontCharacter:"\\ea98"}),t.arrowBoth=new t("arrow-both",{fontCharacter:"\\ea99"}),t.arrowDown=new t("arrow-down",{fontCharacter:"\\ea9a"}),t.arrowLeft=new t("arrow-left",{fontCharacter:"\\ea9b"}),t.arrowRight=new t("arrow-right",{fontCharacter:"\\ea9c"}),t.arrowSmallDown=new t("arrow-small-down",{fontCharacter:"\\ea9d"}),t.arrowSmallLeft=new t("arrow-small-left",{fontCharacter:"\\ea9e"}),t.arrowSmallRight=new t("arrow-small-right",{fontCharacter:"\\ea9f"}),t.arrowSmallUp=new t("arrow-small-up",{fontCharacter:"\\eaa0"}),t.arrowUp=new t("arrow-up",{fontCharacter:"\\eaa1"}),t.bell=new t("bell",{fontCharacter:"\\eaa2"}),t.bold=new t("bold",{fontCharacter:"\\eaa3"}),t.book=new t("book",{fontCharacter:"\\eaa4"}),t.bookmark=new t("bookmark",{fontCharacter:"\\eaa5"}),t.debugBreakpointConditionalUnverified=new t("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),t.debugBreakpointConditional=new t("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),t.debugBreakpointConditionalDisabled=new t("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),t.debugBreakpointDataUnverified=new t("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),t.debugBreakpointData=new t("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),t.debugBreakpointDataDisabled=new t("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),t.debugBreakpointLogUnverified=new t("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),t.debugBreakpointLog=new t("debug-breakpoint-log",{fontCharacter:"\\eaab"}),t.debugBreakpointLogDisabled=new t("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),t.briefcase=new t("briefcase",{fontCharacter:"\\eaac"}),t.broadcast=new t("broadcast",{fontCharacter:"\\eaad"}),t.browser=new t("browser",{fontCharacter:"\\eaae"}),t.bug=new t("bug",{fontCharacter:"\\eaaf"}),t.calendar=new t("calendar",{fontCharacter:"\\eab0"}),t.caseSensitive=new t("case-sensitive",{fontCharacter:"\\eab1"}),t.check=new t("check",{fontCharacter:"\\eab2"}),t.checklist=new t("checklist",{fontCharacter:"\\eab3"}),t.chevronDown=new t("chevron-down",{fontCharacter:"\\eab4"}),t.chevronLeft=new t("chevron-left",{fontCharacter:"\\eab5"}),t.chevronRight=new t("chevron-right",{fontCharacter:"\\eab6"}),t.chevronUp=new t("chevron-up",{fontCharacter:"\\eab7"}),t.chromeClose=new t("chrome-close",{fontCharacter:"\\eab8"}),t.chromeMaximize=new t("chrome-maximize",{fontCharacter:"\\eab9"}),t.chromeMinimize=new t("chrome-minimize",{fontCharacter:"\\eaba"}),t.chromeRestore=new t("chrome-restore",{fontCharacter:"\\eabb"}),t.circleOutline=new t("circle-outline",{fontCharacter:"\\eabc"}),t.debugBreakpointUnverified=new t("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),t.circleSlash=new t("circle-slash",{fontCharacter:"\\eabd"}),t.circuitBoard=new t("circuit-board",{fontCharacter:"\\eabe"}),t.clearAll=new t("clear-all",{fontCharacter:"\\eabf"}),t.clippy=new t("clippy",{fontCharacter:"\\eac0"}),t.closeAll=new t("close-all",{fontCharacter:"\\eac1"}),t.cloudDownload=new t("cloud-download",{fontCharacter:"\\eac2"}),t.cloudUpload=new t("cloud-upload",{fontCharacter:"\\eac3"}),t.code=new t("code",{fontCharacter:"\\eac4"}),t.collapseAll=new t("collapse-all",{fontCharacter:"\\eac5"}),t.colorMode=new t("color-mode",{fontCharacter:"\\eac6"}),t.commentDiscussion=new t("comment-discussion",{fontCharacter:"\\eac7"}),t.compareChanges=new t("compare-changes",{fontCharacter:"\\eafd"}),t.creditCard=new t("credit-card",{fontCharacter:"\\eac9"}),t.dash=new t("dash",{fontCharacter:"\\eacc"}),t.dashboard=new t("dashboard",{fontCharacter:"\\eacd"}),t.database=new t("database",{fontCharacter:"\\eace"}),t.debugContinue=new t("debug-continue",{fontCharacter:"\\eacf"}),t.debugDisconnect=new t("debug-disconnect",{fontCharacter:"\\ead0"}),t.debugPause=new t("debug-pause",{fontCharacter:"\\ead1"}),t.debugRestart=new t("debug-restart",{fontCharacter:"\\ead2"}),t.debugStart=new t("debug-start",{fontCharacter:"\\ead3"}),t.debugStepInto=new t("debug-step-into",{fontCharacter:"\\ead4"}),t.debugStepOut=new t("debug-step-out",{fontCharacter:"\\ead5"}),t.debugStepOver=new t("debug-step-over",{fontCharacter:"\\ead6"}),t.debugStop=new t("debug-stop",{fontCharacter:"\\ead7"}),t.debug=new t("debug",{fontCharacter:"\\ead8"}),t.deviceCameraVideo=new t("device-camera-video",{fontCharacter:"\\ead9"}),t.deviceCamera=new t("device-camera",{fontCharacter:"\\eada"}),t.deviceMobile=new t("device-mobile",{fontCharacter:"\\eadb"}),t.diffAdded=new t("diff-added",{fontCharacter:"\\eadc"}),t.diffIgnored=new t("diff-ignored",{fontCharacter:"\\eadd"}),t.diffModified=new t("diff-modified",{fontCharacter:"\\eade"}),t.diffRemoved=new t("diff-removed",{fontCharacter:"\\eadf"}),t.diffRenamed=new t("diff-renamed",{fontCharacter:"\\eae0"}),t.diff=new t("diff",{fontCharacter:"\\eae1"}),t.discard=new t("discard",{fontCharacter:"\\eae2"}),t.editorLayout=new t("editor-layout",{fontCharacter:"\\eae3"}),t.emptyWindow=new t("empty-window",{fontCharacter:"\\eae4"}),t.exclude=new t("exclude",{fontCharacter:"\\eae5"}),t.extensions=new t("extensions",{fontCharacter:"\\eae6"}),t.eyeClosed=new t("eye-closed",{fontCharacter:"\\eae7"}),t.fileBinary=new t("file-binary",{fontCharacter:"\\eae8"}),t.fileCode=new t("file-code",{fontCharacter:"\\eae9"}),t.fileMedia=new t("file-media",{fontCharacter:"\\eaea"}),t.filePdf=new t("file-pdf",{fontCharacter:"\\eaeb"}),t.fileSubmodule=new t("file-submodule",{fontCharacter:"\\eaec"}),t.fileSymlinkDirectory=new t("file-symlink-directory",{fontCharacter:"\\eaed"}),t.fileSymlinkFile=new t("file-symlink-file",{fontCharacter:"\\eaee"}),t.fileZip=new t("file-zip",{fontCharacter:"\\eaef"}),t.files=new t("files",{fontCharacter:"\\eaf0"}),t.filter=new t("filter",{fontCharacter:"\\eaf1"}),t.flame=new t("flame",{fontCharacter:"\\eaf2"}),t.foldDown=new t("fold-down",{fontCharacter:"\\eaf3"}),t.foldUp=new t("fold-up",{fontCharacter:"\\eaf4"}),t.fold=new t("fold",{fontCharacter:"\\eaf5"}),t.folderActive=new t("folder-active",{fontCharacter:"\\eaf6"}),t.folderOpened=new t("folder-opened",{fontCharacter:"\\eaf7"}),t.gear=new t("gear",{fontCharacter:"\\eaf8"}),t.gift=new t("gift",{fontCharacter:"\\eaf9"}),t.gistSecret=new t("gist-secret",{fontCharacter:"\\eafa"}),t.gist=new t("gist",{fontCharacter:"\\eafb"}),t.gitCommit=new t("git-commit",{fontCharacter:"\\eafc"}),t.gitCompare=new t("git-compare",{fontCharacter:"\\eafd"}),t.gitMerge=new t("git-merge",{fontCharacter:"\\eafe"}),t.githubAction=new t("github-action",{fontCharacter:"\\eaff"}),t.githubAlt=new t("github-alt",{fontCharacter:"\\eb00"}),t.globe=new t("globe",{fontCharacter:"\\eb01"}),t.grabber=new t("grabber",{fontCharacter:"\\eb02"}),t.graph=new t("graph",{fontCharacter:"\\eb03"}),t.gripper=new t("gripper",{fontCharacter:"\\eb04"}),t.heart=new t("heart",{fontCharacter:"\\eb05"}),t.home=new t("home",{fontCharacter:"\\eb06"}),t.horizontalRule=new t("horizontal-rule",{fontCharacter:"\\eb07"}),t.hubot=new t("hubot",{fontCharacter:"\\eb08"}),t.inbox=new t("inbox",{fontCharacter:"\\eb09"}),t.issueClosed=new t("issue-closed",{fontCharacter:"\\eba4"}),t.issueReopened=new t("issue-reopened",{fontCharacter:"\\eb0b"}),t.issues=new t("issues",{fontCharacter:"\\eb0c"}),t.italic=new t("italic",{fontCharacter:"\\eb0d"}),t.jersey=new t("jersey",{fontCharacter:"\\eb0e"}),t.json=new t("json",{fontCharacter:"\\eb0f"}),t.kebabVertical=new t("kebab-vertical",{fontCharacter:"\\eb10"}),t.key=new t("key",{fontCharacter:"\\eb11"}),t.law=new t("law",{fontCharacter:"\\eb12"}),t.lightbulbAutofix=new t("lightbulb-autofix",{fontCharacter:"\\eb13"}),t.linkExternal=new t("link-external",{fontCharacter:"\\eb14"}),t.link=new t("link",{fontCharacter:"\\eb15"}),t.listOrdered=new t("list-ordered",{fontCharacter:"\\eb16"}),t.listUnordered=new t("list-unordered",{fontCharacter:"\\eb17"}),t.liveShare=new t("live-share",{fontCharacter:"\\eb18"}),t.loading=new t("loading",{fontCharacter:"\\eb19"}),t.location=new t("location",{fontCharacter:"\\eb1a"}),t.mailRead=new t("mail-read",{fontCharacter:"\\eb1b"}),t.mail=new t("mail",{fontCharacter:"\\eb1c"}),t.markdown=new t("markdown",{fontCharacter:"\\eb1d"}),t.megaphone=new t("megaphone",{fontCharacter:"\\eb1e"}),t.mention=new t("mention",{fontCharacter:"\\eb1f"}),t.milestone=new t("milestone",{fontCharacter:"\\eb20"}),t.mortarBoard=new t("mortar-board",{fontCharacter:"\\eb21"}),t.move=new t("move",{fontCharacter:"\\eb22"}),t.multipleWindows=new t("multiple-windows",{fontCharacter:"\\eb23"}),t.mute=new t("mute",{fontCharacter:"\\eb24"}),t.noNewline=new t("no-newline",{fontCharacter:"\\eb25"}),t.note=new t("note",{fontCharacter:"\\eb26"}),t.octoface=new t("octoface",{fontCharacter:"\\eb27"}),t.openPreview=new t("open-preview",{fontCharacter:"\\eb28"}),t.package_=new t("package",{fontCharacter:"\\eb29"}),t.paintcan=new t("paintcan",{fontCharacter:"\\eb2a"}),t.pin=new t("pin",{fontCharacter:"\\eb2b"}),t.play=new t("play",{fontCharacter:"\\eb2c"}),t.run=new t("run",{fontCharacter:"\\eb2c"}),t.plug=new t("plug",{fontCharacter:"\\eb2d"}),t.preserveCase=new t("preserve-case",{fontCharacter:"\\eb2e"}),t.preview=new t("preview",{fontCharacter:"\\eb2f"}),t.project=new t("project",{fontCharacter:"\\eb30"}),t.pulse=new t("pulse",{fontCharacter:"\\eb31"}),t.question=new t("question",{fontCharacter:"\\eb32"}),t.quote=new t("quote",{fontCharacter:"\\eb33"}),t.radioTower=new t("radio-tower",{fontCharacter:"\\eb34"}),t.reactions=new t("reactions",{fontCharacter:"\\eb35"}),t.references=new t("references",{fontCharacter:"\\eb36"}),t.refresh=new t("refresh",{fontCharacter:"\\eb37"}),t.regex=new t("regex",{fontCharacter:"\\eb38"}),t.remoteExplorer=new t("remote-explorer",{fontCharacter:"\\eb39"}),t.remote=new t("remote",{fontCharacter:"\\eb3a"}),t.remove=new t("remove",{fontCharacter:"\\eb3b"}),t.replaceAll=new t("replace-all",{fontCharacter:"\\eb3c"}),t.replace=new t("replace",{fontCharacter:"\\eb3d"}),t.repoClone=new t("repo-clone",{fontCharacter:"\\eb3e"}),t.repoForcePush=new t("repo-force-push",{fontCharacter:"\\eb3f"}),t.repoPull=new t("repo-pull",{fontCharacter:"\\eb40"}),t.repoPush=new t("repo-push",{fontCharacter:"\\eb41"}),t.report=new t("report",{fontCharacter:"\\eb42"}),t.requestChanges=new t("request-changes",{fontCharacter:"\\eb43"}),t.rocket=new t("rocket",{fontCharacter:"\\eb44"}),t.rootFolderOpened=new t("root-folder-opened",{fontCharacter:"\\eb45"}),t.rootFolder=new t("root-folder",{fontCharacter:"\\eb46"}),t.rss=new t("rss",{fontCharacter:"\\eb47"}),t.ruby=new t("ruby",{fontCharacter:"\\eb48"}),t.saveAll=new t("save-all",{fontCharacter:"\\eb49"}),t.saveAs=new t("save-as",{fontCharacter:"\\eb4a"}),t.save=new t("save",{fontCharacter:"\\eb4b"}),t.screenFull=new t("screen-full",{fontCharacter:"\\eb4c"}),t.screenNormal=new t("screen-normal",{fontCharacter:"\\eb4d"}),t.searchStop=new t("search-stop",{fontCharacter:"\\eb4e"}),t.server=new t("server",{fontCharacter:"\\eb50"}),t.settingsGear=new t("settings-gear",{fontCharacter:"\\eb51"}),t.settings=new t("settings",{fontCharacter:"\\eb52"}),t.shield=new t("shield",{fontCharacter:"\\eb53"}),t.smiley=new t("smiley",{fontCharacter:"\\eb54"}),t.sortPrecedence=new t("sort-precedence",{fontCharacter:"\\eb55"}),t.splitHorizontal=new t("split-horizontal",{fontCharacter:"\\eb56"}),t.splitVertical=new t("split-vertical",{fontCharacter:"\\eb57"}),t.squirrel=new t("squirrel",{fontCharacter:"\\eb58"}),t.starFull=new t("star-full",{fontCharacter:"\\eb59"}),t.starHalf=new t("star-half",{fontCharacter:"\\eb5a"}),t.symbolClass=new t("symbol-class",{fontCharacter:"\\eb5b"}),t.symbolColor=new t("symbol-color",{fontCharacter:"\\eb5c"}),t.symbolConstant=new t("symbol-constant",{fontCharacter:"\\eb5d"}),t.symbolEnumMember=new t("symbol-enum-member",{fontCharacter:"\\eb5e"}),t.symbolField=new t("symbol-field",{fontCharacter:"\\eb5f"}),t.symbolFile=new t("symbol-file",{fontCharacter:"\\eb60"}),t.symbolInterface=new t("symbol-interface",{fontCharacter:"\\eb61"}),t.symbolKeyword=new t("symbol-keyword",{fontCharacter:"\\eb62"}),t.symbolMisc=new t("symbol-misc",{fontCharacter:"\\eb63"}),t.symbolOperator=new t("symbol-operator",{fontCharacter:"\\eb64"}),t.symbolProperty=new t("symbol-property",{fontCharacter:"\\eb65"}),t.wrench=new t("wrench",{fontCharacter:"\\eb65"}),t.wrenchSubaction=new t("wrench-subaction",{fontCharacter:"\\eb65"}),t.symbolSnippet=new t("symbol-snippet",{fontCharacter:"\\eb66"}),t.tasklist=new t("tasklist",{fontCharacter:"\\eb67"}),t.telescope=new t("telescope",{fontCharacter:"\\eb68"}),t.textSize=new t("text-size",{fontCharacter:"\\eb69"}),t.threeBars=new t("three-bars",{fontCharacter:"\\eb6a"}),t.thumbsdown=new t("thumbsdown",{fontCharacter:"\\eb6b"}),t.thumbsup=new t("thumbsup",{fontCharacter:"\\eb6c"}),t.tools=new t("tools",{fontCharacter:"\\eb6d"}),t.triangleDown=new t("triangle-down",{fontCharacter:"\\eb6e"}),t.triangleLeft=new t("triangle-left",{fontCharacter:"\\eb6f"}),t.triangleRight=new t("triangle-right",{fontCharacter:"\\eb70"}),t.triangleUp=new t("triangle-up",{fontCharacter:"\\eb71"}),t.twitter=new t("twitter",{fontCharacter:"\\eb72"}),t.unfold=new t("unfold",{fontCharacter:"\\eb73"}),t.unlock=new t("unlock",{fontCharacter:"\\eb74"}),t.unmute=new t("unmute",{fontCharacter:"\\eb75"}),t.unverified=new t("unverified",{fontCharacter:"\\eb76"}),t.verified=new t("verified",{fontCharacter:"\\eb77"}),t.versions=new t("versions",{fontCharacter:"\\eb78"}),t.vmActive=new t("vm-active",{fontCharacter:"\\eb79"}),t.vmOutline=new t("vm-outline",{fontCharacter:"\\eb7a"}),t.vmRunning=new t("vm-running",{fontCharacter:"\\eb7b"}),t.watch=new t("watch",{fontCharacter:"\\eb7c"}),t.whitespace=new t("whitespace",{fontCharacter:"\\eb7d"}),t.wholeWord=new t("whole-word",{fontCharacter:"\\eb7e"}),t.window=new t("window",{fontCharacter:"\\eb7f"}),t.wordWrap=new t("word-wrap",{fontCharacter:"\\eb80"}),t.zoomIn=new t("zoom-in",{fontCharacter:"\\eb81"}),t.zoomOut=new t("zoom-out",{fontCharacter:"\\eb82"}),t.listFilter=new t("list-filter",{fontCharacter:"\\eb83"}),t.listFlat=new t("list-flat",{fontCharacter:"\\eb84"}),t.listSelection=new t("list-selection",{fontCharacter:"\\eb85"}),t.selection=new t("selection",{fontCharacter:"\\eb85"}),t.listTree=new t("list-tree",{fontCharacter:"\\eb86"}),t.debugBreakpointFunctionUnverified=new t("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),t.debugBreakpointFunction=new t("debug-breakpoint-function",{fontCharacter:"\\eb88"}),t.debugBreakpointFunctionDisabled=new t("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),t.debugStackframeActive=new t("debug-stackframe-active",{fontCharacter:"\\eb89"}),t.debugStackframeDot=new t("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),t.debugStackframe=new t("debug-stackframe",{fontCharacter:"\\eb8b"}),t.debugStackframeFocused=new t("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),t.debugBreakpointUnsupported=new t("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),t.symbolString=new t("symbol-string",{fontCharacter:"\\eb8d"}),t.debugReverseContinue=new t("debug-reverse-continue",{fontCharacter:"\\eb8e"}),t.debugStepBack=new t("debug-step-back",{fontCharacter:"\\eb8f"}),t.debugRestartFrame=new t("debug-restart-frame",{fontCharacter:"\\eb90"}),t.callIncoming=new t("call-incoming",{fontCharacter:"\\eb92"}),t.callOutgoing=new t("call-outgoing",{fontCharacter:"\\eb93"}),t.menu=new t("menu",{fontCharacter:"\\eb94"}),t.expandAll=new t("expand-all",{fontCharacter:"\\eb95"}),t.feedback=new t("feedback",{fontCharacter:"\\eb96"}),t.groupByRefType=new t("group-by-ref-type",{fontCharacter:"\\eb97"}),t.ungroupByRefType=new t("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),t.account=new t("account",{fontCharacter:"\\eb99"}),t.bellDot=new t("bell-dot",{fontCharacter:"\\eb9a"}),t.debugConsole=new t("debug-console",{fontCharacter:"\\eb9b"}),t.library=new t("library",{fontCharacter:"\\eb9c"}),t.output=new t("output",{fontCharacter:"\\eb9d"}),t.runAll=new t("run-all",{fontCharacter:"\\eb9e"}),t.syncIgnored=new t("sync-ignored",{fontCharacter:"\\eb9f"}),t.pinned=new t("pinned",{fontCharacter:"\\eba0"}),t.githubInverted=new t("github-inverted",{fontCharacter:"\\eba1"}),t.debugAlt=new t("debug-alt",{fontCharacter:"\\eb91"}),t.serverProcess=new t("server-process",{fontCharacter:"\\eba2"}),t.serverEnvironment=new t("server-environment",{fontCharacter:"\\eba3"}),t.pass=new t("pass",{fontCharacter:"\\eba4"}),t.stopCircle=new t("stop-circle",{fontCharacter:"\\eba5"}),t.playCircle=new t("play-circle",{fontCharacter:"\\eba6"}),t.record=new t("record",{fontCharacter:"\\eba7"}),t.debugAltSmall=new t("debug-alt-small",{fontCharacter:"\\eba8"}),t.vmConnect=new t("vm-connect",{fontCharacter:"\\eba9"}),t.cloud=new t("cloud",{fontCharacter:"\\ebaa"}),t.merge=new t("merge",{fontCharacter:"\\ebab"}),t.exportIcon=new t("export",{fontCharacter:"\\ebac"}),t.graphLeft=new t("graph-left",{fontCharacter:"\\ebad"}),t.magnet=new t("magnet",{fontCharacter:"\\ebae"}),t.notebook=new t("notebook",{fontCharacter:"\\ebaf"}),t.redo=new t("redo",{fontCharacter:"\\ebb0"}),t.checkAll=new t("check-all",{fontCharacter:"\\ebb1"}),t.pinnedDirty=new t("pinned-dirty",{fontCharacter:"\\ebb2"}),t.passFilled=new t("pass-filled",{fontCharacter:"\\ebb3"}),t.circleLargeFilled=new t("circle-large-filled",{fontCharacter:"\\ebb4"}),t.circleLargeOutline=new t("circle-large-outline",{fontCharacter:"\\ebb5"}),t.combine=new t("combine",{fontCharacter:"\\ebb6"}),t.gather=new t("gather",{fontCharacter:"\\ebb6"}),t.table=new t("table",{fontCharacter:"\\ebb7"}),t.variableGroup=new t("variable-group",{fontCharacter:"\\ebb8"}),t.typeHierarchy=new t("type-hierarchy",{fontCharacter:"\\ebb9"}),t.typeHierarchySub=new t("type-hierarchy-sub",{fontCharacter:"\\ebba"}),t.typeHierarchySuper=new t("type-hierarchy-super",{fontCharacter:"\\ebbb"}),t.gitPullRequestCreate=new t("git-pull-request-create",{fontCharacter:"\\ebbc"}),t.runAbove=new t("run-above",{fontCharacter:"\\ebbd"}),t.runBelow=new t("run-below",{fontCharacter:"\\ebbe"}),t.notebookTemplate=new t("notebook-template",{fontCharacter:"\\ebbf"}),t.debugRerun=new t("debug-rerun",{fontCharacter:"\\ebc0"}),t.workspaceTrusted=new t("workspace-trusted",{fontCharacter:"\\ebc1"}),t.workspaceUntrusted=new t("workspace-untrusted",{fontCharacter:"\\ebc2"}),t.workspaceUnspecified=new t("workspace-unspecified",{fontCharacter:"\\ebc3"}),t.terminalCmd=new t("terminal-cmd",{fontCharacter:"\\ebc4"}),t.terminalDebian=new t("terminal-debian",{fontCharacter:"\\ebc5"}),t.terminalLinux=new t("terminal-linux",{fontCharacter:"\\ebc6"}),t.terminalPowershell=new t("terminal-powershell",{fontCharacter:"\\ebc7"}),t.terminalTmux=new t("terminal-tmux",{fontCharacter:"\\ebc8"}),t.terminalUbuntu=new t("terminal-ubuntu",{fontCharacter:"\\ebc9"}),t.terminalBash=new t("terminal-bash",{fontCharacter:"\\ebca"}),t.arrowSwap=new t("arrow-swap",{fontCharacter:"\\ebcb"}),t.copy=new t("copy",{fontCharacter:"\\ebcc"}),t.personAdd=new t("person-add",{fontCharacter:"\\ebcd"}),t.filterFilled=new t("filter-filled",{fontCharacter:"\\ebce"}),t.wand=new t("wand",{fontCharacter:"\\ebcf"}),t.debugLineByLine=new t("debug-line-by-line",{fontCharacter:"\\ebd0"}),t.inspect=new t("inspect",{fontCharacter:"\\ebd1"}),t.layers=new t("layers",{fontCharacter:"\\ebd2"}),t.layersDot=new t("layers-dot",{fontCharacter:"\\ebd3"}),t.layersActive=new t("layers-active",{fontCharacter:"\\ebd4"}),t.compass=new t("compass",{fontCharacter:"\\ebd5"}),t.compassDot=new t("compass-dot",{fontCharacter:"\\ebd6"}),t.compassActive=new t("compass-active",{fontCharacter:"\\ebd7"}),t.azure=new t("azure",{fontCharacter:"\\ebd8"}),t.issueDraft=new t("issue-draft",{fontCharacter:"\\ebd9"}),t.gitPullRequestClosed=new t("git-pull-request-closed",{fontCharacter:"\\ebda"}),t.gitPullRequestDraft=new t("git-pull-request-draft",{fontCharacter:"\\ebdb"}),t.debugAll=new t("debug-all",{fontCharacter:"\\ebdc"}),t.debugCoverage=new t("debug-coverage",{fontCharacter:"\\ebdd"}),t.dropDownButton=new t("drop-down-button",t.chevronDown.definition)}(I=e.Codicon||(e.Codicon={}))}),define(be[104],Ee([0,1,15,7]),function(re,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function E(c){const g=c;return g?[g.on,g.pause,g.resume,g.destroy].every(S=>typeof S=="function"):!1}e.isReadableStream=E;function A(c){const g=c;return g?E(g.stream)&&Array.isArray(g.buffer)&&typeof g.ended=="boolean":!1}e.isReadableBufferedStream=A;function R(c,g){return new I(c,g)}e.newWriteableStream=R;class I{constructor(g,S){this.reducer=g,this.options=S,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(g){if(!this.state.destroyed){if(this.state.flowing)this.emitData(g);else if(this.buffer.data.push(g),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(S=>this.pendingWritePromises.push(S))}}error(g){this.state.destroyed||(this.state.flowing?this.emitError(g):this.buffer.error.push(g))}end(g){this.state.destroyed||(typeof g!="undefined"&&this.write(g),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(g){this.listeners.data.slice(0).forEach(S=>S(g))}emitError(g){this.listeners.error.length===0?(0,h.onUnexpectedError)(g):this.listeners.error.slice(0).forEach(S=>S(g))}emitEnd(){this.listeners.end.slice(0).forEach(g=>g())}on(g,S){if(!this.state.destroyed)switch(g){case"data":this.listeners.data.push(S),this.resume();break;case"end":this.listeners.end.push(S),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(S),this.state.flowing&&this.flowErrors();break}}removeListener(g,S){if(this.state.destroyed)return;let i;switch(g){case"data":i=this.listeners.data;break;case"end":i=this.listeners.end;break;case"error":i=this.listeners.error;break}if(i){const s=i.indexOf(S);s>=0&&i.splice(s,1)}}flowData(){if(this.buffer.data.length>0){const g=this.reducer(this.buffer.data);this.emitData(g),this.buffer.data.length=0;const S=[...this.pendingWritePromises];this.pendingWritePromises.length=0,S.forEach(i=>i())}}flowErrors(){if(this.listeners.error.length>0){for(const g of this.buffer.error)this.emitError(g);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function y(c,g){const S=[];let i;for(;(i=c.read())!==null;)S.push(i);return g(S)}e.consumeReadable=y;function k(c,g,S){const i=[];let s;for(;(s=c.read())!==null&&i.length<S;)i.push(s);return s===null&&i.length>0?g(i):{read:()=>{if(i.length>0)return i.shift();if(typeof s!="undefined"){const u=s;return s=void 0,u}return c.read()}}}e.peekReadable=k;function t(c,g){return new Promise((S,i)=>{const s=[];_(c,{onData:u=>{g&&s.push(u)},onError:u=>{g?i(u):S(void 0)},onEnd:()=>{S(g?g(s):void 0)}})})}e.consumeStream=t;function _(c,g){c.on("error",S=>g.onError(S)),c.on("end",()=>g.onEnd()),c.on("data",S=>g.onData(S))}e.listenStream=_;function r(c,g){return new Promise((S,i)=>{const s=new F.DisposableStore,u=[],o=w=>{if(u.push(w),u.length>g)return s.dispose(),c.pause(),S({stream:c,buffer:u,ended:!1})},f=w=>i(w),p=()=>S({stream:c,buffer:u,ended:!0});s.add((0,F.toDisposable)(()=>c.removeListener("error",f))),c.on("error",f),s.add((0,F.toDisposable)(()=>c.removeListener("end",p))),c.on("end",p),s.add((0,F.toDisposable)(()=>c.removeListener("data",o))),c.on("data",o)})}e.peekStream=r;function d(c,g){const S=R(g);return S.end(c),S}e.toStream=d;function a(){const c=R(()=>{throw new Error("not supported")});return c.end(),c}e.emptyStream=a;function l(c){let g=!1;return{read:()=>g?null:(g=!0,c)}}e.toReadable=l;function v(c,g,S){const i=R(S);return _(c,{onData:s=>i.write(g.data(s)),onError:s=>i.error(g.error?g.error(s):s),onEnd:()=>i.end()}),i}e.transform=v;function T(c,g,S){let i=!1;return{read:()=>{const s=g.read();return i?s:(i=!0,s!==null?S([c,s]):c)}}}e.prefixedReadable=T;function b(c,g,S){let i=!1;const s=R(S);return _(g,{onData:u=>i?s.write(u):(i=!0,s.write(S([c,u]))),onError:u=>s.error(u),onEnd:()=>{i||(i=!0,s.write(c)),s.end()}}),s}e.prefixedStream=b}),define(be[23],Ee([0,1,104]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const F=typeof Buffer!="undefined";let E,A;class R{constructor(o){this.buffer=o,this.byteLength=this.buffer.byteLength}static alloc(o){return F?new R(Buffer.allocUnsafe(o)):new R(new Uint8Array(o))}static wrap(o){return F&&!Buffer.isBuffer(o)&&(o=Buffer.from(o.buffer,o.byteOffset,o.byteLength)),new R(o)}static fromString(o,f){return!(f?.dontUseNodeBuffer||!1)&&F?new R(Buffer.from(o)):(E||(E=new TextEncoder),new R(E.encode(o)))}static concat(o,f){if(typeof f=="undefined"){f=0;for(let C=0,P=o.length;C<P;C++)f+=o[C].byteLength}const p=R.alloc(f);let w=0;for(let C=0,P=o.length;C<P;C++){const n=o[C];p.set(n,w),w+=n.byteLength}return p}toString(){return F?this.buffer.toString():(A||(A=new TextDecoder),A.decode(this.buffer))}slice(o,f){return new R(this.buffer.subarray(o,f))}set(o,f){o instanceof R?this.buffer.set(o.buffer,f):this.buffer.set(o,f)}readUInt32BE(o){return k(this.buffer,o)}writeUInt32BE(o,f){t(this.buffer,o,f)}readUInt32LE(o){return _(this.buffer,o)}writeUInt32LE(o,f){r(this.buffer,o,f)}readUInt8(o){return d(this.buffer,o)}writeUInt8(o,f){a(this.buffer,o,f)}}e.VSBuffer=R;function I(u,o){return u[o+0]<<0>>>0|u[o+1]<<8>>>0}e.readUInt16LE=I;function y(u,o,f){u[f+0]=o&255,o=o>>>8,u[f+1]=o&255}e.writeUInt16LE=y;function k(u,o){return u[o]*2**24+u[o+1]*2**16+u[o+2]*2**8+u[o+3]}e.readUInt32BE=k;function t(u,o,f){u[f+3]=o,o=o>>>8,u[f+2]=o,o=o>>>8,u[f+1]=o,o=o>>>8,u[f]=o}e.writeUInt32BE=t;function _(u,o){return u[o+0]<<0>>>0|u[o+1]<<8>>>0|u[o+2]<<16>>>0|u[o+3]<<24>>>0}e.readUInt32LE=_;function r(u,o,f){u[f+0]=o&255,o=o>>>8,u[f+1]=o&255,o=o>>>8,u[f+2]=o&255,o=o>>>8,u[f+3]=o&255}e.writeUInt32LE=r;function d(u,o){return u[o]}e.readUInt8=d;function a(u,o,f){u[f]=o}e.writeUInt8=a;function l(u){return h.consumeReadable(u,o=>R.concat(o))}e.readableToBuffer=l;function v(u){return h.toReadable(u)}e.bufferToReadable=v;function T(u){return h.consumeStream(u,o=>R.concat(o))}e.streamToBuffer=T;async function b(u){return u.ended?R.concat(u.buffer):R.concat([...u.buffer,await T(u.stream)])}e.bufferedStreamToBuffer=b;function c(u){return h.toStream(u,o=>R.concat(o))}e.bufferToStream=c;function g(u){return h.transform(u,{data:o=>typeof o=="string"?R.fromString(o):R.wrap(o)},o=>R.concat(o))}e.streamToBufferReadableStream=g;function S(u){return h.newWriteableStream(o=>R.concat(o),u)}e.newWriteableBufferStream=S;function i(u,o){return h.prefixedReadable(u,o,f=>R.concat(f))}e.prefixedBufferReadable=i;function s(u,o){return h.prefixedStream(u,o,f=>R.concat(f))}e.prefixedBufferStream=s}),define(be[35],Ee([0,1,9]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var F;(function(E){E[E.Ignore=0]="Ignore",E[E.Info=1]="Info",E[E.Warning=2]="Warning",E[E.Error=3]="Error"})(F||(F={})),function(E){const A="error",R="warning",I="warn",y="info",k="ignore";function t(r){return r?h.equalsIgnoreCase(A,r)?E.Error:h.equalsIgnoreCase(R,r)||h.equalsIgnoreCase(I,r)?E.Warning:h.equalsIgnoreCase(y,r)?E.Info:E.Ignore:E.Ignore}E.fromValue=t;function _(r){switch(r){case E.Error:return A;case E.Warning:return R;case E.Info:return y;default:return k}}E.toString=_}(F||(F={})),e.default=F}),define(be[40],Ee([0,1,17,26,9,10]),function(re,e,h,F,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function R(u){return u===47||u===92}e.isPathSeparator=R;function I(u){return u.replace(/[\\/]/g,h.posix.sep)}e.toSlashes=I;function y(u){return u.indexOf("/")===-1&&(u=I(u)),/^[a-zA-Z]:(\/|$)/.test(u)&&(u="/"+u),u}e.toPosixPath=y;function k(u,o=h.posix.sep){if(!u)return"";const f=u.length,p=u.charCodeAt(0);if(R(p)){if(R(u.charCodeAt(1))&&!R(u.charCodeAt(2))){let C=3;const P=C;for(;C<f&&!R(u.charCodeAt(C));C++);if(P!==C&&!R(u.charCodeAt(C+1))){for(C+=1;C<f;C++)if(R(u.charCodeAt(C)))return u.slice(0,C+1).replace(/[\\/]/g,o)}}return o}else if(T(p)&&u.charCodeAt(1)===58)return R(u.charCodeAt(2))?u.slice(0,2)+o:u.slice(0,2);let w=u.indexOf("://");if(w!==-1){for(w+=3;w<f;w++)if(R(u.charCodeAt(w)))return u.slice(0,w+1)}return""}e.getRoot=k;function t(u){if(!F.isWindows||!u||u.length<5)return!1;let o=u.charCodeAt(0);if(o!==92||(o=u.charCodeAt(1),o!==92))return!1;let f=2;const p=f;for(;f<u.length&&(o=u.charCodeAt(f),o!==92);f++);return!(p===f||(o=u.charCodeAt(f+1),isNaN(o)||o===92))}e.isUNC=t;const _=/[\\/:\*\?"<>\|]/g,r=/[\\/]/g,d=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function a(u,o=F.isWindows){const f=o?_:r;return!(!u||u.length===0||/^\s+$/.test(u)||(f.lastIndex=0,f.test(u))||o&&d.test(u)||u==="."||u===".."||o&&u[u.length-1]==="."||o&&u.length!==u.trim().length||u.length>255)}e.isValidBasename=a;function l(u,o,f){const p=u===o;return!f||p?p:!u||!o?!1:(0,E.equalsIgnoreCase)(u,o)}e.isEqual=l;function v(u,o,f,p=h.sep){if(u===o)return!0;if(!u||!o||o.length>u.length)return!1;if(f){if(!(0,E.startsWithIgnoreCase)(u,o))return!1;if(o.length===u.length)return!0;let C=o.length;return o.charAt(o.length-1)===p&&C--,u.charAt(C)===p}return o.charAt(o.length-1)!==p&&(o+=p),u.indexOf(o)===0}e.isEqualOrParent=v;function T(u){return u>=65&&u<=90||u>=97&&u<=122}e.isWindowsDriveLetter=T;function b(u,o){return F.isWindows&&u.endsWith(":")&&(u+=h.sep),(0,h.isAbsolute)(u)||(u=(0,h.join)(o,u)),u=(0,h.normalize)(u),F.isWindows?(u=(0,E.rtrim)(u,h.sep),u.endsWith(":")&&(u+=h.sep)):(u=(0,E.rtrim)(u,h.sep),u||(u=h.sep)),u}e.sanitizeFilePath=b;function c(u){const o=(0,h.normalize)(u);return F.isWindows?u.length>3?!1:g(o)&&(u.length===2||o.charCodeAt(2)===92):o===h.posix.sep}e.isRootOrDriveLetter=c;function g(u){return F.isWindows?T(u.charCodeAt(0))&&u.charCodeAt(1)===58:!1}e.hasDriveLetter=g;function S(u){return g(u)?u[0]:void 0}e.getDriveLetter=S;function i(u,o,f){return o.length>u.length?-1:u===o?0:(f&&(u=u.toLowerCase(),o=o.toLowerCase()),u.indexOf(o))}e.indexOfPath=i;function s(u){const o=u.split(":");let f,p,w;if(o.forEach(C=>{const P=Number(C);(0,A.isNumber)(P)?p===void 0?p=P:w===void 0&&(w=P):f=f?[f,C].join(":"):C}),!f)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:f,line:p!==void 0?p:void 0,column:w!==void 0?w:p!==void 0?1:void 0}}e.parseLineAndColumnAware=s}),define(be[22],Ee([0,1,10]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function F(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const v=Array.isArray(l)?[]:{};return Object.keys(l).forEach(T=>{l[T]&&typeof l[T]=="object"?v[T]=F(l[T]):v[T]=l[T]}),v}e.deepClone=F;function E(l){if(!l||typeof l!="object")return l;const v=[l];for(;v.length>0;){const T=v.shift();Object.freeze(T);for(const b in T)if(A.call(T,b)){const c=T[b];typeof c=="object"&&!Object.isFrozen(c)&&v.push(c)}}return l}e.deepFreeze=E;const A=Object.prototype.hasOwnProperty;function R(l,v){return I(l,v,new Set)}e.cloneAndChange=R;function I(l,v,T){if((0,h.isUndefinedOrNull)(l))return l;const b=v(l);if(typeof b!="undefined")return b;if((0,h.isArray)(l)){const c=[];for(const g of l)c.push(I(g,v,T));return c}if((0,h.isObject)(l)){if(T.has(l))throw new Error("Cannot clone recursive data-structure");T.add(l);const c={};for(let g in l)A.call(l,g)&&(c[g]=I(l[g],v,T));return T.delete(l),c}return l}function y(l,v,T=!0){return(0,h.isObject)(l)?((0,h.isObject)(v)&&Object.keys(v).forEach(b=>{b in l?T&&((0,h.isObject)(l[b])&&(0,h.isObject)(v[b])?y(l[b],v[b],T):l[b]=v[b]):l[b]=v[b]}),l):v}e.mixin=y;function k(l,v){if(l===v)return!0;if(l==null||v===null||v===void 0||typeof l!=typeof v||typeof l!="object"||Array.isArray(l)!==Array.isArray(v))return!1;let T,b;if(Array.isArray(l)){if(l.length!==v.length)return!1;for(T=0;T<l.length;T++)if(!k(l[T],v[T]))return!1}else{const c=[];for(b in l)c.push(b);c.sort();const g=[];for(b in v)g.push(b);if(g.sort(),!k(c,g))return!1;for(T=0;T<c.length;T++)if(!k(l[c[T]],v[c[T]]))return!1}return!0}e.equals=k;function t(l){const v=new Set;return JSON.stringify(l,(T,b)=>{if((0,h.isObject)(b)||Array.isArray(b)){if(v.has(b))return"[Circular]";v.add(b)}return b})}e.safeStringify=t;function _(l,v,T){const b=v(l);return typeof b=="undefined"?T:b}e.getOrDefault=_;function r(l,v){const T=Object.create(null);return!l||!v||Object.keys(v).forEach(c=>{const g=l[c],S=v[c];k(g,S)||(T[c]=S)}),T}e.distinct=r;function d(l,v){const T=v.toLowerCase(),b=Object.keys(l).find(c=>c.toLowerCase()===T);return b?l[b]:l[v]}e.getCaseInsensitive=d;function a(l,v){const T=Object.create(null);for(const b of Object.keys(l))v(b,l[b])&&(T[b]=l[b]);return T}e.filter=a});var et=this&&this.__classPrivateFieldSet||function(re,e,h,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(re,h):E?E.value=h:e.set(re,h),h},Oe=this&&this.__classPrivateFieldGet||function(re,e,h,F){if(h==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!F:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?F:h==="a"?F.call(re):F?F.value:e.get(re)};define(be[20],Ee([0,1,9,2]),function(re,e,h,F){"use strict";var E,A,R;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function I(i,s,u){let o=i.get(s);return o===void 0&&(o=u,i.set(s,o)),o}e.getOrSet=I;function y(i){const s=[];return i.forEach((u,o)=>{s.push(`${o} => ${u}`)}),`Map(${i.size}) {${s.join(", ")}}`}e.mapToString=y;function k(i){const s=[];return i.forEach(u=>{s.push(u)}),`Set(${i.size}) {${s.join(", ")}}`}e.setToString=k;class t{constructor(){this._value="",this._pos=0}reset(s){return this._value=s,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(s){const u=s.charCodeAt(0),o=this._value.charCodeAt(this._pos);return u-o}value(){return this._value[this._pos]}}e.StringIterator=t;class _{constructor(s=!0){this._caseSensitive=s}reset(s){return this._value=s,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(s)this._from++;else break;else s=!1;return this}cmp(s){return this._caseSensitive?(0,h.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,h.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=_;class r{constructor(s=!0,u=!0){this._splitOnBackslash=s,this._caseSensitive=u}reset(s){return this._value=s.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let s=!0;for(;this._to<this._value.length;this._to++){const u=this._value.charCodeAt(this._to);if(u===47||this._splitOnBackslash&&u===92)if(s)this._from++;else break;else s=!1}return this}cmp(s){return this._caseSensitive?(0,h.compareSubstring)(s,this._value,0,s.length,this._from,this._to):(0,h.compareSubstringIgnoreCase)(s,this._value,0,s.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=r;var d;(function(i){i[i.Scheme=1]="Scheme",i[i.Authority=2]="Authority",i[i.Path=3]="Path",i[i.Query=4]="Query",i[i.Fragment=5]="Fragment"})(d||(d={}));class a{constructor(s){this._ignorePathCasing=s,this._states=[],this._stateIdx=0}reset(s){return this._value=s,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new r(!1,!this._ignorePathCasing(s)),this._pathIterator.reset(s.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(s){if(this._states[this._stateIdx]===1)return(0,h.compareIgnoreCase)(s,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,h.compareIgnoreCase)(s,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(s);if(this._states[this._stateIdx]===4)return(0,h.compare)(s,this._value.query);if(this._states[this._stateIdx]===5)return(0,h.compare)(s,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=a;class l{isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}}class v{constructor(s){this._iter=s}static forUris(s=()=>!1){return new v(new a(s))}static forPaths(){return new v(new r)}static forStrings(){return new v(new t)}static forConfigKeys(){return new v(new _)}clear(){this._root=void 0}set(s,u){const o=this._iter.reset(s);let f;for(this._root||(this._root=new l,this._root.segment=o.value()),f=this._root;;){const w=o.cmp(f.segment);if(w>0)f.left||(f.left=new l,f.left.segment=o.value()),f=f.left;else if(w<0)f.right||(f.right=new l,f.right.segment=o.value()),f=f.right;else if(o.hasNext())o.next(),f.mid||(f.mid=new l,f.mid.segment=o.value()),f=f.mid;else break}const p=f.value;return f.value=u,f.key=s,p}get(s){return this._getNode(s)?.value}_getNode(s){const u=this._iter.reset(s);let o=this._root;for(;o;){const f=u.cmp(o.segment);if(f>0)o=o.left;else if(f<0)o=o.right;else if(u.hasNext())u.next(),o=o.mid;else break}return o}has(s){const u=this._getNode(s);return!(u?.value===void 0&&u?.mid===void 0)}delete(s){return this._delete(s,!1)}deleteSuperstr(s){return this._delete(s,!0)}_delete(s,u){const o=this._iter.reset(s),f=[];let p=this._root;for(;p;){const w=o.cmp(p.segment);if(w>0)f.push([1,p]),p=p.left;else if(w<0)f.push([-1,p]),p=p.right;else if(o.hasNext())o.next(),f.push([0,p]),p=p.mid;else{for(u?(p.left=void 0,p.mid=void 0,p.right=void 0):p.value=void 0;f.length>0&&p.isEmpty();){let[C,P]=f.pop();switch(C){case 1:P.left=void 0;break;case 0:P.mid=void 0;break;case-1:P.right=void 0;break}p=P}break}}}findSubstr(s){const u=this._iter.reset(s);let o=this._root,f;for(;o;){const p=u.cmp(o.segment);if(p>0)o=o.left;else if(p<0)o=o.right;else if(u.hasNext())u.next(),f=o.value||f,o=o.mid;else break}return o&&o.value||f}findSuperstr(s){const u=this._iter.reset(s);let o=this._root;for(;o;){const f=u.cmp(o.segment);if(f>0)o=o.left;else if(f<0)o=o.right;else if(u.hasNext())u.next(),o=o.mid;else return o.mid?this._entries(o.mid):void 0}}forEach(s){for(const[u,o]of this)s(o,u)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(s){if(!s)return;const u=[s];for(;u.length>0;){const o=u.pop();o&&(o.value&&(yield[o.key,o.value]),o.left&&u.push(o.left),o.mid&&u.push(o.mid),o.right&&u.push(o.right))}}}e.TernarySearchTree=v;class T{constructor(s,u){this[E]="ResourceMap",s instanceof T?(this.map=new Map(s.map),this.toKey=u??T.defaultToKey):(this.map=new Map,this.toKey=s??T.defaultToKey)}set(s,u){return this.map.set(this.toKey(s),u),this}get(s){return this.map.get(this.toKey(s))}has(s){return this.map.has(this.toKey(s))}get size(){return this.map.size}clear(){this.map.clear()}delete(s){return this.map.delete(this.toKey(s))}forEach(s,u){typeof u!="undefined"&&(s=s.bind(u));for(let[o,f]of this.map)s(f,F.URI.parse(o),this)}values(){return this.map.values()}*keys(){for(let s of this.map.keys())yield F.URI.parse(s)}*entries(){for(let s of this.map.entries())yield[F.URI.parse(s[0]),s[1]]}*[(E=Symbol.toStringTag,Symbol.iterator)](){for(let s of this.map)yield[F.URI.parse(s[0]),s[1]]}}e.ResourceMap=T,T.defaultToKey=i=>i.toString();var b;(function(i){i[i.None=0]="None",i[i.AsOld=1]="AsOld",i[i.AsNew=2]="AsNew"})(b=e.Touch||(e.Touch={}));class c{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(s){return this._map.has(s)}get(s,u=0){const o=this._map.get(s);if(!!o)return u!==0&&this.touch(o,u),o.value}set(s,u,o=0){let f=this._map.get(s);if(f)f.value=u,o!==0&&this.touch(f,o);else{switch(f={key:s,value:u,next:void 0,previous:void 0},o){case 0:this.addItemLast(f);break;case 1:this.addItemFirst(f);break;case 2:this.addItemLast(f);break;default:this.addItemLast(f);break}this._map.set(s,f),this._size++}return this}delete(s){return!!this.remove(s)}remove(s){const u=this._map.get(s);if(!!u)return this._map.delete(s),this.removeItem(u),this._size--,u.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const s=this._head;return this._map.delete(s.key),this.removeItem(s),this._size--,s.value}forEach(s,u){const o=this._state;let f=this._head;for(;f;){if(u?s.bind(u)(f.value,f.key,this):s(f.value,f.key,this),this._state!==o)throw new Error("LinkedMap got modified during iteration.");f=f.next}}keys(){const s=this,u=this._state;let o=this._head;const f={[Symbol.iterator](){return f},next(){if(s._state!==u)throw new Error("LinkedMap got modified during iteration.");if(o){const p={value:o.key,done:!1};return o=o.next,p}else return{value:void 0,done:!0}}};return f}values(){const s=this,u=this._state;let o=this._head;const f={[Symbol.iterator](){return f},next(){if(s._state!==u)throw new Error("LinkedMap got modified during iteration.");if(o){const p={value:o.value,done:!1};return o=o.next,p}else return{value:void 0,done:!0}}};return f}entries(){const s=this,u=this._state;let o=this._head;const f={[Symbol.iterator](){return f},next(){if(s._state!==u)throw new Error("LinkedMap got modified during iteration.");if(o){const p={value:[o.key,o.value],done:!1};return o=o.next,p}else return{value:void 0,done:!0}}};return f}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(s){if(s>=this.size)return;if(s===0){this.clear();return}let u=this._head,o=this.size;for(;u&&o>s;)this._map.delete(u.key),u=u.next,o--;this._head=u,this._size=o,u&&(u.previous=void 0),this._state++}addItemFirst(s){if(!this._head&&!this._tail)this._tail=s;else if(this._head)s.next=this._head,this._head.previous=s;else throw new Error("Invalid list");this._head=s,this._state++}addItemLast(s){if(!this._head&&!this._tail)this._head=s;else if(this._tail)s.previous=this._tail,this._tail.next=s;else throw new Error("Invalid list");this._tail=s,this._state++}removeItem(s){if(s===this._head&&s===this._tail)this._head=void 0,this._tail=void 0;else if(s===this._head){if(!s.next)throw new Error("Invalid list");s.next.previous=void 0,this._head=s.next}else if(s===this._tail){if(!s.previous)throw new Error("Invalid list");s.previous.next=void 0,this._tail=s.previous}else{const u=s.next,o=s.previous;if(!u||!o)throw new Error("Invalid list");u.previous=o,o.next=u}s.next=void 0,s.previous=void 0,this._state++}touch(s,u){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(u!==1&&u!==2)){if(u===1){if(s===this._head)return;const o=s.next,f=s.previous;s===this._tail?(f.next=void 0,this._tail=f):(o.previous=f,f.next=o),s.previous=void 0,s.next=this._head,this._head.previous=s,this._head=s,this._state++}else if(u===2){if(s===this._tail)return;const o=s.next,f=s.previous;s===this._head?(o.previous=void 0,this._head=o):(o.previous=f,f.next=o),s.next=void 0,s.previous=this._tail,this._tail.next=s,this._tail=s,this._state++}}}toJSON(){const s=[];return this.forEach((u,o)=>{s.push([o,u])}),s}fromJSON(s){this.clear();for(const[u,o]of s)this.set(u,o)}}e.LinkedMap=c;class g extends c{constructor(s,u=1){super();this._limit=s,this._ratio=Math.min(Math.max(0,u),1)}get limit(){return this._limit}set limit(s){this._limit=s,this.checkTrim()}get ratio(){return this._ratio}set ratio(s){this._ratio=Math.min(Math.max(0,s),1),this.checkTrim()}get(s,u=2){return super.get(s,u)}peek(s){return super.get(s,0)}set(s,u){return super.set(s,u,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=g;class S{constructor(s){R.set(this,void 0),et(this,R,s,"f")}get size(){return Oe(this,R,"f").size}forEach(s,u){Oe(this,R,"f").forEach(s,u)}get(s){return Oe(this,R,"f").get(s)}has(s){return Oe(this,R,"f").has(s)}entries(){return Oe(this,R,"f").entries()}keys(){return Oe(this,R,"f").keys()}values(){return Oe(this,R,"f").values()}[(R=new WeakMap,Symbol.iterator)](){return Oe(this,R,"f").entries()}}e.ReadonlyMapView=S}),define(be[105],Ee([0,1,20,9]),function(re,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function E(...H){return function(ne,fe){for(let Te=0,xe=H.length;Te<xe;Te++){const $e=H[Te](ne,fe);if($e)return $e}return null}}e.or=E,e.matchesStrictPrefix=A.bind(void 0,!1),e.matchesPrefix=A.bind(void 0,!0);function A(H,ne,fe){if(!fe||fe.length<ne.length)return null;let Te;return H?Te=F.startsWithIgnoreCase(fe,ne):Te=fe.indexOf(ne)===0,Te?ne.length>0?[{start:0,end:ne.length}]:[]:null}function R(H,ne){const fe=ne.toLowerCase().indexOf(H.toLowerCase());return fe===-1?null:[{start:fe,end:fe+H.length}]}e.matchesContiguousSubString=R;function I(H,ne){return y(H.toLowerCase(),ne.toLowerCase(),0,0)}e.matchesSubString=I;function y(H,ne,fe,Te){if(fe===H.length)return[];if(Te===ne.length)return null;if(H[fe]===ne[Te]){let xe=null;return(xe=y(H,ne,fe+1,Te+1))?T({start:Te,end:Te+1},xe):null}return y(H,ne,fe,Te+1)}function k(H){return 97<=H&&H<=122}function t(H){return 65<=H&&H<=90}e.isUpper=t;function _(H){return 48<=H&&H<=57}function r(H){return H===32||H===9||H===10||H===13}const d=new Set;"`~!@#$%^&*()-=+[{]}\\|;:'\",.<>/?".split("").forEach(H=>d.add(H.charCodeAt(0)));function a(H){return r(H)||d.has(H)}function l(H,ne){return H===ne||a(H)&&a(ne)}function v(H){return k(H)||t(H)||_(H)}function T(H,ne){return ne.length===0?ne=[H]:H.end===ne[0].start?ne[0].start=H.start:ne.unshift(H),ne}function b(H,ne){for(let fe=ne;fe<H.length;fe++){const Te=H.charCodeAt(fe);if(t(Te)||_(Te)||fe>0&&!v(H.charCodeAt(fe-1)))return fe}return H.length}function c(H,ne,fe,Te){if(fe===H.length)return[];if(Te===ne.length)return null;if(H[fe]!==ne[Te].toLowerCase())return null;{let xe=null,$e=Te+1;for(xe=c(H,ne,fe+1,Te+1);!xe&&($e=b(ne,$e))<ne.length;)xe=c(H,ne,fe+1,$e),$e++;return xe===null?null:T({start:Te,end:Te+1},xe)}}function g(H){let ne=0,fe=0,Te=0,xe=0,$e=0;for(let he=0;he<H.length;he++)$e=H.charCodeAt(he),t($e)&&ne++,k($e)&&fe++,v($e)&&Te++,_($e)&&xe++;const we=ne/H.length,Xe=fe/H.length,z=Te/H.length,K=xe/H.length;return{upperPercent:we,lowerPercent:Xe,alphaPercent:z,numericPercent:K}}function S(H){const{upperPercent:ne,lowerPercent:fe}=H;return fe===0&&ne>.6}function i(H){const{upperPercent:ne,lowerPercent:fe,alphaPercent:Te,numericPercent:xe}=H;return fe>.2&&ne<.8&&Te>.6&&xe<.2}function s(H){let ne=0,fe=0,Te=0,xe=0;for(let $e=0;$e<H.length;$e++)Te=H.charCodeAt($e),t(Te)&&ne++,k(Te)&&fe++,r(Te)&&xe++;return(ne===0||fe===0)&&xe===0?H.length<=30:ne<=5}function u(H,ne){if(!ne||(ne=ne.trim(),ne.length===0)||!s(H)||ne.length>60)return null;const fe=g(ne);if(!i(fe)){if(!S(fe))return null;ne=ne.toLowerCase()}let Te=null,xe=0;for(H=H.toLowerCase();xe<ne.length&&(Te=c(H,ne,0,xe))===null;)xe=b(ne,xe+1);return Te}e.matchesCamelCase=u;function o(H,ne,fe=!1){if(!ne||ne.length===0)return null;let Te=null,xe=0;for(H=H.toLowerCase(),ne=ne.toLowerCase();xe<ne.length&&(Te=f(H,ne,0,xe,fe))===null;)xe=p(ne,xe+1);return Te}e.matchesWords=o;function f(H,ne,fe,Te,xe){if(fe===H.length)return[];if(Te===ne.length)return null;if(l(H.charCodeAt(fe),ne.charCodeAt(Te))){let $e=null,we=Te+1;if($e=f(H,ne,fe+1,Te+1,xe),!xe)for(;!$e&&(we=p(ne,we))<ne.length;)$e=f(H,ne,fe+1,we,xe),we++;return $e===null?null:T({start:Te,end:Te+1},$e)}else return null}function p(H,ne){for(let fe=ne;fe<H.length;fe++)if(a(H.charCodeAt(fe))||fe>0&&a(H.charCodeAt(fe-1)))return fe;return H.length}const w=E(e.matchesPrefix,u,R),C=E(e.matchesPrefix,u,I),P=new h.LRUCache(1e4);function n(H,ne,fe=!1){if(typeof H!="string"||typeof ne!="string")return null;let Te=P.get(H);Te||(Te=new RegExp(F.convertSimple2RegExpPattern(H),"i"),P.set(H,Te));const xe=Te.exec(ne);return xe?[{start:xe.index,end:xe.index+xe[0].length}]:fe?C(H,ne):w(H,ne)}e.matchesFuzzy=n;function m(H,ne){const fe=Qe(H,H.toLowerCase(),0,ne,ne.toLowerCase(),0,!0);return fe?O(fe):null}e.matchesFuzzy2=m;function D(H,ne,fe,Te,xe,$e){const we=Math.min(13,H.length);for(;fe<we;fe++){const Xe=Qe(H,ne,fe,Te,xe,$e,!1);if(Xe)return Xe}return[0,$e]}e.anyScore=D;function O(H){if(typeof H=="undefined")return[];const ne=[],fe=H[1];for(let Te=H.length-1;Te>1;Te--){const xe=H[Te]+fe,$e=ne[ne.length-1];$e&&$e.end===xe?$e.end=xe+1:ne.push({start:xe,end:xe+1})}return ne}e.createMatches=O;const $=128;function Q(){const H=[],ne=[];for(let fe=0;fe<=$;fe++)ne[fe]=0;for(let fe=0;fe<=$;fe++)H.push(ne.slice(0));return H}function ie(H){const ne=[];for(let fe=0;fe<=H;fe++)ne[fe]=0;return ne}const V=ie(2*$),W=ie(2*$),L=Q(),Y=Q(),B=Q(),G=!1;function de(H,ne,fe,Te,xe){function $e(Xe,z,K=" "){for(;Xe.length<z;)Xe=K+Xe;return Xe}let we=` |   |${Te.split("").map(Xe=>$e(Xe,3)).join("|")}
`;for(let Xe=0;Xe<=fe;Xe++)Xe===0?we+=" |":we+=`${ne[Xe-1]}|`,we+=H[Xe].slice(0,xe+1).map(z=>$e(z.toString(),3)).join("|")+`
`;return we}function j(H,ne,fe,Te){H=H.substr(ne),fe=fe.substr(Te),console.log(de(Y,H,H.length,fe,fe.length)),console.log(de(B,H,H.length,fe,fe.length)),console.log(de(L,H,H.length,fe,fe.length))}function le(H,ne){if(ne<0||ne>=H.length)return!1;const fe=H.codePointAt(ne);switch(fe){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 40:case 91:return!0;case void 0:return!1;default:return!!F.isEmojiImprecise(fe)}}function ae(H,ne){if(ne<0||ne>=H.length)return!1;switch(H.charCodeAt(ne)){case 32:case 9:return!0;default:return!1}}function ve(H,ne,fe){return ne[H]!==fe[H]}function Re(H,ne,fe,Te,xe,$e,we=!1){for(;ne<fe&&xe<$e;)H[ne]===Te[xe]&&(we&&(V[ne]=xe),ne+=1),xe+=1;return ne===fe}e.isPatternInWord=Re;var Fe;(function(H){H[H.Diag=1]="Diag",H[H.Left=2]="Left",H[H.LeftLeft=3]="LeftLeft"})(Fe||(Fe={}));var Ne;(function(H){H.Default=[-100,0];function ne(fe){return!fe||fe.length===2&&fe[0]===-100&&fe[1]===0}H.isDefault=ne})(Ne=e.FuzzyScore||(e.FuzzyScore={}));function Qe(H,ne,fe,Te,xe,$e,we){const Xe=H.length>$?$:H.length,z=Te.length>$?$:Te.length;if(fe>=Xe||$e>=z||Xe-fe>z-$e||!Re(ne,fe,Xe,xe,$e,z,!0))return;He(Xe,z,fe,$e,ne,xe);let K=1,he=1,Le=fe,Ve=$e;const tt=[!1];for(K=1,Le=fe;Le<Xe;K++,Le++){const dt=V[Le],bt=W[Le],mt=Le+1<Xe?W[Le+1]:z;for(he=dt-$e+1,Ve=dt;Ve<mt;he++,Ve++){let Et=Number.MIN_SAFE_INTEGER,Ye=!1;Ve<=bt&&(Et=Ke(H,ne,Le,fe,Te,xe,Ve,z,$e,L[K-1][he-1]===0,tt));let Ct=0;Et!==Number.MAX_SAFE_INTEGER&&(Ye=!0,Ct=Et+Y[K-1][he-1]);const Pe=Ve>dt,ye=Pe?Y[K][he-1]+(L[K][he-1]>0?-5:0):0,ke=Ve>dt+1&&L[K][he-1]>0,X=ke?Y[K][he-2]+(L[K][he-2]>0?-5:0):0;if(ke&&(!Pe||X>=ye)&&(!Ye||X>=Ct))Y[K][he]=X,B[K][he]=3,L[K][he]=0;else if(Pe&&(!Ye||ye>=Ct))Y[K][he]=ye,B[K][he]=2,L[K][he]=0;else if(Ye)Y[K][he]=Ct,B[K][he]=1,L[K][he]=L[K-1][he-1]+1;else throw new Error("not possible")}}if(G&&j(H,fe,Te,$e),!tt[0]&&!we)return;K--,he--;const lt=[Y[K][he],$e];let ft=0,St=0;for(;K>=1;){let dt=he;do{const bt=B[K][dt];if(bt===3)dt=dt-2;else if(bt===2)dt=dt-1;else break}while(dt>=1);ft>1&&ne[fe+K-1]===xe[$e+he-1]&&!ve(dt+$e-1,Te,xe)&&ft+1>L[K][dt]&&(dt=he),dt===he?ft++:ft=1,St||(St=dt),K--,he=dt-1,lt.push(he)}z===Xe&&(lt[0]+=2);const Pt=St-Xe;return lt[0]-=Pt,lt}e.fuzzyScore=Qe;function He(H,ne,fe,Te,xe,$e){let we=H-1,Xe=ne-1;for(;we>=fe&&Xe>=Te;)xe[we]===$e[Xe]&&(W[we]=Xe,we--),Xe--}function Ke(H,ne,fe,Te,xe,$e,we,Xe,z,K,he){if(ne[fe]!==$e[we])return Number.MIN_SAFE_INTEGER;let Le=1,Ve=!1;return we===fe-Te?Le=H[fe]===xe[we]?7:5:ve(we,xe,$e)&&(we===0||!ve(we-1,xe,$e))?(Le=H[fe]===xe[we]?7:5,Ve=!0):le($e,we)&&(we===0||!le($e,we-1))?Le=5:(le($e,we-1)||ae($e,we-1))&&(Le=5,Ve=!0),Le>1&&fe===Te&&(he[0]=!0),Ve||(Ve=ve(we,xe,$e)||le($e,we-1)||ae($e,we-1)),fe===Te?we>z&&(Le-=Ve?3:5):K?Le+=Ve?2:0:Le+=Ve?0:1,we+1===Xe&&(Le-=Ve?3:5),Le}function x(H,ne,fe,Te,xe,$e,we){return Z(H,ne,fe,Te,xe,$e,!0,we)}e.fuzzyScoreGracefulAggressive=x;function q(H,ne,fe,Te,xe,$e,we){return Z(H,ne,fe,Te,xe,$e,!1,we)}e.fuzzyScoreGraceful=q;function Z(H,ne,fe,Te,xe,$e,we,Xe){let z=Qe(H,ne,fe,Te,xe,$e,Xe);if(z&&!we)return z;if(H.length>=3){const K=Math.min(7,H.length-1);for(let he=fe+1;he<K;he++){const Le=se(H,he);if(Le){const Ve=Qe(Le,Le.toLowerCase(),fe,Te,xe,$e,Xe);Ve&&(Ve[0]-=3,(!z||Ve[0]>z[0])&&(z=Ve))}}}return z}function se(H,ne){if(ne+1>=H.length)return;const fe=H[ne],Te=H[ne+1];if(fe!==Te)return H.slice(0,ne)+Te+fe+H.slice(ne+2)}}),define(be[106],Ee([0,1,34,105,9]),function(re,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const A=new RegExp(`\\$\\(${h.CSSIcon.iconNameExpression}(?:${h.CSSIcon.iconModifierExpression})?\\)`,"g"),R=new RegExp(`(\\\\)?${A.source}`,"g");function I(l){return l.replace(R,(v,T)=>T?v:`\\${v}`)}e.escapeIcons=I;const y=new RegExp(`\\\\${A.source}`,"g");function k(l){return l.replace(y,v=>`\\${v}`)}e.markdownEscapeEscapedIcons=k;const t=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function _(l){return l.indexOf(e.iconStartMarker)===-1?l:l.replace(t,(v,T,b,c)=>b?v:T||c||"")}e.stripIcons=_;function r(l){const v=l.indexOf(e.iconStartMarker);return v===-1?{text:l}:d(l,v)}e.parseLabelWithIcons=r;function d(l,v){const T=[];let b="";function c(p){if(p){b+=p;for(const w of p)T.push(i)}}let g=-1,S="",i=0,s,u,o=v;const f=l.length;for(c(l.substr(0,v));o<f;)s=l[o],u=l[o+1],s===e.iconStartMarker[0]&&u===e.iconStartMarker[1]?(g=o,c(S),S=e.iconStartMarker,o++):s===")"&&g!==-1?(i+=o-g+1,g=-1,S=""):g!==-1?/^[a-z0-9\-]$/i.test(s)?S+=s:(c(S),g=-1,S=""):c(s),o++;return c(S),{text:b,iconOffsets:T}}function a(l,v,T=!1){const{text:b,iconOffsets:c}=v;if(!c||c.length===0)return(0,F.matchesFuzzy)(l,b,T);const g=(0,E.ltrim)(b," "),S=b.length-g.length,i=(0,F.matchesFuzzy)(l,g,T);if(i)for(const s of i){const u=c[s.start+S]+S;s.start+=u,s.end+=u}return i}e.matchesFuzzyIconAware=a}),define(be[76],Ee([0,1,15,106]),function(re,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var E;(function(r){r[r.Paragraph=0]="Paragraph",r[r.Break=1]="Break"})(E=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class A{constructor(d="",a=!1){if(this.value=d,typeof this.value!="string")throw(0,h.illegalArgument)("value");typeof a=="boolean"?(this.isTrusted=a,this.supportThemeIcons=!1):(this.isTrusted=a.isTrusted??void 0,this.supportThemeIcons=a.supportThemeIcons??!1)}appendText(d,a=0){return this.value+=k(this.supportThemeIcons?(0,F.escapeIcons)(d):d).replace(/([ \t]+)/g,(l,v)=>"&nbsp;".repeat(v.length)).replace(/^>/gm,"\\>").replace(/\n/g,a===1?`\\
`:`

`),this}appendMarkdown(d){return this.value+=d,this}appendCodeblock(d,a){return this.value+="\n```",this.value+=d,this.value+=`
`,this.value+=a,this.value+="\n```\n",this}}e.MarkdownString=A;function R(r){return I(r)?!r.value:Array.isArray(r)?r.every(R):!0}e.isEmptyMarkdownString=R;function I(r){return r instanceof A?!0:r&&typeof r=="object"?typeof r.value=="string"&&(typeof r.isTrusted=="boolean"||r.isTrusted===void 0)&&(typeof r.supportThemeIcons=="boolean"||r.supportThemeIcons===void 0):!1}e.isMarkdownString=I;function y(r,d){return r===d?!0:!r||!d?!1:r.value===d.value&&r.isTrusted===d.isTrusted&&r.supportThemeIcons===d.supportThemeIcons}e.markdownStringEqual=y;function k(r){return r.replace(/[\\`*_{}[\]()#+\-.!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=k;function t(r){return r&&r.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=t;function _(r){const d=[],a=r.split("|").map(v=>v.trim());r=a[0];const l=a[1];if(l){const v=/height=(\d+)/.exec(l),T=/width=(\d+)/.exec(l),b=v?v[1]:"",c=T?T[1]:"",g=isFinite(parseInt(c)),S=isFinite(parseInt(b));g&&d.push(`width="${c}"`),S&&d.push(`height="${b}"`)}return{href:r,dimensions:d}}e.parseHrefAndDimensions=_}),define(be[53],Ee([0,1,23,9,2]),function(re,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function A(t){return JSON.stringify(t,y)}e.stringify=A;function R(t){let _=JSON.parse(t);return _=k(_),_}e.parse=R;var I;(function(t){t[t.Uri=1]="Uri",t[t.Regexp=2]="Regexp",t[t.ScmResource=3]="ScmResource",t[t.ScmResourceGroup=4]="ScmResourceGroup",t[t.ScmProvider=5]="ScmProvider",t[t.CommentController=6]="CommentController",t[t.CommentThread=7]="CommentThread",t[t.CommentThreadReply=8]="CommentThreadReply",t[t.CommentNode=9]="CommentNode",t[t.CommentThreadNode=10]="CommentThreadNode",t[t.TimelineActionContext=11]="TimelineActionContext",t[t.NotebookCellActionContext=12]="NotebookCellActionContext",t[t.TestItemContext=13]="TestItemContext"})(I=e.MarshalledId||(e.MarshalledId={}));function y(t,_){return _ instanceof RegExp?{$mid:2,source:_.source,flags:(0,F.regExpFlags)(_)}:_}function k(t,_=0){if(!t||_>200)return t;if(typeof t=="object"){switch(t.$mid){case 1:return E.URI.revive(t);case 2:return new RegExp(t.source,t.flags)}if(t instanceof h.VSBuffer||t instanceof Uint8Array)return t;if(Array.isArray(t))for(let r=0;r<t.length;++r)t[r]=k(t[r],_+1);else for(const r in t)Object.hasOwnProperty.call(t,r)&&(t[r]=k(t[r],_+1))}return t}e.revive=k}),define(be[11],Ee([0,1,26,2]),function(re,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var E;(function(I){I.inMemory="inmemory",I.vscode="vscode",I.internal="private",I.walkThrough="walkThrough",I.walkThroughSnippet="walkThroughSnippet",I.http="http",I.https="https",I.file="file",I.mailto="mailto",I.untitled="untitled",I.data="data",I.command="command",I.vscodeRemote="vscode-remote",I.vscodeRemoteResource="vscode-remote-resource",I.userData="vscode-userdata",I.vscodeCustomEditor="vscode-custom-editor",I.vscodeNotebook="vscode-notebook",I.vscodeNotebookCell="vscode-notebook-cell",I.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",I.vscodeNotebookCellOutput="vscode-notebook-cell-output",I.vscodeInteractive="vscode-interactive",I.vscodeInteractiveInput="vscode-interactive-input",I.vscodeSettings="vscode-settings",I.vscodeWorkspaceTrust="vscode-workspace-trust",I.vscodeTerminal="vscode-terminal",I.webviewPanel="webview-panel",I.vscodeWebview="vscode-webview",I.extension="extension",I.vscodeFileResource="vscode-file",I.tmp="tmp"})(E=e.Schemas||(e.Schemas={}));class A{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(y){this._preferredWebSchema=y}setDelegate(y){this._delegate=y}set(y,k,t){this._hosts[y]=k,this._ports[y]=t}setConnectionToken(y,k){this._connectionTokens[y]=k}rewrite(y){if(this._delegate)return this._delegate(y);const k=y.authority;let t=this._hosts[k];t&&t.indexOf(":")!==-1&&(t=`[${t}]`);const _=this._ports[k],r=this._connectionTokens[k];let d=`path=${encodeURIComponent(y.path)}`;return typeof r=="string"&&(d+=`&tkn=${encodeURIComponent(r)}`),F.URI.from({scheme:h.isWeb?this._preferredWebSchema:E.vscodeRemoteResource,authority:`${t}:${_}`,path:"/vscode-remote-resource",query:d})}}e.RemoteAuthorities=new A;class R{asBrowserUri(y,k){const t=this.toUri(y,k);return t.scheme===E.vscodeRemote?e.RemoteAuthorities.rewrite(t):t.scheme===E.file&&(h.isNative||typeof h.globals.importScripts=="function"&&h.globals.origin===`${E.vscodeFileResource}://${R.FALLBACK_AUTHORITY}`)?t.with({scheme:E.vscodeFileResource,authority:t.authority||R.FALLBACK_AUTHORITY,query:null,fragment:null}):t}asFileUri(y,k){const t=this.toUri(y,k);return t.scheme===E.vscodeFileResource?t.with({scheme:E.file,authority:t.authority!==R.FALLBACK_AUTHORITY?t.authority:null,query:null,fragment:null}):t}toUri(y,k){return F.URI.isUri(y)?y:F.URI.parse(k.toUrl(y))}}R.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new R}),define(be[24],Ee([0,1,40,11,17,26,9,2]),function(re,e,h,F,E,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function y(d){return(0,I.uriToFsPath)(d,!0)}e.originalFSPath=y;class k{constructor(a){this._ignorePathCasing=a}compare(a,l,v=!1){return a===l?0:(0,R.compare)(this.getComparisonKey(a,v),this.getComparisonKey(l,v))}isEqual(a,l,v=!1){return a===l?!0:!a||!l?!1:this.getComparisonKey(a,v)===this.getComparisonKey(l,v)}getComparisonKey(a,l=!1){return a.with({path:this._ignorePathCasing(a)?a.path.toLowerCase():void 0,fragment:l?null:void 0}).toString()}ignorePathCasing(a){return this._ignorePathCasing(a)}isEqualOrParent(a,l,v=!1){if(a.scheme===l.scheme){if(a.scheme===F.Schemas.file)return h.isEqualOrParent(y(a),y(l),this._ignorePathCasing(a))&&a.query===l.query&&(v||a.fragment===l.fragment);if((0,e.isEqualAuthority)(a.authority,l.authority))return h.isEqualOrParent(a.path,l.path,this._ignorePathCasing(a),"/")&&a.query===l.query&&(v||a.fragment===l.fragment)}return!1}joinPath(a,...l){return I.URI.joinPath(a,...l)}basenameOrAuthority(a){return(0,e.basename)(a)||a.authority}basename(a){return E.posix.basename(a.path)}extname(a){const l=E.posix.extname(a.path),v=l.indexOf("?");return v!==-1?l.substr(0,v):l}dirname(a){if(a.path.length===0)return a;let l;return a.scheme===F.Schemas.file?l=I.URI.file(E.dirname(y(a))).path:(l=E.posix.dirname(a.path),a.authority&&l.length&&l.charCodeAt(0)!==47&&(console.error(`dirname("${a.toString})) resulted in a relative path`),l="/")),a.with({path:l})}normalizePath(a){if(!a.path.length)return a;let l;return a.scheme===F.Schemas.file?l=I.URI.file(E.normalize(y(a))).path:l=E.posix.normalize(a.path),a.with({path:l})}relativePath(a,l){if(a.scheme!==l.scheme||!(0,e.isEqualAuthority)(a.authority,l.authority))return;if(a.scheme===F.Schemas.file){const b=E.relative(y(a),y(l));return A.isWindows?h.toSlashes(b):b}let v=a.path||"/",T=l.path||"/";if(this._ignorePathCasing(a)){let b=0;for(const c=Math.min(v.length,T.length);b<c&&!(v.charCodeAt(b)!==T.charCodeAt(b)&&v.charAt(b).toLowerCase()!==T.charAt(b).toLowerCase());b++);v=T.substr(0,b)+v.substr(b)}return E.posix.relative(v,T)}resolvePath(a,l){if(a.scheme===F.Schemas.file){const v=I.URI.file(E.resolve(y(a),l));return a.with({authority:v.authority,path:v.path})}return l=h.toPosixPath(l),a.with({path:E.posix.resolve(a.path,l)})}isAbsolutePath(a){return!!a.path&&a.path[0]==="/"}isEqualAuthority(a,l){return a===l||(0,R.equalsIgnoreCase)(a,l)}hasTrailingPathSeparator(a,l=E.sep){if(a.scheme===F.Schemas.file){const v=y(a);return v.length>h.getRoot(v).length&&v[v.length-1]===l}else{const v=a.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(a.fsPath)}}removeTrailingPathSeparator(a,l=E.sep){return(0,e.hasTrailingPathSeparator)(a,l)?a.with({path:a.path.substr(0,a.path.length-1)}):a}addTrailingPathSeparator(a,l=E.sep){let v=!1;if(a.scheme===F.Schemas.file){const T=y(a);v=T!==void 0&&T.length===h.getRoot(T).length&&T[T.length-1]===l}else{l="/";const T=a.path;v=T.length===1&&T.charCodeAt(T.length-1)===47}return!v&&!(0,e.hasTrailingPathSeparator)(a,l)?a.with({path:a.path+"/"}):a}}e.ExtUri=k,e.extUri=new k(()=>!1),e.extUriBiasedIgnorePathCase=new k(d=>d.scheme===F.Schemas.file?!A.isLinux:!0),e.extUriIgnorePathCase=new k(d=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function t(d,a){const l=[];for(let v=0;v<d.length;v++){const T=a(d[v]);d.some((b,c)=>c===v?!1:(0,e.isEqualOrParent)(T,a(b)))||l.push(d[v])}return l}e.distinctParents=t;var _;(function(d){d.META_DATA_LABEL="label",d.META_DATA_DESCRIPTION="description",d.META_DATA_SIZE="size",d.META_DATA_MIME="mime";function a(l){const v=new Map;l.path.substring(l.path.indexOf(";")+1,l.path.lastIndexOf(";")).split(";").forEach(c=>{const[g,S]=c.split(":");g&&S&&v.set(g,S)});const b=l.path.substring(0,l.path.indexOf(";"));return b&&v.set(d.META_DATA_MIME,b),v}d.parseMetaData=a})(_=e.DataUri||(e.DataUri={}));function r(d,a,l){if(a){let v=d.path;return v&&v[0]!==E.posix.sep&&(v=E.posix.sep+v),d.with({scheme:l,authority:a,path:v})}return d.with({scheme:l})}e.toLocalResource=r}),define(be[13],Ee([0,1,21,15,3,7,24]),function(re,e,h,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function I(W){return!!W&&typeof W.then=="function"}e.isThenable=I;function y(W){const L=new h.CancellationTokenSource,Y=W(L.token),B=new Promise((G,de)=>{const j=L.token.onCancellationRequested(()=>{j.dispose(),L.dispose(),de((0,F.canceled)())});Promise.resolve(Y).then(le=>{j.dispose(),L.dispose(),G(le)},le=>{j.dispose(),L.dispose(),de(le)})});return new class{cancel(){L.cancel()}then(G,de){return B.then(G,de)}catch(G){return this.then(void 0,G)}finally(G){return B.finally(G)}}}e.createCancelablePromise=y;function k(W,L,Y){return Promise.race([W,new Promise(B=>L.onCancellationRequested(()=>B(Y)))])}e.raceCancellation=k;async function t(W){let L=-1;const Y=W.map((G,de)=>G.then(j=>(L=de,j))),B=await Promise.race(Y);return W.forEach((G,de)=>{de!==L&&G.cancel()}),B}e.raceCancellablePromises=t;function _(W,L,Y){let B;const G=setTimeout(()=>{B?.(void 0),Y?.()},L);return Promise.race([W.finally(()=>clearTimeout(G)),new Promise(de=>B=de)])}e.raceTimeout=_;function r(W){return new Promise((L,Y)=>{const B=W();I(B)?B.then(L,Y):L(B)})}e.asPromise=r;class d{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(L){if(this.activePromise){if(this.queuedPromiseFactory=L,!this.queuedPromise){const Y=()=>{this.queuedPromise=null;const B=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,B};this.queuedPromise=new Promise(B=>{this.activePromise.then(Y,Y).then(B)})}return new Promise((Y,B)=>{this.queuedPromise.then(Y,B)})}return this.activePromise=L(),new Promise((Y,B)=>{this.activePromise.then(G=>{this.activePromise=null,Y(G)},G=>{this.activePromise=null,B(G)})})}}e.Throttler=d;class a{constructor(){this.current=Promise.resolve(null)}queue(L){return this.current=this.current.then(()=>L(),()=>L())}}e.Sequencer=a;class l{constructor(){this.promiseMap=new Map}queue(L,Y){const G=(this.promiseMap.get(L)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.promiseMap.get(L)===G&&this.promiseMap.delete(L)});return this.promiseMap.set(L,G),G}}e.SequencerByKey=l;class v{constructor(L){this.defaultDelay=L,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(L,Y=this.defaultDelay){return this.task=L,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((B,G)=>{this.doResolve=B,this.doReject=G}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const B=this.task;return this.task=null,B()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},Y),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,F.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=v;class T{constructor(L){this.delayer=new v(L),this.throttler=new d}trigger(L,Y){return this.delayer.trigger(()=>this.throttler.queue(L),Y)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=T;class b{constructor(){this._isOpen=!1,this._promise=new Promise((L,Y)=>{this._completePromise=L})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=b;class c extends b{constructor(L){super();this._timeout=setTimeout(()=>this.open(),L)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=c;function g(W,L){return L?new Promise((Y,B)=>{const G=setTimeout(()=>{de.dispose(),Y()},W),de=L.onCancellationRequested(()=>{clearTimeout(G),de.dispose(),B((0,F.canceled)())})}):y(Y=>g(W,Y))}e.timeout=g;function S(W,L=0){const Y=setTimeout(W,L);return(0,A.toDisposable)(()=>clearTimeout(Y))}e.disposableTimeout=S;function i(W){const L=[];let Y=0;const B=W.length;function G(){return Y<B?W[Y++]():null}function de(j){j!=null&&L.push(j);const le=G();return le?le.then(de):Promise.resolve(L)}return Promise.resolve(null).then(de)}e.sequence=i;function s(W,L=B=>!!B,Y=null){let B=0;const G=W.length,de=()=>{if(B>=G)return Promise.resolve(Y);const j=W[B++];return Promise.resolve(j()).then(ae=>L(ae)?Promise.resolve(ae):de())};return de()}e.first=s;function u(W,L=B=>!!B,Y=null){if(W.length===0)return Promise.resolve(Y);let B=W.length;const G=()=>{B=-1;for(const de of W)de.cancel?.()};return new Promise((de,j)=>{for(const le of W)le.then(ae=>{--B>=0&&L(ae)?(G(),de(ae)):B===0&&de(Y)}).catch(ae=>{--B>=0&&(G(),j(ae))})})}e.firstParallel=u;class o{constructor(L){this._size=0,this.maxDegreeOfParalellism=L,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new E.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(L){return this._size++,new Promise((Y,B)=>{this.outstandingPromises.push({factory:L,c:Y,e:B}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const L=this.outstandingPromises.shift();this.runningPromises++;const Y=L.factory();Y.then(L.c,L.e),Y.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=o;class f extends o{constructor(){super(1)}}e.Queue=f;class p{constructor(){this.queues=new Map}queueFor(L,Y=R.extUri){const B=Y.getComparisonKey(L);let G=this.queues.get(B);return G||(G=new f,E.Event.once(G.onFinished)(()=>{G?.dispose(),this.queues.delete(B)}),this.queues.set(B,G)),G}dispose(){this.queues.forEach(L=>L.dispose()),this.queues.clear()}}e.ResourceQueue=p;class w{constructor(L,Y){this._token=-1,typeof L=="function"&&typeof Y=="number"&&this.setIfNotSet(L,Y)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(L,Y){this.cancel(),this._token=setTimeout(()=>{this._token=-1,L()},Y)}setIfNotSet(L,Y){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,L()},Y))}}e.TimeoutTimer=w;class C{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(L,Y){this.cancel(),this._token=setInterval(()=>{L()},Y)}}e.IntervalTimer=C;class P{constructor(L,Y){this.timeoutToken=-1,this.runner=L,this.timeout=Y,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(L=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,L)}get delay(){return this.timeout}set delay(L){this.timeout=L}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=P;class n extends P{constructor(L,Y){super(L,Y);this.units=[]}work(L){this.units.push(L),this.isScheduled()||this.schedule()}doRun(){const L=this.units;this.units=[],this.runner&&this.runner(L)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=n;class m extends A.Disposable{constructor(L,Y,B,G){super();this.maxWorkChunkSize=L,this.maxPendingWork=Y,this.throttleDelay=B,this.handler=G,this.pendingWork=[],this.throttler=this._register(new A.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(L){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+L.length>this.maxPendingWork)return!1}else if(this.pending+L.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...L),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new P(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=m,function(){if(typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"){const W=Object.freeze({didTimeout:!0,timeRemaining(){return 15}});e.runWhenIdle=L=>{const Y=setTimeout(()=>L(W));let B=!1;return{dispose(){B||(B=!0,clearTimeout(Y))}}}}else e.runWhenIdle=(W,L)=>{const Y=requestIdleCallback(W,typeof L=="number"?{timeout:L}:void 0);let B=!1;return{dispose(){B||(B=!0,cancelIdleCallback(Y))}}}}();class D{constructor(L){this._didRun=!1,this._executor=()=>{try{this._value=L()}catch(Y){this._error=Y}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=D;async function O(W,L,Y){let B;for(let G=0;G<Y;G++)try{return await W()}catch(de){B=de,await g(L)}throw B}e.retry=O;class ${hasPending(L){return this._pending?typeof L=="number"?this._pending.taskId===L:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(L,Y,B){return this._pending={taskId:L,cancel:()=>B?.(),promise:Y},Y.then(()=>this.donePending(L),()=>this.donePending(L)),Y}donePending(L){this._pending&&L===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const L=this._next;this._next=void 0,L.run().then(L.promiseResolve,L.promiseReject)}}setNext(L){if(this._next)this._next.run=L;else{let Y,B;const G=new Promise((de,j)=>{Y=de,B=j});this._next={run:L,promise:G,promiseResolve:Y,promiseReject:B}}return this._next.promise}}e.TaskSequentializer=$;class Q{constructor(L){this.interval=L,this.lastIncrementTime=0,this.value=0}increment(){const L=Date.now();return L-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=L,this.value=0),this.value++,this.value}}e.IntervalCounter=Q;class ie{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((L,Y)=>{this.completeCallback=L,this.errorCallback=Y})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(L){return new Promise(Y=>{this.completeCallback(L),this.resolved=!0,Y()})}error(L){return new Promise(Y=>{this.errorCallback(L),this.rejected=!0,Y()})}cancel(){new Promise(L=>{this.errorCallback((0,F.canceled)()),this.rejected=!0,L()})}}e.DeferredPromise=ie;var V;(function(W){async function L(Y){let B;const G=await Promise.all(Y.map(de=>de.then(j=>j,j=>{B||(B=j)})));if(typeof B!="undefined")throw B;return G}W.settled=L})(V=e.Promises||(e.Promises={}))}),define(be[107],Ee([0,1,13,17]),function(re,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const E=new h.IdleValue(()=>{const P=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:P,collatorIsNumeric:P.resolvedOptions().numeric}}),A=new h.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),R=new h.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function I(P,n,m=!1){const D=P||"",O=n||"",$=E.value.collator.compare(D,O);return E.value.collatorIsNumeric&&$===0&&D!==O?D<O?-1:1:$}e.compareFileNames=I;function y(P,n){const m=A.value.collator;return P=P||"",n=n||"",S(m,P,n)}e.compareFileNamesDefault=y;function k(P,n){const m=A.value.collator;return P=P||"",n=n||"",o(P,n)||S(m,P,n)}e.compareFileNamesUpper=k;function t(P,n){const m=A.value.collator;return P=P||"",n=n||"",u(P,n)||S(m,P,n)}e.compareFileNamesLower=t;function _(P,n){return P=P||"",n=n||"",P===n?0:P<n?-1:1}e.compareFileNamesUnicode=_;function r(P,n,m=!1){m||(P=P&&P.toLowerCase(),n=n&&n.toLowerCase());const[D,O]=c(P),[$,Q]=c(n);return D!==$?D<$?-1:1:O===Q?0:O<Q?-1:1}e.noIntlCompareFileNames=r;function d(P,n){const[m,D]=c(P),[O,$]=c(n);let Q=E.value.collator.compare(D,$);if(Q===0){if(E.value.collatorIsNumeric&&D!==$)return D<$?-1:1;if(Q=E.value.collator.compare(m,O),E.value.collatorIsNumeric&&Q===0&&m!==O)return m<O?-1:1}return Q}e.compareFileExtensions=d;function a(P,n){P=P||"",n=n||"";const m=g(P),D=g(n),O=A.value.collator,$=R.value.collator;return S($,m,D)||S(O,P,n)}e.compareFileExtensionsDefault=a;function l(P,n){P=P||"",n=n||"";const m=g(P),D=g(n),O=A.value.collator,$=R.value.collator;return S($,m,D)||o(P,n)||S(O,P,n)}e.compareFileExtensionsUpper=l;function v(P,n){P=P||"",n=n||"";const m=g(P),D=g(n),O=A.value.collator,$=R.value.collator;return S($,m,D)||u(P,n)||S(O,P,n)}e.compareFileExtensionsLower=v;function T(P,n){P=P||"",n=n||"";const m=g(P).toLowerCase(),D=g(n).toLowerCase();return m!==D?m<D?-1:1:P!==n?P<n?-1:1:0}e.compareFileExtensionsUnicode=T;const b=/^(.*?)(\.([^.]*))?$/;function c(P,n=!1){const m=P?b.exec(P):[];let D=[m&&m[1]||"",m&&m[3]||""];return n&&(!D[0]&&D[1]||D[0]&&D[0].charAt(0)===".")&&(D=[D[0]+"."+D[1],""]),D}function g(P){const n=P?b.exec(P):[];return n&&n[1]&&n[1].charAt(0)!=="."&&n[3]||""}function S(P,n,m){let D=P.compare(n,m);return D!==0?D:n.length!==m.length?n.length<m.length?-1:1:0}function i(P){const n=P.charAt(0);return n.toLocaleUpperCase()!==n}function s(P){const n=P.charAt(0);return n.toLocaleLowerCase()!==n}function u(P,n){return i(P)&&s(n)?-1:s(P)&&i(n)?1:0}function o(P,n){return s(P)&&i(n)?-1:i(P)&&s(n)?1:0}function f(P,n,m=!1){return m||(P=P&&P.toLowerCase(),n=n&&n.toLowerCase()),P===n?0:P<n?-1:1}function p(P,n,m=!1){const D=P.split(F.sep),O=n.split(F.sep),$=D.length-1,Q=O.length-1;let ie,V;for(let W=0;;W++){if(ie=$===W,V=Q===W,ie&&V)return I(D[W],O[W],m);if(ie)return-1;if(V)return 1;const L=f(D[W],O[W],m);if(L!==0)return L}}e.comparePaths=p;function w(P,n,m){const D=P.toLowerCase(),O=n.toLowerCase(),$=C(P,n,m);if($)return $;const Q=D.endsWith(m),ie=O.endsWith(m);if(Q!==ie)return Q?-1:1;const V=I(D,O);return V!==0?V:D.localeCompare(O)}e.compareAnything=w;function C(P,n,m){const D=P.toLowerCase(),O=n.toLowerCase(),$=D.startsWith(m),Q=O.startsWith(m);if($!==Q)return $?-1:1;if($&&Q){if(D.length<O.length)return-1;if(D.length>O.length)return 1}return 0}e.compareByPrefix=C}),define(be[27],Ee([0,1,13,40,20,17,9]),function(re,e,h,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.hasSiblingFn=e.hasSiblingPromiseFn=e.parse=e.match=e.splitGlobAware=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I;const y="**",k="/",t="[/\\\\]",_="[^/\\\\]",r=/\//g;function d(G){switch(G){case 0:return"";case 1:return`${_}*?`;default:return`(?:${t}|${_}+${t}|${t}${_}+)*?`}}function a(G,de){if(!G)return[];const j=[];let le=!1,ae=!1,ve="";for(const Re of G){switch(Re){case de:if(!le&&!ae){j.push(ve),ve="";continue}break;case"{":le=!0;break;case"}":le=!1;break;case"[":ae=!0;break;case"]":ae=!1;break}ve+=Re}return ve&&j.push(ve),j}e.splitGlobAware=a;function l(G){if(!G)return"";let de="";const j=a(G,k);if(j.every(le=>le===y))de=".*";else{let le=!1;j.forEach((ae,ve)=>{if(ae===y){le||(de+=d(2),le=!0);return}let Re=!1,Fe="",Ne=!1,Qe="";for(const He of ae){if(He!=="}"&&Re){Fe+=He;continue}if(Ne&&(He!=="]"||!Qe)){let Ke;He==="-"?Ke=He:(He==="^"||He==="!")&&!Qe?Ke="^":He===k?Ke="":Ke=R.escapeRegExpCharacters(He),Qe+=Ke;continue}switch(He){case"{":Re=!0;continue;case"[":Ne=!0;continue;case"}":de+=`(?:${a(Fe,",").map(q=>l(q)).join("|")})`,Re=!1,Fe="";break;case"]":de+="["+Qe+"]",Ne=!1,Qe="";break;case"?":de+=_;continue;case"*":de+=d(1);continue;default:de+=R.escapeRegExpCharacters(He)}}ve<j.length-1&&(j[ve+1]!==y||ve+2<j.length)&&(de+=t),le=!1})}return de}const v=/^\*\*\/\*\.[\w\.-]+$/,T=/^\*\*\/([\w\.-]+)\/?$/,b=/^{\*\*\/[\*\.]?[\w\.-]+\/?(,\*\*\/[\*\.]?[\w\.-]+\/?)*}$/,c=/^{\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?(,\*\*\/[\*\.]?[\w\.-]+(\/(\*\*)?)?)*}$/,g=/^\*\*((\/[\w\.-]+)+)\/?$/,S=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new E.LRUCache(1e4),s=function(){return!1},u=function(){return null};function o(G,de){if(!G)return u;let j;typeof G!="string"?j=G.pattern:j=G,j=j.trim();const le=`${j}_${!!de.trimForExclusions}`;let ae=i.get(le);if(ae)return f(ae,G);let ve;if(v.test(j)){const Re=j.substr(4);ae=function(Fe,Ne){return typeof Fe=="string"&&Fe.endsWith(Re)?j:null}}else(ve=T.exec(p(j,de)))?ae=w(ve[1],j):(de.trimForExclusions?c:b).test(j)?ae=C(j,de):(ve=g.exec(p(j,de)))?ae=P(ve[1].substr(1),j,!0):(ve=S.exec(p(j,de)))?ae=P(ve[1],j,!1):ae=n(j);return i.set(le,ae),f(ae,G)}function f(G,de){return typeof de=="string"?G:function(j,le){return F.isEqualOrParent(j,de.base)?G(A.relative(de.base,j),le):null}}function p(G,de){return de.trimForExclusions&&G.endsWith("/**")?G.substr(0,G.length-2):G}function w(G,de){const j=`/${G}`,le=`\\${G}`,ae=function(Re,Fe){return typeof Re!="string"?null:Fe?Fe===G?de:null:Re===G||Re.endsWith(j)||Re.endsWith(le)?de:null},ve=[G];return ae.basenames=ve,ae.patterns=[de],ae.allBasenames=ve,ae}function C(G,de){const j=B(G.slice(1,-1).split(",").map(Fe=>o(Fe,de)).filter(Fe=>Fe!==u),G),le=j.length;if(!le)return u;if(le===1)return j[0];const ae=function(Fe,Ne){for(let Qe=0,He=j.length;Qe<He;Qe++)if(j[Qe](Fe,Ne))return G;return null},ve=j.find(Fe=>!!Fe.allBasenames);ve&&(ae.allBasenames=ve.allBasenames);const Re=j.reduce((Fe,Ne)=>Ne.allPaths?Fe.concat(Ne.allPaths):Fe,[]);return Re.length&&(ae.allPaths=Re),ae}function P(G,de,j){const le=A.sep===A.posix.sep,ae=le?G:G.replace(r,A.sep),ve=A.sep+ae,Re=A.posix.sep+G,Fe=j?function(Ne,Qe){return typeof Ne=="string"&&(Ne===ae||Ne.endsWith(ve)||!le&&(Ne===G||Ne.endsWith(Re)))?de:null}:function(Ne,Qe){return typeof Ne=="string"&&(Ne===ae||!le&&Ne===G)?de:null};return Fe.allPaths=[(j?"*/":"./")+G],Fe}function n(G){try{const de=new RegExp(`^${l(G)}$`);return function(j){return de.lastIndex=0,typeof j=="string"&&de.test(j)?G:null}}catch(de){return u}}function m(G,de,j){return!G||typeof de!="string"?!1:D(G)(de,void 0,j)}e.match=m;function D(G,de={}){if(!G)return s;if(typeof G=="string"||ie(G)){const j=o(G,de);if(j===u)return s;const le=function(ae,ve){return!!j(ae,ve)};return j.allBasenames&&(le.allBasenames=j.allBasenames),j.allPaths&&(le.allPaths=j.allPaths),le}return L(G,de)}e.parse=D;function O(G){if(!G)return;let de;return j=>(de||(de=(G()||Promise.resolve([])).then(le=>le?Q(le):{})),de.then(le=>!!le[j]))}e.hasSiblingPromiseFn=O;function $(G){if(!G)return;let de;return j=>{if(!de){const le=G();de=le?Q(le):{}}return!!de[j]}}e.hasSiblingFn=$;function Q(G){const de={};for(const j of G)de[j]=!0;return de}function ie(G){const de=G;return de&&typeof de.base=="string"&&typeof de.pattern=="string"}e.isRelativePattern=ie;function V(G){return G.allBasenames||[]}e.getBasenameTerms=V;function W(G){return G.allPaths||[]}e.getPathTerms=W;function L(G,de){const j=B(Object.getOwnPropertyNames(G).map(Fe=>Y(Fe,G[Fe],de)).filter(Fe=>Fe!==u)),le=j.length;if(!le)return u;if(!j.some(Fe=>!!Fe.requiresSiblings)){if(le===1)return j[0];const Fe=function(He,Ke){for(let x=0,q=j.length;x<q;x++){const Z=j[x](He,Ke);if(Z)return Z}return null},Ne=j.find(He=>!!He.allBasenames);Ne&&(Fe.allBasenames=Ne.allBasenames);const Qe=j.reduce((He,Ke)=>Ke.allPaths?He.concat(Ke.allPaths):He,[]);return Qe.length&&(Fe.allPaths=Qe),Fe}const ae=function(Fe,Ne,Qe){let He;for(let Ke=0,x=j.length;Ke<x;Ke++){const q=j[Ke];q.requiresSiblings&&Qe&&(Ne||(Ne=A.basename(Fe)),He||(He=Ne.substr(0,Ne.length-A.extname(Fe).length)));const Z=q(Fe,Ne,He,Qe);if(Z)return Z}return null},ve=j.find(Fe=>!!Fe.allBasenames);ve&&(ae.allBasenames=ve.allBasenames);const Re=j.reduce((Fe,Ne)=>Ne.allPaths?Fe.concat(Ne.allPaths):Fe,[]);return Re.length&&(ae.allPaths=Re),ae}function Y(G,de,j){if(de===!1)return u;const le=o(G,j);if(le===u)return u;if(typeof de=="boolean")return le;if(de){const ae=de.when;if(typeof ae=="string"){const ve=(Re,Fe,Ne,Qe)=>{if(!Qe||!le(Re,Fe))return null;const He=ae.replace("$(basename)",Ne),Ke=Qe(He);return(0,h.isThenable)(Ke)?Ke.then(x=>x?G:null):Ke?G:null};return ve.requiresSiblings=!0,ve}}return le}function B(G,de){const j=G.filter(Fe=>!!Fe.basenames);if(j.length<2)return G;const le=j.reduce((Fe,Ne)=>{const Qe=Ne.basenames;return Qe?Fe.concat(Qe):Fe},[]);let ae;if(de){ae=[];for(let Fe=0,Ne=le.length;Fe<Ne;Fe++)ae.push(de)}else ae=j.reduce((Fe,Ne)=>{const Qe=Ne.patterns;return Qe?Fe.concat(Qe):Fe},[]);const ve=function(Fe,Ne){if(typeof Fe!="string")return null;if(!Ne){let He;for(He=Fe.length;He>0;He--){const Ke=Fe.charCodeAt(He-1);if(Ke===47||Ke===92)break}Ne=Fe.substr(He)}const Qe=le.indexOf(Ne);return Qe!==-1?ae[Qe]:null};ve.basenames=le,ve.patterns=ae,ve.allBasenames=le;const Re=G.filter(Fe=>!Fe.basenames);return Re.push(ve),Re}}),define(be[77],Ee([0,1,40,11,17,26,24,9,2]),function(re,e,h,F,E,A,R,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function k(o,f,p){if(typeof o=="string"&&(o=y.URI.file(o)),p){const C=p.getWorkspaceFolder(o);if(C){const P=p.getWorkspace().folders.length>1;let n;if((0,R.isEqual)(C.uri,o)?n="":n=(0,R.relativePath)(C.uri,o),P){const m=C.name?C.name:(0,R.basename)(C.uri);n=n?m+" \u2022 "+n:m}return n}}if(o.scheme!==F.Schemas.file&&o.scheme!==F.Schemas.untitled)return o.with({query:null,fragment:null}).toString(!0);if((0,h.hasDriveLetter)(o.fsPath))return(0,E.normalize)(_(o.fsPath));let w=(0,E.normalize)(o.fsPath);return!A.isWindows&&f?.userHome&&(w=d(w,f.userHome.fsPath)),w}e.getPathLabel=k;function t(o){if(!o)return;typeof o=="string"&&(o=y.URI.file(o));const f=(0,R.basename)(o)||(o.scheme===F.Schemas.file?o.fsPath:o.path);return A.isWindows&&(0,h.isRootOrDriveLetter)(f)?_(f):f}e.getBaseLabel=t;function _(o){return(0,h.hasDriveLetter)(o)?o.charAt(0).toUpperCase()+o.slice(1):o}e.normalizeDriveLetter=_;let r=Object.create(null);function d(o,f){if(A.isWindows||!o||!f)return o;let p=r.original===f?r.normalized:void 0;return p||(p=`${(0,I.rtrim)(f,E.posix.sep)}${E.posix.sep}`,r={original:f,normalized:p}),(A.isLinux?o.startsWith(p):(0,I.startsWithIgnoreCase)(o,p))&&(o=`~/${o.substr(p.length)}`),o}e.tildify=d;function a(o,f){return o.replace(/^~($|\/|\\)/,`${f}$1`)}e.untildify=a;const l="\u2026",v="\\\\",T="~";function b(o,f=E.sep){const p=new Array(o.length);let w=!1;for(let C=0;C<o.length;C++){let P=o[C];if(P===""){p[C]=`.${f}`;continue}if(!P){p[C]=P;continue}w=!0;let n="";P.indexOf(v)===0?(n=P.substr(0,P.indexOf(v)+v.length),P=P.substr(P.indexOf(v)+v.length)):P.indexOf(f)===0?(n=P.substr(0,P.indexOf(f)+f.length),P=P.substr(P.indexOf(f)+f.length)):P.indexOf(T)===0&&(n=P.substr(0,P.indexOf(T)+T.length),P=P.substr(P.indexOf(T)+T.length));const m=P.split(f);for(let D=1;w&&D<=m.length;D++)for(let O=m.length-D;w&&O>=0;O--){w=!1;let $=m.slice(O,O+D).join(f);for(let Q=0;!w&&Q<o.length;Q++)if(Q!==C&&o[Q]&&o[Q].indexOf($)>-1){const ie=O+D===m.length,V=O>0&&o[Q].indexOf(f)>-1?f+$:$,W=o[Q].endsWith(V);w=!ie||W}if(!w){let Q="";(m[0].endsWith(":")||n!=="")&&(O===1&&(O=0,D++,$=m[0]+f+$),O>0&&(Q=m[0]+f),Q=n+Q),O>0&&(Q=Q+l+f),Q=Q+$,O+D<m.length&&(Q=Q+f+l),p[C]=Q}}w&&(p[C]=P)}return p}e.shorten=b;var c;(function(o){o[o.TEXT=0]="TEXT",o[o.VARIABLE=1]="VARIABLE",o[o.SEPARATOR=2]="SEPARATOR"})(c||(c={}));function g(o,f=Object.create(null)){const p=[];let w=!1,C="";for(const P of o)if(P==="$"||w&&P==="{")C&&p.push({value:C,type:c.TEXT}),C="",w=!0;else if(P==="}"&&w){const n=f[C];if(typeof n=="string")n.length&&p.push({value:n,type:c.VARIABLE});else if(n){const m=p[p.length-1];(!m||m.type!==c.SEPARATOR)&&p.push({value:n.label,type:c.SEPARATOR})}C="",w=!1}else C+=P;return C&&!w&&p.push({value:C,type:c.TEXT}),p.filter((P,n)=>{if(P.type===c.SEPARATOR){const m=p[n-1],D=p[n+1];return[m,D].every(O=>O&&(O.type===c.VARIABLE||O.type===c.TEXT)&&O.value.length>0)}return!0}).map(P=>P.value).join("")}e.template=g;function S(o,f){return A.isMacintosh||f?o.replace(/\(&&\w\)|&&/g,"").replace(/&/g,A.isMacintosh?"&":"&&"):o.replace(/&&|&/g,p=>p==="&"?"&&":"&")}e.mnemonicMenuLabel=S;function i(o,f){return A.isMacintosh||f?o.replace(/\(&&\w\)|&&/g,""):A.isWindows?o.replace(/&&|&/g,p=>p==="&"?"&&":"&"):o.replace(/&&/g,"_")}e.mnemonicButtonLabel=i;function s(o){return o.replace(/&/g,"&&")}e.unmnemonicLabel=s;function u(o){const f=o.indexOf("/")!==-1?E.posix:E.win32,p=f.basename(o),w=f.dirname(o);return p.length?{name:p,parentPath:w}:{name:w,parentPath:""}}e.splitName=u}),define(be[78],Ee([0,1,27,11,17,24,9]),function(re,e,h,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.isUnspecific=e.guessMimeTypes=e.clearTextMimes=e.registerTextMime=e.Mimes=void 0;var I;(function(o){o.text="text/plain",o.binary="application/octet-stream",o.unknown="application/unknown",o.markdown="text/markdown"})(I=e.Mimes||(e.Mimes={}));let y=[],k=[],t=[];function _(o,f=!1){const p=r(o);y.push(p),p.userConfigured?t.push(p):k.push(p),f&&!p.userConfigured&&y.forEach(w=>{w.mime===p.mime||w.userConfigured||(p.extension&&w.extension===p.extension&&console.warn(`Overwriting extension <<${p.extension}>> to now point to mime <<${p.mime}>>`),p.filename&&w.filename===p.filename&&console.warn(`Overwriting filename <<${p.filename}>> to now point to mime <<${p.mime}>>`),p.filepattern&&w.filepattern===p.filepattern&&console.warn(`Overwriting filepattern <<${p.filepattern}>> to now point to mime <<${p.mime}>>`),p.firstline&&w.firstline===p.firstline&&console.warn(`Overwriting firstline <<${p.firstline}>> to now point to mime <<${p.mime}>>`))})}e.registerTextMime=_;function r(o){return{id:o.id,mime:o.mime,filename:o.filename,extension:o.extension,filepattern:o.filepattern,firstline:o.firstline,userConfigured:o.userConfigured,filenameLowercase:o.filename?o.filename.toLowerCase():void 0,extensionLowercase:o.extension?o.extension.toLowerCase():void 0,filepatternLowercase:o.filepattern?o.filepattern.toLowerCase():void 0,filepatternOnPath:o.filepattern?o.filepattern.indexOf(E.posix.sep)>=0:!1}}function d(o){o?(y=y.filter(f=>!f.userConfigured),t=[]):(y=[],k=[],t=[])}e.clearTextMimes=d;function a(o,f){let p;if(o)switch(o.scheme){case F.Schemas.file:p=o.fsPath;break;case F.Schemas.data:p=A.DataUri.parseMetaData(o).get(A.DataUri.META_DATA_LABEL);break;default:p=o.path}if(!p)return[I.unknown];p=p.toLowerCase();const w=(0,E.basename)(p),C=l(p,w,t);if(C)return[C,I.text];const P=l(p,w,k);if(P)return[P,I.text];if(f){const n=v(f);if(n)return[n,I.text]}return[I.unknown]}e.guessMimeTypes=a;function l(o,f,p){let w=null,C=null,P=null;for(let n=p.length-1;n>=0;n--){const m=p[n];if(f===m.filenameLowercase){w=m;break}if(m.filepattern&&(!C||m.filepattern.length>C.filepattern.length)){const D=m.filepatternOnPath?o:f;(0,h.match)(m.filepatternLowercase,D)&&(C=m)}m.extension&&(!P||m.extension.length>P.extension.length)&&f.endsWith(m.extensionLowercase)&&(P=m)}return w?w.mime:C?C.mime:P?P.mime:null}function v(o){if((0,R.startsWithUTF8BOM)(o)&&(o=o.substr(1)),o.length>0)for(let f=y.length-1;f>=0;f--){const p=y[f];if(!p.firstline)continue;const w=o.match(p.firstline);if(w&&w.length>0)return p.mime}return null}function T(o){return o?typeof o=="string"?o===I.binary||o===I.text||o===I.unknown:o.length===1&&T(o[0]):!0}e.isUnspecific=T;const b={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},c={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function g(o){const f=(0,E.extname)(o),p=b[f.toLowerCase()];return p!==void 0?p:S(o)}e.getMediaOrTextMime=g;function S(o){const f=(0,E.extname)(o);return c[f.toLowerCase()]}e.getMediaMime=S;function i(o){for(const f in c)if(c[f]===o)return f}e.getExtensionForMimeType=i;const s=/^(.+)\/(.+?)(;.+)?$/;function u(o,f){const p=s.exec(o);return p?`${p[1].toLowerCase()}/${p[2].toLowerCase()}${p[3]??""}`:f?void 0:o}e.normalizeMimeType=u}),define(be[108],Ee([0,1,2]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function F(t){return t.toJSON()}class E{constructor(_){this._uriTransformer=_}transformIncoming(_){const r=this._uriTransformer.transformIncoming(_);return r===_?_:F(h.URI.from(r))}transformOutgoing(_){const r=this._uriTransformer.transformOutgoing(_);return r===_?_:F(h.URI.from(r))}transformOutgoingURI(_){const r=this._uriTransformer.transformOutgoing(_);return r===_?_:h.URI.from(r)}transformOutgoingScheme(_){return this._uriTransformer.transformOutgoingScheme(_)}}e.URITransformer=E,e.DefaultURITransformer=new class{transformIncoming(t){return t}transformOutgoing(t){return t}transformOutgoingURI(t){return t}transformOutgoingScheme(t){return t}};function A(t,_,r){if(!t||r>200)return null;if(typeof t=="object"){if(t instanceof h.URI)return _.transformOutgoing(t);for(let d in t)if(Object.hasOwnProperty.call(t,d)){const a=A(t[d],_,r+1);a!==null&&(t[d]=a)}}return null}function R(t,_){const r=A(t,_,0);return r===null?t:r}e.transformOutgoingURIs=R;function I(t,_,r,d){if(!t||d>200)return null;if(typeof t=="object"){if(t.$mid===1)return r?h.URI.revive(_.transformIncoming(t)):_.transformIncoming(t);for(let a in t)if(Object.hasOwnProperty.call(t,a)){const l=I(t[a],_,r,d+1);l!==null&&(t[a]=l)}}return null}function y(t,_){const r=I(t,_,!1,0);return r===null?t:r}e.transformIncomingURIs=y;function k(t,_){const r=I(t,_,!0,0);return r===null?t:r}e.transformAndReviveIncomingURIs=k}),define(be[36],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const h=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function F(y){return h.test(y)}e.isUUID=F;const E=new Uint8Array(16),A=[];for(let y=0;y<256;y++)A.push(y.toString(16).padStart(2,"0"));let R;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?R=crypto.getRandomValues.bind(crypto):R=function(y){for(let k=0;k<y.length;k++)y[k]=Math.floor(Math.random()*256);return y};function I(){R(E),E[6]=E[6]&15|64,E[8]=E[8]&63|128;let y=0,k="";return k+=A[E[y++]],k+=A[E[y++]],k+=A[E[y++]],k+=A[E[y++]],k+="-",k+=A[E[y++]],k+=A[E[y++]],k+="-",k+=A[E[y++]],k+=A[E[y++]],k+="-",k+=A[E[y++]],k+=A[E[y++]],k+="-",k+=A[E[y++]],k+=A[E[y++]],k+=A[E[y++]],k+=A[E[y++]],k+=A[E[y++]],k+=A[E[y++]],k}e.generateUuid=I}),define(be[109],Ee([0,1,226]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMapForWordSeparators=e.WordCharacterClassifier=e.WordCharacterClass=void 0;var F;(function(R){R[R.Regular=0]="Regular",R[R.Whitespace=1]="Whitespace",R[R.WordSeparator=2]="WordSeparator"})(F=e.WordCharacterClass||(e.WordCharacterClass={}));class E extends h.CharacterClassifier{constructor(I){super(0);for(let y=0,k=I.length;y<k;y++)this.set(I.charCodeAt(y),2);this.set(32,1),this.set(9,1)}}e.WordCharacterClassifier=E;function A(R){let I={};return y=>(I.hasOwnProperty(y)||(I[y]=R(y)),I[y])}e.getMapForWordSeparators=A(R=>new E(R))}),define(be[79],Ee([0,1,22]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApplyEditsResult=e.ValidAnnotatedEditOperation=e.ModelConstants=e.PositionAffinity=e.TrackedRangeStickiness=e.FindMatch=e.TextModelResolvedOptions=e.EndOfLineSequence=e.DefaultEndOfLine=e.EndOfLinePreference=e.MinimapPosition=e.OverviewRulerLane=void 0;var F;(function(l){l[l.Left=1]="Left",l[l.Center=2]="Center",l[l.Right=4]="Right",l[l.Full=7]="Full"})(F=e.OverviewRulerLane||(e.OverviewRulerLane={}));var E;(function(l){l[l.Inline=1]="Inline",l[l.Gutter=2]="Gutter"})(E=e.MinimapPosition||(e.MinimapPosition={}));var A;(function(l){l[l.TextDefined=0]="TextDefined",l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(A=e.EndOfLinePreference||(e.EndOfLinePreference={}));var R;(function(l){l[l.LF=1]="LF",l[l.CRLF=2]="CRLF"})(R=e.DefaultEndOfLine||(e.DefaultEndOfLine={}));var I;(function(l){l[l.LF=0]="LF",l[l.CRLF=1]="CRLF"})(I=e.EndOfLineSequence||(e.EndOfLineSequence={}));class y{constructor(v){this._textModelResolvedOptionsBrand=void 0,this.tabSize=Math.max(1,v.tabSize|0),this.indentSize=v.tabSize|0,this.insertSpaces=Boolean(v.insertSpaces),this.defaultEOL=v.defaultEOL|0,this.trimAutoWhitespace=Boolean(v.trimAutoWhitespace),this.bracketPairColorizationOptions=v.bracketPairColorizationOptions}equals(v){return this.tabSize===v.tabSize&&this.indentSize===v.indentSize&&this.insertSpaces===v.insertSpaces&&this.defaultEOL===v.defaultEOL&&this.trimAutoWhitespace===v.trimAutoWhitespace&&(0,h.equals)(this.bracketPairColorizationOptions,v.bracketPairColorizationOptions)}createChangeEvent(v){return{tabSize:this.tabSize!==v.tabSize,indentSize:this.indentSize!==v.indentSize,insertSpaces:this.insertSpaces!==v.insertSpaces,trimAutoWhitespace:this.trimAutoWhitespace!==v.trimAutoWhitespace}}}e.TextModelResolvedOptions=y;class k{constructor(v,T){this._findMatchBrand=void 0,this.range=v,this.matches=T}}e.FindMatch=k;var t;(function(l){l[l.AlwaysGrowsWhenTypingAtEdges=0]="AlwaysGrowsWhenTypingAtEdges",l[l.NeverGrowsWhenTypingAtEdges=1]="NeverGrowsWhenTypingAtEdges",l[l.GrowsOnlyWhenTypingBefore=2]="GrowsOnlyWhenTypingBefore",l[l.GrowsOnlyWhenTypingAfter=3]="GrowsOnlyWhenTypingAfter"})(t=e.TrackedRangeStickiness||(e.TrackedRangeStickiness={}));var _;(function(l){l[l.Left=0]="Left",l[l.Right=1]="Right",l[l.None=2]="None"})(_=e.PositionAffinity||(e.PositionAffinity={}));var r;(function(l){l[l.FIRST_LINE_DETECTION_LENGTH_LIMIT=1e3]="FIRST_LINE_DETECTION_LENGTH_LIMIT"})(r=e.ModelConstants||(e.ModelConstants={}));class d{constructor(v,T,b,c,g,S){this.identifier=v,this.range=T,this.text=b,this.forceMoveMarkers=c,this.isAutoWhitespaceEdit=g,this._isTracked=S}}e.ValidAnnotatedEditOperation=d;class a{constructor(v,T,b){this.reverseEdits=v,this.changes=T,this.trimAutoWhitespaceLineNumbers=b}}e.ApplyEditsResult=a}),define(be[110],Ee([0,1,9,109,111,41,79]),function(re,e,h,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Searcher=e.isValidMatch=e.TextModelSearch=e.createFindMatch=e.SearchData=e.isMultilineRegexSource=e.SearchParams=void 0;const I=999;class y{constructor(c,g,S,i){this.searchString=c,this.isRegex=g,this.matchCase=S,this.wordSeparators=i}parseSearchRequest(){if(this.searchString==="")return null;let c;this.isRegex?c=k(this.searchString):c=this.searchString.indexOf(`
`)>=0;let g=null;try{g=h.createRegExp(this.searchString,this.isRegex,{matchCase:this.matchCase,wholeWord:!1,multiline:c,global:!0,unicode:!0})}catch(i){return null}if(!g)return null;let S=!this.isRegex&&!c;return S&&this.searchString.toLowerCase()!==this.searchString.toUpperCase()&&(S=this.matchCase),new t(g,this.wordSeparators?(0,F.getMapForWordSeparators)(this.wordSeparators):null,S?this.searchString:null)}}e.SearchParams=y;function k(b){if(!b||b.length===0)return!1;for(let c=0,g=b.length;c<g;c++)if(b.charCodeAt(c)===92){if(c++,c>=g)break;const i=b.charCodeAt(c);if(i===110||i===114||i===87||i===119)return!0}return!1}e.isMultilineRegexSource=k;class t{constructor(c,g,S){this.regex=c,this.wordSeparators=g,this.simpleSearch=S}}e.SearchData=t;function _(b,c,g){if(!g)return new R.FindMatch(b,null);let S=[];for(let i=0,s=c.length;i<s;i++)S[i]=c[i];return new R.FindMatch(b,S)}e.createFindMatch=_;class r{constructor(c){let g=[],S=0;for(let i=0,s=c.length;i<s;i++)c.charCodeAt(i)===10&&(g[S++]=i);this._lineFeedsOffsets=g}findLineFeedCountBeforeOffset(c){const g=this._lineFeedsOffsets;let S=0,i=g.length-1;if(i===-1||c<=g[0])return 0;for(;S<i;){const s=S+((i-S)/2>>0);g[s]>=c?i=s-1:g[s+1]>=c?(S=s,i=s):S=s+1}return S+1}}class d{static findMatches(c,g,S,i,s){const u=g.parseSearchRequest();return u?u.regex.multiline?this._doFindMatchesMultiline(c,S,new T(u.wordSeparators,u.regex),i,s):this._doFindMatchesLineByLine(c,S,u,i,s):[]}static _getMultilineMatchRange(c,g,S,i,s,u){let o,f=0;i?(f=i.findLineFeedCountBeforeOffset(s),o=g+s+f):o=g+s;let p;if(i){let n=i.findLineFeedCountBeforeOffset(s+u.length)-f;p=o+u.length+n}else p=o+u.length;const w=c.getPositionAt(o),C=c.getPositionAt(p);return new A.Range(w.lineNumber,w.column,C.lineNumber,C.column)}static _doFindMatchesMultiline(c,g,S,i,s){const u=c.getOffsetAt(g.getStartPosition()),o=c.getValueInRange(g,1),f=c.getEOL()===`\r
`?new r(o):null,p=[];let w=0,C;for(S.reset(0);C=S.next(o);)if(p[w++]=_(this._getMultilineMatchRange(c,u,o,f,C.index,C[0]),C,i),w>=s)return p;return p}static _doFindMatchesLineByLine(c,g,S,i,s){const u=[];let o=0;if(g.startLineNumber===g.endLineNumber){const p=c.getLineContent(g.startLineNumber).substring(g.startColumn-1,g.endColumn-1);return o=this._findMatchesInLine(S,p,g.startLineNumber,g.startColumn-1,o,u,i,s),u}const f=c.getLineContent(g.startLineNumber).substring(g.startColumn-1);o=this._findMatchesInLine(S,f,g.startLineNumber,g.startColumn-1,o,u,i,s);for(let p=g.startLineNumber+1;p<g.endLineNumber&&o<s;p++)o=this._findMatchesInLine(S,c.getLineContent(p),p,0,o,u,i,s);if(o<s){const p=c.getLineContent(g.endLineNumber).substring(0,g.endColumn-1);o=this._findMatchesInLine(S,p,g.endLineNumber,0,o,u,i,s)}return u}static _findMatchesInLine(c,g,S,i,s,u,o,f){const p=c.wordSeparators;if(!o&&c.simpleSearch){const P=c.simpleSearch,n=P.length,m=g.length;let D=-n;for(;(D=g.indexOf(P,D+n))!==-1;)if((!p||v(p,g,m,D,n))&&(u[s++]=new R.FindMatch(new A.Range(S,D+1+i,S,D+1+n+i),null),s>=f))return s;return s}const w=new T(c.wordSeparators,c.regex);let C;w.reset(0);do if(C=w.next(g),C&&(u[s++]=_(new A.Range(S,C.index+1+i,S,C.index+1+C[0].length+i),C,o),s>=f))return s;while(C);return s}static findNextMatch(c,g,S,i){const s=g.parseSearchRequest();if(!s)return null;const u=new T(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindNextMatchMultiline(c,S,u,i):this._doFindNextMatchLineByLine(c,S,u,i)}static _doFindNextMatchMultiline(c,g,S,i){const s=new E.Position(g.lineNumber,1),u=c.getOffsetAt(s),o=c.getLineCount(),f=c.getValueInRange(new A.Range(s.lineNumber,s.column,o,c.getLineMaxColumn(o)),1),p=c.getEOL()===`\r
`?new r(f):null;S.reset(g.column-1);let w=S.next(f);return w?_(this._getMultilineMatchRange(c,u,f,p,w.index,w[0]),w,i):g.lineNumber!==1||g.column!==1?this._doFindNextMatchMultiline(c,new E.Position(1,1),S,i):null}static _doFindNextMatchLineByLine(c,g,S,i){const s=c.getLineCount(),u=g.lineNumber,o=c.getLineContent(u),f=this._findFirstMatchInLine(S,o,u,g.column,i);if(f)return f;for(let p=1;p<=s;p++){const w=(u+p-1)%s,C=c.getLineContent(w+1),P=this._findFirstMatchInLine(S,C,w+1,1,i);if(P)return P}return null}static _findFirstMatchInLine(c,g,S,i,s){c.reset(i-1);const u=c.next(g);return u?_(new A.Range(S,u.index+1,S,u.index+1+u[0].length),u,s):null}static findPreviousMatch(c,g,S,i){const s=g.parseSearchRequest();if(!s)return null;const u=new T(s.wordSeparators,s.regex);return s.regex.multiline?this._doFindPreviousMatchMultiline(c,S,u,i):this._doFindPreviousMatchLineByLine(c,S,u,i)}static _doFindPreviousMatchMultiline(c,g,S,i){const s=this._doFindMatchesMultiline(c,new A.Range(1,1,g.lineNumber,g.column),S,i,10*I);if(s.length>0)return s[s.length-1];const u=c.getLineCount();return g.lineNumber!==u||g.column!==c.getLineMaxColumn(u)?this._doFindPreviousMatchMultiline(c,new E.Position(u,c.getLineMaxColumn(u)),S,i):null}static _doFindPreviousMatchLineByLine(c,g,S,i){const s=c.getLineCount(),u=g.lineNumber,o=c.getLineContent(u).substring(0,g.column-1),f=this._findLastMatchInLine(S,o,u,i);if(f)return f;for(let p=1;p<=s;p++){const w=(s+u-p-1)%s,C=c.getLineContent(w+1),P=this._findLastMatchInLine(S,C,w+1,i);if(P)return P}return null}static _findLastMatchInLine(c,g,S,i){let s=null,u;for(c.reset(0);u=c.next(g);)s=_(new A.Range(S,u.index+1,S,u.index+1+u[0].length),u,i);return s}}e.TextModelSearch=d;function a(b,c,g,S,i){if(S===0)return!0;const s=c.charCodeAt(S-1);if(b.get(s)!==0||s===13||s===10)return!0;if(i>0){const u=c.charCodeAt(S);if(b.get(u)!==0)return!0}return!1}function l(b,c,g,S,i){if(S+i===g)return!0;const s=c.charCodeAt(S+i);if(b.get(s)!==0||s===13||s===10)return!0;if(i>0){const u=c.charCodeAt(S+i-1);if(b.get(u)!==0)return!0}return!1}function v(b,c,g,S,i){return a(b,c,g,S,i)&&l(b,c,g,S,i)}e.isValidMatch=v;class T{constructor(c,g){this._wordSeparators=c,this._searchRegex=g,this._prevMatchStartIndex=-1,this._prevMatchLength=0}reset(c){this._searchRegex.lastIndex=c,this._prevMatchStartIndex=-1,this._prevMatchLength=0}next(c){const g=c.length;let S;do{if(this._prevMatchStartIndex+this._prevMatchLength===g||(S=this._searchRegex.exec(c),!S))return null;const i=S.index,s=S[0].length;if(i===this._prevMatchStartIndex&&s===this._prevMatchLength){if(s===0){h.getNextCodePoint(c,g,this._searchRegex.lastIndex)>65535?this._searchRegex.lastIndex+=2:this._searchRegex.lastIndex+=1;continue}return null}if(this._prevMatchStartIndex=i,this._prevMatchLength=s,!this._wordSeparators||v(this._wordSeparators,c,g,i,s))return S}while(S);return null}}e.Searcher=T}),define(be[112],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var h;(function(R){R[R.None=0]="None",R[R.Indent=1]="Indent",R[R.IndentOutdent=2]="IndentOutdent",R[R.Outdent=3]="Outdent"})(h=e.IndentAction||(e.IndentAction={}));class F{constructor(I){if(this._standardAutoClosingPairConditionalBrand=void 0,this.open=I.open,this.close=I.close,this._standardTokenMask=0,Array.isArray(I.notIn))for(let y=0,k=I.notIn.length;y<k;y++)switch(I.notIn[y]){case"string":this._standardTokenMask|=2;break;case"comment":this._standardTokenMask|=1;break;case"regex":this._standardTokenMask|=4;break}}isOK(I){return(this._standardTokenMask&I)==0}}e.StandardAutoClosingPairConditional=F;class E{constructor(I){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const y of I)A(this.autoClosingPairsOpenByStart,y.open.charAt(0),y),A(this.autoClosingPairsOpenByEnd,y.open.charAt(y.open.length-1),y),A(this.autoClosingPairsCloseByStart,y.close.charAt(0),y),A(this.autoClosingPairsCloseByEnd,y.close.charAt(y.close.length-1),y),y.close.length===1&&y.open.length===1&&A(this.autoClosingPairsCloseSingleChar,y.close,y)}}e.AutoClosingPairs=E;function A(R,I,y){R.has(I)?R.get(I).push(y):R.set(I,[y])}}),define(be[54],Ee([0,1,27,17]),function(re,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function E(A,R,I,y){if(Array.isArray(A)){let k=0;for(const t of A){const _=E(t,R,I,y);if(_===10)return _;_>k&&(k=_)}return k}else{if(typeof A=="string")return y?A==="*"?5:A===I?10:0:0;if(A){const{language:k,pattern:t,scheme:_,hasAccessToAllModels:r}=A;if(!y&&!r)return 0;let d=0;if(_)if(_===R.scheme)d=10;else if(_==="*")d=5;else return 0;if(k)if(k===I)d=10;else if(k==="*")d=Math.max(d,5);else return 0;if(t){let a;if(typeof t=="string"?a=t:a={...t,base:(0,F.normalize)(t.base)},a===R.fsPath||(0,h.match)(a,R.fsPath))d=10;else return 0}return d}else return 0}}e.score=E}),define(be[113],Ee([0,1,3,7]),function(re,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TokenizationRegistryImpl=void 0;class E{constructor(){this._map=new Map,this._promises=new Map,this._onDidChange=new h.Emitter,this.onDidChange=this._onDidChange.event,this._colorMap=null}fire(R){this._onDidChange.fire({changedLanguages:R,changedColorMap:!1})}register(R,I){return this._map.set(R,I),this.fire([R]),(0,F.toDisposable)(()=>{this._map.get(R)===I&&(this._map.delete(R),this.fire([R]))})}registerPromise(R,I){let y=null,k=!1;return this._promises.set(R,I.then(t=>{this._promises.delete(R),!(k||!t)&&(y=this.register(R,t))})),(0,F.toDisposable)(()=>{k=!0,y&&y.dispose()})}getPromise(R){const I=this.get(R);if(I)return Promise.resolve(I);const y=this._promises.get(R);return y?y.then(k=>this.get(R)):null}get(R){return this._map.get(R)||null}setColorMap(R){this._colorMap=R,this._onDidChange.fire({changedLanguages:Array.from(this._map.keys()),changedColorMap:!0})}getColorMap(){return this._colorMap}getDefaultBackground(){return this._colorMap&&this._colorMap.length>2?this._colorMap[2]:null}}e.TokenizationRegistryImpl=E}),define(be[80],Ee([0,1,23,26]),function(re,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var E;(function(_){_[_.Full=1]="Full",_[_.Delta=2]="Delta"})(E||(E={}));function A(_){for(let r=0,d=_.length;r<d;r+=4){const a=_[r+0],l=_[r+1],v=_[r+2],T=_[r+3];_[r+0]=T,_[r+1]=v,_[r+2]=l,_[r+3]=a}}function R(_){const r=new Uint8Array(_.buffer,_.byteOffset,_.length*4);return F.isLittleEndian()||A(r),h.VSBuffer.wrap(r)}function I(_){const r=_.buffer;if(F.isLittleEndian()||A(r),r.byteOffset%4==0)return new Uint32Array(r.buffer,r.byteOffset,r.length/4);{const d=new Uint8Array(r.byteLength);return d.set(r),new Uint32Array(d.buffer,d.byteOffset,d.length/4)}}function y(_){const r=new Uint32Array(k(_));let d=0;if(r[d++]=_.id,_.type==="full")r[d++]=1,r[d++]=_.data.length,r.set(_.data,d),d+=_.data.length;else{r[d++]=2,r[d++]=_.deltas.length;for(const a of _.deltas)r[d++]=a.start,r[d++]=a.deleteCount,a.data?(r[d++]=a.data.length,r.set(a.data,d),d+=a.data.length):r[d++]=0}return R(r)}e.encodeSemanticTokensDto=y;function k(_){let r=0;if(r+=1+1,_.type==="full")r+=1+_.data.length;else{r+=1,r+=(1+1+1)*_.deltas.length;for(const d of _.deltas)d.data&&(r+=d.data.length)}return r}function t(_){const r=I(_);let d=0;const a=r[d++];if(r[d++]===1){const b=r[d++],c=r.subarray(d,d+b);return d+=b,{id:a,type:"full",data:c}}const v=r[d++];let T=[];for(let b=0;b<v;b++){const c=r[d++],g=r[d++],S=r[d++];let i;S>0&&(i=r.subarray(d,d+S),d+=S),T[b]={start:c,deleteCount:g,data:i}}return{id:a,type:"delta",deltas:T}}e.decodeSemanticTokensDto=t}),define(be[114],Ee([18,19]),function(re,e){return re.create("vs/base/common/errorMessage",e)}),define(be[55],Ee([0,1,16,10,114]),function(re,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function A(k,t){return t&&(k.stack||k.stacktrace)?E.localize(0,null,I(k),R(k.stack)||R(k.stacktrace)):I(k)}function R(k){return Array.isArray(k)?k.join(`
`):k}function I(k){return typeof k.code=="string"&&typeof k.errno=="number"&&typeof k.syscall=="string"?E.localize(1,null,k.message):k.message||E.localize(2,null)}function y(k=null,t=!1){if(!k)return E.localize(3,null);if(Array.isArray(k)){const _=h.coalesce(k),r=y(_[0],t);return _.length>1?E.localize(4,null,r,_.length):r}if(F.isString(k))return k;if(k.detail){const _=k.detail;if(_.error)return A(_.error,t);if(_.exception)return A(_.exception,t)}return k.stack?A(k,t):k.message?k.message:E.localize(5,null)}e.toErrorMessage=y}),define(be[115],Ee([18,19]),function(re,e){return re.create("vs/editor/common/config/editorOptions",e)}),define(be[116],Ee([0,1,115,26,117]),function(re,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_MODEL_DEFAULTS=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.boolean=e.ComputeOptionsMemory=e.ValidatedEditorOptions=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var A;(function(z){z[z.None=0]="None",z[z.Keep=1]="Keep",z[z.Brackets=2]="Brackets",z[z.Advanced=3]="Advanced",z[z.Full=4]="Full"})(A=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class R{constructor(K){this._values=K}hasChanged(K){return this._values[K]}}e.ConfigurationChangedEvent=R;class I{constructor(){this._values=[]}_read(K){return this._values[K]}get(K){return this._values[K]}_write(K,he){this._values[K]=he}}e.ValidatedEditorOptions=I;class y{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=y;class k{constructor(K,he,Le,Ve){this.id=K,this.name=he,this.defaultValue=Le,this.schema=Ve}compute(K,he,Le){return Le}}class t{constructor(K,he=null){this.schema=void 0,this.id=K,this.name="_never_",this.defaultValue=void 0,this.deps=he}validate(K){return this.defaultValue}}class _{constructor(K,he,Le,Ve){this.id=K,this.name=he,this.defaultValue=Le,this.schema=Ve}validate(K){return typeof K=="undefined"?this.defaultValue:K}compute(K,he,Le){return Le}}function r(z,K){return typeof z=="undefined"?K:z==="false"?!1:Boolean(z)}e.boolean=r;class d extends _{constructor(K,he,Le,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="boolean",Ve.default=Le),super(K,he,Le,Ve)}validate(K){return r(K,this.defaultValue)}}class a extends _{constructor(K,he,Le,Ve,tt,lt=void 0){typeof lt!="undefined"&&(lt.type="integer",lt.default=Le,lt.minimum=Ve,lt.maximum=tt),super(K,he,Le,lt),this.minimum=Ve,this.maximum=tt}static clampedInt(K,he,Le,Ve){if(typeof K=="undefined")return he;let tt=parseInt(K,10);return isNaN(tt)?he:(tt=Math.max(Le,tt),tt=Math.min(Ve,tt),tt|0)}validate(K){return a.clampedInt(K,this.defaultValue,this.minimum,this.maximum)}}class l extends _{constructor(K,he,Le,Ve,tt){typeof tt!="undefined"&&(tt.type="number",tt.default=Le),super(K,he,Le,tt),this.validationFn=Ve}static clamp(K,he,Le){return K<he?he:K>Le?Le:K}static float(K,he){if(typeof K=="number")return K;if(typeof K=="undefined")return he;const Le=parseFloat(K);return isNaN(Le)?he:Le}validate(K){return this.validationFn(l.float(K,this.defaultValue))}}class v extends _{static string(K,he){return typeof K!="string"?he:K}constructor(K,he,Le,Ve=void 0){typeof Ve!="undefined"&&(Ve.type="string",Ve.default=Le),super(K,he,Le,Ve)}validate(K){return v.string(K,this.defaultValue)}}function T(z,K,he){return typeof z!="string"||he.indexOf(z)===-1?K:z}e.stringSet=T;class b extends _{constructor(K,he,Le,Ve,tt=void 0){typeof tt!="undefined"&&(tt.type="string",tt.enum=Ve,tt.default=Le),super(K,he,Le,tt),this._allowedValues=Ve}validate(K){return T(K,this.defaultValue,this._allowedValues)}}class c extends k{constructor(K,he,Le,Ve,tt,lt,ft=void 0){typeof ft!="undefined"&&(ft.type="string",ft.enum=tt,ft.default=Ve),super(K,he,Le,ft),this._allowedValues=tt,this._convert=lt}validate(K){return typeof K!="string"?this.defaultValue:this._allowedValues.indexOf(K)===-1?this.defaultValue:this._convert(K)}}function g(z){switch(z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class S extends k{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[h.localize(0,null),h.localize(1,null),h.localize(2,null)],default:"auto",description:h.localize(3,null)})}validate(K){switch(K){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(K,he,Le){return Le===0?K.accessibilitySupport:Le}}class i extends k{constructor(){const K={insertSpace:!0,ignoreEmptyLines:!0};super(18,"comments",K,{"editor.comments.insertSpace":{type:"boolean",default:K.insertSpace,description:h.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:K.ignoreEmptyLines,description:h.localize(5,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{insertSpace:r(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:r(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var s;(function(z){z[z.Hidden=0]="Hidden",z[z.Blink=1]="Blink",z[z.Smooth=2]="Smooth",z[z.Phase=3]="Phase",z[z.Expand=4]="Expand",z[z.Solid=5]="Solid"})(s=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function u(z){switch(z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var o;(function(z){z[z.Line=1]="Line",z[z.Block=2]="Block",z[z.Underline=3]="Underline",z[z.LineThin=4]="LineThin",z[z.BlockOutline=5]="BlockOutline",z[z.UnderlineThin=6]="UnderlineThin"})(o=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function f(z){switch(z){case o.Line:return"line";case o.Block:return"block";case o.Underline:return"underline";case o.LineThin:return"line-thin";case o.BlockOutline:return"block-outline";case o.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=f;function p(z){switch(z){case"line":return o.Line;case"block":return o.Block;case"underline":return o.Underline;case"line-thin":return o.LineThin;case"block-outline":return o.BlockOutline;case"underline-thin":return o.UnderlineThin}}class w extends t{constructor(){super(127,[65,32])}compute(K,he,Le){const Ve=["monaco-editor"];return he.get(32)&&Ve.push(he.get(32)),K.extraEditorClassName&&Ve.push(K.extraEditorClassName),he.get(65)==="default"?Ve.push("mouse-default"):he.get(65)==="copy"&&Ve.push("mouse-copy"),he.get(100)&&Ve.push("showUnused"),he.get(125)&&Ve.push("showDeprecated"),Ve.join(" ")}}class C extends d{constructor(){super(31,"emptySelectionClipboard",!0,{description:h.localize(6,null)})}compute(K,he,Le){return Le&&K.emptySelectionClipboard}}class P extends k{constructor(){const K={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(34,"find",K,{"editor.find.cursorMoveOnType":{type:"boolean",default:K.cursorMoveOnType,description:h.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:K.seedSearchStringFromSelection,enumDescriptions:[h.localize(8,null),h.localize(9,null),h.localize(10,null)],description:h.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:K.autoFindInSelection,enumDescriptions:[h.localize(12,null),h.localize(13,null),h.localize(14,null)],description:h.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:K.globalFindClipboard,description:h.localize(16,null),included:F.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:K.addExtraSpaceOnTop,description:h.localize(17,null)},"editor.find.loop":{type:"boolean",default:K.loop,description:h.localize(18,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{cursorMoveOnType:r(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof K.seedSearchStringFromSelection=="boolean"?K.seedSearchStringFromSelection?"always":"never":T(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof K.autoFindInSelection=="boolean"?K.autoFindInSelection?"always":"never":T(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:r(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:r(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:r(he.loop,this.defaultValue.loop)}}}class n extends k{constructor(){super(43,"fontLigatures",n.OFF,{anyOf:[{type:"boolean",description:h.localize(19,null)},{type:"string",description:h.localize(20,null)}],description:h.localize(21,null),default:!1})}validate(K){return typeof K=="undefined"?this.defaultValue:typeof K=="string"?K==="false"?n.OFF:K==="true"?n.ON:K:Boolean(K)?n.ON:n.OFF}}e.EditorFontLigatures=n,n.OFF='"liga" off, "calt" off',n.ON='"liga" on, "calt" on';class m extends t{constructor(){super(42)}compute(K,he,Le){return K.fontInfo}}class D extends _{constructor(){super(44,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:h.localize(22,null)})}validate(K){let he=l.float(K,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(he,6,100)}compute(K,he,Le){return K.fontInfo.fontSize}}class O extends k{constructor(){super(45,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:O.MINIMUM_VALUE,maximum:O.MAXIMUM_VALUE,errorMessage:h.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:O.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:h.localize(24,null)})}validate(K){return K==="normal"||K==="bold"?K:String(a.clampedInt(K,e.EDITOR_FONT_DEFAULTS.fontWeight,O.MINIMUM_VALUE,O.MAXIMUM_VALUE))}}O.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],O.MINIMUM_VALUE=1,O.MAXIMUM_VALUE=1e3;class $ extends k{constructor(){const K={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:K.multiple,enumDescriptions:[h.localize(25,null),h.localize(26,null),h.localize(27,null)]},Le=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(49,"gotoLocation",K,{"editor.gotoLocation.multiple":{deprecationMessage:h.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:h.localize(29,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:h.localize(30,null),...he},"editor.gotoLocation.multipleDeclarations":{description:h.localize(31,null),...he},"editor.gotoLocation.multipleImplementations":{description:h.localize(32,null),...he},"editor.gotoLocation.multipleReferences":{description:h.localize(33,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:K.alternativeDefinitionCommand,enum:Le,description:h.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:K.alternativeTypeDefinitionCommand,enum:Le,description:h.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:K.alternativeDeclarationCommand,enum:Le,description:h.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:K.alternativeImplementationCommand,enum:Le,description:h.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:K.alternativeReferenceCommand,enum:Le,description:h.localize(38,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{multiple:T(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??T(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??T(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??T(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??T(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??T(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:v.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:v.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:v.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:v.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:v.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class Q extends k{constructor(){const K={enabled:!0,delay:300,sticky:!0};super(52,"hover",K,{"editor.hover.enabled":{type:"boolean",default:K.enabled,description:h.localize(39,null)},"editor.hover.delay":{type:"number",default:K.delay,description:h.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:K.sticky,description:h.localize(41,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{enabled:r(he.enabled,this.defaultValue.enabled),delay:a.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:r(he.sticky,this.defaultValue.sticky)}}}var ie;(function(z){z[z.None=0]="None",z[z.Text=1]="Text",z[z.Blocks=2]="Blocks"})(ie=e.RenderMinimap||(e.RenderMinimap={}));class V extends t{constructor(){super(130,[48,57,36,64,92,59,60,94,117,120,121,122,2])}compute(K,he,Le){return V.computeLayout(he,{memory:K.memory,outerWidth:K.outerWidth,outerHeight:K.outerHeight,isDominatedByLongLines:K.isDominatedByLongLines,lineHeight:K.fontInfo.lineHeight,viewLineCount:K.viewLineCount,lineNumbersDigitCount:K.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:K.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:K.fontInfo.maxDigitWidth,pixelRatio:K.pixelRatio})}static computeContainedMinimapLineCount(K){const he=K.height/K.lineHeight,Le=K.scrollBeyondLastLine?he-1:0,Ve=(K.viewLineCount+Le)/(K.pixelRatio*K.height),tt=Math.floor(K.viewLineCount/Ve);return{typicalViewportLineCount:he,extraLinesBeyondLastLine:Le,desiredRatio:Ve,minimapLineCount:tt}}static _computeMinimapLayout(K,he){const Le=K.outerWidth,Ve=K.outerHeight,tt=K.pixelRatio;if(!K.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(tt*Ve),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:Ve};const lt=he.stableMinimapLayoutInput,ft=lt&&K.outerHeight===lt.outerHeight&&K.lineHeight===lt.lineHeight&&K.typicalHalfwidthCharacterWidth===lt.typicalHalfwidthCharacterWidth&&K.pixelRatio===lt.pixelRatio&&K.scrollBeyondLastLine===lt.scrollBeyondLastLine&&K.minimap.enabled===lt.minimap.enabled&&K.minimap.side===lt.minimap.side&&K.minimap.size===lt.minimap.size&&K.minimap.showSlider===lt.minimap.showSlider&&K.minimap.renderCharacters===lt.minimap.renderCharacters&&K.minimap.maxColumn===lt.minimap.maxColumn&&K.minimap.scale===lt.minimap.scale&&K.verticalScrollbarWidth===lt.verticalScrollbarWidth&&K.isViewportWrapping===lt.isViewportWrapping,St=K.lineHeight,Pt=K.typicalHalfwidthCharacterWidth,dt=K.scrollBeyondLastLine,bt=K.minimap.renderCharacters;let mt=tt>=2?Math.round(K.minimap.scale*2):K.minimap.scale;const Et=K.minimap.maxColumn,Ye=K.minimap.size,Ct=K.minimap.side,Pe=K.verticalScrollbarWidth,ye=K.viewLineCount,ke=K.remainingWidth,X=K.isViewportWrapping,ue=bt?2:3;let ge=Math.floor(tt*Ve);const me=ge/tt;let Ie=!1,Ue=!1,Me=ue*mt,je=mt/tt,Je=1;if(Ye==="fill"||Ye==="fit"){const{typicalViewportLineCount:qe,extraLinesBeyondLastLine:ze,desiredRatio:it,minimapLineCount:vt}=V.computeContainedMinimapLineCount({viewLineCount:ye,scrollBeyondLastLine:dt,height:Ve,lineHeight:St,pixelRatio:tt});if(ye/vt>1)Ie=!0,Ue=!0,mt=1,Me=1,je=mt/tt;else{let ot=!1,st=mt+1;if(Ye==="fit"){const ut=Math.ceil((ye+ze)*Me);X&&ft&&ke<=he.stableFitRemainingWidth?(ot=!0,st=he.stableFitMaxMinimapScale):ot=ut>ge}if(Ye==="fill"||ot){Ie=!0;const ut=mt;Me=Math.min(St*tt,Math.max(1,Math.floor(1/it))),X&&ft&&ke<=he.stableFitRemainingWidth&&(st=he.stableFitMaxMinimapScale),mt=Math.min(st,Math.max(1,Math.floor(Me/ue))),mt>ut&&(Je=Math.min(2,mt/ut)),je=mt/tt/Je,ge=Math.ceil(Math.max(qe,ye+ze)*Me),X?(he.stableMinimapLayoutInput=K,he.stableFitRemainingWidth=ke,he.stableFitMaxMinimapScale=mt):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const te=Math.floor(Et*je),pe=Math.min(te,Math.max(0,Math.floor((ke-Pe-2)*je/(Pt+je)))+e.MINIMAP_GUTTER_WIDTH);let oe=Math.floor(tt*pe);const U=oe/tt;oe=Math.floor(oe*Je);const De=bt?1:2,Se=Ct==="left"?0:Le-pe-Pe;return{renderMinimap:De,minimapLeft:Se,minimapWidth:pe,minimapHeightIsEditorHeight:Ie,minimapIsSampling:Ue,minimapScale:mt,minimapLineHeight:Me,minimapCanvasInnerWidth:oe,minimapCanvasInnerHeight:ge,minimapCanvasOuterWidth:U,minimapCanvasOuterHeight:me}}static computeLayout(K,he){const Le=he.outerWidth|0,Ve=he.outerHeight|0,tt=he.lineHeight|0,lt=he.lineNumbersDigitCount|0,ft=he.typicalHalfwidthCharacterWidth,St=he.maxDigitWidth,Pt=he.pixelRatio,dt=he.viewLineCount,bt=K.get(122),mt=bt==="inherit"?K.get(121):bt,Et=mt==="inherit"?K.get(117):mt,Ye=K.get(120),Ct=K.get(2),Pe=he.isDominatedByLongLines,ye=K.get(48),ke=K.get(59).renderType!==0,X=K.get(60),ue=K.get(94),ge=K.get(64),me=K.get(92),Ie=me.verticalScrollbarSize,Ue=me.verticalHasArrows,Me=me.arrowSize,je=me.horizontalScrollbarSize,Je=K.get(57),te=K.get(36);let pe;if(typeof Je=="string"&&/^\d+(\.\d+)?ch$/.test(Je)){const Wt=parseFloat(Je.substr(0,Je.length-2));pe=a.clampedInt(Wt*ft,0,0,1e3)}else pe=a.clampedInt(Je,0,0,1e3);te&&(pe+=16);let oe=0;if(ke){const Wt=Math.max(lt,X);oe=Math.round(Wt*St)}let U=0;ye&&(U=tt);let De=0,Se=De+U,qe=Se+oe,ze=qe+pe;const it=Le-U-oe-pe;let vt=!1,ht=!1,ot=-1;Ct!==2&&(mt==="inherit"&&Pe?(vt=!0,ht=!0):Et==="on"||Et==="bounded"?ht=!0:Et==="wordWrapColumn"&&(ot=Ye));const st=V._computeMinimapLayout({outerWidth:Le,outerHeight:Ve,lineHeight:tt,typicalHalfwidthCharacterWidth:ft,pixelRatio:Pt,scrollBeyondLastLine:ue,minimap:ge,verticalScrollbarWidth:Ie,viewLineCount:dt,remainingWidth:it,isViewportWrapping:ht},he.memory||new y);st.renderMinimap!==0&&st.minimapLeft===0&&(De+=st.minimapWidth,Se+=st.minimapWidth,qe+=st.minimapWidth,ze+=st.minimapWidth);const ut=it-st.minimapWidth,kt=Math.max(1,Math.floor((ut-Ie-2)/ft)),Tt=Ue?Me:0;return ht&&(ot=Math.max(1,kt),Et==="bounded"&&(ot=Math.min(ot,Ye))),{width:Le,height:Ve,glyphMarginLeft:De,glyphMarginWidth:U,lineNumbersLeft:Se,lineNumbersWidth:oe,decorationsLeft:qe,decorationsWidth:pe,contentLeft:ze,contentWidth:ut,minimap:st,viewportColumn:kt,isWordWrapMinified:vt,isViewportWrapping:ht,wrappingColumn:ot,verticalScrollbarWidth:Ie,horizontalScrollbarHeight:je,overviewRuler:{top:Tt,width:Ie,height:Ve-2*Tt,right:0}}}}e.EditorLayoutInfoComputer=V;class W extends k{constructor(){const K={enabled:!0};super(56,"lightbulb",K,{"editor.lightbulb.enabled":{type:"boolean",default:K.enabled,description:h.localize(42,null)}})}validate(K){return!K||typeof K!="object"?this.defaultValue:{enabled:r(K.enabled,this.defaultValue.enabled)}}}class L extends k{constructor(){const K={enabled:!0,fontSize:0,fontFamily:""};super(126,"inlayHints",K,{"editor.inlayHints.enabled":{type:"boolean",default:K.enabled,description:h.localize(43,null)},"editor.inlayHints.fontSize":{type:"number",default:K.fontSize,markdownDescription:h.localize(44,null)},"editor.inlayHints.fontFamily":{type:"string",default:K.fontFamily,description:h.localize(45,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{enabled:r(he.enabled,this.defaultValue.enabled),fontSize:a.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:v.string(he.fontFamily,this.defaultValue.fontFamily)}}}class Y extends l{constructor(){super(58,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,K=>l.clamp(K,0,150),{markdownDescription:h.localize(46,null)})}compute(K,he,Le){return K.fontInfo.lineHeight}}class B extends k{constructor(){const K={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",renderCharacters:!0,maxColumn:120,scale:1};super(64,"minimap",K,{"editor.minimap.enabled":{type:"boolean",default:K.enabled,description:h.localize(47,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[h.localize(48,null),h.localize(49,null),h.localize(50,null)],default:K.size,description:h.localize(51,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:K.side,description:h.localize(52,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:K.showSlider,description:h.localize(53,null)},"editor.minimap.scale":{type:"number",default:K.scale,minimum:1,maximum:3,enum:[1,2,3],description:h.localize(54,null)},"editor.minimap.renderCharacters":{type:"boolean",default:K.renderCharacters,description:h.localize(55,null)},"editor.minimap.maxColumn":{type:"number",default:K.maxColumn,description:h.localize(56,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{enabled:r(he.enabled,this.defaultValue.enabled),size:T(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:T(he.side,this.defaultValue.side,["right","left"]),showSlider:T(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:r(he.renderCharacters,this.defaultValue.renderCharacters),scale:a.clampedInt(he.scale,1,1,3),maxColumn:a.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function G(z){return z==="ctrlCmd"?F.isMacintosh?"metaKey":"ctrlKey":"altKey"}class de extends k{constructor(){super(74,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(57,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:h.localize(58,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{top:a.clampedInt(he.top,0,0,1e3),bottom:a.clampedInt(he.bottom,0,0,1e3)}}}class j extends k{constructor(){const K={enabled:!0,cycle:!1};super(75,"parameterHints",K,{"editor.parameterHints.enabled":{type:"boolean",default:K.enabled,description:h.localize(59,null)},"editor.parameterHints.cycle":{type:"boolean",default:K.cycle,description:h.localize(60,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{enabled:r(he.enabled,this.defaultValue.enabled),cycle:r(he.cycle,this.defaultValue.cycle)}}}class le extends t{constructor(){super(128)}compute(K,he,Le){return K.pixelRatio}}class ae extends k{constructor(){const K={other:!0,comments:!1,strings:!1};super(78,"quickSuggestions",K,{anyOf:[{type:"boolean"},{type:"object",properties:{strings:{type:"boolean",default:K.strings,description:h.localize(61,null)},comments:{type:"boolean",default:K.comments,description:h.localize(62,null)},other:{type:"boolean",default:K.other,description:h.localize(63,null)}}}],default:K,description:h.localize(64,null)});this.defaultValue=K}validate(K){if(typeof K=="boolean")return K;if(K&&typeof K=="object"){const he=K,Le={other:r(he.other,this.defaultValue.other),comments:r(he.comments,this.defaultValue.comments),strings:r(he.strings,this.defaultValue.strings)};return Le.other&&Le.comments&&Le.strings?!0:!Le.other&&!Le.comments&&!Le.strings?!1:Le}return this.defaultValue}}var ve;(function(z){z[z.Off=0]="Off",z[z.On=1]="On",z[z.Relative=2]="Relative",z[z.Interval=3]="Interval",z[z.Custom=4]="Custom"})(ve=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Re extends k{constructor(){super(59,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[h.localize(65,null),h.localize(66,null),h.localize(67,null),h.localize(68,null)],default:"on",description:h.localize(69,null)})}validate(K){let he=this.defaultValue.renderType,Le=this.defaultValue.renderFn;return typeof K!="undefined"&&(typeof K=="function"?(he=4,Le=K):K==="interval"?he=3:K==="relative"?he=2:K==="on"?he=1:he=0),{renderType:he,renderFn:Le}}}function Fe(z){const K=z.get(87);return K==="editable"?z.get(80):K!=="on"}e.filterValidationDecorations=Fe;class Ne extends k{constructor(){const K=[],he={type:"number",description:h.localize(70,null)};super(91,"rulers",K,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:h.localize(71,null),format:"color-hex"}}}]},default:K,description:h.localize(72,null)})}validate(K){if(Array.isArray(K)){let he=[];for(let Le of K)if(typeof Le=="number")he.push({column:a.clampedInt(Le,0,0,1e4),color:null});else if(Le&&typeof Le=="object"){const Ve=Le;he.push({column:a.clampedInt(Ve.column,0,0,1e4),color:Ve.color})}return he.sort((Le,Ve)=>Le.column-Ve.column),he}return this.defaultValue}}function Qe(z,K){if(typeof z!="string")return K;switch(z){case"hidden":return 2;case"visible":return 3;default:return 1}}class He extends k{constructor(){const K={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(92,"scrollbar",K,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(73,null),h.localize(74,null),h.localize(75,null)],default:"auto",description:h.localize(76,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[h.localize(77,null),h.localize(78,null),h.localize(79,null)],default:"auto",description:h.localize(80,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:K.verticalScrollbarSize,description:h.localize(81,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:K.horizontalScrollbarSize,description:h.localize(82,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:K.scrollByPage,description:h.localize(83,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K,Le=a.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),Ve=a.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:a.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Qe(he.vertical,this.defaultValue.vertical),horizontal:Qe(he.horizontal,this.defaultValue.horizontal),useShadows:r(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:r(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:r(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:r(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:r(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Le,horizontalSliderSize:a.clampedInt(he.horizontalSliderSize,Le,0,1e3),verticalScrollbarSize:Ve,verticalSliderSize:a.clampedInt(he.verticalSliderSize,Ve,0,1e3),scrollByPage:r(he.scrollByPage,this.defaultValue.scrollByPage)}}}class Ke extends k{constructor(){const K={enabled:!0,mode:"subwordSmart"};super(54,"inlineSuggest",K,{"editor.inlineSuggest.enabled":{type:"boolean",default:K.enabled,description:h.localize(84,null)},"editor.inlineSuggest.mode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[h.localize(85,null),h.localize(86,null),h.localize(87,null)],default:K.mode,description:h.localize(88,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{enabled:r(he.enabled,this.defaultValue.enabled),mode:T(he.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class x extends k{constructor(){const K={enabled:!1};super(12,"bracketPairColorization",K,{"editor.bracketPairColorization.enabled":{type:"boolean",default:K.enabled,description:h.localize(89,null)}})}validate(K){return!K||typeof K!="object"?this.defaultValue:{enabled:r(K.enabled,this.defaultValue.enabled)}}}class q extends k{constructor(){const K={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(106,"suggest",K,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[h.localize(90,null),h.localize(91,null)],default:K.insertMode,description:h.localize(92,null)},"editor.suggest.filterGraceful":{type:"boolean",default:K.filterGraceful,description:h.localize(93,null)},"editor.suggest.localityBonus":{type:"boolean",default:K.localityBonus,description:h.localize(94,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:K.shareSuggestSelections,markdownDescription:h.localize(95,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:K.snippetsPreventQuickSuggestions,description:h.localize(96,null)},"editor.suggest.showIcons":{type:"boolean",default:K.showIcons,description:h.localize(97,null)},"editor.suggest.showStatusBar":{type:"boolean",default:K.showStatusBar,description:h.localize(98,null)},"editor.suggest.preview":{type:"boolean",default:K.preview,description:h.localize(99,null)},"editor.suggest.previewMode":{type:"string",enum:["prefix","subword","subwordSmart"],enumDescriptions:[h.localize(100,null),h.localize(101,null),h.localize(102,null)],default:K.previewMode,description:h.localize(103,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:K.showInlineDetails,description:h.localize(104,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:h.localize(105,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:h.localize(106,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:h.localize(107,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:h.localize(108,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:h.localize(109,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:h.localize(110,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:h.localize(111,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:h.localize(112,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:h.localize(113,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:h.localize(114,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:h.localize(115,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:h.localize(116,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:h.localize(117,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:h.localize(118,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:h.localize(119,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:h.localize(120,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:h.localize(121,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:h.localize(122,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:h.localize(123,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:h.localize(124,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:h.localize(125,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:h.localize(126,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:h.localize(127,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:h.localize(128,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:h.localize(129,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:h.localize(130,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:h.localize(131,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:h.localize(132,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:h.localize(133,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:h.localize(134,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:h.localize(135,null)}})}validate(K){if(!K||typeof K!="object")return this.defaultValue;const he=K;return{insertMode:T(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:r(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:r(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:r(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:r(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:r(he.showIcons,this.defaultValue.showIcons),showStatusBar:r(he.showStatusBar,this.defaultValue.showStatusBar),preview:r(he.preview,this.defaultValue.preview),previewMode:T(he.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:r(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:r(he.showMethods,this.defaultValue.showMethods),showFunctions:r(he.showFunctions,this.defaultValue.showFunctions),showConstructors:r(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:r(he.showDeprecated,this.defaultValue.showDeprecated),showFields:r(he.showFields,this.defaultValue.showFields),showVariables:r(he.showVariables,this.defaultValue.showVariables),showClasses:r(he.showClasses,this.defaultValue.showClasses),showStructs:r(he.showStructs,this.defaultValue.showStructs),showInterfaces:r(he.showInterfaces,this.defaultValue.showInterfaces),showModules:r(he.showModules,this.defaultValue.showModules),showProperties:r(he.showProperties,this.defaultValue.showProperties),showEvents:r(he.showEvents,this.defaultValue.showEvents),showOperators:r(he.showOperators,this.defaultValue.showOperators),showUnits:r(he.showUnits,this.defaultValue.showUnits),showValues:r(he.showValues,this.defaultValue.showValues),showConstants:r(he.showConstants,this.defaultValue.showConstants),showEnums:r(he.showEnums,this.defaultValue.showEnums),showEnumMembers:r(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:r(he.showKeywords,this.defaultValue.showKeywords),showWords:r(he.showWords,this.defaultValue.showWords),showColors:r(he.showColors,this.defaultValue.showColors),showFiles:r(he.showFiles,this.defaultValue.showFiles),showReferences:r(he.showReferences,this.defaultValue.showReferences),showFolders:r(he.showFolders,this.defaultValue.showFolders),showTypeParameters:r(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:r(he.showSnippets,this.defaultValue.showSnippets),showUsers:r(he.showUsers,this.defaultValue.showUsers),showIssues:r(he.showIssues,this.defaultValue.showIssues)}}}class Z extends k{constructor(){super(102,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:h.localize(136,null),default:!0,type:"boolean"}})}validate(K){return!K||typeof K!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:r(K.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class se extends t{constructor(){super(129,[80])}compute(K,he,Le){return he.get(80)?!0:K.tabFocusMode}}var H;(function(z){z[z.None=0]="None",z[z.Same=1]="Same",z[z.Indent=2]="Indent",z[z.DeepIndent=3]="DeepIndent"})(H=e.WrappingIndent||(e.WrappingIndent={}));function ne(z){switch(z){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class fe extends t{constructor(){super(131,[130])}compute(K,he,Le){const Ve=he.get(130);return{isDominatedByLongLines:K.isDominatedByLongLines,isWordWrapMinified:Ve.isWordWrapMinified,isViewportWrapping:Ve.isViewportWrapping,wrappingColumn:Ve.wrappingColumn}}}const Te="Consolas, 'Courier New', monospace",xe="Menlo, Monaco, 'Courier New', monospace",$e="'Droid Sans Mono', 'monospace', monospace, 'Droid Sans Fallback'";e.EDITOR_FONT_DEFAULTS={fontFamily:F.isMacintosh?xe:F.isLinux?$e:Te,fontWeight:"normal",fontSize:F.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!1}},e.editorOptionsRegistry=[];function we(z){return e.editorOptionsRegistry[z.id]=z,z}var Xe;(function(z){z[z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",z[z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",z[z.accessibilitySupport=2]="accessibilitySupport",z[z.accessibilityPageSize=3]="accessibilityPageSize",z[z.ariaLabel=4]="ariaLabel",z[z.autoClosingBrackets=5]="autoClosingBrackets",z[z.autoClosingDelete=6]="autoClosingDelete",z[z.autoClosingOvertype=7]="autoClosingOvertype",z[z.autoClosingQuotes=8]="autoClosingQuotes",z[z.autoIndent=9]="autoIndent",z[z.automaticLayout=10]="automaticLayout",z[z.autoSurround=11]="autoSurround",z[z.bracketPairColorization=12]="bracketPairColorization",z[z.codeLens=13]="codeLens",z[z.codeLensFontFamily=14]="codeLensFontFamily",z[z.codeLensFontSize=15]="codeLensFontSize",z[z.colorDecorators=16]="colorDecorators",z[z.columnSelection=17]="columnSelection",z[z.comments=18]="comments",z[z.contextmenu=19]="contextmenu",z[z.copyWithSyntaxHighlighting=20]="copyWithSyntaxHighlighting",z[z.cursorBlinking=21]="cursorBlinking",z[z.cursorSmoothCaretAnimation=22]="cursorSmoothCaretAnimation",z[z.cursorStyle=23]="cursorStyle",z[z.cursorSurroundingLines=24]="cursorSurroundingLines",z[z.cursorSurroundingLinesStyle=25]="cursorSurroundingLinesStyle",z[z.cursorWidth=26]="cursorWidth",z[z.disableLayerHinting=27]="disableLayerHinting",z[z.disableMonospaceOptimizations=28]="disableMonospaceOptimizations",z[z.domReadOnly=29]="domReadOnly",z[z.dragAndDrop=30]="dragAndDrop",z[z.emptySelectionClipboard=31]="emptySelectionClipboard",z[z.extraEditorClassName=32]="extraEditorClassName",z[z.fastScrollSensitivity=33]="fastScrollSensitivity",z[z.find=34]="find",z[z.fixedOverflowWidgets=35]="fixedOverflowWidgets",z[z.folding=36]="folding",z[z.foldingStrategy=37]="foldingStrategy",z[z.foldingHighlight=38]="foldingHighlight",z[z.foldingImportsByDefault=39]="foldingImportsByDefault",z[z.unfoldOnClickAfterEndOfLine=40]="unfoldOnClickAfterEndOfLine",z[z.fontFamily=41]="fontFamily",z[z.fontInfo=42]="fontInfo",z[z.fontLigatures=43]="fontLigatures",z[z.fontSize=44]="fontSize",z[z.fontWeight=45]="fontWeight",z[z.formatOnPaste=46]="formatOnPaste",z[z.formatOnType=47]="formatOnType",z[z.glyphMargin=48]="glyphMargin",z[z.gotoLocation=49]="gotoLocation",z[z.hideCursorInOverviewRuler=50]="hideCursorInOverviewRuler",z[z.highlightActiveIndentGuide=51]="highlightActiveIndentGuide",z[z.hover=52]="hover",z[z.inDiffEditor=53]="inDiffEditor",z[z.inlineSuggest=54]="inlineSuggest",z[z.letterSpacing=55]="letterSpacing",z[z.lightbulb=56]="lightbulb",z[z.lineDecorationsWidth=57]="lineDecorationsWidth",z[z.lineHeight=58]="lineHeight",z[z.lineNumbers=59]="lineNumbers",z[z.lineNumbersMinChars=60]="lineNumbersMinChars",z[z.linkedEditing=61]="linkedEditing",z[z.links=62]="links",z[z.matchBrackets=63]="matchBrackets",z[z.minimap=64]="minimap",z[z.mouseStyle=65]="mouseStyle",z[z.mouseWheelScrollSensitivity=66]="mouseWheelScrollSensitivity",z[z.mouseWheelZoom=67]="mouseWheelZoom",z[z.multiCursorMergeOverlapping=68]="multiCursorMergeOverlapping",z[z.multiCursorModifier=69]="multiCursorModifier",z[z.multiCursorPaste=70]="multiCursorPaste",z[z.occurrencesHighlight=71]="occurrencesHighlight",z[z.overviewRulerBorder=72]="overviewRulerBorder",z[z.overviewRulerLanes=73]="overviewRulerLanes",z[z.padding=74]="padding",z[z.parameterHints=75]="parameterHints",z[z.peekWidgetDefaultFocus=76]="peekWidgetDefaultFocus",z[z.definitionLinkOpensInPeek=77]="definitionLinkOpensInPeek",z[z.quickSuggestions=78]="quickSuggestions",z[z.quickSuggestionsDelay=79]="quickSuggestionsDelay",z[z.readOnly=80]="readOnly",z[z.renameOnType=81]="renameOnType",z[z.renderControlCharacters=82]="renderControlCharacters",z[z.renderIndentGuides=83]="renderIndentGuides",z[z.renderFinalNewline=84]="renderFinalNewline",z[z.renderLineHighlight=85]="renderLineHighlight",z[z.renderLineHighlightOnlyWhenFocus=86]="renderLineHighlightOnlyWhenFocus",z[z.renderValidationDecorations=87]="renderValidationDecorations",z[z.renderWhitespace=88]="renderWhitespace",z[z.revealHorizontalRightPadding=89]="revealHorizontalRightPadding",z[z.roundedSelection=90]="roundedSelection",z[z.rulers=91]="rulers",z[z.scrollbar=92]="scrollbar",z[z.scrollBeyondLastColumn=93]="scrollBeyondLastColumn",z[z.scrollBeyondLastLine=94]="scrollBeyondLastLine",z[z.scrollPredominantAxis=95]="scrollPredominantAxis",z[z.selectionClipboard=96]="selectionClipboard",z[z.selectionHighlight=97]="selectionHighlight",z[z.selectOnLineNumbers=98]="selectOnLineNumbers",z[z.showFoldingControls=99]="showFoldingControls",z[z.showUnused=100]="showUnused",z[z.snippetSuggestions=101]="snippetSuggestions",z[z.smartSelect=102]="smartSelect",z[z.smoothScrolling=103]="smoothScrolling",z[z.stickyTabStops=104]="stickyTabStops",z[z.stopRenderingLineAfter=105]="stopRenderingLineAfter",z[z.suggest=106]="suggest",z[z.suggestFontSize=107]="suggestFontSize",z[z.suggestLineHeight=108]="suggestLineHeight",z[z.suggestOnTriggerCharacters=109]="suggestOnTriggerCharacters",z[z.suggestSelection=110]="suggestSelection",z[z.tabCompletion=111]="tabCompletion",z[z.tabIndex=112]="tabIndex",z[z.unusualLineTerminators=113]="unusualLineTerminators",z[z.useShadowDOM=114]="useShadowDOM",z[z.useTabStops=115]="useTabStops",z[z.wordSeparators=116]="wordSeparators",z[z.wordWrap=117]="wordWrap",z[z.wordWrapBreakAfterCharacters=118]="wordWrapBreakAfterCharacters",z[z.wordWrapBreakBeforeCharacters=119]="wordWrapBreakBeforeCharacters",z[z.wordWrapColumn=120]="wordWrapColumn",z[z.wordWrapOverride1=121]="wordWrapOverride1",z[z.wordWrapOverride2=122]="wordWrapOverride2",z[z.wrappingIndent=123]="wrappingIndent",z[z.wrappingStrategy=124]="wrappingStrategy",z[z.showDeprecated=125]="showDeprecated",z[z.inlayHints=126]="inlayHints",z[z.editorClassName=127]="editorClassName",z[z.pixelRatio=128]="pixelRatio",z[z.tabFocusMode=129]="tabFocusMode",z[z.layoutInfo=130]="layoutInfo",z[z.wrappingInfo=131]="wrappingInfo"})(Xe=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:we(new d(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:h.localize(137,null)})),acceptSuggestionOnEnter:we(new b(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",h.localize(138,null),""],markdownDescription:h.localize(139,null)})),accessibilitySupport:we(new S),accessibilityPageSize:we(new a(3,"accessibilityPageSize",10,1,1073741824,{description:h.localize(140,null)})),ariaLabel:we(new v(4,"ariaLabel",h.localize(141,null))),autoClosingBrackets:we(new b(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(142,null),h.localize(143,null),""],description:h.localize(144,null)})),autoClosingDelete:we(new b(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",h.localize(145,null),""],description:h.localize(146,null)})),autoClosingOvertype:we(new b(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",h.localize(147,null),""],description:h.localize(148,null)})),autoClosingQuotes:we(new b(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",h.localize(149,null),h.localize(150,null),""],description:h.localize(151,null)})),autoIndent:we(new c(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],g,{enumDescriptions:[h.localize(152,null),h.localize(153,null),h.localize(154,null),h.localize(155,null),h.localize(156,null)],description:h.localize(157,null)})),automaticLayout:we(new d(10,"automaticLayout",!1)),autoSurround:we(new b(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[h.localize(158,null),h.localize(159,null),h.localize(160,null),""],description:h.localize(161,null)})),bracketPairColorization:we(new x),stickyTabStops:we(new d(104,"stickyTabStops",!1,{description:h.localize(162,null)})),codeLens:we(new d(13,"codeLens",!0,{description:h.localize(163,null)})),codeLensFontFamily:we(new v(14,"codeLensFontFamily","",{description:h.localize(164,null)})),codeLensFontSize:we(new a(15,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:h.localize(165,null)})),colorDecorators:we(new d(16,"colorDecorators",!0,{description:h.localize(166,null)})),columnSelection:we(new d(17,"columnSelection",!1,{description:h.localize(167,null)})),comments:we(new i),contextmenu:we(new d(19,"contextmenu",!0)),copyWithSyntaxHighlighting:we(new d(20,"copyWithSyntaxHighlighting",!0,{description:h.localize(168,null)})),cursorBlinking:we(new c(21,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],u,{description:h.localize(169,null)})),cursorSmoothCaretAnimation:we(new d(22,"cursorSmoothCaretAnimation",!1,{description:h.localize(170,null)})),cursorStyle:we(new c(23,"cursorStyle",o.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],p,{description:h.localize(171,null)})),cursorSurroundingLines:we(new a(24,"cursorSurroundingLines",0,0,1073741824,{description:h.localize(172,null)})),cursorSurroundingLinesStyle:we(new b(25,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[h.localize(173,null),h.localize(174,null)],description:h.localize(175,null)})),cursorWidth:we(new a(26,"cursorWidth",0,0,1073741824,{markdownDescription:h.localize(176,null)})),disableLayerHinting:we(new d(27,"disableLayerHinting",!1)),disableMonospaceOptimizations:we(new d(28,"disableMonospaceOptimizations",!1)),domReadOnly:we(new d(29,"domReadOnly",!1)),dragAndDrop:we(new d(30,"dragAndDrop",!0,{description:h.localize(177,null)})),emptySelectionClipboard:we(new C),extraEditorClassName:we(new v(32,"extraEditorClassName","")),fastScrollSensitivity:we(new l(33,"fastScrollSensitivity",5,z=>z<=0?5:z,{markdownDescription:h.localize(178,null)})),find:we(new P),fixedOverflowWidgets:we(new d(35,"fixedOverflowWidgets",!1)),folding:we(new d(36,"folding",!0,{description:h.localize(179,null)})),foldingStrategy:we(new b(37,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[h.localize(180,null),h.localize(181,null)],description:h.localize(182,null)})),foldingHighlight:we(new d(38,"foldingHighlight",!0,{description:h.localize(183,null)})),foldingImportsByDefault:we(new d(39,"foldingImportsByDefault",!1,{description:h.localize(184,null)})),unfoldOnClickAfterEndOfLine:we(new d(40,"unfoldOnClickAfterEndOfLine",!1,{description:h.localize(185,null)})),fontFamily:we(new v(41,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:h.localize(186,null)})),fontInfo:we(new m),fontLigatures2:we(new n),fontSize:we(new D),fontWeight:we(new O),formatOnPaste:we(new d(46,"formatOnPaste",!1,{description:h.localize(187,null)})),formatOnType:we(new d(47,"formatOnType",!1,{description:h.localize(188,null)})),glyphMargin:we(new d(48,"glyphMargin",!0,{description:h.localize(189,null)})),gotoLocation:we(new $),hideCursorInOverviewRuler:we(new d(50,"hideCursorInOverviewRuler",!1,{description:h.localize(190,null)})),highlightActiveIndentGuide:we(new d(51,"highlightActiveIndentGuide",!0,{description:h.localize(191,null)})),hover:we(new Q),inDiffEditor:we(new d(53,"inDiffEditor",!1)),letterSpacing:we(new l(55,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,z=>l.clamp(z,-5,20),{description:h.localize(192,null)})),lightbulb:we(new W),lineDecorationsWidth:we(new _(57,"lineDecorationsWidth",10)),lineHeight:we(new Y),lineNumbers:we(new Re),lineNumbersMinChars:we(new a(60,"lineNumbersMinChars",5,1,300)),linkedEditing:we(new d(61,"linkedEditing",!1,{description:h.localize(193,null)})),links:we(new d(62,"links",!0,{description:h.localize(194,null)})),matchBrackets:we(new b(63,"matchBrackets","always",["always","near","never"],{description:h.localize(195,null)})),minimap:we(new B),mouseStyle:we(new b(65,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:we(new l(66,"mouseWheelScrollSensitivity",1,z=>z===0?1:z,{markdownDescription:h.localize(196,null)})),mouseWheelZoom:we(new d(67,"mouseWheelZoom",!1,{markdownDescription:h.localize(197,null)})),multiCursorMergeOverlapping:we(new d(68,"multiCursorMergeOverlapping",!0,{description:h.localize(198,null)})),multiCursorModifier:we(new c(69,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],G,{markdownEnumDescriptions:[h.localize(199,null),h.localize(200,null)],markdownDescription:h.localize(201,null)})),multiCursorPaste:we(new b(70,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[h.localize(202,null),h.localize(203,null)],markdownDescription:h.localize(204,null)})),occurrencesHighlight:we(new d(71,"occurrencesHighlight",!0,{description:h.localize(205,null)})),overviewRulerBorder:we(new d(72,"overviewRulerBorder",!0,{description:h.localize(206,null)})),overviewRulerLanes:we(new a(73,"overviewRulerLanes",3,0,3)),padding:we(new de),parameterHints:we(new j),peekWidgetDefaultFocus:we(new b(76,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[h.localize(207,null),h.localize(208,null)],description:h.localize(209,null)})),definitionLinkOpensInPeek:we(new d(77,"definitionLinkOpensInPeek",!1,{description:h.localize(210,null)})),quickSuggestions:we(new ae),quickSuggestionsDelay:we(new a(79,"quickSuggestionsDelay",10,0,1073741824,{description:h.localize(211,null)})),readOnly:we(new d(80,"readOnly",!1)),renameOnType:we(new d(81,"renameOnType",!1,{description:h.localize(212,null),markdownDeprecationMessage:h.localize(213,null)})),renderControlCharacters:we(new d(82,"renderControlCharacters",!1,{description:h.localize(214,null)})),renderIndentGuides:we(new d(83,"renderIndentGuides",!0,{description:h.localize(215,null)})),renderFinalNewline:we(new d(84,"renderFinalNewline",!0,{description:h.localize(216,null)})),renderLineHighlight:we(new b(85,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",h.localize(217,null)],description:h.localize(218,null)})),renderLineHighlightOnlyWhenFocus:we(new d(86,"renderLineHighlightOnlyWhenFocus",!1,{description:h.localize(219,null)})),renderValidationDecorations:we(new b(87,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:we(new b(88,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",h.localize(220,null),h.localize(221,null),h.localize(222,null),""],description:h.localize(223,null)})),revealHorizontalRightPadding:we(new a(89,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:we(new d(90,"roundedSelection",!0,{description:h.localize(224,null)})),rulers:we(new Ne),scrollbar:we(new He),scrollBeyondLastColumn:we(new a(93,"scrollBeyondLastColumn",5,0,1073741824,{description:h.localize(225,null)})),scrollBeyondLastLine:we(new d(94,"scrollBeyondLastLine",!0,{description:h.localize(226,null)})),scrollPredominantAxis:we(new d(95,"scrollPredominantAxis",!0,{description:h.localize(227,null)})),selectionClipboard:we(new d(96,"selectionClipboard",!0,{description:h.localize(228,null),included:F.isLinux})),selectionHighlight:we(new d(97,"selectionHighlight",!0,{description:h.localize(229,null)})),selectOnLineNumbers:we(new d(98,"selectOnLineNumbers",!0)),showFoldingControls:we(new b(99,"showFoldingControls","mouseover",["always","mouseover"],{enumDescriptions:[h.localize(230,null),h.localize(231,null)],description:h.localize(232,null)})),showUnused:we(new d(100,"showUnused",!0,{description:h.localize(233,null)})),showDeprecated:we(new d(125,"showDeprecated",!0,{description:h.localize(234,null)})),inlayHints:we(new L),snippetSuggestions:we(new b(101,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[h.localize(235,null),h.localize(236,null),h.localize(237,null),h.localize(238,null)],description:h.localize(239,null)})),smartSelect:we(new Z),smoothScrolling:we(new d(103,"smoothScrolling",!1,{description:h.localize(240,null)})),stopRenderingLineAfter:we(new a(105,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:we(new q),inlineSuggest:we(new Ke),suggestFontSize:we(new a(107,"suggestFontSize",0,0,1e3,{markdownDescription:h.localize(241,null)})),suggestLineHeight:we(new a(108,"suggestLineHeight",0,0,1e3,{markdownDescription:h.localize(242,null)})),suggestOnTriggerCharacters:we(new d(109,"suggestOnTriggerCharacters",!0,{description:h.localize(243,null)})),suggestSelection:we(new b(110,"suggestSelection","recentlyUsed",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[h.localize(244,null),h.localize(245,null),h.localize(246,null)],description:h.localize(247,null)})),tabCompletion:we(new b(111,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[h.localize(248,null),h.localize(249,null),h.localize(250,null)],description:h.localize(251,null)})),tabIndex:we(new a(112,"tabIndex",0,-1,1073741824)),unusualLineTerminators:we(new b(113,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[h.localize(252,null),h.localize(253,null),h.localize(254,null)],description:h.localize(255,null)})),useShadowDOM:we(new d(114,"useShadowDOM",!0)),useTabStops:we(new d(115,"useTabStops",!0,{description:h.localize(256,null)})),wordSeparators:we(new v(116,"wordSeparators",E.USUAL_WORD_SEPARATORS,{description:h.localize(257,null)})),wordWrap:we(new b(117,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[h.localize(258,null),h.localize(259,null),h.localize(260,null),h.localize(261,null)],description:h.localize(262,null)})),wordWrapBreakAfterCharacters:we(new v(118,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:we(new v(119,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:we(new a(120,"wordWrapColumn",80,1,1073741824,{markdownDescription:h.localize(263,null)})),wordWrapOverride1:we(new b(121,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:we(new b(122,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:we(new c(123,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],ne,{enumDescriptions:[h.localize(264,null),h.localize(265,null),h.localize(266,null),h.localize(267,null)],description:h.localize(268,null)})),wrappingStrategy:we(new b(124,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[h.localize(269,null),h.localize(270,null)],description:h.localize(271,null)})),editorClassName:we(new w),pixelRatio:we(new le),tabFocusMode:we(new se),layoutInfo:we(new V),wrappingInfo:we(new fe)}}),define(be[118],Ee([18,19]),function(re,e){return re.create("vs/platform/configuration/common/configurationRegistry",e)}),define(be[119],Ee([18,19]),function(re,e){return re.create("vs/platform/extensions/common/extensionValidator",e)}),define(be[120],Ee([18,19]),function(re,e){return re.create("vs/platform/files/common/files",e)}),define(be[121],Ee([18,19]),function(re,e){return re.create("vs/platform/markers/common/markers",e)}),define(be[122],Ee([18,19]),function(re,e){return re.create("vs/platform/theme/common/iconRegistry",e)}),define(be[123],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(be[124],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostExtensionService",e)}),define(be[125],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostProgress",e)}),define(be[126],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostStatusBar",e)}),define(be[127],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTerminalService",e)}),define(be[128],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostTreeViews",e)}),define(be[129],Ee([18,19]),function(re,e){return re.create("vs/workbench/api/common/extHostWorkspace",e)}),define(be[130],Ee([18,19]),function(re,e){return re.create("vs/workbench/common/editor",e)}),define(be[131],Ee([18,19]),function(re,e){return re.create("vs/workbench/common/views",e)}),define(be[132],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(be[133],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/search/common/queryBuilder",e)}),define(be[134],Ee([18,19]),function(re,e){return re.create("vs/workbench/contrib/tasks/common/taskService",e)}),define(be[135],Ee([18,19]),function(re,e){return re.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(be[136],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionRevealType=e.EditorOpenContext=e.EditorResolution=e.EditorActivation=void 0;var h;(function(R){R[R.ACTIVATE=1]="ACTIVATE",R[R.RESTORE=2]="RESTORE",R[R.PRESERVE=3]="PRESERVE"})(h=e.EditorActivation||(e.EditorActivation={}));var F;(function(R){R[R.PICK=0]="PICK",R[R.DISABLED=1]="DISABLED",R[R.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(F=e.EditorResolution||(e.EditorResolution={}));var E;(function(R){R[R.API=0]="API",R[R.USER=1]="USER"})(E=e.EditorOpenContext||(e.EditorOpenContext={}));var A;(function(R){R[R.Center=0]="Center",R[R.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",R[R.NearTop=2]="NearTop",R[R.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(A=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}))}),define(be[137],Ee([0,1,119]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const F=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,E=/^-(\d{4})(\d{2})(\d{2})$/;function A(r){return r=r.trim(),r==="*"||F.test(r)}e.isValidVersionStr=A;function R(r){if(!A(r))return null;if(r=r.trim(),r==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let d=r.match(F);return d?{hasCaret:d[1]==="^",hasGreaterEquals:d[1]===">=",majorBase:d[2]==="x"?0:parseInt(d[2],10),majorMustEqual:d[2]!=="x",minorBase:d[4]==="x"?0:parseInt(d[4],10),minorMustEqual:d[4]!=="x",patchBase:d[6]==="x"?0:parseInt(d[6],10),patchMustEqual:d[6]!=="x",preRelease:d[8]||null}:null}e.parseVersion=R;function I(r){if(!r)return null;let d=r.majorBase,a=r.majorMustEqual,l=r.minorBase,v=r.minorMustEqual,T=r.patchBase,b=r.patchMustEqual;r.hasCaret&&(d===0||(v=!1),b=!1);let c=0;if(r.preRelease){const g=E.exec(r.preRelease);if(g){const[,S,i,s]=g;c=Date.UTC(Number(S),Number(i)-1,Number(s))}}return{majorBase:d,majorMustEqual:a,minorBase:l,minorMustEqual:v,patchBase:T,patchMustEqual:b,isMinimum:r.hasGreaterEquals,notBefore:c}}e.normalizeVersion=I;function y(r,d,a){let l;typeof r=="string"?l=I(R(r)):l=r;let v;d instanceof Date?v=d.getTime():typeof d=="string"&&(v=new Date(d).getTime());let T;if(typeof a=="string"?T=I(R(a)):T=a,!l||!T)return!1;let b=l.majorBase,c=l.minorBase,g=l.patchBase,S=T.majorBase,i=T.minorBase,s=T.patchBase,u=T.notBefore,o=T.majorMustEqual,f=T.minorMustEqual,p=T.patchMustEqual;return T.isMinimum?b>S?!0:b<S?!1:c>i?!0:c<i||v&&v<u?!1:g>=s:(b===1&&S===0&&(!o||!f||!p)&&(S=1,i=0,s=0,o=!0,f=!1,p=!1),b<S?!1:b>S?!o:c<i?!1:c>i?!f:g<s?!1:g>s?!p:!(v&&v<u))}e.isValidVersion=y;function k(r,d,a,l){return a.isBuiltin||typeof a.main=="undefined"?!0:_(r,d,a.engines.vscode,l)}e.isValidExtensionVersion=k;function t(r,d,a){return r==="*"||_(d,a,r)}e.isEngineValid=t;function _(r,d,a,l=[]){let v=I(R(a));if(!v)return l.push(h.localize(0,null,a)),!1;if(v.majorBase===0){if(!v.majorMustEqual||!v.minorMustEqual)return l.push(h.localize(1,null,a)),!1}else if(!v.majorMustEqual)return l.push(h.localize(2,null,a)),!1;return y(r,d,v)?!0:(l.push(h.localize(3,null,r,a)),!1)}}),define(be[81],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class h{constructor(E,A=[],R=!1){this.ctor=E,this.staticArguments=A,this.supportsDelayedInstantiation=R}}e.SyncDescriptor=h}),define(be[56],Ee([0,1,81]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const F=[];function E(R,I,y){I instanceof h.SyncDescriptor||(I=new h.SyncDescriptor(I,[],y)),F.push([R,I])}e.registerSingleton=E;function A(){return F}e.getSingletonServiceDescriptors=A}),define(be[138],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class h{constructor(A){this.incoming=new Map,this.outgoing=new Map,this.data=A}}e.Node=h;class F{constructor(A){this._hashFn=A,this._nodes=new Map}roots(){const A=[];for(let R of this._nodes.values())R.outgoing.size===0&&A.push(R);return A}insertEdge(A,R){const I=this.lookupOrInsertNode(A),y=this.lookupOrInsertNode(R);I.outgoing.set(this._hashFn(R),y),y.incoming.set(this._hashFn(A),I)}removeNode(A){const R=this._hashFn(A);this._nodes.delete(R);for(let I of this._nodes.values())I.outgoing.delete(R),I.incoming.delete(R)}lookupOrInsertNode(A){const R=this._hashFn(A);let I=this._nodes.get(R);return I||(I=new h(A),this._nodes.set(R,I)),I}lookup(A){return this._nodes.get(this._hashFn(A))}isEmpty(){return this._nodes.size===0}toString(){let A=[];for(let[R,I]of this._nodes)A.push(`${R}, (incoming)[${[...I.incoming.keys()].join(", ")}], (outgoing)[${[...I.outgoing.keys()].join(",")}]`);return A.join(`
`)}findCycleSlow(){for(let[A,R]of this._nodes){const I=new Set([A]),y=this._findCycle(R,I);if(y)return y}}_findCycle(A,R){for(let[I,y]of A.outgoing){if(R.has(I))return[...R,I].join(" -> ");R.add(I);const k=this._findCycle(y,R);if(k)return k;R.delete(I)}}}e.Graph=F}),define(be[4],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var h;(function(I){I.serviceIds=new Map,I.DI_TARGET="$di$target",I.DI_DEPENDENCIES="$di$dependencies";function y(k){return k[I.DI_DEPENDENCIES]||[]}I.getServiceDependencies=y})(h=e._util||(e._util={})),e.IInstantiationService=E("instantiationService");function F(I,y,k,t){y[h.DI_TARGET]===y?y[h.DI_DEPENDENCIES].push({id:I,index:k,optional:t}):(y[h.DI_DEPENDENCIES]=[{id:I,index:k,optional:t}],y[h.DI_TARGET]=y)}function E(I){if(h.serviceIds.has(I))return h.serviceIds.get(I);const y=function(k,t,_){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");F(y,k,_,!1)};return y.toString=()=>I,h.serviceIds.set(I,y),y}e.createDecorator=E;function A(I){return I}e.refineServiceDecorator=A;function R(I){return function(y,k,t){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");F(I,y,t,!0)}}e.optional=R}),define(be[139],Ee([0,1,4]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shouldSynchronizeModel=e.IModelService=void 0,e.IModelService=(0,h.createDecorator)("modelService");function F(E){return!E.isTooLargeForSyncing()&&!E.isForSimpleWidget}e.shouldSynchronizeModel=F}),define(be[140],Ee([0,1,3,57,7,20,75,54,139]),function(re,e,h,F,E,A,R,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguageFeatureRequestDelays=e.LanguageFeatureRegistry=void 0;function k(r){return typeof r=="string"?!1:Array.isArray(r)?r.every(k):!!r.exclusive}class t{constructor(){this._clock=0,this._entries=[],this._onDidChange=new h.Emitter}get onDidChange(){return this._onDidChange.event}register(d,a){let l={selector:d,provider:a,_score:-1,_time:this._clock++};return this._entries.push(l),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),(0,E.toDisposable)(()=>{if(l){let v=this._entries.indexOf(l);v>=0&&(this._entries.splice(v,1),this._lastCandidate=void 0,this._onDidChange.fire(this._entries.length),l=void 0)}})}has(d){return this.all(d).length>0}all(d){if(!d)return[];this._updateScores(d);const a=[];for(let l of this._entries)l._score>0&&a.push(l.provider);return a}ordered(d){const a=[];return this._orderedForEach(d,l=>a.push(l.provider)),a}orderedGroups(d){const a=[];let l,v;return this._orderedForEach(d,T=>{l&&v===T._score?l.push(T.provider):(v=T._score,l=[T.provider],a.push(l))}),a}_orderedForEach(d,a){if(!!d){this._updateScores(d);for(const l of this._entries)l._score>0&&a(l)}}_updateScores(d){let a={uri:d.uri.toString(),language:d.getLanguageIdentifier().language};if(!(this._lastCandidate&&this._lastCandidate.language===a.language&&this._lastCandidate.uri===a.uri)){this._lastCandidate=a;for(let l of this._entries)if(l._score=(0,I.score)(l.selector,d.uri,d.getLanguageIdentifier().language,(0,y.shouldSynchronizeModel)(d)),k(l.selector)&&l._score>0){for(let v of this._entries)v._score=0;l._score=1e3;break}this._entries.sort(t._compareByScoreAndTime)}}static _compareByScoreAndTime(d,a){return d._score<a._score?1:d._score>a._score?-1:d._time<a._time?1:d._time>a._time?-1:0}}e.LanguageFeatureRegistry=t;class _{constructor(d,a,l=Number.MAX_SAFE_INTEGER){this._registry=d,this.min=a,this.max=l,this._cache=new A.LRUCache(50,.7)}_key(d){return d.id+(0,F.hash)(this._registry.all(d))}_clamp(d){return d===void 0?this.min:Math.min(this.max,Math.max(this.min,Math.floor(d*1.3)))}get(d){const a=this._key(d),l=this._cache.get(a);return this._clamp(l?.value)}update(d,a){const l=this._key(d);let v=this._cache.get(l);return v||(v=new R.MovingAverage,this._cache.set(l,v)),v.update(a),this.get(d)}}e.LanguageFeatureRequestDelays=_}),define(be[58],Ee([0,1,2,41,140,113,34]),function(re,e,h,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExternalUriOpenerPriority=e.TokenizationRegistry=e.DocumentRangeSemanticTokensProviderRegistry=e.DocumentSemanticTokensProviderRegistry=e.FoldingRangeProviderRegistry=e.SelectionRangeRegistry=e.ColorProviderRegistry=e.LinkProviderRegistry=e.OnTypeFormattingEditProviderRegistry=e.DocumentRangeFormattingEditProviderRegistry=e.DocumentFormattingEditProviderRegistry=e.CodeActionProviderRegistry=e.InlayHintsProviderRegistry=e.CodeLensProviderRegistry=e.TypeDefinitionProviderRegistry=e.ImplementationProviderRegistry=e.DeclarationProviderRegistry=e.DefinitionProviderRegistry=e.LinkedEditingRangeProviderRegistry=e.DocumentHighlightProviderRegistry=e.DocumentSymbolProviderRegistry=e.InlineValuesProviderRegistry=e.EvaluatableExpressionProviderRegistry=e.HoverProviderRegistry=e.SignatureHelpProviderRegistry=e.InlineCompletionsProviderRegistry=e.CompletionProviderRegistry=e.RenameProviderRegistry=e.ReferenceProviderRegistry=e.InlayHintKind=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.SymbolKinds=e.SymbolTag=e.SymbolKind=e.isLocationLink=e.DocumentHighlightKind=e.SignatureHelpTriggerKind=e.CodeActionTriggerType=e.InlineCompletionTriggerKind=e.CompletionTriggerKind=e.CompletionItemInsertTextRule=e.CompletionItemTag=e.completionKindFromString=e.completionKindToCssClass=e.CompletionItemKind=e.TokenMetadata=e.MetadataConsts=e.StandardTokenType=e.ColorId=e.FontStyle=e.LanguageIdentifier=e.LanguageId=void 0;var I;(function(n){n[n.Null=0]="Null",n[n.PlainText=1]="PlainText"})(I=e.LanguageId||(e.LanguageId={}));class y{constructor(m,D){this.language=m,this.id=D}}e.LanguageIdentifier=y;var k;(function(n){n[n.NotSet=-1]="NotSet",n[n.None=0]="None",n[n.Italic=1]="Italic",n[n.Bold=2]="Bold",n[n.Underline=4]="Underline"})(k=e.FontStyle||(e.FontStyle={}));var t;(function(n){n[n.None=0]="None",n[n.DefaultForeground=1]="DefaultForeground",n[n.DefaultBackground=2]="DefaultBackground"})(t=e.ColorId||(e.ColorId={}));var _;(function(n){n[n.Other=0]="Other",n[n.Comment=1]="Comment",n[n.String=2]="String",n[n.RegEx=4]="RegEx"})(_=e.StandardTokenType||(e.StandardTokenType={}));var r;(function(n){n[n.LANGUAGEID_MASK=255]="LANGUAGEID_MASK",n[n.TOKEN_TYPE_MASK=1792]="TOKEN_TYPE_MASK",n[n.FONT_STYLE_MASK=14336]="FONT_STYLE_MASK",n[n.FOREGROUND_MASK=8372224]="FOREGROUND_MASK",n[n.BACKGROUND_MASK=4286578688]="BACKGROUND_MASK",n[n.ITALIC_MASK=2048]="ITALIC_MASK",n[n.BOLD_MASK=4096]="BOLD_MASK",n[n.UNDERLINE_MASK=8192]="UNDERLINE_MASK",n[n.SEMANTIC_USE_ITALIC=1]="SEMANTIC_USE_ITALIC",n[n.SEMANTIC_USE_BOLD=2]="SEMANTIC_USE_BOLD",n[n.SEMANTIC_USE_UNDERLINE=4]="SEMANTIC_USE_UNDERLINE",n[n.SEMANTIC_USE_FOREGROUND=8]="SEMANTIC_USE_FOREGROUND",n[n.SEMANTIC_USE_BACKGROUND=16]="SEMANTIC_USE_BACKGROUND",n[n.LANGUAGEID_OFFSET=0]="LANGUAGEID_OFFSET",n[n.TOKEN_TYPE_OFFSET=8]="TOKEN_TYPE_OFFSET",n[n.FONT_STYLE_OFFSET=11]="FONT_STYLE_OFFSET",n[n.FOREGROUND_OFFSET=14]="FOREGROUND_OFFSET",n[n.BACKGROUND_OFFSET=23]="BACKGROUND_OFFSET"})(r=e.MetadataConsts||(e.MetadataConsts={}));class d{static getLanguageId(m){return(m&255)>>>0}static getTokenType(m){return(m&1792)>>>8}static getFontStyle(m){return(m&14336)>>>11}static getForeground(m){return(m&8372224)>>>14}static getBackground(m){return(m&4286578688)>>>23}static getClassNameFromMetadata(m){let D=this.getForeground(m),O="mtk"+D,$=this.getFontStyle(m);return $&1&&(O+=" mtki"),$&2&&(O+=" mtkb"),$&4&&(O+=" mtku"),O}static getInlineStyleFromMetadata(m,D){const O=this.getForeground(m),$=this.getFontStyle(m);let Q=`color: ${D[O]};`;return $&1&&(Q+="font-style: italic;"),$&2&&(Q+="font-weight: bold;"),$&4&&(Q+="text-decoration: underline;"),Q}}e.TokenMetadata=d;var a;(function(n){n[n.Method=0]="Method",n[n.Function=1]="Function",n[n.Constructor=2]="Constructor",n[n.Field=3]="Field",n[n.Variable=4]="Variable",n[n.Class=5]="Class",n[n.Struct=6]="Struct",n[n.Interface=7]="Interface",n[n.Module=8]="Module",n[n.Property=9]="Property",n[n.Event=10]="Event",n[n.Operator=11]="Operator",n[n.Unit=12]="Unit",n[n.Value=13]="Value",n[n.Constant=14]="Constant",n[n.Enum=15]="Enum",n[n.EnumMember=16]="EnumMember",n[n.Keyword=17]="Keyword",n[n.Text=18]="Text",n[n.Color=19]="Color",n[n.File=20]="File",n[n.Reference=21]="Reference",n[n.Customcolor=22]="Customcolor",n[n.Folder=23]="Folder",n[n.TypeParameter=24]="TypeParameter",n[n.User=25]="User",n[n.Issue=26]="Issue",n[n.Snippet=27]="Snippet"})(a=e.CompletionItemKind||(e.CompletionItemKind={})),e.completionKindToCssClass=function(){let n=Object.create(null);return n[0]="symbol-method",n[1]="symbol-function",n[2]="symbol-constructor",n[3]="symbol-field",n[4]="symbol-variable",n[5]="symbol-class",n[6]="symbol-struct",n[7]="symbol-interface",n[8]="symbol-module",n[9]="symbol-property",n[10]="symbol-event",n[11]="symbol-operator",n[12]="symbol-unit",n[13]="symbol-value",n[14]="symbol-constant",n[15]="symbol-enum",n[16]="symbol-enum-member",n[17]="symbol-keyword",n[27]="symbol-snippet",n[18]="symbol-text",n[19]="symbol-color",n[20]="symbol-file",n[21]="symbol-reference",n[22]="symbol-customcolor",n[23]="symbol-folder",n[24]="symbol-type-parameter",n[25]="account",n[26]="issues",function(m){const D=n[m];let O=D&&R.iconRegistry.get(D);return O||(console.info("No codicon found for CompletionItemKind "+m),O=R.Codicon.symbolProperty),O.classNames}}(),e.completionKindFromString=function(){let n=Object.create(null);return n.method=0,n.function=1,n.constructor=2,n.field=3,n.variable=4,n.class=5,n.struct=6,n.interface=7,n.module=8,n.property=9,n.event=10,n.operator=11,n.unit=12,n.value=13,n.constant=14,n.enum=15,n["enum-member"]=16,n.enumMember=16,n.keyword=17,n.snippet=27,n.text=18,n.color=19,n.file=20,n.reference=21,n.customcolor=22,n.folder=23,n["type-parameter"]=24,n.typeParameter=24,n.account=25,n.issue=26,function(m,D){let O=n[m];return typeof O=="undefined"&&!D&&(O=9),O}}();var l;(function(n){n[n.Deprecated=1]="Deprecated"})(l=e.CompletionItemTag||(e.CompletionItemTag={}));var v;(function(n){n[n.KeepWhitespace=1]="KeepWhitespace",n[n.InsertAsSnippet=4]="InsertAsSnippet"})(v=e.CompletionItemInsertTextRule||(e.CompletionItemInsertTextRule={}));var T;(function(n){n[n.Invoke=0]="Invoke",n[n.TriggerCharacter=1]="TriggerCharacter",n[n.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(T=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var b;(function(n){n[n.Automatic=0]="Automatic",n[n.Explicit=1]="Explicit"})(b=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var c;(function(n){n[n.Invoke=1]="Invoke",n[n.Auto=2]="Auto"})(c=e.CodeActionTriggerType||(e.CodeActionTriggerType={}));var g;(function(n){n[n.Invoke=1]="Invoke",n[n.TriggerCharacter=2]="TriggerCharacter",n[n.ContentChange=3]="ContentChange"})(g=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var S;(function(n){n[n.Text=0]="Text",n[n.Read=1]="Read",n[n.Write=2]="Write"})(S=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));function i(n){return n&&h.URI.isUri(n.uri)&&F.Range.isIRange(n.range)&&(F.Range.isIRange(n.originSelectionRange)||F.Range.isIRange(n.targetSelectionRange))}e.isLocationLink=i;var s;(function(n){n[n.File=0]="File",n[n.Module=1]="Module",n[n.Namespace=2]="Namespace",n[n.Package=3]="Package",n[n.Class=4]="Class",n[n.Method=5]="Method",n[n.Property=6]="Property",n[n.Field=7]="Field",n[n.Constructor=8]="Constructor",n[n.Enum=9]="Enum",n[n.Interface=10]="Interface",n[n.Function=11]="Function",n[n.Variable=12]="Variable",n[n.Constant=13]="Constant",n[n.String=14]="String",n[n.Number=15]="Number",n[n.Boolean=16]="Boolean",n[n.Array=17]="Array",n[n.Object=18]="Object",n[n.Key=19]="Key",n[n.Null=20]="Null",n[n.EnumMember=21]="EnumMember",n[n.Struct=22]="Struct",n[n.Event=23]="Event",n[n.Operator=24]="Operator",n[n.TypeParameter=25]="TypeParameter"})(s=e.SymbolKind||(e.SymbolKind={}));var u;(function(n){n[n.Deprecated=1]="Deprecated"})(u=e.SymbolTag||(e.SymbolTag={}));var o;(function(n){const m=new Map;m.set("file",0),m.set("module",1),m.set("namespace",2),m.set("package",3),m.set("class",4),m.set("method",5),m.set("property",6),m.set("field",7),m.set("constructor",8),m.set("enum",9),m.set("interface",10),m.set("function",11),m.set("variable",12),m.set("constant",13),m.set("string",14),m.set("number",15),m.set("boolean",16),m.set("array",17),m.set("object",18),m.set("key",19),m.set("null",20),m.set("enum-member",21),m.set("struct",22),m.set("event",23),m.set("operator",24),m.set("type-parameter",25);const D=new Map;D.set(0,"file"),D.set(1,"module"),D.set(2,"namespace"),D.set(3,"package"),D.set(4,"class"),D.set(5,"method"),D.set(6,"property"),D.set(7,"field"),D.set(8,"constructor"),D.set(9,"enum"),D.set(10,"interface"),D.set(11,"function"),D.set(12,"variable"),D.set(13,"constant"),D.set(14,"string"),D.set(15,"number"),D.set(16,"boolean"),D.set(17,"array"),D.set(18,"object"),D.set(19,"key"),D.set(20,"null"),D.set(21,"enum-member"),D.set(22,"struct"),D.set(23,"event"),D.set(24,"operator"),D.set(25,"type-parameter");function O(ie){return m.get(ie)}n.fromString=O;function $(ie){return D.get(ie)}n.toString=$;function Q(ie,V){const W=D.get(ie);let L=W&&R.iconRegistry.get("symbol-"+W);return L||(console.info("No codicon found for SymbolKind "+ie),L=R.Codicon.symbolProperty),`${V?"inline":"block"} ${L.classNames}`}n.toCssClassName=Q})(o=e.SymbolKinds||(e.SymbolKinds={}));class f{constructor(m){this.value=m}}e.FoldingRangeKind=f,f.Comment=new f("comment"),f.Imports=new f("imports"),f.Region=new f("region");var p;(function(n){n[n.Collapsed=0]="Collapsed",n[n.Expanded=1]="Expanded"})(p=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var w;(function(n){n[n.Editing=0]="Editing",n[n.Preview=1]="Preview"})(w=e.CommentMode||(e.CommentMode={}));var C;(function(n){n[n.Other=0]="Other",n[n.Type=1]="Type",n[n.Parameter=2]="Parameter"})(C=e.InlayHintKind||(e.InlayHintKind={})),e.ReferenceProviderRegistry=new E.LanguageFeatureRegistry,e.RenameProviderRegistry=new E.LanguageFeatureRegistry,e.CompletionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineCompletionsProviderRegistry=new E.LanguageFeatureRegistry,e.SignatureHelpProviderRegistry=new E.LanguageFeatureRegistry,e.HoverProviderRegistry=new E.LanguageFeatureRegistry,e.EvaluatableExpressionProviderRegistry=new E.LanguageFeatureRegistry,e.InlineValuesProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSymbolProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentHighlightProviderRegistry=new E.LanguageFeatureRegistry,e.LinkedEditingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.DeclarationProviderRegistry=new E.LanguageFeatureRegistry,e.ImplementationProviderRegistry=new E.LanguageFeatureRegistry,e.TypeDefinitionProviderRegistry=new E.LanguageFeatureRegistry,e.CodeLensProviderRegistry=new E.LanguageFeatureRegistry,e.InlayHintsProviderRegistry=new E.LanguageFeatureRegistry,e.CodeActionProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.OnTypeFormattingEditProviderRegistry=new E.LanguageFeatureRegistry,e.LinkProviderRegistry=new E.LanguageFeatureRegistry,e.ColorProviderRegistry=new E.LanguageFeatureRegistry,e.SelectionRangeRegistry=new E.LanguageFeatureRegistry,e.FoldingRangeProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.DocumentRangeSemanticTokensProviderRegistry=new E.LanguageFeatureRegistry,e.TokenizationRegistry=new A.TokenizationRegistryImpl;var P;(function(n){n[n.None=0]="None",n[n.Option=1]="Option",n[n.Default=2]="Default",n[n.Preferred=3]="Preferred"})(P=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}))}),define(be[42],Ee([0,1,26,9,4]),function(re,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyOrExpr=e.ContextKeyAndExpr=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.ContextKeyExpr=e.ContextKeyExprType=void 0;let A=h.userAgent||"";const R=new Map;R.set("false",!1),R.set("true",!0),R.set("isMac",h.isMacintosh),R.set("isLinux",h.isLinux),R.set("isWindows",h.isWindows),R.set("isWeb",h.isWeb),R.set("isMacNative",h.isMacintosh&&!h.isWeb),R.set("isEdge",A.indexOf("Edg/")>=0),R.set("isFirefox",A.indexOf("Firefox")>=0),R.set("isChrome",A.indexOf("Chrome")>=0),R.set("isSafari",A.indexOf("Safari")>=0);const I=Object.prototype.hasOwnProperty;var y;(function(P){P[P.False=0]="False",P[P.True=1]="True",P[P.Defined=2]="Defined",P[P.Not=3]="Not",P[P.Equals=4]="Equals",P[P.NotEquals=5]="NotEquals",P[P.And=6]="And",P[P.Regex=7]="Regex",P[P.NotRegex=8]="NotRegex",P[P.Or=9]="Or",P[P.In=10]="In",P[P.NotIn=11]="NotIn",P[P.Greater=12]="Greater",P[P.GreaterEquals=13]="GreaterEquals",P[P.Smaller=14]="Smaller",P[P.SmallerEquals=15]="SmallerEquals"})(y=e.ContextKeyExprType||(e.ContextKeyExprType={}));class k{static false(){return _.INSTANCE}static true(){return r.INSTANCE}static has(n){return d.create(n)}static equals(n,m){return a.create(n,m)}static notEquals(n,m){return T.create(n,m)}static regex(n,m){return s.create(n,m)}static in(n,m){return l.create(n,m)}static not(n){return b.create(n)}static and(...n){return o.create(n)}static or(...n){return f.create(n)}static greater(n,m){return c.create(n,m)}static less(n,m){return S.create(n,m)}static deserialize(n,m=!1){if(!!n)return this._deserializeOrExpression(n,m)}static _deserializeOrExpression(n,m){let D=n.split("||");return f.create(D.map(O=>this._deserializeAndExpression(O,m)))}static _deserializeAndExpression(n,m){let D=n.split("&&");return o.create(D.map(O=>this._deserializeOne(O,m)))}static _deserializeOne(n,m){if(n=n.trim(),n.indexOf("!=")>=0){let D=n.split("!=");return T.create(D[0].trim(),this._deserializeValue(D[1],m))}if(n.indexOf("==")>=0){let D=n.split("==");return a.create(D[0].trim(),this._deserializeValue(D[1],m))}if(n.indexOf("=~")>=0){let D=n.split("=~");return s.create(D[0].trim(),this._deserializeRegexValue(D[1],m))}if(n.indexOf(" in ")>=0){let D=n.split(" in ");return l.create(D[0].trim(),D[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(n)){const D=n.split(">=");return g.create(D[0].trim(),D[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(n)){const D=n.split(">");return c.create(D[0].trim(),D[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(n)){const D=n.split("<=");return i.create(D[0].trim(),D[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(n)){const D=n.split("<");return S.create(D[0].trim(),D[1].trim())}return/^\!\s*/.test(n)?b.create(n.substr(1).trim()):d.create(n)}static _deserializeValue(n,m){if(n=n.trim(),n==="true")return!0;if(n==="false")return!1;let D=/^'([^']*)'$/.exec(n);return D?D[1].trim():n}static _deserializeRegexValue(n,m){if((0,F.isFalsyOrWhitespace)(n)){if(m)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}let D=n.indexOf("/"),O=n.lastIndexOf("/");if(D===O||D<0){if(m)throw new Error(`bad regexp-value '${n}', missing /-enclosure`);return console.warn(`bad regexp-value '${n}', missing /-enclosure`),null}let $=n.slice(D+1,O),Q=n[O+1]==="i"?"i":"";try{return new RegExp($,Q)}catch(ie){if(m)throw new Error(`bad regexp-value '${n}', parse error: ${ie}`);return console.warn(`bad regexp-value '${n}', parse error: ${ie}`),null}}}e.ContextKeyExpr=k;function t(P,n){return P.cmp(n)}class _{constructor(){this.type=0}cmp(n){return this.type-n.type}equals(n){return n.type===this.type}evaluate(n){return!1}serialize(){return"false"}keys(){return[]}map(n){return this}negate(){return r.INSTANCE}}e.ContextKeyFalseExpr=_,_.INSTANCE=new _;class r{constructor(){this.type=1}cmp(n){return this.type-n.type}equals(n){return n.type===this.type}evaluate(n){return!0}serialize(){return"true"}keys(){return[]}map(n){return this}negate(){return _.INSTANCE}}e.ContextKeyTrueExpr=r,r.INSTANCE=new r;class d{constructor(n){this.key=n,this.type=2}static create(n){const m=R.get(n);return typeof m=="boolean"?m?r.INSTANCE:_.INSTANCE:new d(n)}cmp(n){return n.type!==this.type?this.type-n.type:w(this.key,n.key)}equals(n){return n.type===this.type?this.key===n.key:!1}evaluate(n){return!!n.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(n){return n.mapDefined(this.key)}negate(){return b.create(this.key)}}e.ContextKeyDefinedExpr=d;class a{constructor(n,m){this.key=n,this.value=m,this.type=4}static create(n,m){if(typeof m=="boolean")return m?d.create(n):b.create(n);const D=R.get(n);return typeof D=="boolean"?m===(D?"true":"false")?r.INSTANCE:_.INSTANCE:new a(n,m)}cmp(n){return n.type!==this.type?this.type-n.type:C(this.key,this.value,n.key,n.value)}equals(n){return n.type===this.type?this.key===n.key&&this.value===n.value:!1}evaluate(n){return n.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(n){return n.mapEquals(this.key,this.value)}negate(){return T.create(this.key,this.value)}}e.ContextKeyEqualsExpr=a;class l{constructor(n,m){this.key=n,this.valueKey=m,this.type=10}static create(n,m){return new l(n,m)}cmp(n){return n.type!==this.type?this.type-n.type:C(this.key,this.valueKey,n.key,n.valueKey)}equals(n){return n.type===this.type?this.key===n.key&&this.valueKey===n.valueKey:!1}evaluate(n){const m=n.getValue(this.valueKey),D=n.getValue(this.key);return Array.isArray(m)?m.indexOf(D)>=0:typeof D=="string"&&typeof m=="object"&&m!==null?I.call(m,D):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(n){return n.mapIn(this.key,this.valueKey)}negate(){return v.create(this)}}e.ContextKeyInExpr=l;class v{constructor(n){this._actual=n,this.type=11}static create(n){return new v(n)}cmp(n){return n.type!==this.type?this.type-n.type:this._actual.cmp(n._actual)}equals(n){return n.type===this.type?this._actual.equals(n._actual):!1}evaluate(n){return!this._actual.evaluate(n)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(n){return new v(this._actual.map(n))}negate(){return this._actual}}e.ContextKeyNotInExpr=v;class T{constructor(n,m){this.key=n,this.value=m,this.type=5}static create(n,m){if(typeof m=="boolean")return m?b.create(n):d.create(n);const D=R.get(n);return typeof D=="boolean"?m===(D?"true":"false")?_.INSTANCE:r.INSTANCE:new T(n,m)}cmp(n){return n.type!==this.type?this.type-n.type:C(this.key,this.value,n.key,n.value)}equals(n){return n.type===this.type?this.key===n.key&&this.value===n.value:!1}evaluate(n){return n.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(n){return n.mapNotEquals(this.key,this.value)}negate(){return a.create(this.key,this.value)}}e.ContextKeyNotEqualsExpr=T;class b{constructor(n){this.key=n,this.type=3}static create(n){const m=R.get(n);return typeof m=="boolean"?m?_.INSTANCE:r.INSTANCE:new b(n)}cmp(n){return n.type!==this.type?this.type-n.type:w(this.key,n.key)}equals(n){return n.type===this.type?this.key===n.key:!1}evaluate(n){return!n.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(n){return n.mapNot(this.key)}negate(){return d.create(this.key)}}e.ContextKeyNotExpr=b;class c{constructor(n,m){this.key=n,this.value=m,this.type=12}static create(n,m){return new c(n,m)}cmp(n){return n.type!==this.type?this.type-n.type:C(this.key,this.value,n.key,n.value)}equals(n){return n.type===this.type?this.key===n.key&&this.value===n.value:!1}evaluate(n){return parseFloat(n.getValue(this.key))>parseFloat(this.value)}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(n){return n.mapGreater(this.key,this.value)}negate(){return i.create(this.key,this.value)}}e.ContextKeyGreaterExpr=c;class g{constructor(n,m){this.key=n,this.value=m,this.type=13}static create(n,m){return new g(n,m)}cmp(n){return n.type!==this.type?this.type-n.type:C(this.key,this.value,n.key,n.value)}equals(n){return n.type===this.type?this.key===n.key&&this.value===n.value:!1}evaluate(n){return parseFloat(n.getValue(this.key))>=parseFloat(this.value)}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(n){return n.mapGreaterEquals(this.key,this.value)}negate(){return S.create(this.key,this.value)}}e.ContextKeyGreaterEqualsExpr=g;class S{constructor(n,m){this.key=n,this.value=m,this.type=14}static create(n,m){return new S(n,m)}cmp(n){return n.type!==this.type?this.type-n.type:C(this.key,this.value,n.key,n.value)}equals(n){return n.type===this.type?this.key===n.key&&this.value===n.value:!1}evaluate(n){return parseFloat(n.getValue(this.key))<parseFloat(this.value)}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(n){return n.mapSmaller(this.key,this.value)}negate(){return g.create(this.key,this.value)}}e.ContextKeySmallerExpr=S;class i{constructor(n,m){this.key=n,this.value=m,this.type=15}static create(n,m){return new i(n,m)}cmp(n){return n.type!==this.type?this.type-n.type:C(this.key,this.value,n.key,n.value)}equals(n){return n.type===this.type?this.key===n.key&&this.value===n.value:!1}evaluate(n){return parseFloat(n.getValue(this.key))<=parseFloat(this.value)}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(n){return n.mapSmallerEquals(this.key,this.value)}negate(){return c.create(this.key,this.value)}}e.ContextKeySmallerEqualsExpr=i;class s{constructor(n,m){this.key=n,this.regexp=m,this.type=7}static create(n,m){return new s(n,m)}cmp(n){if(n.type!==this.type)return this.type-n.type;if(this.key<n.key)return-1;if(this.key>n.key)return 1;const m=this.regexp?this.regexp.source:"",D=n.regexp?n.regexp.source:"";return m<D?-1:m>D?1:0}equals(n){if(n.type===this.type){const m=this.regexp?this.regexp.source:"",D=n.regexp?n.regexp.source:"";return this.key===n.key&&m===D}return!1}evaluate(n){let m=n.getValue(this.key);return this.regexp?this.regexp.test(m):!1}serialize(){const n=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${n}`}keys(){return[this.key]}map(n){return n.mapRegex(this.key,this.regexp)}negate(){return u.create(this)}}e.ContextKeyRegexExpr=s;class u{constructor(n){this._actual=n,this.type=8}static create(n){return new u(n)}cmp(n){return n.type!==this.type?this.type-n.type:this._actual.cmp(n._actual)}equals(n){return n.type===this.type?this._actual.equals(n._actual):!1}evaluate(n){return!this._actual.evaluate(n)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(n){return new u(this._actual.map(n))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=u;class o{constructor(n){this.expr=n,this.type=6}static create(n){return o._normalizeArr(n)}cmp(n){if(n.type!==this.type)return this.type-n.type;if(this.expr.length<n.expr.length)return-1;if(this.expr.length>n.expr.length)return 1;for(let m=0,D=this.expr.length;m<D;m++){const O=t(this.expr[m],n.expr[m]);if(O!==0)return O}return 0}equals(n){if(n.type===this.type){if(this.expr.length!==n.expr.length)return!1;for(let m=0,D=this.expr.length;m<D;m++)if(!this.expr[m].equals(n.expr[m]))return!1;return!0}return!1}evaluate(n){for(let m=0,D=this.expr.length;m<D;m++)if(!this.expr[m].evaluate(n))return!1;return!0}static _normalizeArr(n){const m=[];let D=!1;for(const O of n)if(!!O){if(O.type===1){D=!0;continue}if(O.type===0)return _.INSTANCE;if(O.type===6){m.push(...O.expr);continue}m.push(O)}if(m.length===0&&D)return r.INSTANCE;if(m.length!==0){if(m.length===1)return m[0];for(m.sort(t);m.length>1;){const O=m[m.length-1];if(O.type!==9)break;m.pop();const $=m.pop(),Q=f.create(O.expr.map(ie=>o.create([ie,$])));Q&&(m.push(Q),m.sort(t))}return m.length===1?m[0]:new o(m)}}serialize(){return this.expr.map(n=>n.serialize()).join(" && ")}keys(){const n=[];for(let m of this.expr)n.push(...m.keys());return n}map(n){return new o(this.expr.map(m=>m.map(n)))}negate(){let n=[];for(let m of this.expr)n.push(m.negate());return f.create(n)}}e.ContextKeyAndExpr=o;class f{constructor(n){this.expr=n,this.type=9}static create(n){const m=f._normalizeArr(n);if(m.length!==0)return m.length===1?m[0]:new f(m)}cmp(n){if(n.type!==this.type)return this.type-n.type;if(this.expr.length<n.expr.length)return-1;if(this.expr.length>n.expr.length)return 1;for(let m=0,D=this.expr.length;m<D;m++){const O=t(this.expr[m],n.expr[m]);if(O!==0)return O}return 0}equals(n){if(n.type===this.type){if(this.expr.length!==n.expr.length)return!1;for(let m=0,D=this.expr.length;m<D;m++)if(!this.expr[m].equals(n.expr[m]))return!1;return!0}return!1}evaluate(n){for(let m=0,D=this.expr.length;m<D;m++)if(this.expr[m].evaluate(n))return!0;return!1}static _normalizeArr(n){let m=[],D=!1;if(n){for(let O=0,$=n.length;O<$;O++){const Q=n[O];if(!!Q){if(Q.type===0){D=!0;continue}if(Q.type===1)return[r.INSTANCE];if(Q.type===9){m=m.concat(Q.expr);continue}m.push(Q)}}if(m.length===0&&D)return[_.INSTANCE];m.sort(t)}return m}serialize(){return this.expr.map(n=>n.serialize()).join(" || ")}keys(){const n=[];for(let m of this.expr)n.push(...m.keys());return n}map(n){return new f(this.expr.map(m=>m.map(n)))}negate(){let n=[];for(let D of this.expr)n.push(D.negate());const m=D=>D.type===9?D.expr:[D];for(;n.length>1;){const D=n.shift(),O=n.shift(),$=[];for(const Q of m(D))for(const ie of m(O))$.push(k.and(Q,ie));n.unshift(k.or(...$))}return n[0]}}e.ContextKeyOrExpr=f;class p extends d{constructor(n,m,D){super(n);this._defaultValue=m,typeof D=="object"?p._info.push({...D,key:n}):D!==!0&&p._info.push({key:n,description:D,type:m!=null?typeof m:void 0})}static all(){return p._info.values()}bindTo(n){return n.createKey(this.key,this._defaultValue)}getValue(n){return n.getContextKeyValue(this.key)}toNegated(){return k.not(this.key)}isEqualTo(n){return k.equals(this.key,n)}notEqualsTo(n){return k.notEquals(this.key,n)}}e.RawContextKey=p,p._info=[],e.IContextKeyService=(0,E.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function w(P,n){return P<n?-1:P>n?1:0}function C(P,n,m,D){return P<m?-1:P>m?1:n<D?-1:n>D?1:0}}),define(be[141],Ee([0,1,4]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,h.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,h.refineServiceDecorator)(e.IEnvironmentService)}),define(be[25],Ee([0,1,9,4]),function(re,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isAuthenticaionProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function E(t){if(typeof t=="object"&&t!==null&&t.supported!==!0)return t.description}e.getWorkspaceSupportTypeMessage=E;function A(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var R;(function(t){t[t.System=0]="System",t[t.User=1]="User"})(R=e.ExtensionType||(e.ExtensionType={}));class I{constructor(_){this.value=_,this._lower=_.toLowerCase()}static equals(_,r){if(typeof _=="undefined"||_===null)return typeof r=="undefined"||r===null;if(typeof r=="undefined"||r===null)return!1;if(typeof _=="string"||typeof r=="string"){let d=typeof _=="string"?_:_.value,a=typeof r=="string"?r:r.value;return h.equalsIgnoreCase(d,a)}return _._lower===r._lower}static toKey(_){return typeof _=="string"?_.toLowerCase():_._lower}}e.ExtensionIdentifier=I;function y(t){return t.contributes&&t.contributes.localizations?t.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function k(t){return t.contributes&&t.contributes.authentication?t.contributes.authentication.length>0:!1}e.isAuthenticaionProviderExtension=k,e.IBuiltinExtensionsScannerService=(0,F.createDecorator)("IBuiltinExtensionsScannerService")}),define(be[142],Ee([0,1,9,25]),function(re,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function E(a,l){return a.uuid&&l.uuid?a.uuid===l.uuid:a.id===l.id?!0:(0,h.compareIgnoreCase)(a.id,l.id)===0}e.areSameExtensions=E;class A{constructor(l,v){this.version=v,this.id=l.id,this.uuid=l.uuid}key(){return`${this.id}-${this.version}`}equals(l){return l instanceof A?E(this,l)&&this.version===l.version:!1}}e.ExtensionIdentifierWithVersion=A;function R(a,l){return`${a}.${l}`}e.getExtensionId=R;function I(a){return a.toLocaleLowerCase()}e.adoptToGalleryExtensionId=I;function y(a,l){return I(R(a,l))}e.getGalleryExtensionId=y;function k(a,l){const v=[],T=b=>{for(const c of v)if(c.some(g=>E(l(g),l(b))))return c;return null};for(const b of a){const c=T(b);c?c.push(b):v.push([b])}return v}e.groupByExtension=k;function t(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=t;function _(a){return{id:a.identifier.id,name:a.name,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),...a.telemetryData}}e.getGalleryExtensionTelemetryData=_,e.BetterMergeId=new F.ExtensionIdentifier("pprice.better-merge");function r(a){const l=new Set;for(const v of a)v.malicious&&l.add(v.id.id);return l}e.getMaliciousExtensionsSet=r;function d(a,l){const v=[],T=l.manifest.extensionDependencies?.slice(0)??[];for(;T.length;){const b=T.shift();if(b&&v.every(c=>!E(c.identifier,{id:b}))){const c=a.filter(g=>E(g.identifier,{id:b}));c.length===1&&(v.push(c[0]),T.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return v}e.getExtensionDependencies=d}),define(be[59],Ee([0,1,20,17,9,10,2,120,4]),function(re,e,h,F,E,A,R,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,y.createDecorator)("fileService");function k(V){return V.create===!0}e.isFileOpenForWriteOptions=k;var t;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(t=e.FileType||(e.FileType={}));var _;(function(V){V[V.Readonly=1]="Readonly"})(_=e.FilePermission||(e.FilePermission={}));var r;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock"})(r=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function d(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=d;function a(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=a;function l(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=l;function v(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=v;var T;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(T=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class b extends Error{constructor(W,L){super(W);this.code=L}}e.FileSystemProviderError=b;function c(V,W){const L=new b(V.toString(),W);return S(L,W),L}e.createFileSystemProviderError=c;function g(V){return V||c((0,I.localize)(0,null),T.Unknown)}e.ensureFileSystemProviderError=g;function S(V,W){return V.name=W?`${W} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=S;function i(V){if(!V)return T.Unknown;if(V instanceof b)return V.code;const W=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!W)return T.Unknown;switch(W[1]){case T.FileExists:return T.FileExists;case T.FileIsADirectory:return T.FileIsADirectory;case T.FileNotADirectory:return T.FileNotADirectory;case T.FileNotFound:return T.FileNotFound;case T.FileExceedsMemoryLimit:return T.FileExceedsMemoryLimit;case T.FileTooLarge:return T.FileTooLarge;case T.FileWriteLocked:return T.FileWriteLocked;case T.NoPermissions:return T.NoPermissions;case T.Unavailable:return T.Unavailable}return T.Unknown}e.toFileSystemProviderErrorCode=i;function s(V){if(V instanceof C)return V.fileOperationResult;switch(i(V)){case T.FileNotFound:return 1;case T.FileIsADirectory:return 0;case T.FileNotADirectory:return 10;case T.FileWriteLocked:return 5;case T.NoPermissions:return 6;case T.FileExists:return 4;case T.FileExceedsMemoryLimit:return 9;case T.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=s;var u;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY"})(u=e.FileOperation||(e.FileOperation={}));class o{constructor(W,L,Y){this.resource=W,this.operation=L,this.target=Y}isOperation(W){return this.operation===W}}e.FileOperationEvent=o;var f;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(f=e.FileChangeType||(e.FileChangeType={}));class p{constructor(W,L){this.added=void 0,this.updated=void 0,this.deleted=void 0;for(const Y of W)switch(Y.type){case 1:this.added||(this.added=h.TernarySearchTree.forUris(()=>L)),this.added.set(Y.resource,Y);break;case 0:this.updated||(this.updated=h.TernarySearchTree.forUris(()=>L)),this.updated.set(Y.resource,Y);break;case 2:this.deleted||(this.deleted=h.TernarySearchTree.forUris(()=>L)),this.deleted.set(Y.resource,Y);break}}contains(W,...L){return this.doContains(W,{includeChildren:!1},...L)}affects(W,...L){return this.doContains(W,{includeChildren:!0},...L)}doContains(W,L,...Y){if(!W)return!1;const B=Y.length>0;return!!((!B||Y.includes(1))&&(this.added?.get(W)||L.includeChildren&&this.added?.findSuperstr(W))||(!B||Y.includes(0))&&(this.updated?.get(W)||L.includeChildren&&this.updated?.findSuperstr(W))||(!B||Y.includes(2))&&(this.deleted?.findSubstr(W)||L.includeChildren&&this.deleted?.findSuperstr(W)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=p;function w(V,W,L){return!V||!W||V===W||W.length>V.length?!1:(W.charAt(W.length-1)!==F.sep&&(W+=F.sep),L?(0,E.startsWithIgnoreCase)(V,W):V.indexOf(W)===0)}e.isParent=w;class C extends Error{constructor(W,L,Y){super(W);this.fileOperationResult=L,this.options=Y}}e.FileOperationError=C;class P extends C{constructor(W,L,Y){super(W,2,Y);this.stat=L}}e.NotModifiedSinceFileOperationError=P;var n;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(n=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var m;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(m=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function D(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=D;async function O(V,W){if(!W.canHandleResource(R.URI.from({scheme:V.scheme})))return new Promise(L=>{const Y=W.onDidChangeFileSystemProviderRegistrations(B=>{B.scheme===V.scheme&&B.added&&(Y.dispose(),L())})})}e.whenProviderRegistered=O,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(W){return(0,A.isNumber)(W)||(W=0),W<$.KB?(0,I.localize)(1,null,W.toFixed(0)):W<$.MB?(0,I.localize)(2,null,(W/$.KB).toFixed(2)):W<$.GB?(0,I.localize)(3,null,(W/$.MB).toFixed(2)):W<$.TB?(0,I.localize)(4,null,(W/$.GB).toFixed(2)):(0,I.localize)(5,null,(W/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var Q;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(Q=e.Arch||(e.Arch={}));function ie(V){return{maxFileSize:V===0?300*$.MB:16*$.GB,maxHeapSize:V===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=ie}),define(be[60],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class h{constructor(...E){this._entries=new Map;for(let[A,R]of E)this.set(A,R)}set(E,A){const R=this._entries.get(E);return this._entries.set(E,A),R}has(E){return this._entries.has(E)}get(E){return this._entries.get(E)}}e.ServiceCollection=h}),define(be[143],Ee([0,1,13,15,81,138,4,60]),function(re,e,h,F,E,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const y=!1;class k extends Error{constructor(a){super("cyclic dependency between services");this.message=a.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${a.toString()}`}}class t{constructor(a=new I.ServiceCollection,l=!1,v){this._activeInstantiations=new Set,this._services=a,this._strict=l,this._parent=v,this._services.set(R.IInstantiationService,this)}createChild(a){return new t(a,this._strict,this)}invokeFunction(a,...l){let v=r.traceInvocation(a),T=!1;try{return a({get:(c,g)=>{if(T)throw(0,F.illegalState)("service accessor is only valid during the invocation of its target method");const S=this._getOrCreateServiceInstance(c,v);if(!S&&g!==R.optional)throw new Error(`[invokeFunction] unknown service '${c}'`);return S}},...l)}finally{T=!0,v.stop()}}createInstance(a,...l){let v,T;return a instanceof E.SyncDescriptor?(v=r.traceCreation(a.ctor),T=this._createInstance(a.ctor,a.staticArguments.concat(l),v)):(v=r.traceCreation(a),T=this._createInstance(a,l,v)),v.stop(),T}_createInstance(a,l=[],v){let T=R._util.getServiceDependencies(a).sort((g,S)=>g.index-S.index),b=[];for(const g of T){let S=this._getOrCreateServiceInstance(g.id,v);if(!S&&this._strict&&!g.optional)throw new Error(`[createInstance] ${a.name} depends on UNKNOWN service ${g.id}.`);b.push(S)}let c=T.length>0?T[0].index:l.length;if(l.length!==c){console.warn(`[createInstance] First service dependency of ${a.name} at position ${c+1} conflicts with ${l.length} static arguments`);let g=c-l.length;g>0?l=l.concat(new Array(g)):l=l.slice(0,c)}return new a(...[...l,...b])}_setServiceInstance(a,l){if(this._services.get(a)instanceof E.SyncDescriptor)this._services.set(a,l);else if(this._parent)this._parent._setServiceInstance(a,l);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(a){let l=this._services.get(a);return!l&&this._parent?this._parent._getServiceInstanceOrDescriptor(a):l}_getOrCreateServiceInstance(a,l){let v=this._getServiceInstanceOrDescriptor(a);return v instanceof E.SyncDescriptor?this._safeCreateAndCacheServiceInstance(a,v,l.branch(a,!0)):(l.branch(a,!1),v)}_safeCreateAndCacheServiceInstance(a,l,v){if(this._activeInstantiations.has(a))throw new Error(`illegal state - RECURSIVELY instantiating service '${a}'`);this._activeInstantiations.add(a);try{return this._createAndCacheServiceInstance(a,l,v)}finally{this._activeInstantiations.delete(a)}}_createAndCacheServiceInstance(a,l,v){const T=new A.Graph(g=>g.id.toString());let b=0;const c=[{id:a,desc:l,_trace:v}];for(;c.length;){const g=c.pop();if(T.lookupOrInsertNode(g),b++>1e3)throw new k(T);for(let S of R._util.getServiceDependencies(g.desc.ctor)){let i=this._getServiceInstanceOrDescriptor(S.id);if(!i&&!S.optional&&console.warn(`[createInstance] ${a} depends on ${S.id} which is NOT registered.`),i instanceof E.SyncDescriptor){const s={id:S.id,desc:i,_trace:g._trace.branch(S.id,!0)};T.insertEdge(g,s),c.push(s)}}}for(;;){const g=T.roots();if(g.length===0){if(!T.isEmpty())throw new k(T);break}for(const{data:S}of g){if(this._getServiceInstanceOrDescriptor(S.id)instanceof E.SyncDescriptor){const s=this._createServiceInstanceWithOwner(S.id,S.desc.ctor,S.desc.staticArguments,S.desc.supportsDelayedInstantiation,S._trace);this._setServiceInstance(S.id,s)}T.removeNode(S)}}return this._getServiceInstanceOrDescriptor(a)}_createServiceInstanceWithOwner(a,l,v=[],T,b){if(this._services.get(a)instanceof E.SyncDescriptor)return this._createServiceInstance(l,v,T,b);if(this._parent)return this._parent._createServiceInstanceWithOwner(a,l,v,T,b);throw new Error(`illegalState - creating UNKNOWN service instance ${l.name}`)}_createServiceInstance(a,l=[],v,T){if(v){const b=new h.IdleValue(()=>this._createInstance(a,l,T));return new Proxy(Object.create(null),{get(c,g){if(g in c)return c[g];let S=b.value,i=S[g];return typeof i!="function"||(i=i.bind(S),c[g]=i),i},set(c,g,S){return b.value[g]=S,!0}})}else return this._createInstance(a,l,T)}}e.InstantiationService=t;var _;(function(d){d[d.Creation=0]="Creation",d[d.Invocation=1]="Invocation",d[d.Branch=2]="Branch"})(_||(_={}));class r{constructor(a,l){this.type=a,this.name=l,this._start=Date.now(),this._dep=[]}static traceInvocation(a){return y?new r(1,a.name||a.toString().substring(0,42).replace(/\n/g,"")):r._None}static traceCreation(a){return y?new r(0,a.name):r._None}branch(a,l){let v=new r(2,a.toString());return this._dep.push([a,l,v]),v}stop(){let a=Date.now()-this._start;r._totals+=a;let l=!1;function v(b,c){let g=[],S=new Array(b+1).join("	");for(const[i,s,u]of c._dep)if(s&&u){l=!0,g.push(`${S}CREATES -> ${i}`);let o=v(b+1,u);o&&g.push(o)}else g.push(`${S}uses -> ${i}`);return g.join(`
`)}let T=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${v(1,this)}`,`DONE, took ${a.toFixed(2)}ms (grand total ${r._totals.toFixed(2)}ms)`];(a>2||l)&&console.log(T.join(`
`))}}r._None=new class extends r{constructor(){super(-1,null)}stop(){}branch(){return this}},r._totals=0}),define(be[14],Ee([0,1,55,3,7,26,4]),function(re,e,h,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,R.createDecorator)("logService"),e.ILoggerService=(0,R.createDecorator)("loggerService");function I(){return new Date().toISOString()}var y;(function(S){S[S.Trace=0]="Trace",S[S.Debug=1]="Debug",S[S.Info=2]="Info",S[S.Warning=3]="Warning",S[S.Error=4]="Error",S[S.Critical=5]="Critical",S[S.Off=6]="Off"})(y=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=y.Info;class k extends E.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new F.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(i){this.level!==i&&(this.level=i,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=k;class t extends k{constructor(i){super();this.logAlways=i}checkLogLevel(i){return this.logAlways||this.getLevel()<=i}trace(i,...s){this.checkLogLevel(y.Trace)&&this.log(y.Trace,this.format([i,...s]))}debug(i,...s){this.checkLogLevel(y.Debug)&&this.log(y.Debug,this.format([i,...s]))}info(i,...s){this.checkLogLevel(y.Info)&&this.log(y.Info,this.format([i,...s]))}warn(i,...s){this.checkLogLevel(y.Warning)&&this.log(y.Warning,this.format([i,...s]))}error(i,...s){if(this.checkLogLevel(y.Error))if(i instanceof Error){const u=Array.prototype.slice.call(arguments);u[0]=i.stack,this.log(y.Error,this.format(u))}else this.log(y.Error,this.format([i,...s]))}critical(i,...s){this.checkLogLevel(y.Critical)&&this.log(y.Critical,this.format([i,...s]))}flush(){}format(i){let s="";for(let u=0;u<i.length;u++){let o=i[u];if(typeof o=="object")try{o=JSON.stringify(o)}catch(f){}s+=(u>0?" ":"")+o}return s}}e.AbstractMessageLogger=t;class _ extends k{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i),this.useColors=!A.isWindows}trace(i,...s){this.getLevel()<=y.Trace&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...s):console.log(`[main ${I()}]`,i,...s))}debug(i,...s){this.getLevel()<=y.Debug&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...s):console.log(`[main ${I()}]`,i,...s))}info(i,...s){this.getLevel()<=y.Info&&(this.useColors?console.log(`[90m[main ${I()}][0m`,i,...s):console.log(`[main ${I()}]`,i,...s))}warn(i,...s){this.getLevel()<=y.Warning&&(this.useColors?console.warn(`[93m[main ${I()}][0m`,i,...s):console.warn(`[main ${I()}]`,i,...s))}error(i,...s){this.getLevel()<=y.Error&&(this.useColors?console.error(`[91m[main ${I()}][0m`,i,...s):console.error(`[main ${I()}]`,i,...s))}critical(i,...s){this.getLevel()<=y.Critical&&(this.useColors?console.error(`[90m[main ${I()}][0m`,i,...s):console.error(`[main ${I()}]`,i,...s))}dispose(){}flush(){}}e.ConsoleMainLogger=_;class r extends k{constructor(i=e.DEFAULT_LOG_LEVEL){super();this.setLevel(i)}trace(i,...s){this.getLevel()<=y.Trace&&console.log("%cTRACE","color: #888",i,...s)}debug(i,...s){this.getLevel()<=y.Debug&&console.log("%cDEBUG","background: #eee; color: #888",i,...s)}info(i,...s){this.getLevel()<=y.Info&&console.log("%c INFO","color: #33f",i,...s)}warn(i,...s){this.getLevel()<=y.Warning&&console.log("%c WARN","color: #993",i,...s)}error(i,...s){this.getLevel()<=y.Error&&console.log("%c  ERR","color: #f33",i,...s)}critical(i,...s){this.getLevel()<=y.Critical&&console.log("%cCRITI","background: #f33; color: white",i,...s)}dispose(){}flush(){}}e.ConsoleLogger=r;class d extends k{constructor(i,s=e.DEFAULT_LOG_LEVEL){super();this.adapter=i,this.setLevel(s)}trace(i,...s){this.getLevel()<=y.Trace&&this.adapter.log(y.Trace,[this.extractMessage(i),...s])}debug(i,...s){this.getLevel()<=y.Debug&&this.adapter.log(y.Debug,[this.extractMessage(i),...s])}info(i,...s){this.getLevel()<=y.Info&&this.adapter.log(y.Info,[this.extractMessage(i),...s])}warn(i,...s){this.getLevel()<=y.Warning&&this.adapter.log(y.Warning,[this.extractMessage(i),...s])}error(i,...s){this.getLevel()<=y.Error&&this.adapter.log(y.Error,[this.extractMessage(i),...s])}critical(i,...s){this.getLevel()<=y.Critical&&this.adapter.log(y.Critical,[this.extractMessage(i),...s])}extractMessage(i){return typeof i=="string"?i:(0,h.toErrorMessage)(i,this.getLevel()<=y.Trace)}dispose(){}flush(){}}e.AdapterLogger=d;class a extends k{constructor(i){super();this.logServices=i,i.length&&this.setLevel(i[0].getLevel())}setLevel(i){for(const s of this.logServices)s.setLevel(i);super.setLevel(i)}trace(i,...s){for(const u of this.logServices)u.trace(i,...s)}debug(i,...s){for(const u of this.logServices)u.debug(i,...s)}info(i,...s){for(const u of this.logServices)u.info(i,...s)}warn(i,...s){for(const u of this.logServices)u.warn(i,...s)}error(i,...s){for(const u of this.logServices)u.error(i,...s)}critical(i,...s){for(const u of this.logServices)u.critical(i,...s)}flush(){for(const i of this.logServices)i.flush()}dispose(){for(const i of this.logServices)i.dispose()}}e.MultiplexLogService=a;class l extends E.Disposable{constructor(i){super();this.logger=i,this._register(i)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(i){this.logger.setLevel(i)}getLevel(){return this.logger.getLevel()}trace(i,...s){this.logger.trace(i,...s)}debug(i,...s){this.logger.debug(i,...s)}info(i,...s){this.logger.info(i,...s)}warn(i,...s){this.logger.warn(i,...s)}error(i,...s){this.logger.error(i,...s)}critical(i,...s){this.logger.critical(i,...s)}flush(){this.logger.flush()}}e.LogService=l;class v extends E.Disposable{constructor(i,s){super();this.logLevel=i,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(s(u=>{this.logLevel=u,this.logLevelChangeableLoggers.forEach(o=>o.setLevel(u))}))}getLogger(i){return this.loggers.get(i.toString())}createLogger(i,s){let u=this.loggers.get(i.toString());return u||(u=this.doCreateLogger(i,s?.always?y.Trace:this.logLevel,s),this.loggers.set(i.toString(),u),s?.always||this.logLevelChangeableLoggers.push(u)),u}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(i=>i.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class T{constructor(){this.onDidChangeLogLevel=new F.Emitter().event}setLevel(i){}getLevel(){return y.Info}trace(i,...s){}debug(i,...s){}info(i,...s){}warn(i,...s){}error(i,...s){}critical(i,...s){}dispose(){}flush(){}}e.NullLogService=T;function b(S){if(S.verbose)return y.Trace;if(typeof S.logLevel=="string"){const i=c(S.logLevel.toLowerCase());if(i!==void 0)return i}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=b;function c(S){switch(S){case"trace":return y.Trace;case"debug":return y.Debug;case"info":return y.Info;case"warn":return y.Warning;case"error":return y.Error;case"critical":return y.Critical;case"off":return y.Off}}e.parseLogLevel=c;function g(S){switch(S){case y.Trace:return"trace";case y.Debug:return"debug";case y.Info:return"info";case y.Warning:return"warn";case y.Error:return"error";case y.Critical:return"critical";case y.Off:return"off"}}e.LogLevelToString=g}),define(be[82],Ee([0,1,35,121,4]),function(re,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var A;(function(y){y[y.Unnecessary=1]="Unnecessary",y[y.Deprecated=2]="Deprecated"})(A=e.MarkerTag||(e.MarkerTag={}));var R;(function(y){y[y.Hint=1]="Hint",y[y.Info=2]="Info",y[y.Warning=4]="Warning",y[y.Error=8]="Error"})(R=e.MarkerSeverity||(e.MarkerSeverity={})),function(y){function k(a,l){return l-a}y.compare=k;const t=Object.create(null);t[y.Error]=(0,F.localize)(0,null),t[y.Warning]=(0,F.localize)(1,null),t[y.Info]=(0,F.localize)(2,null);function _(a){return t[a]||""}y.toString=_;function r(a){switch(a){case h.default.Error:return y.Error;case h.default.Warning:return y.Warning;case h.default.Info:return y.Info;case h.default.Ignore:return y.Hint}}y.fromSeverity=r;function d(a){switch(a){case y.Error:return h.default.Error;case y.Warning:return h.default.Warning;case y.Info:return h.default.Info;case y.Hint:return h.default.Ignore}}y.toSeverity=d}(R=e.MarkerSeverity||(e.MarkerSeverity={}));var I;(function(y){const k="";function t(r){return _(r,!0)}y.makeKey=t;function _(r,d){let a=[k];return r.source?a.push(r.source.replace("\xA6","\\\xA6")):a.push(k),r.code?typeof r.code=="string"?a.push(r.code.replace("\xA6","\\\xA6")):a.push(r.code.value.replace("\xA6","\\\xA6")):a.push(k),r.severity!==void 0&&r.severity!==null?a.push(R.toString(r.severity)):a.push(k),r.message&&d?a.push(r.message.replace("\xA6","\\\xA6")):a.push(k),r.startLineNumber!==void 0&&r.startLineNumber!==null?a.push(r.startLineNumber.toString()):a.push(k),r.startColumn!==void 0&&r.startColumn!==null?a.push(r.startColumn.toString()):a.push(k),r.endLineNumber!==void 0&&r.endLineNumber!==null?a.push(r.endLineNumber.toString()):a.push(k),r.endColumn!==void 0&&r.endColumn!==null?a.push(r.endColumn.toString()):a.push(k),a.push(k),a.join("\xA6")}y.makeKeyOptionalMessage=_})(I=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,E.createDecorator)("markerService")}),define(be[144],Ee([0,1,3,35,4]),function(re,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=F.default,e.INotificationService=(0,E.createDecorator)("notificationService");var A;(function(k){k[k.WORKSPACE=0]="WORKSPACE",k[k.GLOBAL=1]="GLOBAL"})(A=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var R;(function(k){k[k.OFF=0]="OFF",k[k.SILENT=1]="SILENT",k[k.ERROR=2]="ERROR"})(R=e.NotificationsFilter||(e.NotificationsFilter={}));class I{constructor(){this.progress=new y,this.onDidClose=h.Event.None,this.onDidChangeVisibility=h.Event.None}updateSeverity(t){}updateMessage(t){}updateActions(t){}close(){}}e.NoOpNotification=I;class y{infinite(){}done(){}total(t){}worked(t){}}e.NoOpProgress=y}),define(be[145],Ee([0,1,7,9,2,4]),function(re,e,h,F,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,A.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return h.Disposable.None},registerValidator(){return h.Disposable.None},registerExternalUriResolver(){return h.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return h.Disposable.None},async open(){return!1},async resolveExternalUri(I){return{resolved:I,dispose(){}}}});function R(I,y){return E.URI.isUri(I)?(0,F.equalsIgnoreCase)(I.scheme,y):(0,F.startsWithIgnoreCase)(I,y+":")}e.matchesScheme=R});var Be=this&&this.__decorate||function(re,e,h,F){var E=arguments.length,A=E<3?e:F===null?F=Object.getOwnPropertyDescriptor(e,h):F,R;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")A=Reflect.decorate(re,e,h,F);else for(var I=re.length-1;I>=0;I--)(R=re[I])&&(A=(E<3?R(A):E>3?R(e,h,A):R(e,h))||A);return E>3&&A&&Object.defineProperty(e,h,A),A},We=this&&this.__param||function(re,e){return function(h,F){e(h,F,re)}};define(be[146],Ee([0,1,13,21,7,4]),function(re,e,h,F,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,A.createDecorator)("progressService");var R;(function(t){t[t.Explorer=1]="Explorer",t[t.Scm=3]="Scm",t[t.Extensions=5]="Extensions",t[t.Window=10]="Window",t[t.Notification=15]="Notification",t[t.Dialog=20]="Dialog"})(R=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class I{constructor(_){this.callback=_}get value(){return this._value}report(_){this._value=_,this.callback(this._value)}}e.Progress=I,I.None=Object.freeze({report(){}});let y=class extends E.Disposable{constructor(_,r){super();this.deferred=new h.DeferredPromise,r.withProgress(_,d=>(this.reporter=d,this.lastStep&&d.report(this.lastStep),this.deferred.p)),this._register((0,E.toDisposable)(()=>this.deferred.complete()))}report(_){this.reporter?this.reporter.report(_):this.lastStep=_}};y=Be([We(1,e.IProgressService)],y),e.UnmanagedProgress=y;class k extends E.Disposable{constructor(_){super();this.progressIndicator=_,this.currentOperationId=0,this.currentOperationDisposables=this._register(new E.DisposableStore)}start(_){this.stop();const r=++this.currentOperationId,d=new F.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{r===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},_),this.currentOperationDisposables.add((0,E.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,E.toDisposable)(()=>d.cancel())),this.currentOperationDisposables.add((0,E.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:r,token:d.token,stop:()=>this.doStop(r),isCurrent:()=>this.currentOperationId===r}}stop(){this.doStop(this.currentOperationId)}doStop(_){this.currentOperationId===_&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=k,e.IEditorProgressService=(0,A.createDecorator)("editorProgressService")}),define(be[28],Ee([0,1,39,10]),function(re,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class E{constructor(){this.data=new Map}add(R,I){h.ok(F.isString(R)),h.ok(F.isObject(I)),h.ok(!this.data.has(R),"There is already an extension with this id"),this.data.set(R,I)}knows(R){return this.data.has(R)}as(R){return this.data.get(R)||null}}e.Registry=new E}),define(be[83],Ee([0,1,3,28]),function(re,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function E(I){return I.length>0&&I.charAt(I.length-1)==="#"?I.substring(0,I.length-1):I}class A{constructor(){this._onDidChangeSchema=new h.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(y,k){this.schemasById[E(y)]=k,this._onDidChangeSchema.fire(y)}notifySchemaChanged(y){this._onDidChangeSchema.fire(y)}getSchemaContributions(){return{schemas:this.schemasById}}}const R=new A;F.Registry.add(e.Extensions.JSONContribution,R)}),define(be[61],Ee([0,1,3,10,118,83,28]),function(re,e,h,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(T){T.Multiline="multilineText",T.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var y;(function(T){T[T.APPLICATION=1]="APPLICATION",T[T.MACHINE=2]="MACHINE",T[T.WINDOW=3]="WINDOW",T[T.RESOURCE=4]="RESOURCE",T[T.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",T[T.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(y=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const k=R.Registry.as(A.Extensions.JSONContribution);class t{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new h.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new h.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:E.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(b,c=!0){this.registerConfigurations([b],c)}registerConfigurations(b,c=!0){const g=[];b.forEach(S=>{g.push(...this.validateAndRegisterProperties(S,c,S.extensionInfo)),this.configurationContributors.push(S),this.registerJSONConfiguration(S)}),k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(g)}deregisterConfigurations(b){const c=[],g=S=>{if(S.properties)for(const i in S.properties)c.push(i),delete this.configurationProperties[i],this.removeFromSchema(i,S.properties[i]);S.allOf&&S.allOf.forEach(i=>g(i))};for(const S of b){g(S);const i=this.configurationContributors.indexOf(S);i!==-1&&this.configurationContributors.splice(i,1)}k.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}registerDefaultConfigurations(b){const c=[],g=[];for(const S of b)for(const i in S)if(c.push(i),e.OVERRIDE_PROPERTY_PATTERN.test(i)){this.defaultValues[i]={...this.defaultValues[i]||{},...S[i]};const s={type:"object",default:this.defaultValues[i],description:E.localize(1,null,i),$ref:e.resourceLanguageSettingsSchemaId};g.push(r(i)),this.configurationProperties[i]=s,this.defaultLanguageConfigurationOverridesNode.properties[i]=s}else{this.defaultValues[i]=S[i];const s=this.configurationProperties[i];s&&(this.updatePropertyDefaultValue(i,s),this.updateSchema(i,s))}this.registerOverrideIdentifiers(g),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterDefaultConfigurations(b){const c=[];for(const g of b)for(const S in g)if(c.push(S),delete this.defaultValues[S],e.OVERRIDE_PROPERTY_PATTERN.test(S))delete this.configurationProperties[S],delete this.defaultLanguageConfigurationOverridesNode.properties[S];else{const i=this.configurationProperties[S];i&&(this.updatePropertyDefaultValue(S,i),this.updateSchema(S,i))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}notifyConfigurationSchemaUpdated(...b){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(b){for(const c of b)this.overrideIdentifiers.add(c);this.updateOverridePropertyPatternKey()}validateAndRegisterProperties(b,c=!0,g,S=3){S=F.isUndefinedOrNull(b.scope)?S:b.scope;let i=[],s=b.properties;if(s)for(let o in s){if(c&&l(o)){delete s[o];continue}const f=s[o];if(this.updatePropertyDefaultValue(o,f),e.OVERRIDE_PROPERTY_PATTERN.test(o)?f.scope=void 0:(f.scope=F.isUndefinedOrNull(f.scope)?S:f.scope,f.restricted=F.isUndefinedOrNull(f.restricted)?!!g?.restrictedConfigurations?.includes(o):f.restricted),s[o].hasOwnProperty("included")&&!s[o].included){this.excludedConfigurationProperties[o]=s[o],delete s[o];continue}else this.configurationProperties[o]=s[o];!s[o].deprecationMessage&&s[o].markdownDeprecationMessage&&(s[o].deprecationMessage=s[o].markdownDeprecationMessage),i.push(o)}let u=b.allOf;if(u)for(let o of u)i.push(...this.validateAndRegisterProperties(o,c,g,S));return i}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(b){const c=g=>{let S=g.properties;if(S)for(const s in S)this.updateSchema(s,S[s]);let i=g.allOf;i&&i.forEach(c)};c(b)}updateSchema(b,c){switch(e.allSettings.properties[b]=c,c.scope){case 1:e.applicationSettings.properties[b]=c;break;case 2:e.machineSettings.properties[b]=c;break;case 6:e.machineOverridableSettings.properties[b]=c;break;case 3:e.windowSettings.properties[b]=c;break;case 4:e.resourceSettings.properties[b]=c;break;case 5:e.resourceSettings.properties[b]=c,this.resourceLanguageSettingsSchema.properties[b]=c;break}}removeFromSchema(b,c){switch(delete e.allSettings.properties[b],c.scope){case 1:delete e.applicationSettings.properties[b];break;case 2:delete e.machineSettings.properties[b];break;case 6:delete e.machineOverridableSettings.properties[b];break;case 3:delete e.windowSettings.properties[b];break;case 4:case 5:delete e.resourceSettings.properties[b];break}}updateOverridePropertyPatternKey(){for(const b of this.overrideIdentifiers.values()){const c=`[${b}]`,g={type:"object",description:E.localize(2,null),errorMessage:E.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(c,g),e.allSettings.properties[c]=g,e.applicationSettings.properties[c]=g,e.machineSettings.properties[c]=g,e.machineOverridableSettings.properties[c]=g,e.windowSettings.properties[c]=g,e.resourceSettings.properties[c]=g}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(b,c){let g=this.defaultValues[b];F.isUndefined(g)&&(g=c.default),F.isUndefined(g)&&(g=d(c.type)),c.default=g}}const _="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(_);function r(T){return T.substring(1,T.length-1)}e.overrideIdentifierFromKey=r;function d(T){switch(Array.isArray(T)?T[0]:T){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=d;const a=new t;R.Registry.add(e.Extensions.Configuration,a);function l(T){return T.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(T)?E.localize(5,null,T):a.getConfigurationProperties()[T]!==void 0?E.localize(6,null,T):null:E.localize(4,null)}e.validateProperty=l;function v(){const T=[],b=a.getConfigurationProperties();for(const c of Object.keys(b))T.push([c,b[c].scope]);return T.push(["launch",4]),T.push(["task",4]),T}e.getScopes=v}),define(be[84],Ee([0,1,22,10,2,61,4,28]),function(re,e,h,F,E,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,R.createDecorator)("configurationService");function y(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof E.URI)}e.isConfigurationOverrides=y;var k;(function(s){s[s.USER=1]="USER",s[s.USER_LOCAL=2]="USER_LOCAL",s[s.USER_REMOTE=3]="USER_REMOTE",s[s.WORKSPACE=4]="WORKSPACE",s[s.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",s[s.DEFAULT=6]="DEFAULT",s[s.MEMORY=7]="MEMORY"})(k=e.ConfigurationTarget||(e.ConfigurationTarget={}));function t(s){switch(s){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=t;function _(s,u){const o=u?s?u.keys.filter(m=>s.keys.indexOf(m)===-1):[...u.keys]:[],f=s?u?s.keys.filter(m=>u.keys.indexOf(m)===-1):[...s.keys]:[],p=[];if(u&&s){for(const m of s.keys)if(u.keys.indexOf(m)!==-1){const D=T(s.contents,m),O=T(u.contents,m);h.equals(D,O)||p.push(m)}}const w=[],C=m=>{const D={};for(const O of m)for(const $ of O.identifiers)D[S($)]=O;return D},P=u?C(u.overrides):{},n=s?C(s.overrides):{};if(Object.keys(P).length)for(const m of o){const D=P[m];D&&w.push([(0,A.overrideIdentifierFromKey)(m),D.keys])}if(Object.keys(n).length)for(const m of f){const D=n[m];D&&w.push([(0,A.overrideIdentifierFromKey)(m),D.keys])}if(Object.keys(P).length&&Object.keys(n).length)for(const m of p){const D=n[m],O=P[m];if(D&&O){const $=_({contents:D.contents,keys:D.keys,overrides:[]},{contents:O.contents,keys:O.keys,overrides:[]});w.push([(0,A.overrideIdentifierFromKey)(m),[...$.added,...$.removed,...$.updated]])}}return{added:o,removed:f,updated:p,overrides:w}}e.compare=_;function r(s,u){const o=[];for(const f of Object.keys(s))if(A.OVERRIDE_PROPERTY_PATTERN.test(f)){const p={};for(const w in s[f])p[w]=s[f][w];o.push({identifiers:[(0,A.overrideIdentifierFromKey)(f).trim()],keys:Object.keys(p),contents:d(p,u)})}return o}e.toOverrides=r;function d(s,u){const o=Object.create(null);for(let f in s)a(o,f,s[f],u);return o}e.toValuesTree=d;function a(s,u,o,f){const p=u.split("."),w=p.pop();let C=s;for(let P=0;P<p.length;P++){let n=p[P],m=C[n];switch(typeof m){case"undefined":m=C[n]=Object.create(null);break;case"object":break;default:f(`Ignoring ${u} as ${p.slice(0,P+1).join(".")} is ${JSON.stringify(m)}`);return}C=m}if(typeof C=="object"&&C!==null)try{C[w]=o}catch(P){f(`Ignoring ${u} as ${p.join(".")} is ${JSON.stringify(C)}`)}else f(`Ignoring ${u} as ${p.join(".")} is ${JSON.stringify(C)}`)}e.addToValueTree=a;function l(s,u){const o=u.split(".");v(s,o)}e.removeFromValueTree=l;function v(s,u){const o=u.shift();if(u.length===0){delete s[o];return}if(Object.keys(s).indexOf(o)!==-1){const f=s[o];typeof f=="object"&&!Array.isArray(f)&&(v(f,u),Object.keys(f).length===0&&delete s[o])}}function T(s,u,o){function f(C,P){let n=C;for(const m of P){if(typeof n!="object"||n===null)return;n=n[m]}return n}const p=u.split("."),w=f(s,p);return typeof w=="undefined"?o:w}e.getConfigurationValue=T;function b(s,u,o){Object.keys(u).forEach(f=>{f!=="__proto__"&&(f in s?F.isObject(s[f])&&F.isObject(u[f])?b(s[f],u[f],o):o&&(s[f]=u[f]):s[f]=u[f])})}e.merge=b;function c(){const s=I.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(s)}e.getConfigurationKeys=c;function g(){const s=Object.create(null),u=I.Registry.as(A.Extensions.Configuration).getConfigurationProperties();for(let o in u){let f=u[o].default;a(s,o,f,p=>console.error(`Conflict in default settings: ${p}`))}return s}e.getDefaultValues=g;function S(s){return`[${s}]`}e.keyFromOverrideIdentifier=S;function i(s,u,o){const f=s.inspect(u),p=s.inspect(o);return typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:typeof p.userValue!="undefined"||typeof p.workspaceValue!="undefined"||typeof p.workspaceFolderValue!="undefined"?p.value:f.defaultValue}e.getMigratedSettingValue=i}),define(be[147],Ee([0,1,16,3,102,7,20,22,10,2,84,61,28]),function(re,e,h,F,E,A,R,I,y,k,t,_,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class d{constructor(i={},s=[],u=[]){this._contents=i,this._keys=s,this._overrides=u,this.isFrozen=!1}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(i){return i?(0,t.getConfigurationValue)(this.contents,i):this.contents}getOverrideValue(i,s){const u=this.getContentsForOverrideIdentifer(s);return u?i?(0,t.getConfigurationValue)(u,i):u:void 0}getKeysForOverrideIdentifier(i){for(const s of this.overrides)if(s.identifiers.indexOf(i)!==-1)return s.keys;return[]}override(i){const s=this.getContentsForOverrideIdentifer(i);if(!s||typeof s!="object"||!Object.keys(s).length)return this;let u={};for(const o of h.distinct([...Object.keys(this.contents),...Object.keys(s)])){let f=this.contents[o],p=s[o];p&&(typeof f=="object"&&typeof p=="object"?(f=I.deepClone(f),this.mergeContents(f,p)):f=p),u[o]=f}return new d(u,this.keys,this.overrides)}merge(...i){const s=I.deepClone(this.contents),u=I.deepClone(this.overrides),o=[...this.keys];for(const f of i){this.mergeContents(s,f.contents);for(const p of f.overrides){const[w]=u.filter(C=>h.equals(C.identifiers,p.identifiers));w?this.mergeContents(w.contents,p.contents):u.push(I.deepClone(p))}for(const p of f.keys)o.indexOf(p)===-1&&o.push(p)}return new d(s,o,u)}freeze(){return this.isFrozen=!0,this}mergeContents(i,s){for(const u of Object.keys(s)){if(u in i&&y.isObject(i[u])&&y.isObject(s[u])){this.mergeContents(i[u],s[u]);continue}i[u]=I.deepClone(s[u])}}checkAndFreeze(i){return this.isFrozen&&!Object.isFrozen(i)?I.deepFreeze(i):i}getContentsForOverrideIdentifer(i){for(const s of this.overrides)if(s.identifiers.indexOf(i)!==-1)return s.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(i,s){this.addKey(i),(0,t.addToValueTree)(this.contents,i,s,u=>{throw new Error(u)})}removeValue(i){this.removeKey(i)&&(0,t.removeFromValueTree)(this.contents,i)}addKey(i){let s=this.keys.length;for(let u=0;u<s;u++)i.indexOf(this.keys[u])===0&&(s=u);this.keys.splice(s,1,i)}removeKey(i){let s=this.keys.indexOf(i);return s!==-1?(this.keys.splice(s,1),!0):!1}}e.ConfigurationModel=d;class a extends d{constructor(){const i=(0,t.getDefaultValues)(),s=(0,t.getConfigurationKeys)(),u=[];for(const o of Object.keys(i))_.OVERRIDE_PROPERTY_PATTERN.test(o)&&u.push({identifiers:[(0,_.overrideIdentifierFromKey)(o).trim()],keys:Object.keys(i[o]),contents:(0,t.toValuesTree)(i[o],f=>console.error(`Conflict in default settings file: ${f}`))});super(i,s,u)}}e.DefaultConfigurationModel=a;class l{constructor(i){this._name=i,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new d}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(i,s){if(!y.isUndefinedOrNull(i)){const u=this.doParseContent(i);this.parseRaw(u,s)}}reparse(i){this._raw&&this.parseRaw(this._raw,i)}parseRaw(i,s){this._raw=i;const{contents:u,keys:o,overrides:f,restricted:p}=this.doParseRaw(i,s);this._configurationModel=new d(u,o,f),this._restrictedConfigurations=p||[]}doParseContent(i){let s={},u=null,o=[],f=[],p=[];function w(P){Array.isArray(o)?o.push(P):u!==null&&(o[u]=P)}let C={onObjectBegin:()=>{let P={};w(P),f.push(o),o=P,u=null},onObjectProperty:P=>{u=P},onObjectEnd:()=>{o=f.pop()},onArrayBegin:()=>{let P=[];w(P),f.push(o),o=P,u=null},onArrayEnd:()=>{o=f.pop()},onLiteralValue:w,onError:(P,n,m)=>{p.push({error:P,offset:n,length:m})}};if(i)try{E.visit(i,C),s=o[0]||{}}catch(P){console.error(`Error while parsing settings file ${this._name}: ${P}`),this._parseErrors=[P]}return s}doParseRaw(i,s){const u=r.Registry.as(_.Extensions.Configuration).getConfigurationProperties(),o=this.filter(i,u,!0,s);i=o.raw;const f=(0,t.toValuesTree)(i,C=>console.error(`Conflict in settings file ${this._name}: ${C}`)),p=Object.keys(i),w=(0,t.toOverrides)(i,C=>console.error(`Conflict in settings file ${this._name}: ${C}`));return{contents:f,keys:p,overrides:w,restricted:o.restricted}}filter(i,s,u,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:i,restricted:[]};const f={},p=[];for(let w in i)if(_.OVERRIDE_PROPERTY_PATTERN.test(w)&&u){const C=this.filter(i[w],s,!1,o);f[w]=C.raw,p.push(...C.restricted)}else{const C=s[w],P=C?typeof C.scope!="undefined"?C.scope:3:void 0;C?.restricted&&p.push(w),(P===void 0||o.scopes===void 0||o.scopes.includes(P))&&(o.skipRestricted&&C?.restricted||(f[w]=i[w]))}return{raw:f,restricted:p}}}e.ConfigurationModelParser=l;class v extends A.Disposable{constructor(i,s,u,o){super();this.userSettingsResource=i,this.scopes=s,this.fileService=o,this._onDidChange=this._register(new F.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new l(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(u.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(F.Event.filter(this.fileService.onDidFilesChange,f=>f.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const i=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(i.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(i){return new d}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=v;class T{constructor(i,s,u=new d,o=new d,f=new R.ResourceMap,p=new d,w=new R.ResourceMap,C=!0){this._defaultConfiguration=i,this._localUserConfiguration=s,this._remoteUserConfiguration=u,this._workspaceConfiguration=o,this._folderConfigurations=f,this._memoryConfiguration=p,this._memoryConfigurationByResource=w,this._freeze=C,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new R.ResourceMap,this._userConfiguration=null}getValue(i,s,u){return this.getConsolidateConfigurationModel(s,u).getValue(i)}updateValue(i,s,u={}){let o;u.resource?(o=this._memoryConfigurationByResource.get(u.resource),o||(o=new d,this._memoryConfigurationByResource.set(u.resource,o))):o=this._memoryConfiguration,s===void 0?o.removeValue(i):o.setValue(i,s),u.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(i,s,u){const o=this.getConsolidateConfigurationModel(s,u),f=this.getFolderConfigurationModelForResource(s.resource,u),p=s.resource?this._memoryConfigurationByResource.get(s.resource)||this._memoryConfiguration:this._memoryConfiguration,w=s.overrideIdentifier?this._defaultConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._defaultConfiguration.freeze().getValue(i),C=s.overrideIdentifier?this.userConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.userConfiguration.freeze().getValue(i),P=s.overrideIdentifier?this.localUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.localUserConfiguration.freeze().getValue(i),n=s.overrideIdentifier?this.remoteUserConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this.remoteUserConfiguration.freeze().getValue(i),m=u?s.overrideIdentifier?this._workspaceConfiguration.freeze().override(s.overrideIdentifier).getValue(i):this._workspaceConfiguration.freeze().getValue(i):void 0,D=f?s.overrideIdentifier?f.freeze().override(s.overrideIdentifier).getValue(i):f.freeze().getValue(i):void 0,O=s.overrideIdentifier?p.override(s.overrideIdentifier).getValue(i):p.getValue(i),$=o.getValue(i),Q=h.distinct(h.flatten(o.overrides.map(ie=>ie.identifiers))).filter(ie=>o.getOverrideValue(i,ie)!==void 0);return{defaultValue:w,userValue:C,userLocalValue:P,userRemoteValue:n,workspaceValue:m,workspaceFolderValue:D,memoryValue:O,value:$,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,user:C!==void 0?{value:this.userConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userLocal:P!==void 0?{value:this.localUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,userRemote:n!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspace:m!==void 0?{value:this._workspaceConfiguration.freeze().getValue(i),override:s.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,workspaceFolder:D!==void 0?{value:f?.freeze().getValue(i),override:s.overrideIdentifier?f?.freeze().getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,memory:O!==void 0?{value:p.getValue(i),override:s.overrideIdentifier?p.getOverrideValue(i,s.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Q.length?Q:void 0}}keys(i){const s=this.getFolderConfigurationModelForResource(void 0,i);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:s?s.freeze().keys:[]}}updateDefaultConfiguration(i){this._defaultConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(i){this._localUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(i){this._remoteUserConfiguration=i,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(i){this._workspaceConfiguration=i,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(i,s){this._folderConfigurations.set(i,s),this._foldersConsolidatedConfigurations.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this._foldersConsolidatedConfigurations.delete(i)}compareAndUpdateDefaultConfiguration(i,s){const u=s.filter(o=>_.OVERRIDE_PROPERTY_PATTERN.test(o)).map(o=>{const f=(0,_.overrideIdentifierFromKey)(o),p=this._defaultConfiguration.getKeysForOverrideIdentifier(f),w=i.getKeysForOverrideIdentifier(f),C=[...w.filter(P=>p.indexOf(P)===-1),...p.filter(P=>w.indexOf(P)===-1),...p.filter(P=>!I.equals(this._defaultConfiguration.override(f).getValue(P),i.override(f).getValue(P)))];return[f,C]});return this.updateDefaultConfiguration(i),{keys:s,overrides:u}}compareAndUpdateLocalUserConfiguration(i){const{added:s,updated:u,removed:o,overrides:f}=(0,t.compare)(this.localUserConfiguration,i),p=[...s,...u,...o];return p.length&&this.updateLocalUserConfiguration(i),{keys:p,overrides:f}}compareAndUpdateRemoteUserConfiguration(i){const{added:s,updated:u,removed:o,overrides:f}=(0,t.compare)(this.remoteUserConfiguration,i);let p=[...s,...u,...o];return p.length&&this.updateRemoteUserConfiguration(i),{keys:p,overrides:f}}compareAndUpdateWorkspaceConfiguration(i){const{added:s,updated:u,removed:o,overrides:f}=(0,t.compare)(this.workspaceConfiguration,i);let p=[...s,...u,...o];return p.length&&this.updateWorkspaceConfiguration(i),{keys:p,overrides:f}}compareAndUpdateFolderConfiguration(i,s){const u=this.folderConfigurations.get(i),{added:o,updated:f,removed:p,overrides:w}=(0,t.compare)(u,s);let C=[...o,...f,...p];return(C.length||!u)&&this.updateFolderConfiguration(i,s),{keys:C,overrides:w}}compareAndDeleteFolderConfiguration(i){const s=this.folderConfigurations.get(i);if(!s)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:u,updated:o,removed:f,overrides:p}=(0,t.compare)(s,void 0);return{keys:[...u,...o,...f],overrides:p}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(i,s){let u=this.getConsolidatedConfigurationModelForResource(i,s);return i.overrideIdentifier?u.override(i.overrideIdentifier):u}getConsolidatedConfigurationModelForResource({resource:i},s){let u=this.getWorkspaceConsolidatedConfiguration();if(s&&i){const o=s.getFolder(i);o&&(u=this.getFolderConsolidatedConfiguration(o.uri)||u);const f=this._memoryConfigurationByResource.get(i);f&&(u=u.merge(f))}return u}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(i){let s=this._foldersConsolidatedConfigurations.get(i);if(!s){const u=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(i);o?(s=u.merge(o),this._freeze&&(s=s.freeze()),this._foldersConsolidatedConfigurations.set(i,s)):s=u}return s}getFolderConfigurationModelForResource(i,s){if(s&&i){const u=s.getFolder(i);if(u)return this._folderConfigurations.get(u.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((i,s)=>{const{contents:u,overrides:o,keys:f}=this._folderConfigurations.get(s);return i.push([s,{contents:u,overrides:o,keys:f}]),i},[])}}allKeys(){const i=new Set;return this._defaultConfiguration.freeze().keys.forEach(s=>i.add(s)),this.userConfiguration.freeze().keys.forEach(s=>i.add(s)),this._workspaceConfiguration.freeze().keys.forEach(s=>i.add(s)),this._folderConfigurations.forEach(s=>s.freeze().keys.forEach(u=>i.add(u))),[...i.values()]}getAllKeysForOverrideIdentifier(i){const s=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(i).forEach(u=>s.add(u)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(u=>s.add(u)),this._workspaceConfiguration.getKeysForOverrideIdentifier(i).forEach(u=>s.add(u)),this._folderConfigurations.forEach(u=>u.getKeysForOverrideIdentifier(i).forEach(o=>s.add(o))),[...s.values()]}static parse(i){const s=this.parseConfigurationModel(i.defaults),u=this.parseConfigurationModel(i.user),o=this.parseConfigurationModel(i.workspace),f=i.folders.reduce((p,w)=>(p.set(k.URI.revive(w[0]),this.parseConfigurationModel(w[1])),p),new R.ResourceMap);return new T(s,u,new d,o,f,new d,new R.ResourceMap,!1)}static parseConfigurationModel(i){return new d(i.contents,i.keys,i.overrides).freeze()}}e.Configuration=T;function b(...S){if(S.length===0)return{keys:[],overrides:[]};if(S.length===1)return S[0];const i=new Set,s=new Map;for(const o of S)o.keys.forEach(f=>i.add(f)),o.overrides.forEach(([f,p])=>{const w=(0,R.getOrSet)(s,f,new Set);p.forEach(C=>w.add(C))});const u=[];return s.forEach((o,f)=>u.push([f,[...o.values()]])),{keys:[...i.values()],overrides:u}}e.mergeChanges=b;class c{constructor(i,s,u,o){this.change=i,this.previous=s,this.currentConfiguraiton=u,this.currentWorkspace=o,this._previousConfiguration=void 0;const f=new Set;i.keys.forEach(w=>f.add(w)),i.overrides.forEach(([,w])=>w.forEach(C=>f.add(C))),this.affectedKeys=[...f.values()];const p=new d;this.affectedKeys.forEach(w=>p.setValue(w,{})),this.affectedKeysTree=p.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=T.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(i,s){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,i)){if(s){const u=this.previousConfiguration?this.previousConfiguration.getValue(i,s,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(i,s,this.currentWorkspace);return!I.equals(u,o)}return!0}return!1}doesAffectedKeysTreeContains(i,s){let u=(0,t.toValuesTree)({[s]:!0},()=>{}),o;for(;typeof u=="object"&&(o=Object.keys(u)[0]);){if(i=i[o],!i)return!1;u=u[o]}return!0}}e.ConfigurationChangeEvent=c;class g extends c{constructor(i,s,u,o){super({keys:i.allKeys(),overrides:[]},void 0,i,s);this.source=u,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=g}),define(be[85],Ee([0,1,4]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,h.createDecorator)("remoteAuthorityResolverService");var F;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(F=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class E extends Error{constructor(R,I=F.Unknown,y){super(R);this._message=R,this._code=I,this._detail=y,this.isHandled=I===F.NotAvailable&&y===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,E.prototype)}static isTemporarilyNotAvailable(R){return R instanceof E&&R._code===F.TemporarilyNotAvailable}static isNoResolverFound(R){return R instanceof E&&R._code===F.NoResolverFound}static isHandled(R){return R instanceof E&&R.isHandled}}e.RemoteAuthorityResolverError=E}),define(be[86],Ee([0,1,11]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function F(k){return k.scheme===h.Schemas.vscodeRemote?k.authority:void 0}e.getRemoteAuthority=F;function E(k){if(!k)return;const t=k.indexOf("+");return t<0?k:k.substr(0,t)}e.getRemoteName=E;function A(k){return k.scheme!==h.Schemas.file&&k.scheme!==h.Schemas.vscodeRemote}e.isVirtualResource=A;function R(k){if(k.folders.length)return k.folders.every(t=>A(t.uri))?k.folders[0].uri:void 0;if(k.configuration&&A(k.configuration))return k.configuration}e.getVirtualWorkspaceLocation=R;function I(k){return R(k)?.scheme}e.getVirtualWorkspaceScheme=I;function y(k){return R(k)!==void 0}e.isVirtualWorkspace=y}),define(be[148],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class h{constructor(E){this._callback=E,this._terminalBufferMap=new Map}dispose(){for(const E of this._terminalBufferMap.values())E.dispose()}startBuffering(E,A,R=5){let I;return I=A(y=>{const k=typeof y=="string"?y:y.data;let t=this._terminalBufferMap.get(E);if(t){t.data.push(k);return}const _=setTimeout(()=>this.flushBuffer(E),R);t={data:[k],timeoutId:_,dispose:()=>{clearTimeout(_),this.flushBuffer(E),I.dispose()}},this._terminalBufferMap.set(E,t)}),I}stopBuffering(E){const A=this._terminalBufferMap.get(E);A&&A.dispose()}flushBuffer(E){const A=this._terminalBufferMap.get(E);A&&(this._terminalBufferMap.delete(E),this._callback(E,A.data.join("")))}}e.TerminalDataBufferer=h}),define(be[149],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var h;(function(F){F.DARK="dark",F.LIGHT="light",F.HIGH_CONTRAST="hc"})(h=e.ColorScheme||(e.ColorScheme={}))}),define(be[43],Ee([0,1,34,3,7,4,28,149]),function(re,e,h,F,E,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,A.createDecorator)("themeService");var y;(function(v){function T(b){return b&&typeof b=="object"&&typeof b.id=="string"}v.isThemeColor=T})(y=e.ThemeColor||(e.ThemeColor={}));function k(v){return{id:v}}e.themeColorFromId=k;var t;(function(v){function T(s){return s&&typeof s=="object"&&typeof s.id=="string"&&(typeof s.color=="undefined"||y.isThemeColor(s.color))}v.isThemeIcon=T;const b=new RegExp(`^\\$\\((${h.CSSIcon.iconNameExpression}(?:${h.CSSIcon.iconModifierExpression})?)\\)$`);function c(s){const u=b.exec(s);if(!u)return;let[,o]=u;return{id:o}}v.fromString=c;function g(s,u){let o=s.id;const f=o.lastIndexOf("~");return f!==-1&&(o=o.substring(0,f)),u&&(o=`${o}~${u}`),{id:o}}v.modify=g;function S(s,u){return s.id===u.id&&s.color?.id===u.color?.id}v.isEqual=S;function i(s,u){return{id:s.id,color:u?k(u):void 0}}v.asThemeIcon=i,v.asClassNameArray=h.CSSIcon.asClassNameArray,v.asClassName=h.CSSIcon.asClassName,v.asCSSSelector=h.CSSIcon.asCSSSelector})(t=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=h.Codicon.file,e.FolderThemeIcon=h.Codicon.folder;function _(v){switch(v){case I.ColorScheme.DARK:return"vs-dark";case I.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=_,e.Extensions={ThemingContribution:"base.contributions.theming"};class r{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new F.Emitter}onColorThemeChange(T){return this.themingParticipants.push(T),this.onThemingParticipantAddedEmitter.fire(T),(0,E.toDisposable)(()=>{const b=this.themingParticipants.indexOf(T);this.themingParticipants.splice(b,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let d=new r;R.Registry.add(e.Extensions.ThemingContribution,d);function a(v){return d.onColorThemeChange(v)}e.registerThemingParticipant=a;class l extends E.Disposable{constructor(T){super();this.themeService=T,this.theme=T.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(b=>this.onThemeChange(b)))}onThemeChange(T){this.theme=T,this.updateStyles()}updateStyles(){}getColor(T,b){let c=this.theme.getColor(T);return c&&b&&(c=b(c,this.theme)),c?c.toString():null}}e.Themable=l}),define(be[150],Ee([0,1,13,34,3,122,83,28,43]),function(re,e,h,F,E,A,R,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.syncing=e.gotoNextLocation=e.gotoPreviousLocation=e.widgetClose=e.iconsSchemaId=e.getIconRegistry=e.registerIcon=e.Extensions=void 0,e.Extensions={IconContribution:"base.contributions.icons"};class k{constructor(){this._onDidChange=new E.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,A.localize)(0,null)},fontCharacter:{type:"string",description:(0,A.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${F.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(T,b,c,g){const S=this.iconsById[T];if(S){if(c&&!S.description){S.description=c,this.iconSchema.properties[T].markdownDescription=`${c} $(${T})`;const u=this.iconReferenceSchema.enum.indexOf(T);u!==-1&&(this.iconReferenceSchema.enumDescriptions[u]=c),this._onDidChange.fire()}return S}let i={id:T,description:c,defaults:b,deprecationMessage:g};this.iconsById[T]=i;let s={$ref:"#/definitions/icons"};return g&&(s.deprecationMessage=g),c&&(s.markdownDescription=`${c}: $(${T})`),this.iconSchema.properties[T]=s,this.iconReferenceSchema.enum.push(T),this.iconReferenceSchema.enumDescriptions.push(c||""),this._onDidChange.fire(),{id:T}}deregisterIcon(T){delete this.iconsById[T],delete this.iconSchema.properties[T];const b=this.iconReferenceSchema.enum.indexOf(T);b!==-1&&(this.iconReferenceSchema.enum.splice(b,1),this.iconReferenceSchema.enumDescriptions.splice(b,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(T=>this.iconsById[T])}getIcon(T){return this.iconsById[T]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(T,b){const c=this.iconFontsById[T];if(c)return c;let g={id:T,definition:b};return this.iconFontsById[T]=g,this._onDidChange.fire(),g}deregisterIconFont(T){delete this.iconFontsById[T]}getIconFonts(){return Object.keys(this.iconFontsById).map(T=>this.iconFontsById[T])}getIconFont(T){return this.iconFontsById[T]}toString(){const T=(S,i)=>S.id.localeCompare(i.id),b=S=>{for(;y.ThemeIcon.isThemeIcon(S.defaults);)S=this.iconsById[S.defaults.id];return`codicon codicon-${S?S.id:""}`};let c=[];c.push("| preview     | identifier                        | default codicon ID                | description"),c.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const g=Object.keys(this.iconsById).map(S=>this.iconsById[S]);for(const S of g.filter(i=>!!i.description).sort(T))c.push(`|<i class="${b(S)}"></i>|${S.id}|${y.ThemeIcon.isThemeIcon(S.defaults)?S.defaults.id:S.id}|${S.description||""}|`);c.push("| preview     | identifier                        "),c.push("| ----------- | --------------------------------- |");for(const S of g.filter(i=>!y.ThemeIcon.isThemeIcon(i.defaults)).sort(T))c.push(`|<i class="${b(S)}"></i>|${S.id}|`);return c.join(`
`)}}const t=new k;I.Registry.add(e.Extensions.IconContribution,t);function _(v,T,b,c){return t.registerIcon(v,T,b,c)}e.registerIcon=_;function r(){return t}e.getIconRegistry=r;function d(){for(const v of F.iconRegistry.all)t.registerIcon(v.id,v.definition,v.description);F.iconRegistry.onDidRegister(v=>t.registerIcon(v.id,v.definition,v.description))}d(),e.iconsSchemaId="vscode://schemas/icons";let a=I.Registry.as(R.Extensions.JSONContribution);a.registerSchema(e.iconsSchemaId,t.getIconSchema());const l=new h.RunOnceScheduler(()=>a.notifySchemaChanged(e.iconsSchemaId),200);t.onDidChange(()=>{l.isScheduled()||l.schedule()}),e.widgetClose=_("widget-close",F.Codicon.close,(0,A.localize)(2,null)),e.gotoPreviousLocation=_("goto-previous-location",F.Codicon.arrowUp,(0,A.localize)(3,null)),e.gotoNextLocation=_("goto-next-location",F.Codicon.arrowDown,(0,A.localize)(4,null)),e.syncing=y.ThemeIcon.modify(F.Codicon.sync,"spin")}),define(be[44],Ee([0,1,20,24,2,4]),function(re,e,h,F,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,A.createDecorator)("contextService");var R;(function(r){r[r.EMPTY=1]="EMPTY",r[r.FOLDER=2]="FOLDER",r[r.WORKSPACE=3]="WORKSPACE"})(R=e.WorkbenchState||(e.WorkbenchState={}));function I(r){const d=r;return!!(d&&typeof d=="object"&&typeof d.id=="string"&&Array.isArray(d.folders))}e.isWorkspace=I;function y(r){const d=r;return!!(d&&typeof d=="object"&&E.URI.isUri(d.uri)&&typeof d.name=="string"&&typeof d.toResource=="function")}e.isWorkspaceFolder=y;class k{constructor(d,a,l,v){this._id=d,this._configuration=l,this._ignorePathCasing=v,this._foldersMap=h.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=a}update(d){this._id=d.id,this._configuration=d.configuration,this._ignorePathCasing=d._ignorePathCasing,this.folders=d.folders}get folders(){return this._folders}set folders(d){this._folders=d,this.updateFoldersMap()}get id(){return this._id}get configuration(){return this._configuration}set configuration(d){this._configuration=d}getFolder(d){return d&&this._foldersMap.findSubstr(d.with({scheme:d.scheme,authority:d.authority,path:d.path}))||null}updateFoldersMap(){this._foldersMap=h.TernarySearchTree.forUris(this._ignorePathCasing);for(const d of this.folders)this._foldersMap.set(d.uri,d)}toJSON(){return{id:this.id,folders:this.folders,configuration:this.configuration}}}e.Workspace=k;class t{constructor(d,a){this.raw=a,this.uri=d.uri,this.index=d.index,this.name=d.name}toResource(d){return(0,F.joinPath)(this.uri,d)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=t;function _(r){return new t({uri:r,index:0,name:(0,F.basenameOrAuthority)(r)},{uri:r.toString()})}e.toWorkspaceFolder=_}),define(be[62],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class h{constructor(E){this.id=E,this._data=new Map,this._idPool=1}add(E){const A=this._idPool++;return this._data.set(A,E),this.logDebugInfo(),A}get(E,A){return this._data.has(E)?this._data.get(E)[A]:void 0}delete(E){this._data.delete(E),this.logDebugInfo()}logDebugInfo(){!h.enableDebugLogging||console.log(`${this.id} cache size \u2014 ${this._data.size}`)}}e.Cache=h,h.enableDebugLogging=!1}),define(be[63],Ee([0,1,2,3,4]),function(re,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,E.createDecorator)("IExtHostEditorTabs");class A{constructor(){this._onDidChangeTabs=new F.Emitter,this.onDidChangeTabs=this._onDidChangeTabs.event,this._tabs=[]}get tabs(){return this._tabs}$acceptEditorTabs(I){this._tabs=I.map(y=>({name:y.name,group:y.group,resource:h.URI.revive(y.resource),isActive:y.isActive})),this._onDidChangeTabs.fire()}}e.ExtHostEditorTabs=A}),define(be[45],Ee([0,1,11,4]),function(re,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class E{constructor(){this._systemSchemes=new Set(Object.keys(h.Schemas)),this._providerInfo=new Map}$acceptProviderInfos(R,I){I===null?this._providerInfo.delete(R):this._providerInfo.set(R,I)}isFreeScheme(R){return!this._providerInfo.has(R)&&!this._systemSchemes.has(R)}getCapabilities(R){return this._providerInfo.get(R)}}e.ExtHostFileSystemInfo=E,e.IExtHostFileSystemInfo=(0,F.createDecorator)("IExtHostFileSystemInfo")}),define(be[29],Ee([0,1,4]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,h.createDecorator)("IExtHostInitDataService")}),define(be[151],Ee([0,1,13]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class F{constructor(R,I,y){this._deferredPromises=new Map,this._id=R,this._shared=I,this._storage=y,this._init=this._storage.getValue(this._shared,this._id,Object.create(null)).then(k=>(this._value=k,this)),this._storageListener=this._storage.onDidChangeStorage(k=>{k.shared===this._shared&&k.key===this._id&&(this._value=k.value)}),this._scheduler=new h.RunOnceScheduler(()=>{const k=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const t of k.values())t.complete()}catch(t){for(const _ of k.values())_.error(t)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,R])=>R!==void 0).map(([R])=>R)}get whenReady(){return this._init}get(R,I){let y=this._value[R];return typeof y=="undefined"&&(y=I),y}update(R,I){this._value[R]=I;let y=this._deferredPromises.get(R);if(y!==void 0)return y.p;const k=new h.DeferredPromise;return this._deferredPromises.set(R,k),this._scheduler.isScheduled()||this._scheduler.schedule(),k.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=F;class E extends F{constructor(R,I){super(R.identifier.value,!0,I);this._extension=R}setKeysForSync(R){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},R)}}e.ExtensionGlobalMemento=E}),define(be[152],Ee([0,1,3,2,14]),function(re,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;let A=class{constructor(I,y){this._logService=I,this._notebooksAndEditors=y,this._onDidChangeNotebookDocumentMetadata=new h.Emitter,this.onDidChangeNotebookDocumentMetadata=this._onDidChangeNotebookDocumentMetadata.event,this._onDidSaveNotebookDocument=new h.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event}$acceptModelChanged(I,y,k){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(I)).acceptModelChanged(y.value,k)}$acceptDirtyStateChanged(I,y){this._notebooksAndEditors.getNotebookDocument(F.URI.revive(I)).acceptDirty(y)}$acceptModelSaved(I){const y=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(I));this._onDidSaveNotebookDocument.fire(y.apiNotebook)}$acceptDocumentPropertiesChanged(I,y){this._logService.debug("ExtHostNotebook#$acceptDocumentPropertiesChanged",I.path,y);const k=this._notebooksAndEditors.getNotebookDocument(F.URI.revive(I));k.acceptDocumentPropertiesChanged(y),y.metadata&&this._onDidChangeNotebookDocumentMetadata.fire({document:k.apiNotebook})}};A=Be([We(0,E.ILogService)],A),e.ExtHostNotebookDocuments=A}),define(be[12],Ee([0,1,4]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,h.createDecorator)("IExtHostRpcService");class F{constructor(A){this.getProxy=A.getProxy.bind(A),this.set=A.set.bind(A),this.assertRegistered=A.assertRegistered.bind(A),this.drain=A.drain.bind(A)}}e.ExtHostRpcService=F});var et=this&&this.__classPrivateFieldSet||function(re,e,h,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(re,h):E?E.value=h:e.set(re,h),h},Oe=this&&this.__classPrivateFieldGet||function(re,e,h,F){if(h==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!F:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?F:h==="a"?F.call(re):F?F.value:e.get(re)};define(be[153],Ee([0,1,25,3]),function(re,e,h,F){"use strict";var E;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class A{constructor(I,y){E.set(this,void 0),this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._id=h.ExtensionIdentifier.toKey(I.identifier),et(this,E,y,"f"),Oe(this,E,"f").onDidChangePassword(k=>{k.extensionId===this._id&&this._onDidChange.fire({key:k.key})})}get(I){return Oe(this,E,"f").get(this._id,I)}store(I,y){return Oe(this,E,"f").store(this._id,I,y)}delete(I){return Oe(this,E,"f").delete(this._id,I)}}e.ExtensionSecrets=A,E=new WeakMap}),define(be[87],Ee([0,1,4,3]),function(re,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class E{constructor(){this._onDidChangeTelemetryEnabled=new F.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._enabled=!1}getTelemetryEnabled(){return this._enabled}$initializeTelemetryEnabled(R){this._enabled=R}$onDidChangeTelemetryEnabled(R){this._enabled=R,this._onDidChangeTelemetryEnabled.fire(R)}}e.ExtHostTelemetry=E,e.IExtHostTelemetry=(0,h.createDecorator)("IExtHostTelemetry")}),define(be[64],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestItemRootImpl=e.TestItemImpl=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.diffTestItems=e.getPrivateApiFor=e.createPrivateApiFor=e.ExtHostTestItemEventOp=void 0;var h;(function(b){b[b.Upsert=0]="Upsert",b[b.RemoveChild=1]="RemoveChild",b[b.Invalidated=2]="Invalidated",b[b.SetProp=3]="SetProp",b[b.Bulk=4]="Bulk"})(h=e.ExtHostTestItemEventOp||(e.ExtHostTestItemEventOp={}));const F=new WeakMap,E=(b,c)=>{const g={controllerId:c};return F.set(b,g),g};e.createPrivateApiFor=E;const A=b=>F.get(b);e.getPrivateApiFor=A;const R=(b,c,g,S)=>{let i=g;return{enumerable:!0,configurable:!1,get(){return i},set(s){S(i,s)||(i=s,b.listener?.({op:3,key:c,value:s}))}}},I=(b,c)=>b===c,y={range:(b,c)=>b===c?!0:!b||!c?!1:b.isEqual(c),label:I,description:I,busy:I,error:I,canResolveChildren:I,tags:(b,c)=>!(b.length!==c.length||b.some(g=>!c.find(S=>g.id===S.id)))},k=Object.keys(y),t=(b,c)=>({range:R(b,"range",void 0,y.range),label:R(b,"label",c,y.label),description:R(b,"description",void 0,y.description),canResolveChildren:R(b,"canResolveChildren",!1,y.canResolveChildren),busy:R(b,"busy",!1,y.busy),error:R(b,"error",void 0,y.error),tags:R(b,"tags",[],y.tags)}),_=(b,c)=>{const g=new Map;for(const S of k)y[S](b[S],c[S])||g.set(S,c[S]);return g};e.diffTestItems=_;class r extends Error{constructor(c){super(`Attempted to insert a duplicate test item ID ${c}`)}}e.DuplicateTestItemError=r;class d extends Error{constructor(c){super(`TestItem with ID "${c}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=d;class a extends Error{constructor(c,g,S){super(`TestItem with ID "${c}" is from controller "${g}" and cannot be added as a child of an item from controller "${S}".`)}}e.MixedTestItemController=a;const l=b=>{const c=(0,e.getPrivateApiFor)(b);let g=new Map;return{get size(){return g.size},forEach(S,i){for(const s of g.values())S.call(i,s,this)},replace(S){const i=new Map,s=new Set(g.keys()),u={op:4,ops:[]};for(const o of S){if(!(o instanceof v))throw new d(o.id);const f=(0,e.getPrivateApiFor)(o).controllerId;if(f!==c.controllerId)throw new a(o.id,f,c.controllerId);if(i.has(o.id))throw new r(o.id);i.set(o.id,o),s.delete(o.id),u.ops.push({op:0,item:o})}for(const o of s.keys())u.ops.push({op:1,id:o});c.listener?.(u),g=i},add(S){if(!(S instanceof v))throw new d(S.id);g.set(S.id,S),c.listener?.({op:0,item:S})},delete(S){g.delete(S)&&c.listener?.({op:1,id:S})},get(S){return g.get(S)},toJSON(){return Array.from(g.values())},[Symbol.iterator](){return g.values()}}};class v{constructor(c,g,S,i){if(g.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(g)} symbol`);const s=(0,e.createPrivateApiFor)(this,c);Object.defineProperties(this,{id:{value:g,enumerable:!0,writable:!1},uri:{value:i,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return s.parent instanceof T?void 0:s.parent}},children:{value:l(this),enumerable:!0,writable:!1},...t(s,S)})}invalidateResults(){(0,e.getPrivateApiFor)(this).listener?.({op:2})}}e.TestItemImpl=v;class T extends v{constructor(c,g){super(c,c,g,void 0)}}e.TestItemRootImpl=T}),define(be[65],Ee([0,1,4,3,12]),function(re,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDto=void 0;var A;(function(I){function y(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,protocol:t.protocol}}I.fromApiTunnel=y;function k(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.public,protocol:t.protocol}}I.fromServiceTunnel=k})(A=e.TunnelDto||(e.TunnelDto={})),e.IExtHostTunnelService=(0,h.createDecorator)("IExtHostTunnelService");let R=class{constructor(y){this.onDidChangeTunnels=new F.Emitter().event}async $applyCandidateFilter(y){return y}async openTunnel(y,k){}async getTunnels(){return[]}async setTunnelExtensionFunctions(y){return{dispose:()=>{}}}registerPortsAttributesProvider(y,k){return{dispose:()=>{}}}async $providePortAttributes(y,k,t,_,r){return[]}async $forwardPort(y,k){}async $closeTunnel(y){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};R=Be([We(0,E.IExtHostRpcService)],R),e.ExtHostTunnelService=R});var et=this&&this.__classPrivateFieldSet||function(re,e,h,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(re,h):E?E.value=h:e.set(re,h),h},Oe=this&&this.__classPrivateFieldGet||function(re,e,h,F){if(h==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!F:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?F:h==="a"?F.call(re):F?F.value:e.get(re)};define(be[6],Ee([0,1,16,15,76,20,78,10,2,36,59,85]),function(re,e,h,F,E,A,R,I,y,k,t,_){"use strict";var r,d,a,l,v,T,b,c,g,S,i,s,u,o,f,p,w,C,P,n;Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.QuickInputButtons=e.DebugConfigurationProviderTriggerKind=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLink=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestions=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function m(N){function M(){return Reflect.construct(N,arguments,this.constructor)}return Object.defineProperty(M,"name",Object.getOwnPropertyDescriptor(N,"name")),Object.setPrototypeOf(M,N),Object.setPrototypeOf(M.prototype,N.prototype),M}let D=v=class{constructor(M){r.set(this,void 0),et(this,r,M,"f")}static from(...M){let ee=M;return new v(function(){if(ee){for(const _e of ee)_e&&typeof _e.dispose=="function"&&_e.dispose();ee=void 0}})}dispose(){typeof Oe(this,r,"f")=="function"&&(Oe(this,r,"f").call(this),et(this,r,void 0,"f"))}};r=new WeakMap,D=v=Be([m],D),e.Disposable=D;let O=T=class{constructor(M,ee){if(M<0)throw(0,F.illegalArgument)("line must be non-negative");if(ee<0)throw(0,F.illegalArgument)("character must be non-negative");this._line=M,this._character=ee}static Min(...M){if(M.length===0)throw new TypeError;let ee=M[0];for(let _e=1;_e<M.length;_e++){const Ge=M[_e];Ge.isBefore(ee)&&(ee=Ge)}return ee}static Max(...M){if(M.length===0)throw new TypeError;let ee=M[0];for(let _e=1;_e<M.length;_e++){const Ge=M[_e];Ge.isAfter(ee)&&(ee=Ge)}return ee}static isPosition(M){if(!M)return!1;if(M instanceof T)return!0;let{line:ee,character:_e}=M;return typeof ee=="number"&&typeof _e=="number"}get line(){return this._line}get character(){return this._character}isBefore(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<M._character}isBeforeOrEqual(M){return this._line<M._line?!0:M._line<this._line?!1:this._character<=M._character}isAfter(M){return!this.isBeforeOrEqual(M)}isAfterOrEqual(M){return!this.isBefore(M)}isEqual(M){return this._line===M._line&&this._character===M._character}compareTo(M){return this._line<M._line?-1:this._line>M.line?1:this._character<M._character?-1:this._character>M._character?1:0}translate(M,ee=0){if(M===null||ee===null)throw(0,F.illegalArgument)();let _e;return typeof M=="undefined"?_e=0:typeof M=="number"?_e=M:(_e=typeof M.lineDelta=="number"?M.lineDelta:0,ee=typeof M.characterDelta=="number"?M.characterDelta:0),_e===0&&ee===0?this:new T(this.line+_e,this.character+ee)}with(M,ee=this.character){if(M===null||ee===null)throw(0,F.illegalArgument)();let _e;return typeof M=="undefined"?_e=this.line:typeof M=="number"?_e=M:(_e=typeof M.line=="number"?M.line:this.line,ee=typeof M.character=="number"?M.character:this.character),_e===this.line&&ee===this.character?this:new T(_e,ee)}toJSON(){return{line:this.line,character:this.character}}};O=T=Be([m],O),e.Position=O;let $=b=class{constructor(M,ee,_e,Ge){let Ze,nt;if(typeof M=="number"&&typeof ee=="number"&&typeof _e=="number"&&typeof Ge=="number"?(Ze=new O(M,ee),nt=new O(_e,Ge)):M instanceof O&&ee instanceof O&&(Ze=M,nt=ee),!Ze||!nt)throw new Error("Invalid arguments");Ze.isBefore(nt)?(this._start=Ze,this._end=nt):(this._start=nt,this._end=Ze)}static isRange(M){return M instanceof b?!0:M?O.isPosition(M.start)&&O.isPosition(M.end):!1}get start(){return this._start}get end(){return this._end}contains(M){return M instanceof b?this.contains(M._start)&&this.contains(M._end):M instanceof O?!(M.isBefore(this._start)||this._end.isBefore(M)):!1}isEqual(M){return this._start.isEqual(M._start)&&this._end.isEqual(M._end)}intersection(M){const ee=O.Max(M.start,this._start),_e=O.Min(M.end,this._end);if(!ee.isAfter(_e))return new b(ee,_e)}union(M){if(this.contains(M))return this;if(M.contains(this))return M;const ee=O.Min(M.start,this._start),_e=O.Max(M.end,this.end);return new b(ee,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(M,ee=this.end){if(M===null||ee===null)throw(0,F.illegalArgument)();let _e;return M?O.isPosition(M)?_e=M:(_e=M.start||this.start,ee=M.end||this.end):_e=this.start,_e.isEqual(this._start)&&ee.isEqual(this.end)?this:new b(_e,ee)}toJSON(){return[this.start,this.end]}};$=b=Be([m],$),e.Range=$;let Q=c=class extends ${constructor(M,ee,_e,Ge){let Ze,nt;if(typeof M=="number"&&typeof ee=="number"&&typeof _e=="number"&&typeof Ge=="number"?(Ze=new O(M,ee),nt=new O(_e,Ge)):M instanceof O&&ee instanceof O&&(Ze=M,nt=ee),!Ze||!nt)throw new Error("Invalid arguments");super(Ze,nt);this._anchor=Ze,this._active=nt}static isSelection(M){return M instanceof c?!0:M?$.isRange(M)&&O.isPosition(M.anchor)&&O.isPosition(M.active)&&typeof M.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};Q=c=Be([m],Q),e.Selection=Q;class ie{constructor(M,ee,_e){if(typeof M!="string"||M.length===0)throw(0,F.illegalArgument)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,F.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,F.illegalArgument)("connectionToken");this.host=M,this.port=Math.round(ee),this.connectionToken=_e}}e.ResolvedAuthority=ie;class V extends Error{constructor(M,ee=_.RemoteAuthorityResolverErrorCode.Unknown,_e){super(M);this._message=M,this._code=ee,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,V.prototype)}static NotAvailable(M,ee){return new V(M,_.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(M){return new V(M,_.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=V;var W;(function(N){N[N.LF=1]="LF",N[N.CRLF=2]="CRLF"})(W=e.EndOfLine||(e.EndOfLine={}));var L;(function(N){N[N.Replace=1]="Replace",N[N.Append=2]="Append",N[N.Prepend=3]="Prepend"})(L=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let Y=g=class{constructor(M,ee){this._range=M,this._newText=ee}static isTextEdit(M){return M instanceof g?!0:M?$.isRange(M)&&typeof M.newText=="string":!1}static replace(M,ee){return new g(M,ee)}static insert(M,ee){return g.replace(new $(M,M),ee)}static delete(M){return g.replace(M,"")}static setEndOfLine(M){const ee=new g(new $(new O(0,0),new O(0,0)),"");return ee.newEol=M,ee}get range(){return this._range}set range(M){if(M&&!$.isRange(M))throw(0,F.illegalArgument)("range");this._range=M}get newText(){return this._newText||""}set newText(M){if(M&&typeof M!="string")throw(0,F.illegalArgument)("newText");this._newText=M}get newEol(){return this._newEol}set newEol(M){if(M&&typeof M!="number")throw(0,F.illegalArgument)("newEol");this._newEol=M}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};Y=g=Be([m],Y),e.TextEdit=Y;var B;(function(N){N[N.File=1]="File",N[N.Text=2]="Text",N[N.Cell=3]="Cell",N[N.CellReplace=5]="CellReplace"})(B=e.FileEditType||(e.FileEditType={}));let G=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(M,ee,_e,Ge){this._edits.push({_type:1,from:M,to:ee,options:_e,metadata:Ge})}createFile(M,ee,_e){this._edits.push({_type:1,from:void 0,to:M,options:ee,metadata:_e})}deleteFile(M,ee,_e){this._edits.push({_type:1,from:M,to:void 0,options:ee,metadata:_e})}replaceNotebookMetadata(M,ee,_e){this._edits.push({_type:3,metadata:_e,uri:M,edit:{editType:5,metadata:ee},notebookMetadata:ee})}replaceNotebookCells(M,ee,_e,Ge,Ze){let nt,at,yt=[],At;if(Bt.isNotebookRange(ee)&&Ft.isNotebookCellDataArray(_e)&&!Ft.isNotebookCellDataArray(Ge)?(nt=ee.start,at=ee.end,yt=_e,At=Ge):typeof ee=="number"&&typeof _e=="number"&&Ft.isNotebookCellDataArray(Ge)&&(nt=ee,at=_e,yt=Ge,At=Ze),nt===void 0||at===void 0)throw new Error("Invalid arguments");(nt!==at||yt.length>0)&&this._edits.push({_type:5,uri:M,index:nt,count:at-nt,cells:yt,metadata:At})}replaceNotebookCellMetadata(M,ee,_e,Ge){this._edits.push({_type:3,metadata:Ge,uri:M,edit:{editType:8,index:ee,metadata:_e}})}replace(M,ee,_e,Ge){this._edits.push({_type:2,uri:M,edit:new Y(ee,_e),metadata:Ge})}insert(M,ee,_e,Ge){this.replace(M,new $(ee,ee),_e,Ge)}delete(M,ee,_e){this.replace(M,ee,"",_e)}has(M){return this._edits.some(ee=>ee._type===2&&ee.uri.toString()===M.toString())}set(M,ee){if(ee)for(const _e of ee)_e&&this._edits.push({_type:2,uri:M,edit:_e});else{for(let _e=0;_e<this._edits.length;_e++){const Ge=this._edits[_e];Ge._type===2&&Ge.uri.toString()===M.toString()&&(this._edits[_e]=void 0)}(0,h.coalesceInPlace)(this._edits)}}get(M){const ee=[];for(let _e of this._edits)_e._type===2&&_e.uri.toString()===M.toString()&&ee.push(_e.edit);return ee}entries(){const M=new A.ResourceMap;for(let ee of this._edits)if(ee._type===2){let _e=M.get(ee.uri);_e||(_e=[ee.uri,[]],M.set(ee.uri,_e)),_e[1].push(ee.edit)}return[...M.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};G=Be([m],G),e.WorkspaceEdit=G;let de=S=class{constructor(M){this._tabstop=1,this.value=M||""}static isSnippetString(M){return M instanceof S?!0:M?typeof M.value=="string":!1}static _escape(M){return M.replace(/\$|}|\\/g,"\\$&")}appendText(M){return this.value+=S._escape(M),this}appendTabstop(M=this._tabstop++){return this.value+="$",this.value+=M,this}appendPlaceholder(M,ee=this._tabstop++){if(typeof M=="function"){const _e=new S;_e._tabstop=this._tabstop,M(_e),this._tabstop=_e._tabstop,M=_e.value}else M=S._escape(M);return this.value+="${",this.value+=ee,this.value+=":",this.value+=M,this.value+="}",this}appendChoice(M,ee=this._tabstop++){const _e=M.map(Ge=>Ge.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(M,ee){if(typeof ee=="function"){const _e=new S;_e._tabstop=this._tabstop,ee(_e),this._tabstop=_e._tabstop,ee=_e.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=M,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};de=S=Be([m],de),e.SnippetString=de;var j;(function(N){N[N.Unnecessary=1]="Unnecessary",N[N.Deprecated=2]="Deprecated"})(j=e.DiagnosticTag||(e.DiagnosticTag={}));var le;(function(N){N[N.Hint=3]="Hint",N[N.Information=2]="Information",N[N.Warning=1]="Warning",N[N.Error=0]="Error"})(le=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let ae=i=class{constructor(M,ee){if(this.uri=M,ee)if(ee instanceof $)this.range=ee;else if(ee instanceof O)this.range=new $(ee,ee);else throw new Error("Illegal argument")}static isLocation(M){return M instanceof i?!0:M?$.isRange(M.range)&&y.URI.isUri(M.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};ae=i=Be([m],ae),e.Location=ae;let ve=class{constructor(M,ee){this.location=M,this.message=ee}static is(M){return M?typeof M.message=="string"&&M.location&&$.isRange(M.location.range)&&y.URI.isUri(M.location.uri):!1}static isEqual(M,ee){return M===ee?!0:!M||!ee?!1:M.message===ee.message&&M.location.range.isEqual(ee.location.range)&&M.location.uri.toString()===ee.location.uri.toString()}};ve=Be([m],ve),e.DiagnosticRelatedInformation=ve;let Re=class{constructor(M,ee,_e=le.Error){if(!$.isRange(M))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=M,this.message=ee,this.severity=_e}toJSON(){return{severity:le[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(M,ee){return M===ee?!0:!M||!ee?!1:M.message===ee.message&&M.severity===ee.severity&&M.code===ee.code&&M.severity===ee.severity&&M.source===ee.source&&M.range.isEqual(ee.range)&&(0,h.equals)(M.tags,ee.tags)&&(0,h.equals)(M.relatedInformation,ee.relatedInformation,ve.isEqual)}};Re=Be([m],Re),e.Diagnostic=Re;let Fe=class{constructor(M,ee){if(!M)throw new Error("Illegal argument, contents must be defined");Array.isArray(M)?this.contents=M:this.contents=[M],this.range=ee}};Fe=Be([m],Fe),e.Hover=Fe;var Ne;(function(N){N[N.Text=0]="Text",N[N.Read=1]="Read",N[N.Write=2]="Write"})(Ne=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Qe=class{constructor(M,ee=Ne.Text){this.range=M,this.kind=ee}toJSON(){return{range:this.range,kind:Ne[this.kind]}}};Qe=Be([m],Qe),e.DocumentHighlight=Qe;var He;(function(N){N[N.File=0]="File",N[N.Module=1]="Module",N[N.Namespace=2]="Namespace",N[N.Package=3]="Package",N[N.Class=4]="Class",N[N.Method=5]="Method",N[N.Property=6]="Property",N[N.Field=7]="Field",N[N.Constructor=8]="Constructor",N[N.Enum=9]="Enum",N[N.Interface=10]="Interface",N[N.Function=11]="Function",N[N.Variable=12]="Variable",N[N.Constant=13]="Constant",N[N.String=14]="String",N[N.Number=15]="Number",N[N.Boolean=16]="Boolean",N[N.Array=17]="Array",N[N.Object=18]="Object",N[N.Key=19]="Key",N[N.Null=20]="Null",N[N.EnumMember=21]="EnumMember",N[N.Struct=22]="Struct",N[N.Event=23]="Event",N[N.Operator=24]="Operator",N[N.TypeParameter=25]="TypeParameter"})(He=e.SymbolKind||(e.SymbolKind={}));var Ke;(function(N){N[N.Deprecated=1]="Deprecated"})(Ke=e.SymbolTag||(e.SymbolTag={}));let x=s=class{constructor(M,ee,_e,Ge,Ze){this.name=M,this.kind=ee,this.containerName=Ze,typeof _e=="string"&&(this.containerName=_e),Ge instanceof ae?this.location=Ge:_e instanceof $&&(this.location=new ae(Ge,_e)),s.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:He[this.kind],location:this.location,containerName:this.containerName}}};x=s=Be([m],x),e.SymbolInformation=x;let q=u=class{constructor(M,ee,_e,Ge,Ze){this.name=M,this.detail=ee,this.kind=_e,this.range=Ge,this.selectionRange=Ze,this.children=[],u.validate(this)}static validate(M){if(!M.name)throw new Error("name must not be falsy");if(!M.range.contains(M.selectionRange))throw new Error("selectionRange must be contained in fullRange");M.children&&M.children.forEach(u.validate)}};q=u=Be([m],q),e.DocumentSymbol=q;var Z;(function(N){N[N.Invoke=1]="Invoke",N[N.Automatic=2]="Automatic"})(Z=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let se=class{constructor(M,ee){this.title=M,this.kind=ee}};se=Be([m],se),e.CodeAction=se;let H=o=class{constructor(M){this.value=M}append(M){return new o(this.value?this.value+o.sep+M:M)}intersects(M){return this.contains(M)||M.contains(this)}contains(M){return this.value===M.value||M.value.startsWith(this.value+o.sep)}};H.sep=".",H=o=Be([m],H),e.CodeActionKind=H,H.Empty=new H(""),H.QuickFix=H.Empty.append("quickfix"),H.Refactor=H.Empty.append("refactor"),H.RefactorExtract=H.Refactor.append("extract"),H.RefactorInline=H.Refactor.append("inline"),H.RefactorRewrite=H.Refactor.append("rewrite"),H.Source=H.Empty.append("source"),H.SourceOrganizeImports=H.Source.append("organizeImports"),H.SourceFixAll=H.Source.append("fixAll");let ne=class{constructor(M,ee){if(this.range=M,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};ne=Be([m],ne),e.SelectionRange=ne;class fe{constructor(M,ee,_e,Ge,Ze,nt){this.kind=M,this.name=ee,this.detail=_e,this.uri=Ge,this.range=Ze,this.selectionRange=nt}}e.CallHierarchyItem=fe;class Te{constructor(M,ee){this.fromRanges=ee,this.from=M}}e.CallHierarchyIncomingCall=Te;class xe{constructor(M,ee){this.fromRanges=ee,this.to=M}}e.CallHierarchyOutgoingCall=xe;var $e;(function(N){N[N.Information=0]="Information",N[N.Warning=1]="Warning",N[N.Error=2]="Error"})($e=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let we=class{constructor(M,ee){this.range=M,this.command=ee}get isResolved(){return!!this.command}};we=Be([m],we),e.CodeLens=we;let Xe=f=class{constructor(M,ee=!1){d.set(this,void 0),et(this,d,new E.MarkdownString(M,{supportThemeIcons:ee}),"f")}static isMarkdownString(M){return M instanceof f?!0:M&&M.appendCodeblock&&M.appendMarkdown&&M.appendText&&M.value!==void 0}get value(){return Oe(this,d,"f").value}set value(M){Oe(this,d,"f").value=M}get isTrusted(){return Oe(this,d,"f").isTrusted}set isTrusted(M){Oe(this,d,"f").isTrusted=M}get supportThemeIcons(){return Oe(this,d,"f").supportThemeIcons}set supportThemeIcons(M){Oe(this,d,"f").supportThemeIcons=M}appendText(M){return Oe(this,d,"f").appendText(M),this}appendMarkdown(M){return Oe(this,d,"f").appendMarkdown(M),this}appendCodeblock(M,ee){return Oe(this,d,"f").appendCodeblock(ee??"",M),this}};d=new WeakMap,Xe=f=Be([m],Xe),e.MarkdownString=Xe;let z=class{constructor(M,ee){this.label=M,this.documentation=ee}};z=Be([m],z),e.ParameterInformation=z;let K=class{constructor(M,ee){this.label=M,this.documentation=ee,this.parameters=[]}};K=Be([m],K),e.SignatureInformation=K;let he=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};he=Be([m],he),e.SignatureHelp=he;var Le;(function(N){N[N.Invoke=1]="Invoke",N[N.TriggerCharacter=2]="TriggerCharacter",N[N.ContentChange=3]="ContentChange"})(Le=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var Ve;(function(N){N[N.Other=0]="Other",N[N.Type=1]="Type",N[N.Parameter=2]="Parameter"})(Ve=e.InlayHintKind||(e.InlayHintKind={}));let tt=class{constructor(M,ee,_e){this.text=M,this.position=ee,this.kind=_e}};tt=Be([m],tt),e.InlayHint=tt;var lt;(function(N){N[N.Invoke=0]="Invoke",N[N.TriggerCharacter=1]="TriggerCharacter",N[N.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(lt=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ft;(function(N){N[N.Text=0]="Text",N[N.Method=1]="Method",N[N.Function=2]="Function",N[N.Constructor=3]="Constructor",N[N.Field=4]="Field",N[N.Variable=5]="Variable",N[N.Class=6]="Class",N[N.Interface=7]="Interface",N[N.Module=8]="Module",N[N.Property=9]="Property",N[N.Unit=10]="Unit",N[N.Value=11]="Value",N[N.Enum=12]="Enum",N[N.Keyword=13]="Keyword",N[N.Snippet=14]="Snippet",N[N.Color=15]="Color",N[N.File=16]="File",N[N.Reference=17]="Reference",N[N.Folder=18]="Folder",N[N.EnumMember=19]="EnumMember",N[N.Constant=20]="Constant",N[N.Struct=21]="Struct",N[N.Event=22]="Event",N[N.Operator=23]="Operator",N[N.TypeParameter=24]="TypeParameter",N[N.User=25]="User",N[N.Issue=26]="Issue"})(ft=e.CompletionItemKind||(e.CompletionItemKind={}));var St;(function(N){N[N.Deprecated=1]="Deprecated"})(St=e.CompletionItemTag||(e.CompletionItemTag={}));let Pt=class{constructor(M,ee){this.label=M,this.kind=ee}toJSON(){return{label:this.label,kind:this.kind&&ft[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};Pt=Be([m],Pt),e.CompletionItem=Pt;let dt=class{constructor(M=[],ee=!1){this.items=M,this.isIncomplete=ee}};dt=Be([m],dt),e.CompletionList=dt;let bt=class{constructor(M,ee,_e){this.text=M,this.range=ee,this.command=_e}};bt=Be([m],bt),e.InlineSuggestion=bt;let mt=class{constructor(M){this.items=M}};mt=Be([m],mt),e.InlineSuggestions=mt;var Et;(function(N){N[N.Active=-1]="Active",N[N.Beside=-2]="Beside",N[N.One=1]="One",N[N.Two=2]="Two",N[N.Three=3]="Three",N[N.Four=4]="Four",N[N.Five=5]="Five",N[N.Six=6]="Six",N[N.Seven=7]="Seven",N[N.Eight=8]="Eight",N[N.Nine=9]="Nine"})(Et=e.ViewColumn||(e.ViewColumn={}));var Ye;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(Ye=e.StatusBarAlignment||(e.StatusBarAlignment={}));var Ct;(function(N){N[N.Off=0]="Off",N[N.On=1]="On",N[N.Relative=2]="Relative"})(Ct=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Pe;(function(N){N[N.Manual=1]="Manual",N[N.AfterDelay=2]="AfterDelay",N[N.FocusOut=3]="FocusOut"})(Pe=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var ye;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(ye=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ke;(function(N){N[N.Keyboard=1]="Keyboard",N[N.Mouse=2]="Mouse",N[N.Command=3]="Command"})(ke=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var X;(function(N){N[N.Undo=1]="Undo",N[N.Redo=2]="Redo"})(X=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var ue;(function(N){N[N.OpenOpen=0]="OpenOpen",N[N.ClosedClosed=1]="ClosedClosed",N[N.OpenClosed=2]="OpenClosed",N[N.ClosedOpen=3]="ClosedOpen"})(ue=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(N){function M(ee){switch(ee){case"keyboard":return N.Keyboard;case"mouse":return N.Mouse;case"api":return N.Command}}N.fromValue=M}(ke=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let ge=class{constructor(M,ee){if(ee&&!y.URI.isUri(ee))throw(0,F.illegalArgument)("target");if(!$.isRange(M)||M.isEmpty)throw(0,F.illegalArgument)("range");this.range=M,this.target=ee}};ge=Be([m],ge),e.DocumentLink=ge;let me=class{constructor(M,ee,_e,Ge){this.red=M,this.green=ee,this.blue=_e,this.alpha=Ge}};me=Be([m],me),e.Color=me;let Ie=class{constructor(M,ee){if(ee&&!(ee instanceof me))throw(0,F.illegalArgument)("color");if(!$.isRange(M)||M.isEmpty)throw(0,F.illegalArgument)("range");this.range=M,this.color=ee}};Ie=Be([m],Ie),e.ColorInformation=Ie;let Ue=class{constructor(M){if(!M||typeof M!="string")throw(0,F.illegalArgument)("label");this.label=M}};Ue=Be([m],Ue),e.ColorPresentation=Ue;var Me;(function(N){N[N.RGB=0]="RGB",N[N.HEX=1]="HEX",N[N.HSL=2]="HSL"})(Me=e.ColorFormat||(e.ColorFormat={}));var je;(function(N){N[N.Error=0]="Error",N[N.Warning=1]="Warning",N[N.Information=2]="Information"})(je=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));class Je{constructor(M,ee,_e){if(this.startIndex=M,this.length=ee,this.tooltip=_e,typeof M!="number"||M<0)throw(0,F.illegalArgument)("startIndex");if(typeof ee!="number"||ee<1)throw(0,F.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,F.illegalArgument)("tooltip")}}e.TerminalLink=Je;class te{constructor(M){this.options=M,typeof M!="object"&&(0,F.illegalArgument)("options")}}e.TerminalProfile=te;var pe;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(pe=e.TaskRevealKind||(e.TaskRevealKind={}));var oe;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(oe=e.TaskPanelKind||(e.TaskPanelKind={}));let U=p=class{constructor(M,ee){if(typeof M!="string"||typeof ee!="string")throw(0,F.illegalArgument)("name");this._id=M}static from(M){switch(M){case"clean":return p.Clean;case"build":return p.Build;case"rebuild":return p.Rebuild;case"test":return p.Test;default:return}}get id(){return this._id}};U.Clean=new p("clean","Clean"),U.Build=new p("build","Build"),U.Rebuild=new p("rebuild","Rebuild"),U.Test=new p("test","Test"),U=p=Be([m],U),e.TaskGroup=U;function De(N){let M="";for(let ee=0;ee<N.length;ee++)M+=N[ee].replace(/,/g,",,")+",";return M}let Se=class{constructor(M,ee,_e){if(typeof M!="string")throw(0,F.illegalArgument)("process");this._args=[],this._process=M,ee!==void 0&&(Array.isArray(ee)?(this._args=ee,this._options=_e):this._options=ee)}get process(){return this._process}set process(M){if(typeof M!="string")throw(0,F.illegalArgument)("process");this._process=M}get args(){return this._args}set args(M){Array.isArray(M)||(M=[]),this._args=M}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("process"),this._process!==void 0&&M.push(this._process),this._args&&this._args.length>0)for(let ee of this._args)M.push(ee);return De(M)}};Se=Be([m],Se),e.ProcessExecution=Se;let qe=class{constructor(M,ee,_e){if(this._args=[],Array.isArray(ee)){if(!M)throw(0,F.illegalArgument)("command can't be undefined or null");if(typeof M!="string"&&typeof M.value!="string")throw(0,F.illegalArgument)("command");this._command=M,this._args=ee,this._options=_e}else{if(typeof M!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=M,this._options=ee}}get commandLine(){return this._commandLine}set commandLine(M){if(typeof M!="string")throw(0,F.illegalArgument)("commandLine");this._commandLine=M}get command(){return this._command?this._command:""}set command(M){if(typeof M!="string"&&typeof M.value!="string")throw(0,F.illegalArgument)("command");this._command=M}get args(){return this._args}set args(M){this._args=M||[]}get options(){return this._options}set options(M){this._options=M}computeId(){const M=[];if(M.push("shell"),this._commandLine!==void 0&&M.push(this._commandLine),this._command!==void 0&&M.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(let ee of this._args)M.push(typeof ee=="string"?ee:ee.value);return De(M)}};qe=Be([m],qe),e.ShellExecution=qe;var ze;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(ze=e.ShellQuoting||(e.ShellQuoting={}));var it;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace"})(it=e.TaskScope||(e.TaskScope={}));class vt{constructor(M){this._callback=M}computeId(){return"customExecution"+(0,k.generateUuid)()}set callback(M){this._callback=M}get callback(){return this._callback}}e.CustomExecution=vt;let ht=w=class{constructor(M,ee,_e,Ge,Ze,nt){this.__deprecated=!1,this._definition=this.definition=M;let at;typeof ee=="string"?(this._name=this.name=ee,this._source=this.source=_e,this.execution=Ge,at=Ze,this.__deprecated=!0):ee===it.Global||ee===it.Workspace?(this.target=ee,this._name=this.name=_e,this._source=this.source=Ge,this.execution=Ze,at=nt):(this.target=ee,this._name=this.name=_e,this._source=this.source=Ge,this.execution=Ze,at=nt),typeof at=="string"?(this._problemMatchers=[at],this._hasDefinedMatchers=!0):Array.isArray(at)?(this._problemMatchers=at,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(M){this.__id=M}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Se?this._definition={type:w.ProcessType,id:this._execution.computeId()}:this._execution instanceof qe?this._definition={type:w.ShellType,id:this._execution.computeId()}:this._execution instanceof vt?this._definition={type:w.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:w.EmptyType,id:(0,k.generateUuid)()}}get definition(){return this._definition}set definition(M){if(M==null)throw(0,F.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=M}get scope(){return this._scope}set target(M){this.clear(),this._scope=M}get name(){return this._name}set name(M){if(typeof M!="string")throw(0,F.illegalArgument)("name");this.clear(),this._name=M}get execution(){return this._execution}set execution(M){M===null&&(M=void 0),this.clear(),this._execution=M;const ee=this._definition.type;(w.EmptyType===ee||w.ProcessType===ee||w.ShellType===ee||w.ExtensionCallbackType===ee)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(M){if(Array.isArray(M))this.clear(),this._problemMatchers=M,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(M){M!==!0&&M!==!1&&(M=!1),this.clear(),this._isBackground=M}get source(){return this._source}set source(M){if(typeof M!="string"||M.length===0)throw(0,F.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=M}get group(){return this._group}set group(M){M===null&&(M=void 0),this.clear(),this._group=M}get detail(){return this._detail}set detail(M){M===null&&(M=void 0),this._detail=M}get presentationOptions(){return this._presentationOptions}set presentationOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._presentationOptions=M}get runOptions(){return this._runOptions}set runOptions(M){M==null&&(M=Object.create(null)),this.clear(),this._runOptions=M}};ht.ExtensionCallbackType="customExecution",ht.ProcessType="process",ht.ShellType="shell",ht.EmptyType="$empty",ht=w=Be([m],ht),e.Task=ht;var ot;(function(N){N[N.SourceControl=1]="SourceControl",N[N.Window=10]="Window",N[N.Notification=15]="Notification"})(ot=e.ProgressLocation||(e.ProgressLocation={}));let st=class{constructor(M,ee=ut.None){this.collapsibleState=ee,y.URI.isUri(M)?this.resourceUri=M:this.label=M}};st=Be([m],st),e.TreeItem=st;var ut;(function(N){N[N.None=0]="None",N[N.Collapsed=1]="Collapsed",N[N.Expanded=2]="Expanded"})(ut=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let kt=class{constructor(M,ee){this.id=M,this.color=ee}};kt=Be([m],kt),e.ThemeIcon=kt,kt.File=new kt("file"),kt.Folder=new kt("folder");let Tt=class{constructor(M){this.id=M}};Tt=Be([m],Tt),e.ThemeColor=Tt;var Wt;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.WorkspaceFolder=3]="WorkspaceFolder"})(Wt=e.ConfigurationTarget||(e.ConfigurationTarget={}));let jt=class{constructor(M,ee){if(typeof M!="string"&&(!M||!y.URI.isUri(M)&&!y.URI.isUri(M.uri)))throw(0,F.illegalArgument)("base");if(typeof ee!="string")throw(0,F.illegalArgument)("pattern");typeof M=="string"?(this.baseFolder=y.URI.file(M),this.base=M):y.URI.isUri(M)?(this.baseFolder=M,this.base=M.fsPath):(this.baseFolder=M.uri,this.base=M.uri.fsPath),this.pattern=ee}};jt=Be([m],jt),e.RelativePattern=jt;let _t=class{constructor(M,ee,_e,Ge){this.enabled=typeof M=="boolean"?M:!0,typeof ee=="string"&&(this.condition=ee),typeof _e=="string"&&(this.hitCondition=_e),typeof Ge=="string"&&(this.logMessage=Ge)}get id(){return this._id||(this._id=(0,k.generateUuid)()),this._id}};_t=Be([m],_t),e.Breakpoint=_t;let Jt=class extends _t{constructor(M,ee,_e,Ge,Ze){super(ee,_e,Ge,Ze);if(M===null)throw(0,F.illegalArgument)("location");this.location=M}};Jt=Be([m],Jt),e.SourceBreakpoint=Jt;let Xt=class extends _t{constructor(M,ee,_e,Ge,Ze){super(ee,_e,Ge,Ze);this.functionName=M}};Xt=Be([m],Xt),e.FunctionBreakpoint=Xt;let gt=class extends _t{constructor(M,ee,_e,Ge,Ze,nt,at){super(Ge,Ze,nt,at);if(!ee)throw(0,F.illegalArgument)("dataId");this.label=M,this.dataId=ee,this.canPersist=_e}};gt=Be([m],gt),e.DataBreakpoint=gt;let qt=class{constructor(M,ee,_e){this.command=M,this.args=ee||[],this.options=_e}};qt=Be([m],qt),e.DebugAdapterExecutable=qt;let zt=class{constructor(M,ee){this.port=M,this.host=ee}};zt=Be([m],zt),e.DebugAdapterServer=zt;let Zt=class{constructor(M){this.path=M}};Zt=Be([m],Zt),e.DebugAdapterNamedPipeServer=Zt;let ei=class{constructor(M){this.implementation=M}};ei=Be([m],ei),e.DebugAdapterInlineImplementation=ei;let It=class{constructor(M,ee){this.range=M,this.expression=ee}};It=Be([m],It),e.EvaluatableExpression=It;var hi;(function(N){N[N.Automatic=0]="Automatic",N[N.Explicit=1]="Explicit"})(hi=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));let ti=class{constructor(M,ee){this.range=M,this.text=ee}};ti=Be([m],ti),e.InlineValueText=ti;let Ut=class{constructor(M,ee,_e=!0){this.range=M,this.variableName=ee,this.caseSensitiveLookup=_e}};Ut=Be([m],Ut),e.InlineValueVariableLookup=Ut;let ct=class{constructor(M,ee){this.range=M,this.expression=ee}};ct=Be([m],ct),e.InlineValueEvaluatableExpression=ct;let ii=class{constructor(M,ee){this.frameId=M,this.stoppedLocation=ee}};ii=Be([m],ii),e.InlineValueContext=ii;var Lt;(function(N){N[N.Changed=1]="Changed",N[N.Created=2]="Created",N[N.Deleted=3]="Deleted"})(Lt=e.FileChangeType||(e.FileChangeType={}));let Ot=C=class extends Error{constructor(M,ee=t.FileSystemProviderErrorCode.Unknown,_e){super(y.URI.isUri(M)?M.toString(!0):M);this.code=_e?.name??"Unknown",(0,t.markAsFileSystemProviderError)(this,ee),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,C.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(M){return new C(M,t.FileSystemProviderErrorCode.FileExists,C.FileExists)}static FileNotFound(M){return new C(M,t.FileSystemProviderErrorCode.FileNotFound,C.FileNotFound)}static FileNotADirectory(M){return new C(M,t.FileSystemProviderErrorCode.FileNotADirectory,C.FileNotADirectory)}static FileIsADirectory(M){return new C(M,t.FileSystemProviderErrorCode.FileIsADirectory,C.FileIsADirectory)}static NoPermissions(M){return new C(M,t.FileSystemProviderErrorCode.NoPermissions,C.NoPermissions)}static Unavailable(M){return new C(M,t.FileSystemProviderErrorCode.Unavailable,C.Unavailable)}};Ot=C=Be([m],Ot),e.FileSystemError=Ot;let Gt=class{constructor(M,ee,_e){this.start=M,this.end=ee,this.kind=_e}};Gt=Be([m],Gt),e.FoldingRange=Gt;var Ei;(function(N){N[N.Comment=1]="Comment",N[N.Imports=2]="Imports",N[N.Region=3]="Region"})(Ei=e.FoldingRangeKind||(e.FoldingRangeKind={}));var fi;(function(N){N[N.Collapsed=0]="Collapsed",N[N.Expanded=1]="Expanded"})(fi=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var _i;(function(N){N[N.Editing=0]="Editing",N[N.Preview=1]="Preview"})(_i=e.CommentMode||(e.CommentMode={}));class mi{constructor(M,ee=[]){this.tokenTypes=M,this.tokenModifiers=ee}}e.SemanticTokensLegend=mi;function ni(N){return typeof N=="undefined"||(0,I.isStringArray)(N)}class ri{constructor(M){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,M){this._hasLegend=!0;for(let ee=0,_e=M.tokenTypes.length;ee<_e;ee++)this._tokenTypeStrToInt.set(M.tokenTypes[ee],ee);for(let ee=0,_e=M.tokenModifiers.length;ee<_e;ee++)this._tokenModifierStrToInt.set(M.tokenModifiers[ee],ee)}}push(M,ee,_e,Ge,Ze){if(typeof M=="number"&&typeof ee=="number"&&typeof _e=="number"&&typeof Ge=="number"&&(typeof Ze=="number"||typeof Ze=="undefined"))return typeof Ze=="undefined"&&(Ze=0),this._pushEncoded(M,ee,_e,Ge,Ze);if($.isRange(M)&&typeof ee=="string"&&ni(_e))return this._push(M,ee,_e);throw(0,F.illegalArgument)()}_push(M,ee,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(M.start.line!==M.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(ee))throw new Error("`tokenType` is not in the provided legend");const Ge=M.start.line,Ze=M.start.character,nt=M.end.character-M.start.character,at=this._tokenTypeStrToInt.get(ee);let yt=0;if(_e)for(const At of _e){if(!this._tokenModifierStrToInt.has(At))throw new Error("`tokenModifier` is not in the provided legend");const Rt=this._tokenModifierStrToInt.get(At);yt|=1<<Rt>>>0}this._pushEncoded(Ge,Ze,nt,at,yt)}_pushEncoded(M,ee,_e,Ge,Ze){if(this._dataIsSortedAndDeltaEncoded&&(M<this._prevLine||M===this._prevLine&&ee<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const yt=this._data.length/5|0;let At=0,Rt=0;for(let Mt=0;Mt<yt;Mt++){let Nt=this._data[5*Mt],ci=this._data[5*Mt+1];Nt===0?(Nt=At,ci+=Rt):Nt+=At,this._data[5*Mt]=Nt,this._data[5*Mt+1]=ci,At=Nt,Rt=ci}}let nt=M,at=ee;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(nt-=this._prevLine,nt===0&&(at-=this._prevChar)),this._data[this._dataLen++]=nt,this._data[this._dataLen++]=at,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=Ge,this._data[this._dataLen++]=Ze,this._prevLine=M,this._prevChar=ee}static _sortAndDeltaEncode(M){let ee=[];const _e=M.length/5|0;for(let at=0;at<_e;at++)ee[at]=at;ee.sort((at,yt)=>{const At=M[5*at],Rt=M[5*yt];if(At===Rt){const Mt=M[5*at+1],Nt=M[5*yt+1];return Mt-Nt}return At-Rt});const Ge=new Uint32Array(M.length);let Ze=0,nt=0;for(let at=0;at<_e;at++){const yt=5*ee[at],At=M[yt+0],Rt=M[yt+1],Mt=M[yt+2],Nt=M[yt+3],ci=M[yt+4],Ni=At-Ze,ji=Ni===0?Rt-nt:Rt,di=5*at;Ge[di+0]=Ni,Ge[di+1]=ji,Ge[di+2]=Mt,Ge[di+3]=Nt,Ge[di+4]=ci,Ze=At,nt=Rt}return Ge}build(M){return this._dataIsSortedAndDeltaEncoded?new Ht(new Uint32Array(this._data),M):new Ht(ri._sortAndDeltaEncode(this._data),M)}}e.SemanticTokensBuilder=ri;class Ht{constructor(M,ee){this.resultId=ee,this.data=M}}e.SemanticTokens=Ht;class si{constructor(M,ee,_e){this.start=M,this.deleteCount=ee,this.data=_e}}e.SemanticTokensEdit=si;class yi{constructor(M,ee){this.resultId=ee,this.edits=M}}e.SemanticTokensEdits=yi;var Si;(function(N){N[N.Separate=0]="Separate",N[N.MergeWithParent=1]="MergeWithParent"})(Si=e.DebugConsoleMode||(e.DebugConsoleMode={}));var Vt;(function(N){N[N.Initial=1]="Initial",N[N.Dynamic=2]="Dynamic"})(Vt=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));let Kt=class{constructor(){}};Kt.Back={iconPath:new kt("arrow-left")},Kt=Be([m],Kt),e.QuickInputButtons=Kt;var Di;(function(N){N[N.UI=1]="UI",N[N.Workspace=2]="Workspace"})(Di=e.ExtensionKind||(e.ExtensionKind={}));class Ci{constructor(M,ee,_e){this.badge=M,this.tooltip=ee,this.color=_e}static validate(M){if(M.badge&&M.badge.length!==1&&M.badge.length!==2)throw new Error("The 'badge'-property must be undefined or a short character");if(!M.color&&!M.badge&&!M.tooltip)throw new Error("The decoration is empty")}}e.FileDecoration=Ci;let oi=class{constructor(M){this.kind=M}};oi=Be([m],oi),e.ColorTheme=oi;var ai;(function(N){N[N.Light=1]="Light",N[N.Dark=2]="Dark",N[N.HighContrast=3]="HighContrast"})(ai=e.ColorThemeKind||(e.ColorThemeKind={}));class Bt{constructor(M,ee){if(M<0)throw(0,F.illegalArgument)("start must be positive");if(ee<0)throw(0,F.illegalArgument)("end must be positive");M<=ee?(this._start=M,this._end=ee):(this._start=ee,this._end=M)}static isNotebookRange(M){return M instanceof Bt?!0:M?typeof M.start=="number"&&typeof M.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(M){let ee=this._start,_e=this._end;return M.start!==void 0&&(ee=M.start),M.end!==void 0&&(_e=M.end),ee===this._start&&_e===this._end?this:new Bt(ee,_e)}}e.NotebookRange=Bt;class Ft{constructor(M,ee,_e,Ge,Ze,nt,at){this.kind=M,this.value=ee,this.languageId=_e,this.mime=Ge,this.outputs=Ze??[],this.metadata=nt,this.executionSummary=at,Ft.validate(this)}static validate(M){if(typeof M.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof M.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof M.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(M){return Array.isArray(M)&&M.every(ee=>Ft.isNotebookCellData(ee))}static isNotebookCellData(M){return!0}}e.NotebookCellData=Ft;class Qt{constructor(M){this.cells=M}}e.NotebookData=Qt;class Ae{constructor(M,ee){this.data=M,this.mime=ee;const _e=(0,R.normalizeMimeType)(ee,!0);if(!_e)throw new Error(`INVALID mime type: ${ee}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(M){return M instanceof Ae?!0:M?typeof M.mime=="string"&&M.data instanceof Uint8Array:!1}static error(M){const ee={name:M.name,message:M.message,stack:M.stack};return Ae.json(ee,"application/vnd.code.notebook.error")}static stdout(M){return Ae.text(M,"application/vnd.code.notebook.stdout")}static stderr(M){return Ae.text(M,"application/vnd.code.notebook.stderr")}static bytes(M,ee="application/octet-stream"){return new Ae(M,ee)}static text(M,ee=R.Mimes.text){const _e=Oe(Ae,a,"f",l).encode(String(M));return new Ae(_e,ee)}static json(M,ee="application/json"){const _e=JSON.stringify(M,void 0,"	");return Ae.text(_e,ee)}}e.NotebookCellOutputItem=Ae,a=Ae,l={value:new TextEncoder};class $t{constructor(M,ee,_e){this.items=$t.ensureUniqueMimeTypes(M,!0),typeof ee=="string"?(this.id=ee,this.metadata=_e):(this.id=(0,k.generateUuid)(),this.metadata=ee??_e)}static isNotebookCellOutput(M){return M instanceof $t?!0:!M||typeof M!="object"?!1:typeof M.id=="string"&&(0,I.isArray)(M.items)}static ensureUniqueMimeTypes(M,ee=!1){const _e=new Set,Ge=new Set;for(let Ze=0;Ze<M.length;Ze++){const nt=M[Ze],at=(0,R.normalizeMimeType)(nt.mime);if(!_e.has(at)){_e.add(at);continue}Ge.add(Ze),ee&&console.warn(`DUPLICATED mime type '${nt.mime}' will be dropped`)}return Ge.size===0?M:M.filter((Ze,nt)=>!Ge.has(nt))}}e.NotebookCellOutput=$t;var gi;(function(N){N[N.Markup=1]="Markup",N[N.Code=2]="Code"})(gi=e.NotebookCellKind||(e.NotebookCellKind={}));var pt;(function(N){N[N.Idle=1]="Idle",N[N.Pending=2]="Pending",N[N.Executing=3]="Executing"})(pt=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var ki;(function(N){N[N.Left=1]="Left",N[N.Right=2]="Right"})(ki=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var Ii;(function(N){N[N.Default=0]="Default",N[N.InCenter=1]="InCenter",N[N.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",N[N.AtTop=3]="AtTop"})(Ii=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class pi{constructor(M,ee){this.text=M,this.alignment=ee}}e.NotebookCellStatusBarItem=pi;var vi;(function(N){N[N.Default=1]="Default",N[N.Preferred=2]="Preferred"})(vi=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class Pi{constructor(M,ee=[]){this.uri=M,this.provides=(0,h.asArray)(ee)}}e.NotebookRendererScript=Pi;let li=class{constructor(M,ee){this.label=M,this.timestamp=ee}};li=Be([m],li),e.TimelineItem=li;var Ti;(function(N){N[N.Production=1]="Production",N[N.Development=2]="Development",N[N.Test=3]="Test"})(Ti=e.ExtensionMode||(e.ExtensionMode={}));var Ai;(function(N){N[N.Node=1]="Node",N[N.Webworker=2]="Webworker"})(Ai=e.ExtensionRuntime||(e.ExtensionRuntime={}));var wi;(function(N){N[N.Other=0]="Other",N[N.Comment=1]="Comment",N[N.String=2]="String",N[N.RegEx=4]="RegEx"})(wi=e.StandardTokenType||(e.StandardTokenType={}));class Ri{constructor(M,ee){this.ranges=M,this.wordPattern=ee}}e.LinkedEditingRanges=Ri;class Fi{constructor(M,ee){this._port=M,this._autoForwardAction=ee}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=Fi;var Mi;(function(N){N[N.Queued=1]="Queued",N[N.Running=2]="Running",N[N.Passed=3]="Passed",N[N.Failed=4]="Failed",N[N.Skipped=5]="Skipped",N[N.Errored=6]="Errored"})(Mi=e.TestResultState||(e.TestResultState={}));var Li;(function(N){N[N.Run=1]="Run",N[N.Debug=2]="Debug",N[N.Coverage=3]="Coverage"})(Li=e.TestRunProfileKind||(e.TestRunProfileKind={}));let ui=class{constructor(M,ee,_e){this.include=M,this.exclude=ee,this.profile=_e}};ui=Be([m],ui),e.TestRunRequest=ui;let J=P=class{constructor(M){this.message=M}static diff(M,ee,_e){const Ge=new P(M);return Ge.expectedOutput=ee,Ge.actualOutput=_e,Ge}};J=P=Be([m],J),e.TestMessage=J;let ce=class{constructor(M,ee){this.id=M,this.label=ee}};ce=Be([m],ce),e.TestTag=ce;let Ce=class{constructor(M,ee){this.covered=M,this.total=ee}};Ce=Be([m],Ce),e.CoveredCount=Ce;let rt=n=class{constructor(M,ee,_e,Ge){this.uri=M,this.statementCoverage=ee,this.branchCoverage=_e,this.functionCoverage=Ge}static fromDetails(M,ee){const _e=new Ce(0,0),Ge=new Ce(0,0),Ze=new Ce(0,0);for(const at of ee)if("branches"in at){_e.total+=1,_e.covered+=at.executionCount>0?1:0;for(const yt of at.branches)Ge.total+=1,Ge.covered+=yt.executionCount>0?1:0}else Ze.total+=1,Ze.covered+=at.executionCount>0?1:0;const nt=new n(M,_e,Ge.total>0?Ge:void 0,Ze.total>0?Ze:void 0);return nt.detailedCoverage=ee,nt}};rt=n=Be([m],rt),e.FileCoverage=rt;let wt=class{constructor(M,ee,_e=[]){this.executionCount=M,this.location=ee,this.branches=_e}};wt=Be([m],wt),e.StatementCoverage=wt;let Dt=class{constructor(M,ee){this.executionCount=M,this.location=ee}};Dt=Be([m],Dt),e.BranchCoverage=Dt;let Oi=class{constructor(M,ee){this.executionCount=M,this.location=ee}};Oi=Be([m],Oi),e.FunctionCoverage=Oi;var Wi;(function(N){N[N.None=0]="None",N[N.Option=1]="Option",N[N.Default=2]="Default",N[N.Preferred=3]="Preferred"})(Wi=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var zi;(function(N){N[N.Untrusted=0]="Untrusted",N[N.Trusted=1]="Trusted",N[N.Unspecified=2]="Unspecified"})(zi=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var Hi;(function(N){N[N.Notify=1]="Notify",N[N.OpenBrowser=2]="OpenBrowser",N[N.OpenPreview=3]="OpenPreview",N[N.Silent=4]="Silent",N[N.Ignore=5]="Ignore",N[N.OpenBrowserOnce=6]="OpenBrowserOnce"})(Hi=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class Vi{constructor(M,ee,_e,Ge,Ze,nt){this.kind=M,this.name=ee,this.detail=_e,this.uri=Ge,this.range=Ze,this.selectionRange=nt}}e.TypeHierarchyItem=Vi}),define(be[88],Ee([0,1,39,11,9,227,117,6,16]),function(re,e,h,F,E,A,R,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const k=new Map;function t(a,l){l?k.set(a,l):k.delete(a)}e.setWordDefinitionFor=t;function _(a){return k.get(a)}e.getWordDefinitionFor=_;class r extends A.MirrorTextModel{constructor(l,v,T,b,c,g,S,i){super(v,T,b,c);this._proxy=l,this._languageId=g,this._isDirty=S,this._notebook=i,this._isDisposed=!1}dispose(){(0,h.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(l){return(0,y.equals)(this._lines,l)}get document(){if(!this._document){const l=this;this._document={get uri(){return l._uri},get fileName(){return l._uri.fsPath},get isUntitled(){return l._uri.scheme===F.Schemas.untitled},get languageId(){return l._languageId},get version(){return l._versionId},get isClosed(){return l._isDisposed},get isDirty(){return l._isDirty},get notebook(){return l._notebook},save(){return l._save()},getText(v){return v?l._getTextInRange(v):l.getText()},get eol(){return l._eol===`
`?I.EndOfLine.LF:I.EndOfLine.CRLF},get lineCount(){return l._lines.length},lineAt(v){return l._lineAt(v)},offsetAt(v){return l._offsetAt(v)},positionAt(v){return l._positionAt(v)},validateRange(v){return l._validateRange(v)},validatePosition(v){return l._validatePosition(v)},getWordRangeAtPosition(v,T){return l._getWordRangeAtPosition(v,T)}}}return Object.freeze(this._document)}_acceptLanguageId(l){(0,h.ok)(!this._isDisposed),this._languageId=l}_acceptIsDirty(l){(0,h.ok)(!this._isDisposed),this._isDirty=l}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(l){const v=this._validateRange(l);if(v.isEmpty)return"";if(v.isSingleLine)return this._lines[v.start.line].substring(v.start.character,v.end.character);const T=this._eol,b=v.start.line,c=v.end.line,g=[];g.push(this._lines[b].substring(v.start.character));for(let S=b+1;S<c;S++)g.push(this._lines[S]);return g.push(this._lines[c].substring(0,v.end.character)),g.join(T)}_lineAt(l){let v;if(l instanceof I.Position?v=l.line:typeof l=="number"&&(v=l),typeof v!="number"||v<0||v>=this._lines.length||Math.floor(v)!==v)throw new Error("Illegal value for `line`");return new d(v,this._lines[v],v===this._lines.length-1)}_offsetAt(l){return l=this._validatePosition(l),this._ensureLineStarts(),this._lineStarts.getPrefixSum(l.line-1)+l.character}_positionAt(l){l=Math.floor(l),l=Math.max(0,l),this._ensureLineStarts();const v=this._lineStarts.getIndexOf(l),T=this._lines[v.index].length;return new I.Position(v.index,Math.min(v.remainder,T))}_validateRange(l){if(!(l instanceof I.Range))throw new Error("Invalid argument");const v=this._validatePosition(l.start),T=this._validatePosition(l.end);return v===l.start&&T===l.end?l:new I.Range(v.line,v.character,T.line,T.character)}_validatePosition(l){if(!(l instanceof I.Position))throw new Error("Invalid argument");if(this._lines.length===0)return l.with(0,0);let{line:v,character:T}=l,b=!1;if(v<0)v=0,T=0,b=!0;else if(v>=this._lines.length)v=this._lines.length-1,T=this._lines[v].length,b=!0;else{const c=this._lines[v].length;T<0?(T=0,b=!0):T>c&&(T=c,b=!0)}return b?new I.Position(v,T):l}_getWordRangeAtPosition(l,v){const T=this._validatePosition(l);if(!v)v=_(this._languageId);else if((0,E.regExpLeadsToEndlessLoop)(v))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${v.source}' because it matches the empty string.`);const b=(0,R.getWordAtText)(T.character+1,(0,R.ensureValidWordDefinition)(v),this._lines[T.line],0);if(b)return new I.Range(T.line,b.startColumn-1,T.line,b.endColumn-1)}}e.ExtHostDocumentData=r;class d{constructor(l,v,T){this._line=l,this._text=v,this._isLastLine=T}get lineNumber(){return this._line}get text(){return this._text}get range(){return new I.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new I.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=d}),define(be[154],Ee([0,1,6,3,228,7,54,20,2,36]),function(re,e,h,F,E,A,R,I,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookConcatDocument=void 0;class t{constructor(r,d,a,l){this._notebook=a,this._selector=l,this._disposables=new A.DisposableStore,this._isClosed=!1,this._versionId=0,this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this.uri=y.URI.from({scheme:"vscode-concat-doc",path:(0,k.generateUuid)()}),this._init(),this._disposables.add(d.onDidChangeDocument(T=>{const b=this._cellUris.get(T.document.uri);b!==void 0&&(this._cellLengths.changeValue(b,this._cells[b].document.getText().length+1),this._cellLines.changeValue(b,this._cells[b].document.lineCount),this._versionId+=1,this._onDidChange.fire(void 0))}));const v=T=>{T===this._notebook&&(this._init(),this._versionId+=1,this._onDidChange.fire(void 0))};this._disposables.add(r.onDidChangeNotebookCells(T=>v(T.document)))}dispose(){this._disposables.dispose(),this._isClosed=!0}get isClosed(){return this._isClosed}_init(){this._cells=[],this._cellUris=new I.ResourceMap;const r=[],d=[];for(const a of this._notebook.getCells())a.kind===h.NotebookCellKind.Code&&(!this._selector||(0,R.score)(this._selector,a.document.uri,a.document.languageId,!0))&&(this._cellUris.set(a.document.uri,this._cells.length),this._cells.push(a),r.push(a.document.getText().length+1),d.push(a.document.lineCount));this._cellLengths=new E.PrefixSumComputer(new Uint32Array(r)),this._cellLines=new E.PrefixSumComputer(new Uint32Array(d))}get version(){return this._versionId}getText(r){if(!r){let b="";for(const c of this._cells)b+=c.document.getText()+`
`;return b=b.slice(0,-1),b}if(r.isEmpty)return"";const d=this.locationAt(r.start),a=this.locationAt(r.end),l=this._cellUris.get(d.uri),v=this._cellUris.get(a.uri);if(l===void 0||v===void 0)return"";if(l===v)return this._cells[l].document.getText(new h.Range(d.range.start,a.range.end));const T=[this._cells[l].document.getText(new h.Range(d.range.start,new h.Position(this._cells[l].document.lineCount,0)))];for(let b=l+1;b<v;b++)T.push(this._cells[b].document.getText());return T.push(this._cells[v].document.getText(new h.Range(new h.Position(0,0),a.range.end))),T.join(`
`)}offsetAt(r){const d=this._cellLines.getIndexOf(r.line),a=this._cellLengths.getPrefixSum(d.index-1),l=this._cells[d.index].document.offsetAt(r.with(d.remainder));return a+l}positionAt(r){if(typeof r=="number"){const a=this._cellLengths.getIndexOf(r),l=this._cellLines.getPrefixSum(a.index-1);return this._cells[a.index].document.positionAt(a.remainder).translate(l)}const d=this._cellUris.get(r.uri);if(d!==void 0){const a=this._cellLines.getPrefixSum(d-1);return new h.Position(a+r.range.start.line,r.range.start.character)}return new h.Position(0,0)}locationAt(r){h.Range.isRange(r)||(r=new h.Range(r,r));const d=this._cellLines.getIndexOf(r.start.line);let a=d;r.isEmpty||(a=this._cellLines.getIndexOf(r.end.line));const l=new h.Position(d.remainder,r.start.character),v=new h.Position(a.remainder,r.end.character),T=new h.Range(l,v),b=this._cells[d.index];return new h.Location(b.document.uri,b.document.validateRange(T))}contains(r){return this._cellUris.has(r)}validateRange(r){const d=this.validatePosition(r.start),a=this.validatePosition(r.end);return r.with(d,a)}validatePosition(r){const d=this._cellLines.getIndexOf(r.line),a=new h.Position(d.remainder,r.character),l=this._cells[d.index].document.validatePosition(a),v=this._cellLines.getPrefixSum(d.index-1);return new h.Position(v+l.line,l.character)}}e.ExtHostNotebookConcatDocument=t}),define(be[155],Ee([0,1,6,12,3]),function(re,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let A=class{constructor(I){this._actual=new h.ColorTheme(h.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new E.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(I){let y=I==="light"?h.ColorThemeKind.Light:I==="dark"?h.ColorThemeKind.Dark:h.ColorThemeKind.HighContrast;this._actual=new h.ColorTheme(y),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};A=Be([We(0,F.IExtHostRpcService)],A),e.ExtHostTheming=A}),define(be[66],Ee([0,1,4]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,h.createDecorator)("IURITransformerService");class F{constructor(A){A?(this.transformIncoming=A.transformIncoming.bind(A),this.transformOutgoing=A.transformOutgoing.bind(A),this.transformOutgoingURI=A.transformOutgoingURI.bind(A),this.transformOutgoingScheme=A.transformOutgoingScheme.bind(A)):(this.transformIncoming=R=>R,this.transformOutgoing=R=>R,this.transformOutgoingURI=R=>R,this.transformOutgoingScheme=R=>R)}}e.URITransformerService=F}),define(be[156],Ee([0,1,23]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class F{constructor(){this.buffers=[]}add(y){let k=this.buffers.indexOf(y);return k<0&&(k=this.buffers.length,this.buffers.push(y)),k}}function E(I,y){if(y.serializeBuffersForPostMessage){const k=new F,t=(d,a)=>{if(a instanceof ArrayBuffer){const l=k.add(a);return{$$vscode_array_buffer_reference$$:!0,index:l}}else if(ArrayBuffer.isView(a)){const l=A(a);if(l){const v=k.add(a.buffer);return{$$vscode_array_buffer_reference$$:!0,index:v,view:{type:l,byteLength:a.byteLength,byteOffset:a.byteOffset}}}}return a},_=JSON.stringify(I,t),r=k.buffers.map(d=>{const a=new Uint8Array(d);return h.VSBuffer.wrap(a)});return{message:_,buffers:r}}else return{message:JSON.stringify(I),buffers:[]}}e.serializeWebviewMessage=E;function A(I){switch(I.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function R(I,y){const k=y.map(r=>{const d=new ArrayBuffer(r.byteLength);return new Uint8Array(d).set(r.buffer),d}),t=y.length?(r,d)=>{if(typeof d=="object"&&d.$$vscode_array_buffer_reference$$){const a=d,{index:l}=a,v=k[l];if(a.view)switch(a.view.type){case 1:return new Int8Array(v,a.view.byteOffset,a.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(v,a.view.byteOffset,a.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(v,a.view.byteOffset,a.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(v,a.view.byteOffset,a.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(v,a.view.byteOffset,a.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(v,a.view.byteOffset,a.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(v,a.view.byteOffset,a.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(v,a.view.byteOffset,a.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(v,a.view.byteOffset,a.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(v,a.view.byteOffset,a.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(v,a.view.byteOffset,a.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return v}return d}:void 0;return{message:JSON.parse(I,t),arrayBuffers:k}}e.deserializeWebviewMessage=R}),define(be[157],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeDataTransferConverter=void 0;var h;(function(F){function E(R){const I={items:new Map};return R.types.forEach((y,k)=>{I.items.set(y,{asString:async()=>R.items[k].asString})}),I}F.toITreeDataTransfer=E;async function A(R){const I={types:[],items:[]},y=Array.from(R.items.entries());for(const k of y)I.types.push(k[0]),I.items.push({asString:await k[1].asString()});return I}F.toTreeDataTransferDTO=A})(h=e.TreeDataTransferConverter||(e.TreeDataTransferConverter={}))}),define(be[67],Ee([0,1,11,2]),function(re,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-webview.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`https://*.${e.webviewResourceBaseHost}`;function E(I,y){return I.scheme===h.Schemas.http||I.scheme===h.Schemas.https?I:(y&&y.authority&&y.isRemote&&I.scheme===h.Schemas.file&&(I=F.URI.from({scheme:h.Schemas.vscodeRemote,authority:y.authority,path:I.path})),F.URI.from({scheme:h.Schemas.https,authority:`${I.scheme}+${A(I.authority)}.${e.webviewRootResourceAuthority}`,path:I.path,fragment:I.fragment,query:I.query}))}e.asWebviewUri=E;function A(I){return I.replace(/./g,y=>{const k=y.charCodeAt(0);return k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57?y:"-"+k.toString(16).padStart(4,"0")})}function R(I){return I.replace(/-([0-9a-f]{4})/g,(y,k)=>String.fromCharCode(parseInt(k,16)))}e.decodeAuthority=R}),define(be[158],Ee([0,1,3,7,67]),function(re,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class A{constructor(I,y,k){this._proxy=I,this._editors=y,this._initData=k,this._handlePool=0,this._disposables=new F.DisposableStore,this._insets=new Map,this._disposables.add(y.onDidChangeVisibleTextEditors(()=>{const t=y.getVisibleTextEditors();for(const _ of this._insets.values())t.indexOf(_.editor)<0&&_.inset.dispose()}))}dispose(){this._insets.forEach(I=>I.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(I,y,k,t,_){let r;for(const c of this._editors.getVisibleTextEditors(!0))if(c.value===I){r=c;break}if(!r)throw new Error("not a visible editor");const d=this,a=this._handlePool++,l=new h.Emitter,v=new h.Emitter,T=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(c){return(0,E.asWebviewUri)(c,d._initData.remote)}get cspSource(){return E.webviewGenericCspSource}set options(c){this._options=c,d._proxy.$setOptions(a,c)}get options(){return this._options}set html(c){this._html=c,d._proxy.$setHtml(a,c)}get html(){return this._html}get onDidReceiveMessage(){return l.event}postMessage(c){return d._proxy.$postMessage(a,c)}},b=new class{constructor(){this.editor=I,this.line=y,this.height=k,this.webview=T,this.onDidDispose=v.event}dispose(){d._insets.has(a)&&(d._insets.delete(a),d._proxy.$disposeEditorInset(a),v.fire(),v.dispose(),l.dispose())}};return this._proxy.$createEditorInset(a,r.id,r.value.document.uri,y+1,k,t||{},_.identifier,_.extensionLocation),this._insets.set(a,{editor:I,inset:b,onDidReceiveMessage:l}),b}$onDidDispose(I){const y=this._insets.get(I);y&&y.inset.dispose()}$onDidReceiveMessage(I,y){const k=this._insets.get(I);k&&k.onDidReceiveMessage.fire(y)}}e.ExtHostEditorInsets=A}),define(be[159],Ee([0,1,130,10,2,7,4,42,28,16,11]),function(re,e,h,F,E,A,R,I,y,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveReason=e.Verbosity=e.isUntitledResourceEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.isTextEditorPane=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.EditorAreaVisibleContext=e.SplitEditorsVertically=e.IsCenteredLayoutContext=e.InEditorZenModeContext=e.EditorsVisibleContext=e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext=e.ActiveEditorGroupLastContext=e.ActiveEditorGroupIndexContext=e.ActiveEditorGroupEmptyContext=e.EditorGroupEditorsCountContext=e.TextCompareEditorActiveContext=e.TextCompareEditorVisibleContext=e.ActiveEditorAvailableEditorIdsContext=e.ActiveEditorContext=e.ActiveEditorCanRevertContext=e.ActiveEditorReadonlyContext=e.ActiveEditorStickyContext=e.ActiveEditorPinnedContext=e.ActiveEditorDirtyContext=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,h.localize)(0,null),providerDisplayName:(0,h.localize)(1,null)},e.ActiveEditorDirtyContext=new I.RawContextKey("activeEditorIsDirty",!1,(0,h.localize)(2,null)),e.ActiveEditorPinnedContext=new I.RawContextKey("activeEditorIsNotPreview",!1,(0,h.localize)(3,null)),e.ActiveEditorStickyContext=new I.RawContextKey("activeEditorIsPinned",!1,(0,h.localize)(4,null)),e.ActiveEditorReadonlyContext=new I.RawContextKey("activeEditorIsReadonly",!1,(0,h.localize)(5,null)),e.ActiveEditorCanRevertContext=new I.RawContextKey("activeEditorCanRevert",!1,(0,h.localize)(6,null)),e.ActiveEditorContext=new I.RawContextKey("activeEditor",null,{type:"string",description:(0,h.localize)(7,null)}),e.ActiveEditorAvailableEditorIdsContext=new I.RawContextKey("activeEditorAvailableEditorIds","",(0,h.localize)(8,null)),e.TextCompareEditorVisibleContext=new I.RawContextKey("textCompareEditorVisible",!1,(0,h.localize)(9,null)),e.TextCompareEditorActiveContext=new I.RawContextKey("textCompareEditorActive",!1,(0,h.localize)(10,null)),e.EditorGroupEditorsCountContext=new I.RawContextKey("groupEditorsCount",0,(0,h.localize)(11,null)),e.ActiveEditorGroupEmptyContext=new I.RawContextKey("activeEditorGroupEmpty",!1,(0,h.localize)(12,null)),e.ActiveEditorGroupIndexContext=new I.RawContextKey("activeEditorGroupIndex",0,(0,h.localize)(13,null)),e.ActiveEditorGroupLastContext=new I.RawContextKey("activeEditorGroupLast",!1,(0,h.localize)(14,null)),e.MultipleEditorGroupsContext=new I.RawContextKey("multipleEditorGroups",!1,(0,h.localize)(15,null)),e.SingleEditorGroupsContext=e.MultipleEditorGroupsContext.toNegated(),e.EditorsVisibleContext=new I.RawContextKey("editorIsOpen",!1,(0,h.localize)(16,null)),e.InEditorZenModeContext=new I.RawContextKey("inZenMode",!1,(0,h.localize)(17,null)),e.IsCenteredLayoutContext=new I.RawContextKey("isCenteredLayout",!1,(0,h.localize)(18,null)),e.SplitEditorsVertically=new I.RawContextKey("splitEditorsVertically",!1,(0,h.localize)(19,null)),e.EditorAreaVisibleContext=new I.RawContextKey("editorAreaVisible",!0,(0,h.localize)(20,null)),e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";function _(n){return typeof n?.getViewState=="function"}e.isTextEditorPane=_;function r(n){if(c(n))return!1;const m=n;return E.URI.isUri(m?.resource)}e.isResourceEditorInput=r;function d(n){if(c(n))return!1;const m=n;return m?.original!==void 0&&m.modified!==void 0}e.isResourceDiffEditorInput=d;function a(n){if(c(n))return!1;const m=n;return m?m.resource===void 0||m.resource.scheme===t.Schemas.untitled||m.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=a;var l;(function(n){n[n.SHORT=0]="SHORT",n[n.MEDIUM=1]="MEDIUM",n[n.LONG=2]="LONG"})(l=e.Verbosity||(e.Verbosity={}));var v;(function(n){n[n.EXPLICIT=1]="EXPLICIT",n[n.AUTO=2]="AUTO",n[n.FOCUS_CHANGE=3]="FOCUS_CHANGE",n[n.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(v=e.SaveReason||(e.SaveReason={}));var T;(function(n){n[n.None=0]="None",n[n.Readonly=2]="Readonly",n[n.Untitled=4]="Untitled",n[n.Singleton=8]="Singleton",n[n.RequiresTrust=16]="RequiresTrust"})(T=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class b extends A.Disposable{}e.AbstractEditorInput=b;function c(n){return n instanceof b}e.isEditorInput=c;function g(n){const m=n;return E.URI.isUri(m?.preferredResource)}function S(n){const m=n;return c(m?.primary)&&c(m?.secondary)}e.isSideBySideEditorInput=S;function i(n){return c(n?.editor)}e.isEditorInputWithOptions=i;function s(n){const m=n;return i(n)&&m?.group!==void 0}e.isEditorInputWithOptionsAndGroup=s;function u(n){const m=n;return typeof m?.groupId=="number"&&c(m.editor)}e.isEditorIdentifier=u;var o;(function(n){n[n.PRIMARY=1]="PRIMARY",n[n.SECONDARY=2]="SECONDARY",n[n.BOTH=3]="BOTH"})(o=e.SideBySideEditor||(e.SideBySideEditor={}));class f{getOriginalUri(m,D){if(!m)return;const O=S(m)?m.primary:d(m)?m.modified:void 0,$=S(m)?m.secondary:d(m)?m.original:void 0;if(D?.supportSideBySide&&O&&$){if(D?.supportSideBySide===o.BOTH)return{primary:this.getOriginalUri(O,{filterByScheme:D.filterByScheme}),secondary:this.getOriginalUri($,{filterByScheme:D.filterByScheme})};m=D.supportSideBySide===o.PRIMARY?O:$}if(d(m))return;const Q=g(m)?m.preferredResource:m.resource;return!Q||!D||!D.filterByScheme?Q:this.filterUri(Q,D.filterByScheme)}getCanonicalUri(m,D){if(!m)return;const O=S(m)?m.primary:d(m)?m.modified:void 0,$=S(m)?m.secondary:d(m)?m.original:void 0;if(D?.supportSideBySide&&O&&$){if(D?.supportSideBySide===o.BOTH)return{primary:this.getCanonicalUri(O,{filterByScheme:D.filterByScheme}),secondary:this.getCanonicalUri($,{filterByScheme:D.filterByScheme})};m=D.supportSideBySide===o.PRIMARY?O:$}if(d(m))return;const Q=m.resource;return!Q||!D||!D.filterByScheme?Q:this.filterUri(Q,D.filterByScheme)}filterUri(m,D){if(Array.isArray(D)){if(D.some(O=>m.scheme===O))return m}else if(D===m.scheme)return m}}e.EditorResourceAccessor=new f;var p;(function(n){n[n.LEFT=0]="LEFT",n[n.RIGHT=1]="RIGHT"})(p=e.CloseDirection||(e.CloseDirection={}));class w{constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(m){const D=this.instantiationService=m.get(R.IInstantiationService);for(const[O,$]of this.editorSerializerConstructors)this.createEditorSerializer(O,$,D);this.editorSerializerConstructors.clear()}createEditorSerializer(m,D,O){const $=O.createInstance(D);this.editorSerializerInstances.set(m,$)}registerFileEditorFactory(m){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=m}getFileEditorFactory(){return(0,F.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(m,D){if(this.editorSerializerConstructors.has(m)||this.editorSerializerInstances.has(m))throw new Error(`A editor serializer with type ID '${m}' was already registered.`);return this.instantiationService?this.createEditorSerializer(m,D,this.instantiationService):this.editorSerializerConstructors.set(m,D),(0,A.toDisposable)(()=>{this.editorSerializerConstructors.delete(m),this.editorSerializerInstances.delete(m)})}getEditorSerializer(m){return this.editorSerializerInstances.get(typeof m=="string"?m:m.typeId)}}y.Registry.add(e.EditorExtensions.EditorFactory,new w);async function C(n,m){if(!n||!n.length)return[];const D=await Promise.all(n.map(async O=>{const $=E.URI.revive(O.fileUri);if(!$||(await m.activateProvider($.scheme),!m.canHandleResource($)))return;const Q=typeof O.exists=="boolean"?O.exists:await m.exists($);if(!Q&&O.openOnlyIfExists)return;const ie=Q&&!(0,F.isUndefined)(O.selection)?{selection:O.selection,pinned:!0,override:O.editorOverrideId}:{pinned:!0,override:O.editorOverrideId};let V;return Q?V={resource:$,options:ie,forceFile:!0}:V={resource:$,options:ie,forceUntitled:!0},V}));return(0,k.coalesce)(D)}e.pathsToEditors=C;var P;(function(n){n[n.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",n[n.SEQUENTIAL=1]="SEQUENTIAL"})(P=e.EditorsOrder||(e.EditorsOrder={}))}),define(be[160],Ee([0,1,3,42,131,4,7,20,28,16,50,22,34,150]),function(re,e,h,F,E,A,R,I,y,k,t,_,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TREE_ITEM_DATA_TRANSFER_TYPE=e.ResolvableTreeItem=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.IViewDescriptorService=e.getVisbileViewContextKey=e.FocusedViewContext=e.IViewsService=e.ViewContentGroups=e.getEnabledViewContainerContextKey=e.ViewContainerLocationToString=e.ViewContainerLocation=e.Extensions=e.defaultViewIcon=void 0,e.defaultViewIcon=(0,d.registerIcon)("default-view-icon",r.Codicon.window,(0,E.localize)(0,null));var a;(function(f){f.ViewContainersRegistry="workbench.registry.view.containers",f.ViewsRegistry="workbench.registry.view"})(a=e.Extensions||(e.Extensions={}));var l;(function(f){f[f.Sidebar=0]="Sidebar",f[f.Panel=1]="Panel"})(l=e.ViewContainerLocation||(e.ViewContainerLocation={}));function v(f){switch(f){case 0:return"sidebar";case 1:return"panel"}}e.ViewContainerLocationToString=v;function T(f){return`viewContainer.${f}.enabled`}e.getEnabledViewContainerContextKey=T;class b extends R.Disposable{constructor(){super(...arguments);this._onDidRegister=this._register(new h.Emitter),this.onDidRegister=this._onDidRegister.event,this._onDidDeregister=this._register(new h.Emitter),this.onDidDeregister=this._onDidDeregister.event,this.viewContainers=new Map,this.defaultViewContainers=[]}get all(){return(0,k.flatten)([...this.viewContainers.values()])}registerViewContainer(p,w,C){const P=this.get(p.id);if(P)return P;const n=p;return n.openCommandActionDescriptor=C?.donotRegisterOpenCommand?void 0:n.openCommandActionDescriptor??{id:n.id},(0,I.getOrSet)(this.viewContainers,w,[]).push(n),C?.isDefault&&this.defaultViewContainers.push(n),this._onDidRegister.fire({viewContainer:n,viewContainerLocation:w}),n}deregisterViewContainer(p){for(const w of this.viewContainers.keys()){const C=this.viewContainers.get(w),P=C?.indexOf(p);if(P!==-1){C?.splice(P,1),C.length===0&&this.viewContainers.delete(w),this._onDidDeregister.fire({viewContainer:p,viewContainerLocation:w});return}}}get(p){return this.all.filter(w=>w.id===p)[0]}getViewContainers(p){return[...this.viewContainers.get(p)||[]]}getViewContainerLocation(p){return[...this.viewContainers.keys()].filter(w=>this.getViewContainers(w).filter(C=>C?.id===p.id).length>0)[0]}getDefaultViewContainer(p){return this.defaultViewContainers.find(w=>this.getViewContainerLocation(w)===p)}}y.Registry.add(a.ViewContainersRegistry,new b);var c;(function(f){f.Open="2_open",f.Debug="4_debug",f.SCM="5_scm",f.More="9_more"})(c=e.ViewContentGroups||(e.ViewContentGroups={}));function g(f,p){const w=f.group??c.More,C=p.group??c.More;return w!==C?w.localeCompare(C):(f.order??5)-(p.order??5)}class S extends R.Disposable{constructor(){super(...arguments);this._onViewsRegistered=this._register(new h.Emitter),this.onViewsRegistered=this._onViewsRegistered.event,this._onViewsDeregistered=this._register(new h.Emitter),this.onViewsDeregistered=this._onViewsDeregistered.event,this._onDidChangeContainer=this._register(new h.Emitter),this.onDidChangeContainer=this._onDidChangeContainer.event,this._onDidChangeViewWelcomeContent=this._register(new h.Emitter),this.onDidChangeViewWelcomeContent=this._onDidChangeViewWelcomeContent.event,this._viewContainers=[],this._views=new Map,this._viewWelcomeContents=new t.SetMap}registerViews(p,w){this.registerViews2([{views:p,viewContainer:w}])}registerViews2(p){p.forEach(({views:w,viewContainer:C})=>this.addViews(w,C)),this._onViewsRegistered.fire(p)}deregisterViews(p,w){const C=this.removeViews(p,w);C.length&&this._onViewsDeregistered.fire({views:C,viewContainer:w})}moveViews(p,w){for(const C of this._views.keys())if(C!==w){const P=this.removeViews(p,C);P.length&&(this.addViews(P,w),this._onDidChangeContainer.fire({views:P,from:C,to:w}))}}getViews(p){return this._views.get(p)||[]}getView(p){for(const w of this._viewContainers){const C=(this._views.get(w)||[]).filter(P=>P.id===p)[0];if(C)return C}return null}getViewContainer(p){for(const w of this._viewContainers)if((this._views.get(w)||[]).filter(P=>P.id===p)[0])return w;return null}registerViewWelcomeContent(p,w){return this._viewWelcomeContents.add(p,w),this._onDidChangeViewWelcomeContent.fire(p),(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(p,w),this._onDidChangeViewWelcomeContent.fire(p)})}registerViewWelcomeContent2(p,w){const C=new Map;for(const[P,n]of w)this._viewWelcomeContents.add(p,n),C.set(P,(0,R.toDisposable)(()=>{this._viewWelcomeContents.delete(p,n),this._onDidChangeViewWelcomeContent.fire(p)}));return this._onDidChangeViewWelcomeContent.fire(p),C}getViewWelcomeContent(p){const w=[];return this._viewWelcomeContents.forEach(p,C=>w.push(C)),w.sort(g)}addViews(p,w){let C=this._views.get(w);C||(C=[],this._views.set(w,C),this._viewContainers.push(w));for(const P of p){if(this.getView(P.id)!==null)throw new Error((0,E.localize)(1,null,P.id));C.push(P)}}removeViews(p,w){const C=this._views.get(w);if(!C)return[];const P=[],n=[];for(const m of C)p.includes(m)?P.push(m):n.push(m);return P.length&&(n.length?this._views.set(w,n):(this._views.delete(w),this._viewContainers.splice(this._viewContainers.indexOf(w),1))),P}}y.Registry.add(a.ViewsRegistry,new S),e.IViewsService=(0,A.createDecorator)("viewsService"),e.FocusedViewContext=new F.RawContextKey("focusedView","",(0,E.localize)(2,null));function i(f){return`view.${f}.visible`}e.getVisbileViewContextKey=i,e.IViewDescriptorService=(0,A.createDecorator)("viewDescriptorService");var s;(function(f){f[f.Default=0]="Default",f[f.Expand=1]="Expand"})(s=e.ViewVisibilityState||(e.ViewVisibilityState={}));var u;(function(f){f[f.None=0]="None",f[f.Collapsed=1]="Collapsed",f[f.Expanded=2]="Expanded"})(u=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));class o{constructor(p,w){this.resolved=!1,this._hasResolve=!1,(0,_.mixin)(this,p),this._hasResolve=!!w,this.resolve=async C=>{if(w&&!this.resolved){const P=await w(C);P&&(this.tooltip=this.tooltip??P.tooltip,this.command=this.command??P.command)}C.isCancellationRequested||(this.resolved=!0)}}get hasResolve(){return this._hasResolve}resetResolve(){this.resolved=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.ResolvableTreeItem=o,e.TREE_ITEM_DATA_TRANSFER_TYPE="text/treeitems"}),define(be[161],Ee([0,1,3,13,132]),function(re,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class A{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new h.Emitter,this._onExit=new h.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(I){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=I}onEvent(I){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=I}onRequest(I){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=I}sendResponse(I){I.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${I.command}`)):this.internalSend("response",I)}sendRequest(I,y,k,t){const _={command:I};if(y&&Object.keys(y).length>0&&(_.arguments=y),this.internalSend("request",_),typeof t=="number"){const r=setTimeout(()=>{clearTimeout(r);const d=this.pendingRequests.get(_.seq);if(d){this.pendingRequests.delete(_.seq);const a={type:"response",seq:0,request_seq:_.seq,success:!1,command:I,message:(0,E.localize)(0,null,t,I)};d(a)}},t)}return k&&this.pendingRequests.set(_.seq,k),_.seq}acceptMessage(I){this.messageCallback?this.messageCallback(I):(this.queue.push(I),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(I,y){return I.type!=="event"||y.type!=="event"}async processQueue(){let I;for(;this.queue.length;){if((!I||this.needsTaskBoundaryBetween(this.queue[0],I))&&await(0,F.timeout)(0),I=this.queue.shift(),!I)return;switch(I.type){case"event":this.eventCallback&&this.eventCallback(I);break;case"request":this.requestCallback&&this.requestCallback(I);break;case"response":const y=I,k=this.pendingRequests.get(y.request_seq);k&&(this.pendingRequests.delete(y.request_seq),k(y));break}}}internalSend(I,y){y.type=I,y.seq=this.sequence++,this.sendMessage(y)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const I=new Map;this.pendingRequests.forEach((y,k)=>I.set(k,y)),await(0,F.timeout)(500),I.forEach((y,k)=>{y({type:"response",seq:0,request_seq:k,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(k)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=A}),define(be[162],Ee([0,1,9,2,17,22,11]),function(re,e,h,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const I=/{([^}]+)}/g;function y(u,o,f){return u.replace(I,function(p,w){return o&&w.length>0&&w[0]!=="_"?p:f&&f.hasOwnProperty(w)?f[w]:p})}e.formatPII=y;function k(u){const o={};for(const f of Object.keys(u))f.startsWith("!")||(o[f]=u[f]);return o}e.filterExceptionsFromTelemetry=k;function t(u){return u.configuration.request==="attach"&&!_(u)&&(!u.parentSession||t(u.parentSession))}e.isSessionAttach=t;function _(u){let o=u.configuration.type;if(!!o)return o==="vslsShare"&&(o=u.configuration.adapterProxy.configuration.type),(0,h.equalsIgnoreCase)(o,"extensionhost")||(0,h.equalsIgnoreCase)(o,"pwa-extensionhost")?u:u.parentSession?_(u.parentSession):void 0}e.getExtensionHostDebugSession=_;function r(u){return u.type&&(u.label||u.program||u.runtime)}e.isDebuggerMainContribution=r;function d(u,o,f){let p,w=0,C=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g,P=null;for(;P=C.exec(u);){let n=P.index+1,m=n+P[0].length;if(n<=o&&m>=f){p=P[0],w=n;break}}if(p){let n=/\w+/g,m=null;for(;(m=n.exec(p))&&!(m.index+1+w+m[0].length>=f););m&&(p=p.substring(0,n.lastIndex))}return p?{start:w,end:w+p.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=d;const a=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function l(u){return!!(u&&u.match(a))}e.isUri=l;function v(u){if(typeof u.path=="string"&&!(typeof u.sourceReference=="number"&&u.sourceReference>0)){if(l(u.path))return F.URI.parse(u.path);if((0,E.isAbsolute)(u.path))return F.URI.file(u.path)}return u.path}function T(u){if(typeof u.path=="object"){const o=F.URI.revive(u.path);if(o)return o.scheme===R.Schemas.file?o.fsPath:o.toString()}return u.path}function b(u,o){const f=o?v:T,p=(0,A.deepClone)(u);return g(p,(w,C)=>{w&&C&&(C.path=f(C))}),p}e.convertToDAPaths=b;function c(u,o){const f=o?v:T,p=(0,A.deepClone)(u);return g(p,(w,C)=>{!w&&C&&(C.path=f(C))}),p}e.convertToVSCPaths=c;function g(u,o){switch(u.type){case"event":const f=u;switch(f.event){case"output":o(!1,f.body.source);break;case"loadedSource":o(!1,f.body.source);break;case"breakpoint":o(!1,f.body.breakpoint.source);break;default:break}break;case"request":const p=u;switch(p.command){case"setBreakpoints":o(!0,p.arguments.source);break;case"breakpointLocations":o(!0,p.arguments.source);break;case"source":o(!0,p.arguments.source);break;case"gotoTargets":o(!0,p.arguments.source);break;case"launchVSCode":p.arguments.args.forEach(C=>o(!1,C));break;default:break}break;case"response":const w=u;if(w.success&&w.body)switch(w.command){case"stackTrace":w.body.stackFrames.forEach(C=>o(!1,C.source));break;case"loadedSources":w.body.sources.forEach(C=>o(!1,C));break;case"scopes":w.body.scopes.forEach(C=>o(!1,C.source));break;case"setFunctionBreakpoints":w.body.breakpoints.forEach(C=>o(!1,C.source));break;case"setBreakpoints":w.body.breakpoints.forEach(C=>o(!1,C.source));break;default:break}break}}function S(u){return u.filter(o=>!o.presentation?.hidden).sort((o,f)=>o.presentation?f.presentation?o.presentation.group?f.presentation.group?o.presentation.group!==f.presentation.group?o.presentation.group.localeCompare(f.presentation.group):i(o.presentation.order,f.presentation.order):-1:f.presentation.group?1:i(o.presentation.order,f.presentation.order):-1:f.presentation?1:0)}e.getVisibleAndSorted=S;function i(u,o){return typeof u!="number"?typeof o!="number"?0:1:typeof o!="number"?-1:u-o}async function s(u,o){const f=u.getValue("debug.saveBeforeStart",{overrideIdentifier:o.activeTextEditorMode});if(f!=="none"&&(await o.saveAll(),f==="allEditorsInActiveGroup")){const p=o.activeEditorPane;p&&await o.save({editor:p.input,groupId:p.group.id})}await u.reloadConfiguration()}e.saveAllBeforeDebugStart=s}),define(be[89],Ee([0,1,27,78,11,17,26,42]),function(re,e,h,F,E,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.GlobalToolbarShowLabel=e.TextOutputLineLimit=e.OpenGettingStarted=e.ConsolidatedRunButton=e.NotebookCellEditorOptionsCustomizations=e.DragAndDropEnabled=e.ShowFoldingControls=e.ConsolidatedOutputButton=e.UndoRedoPerCell=e.GlobalToolbar=e.InsertToolbarLocation=e.FocusIndicator=e.CompactView=e.ExperimentalInsertToolbarAlignment=e.NotebookTextDiffEditorPreview=e.ShowCellStatusBar=e.CellToolbarVisibility=e.CellToolbarLocation=e.DisplayOrderKey=e.CellSequence=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.sortMimeTypes=e.mimeTypeIsMergeable=e.mimeTypeSupportedByCore=e.mimeTypeIsAlwaysSecure=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.BUILTIN_RENDERER_ID=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=void 0;var y;(function(n){n[n.Markup=1]="Markup",n[n.Code=2]="Code"})(y=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",F.Mimes.markdown,"image/png","image/jpeg",F.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[F.Mimes.markdown,"application/json",F.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.BUILTIN_RENDERER_ID="_builtin",e.RENDERER_NOT_AVAILABLE="_notAvailable";var k;(function(n){n[n.Running=1]="Running",n[n.Idle=2]="Idle"})(k=e.NotebookRunState||(e.NotebookRunState={}));var t;(function(n){n[n.Pending=2]="Pending",n[n.Executing=3]="Executing"})(t=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var _;(function(n){n[n.WithHardKernelDependency=0]="WithHardKernelDependency",n[n.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",n[n.Pure=2]="Pure",n[n.Never=3]="Never"})(_=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var r;(function(n){n.Always="always",n.Never="never",n.Optional="optional"})(r=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var d;(function(n){n[n.ModelChange=1]="ModelChange",n[n.Move=2]="Move",n[n.ChangeLanguage=5]="ChangeLanguage",n[n.Initialize=6]="Initialize",n[n.ChangeCellMetadata=7]="ChangeCellMetadata",n[n.Output=8]="Output",n[n.OutputItem=9]="OutputItem",n[n.ChangeCellContent=10]="ChangeCellContent",n[n.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",n[n.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",n[n.ChangeCellMime=13]="ChangeCellMime",n[n.Unknown=100]="Unknown"})(d=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var a;(function(n){n[n.Handle=0]="Handle",n[n.Index=1]="Index"})(a=e.SelectionStateType||(e.SelectionStateType={}));var l;(function(n){n[n.Replace=1]="Replace",n[n.Output=2]="Output",n[n.Metadata=3]="Metadata",n[n.CellLanguage=4]="CellLanguage",n[n.DocumentMetadata=5]="DocumentMetadata",n[n.Move=6]="Move",n[n.OutputItems=7]="OutputItems",n[n.PartialMetadata=8]="PartialMetadata",n[n.PartialInternalMetadata=9]="PartialInternalMetadata"})(l=e.CellEditType||(e.CellEditType={}));var v;(function(n){n.scheme=E.Schemas.vscodeNotebookCell;const m=/^ch(\d{7,})/;function D(V,W){return V.with({scheme:n.scheme,fragment:`ch${W.toString().padStart(7,"0")}${V.scheme!==E.Schemas.file?V.scheme:""}`})}n.generate=D;function O(V){if(V.scheme!==n.scheme)return;const W=m.exec(V.fragment);return W?{handle:Number(W[1]),notebook:V.with({scheme:V.fragment.substr(W[0].length)||E.Schemas.file,fragment:null})}:void 0}n.parse=O;function $(V){if(V.scheme!==E.Schemas.vscodeNotebookCellMetadata)return;const W=m.exec(V.fragment);return W?{handle:Number(W[1]),notebook:V.with({scheme:V.fragment.substr(W[0].length)||E.Schemas.file,fragment:null})}:void 0}n.parseCellMetadataUri=$;function Q(V,W,L){return V.with({scheme:L,fragment:`ch${W.toString().padStart(7,"0")}${V.scheme!==E.Schemas.file?V.scheme:""}`})}n.generateCellUri=Q;function ie(V,W){if(V.scheme!==W)return;const L=m.exec(V.fragment);return L?{handle:Number(L[1]),notebook:V.with({scheme:V.fragment.substr(L[0].length)||E.Schemas.file,fragment:null})}:void 0}n.parseCellUri=ie})(v=e.CellUri||(e.CellUri={}));const T=new Map([["application/javascript",{supportedByCore:!0}],["image/png",{alwaysSecure:!0,supportedByCore:!0}],["image/jpeg",{alwaysSecure:!0,supportedByCore:!0}],["image/git",{alwaysSecure:!0,supportedByCore:!0}],["image/svg+xml",{supportedByCore:!0}],["application/json",{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.markdown,{alwaysSecure:!0,supportedByCore:!0}],[F.Mimes.text,{alwaysSecure:!0,supportedByCore:!0}],["text/html",{supportedByCore:!0}],["text/x-javascript",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.error",{alwaysSecure:!0,supportedByCore:!0}],["application/vnd.code.notebook.stdout",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}],["application/vnd.code.notebook.stderr",{alwaysSecure:!0,supportedByCore:!0,mergeable:!0}]]);function b(n){return T.get(n)?.alwaysSecure??!1}e.mimeTypeIsAlwaysSecure=b;function c(n){return T.get(n)?.supportedByCore??!1}e.mimeTypeSupportedByCore=c;function g(n){return T.get(n)?.mergeable??!1}e.mimeTypeIsMergeable=g;function S(n,m){return R.isWindows&&(n=n.replace(/\//g,"\\"),m=m.replace(/\//g,"\\")),h.match(n,m)}function i(n,m,D){let O=0;for(let $=0;$<m.length;$++){if(S(m[$],n))return O;O++}for(let $=0;$<D.length;$++){if(S(D[$],n))return O;O++}return O}function s(n,m,D){return n.sort((O,$)=>i(O,m,D)-i($,m,D))}e.sortMimeTypes=s;function u(n,m,D,O=($,Q)=>$===Q){const $=[];function Q(W,L,Y){if(L===0&&Y.length===0)return;const B=$[$.length-1];B&&B.start+B.deleteCount===W?(B.deleteCount+=L,B.toInsert.push(...Y)):$.push({start:W,deleteCount:L,toInsert:Y})}let ie=0,V=0;for(;;){if(ie===n.length){Q(ie,0,m.slice(V));break}if(V===m.length){Q(ie,n.length-ie,[]);break}const W=n[ie],L=m[V];if(O(W,L)){ie+=1,V+=1;continue}D(L)?(Q(ie,1,[]),ie+=1):(Q(ie,0,[L]),V+=1)}return $}e.diff=u,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new I.RawContextKey("notebookEditorCursorAtBoundary","none");var o;(function(n){n.default="default",n.option="option"})(o=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function f(n){const m=n;return!!((typeof m.include=="string"||h.isRelativePattern(m.include))&&(typeof m.exclude=="string"||h.isRelativePattern(m.exclude)))}e.isDocumentExcludePattern=f;function p(n,m,D){if(Array.isArray(n.viewType)&&n.viewType.indexOf(m)>=0||n.viewType===m)return!0;if(n.filenamePattern){let O=f(n.filenamePattern)?n.filenamePattern.include:n.filenamePattern,$=f(n.filenamePattern)?n.filenamePattern.exclude:void 0;if(h.match(O,(0,A.basename)(D.fsPath).toLowerCase()))return!($&&h.match($,(0,A.basename)(D.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=p;class w{constructor(m){this.textModel=m}getElements(){const m=new Int32Array(this.textModel.cells.length);for(let D=0;D<this.textModel.cells.length;D++)m[D]=this.textModel.cells[D].getHashValue();return m}}e.CellSequence=w,e.DisplayOrderKey="notebook.displayOrder",e.CellToolbarLocation="notebook.cellToolbarLocation",e.CellToolbarVisibility="notebook.cellToolbarVisibility",e.ShowCellStatusBar="notebook.showCellStatusBar",e.NotebookTextDiffEditorPreview="notebook.diff.enablePreview",e.ExperimentalInsertToolbarAlignment="notebook.experimental.insertToolbarAlignment",e.CompactView="notebook.compactView",e.FocusIndicator="notebook.cellFocusIndicator",e.InsertToolbarLocation="notebook.insertToolbarLocation",e.GlobalToolbar="notebook.globalToolbar",e.UndoRedoPerCell="notebook.undoRedoPerCell",e.ConsolidatedOutputButton="notebook.consolidatedOutputButton",e.ShowFoldingControls="notebook.showFoldingControls",e.DragAndDropEnabled="notebook.dragAndDropEnabled",e.NotebookCellEditorOptionsCustomizations="notebook.editorOptionsCustomizations",e.ConsolidatedRunButton="notebook.consolidatedRunButton",e.OpenGettingStarted="notebook.experimental.openGettingStarted",e.TextOutputLineLimit="notebook.output.textLineLimit",e.GlobalToolbarShowLabel="notebook.globalToolbarShowLabel";var C;(function(n){n[n.Left=1]="Left",n[n.Right=2]="Right"})(C=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class P{static create(m){return`${P._prefix}${m}`}static parse(m){if(m.startsWith(P._prefix))return m.substr(P._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=P,P._prefix="notebook/"}),define(be[163],Ee([0,1,4]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var F;(function(E){E[E.Output=1]="Output",E[E.OutputItems=2]="OutputItems",E[E.ExecutionState=3]="ExecutionState",E[E.Complete=4]="Complete"})(F=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,h.createDecorator)("INotebookExecutionService")}),define(be[164],Ee([0,1,134,4,42]),function(re,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USER_TASKS_GROUP_KEY=e.ITaskService=e.ProcessExecutionSupportedContext=e.ShellExecutionSupportedContext=e.CustomExecutionSupportedContext=void 0,e.CustomExecutionSupportedContext=new E.RawContextKey("customExecutionSupported",!0,h.localize(0,null)),e.ShellExecutionSupportedContext=new E.RawContextKey("shellExecutionSupported",!1,h.localize(1,null)),e.ProcessExecutionSupportedContext=new E.RawContextKey("processExecutionSupported",!1,h.localize(2,null)),e.ITaskService=(0,F.createDecorator)("taskService"),e.USER_TASKS_GROUP_KEY="settings"}),define(be[165],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function h(E){return[...E.entries()]}e.serializeEnvironmentVariableCollection=h;function F(E){return new Map(E)}e.deserializeEnvironmentVariableCollection=F}),define(be[90],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestDiffOpType=e.DetailType=e.applyTestItemUpdate=e.TestItemExpandState=e.TestMessageType=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var h;(function(_){_[_.Unset=0]="Unset",_[_.Queued=1]="Queued",_[_.Running=2]="Running",_[_.Passed=3]="Passed",_[_.Failed=4]="Failed",_[_.Skipped=5]="Skipped",_[_.Errored=6]="Errored"})(h=e.TestResultState||(e.TestResultState={}));var F;(function(_){_[_.Run=2]="Run",_[_.Debug=4]="Debug",_[_.Coverage=8]="Coverage",_[_.HasNonDefaultProfile=16]="HasNonDefaultProfile",_[_.HasConfigurable=32]="HasConfigurable"})(F=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var E;(function(_){_[_.Error=0]="Error",_[_.Info=1]="Info"})(E=e.TestMessageType||(e.TestMessageType={}));var A;(function(_){_[_.NotExpandable=0]="NotExpandable",_[_.Expandable=1]="Expandable",_[_.BusyExpanding=2]="BusyExpanding",_[_.Expanded=3]="Expanded"})(A=e.TestItemExpandState||(e.TestItemExpandState={}));const R=(_,r)=>{r.expand!==void 0&&(_.expand=r.expand),r.item!==void 0&&(_.item=_.item?Object.assign(_.item,r.item):r.item)};e.applyTestItemUpdate=R;var I;(function(_){_[_.Function=0]="Function",_[_.Statement=1]="Statement"})(I=e.DetailType||(e.DetailType={}));var y;(function(_){_[_.Add=0]="Add",_[_.Update=1]="Update",_[_.Remove=2]="Remove",_[_.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",_[_.Retire=4]="Retire"})(y=e.TestDiffOpType||(e.TestDiffOpType={}));class k{add(r){}update(r){}remove(r,d){}complete(){}}e.IncrementalChangeCollector=k;class t{constructor(){this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0}apply(r){const d=this.createChangeCollector();for(const a of r)switch(a[0]){case 0:{const l=a[1];if(l.parent){if(this.items.has(l.parent)){const v=this.items.get(l.parent);v.children.add(l.item.extId);const T=this.createItem(l,v);this.items.set(l.item.extId,T),d.add(T)}}else{const v=this.createItem(l);this.roots.add(v),this.items.set(l.item.extId,v),d.add(v)}l.expand===2&&this.busyControllerCount++;break}case 1:{const l=a[1],v=this.items.get(l.extId);if(!v)break;l.expand!==void 0&&(v.expand===2&&this.busyControllerCount--,l.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(v,l),d.update(v);break}case 2:{const l=this.items.get(a[1]);if(!l)break;l.parent?this.items.get(l.parent).children.delete(l.item.extId):this.roots.delete(l);const v=[[a[1]]];for(;v.length;)for(const T of v.pop()){const b=this.items.get(T);b&&(v.push(b.children),this.items.delete(T),d.remove(b,b!==l),b.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(a[1]);break;case 3:this.updatePendingRoots(a[1]);break}d.complete()}retireTest(r){}updatePendingRoots(r){this.pendingRootCount+=r}createChangeCollector(){return new k}}e.AbstractIncrementalTestCollection=t}),define(be[68],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var h;(function(A){A.Delimiter="\0"})(h=e.TestIdPathParts||(e.TestIdPathParts={}));var F;(function(A){A[A.IsSame=0]="IsSame",A[A.Disconnected=1]="Disconnected",A[A.IsChild=2]="IsChild",A[A.IsParent=3]="IsParent"})(F=e.TestPosition||(e.TestPosition={}));class E{constructor(R,I=R.length){if(this.path=R,this.viewEnd=I,R.length===0||I<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(R,I,y=R.parent){if(R.id===I)return new E([I]);let k=[R.id];for(let t=y;t&&t.id!==I;t=t.parent)k.push(t.id);return k.push(I),new E(k.reverse())}static isRoot(R){return!R.includes("\0")}static fromString(R){return new E(R.split("\0"))}static join(R,I){return new E([...R.path,I])}static joinToString(R,I){return R.toString()+"\0"+I}static compare(R,I){return R===I?0:I.startsWith(R+"\0")?2:R.startsWith(I+"\0")?3:1}get parentId(){return this.viewEnd>1?new E(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let R=1;R<=this.viewEnd;R++)yield new E(this.path,R)}compare(R){if(typeof R=="string")return E.compare(this.toString(),R);for(let I=0;I<R.viewEnd&&I<this.viewEnd;I++)if(R.path[I]!==this.path[I])return 1;return R.viewEnd>this.viewEnd?2:R.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let R=1;R<this.viewEnd;R++)this.stringifed+="\0",this.stringifed+=this.path[R]}return this.stringifed}}e.TestId=E}),define(be[166],Ee([0,1,17,91,10,22,26,77,135]),function(re,e,h,F,E,A,R,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class k{constructor(_,r,d){this._contributedVariables=new Map,this._context=_,this._labelService=r,d&&(this._envVariablesPromise=d.then(a=>this.prepareEnv(a)))}prepareEnv(_){if(R.isWindows){const r=Object.create(null);return Object.keys(_).forEach(d=>{r[d.toLowerCase()]=_[d]}),r}return _}resolveWithEnvironment(_,r,d){return this.recursiveResolve(this.prepareEnv(_),r?r.uri:void 0,d)}async resolveAsync(_,r){return this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,r)}async resolveAnyBase(_,r,d,a){const l=A.deepClone(r);return R.isWindows&&l.windows?Object.keys(l.windows).forEach(v=>l[v]=l.windows[v]):R.isMacintosh&&l.osx?Object.keys(l.osx).forEach(v=>l[v]=l.osx[v]):R.isLinux&&l.linux&&Object.keys(l.linux).forEach(v=>l[v]=l.linux[v]),delete l.windows,delete l.osx,delete l.linux,this.recursiveResolve(await this._envVariablesPromise,_?_.uri:void 0,l,d,a)}async resolveAnyAsync(_,r,d){return this.resolveAnyBase(_,r,d)}async resolveAnyMap(_,r,d){const a=new Map;return{newConfig:await this.resolveAnyBase(_,r,d,a),resolvedVariables:a}}resolveWithInteractionReplace(_,r,d,a){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(_,r,d,a){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(_,r){if(this._contributedVariables.has(_))throw new Error("Variable "+_+" is contributed twice.");this._contributedVariables.set(_,r)}recursiveResolve(_,r,d,a,l){if(E.isString(d))return this.resolveString(_,r,d,a,l);if(E.isArray(d))return d.map(v=>this.recursiveResolve(_,r,v,a,l));if(E.isObject(d)){let v=Object.create(null);return Object.keys(d).forEach(T=>{const b=this.resolveString(_,r,T,a,l);v[b]=this.recursiveResolve(_,r,d[T],a,l)}),v}return d}resolveString(_,r,d,a,l){return d.replace(k.VARIABLE_REGEXP,(T,b)=>{if(b.includes(k.VARIABLE_LHS))return T;let c=this.evaluateSingleVariable(_,T,b,r,a);return l&&l.set(b,c),c!==T&&E.isString(c)&&c.match(k.VARIABLE_REGEXP)&&(c=this.resolveString(_,r,c,a,l)),c})}fsPath(_){return this._labelService?this._labelService.getUriLabel(_,{noPrefix:!0}):_.fsPath}evaluateSingleVariable(_,r,d,a,l){let v;const T=d.split(":");T.length>1&&(d=T[0],v=T[1]);const b=()=>{const S=this._context.getFilePath();if(S)return S;throw new Error((0,y.localize)(0,null,r))},c=()=>{const S=b();if(this._context.getWorkspaceFolderPathForFile){const i=this._context.getWorkspaceFolderPathForFile();if(i)return i}throw new Error((0,y.localize)(1,null,r,h.basename(S)))},g=()=>{if(v){const S=this._context.getFolderUri(v);if(S)return S;throw new Error((0,y.localize)(2,null,r,v))}if(a)return a;throw this._context.getWorkspaceFolderCount()>1?new Error((0,y.localize)(3,null,r)):new Error((0,y.localize)(4,null,r))};switch(d){case"env":if(v){if(_){const S=_[R.isWindows?v.toLowerCase():v];if(E.isString(S))return S}return""}throw new Error((0,y.localize)(5,null,r));case"config":if(v){const S=this._context.getConfigurationValue(a,v);if(E.isUndefinedOrNull(S))throw new Error((0,y.localize)(6,null,r,v));if(E.isObject(S))throw new Error((0,y.localize)(7,null,r,v));return S}throw new Error((0,y.localize)(8,null,r));case"command":return this.resolveFromMap(r,v,l,"command");case"input":return this.resolveFromMap(r,v,l,"input");default:switch(d){case"workspaceRoot":case"workspaceFolder":return(0,I.normalizeDriveLetter)(this.fsPath(g()));case"cwd":return a||v?(0,I.normalizeDriveLetter)(this.fsPath(g())):F.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return h.basename(this.fsPath(g()));case"lineNumber":const S=this._context.getLineNumber();if(S)return S;throw new Error((0,y.localize)(9,null,r));case"selectedText":const i=this._context.getSelectedText();if(i)return i;throw new Error((0,y.localize)(10,null,r));case"file":return b();case"fileWorkspaceFolder":return c();case"relativeFile":return a||v?h.relative(this.fsPath(g()),b()):b();case"relativeFileDirname":const s=h.dirname(b());if(a||v){const p=h.relative(this.fsPath(g()),s);return p.length===0?".":p}return s;case"fileDirname":return h.dirname(b());case"fileExtname":return h.extname(b());case"fileBasename":return h.basename(b());case"fileBasenameNoExtension":const u=h.basename(b());return u.slice(0,u.length-h.extname(u).length);case"fileDirnameBasename":return h.basename(h.dirname(b()));case"execPath":const o=this._context.getExecPath();return o||r;case"execInstallFolder":const f=this._context.getAppRoot();return f||r;case"pathSeparator":return h.sep;default:try{const p=v?`${d}:${v}`:d;return this.resolveFromMap(r,p,l,void 0)}catch(p){return r}}}}resolveFromMap(_,r,d,a){if(r&&d){const l=a===void 0?d[r]:d[a+":"+r];if(typeof l=="string")return l;throw new Error((0,y.localize)(11,null,_))}return _}}e.AbstractVariableResolverService=k,k.VARIABLE_LHS="${",k.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(be[92],Ee([0,1,4,159]),function(re,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupChangeKind=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,h.createDecorator)("editorGroupsService");var E;(function(l){l[l.UP=0]="UP",l[l.DOWN=1]="DOWN",l[l.LEFT=2]="LEFT",l[l.RIGHT=3]="RIGHT"})(E=e.GroupDirection||(e.GroupDirection={}));var A;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(A=e.GroupOrientation||(e.GroupOrientation={}));var R;(function(l){l[l.FIRST=0]="FIRST",l[l.LAST=1]="LAST",l[l.NEXT=2]="NEXT",l[l.PREVIOUS=3]="PREVIOUS"})(R=e.GroupLocation||(e.GroupLocation={}));var I;(function(l){l[l.MINIMIZE_OTHERS=0]="MINIMIZE_OTHERS",l[l.EVEN=1]="EVEN",l[l.TOGGLE=2]="TOGGLE"})(I=e.GroupsArrangement||(e.GroupsArrangement={}));var y;(function(l){l[l.COPY_EDITORS=0]="COPY_EDITORS",l[l.MOVE_EDITORS=1]="MOVE_EDITORS"})(y=e.MergeGroupMode||(e.MergeGroupMode={}));function k(l){const v=l;return(0,F.isEditorInput)(v?.editor)&&(0,F.isEditorInput)(v?.replacement)}e.isEditorReplacement=k;var t;(function(l){l[l.CREATION_TIME=0]="CREATION_TIME",l[l.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",l[l.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(t=e.GroupsOrder||(e.GroupsOrder={}));var _;(function(l){l[l.GROUP_ACTIVE=0]="GROUP_ACTIVE",l[l.GROUP_INDEX=1]="GROUP_INDEX",l[l.EDITOR_OPEN=2]="EDITOR_OPEN",l[l.EDITOR_CLOSE=3]="EDITOR_CLOSE",l[l.EDITOR_MOVE=4]="EDITOR_MOVE",l[l.EDITOR_ACTIVE=5]="EDITOR_ACTIVE",l[l.EDITOR_LABEL=6]="EDITOR_LABEL",l[l.EDITOR_CAPABILITIES=7]="EDITOR_CAPABILITIES",l[l.EDITOR_PIN=8]="EDITOR_PIN",l[l.EDITOR_STICKY=9]="EDITOR_STICKY",l[l.EDITOR_DIRTY=10]="EDITOR_DIRTY"})(_=e.GroupChangeKind||(e.GroupChangeKind={}));var r;(function(l){l[l.NEW_EDITOR=1]="NEW_EDITOR",l[l.MOVE_EDITOR=2]="MOVE_EDITOR",l[l.COPY_EDITOR=3]="COPY_EDITOR"})(r=e.OpenEditorContext||(e.OpenEditorContext={}));function d(l){const v=l;return!!v&&typeof v.id=="number"&&Array.isArray(v.editors)}e.isEditorGroup=d;function a(l){return l.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=a}),define(be[167],Ee([0,1,4,92]),function(re,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,h.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function E(A){const R=A;return typeof A=="number"||(0,F.isEditorGroup)(R)}e.isPreferredGroup=E}),define(be[8],Ee([0,1,16,23,76,229,53,22,10,2,41,58,136,82,64,89,68,167,6]),function(re,e,h,F,E,A,R,I,y,k,t,_,r,d,a,l,v,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookDecorationRenderOptions=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.Position=e.TokenType=e.Range=e.Selection=void 0;var c;(function(te){function pe(U){const{selectionStartLineNumber:De,selectionStartColumn:Se,positionLineNumber:qe,positionColumn:ze}=U,it=new b.Position(De-1,Se-1),vt=new b.Position(qe-1,ze-1);return new b.Selection(it,vt)}te.to=pe;function oe(U){const{anchor:De,active:Se}=U;return{selectionStartLineNumber:De.line+1,selectionStartColumn:De.character+1,positionLineNumber:Se.line+1,positionColumn:Se.character+1}}te.from=oe})(c=e.Selection||(e.Selection={}));var g;(function(te){function pe(U){if(!U)return;const{start:De,end:Se}=U;return{startLineNumber:De.line+1,startColumn:De.character+1,endLineNumber:Se.line+1,endColumn:Se.character+1}}te.from=pe;function oe(U){if(!U)return;const{startLineNumber:De,startColumn:Se,endLineNumber:qe,endColumn:ze}=U;return new b.Range(De-1,Se-1,qe-1,ze-1)}te.to=oe})(g=e.Range||(e.Range={}));var S;(function(te){function pe(oe){switch(oe){case 1:return b.StandardTokenType.Comment;case 0:return b.StandardTokenType.Other;case 4:return b.StandardTokenType.RegEx;case 2:return b.StandardTokenType.String}}te.to=pe})(S=e.TokenType||(e.TokenType={}));var i;(function(te){function pe(U){return new b.Position(U.lineNumber-1,U.column-1)}te.to=pe;function oe(U){return{lineNumber:U.line+1,column:U.character+1}}te.from=oe})(i=e.Position||(e.Position={}));var s;(function(te){function pe(U){switch(U){case b.DiagnosticTag.Unnecessary:return 1;case b.DiagnosticTag.Deprecated:return 2}}te.from=pe;function oe(U){switch(U){case 1:return b.DiagnosticTag.Unnecessary;case 2:return b.DiagnosticTag.Deprecated;default:return}}te.to=oe})(s=e.DiagnosticTag||(e.DiagnosticTag={}));var u;(function(te){function pe(U){let De;return U.code&&((0,y.isString)(U.code)||(0,y.isNumber)(U.code)?De=String(U.code):De={value:String(U.code.value),target:U.code.target}),{...g.from(U.range),message:U.message,source:U.source,code:De,severity:f.from(U.severity),relatedInformation:U.relatedInformation&&U.relatedInformation.map(o.from),tags:Array.isArray(U.tags)?(0,h.coalesce)(U.tags.map(s.from)):void 0}}te.from=pe;function oe(U){const De=new b.Diagnostic(g.to(U),U.message,f.to(U.severity));return De.source=U.source,De.code=(0,y.isString)(U.code)?U.code:U.code?.value,De.relatedInformation=U.relatedInformation&&U.relatedInformation.map(o.to),De.tags=U.tags&&(0,h.coalesce)(U.tags.map(s.to)),De}te.to=oe})(u=e.Diagnostic||(e.Diagnostic={}));var o;(function(te){function pe(U){return{...g.from(U.location.range),message:U.message,resource:U.location.uri}}te.from=pe;function oe(U){return new b.DiagnosticRelatedInformation(new b.Location(U.resource,g.to(U)),U.message)}te.to=oe})(o=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var f;(function(te){function pe(U){switch(U){case b.DiagnosticSeverity.Error:return d.MarkerSeverity.Error;case b.DiagnosticSeverity.Warning:return d.MarkerSeverity.Warning;case b.DiagnosticSeverity.Information:return d.MarkerSeverity.Info;case b.DiagnosticSeverity.Hint:return d.MarkerSeverity.Hint}return d.MarkerSeverity.Error}te.from=pe;function oe(U){switch(U){case d.MarkerSeverity.Info:return b.DiagnosticSeverity.Information;case d.MarkerSeverity.Warning:return b.DiagnosticSeverity.Warning;case d.MarkerSeverity.Error:return b.DiagnosticSeverity.Error;case d.MarkerSeverity.Hint:return b.DiagnosticSeverity.Hint;default:return b.DiagnosticSeverity.Error}}te.to=oe})(f=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var p;(function(te){function pe(U){return typeof U=="number"&&U>=b.ViewColumn.One?U-1:U===b.ViewColumn.Beside?T.SIDE_GROUP:T.ACTIVE_GROUP}te.from=pe;function oe(U){if(typeof U=="number"&&U>=0)return U+1;throw new Error("invalid 'EditorGroupColumn'")}te.to=oe})(p=e.ViewColumn||(e.ViewColumn={}));function w(te){return typeof te.range!="undefined"}function C(te){return te.length===0?!0:!!w(te[0])}e.isDecorationOptionsArr=C;var P;(function(te){function pe(ze){return ze.map(te.from)}te.fromMany=pe;function oe(ze){return ze&&typeof ze=="object"&&typeof ze.language=="string"&&typeof ze.value=="string"}function U(ze){let it;if(oe(ze)){const{language:st,value:ut}=ze;it={value:"```"+st+`
`+ut+"\n```\n"}}else b.MarkdownString.isMarkdownString(ze)?it={value:ze.value,isTrusted:ze.isTrusted,supportThemeIcons:ze.supportThemeIcons}:typeof ze=="string"?it={value:ze}:it={value:""};const vt=Object.create(null);it.uris=vt;const ht=st=>{try{let ut=k.URI.parse(st,!0);ut=ut.with({query:De(ut.query,vt)}),vt[st]=ut}catch(ut){}return""},ot=new A.Renderer;return ot.link=ht,ot.image=st=>ht(E.parseHrefAndDimensions(st).href),A(it.value,{renderer:ot}),it}te.from=U;function De(ze,it){if(!ze)return ze;let vt;try{vt=(0,R.parse)(ze)}catch(ot){}if(!vt)return ze;let ht=!1;return vt=(0,I.cloneAndChange)(vt,ot=>{if(k.URI.isUri(ot)){const st=`__uri_${Math.random().toString(16).slice(2,8)}`;return it[st]=ot,ht=!0,st}else return}),ht?JSON.stringify(vt):ze}function Se(ze){const it=new b.MarkdownString(ze.value,ze.supportThemeIcons);return it.isTrusted=ze.isTrusted,it}te.to=Se;function qe(ze){if(!!ze)return typeof ze=="string"?ze:te.from(ze)}te.fromStrict=qe})(P=e.MarkdownString||(e.MarkdownString={}));function n(te){return C(te)?te.map(pe=>({range:g.from(pe.range),hoverMessage:Array.isArray(pe.hoverMessage)?P.fromMany(pe.hoverMessage):pe.hoverMessage?P.from(pe.hoverMessage):void 0,renderOptions:pe.renderOptions})):te.map(pe=>({range:g.from(pe)}))}e.fromRangeOrRangeWithMessage=n;function m(te){return typeof te=="undefined"?te:typeof te=="string"?k.URI.file(te):te}e.pathOrURIToURI=m;var D;(function(te){function pe(oe){return typeof oe=="undefined"?oe:{contentText:oe.contentText,contentIconPath:oe.contentIconPath?m(oe.contentIconPath):void 0,border:oe.border,borderColor:oe.borderColor,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,color:oe.color,backgroundColor:oe.backgroundColor,margin:oe.margin,width:oe.width,height:oe.height}}te.from=pe})(D=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var O;(function(te){function pe(oe){return typeof oe=="undefined"?oe:{backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?m(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?D.from(oe.before):void 0,after:oe.after?D.from(oe.after):void 0}}te.from=pe})(O=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var $;(function(te){function pe(oe){if(typeof oe=="undefined")return oe;switch(oe){case b.DecorationRangeBehavior.OpenOpen:return 0;case b.DecorationRangeBehavior.ClosedClosed:return 1;case b.DecorationRangeBehavior.OpenClosed:return 2;case b.DecorationRangeBehavior.ClosedOpen:return 3}}te.from=pe})($=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var Q;(function(te){function pe(oe){return{isWholeLine:oe.isWholeLine,rangeBehavior:oe.rangeBehavior?$.from(oe.rangeBehavior):void 0,overviewRulerLane:oe.overviewRulerLane,light:oe.light?O.from(oe.light):void 0,dark:oe.dark?O.from(oe.dark):void 0,backgroundColor:oe.backgroundColor,outline:oe.outline,outlineColor:oe.outlineColor,outlineStyle:oe.outlineStyle,outlineWidth:oe.outlineWidth,border:oe.border,borderColor:oe.borderColor,borderRadius:oe.borderRadius,borderSpacing:oe.borderSpacing,borderStyle:oe.borderStyle,borderWidth:oe.borderWidth,fontStyle:oe.fontStyle,fontWeight:oe.fontWeight,textDecoration:oe.textDecoration,cursor:oe.cursor,color:oe.color,opacity:oe.opacity,letterSpacing:oe.letterSpacing,gutterIconPath:oe.gutterIconPath?m(oe.gutterIconPath):void 0,gutterIconSize:oe.gutterIconSize,overviewRulerColor:oe.overviewRulerColor,before:oe.before?D.from(oe.before):void 0,after:oe.after?D.from(oe.after):void 0}}te.from=pe})(Q=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var ie;(function(te){function pe(U){return{text:U.newText,eol:U.newEol&&he.from(U.newEol),range:g.from(U.range)}}te.from=pe;function oe(U){const De=new b.TextEdit(g.to(U.range),U.text);return De.newEol=typeof U.eol=="undefined"?void 0:he.to(U.eol),De}te.to=oe})(ie=e.TextEdit||(e.TextEdit={}));var V;(function(te){function pe(U,De,Se){const qe={edits:[]};if(U instanceof b.WorkspaceEdit)for(let ze of U._allEntries())if(ze._type===1)qe.edits.push({_type:1,oldUri:ze.from,newUri:ze.to,options:ze.options,metadata:ze.metadata});else if(ze._type===2){const it=De?.getDocument(ze.uri);qe.edits.push({_type:2,resource:ze.uri,edit:ie.from(ze.edit),modelVersionId:it?.version,metadata:ze.metadata})}else ze._type===3?qe.edits.push({_type:3,metadata:ze.metadata,resource:ze.uri,edit:ze.edit,notebookMetadata:ze.notebookMetadata,notebookVersionId:Se?.getNotebookDocument(ze.uri,!0)?.apiNotebook.version}):ze._type===5&&qe.edits.push({_type:3,metadata:ze.metadata,resource:ze.uri,notebookVersionId:Se?.getNotebookDocument(ze.uri,!0)?.apiNotebook.version,edit:{editType:1,index:ze.index,count:ze.count,cells:ze.cells.map(Et.from)}});return qe}te.from=pe;function oe(U){const De=new b.WorkspaceEdit;for(const Se of U.edits)Se.edit?De.replace(k.URI.revive(Se.resource),g.to(Se.edit.range),Se.edit.text):De.renameFile(k.URI.revive(Se.oldUri),k.URI.revive(Se.newUri),Se.options);return De}te.to=oe})(V=e.WorkspaceEdit||(e.WorkspaceEdit={}));var W;(function(te){const pe=Object.create(null);pe[b.SymbolKind.File]=0,pe[b.SymbolKind.Module]=1,pe[b.SymbolKind.Namespace]=2,pe[b.SymbolKind.Package]=3,pe[b.SymbolKind.Class]=4,pe[b.SymbolKind.Method]=5,pe[b.SymbolKind.Property]=6,pe[b.SymbolKind.Field]=7,pe[b.SymbolKind.Constructor]=8,pe[b.SymbolKind.Enum]=9,pe[b.SymbolKind.Interface]=10,pe[b.SymbolKind.Function]=11,pe[b.SymbolKind.Variable]=12,pe[b.SymbolKind.Constant]=13,pe[b.SymbolKind.String]=14,pe[b.SymbolKind.Number]=15,pe[b.SymbolKind.Boolean]=16,pe[b.SymbolKind.Array]=17,pe[b.SymbolKind.Object]=18,pe[b.SymbolKind.Key]=19,pe[b.SymbolKind.Null]=20,pe[b.SymbolKind.EnumMember]=21,pe[b.SymbolKind.Struct]=22,pe[b.SymbolKind.Event]=23,pe[b.SymbolKind.Operator]=24,pe[b.SymbolKind.TypeParameter]=25;function oe(De){return typeof pe[De]=="number"?pe[De]:6}te.from=oe;function U(De){for(const Se in pe)if(pe[Se]===De)return Number(Se);return b.SymbolKind.Property}te.to=U})(W=e.SymbolKind||(e.SymbolKind={}));var L;(function(te){function pe(U){switch(U){case b.SymbolTag.Deprecated:return 1}}te.from=pe;function oe(U){switch(U){case 1:return b.SymbolTag.Deprecated}}te.to=oe})(L=e.SymbolTag||(e.SymbolTag={}));var Y;(function(te){function pe(U){return{name:U.name,kind:W.from(U.kind),tags:U.tags&&U.tags.map(L.from),containerName:U.containerName,location:le.from(U.location)}}te.from=pe;function oe(U){const De=new b.SymbolInformation(U.name,W.to(U.kind),U.containerName,le.to(U.location));return De.tags=U.tags&&U.tags.map(L.to),De}te.to=oe})(Y=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var B;(function(te){function pe(U){const De={name:U.name||"!!MISSING: name!!",detail:U.detail,range:g.from(U.range),selectionRange:g.from(U.selectionRange),kind:W.from(U.kind),tags:U.tags?.map(L.from)??[]};return U.children&&(De.children=U.children.map(pe)),De}te.from=pe;function oe(U){const De=new b.DocumentSymbol(U.name,U.detail,W.to(U.kind),g.to(U.range),g.to(U.selectionRange));return(0,h.isNonEmptyArray)(U.tags)&&(De.tags=U.tags.map(L.to)),U.children&&(De.children=U.children.map(oe)),De}te.to=oe})(B=e.DocumentSymbol||(e.DocumentSymbol={}));var G;(function(te){function pe(U){const De=new b.CallHierarchyItem(W.to(U.kind),U.name,U.detail||"",k.URI.revive(U.uri),g.to(U.range),g.to(U.selectionRange));return De._sessionId=U._sessionId,De._itemId=U._itemId,De}te.to=pe;function oe(U,De,Se){if(De=De??U._sessionId,Se=Se??U._itemId,De===void 0||Se===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Se,name:U.name,detail:U.detail,kind:W.from(U.kind),uri:U.uri,range:g.from(U.range),selectionRange:g.from(U.selectionRange),tags:U.tags?.map(L.from)}}te.from=oe})(G=e.CallHierarchyItem||(e.CallHierarchyItem={}));var de;(function(te){function pe(oe){return new b.CallHierarchyIncomingCall(G.to(oe.from),oe.fromRanges.map(U=>g.to(U)))}te.to=pe})(de=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var j;(function(te){function pe(oe){return new b.CallHierarchyOutgoingCall(G.to(oe.to),oe.fromRanges.map(U=>g.to(U)))}te.to=pe})(j=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var le;(function(te){function pe(U){return{range:U.range&&g.from(U.range),uri:U.uri}}te.from=pe;function oe(U){return new b.Location(k.URI.revive(U.uri),g.to(U.range))}te.to=oe})(le=e.location||(e.location={}));var ae;(function(te){function pe(U){const De=U,Se=U;return{originSelectionRange:De.originSelectionRange?g.from(De.originSelectionRange):void 0,uri:De.targetUri?De.targetUri:Se.uri,range:g.from(De.targetRange?De.targetRange:Se.range),targetSelectionRange:De.targetSelectionRange?g.from(De.targetSelectionRange):void 0}}te.from=pe;function oe(U){return{targetUri:k.URI.revive(U.uri),targetRange:g.to(U.range),targetSelectionRange:U.targetSelectionRange?g.to(U.targetSelectionRange):void 0,originSelectionRange:U.originSelectionRange?g.to(U.originSelectionRange):void 0}}te.to=oe})(ae=e.DefinitionLink||(e.DefinitionLink={}));var ve;(function(te){function pe(U){return{range:g.from(U.range),contents:P.fromMany(U.contents)}}te.from=pe;function oe(U){return new b.Hover(U.contents.map(P.to),g.to(U.range))}te.to=oe})(ve=e.Hover||(e.Hover={}));var Re;(function(te){function pe(U){return{range:g.from(U.range),expression:U.expression}}te.from=pe;function oe(U){return new b.EvaluatableExpression(g.to(U.range),U.expression)}te.to=oe})(Re=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Fe;(function(te){function pe(U){if(U instanceof b.InlineValueText)return{type:"text",range:g.from(U.range),text:U.text};if(U instanceof b.InlineValueVariableLookup)return{type:"variable",range:g.from(U.range),variableName:U.variableName,caseSensitiveLookup:U.caseSensitiveLookup};if(U instanceof b.InlineValueEvaluatableExpression)return{type:"expression",range:g.from(U.range),expression:U.expression};throw new Error("Unknown 'InlineValue' type")}te.from=pe;function oe(U){switch(U.type){case"text":return{range:g.to(U.range),text:U.text};case"variable":return{range:g.to(U.range),variableName:U.variableName,caseSensitiveLookup:U.caseSensitiveLookup};case"expression":return{range:g.to(U.range),expression:U.expression}}}te.to=oe})(Fe=e.InlineValue||(e.InlineValue={}));var Ne;(function(te){function pe(U){return{frameId:U.frameId,stoppedLocation:g.from(U.stoppedLocation)}}te.from=pe;function oe(U){return new b.InlineValueContext(U.frameId,g.to(U.stoppedLocation))}te.to=oe})(Ne=e.InlineValueContext||(e.InlineValueContext={}));var Qe;(function(te){function pe(U){return{range:g.from(U.range),kind:U.kind}}te.from=pe;function oe(U){return new b.DocumentHighlight(g.to(U.range),U.kind)}te.to=oe})(Qe=e.DocumentHighlight||(e.DocumentHighlight={}));var He;(function(te){function pe(oe){switch(oe){case 1:return b.CompletionTriggerKind.TriggerCharacter;case 2:return b.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return b.CompletionTriggerKind.Invoke}}te.to=pe})(He=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ke;(function(te){function pe(oe){return{triggerKind:He.to(oe.triggerKind),triggerCharacter:oe.triggerCharacter}}te.to=pe})(Ke=e.CompletionContext||(e.CompletionContext={}));var x;(function(te){function pe(U){switch(U){case b.CompletionItemTag.Deprecated:return 1}}te.from=pe;function oe(U){switch(U){case 1:return b.CompletionItemTag.Deprecated}}te.to=oe})(x=e.CompletionItemTag||(e.CompletionItemTag={}));var q;(function(te){const pe=new Map([[b.CompletionItemKind.Method,0],[b.CompletionItemKind.Function,1],[b.CompletionItemKind.Constructor,2],[b.CompletionItemKind.Field,3],[b.CompletionItemKind.Variable,4],[b.CompletionItemKind.Class,5],[b.CompletionItemKind.Interface,7],[b.CompletionItemKind.Struct,6],[b.CompletionItemKind.Module,8],[b.CompletionItemKind.Property,9],[b.CompletionItemKind.Unit,12],[b.CompletionItemKind.Value,13],[b.CompletionItemKind.Constant,14],[b.CompletionItemKind.Enum,15],[b.CompletionItemKind.EnumMember,16],[b.CompletionItemKind.Keyword,17],[b.CompletionItemKind.Snippet,27],[b.CompletionItemKind.Text,18],[b.CompletionItemKind.Color,19],[b.CompletionItemKind.File,20],[b.CompletionItemKind.Reference,21],[b.CompletionItemKind.Folder,23],[b.CompletionItemKind.Event,10],[b.CompletionItemKind.Operator,11],[b.CompletionItemKind.TypeParameter,24],[b.CompletionItemKind.Issue,26],[b.CompletionItemKind.User,25]]);function oe(Se){return pe.get(Se)??9}te.from=oe;const U=new Map([[0,b.CompletionItemKind.Method],[1,b.CompletionItemKind.Function],[2,b.CompletionItemKind.Constructor],[3,b.CompletionItemKind.Field],[4,b.CompletionItemKind.Variable],[5,b.CompletionItemKind.Class],[7,b.CompletionItemKind.Interface],[6,b.CompletionItemKind.Struct],[8,b.CompletionItemKind.Module],[9,b.CompletionItemKind.Property],[12,b.CompletionItemKind.Unit],[13,b.CompletionItemKind.Value],[14,b.CompletionItemKind.Constant],[15,b.CompletionItemKind.Enum],[16,b.CompletionItemKind.EnumMember],[17,b.CompletionItemKind.Keyword],[27,b.CompletionItemKind.Snippet],[18,b.CompletionItemKind.Text],[19,b.CompletionItemKind.Color],[20,b.CompletionItemKind.File],[21,b.CompletionItemKind.Reference],[23,b.CompletionItemKind.Folder],[10,b.CompletionItemKind.Event],[11,b.CompletionItemKind.Operator],[24,b.CompletionItemKind.TypeParameter],[25,b.CompletionItemKind.User],[26,b.CompletionItemKind.Issue]]);function De(Se){return U.get(Se)??b.CompletionItemKind.Property}te.to=De})(q=e.CompletionItemKind||(e.CompletionItemKind={}));var Z;(function(te){function pe(oe,U){const De=new b.CompletionItem(oe.label);return De.insertText=oe.insertText,De.kind=q.to(oe.kind),De.tags=oe.tags?.map(x.to),De.detail=oe.detail,De.documentation=E.isMarkdownString(oe.documentation)?P.to(oe.documentation):oe.documentation,De.sortText=oe.sortText,De.filterText=oe.filterText,De.preselect=oe.preselect,De.commitCharacters=oe.commitCharacters,t.Range.isIRange(oe.range)?De.range=g.to(oe.range):typeof oe.range=="object"&&(De.range={inserting:g.to(oe.range.insert),replacing:g.to(oe.range.replace)}),De.keepWhitespace=typeof oe.insertTextRules=="undefined"?!1:Boolean(oe.insertTextRules&1),typeof oe.insertTextRules!="undefined"&&oe.insertTextRules&4?De.insertText=new b.SnippetString(oe.insertText):(De.insertText=oe.insertText,De.textEdit=De.range instanceof b.Range?new b.TextEdit(De.range,De.insertText):void 0),oe.additionalTextEdits&&oe.additionalTextEdits.length>0&&(De.additionalTextEdits=oe.additionalTextEdits.map(Se=>ie.to(Se))),De.command=U&&oe.command?U.fromInternal(oe.command):void 0,De}te.to=pe})(Z=e.CompletionItem||(e.CompletionItem={}));var se;(function(te){function pe(U){return{label:U.label,documentation:U.documentation?P.fromStrict(U.documentation):void 0}}te.from=pe;function oe(U){return{label:U.label,documentation:E.isMarkdownString(U.documentation)?P.to(U.documentation):U.documentation}}te.to=oe})(se=e.ParameterInformation||(e.ParameterInformation={}));var H;(function(te){function pe(U){return{label:U.label,documentation:U.documentation?P.fromStrict(U.documentation):void 0,parameters:Array.isArray(U.parameters)?U.parameters.map(se.from):[],activeParameter:U.activeParameter}}te.from=pe;function oe(U){return{label:U.label,documentation:E.isMarkdownString(U.documentation)?P.to(U.documentation):U.documentation,parameters:Array.isArray(U.parameters)?U.parameters.map(se.to):[],activeParameter:U.activeParameter}}te.to=oe})(H=e.SignatureInformation||(e.SignatureInformation={}));var ne;(function(te){function pe(U){return{activeSignature:U.activeSignature,activeParameter:U.activeParameter,signatures:Array.isArray(U.signatures)?U.signatures.map(H.from):[]}}te.from=pe;function oe(U){return{activeSignature:U.activeSignature,activeParameter:U.activeParameter,signatures:Array.isArray(U.signatures)?U.signatures.map(H.to):[]}}te.to=oe})(ne=e.SignatureHelp||(e.SignatureHelp={}));var fe;(function(te){function pe(U){return{text:U.text,position:i.from(U.position),kind:Te.from(U.kind??b.InlayHintKind.Other),whitespaceBefore:U.whitespaceBefore,whitespaceAfter:U.whitespaceAfter}}te.from=pe;function oe(U){const De=new b.InlayHint(U.text,i.to(U.position),Te.to(U.kind));return De.whitespaceAfter=U.whitespaceAfter,De.whitespaceBefore=U.whitespaceBefore,De}te.to=oe})(fe=e.InlayHint||(e.InlayHint={}));var Te;(function(te){function pe(U){return U}te.from=pe;function oe(U){return U}te.to=oe})(Te=e.InlayHintKind||(e.InlayHintKind={}));var xe;(function(te){function pe(U){return{range:g.from(U.range),url:U.target,tooltip:U.tooltip}}te.from=pe;function oe(U){let De;if(U.url)try{De=typeof U.url=="string"?k.URI.parse(U.url,!0):k.URI.revive(U.url)}catch(Se){}return new b.DocumentLink(g.to(U.range),De)}te.to=oe})(xe=e.DocumentLink||(e.DocumentLink={}));var $e;(function(te){function pe(U){const De=new b.ColorPresentation(U.label);return U.textEdit&&(De.textEdit=ie.to(U.textEdit)),U.additionalTextEdits&&(De.additionalTextEdits=U.additionalTextEdits.map(Se=>ie.to(Se))),De}te.to=pe;function oe(U){return{label:U.label,textEdit:U.textEdit?ie.from(U.textEdit):void 0,additionalTextEdits:U.additionalTextEdits?U.additionalTextEdits.map(De=>ie.from(De)):void 0}}te.from=oe})($e=e.ColorPresentation||(e.ColorPresentation={}));var we;(function(te){function pe(U){return new b.Color(U[0],U[1],U[2],U[3])}te.to=pe;function oe(U){return[U.red,U.green,U.blue,U.alpha]}te.from=oe})(we=e.Color||(e.Color={}));var Xe;(function(te){function pe(U){return{range:g.from(U.range)}}te.from=pe;function oe(U){return new b.SelectionRange(g.to(U.range))}te.to=oe})(Xe=e.SelectionRange||(e.SelectionRange={}));var z;(function(te){function pe(oe){switch(oe){case 2:return b.TextDocumentSaveReason.AfterDelay;case 1:return b.TextDocumentSaveReason.Manual;case 3:case 4:return b.TextDocumentSaveReason.FocusOut}}te.to=pe})(z=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var K;(function(te){function pe(U){switch(U){case b.TextEditorLineNumbersStyle.Off:return 0;case b.TextEditorLineNumbersStyle.Relative:return 2;case b.TextEditorLineNumbersStyle.On:default:return 1}}te.from=pe;function oe(U){switch(U){case 0:return b.TextEditorLineNumbersStyle.Off;case 2:return b.TextEditorLineNumbersStyle.Relative;case 1:default:return b.TextEditorLineNumbersStyle.On}}te.to=oe})(K=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var he;(function(te){function pe(U){if(U===b.EndOfLine.CRLF)return 1;if(U===b.EndOfLine.LF)return 0}te.from=pe;function oe(U){if(U===1)return b.EndOfLine.CRLF;if(U===0)return b.EndOfLine.LF}te.to=oe})(he=e.EndOfLine||(e.EndOfLine={}));var Le;(function(te){function pe(oe){if(typeof oe=="object")return oe.viewId;switch(oe){case b.ProgressLocation.SourceControl:return 3;case b.ProgressLocation.Window:return 10;case b.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}te.from=pe})(Le=e.ProgressLocation||(e.ProgressLocation={}));var Ve;(function(te){function pe(oe){const U={start:oe.start+1,end:oe.end+1};return oe.kind&&(U.kind=tt.from(oe.kind)),U}te.from=pe})(Ve=e.FoldingRange||(e.FoldingRange={}));var tt;(function(te){function pe(oe){if(oe)switch(oe){case b.FoldingRangeKind.Comment:return _.FoldingRangeKind.Comment;case b.FoldingRangeKind.Imports:return _.FoldingRangeKind.Imports;case b.FoldingRangeKind.Region:return _.FoldingRangeKind.Region}}te.from=pe})(tt=e.FoldingRangeKind||(e.FoldingRangeKind={}));var lt;(function(te){function pe(oe){if(oe)return{pinned:typeof oe.preview=="boolean"?!oe.preview:void 0,inactive:oe.background,preserveFocus:oe.preserveFocus,selection:typeof oe.selection=="object"?g.from(oe.selection):void 0,override:typeof oe.override=="boolean"?r.EditorResolution.DISABLED:void 0}}te.from=pe})(lt=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var ft;(function(te){function pe(U){return U instanceof b.RelativePattern||typeof U=="string"?U:oe(U)?new b.RelativePattern(U.base,U.pattern):U}te.from=pe;function oe(U){const De=U;return De&&typeof De.base=="string"&&typeof De.pattern=="string"}})(ft=e.GlobPattern||(e.GlobPattern={}));var St;(function(te){function pe(oe){if(oe){if(Array.isArray(oe))return oe.map(pe);if(typeof oe=="string")return oe;{const U=oe;return{language:U.language,scheme:U.scheme,pattern:typeof U.pattern=="undefined"?void 0:ft.from(U.pattern),exclusive:U.exclusive}}}else return}te.from=pe})(St=e.LanguageSelector||(e.LanguageSelector={}));var Pt;(function(te){function pe(U){return{start:U.start,end:U.end}}te.from=pe;function oe(U){return new b.NotebookRange(U.start,U.end)}te.to=oe})(Pt=e.NotebookRange||(e.NotebookRange={}));var dt;(function(te){function pe(U){return{timing:typeof U.runStartTime=="number"&&typeof U.runEndTime=="number"?{startTime:U.runStartTime,endTime:U.runEndTime}:void 0,executionOrder:U.executionOrder,success:U.lastRunSuccess}}te.to=pe;function oe(U){return{lastRunSuccess:U.success,runStartTime:U.timing?.startTime,runEndTime:U.timing?.endTime,executionOrder:U.executionOrder}}te.from=oe})(dt=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var bt;(function(te){function pe(U){switch(U){case b.NotebookCellKind.Markup:return l.CellKind.Markup;case b.NotebookCellKind.Code:default:return l.CellKind.Code}}te.from=pe;function oe(U){switch(U){case l.CellKind.Markup:return b.NotebookCellKind.Markup;case l.CellKind.Code:default:return b.NotebookCellKind.Code}}te.to=oe})(bt=e.NotebookCellKind||(e.NotebookCellKind={}));var mt;(function(te){function pe(U){const De={metadata:U.metadata??Object.create(null),cells:[]};for(let Se of U.cells)b.NotebookCellData.validate(Se),De.cells.push(Et.from(Se));return De}te.from=pe;function oe(U){const De=new b.NotebookData(U.cells.map(Et.to));return(0,y.isEmptyObject)(U.metadata)||(De.metadata=U.metadata),De}te.to=oe})(mt=e.NotebookData||(e.NotebookData={}));var Et;(function(te){function pe(U){return{cellKind:bt.from(U.kind),language:U.languageId,mime:U.mime,source:U.value,metadata:U.metadata,internalMetadata:dt.from(U.executionSummary??{}),outputs:U.outputs?U.outputs.map(Ct.from):[]}}te.from=pe;function oe(U){return new b.NotebookCellData(bt.to(U.cellKind),U.source,U.language,U.mime,U.outputs?U.outputs.map(Ct.to):void 0,U.metadata,U.internalMetadata?dt.to(U.internalMetadata):void 0)}te.to=oe})(Et=e.NotebookCellData||(e.NotebookCellData={}));var Ye;(function(te){function pe(U){return{mime:U.mime,valueBytes:F.VSBuffer.wrap(U.data)}}te.from=pe;function oe(U){return new b.NotebookCellOutputItem(U.valueBytes.buffer,U.mime)}te.to=oe})(Ye=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var Ct;(function(te){function pe(U){return{outputId:U.id,items:U.items.map(Ye.from),metadata:U.metadata}}te.from=pe;function oe(U){const De=U.items.map(Ye.to);return new b.NotebookCellOutput(De,U.outputId,U.metadata)}te.to=oe})(Ct=e.NotebookCellOutput||(e.NotebookCellOutput={}));var Pe;(function(te){function pe(Se){if(Se!=null){if(Se instanceof b.RelativePattern||typeof Se=="string")return Se;if(De(Se))return new b.RelativePattern(Se.base,Se.pattern);if(U(Se))return{include:ft.from(Se.include)||void 0,exclude:ft.from(Se.exclude)||void 0}}}te.from=pe;function oe(Se){return typeof Se=="string"?Se:De(Se)?{base:Se.base,pattern:Se.pattern}:{include:Se.include,exclude:Se.exclude}}te.to=oe;function U(Se){const qe=Se,ze=ft.from(qe.include);if(!(ze&&ze instanceof b.RelativePattern||typeof ze=="string"))return!1;const it=ft.from(qe.exclude);return!!(it&&it instanceof b.RelativePattern||typeof it=="string")}function De(Se){const qe=Se;return qe&&typeof qe.base=="string"&&typeof qe.pattern=="string"}})(Pe=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var ye;(function(te){function pe(oe){return{backgroundColor:oe.backgroundColor,borderColor:oe.borderColor,top:oe.top?D.from(oe.top):void 0}}te.from=pe})(ye=e.NotebookDecorationRenderOptions||(e.NotebookDecorationRenderOptions={}));var ke;(function(te){function pe(oe,U,De){const Se=typeof oe.command=="string"?{title:"",command:oe.command}:oe.command;return{alignment:oe.alignment===b.NotebookCellStatusBarAlignment.Left?1:2,command:U.toInternal(Se,De),text:oe.text,tooltip:oe.tooltip,accessibilityInformation:oe.accessibilityInformation,priority:oe.priority}}te.from=pe})(ke=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var X;(function(te){function pe(oe){return{transientOutputs:oe?.transientOutputs??!1,transientCellMetadata:oe?.transientCellMetadata??{},transientDocumentMetadata:oe?.transientDocumentMetadata??{}}}te.from=pe})(X=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var ue;(function(te){function pe(U){return{uri:U.uri,provides:U.provides}}te.from=pe;function oe(U){return new b.NotebookRendererScript(k.URI.revive(U.uri),U.provides)}te.to=oe})(ue=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ge;(function(te){function pe(U){return{message:P.fromStrict(U.message)||"",type:0,expected:U.expectedOutput,actual:U.actualOutput,location:U.location?le.from(U.location):void 0}}te.from=pe;function oe(U){const De=new b.TestMessage(typeof U.message=="string"?U.message:P.to(U.message));return De.actualOutput=U.actual,De.expectedOutput=U.expected,De}te.to=oe})(ge=e.TestMessage||(e.TestMessage={}));var me;(function(te){let pe;(function(U){U.Delimiter="\0"})(pe||(pe={})),te.namespace=(U,De)=>U+"\0"+De;function oe(U,De){return{displayId:De.id,id:te.namespace(U,De.id),label:De.label}}te.display=oe,te.denamespace=U=>{const De=U.indexOf("\0");return{ctrlId:U.slice(0,De),tagId:U.slice(De+1)}}})(me=e.TestTag||(e.TestTag={}));var Ie;(function(te){function pe(Se){const qe=(0,a.getPrivateApiFor)(Se).controllerId;return{extId:v.TestId.fromExtHostTestItem(Se,qe).toString(),label:Se.label,uri:Se.uri,tags:Se.tags.map(ze=>me.namespace(qe,ze.id)),range:g.from(Se.range)||null,description:Se.description||null,error:Se.error&&P.fromStrict(Se.error)||null}}te.from=pe;function oe(Se){return{id:v.TestId.fromString(Se.extId).localId,label:Se.label,uri:k.URI.revive(Se.uri),tags:(Se.tags||[]).map(qe=>{const{tagId:ze}=me.denamespace(qe);return new b.TestTag(ze,ze)}),range:g.to(Se.range||void 0),invalidateResults:()=>{},canResolveChildren:!1,busy:!1,description:Se.description||void 0}}te.toPlain=oe;function U(Se){const qe=v.TestId.fromString(Se.extId),ze=new a.TestItemImpl(qe.controllerId,qe.localId,Se.label,k.URI.revive(Se.uri));return ze.range=g.to(Se.range||void 0),ze.description=Se.description||void 0,ze}function De(Se){let qe;for(const ze of Se.tests){const it=U(ze.item);(0,a.getPrivateApiFor)(it).parent=qe,qe=it}return qe}te.toItemFromContext=De})(Ie=e.TestItem||(e.TestItem={})),function(te){function pe(U){return{id:U.id,label:U.label}}te.from=pe;function oe(U){return new b.TestTag(U.id,U.label)}te.to=oe}(me=e.TestTag||(e.TestTag={}));var Ue;(function(te){const pe=(U,De)=>{const Se={...Ie.toPlain(U.item),parent:void 0,taskStates:U.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(ze=>ze.type===0).map(ge.to)})),children:U.children.map(qe=>De.get(qe)).filter(y.isDefined).map(qe=>pe(qe,De))};for(const qe of Se.children)qe.parent=Se;return Se};function oe(U){const De=[],Se=new Map;for(const qe of U.items)Se.set(qe.item.extId,qe),U.request.targets.some(ze=>ze.controllerId===qe.controllerId&&ze.testIds.includes(qe.item.extId))&&De.push(qe);return{completedAt:U.completedAt,results:De.map(qe=>pe(qe,Se))}}te.to=oe})(Ue=e.TestResults||(e.TestResults={}));var Me;(function(te){function pe(Se){return{covered:Se.covered,total:Se.covered}}function oe(Se){return"line"in Se?i.from(Se):g.from(Se)}function U(Se){return"branches"in Se?{count:Se.executionCount,location:oe(Se.location),type:1,branches:Se.branches.length?Se.branches.map(qe=>({count:qe.executionCount,location:qe.location&&oe(qe.location)})):void 0}:{type:0,count:Se.executionCount,location:oe(Se.location)}}te.fromDetailed=U;function De(Se){return{uri:Se.uri,statement:pe(Se.statementCoverage),branch:Se.branchCoverage&&pe(Se.branchCoverage),function:Se.functionCoverage&&pe(Se.functionCoverage),details:Se.detailedCoverage?.map(U)}}te.fromFile=De})(Me=e.TestCoverage||(e.TestCoverage={}));var je;(function(te){function pe(oe){switch(oe){case 1:return b.CodeActionTriggerKind.Invoke;case 2:return b.CodeActionTriggerKind.Automatic}}te.to=pe})(je=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var Je;(function(te){function pe(U){const De=new b.TypeHierarchyItem(W.to(U.kind),U.name,U.detail||"",k.URI.revive(U.uri),g.to(U.range),g.to(U.selectionRange));return De._sessionId=U._sessionId,De._itemId=U._itemId,De}te.to=pe;function oe(U,De,Se){if(De=De??U._sessionId,Se=Se??U._itemId,De===void 0||Se===void 0)throw new Error("invalid item");return{_sessionId:De,_itemId:Se,kind:W.from(U.kind),name:U.name,detail:U.detail??"",uri:U.uri,range:g.from(U.range),selectionRange:g.from(U.selectionRange),tags:U.tags?.map(L.from)}}te.from=oe})(Je=e.TypeHierarchyItem||(e.TypeHierarchyItem={}))}),define(be[168],Ee([0,1,2,15,6,8,230]),function(re,e,h,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class I{constructor(k,t,_,r={timeout:1500,errors:3}){this._logService=k,this._documents=t,this._mainThreadBulkEdits=_,this._thresholds=r,this._callbacks=new R.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(k){return(t,_,r)=>{const a={dispose:this._callbacks.push([t,_,k])};return Array.isArray(r)&&r.push(a),a}}async $participateInSave(k,t){const _=h.URI.revive(k);let r=!1;const d=setTimeout(()=>r=!0,this._thresholds.timeout),a=[];try{for(let l of[...this._callbacks]){if(r)break;const v=this._documents.getDocument(_),T=await this._deliverEventAsyncAndBlameBadListeners(l,{document:v,reason:A.TextDocumentSaveReason.to(t)});a.push(T)}}finally{clearTimeout(d)}return a}_deliverEventAsyncAndBlameBadListeners([k,t,_],r){const d=this._badListeners.get(k);return typeof d=="number"&&d>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(_,k,t,r).then(()=>!0,a=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' threw ERROR`),this._logService.error(a),!(a instanceof Error)||a.message!=="concurrent_edits"){const l=this._badListeners.get(k);this._badListeners.set(k,l?l+1:1),typeof l=="number"&&l>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${_.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(k,t,_,r){const d=[],a=Date.now(),{document:l,reason:v}=r,{version:T}=l,b=Object.freeze({document:l,reason:v,waitUntil(c){if(Object.isFrozen(d))throw(0,F.illegalState)("waitUntil can not be called async");d.push(Promise.resolve(c))}});try{t.apply(_,[b])}catch(c){return Promise.reject(c)}return Object.freeze(d),new Promise((c,g)=>{const S=setTimeout(()=>g(new Error("timeout")),this._thresholds.timeout);return Promise.all(d).then(i=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${k.identifier.value}' finished after ${Date.now()-a}ms`),clearTimeout(S),c(i)}).catch(i=>{clearTimeout(S),g(i)})}).then(c=>{const g={edits:[]};for(const S of c)if(Array.isArray(S)&&S.every(i=>i instanceof E.TextEdit))for(const{newText:i,newEol:s,range:u}of S)g.edits.push({_type:2,resource:l.uri,edit:{range:u&&A.Range.from(u),text:i,eol:s&&A.EndOfLine.from(s)}});if(g.edits.length!==0)return T===l.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(g):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=I}),define(be[169],Ee([0,1,3,27,2,8,6]),function(re,e,h,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class I{constructor(t,_,r,d,a){this._onDidCreate=new h.Emitter,this._onDidChange=new h.Emitter,this._onDidDelete=new h.Emitter,this._config=0,r&&(this._config+=1),d&&(this._config+=2),a&&(this._config+=4);const l=(0,F.parse)(_),v=t(T=>{if(!r)for(let b of T.created){const c=E.URI.revive(b);l(c.fsPath)&&this._onDidCreate.fire(c)}if(!d)for(let b of T.changed){const c=E.URI.revive(b);l(c.fsPath)&&this._onDidChange.fire(c)}if(!a)for(let b of T.deleted){const c=E.URI.revive(b);l(c.fsPath)&&this._onDidDelete.fire(c)}});this._disposable=R.Disposable.from(this._onDidCreate,this._onDidChange,this._onDidDelete,v)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class y{constructor(t,_,r){this._logService=_,this._extHostDocumentsAndEditors=r,this._onFileSystemEvent=new h.Emitter,this._onDidRenameFile=new h.Emitter,this._onDidCreateFile=new h.Emitter,this._onDidDeleteFile=new h.Emitter,this._onWillRenameFile=new h.AsyncEmitter,this._onWillCreateFile=new h.AsyncEmitter,this._onWillDeleteFile=new h.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(t,_,r,d){return new I(this._onFileSystemEvent.event,t,_,r,d)}$onFileEvent(t){this._onFileSystemEvent.fire(t)}$onDidRunFileOperation(t,_){switch(t){case 2:this._onDidRenameFile.fire(Object.freeze({files:_.map(r=>({oldUri:E.URI.revive(r.source),newUri:E.URI.revive(r.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:_.map(r=>E.URI.revive(r.target))}));break;case 0:this._onDidCreateFile.fire(Object.freeze({files:_.map(r=>E.URI.revive(r.target))}));break;default:}}getOnWillRenameFileEvent(t){return this._createWillExecuteEvent(t,this._onWillRenameFile)}getOnWillCreateFileEvent(t){return this._createWillExecuteEvent(t,this._onWillCreateFile)}getOnWillDeleteFileEvent(t){return this._createWillExecuteEvent(t,this._onWillDeleteFile)}_createWillExecuteEvent(t,_){return(r,d,a)=>{const l=function(T){r.call(d,T)};return l.extension=t,_.event(l,void 0,a)}}async $onWillRunFileOperation(t,_,r,d){switch(t){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:_.map(a=>({oldUri:E.URI.revive(a.source),newUri:E.URI.revive(a.target)}))},r,d);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:_.map(a=>E.URI.revive(a.target))},r,d);case 0:return await this._fireWillEvent(this._onWillCreateFile,{files:_.map(a=>E.URI.revive(a.target))},r,d)}}async _fireWillEvent(t,_,r,d){const a=new Set,l=[];if(await t.fireAsync(_,d,async(T,b)=>{const c=Date.now(),g=await Promise.resolve(T);g instanceof R.WorkspaceEdit&&(l.push(g),a.add(b.extension.displayName??b.extension.identifier.value)),Date.now()-c>r&&this._logService.warn("SLOW file-participant",b.extension.identifier)}),d.isCancellationRequested||l.length===0)return;const v={edits:[]};for(let T of l){let{edits:b}=A.WorkspaceEdit.from(T,this._extHostDocumentsAndEditors);v.edits=v.edits.concat(b)}return{edit:v,extensionNames:Array.from(a)}}}e.ExtHostFileSystemEventService=y}),define(be[170],Ee([0,1,11,22,2,8,6,89]),function(re,e,h,F,E,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class y{constructor(r,d,a,l){this.start=r,this.deletedCount=d,this.deletedItems=a,this.items=l}static asApiEvents(r){return r.map(d=>({start:d.start,deletedCount:d.deletedCount,deletedItems:d.deletedItems,items:d.items.map(a=>a.apiCell)}))}}class k{constructor(r,d,a){this.notebook=r,this._extHostDocument=d,this._cellData=a,this.handle=a.handle,this.uri=E.URI.revive(a.uri),this.cellKind=a.cellKind,this._outputs=a.outputs.map(A.NotebookCellOutput.to),this._internalMetadata=a.internalMetadata??{},this._metadata=Object.freeze(a.metadata??{}),this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(a.internalMetadata??{}))}static asModelAddData(r,d){return{EOL:d.eol,lines:d.source,modeId:d.language,uri:d.uri,isDirty:!1,versionId:1,notebook:r}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const r=this,d=this._extHostDocument.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);this._apiCell=Object.freeze({get index(){return r.notebook.getCellIndex(r)},notebook:r.notebook.apiNotebook,kind:A.NotebookCellKind.to(this._cellData.cellKind),document:d.document,get mime(){return r._mime},set mime(a){r._mime=a},get outputs(){return r._outputs.slice(0)},get metadata(){return r._metadata},get executionSummary(){return r._previousResult}})}return this._apiCell}setOutputs(r){this._outputs=r.map(A.NotebookCellOutput.to)}setOutputItems(r,d,a){const l=a.map(A.NotebookCellOutputItem.to),v=this._outputs.find(T=>T.id===r);v&&(d||(v.items.length=0),v.items.push(...l))}setMetadata(r){this._metadata=Object.freeze(r)}setInternalMetadata(r){this._internalMetadata=r,this._previousResult=Object.freeze(A.NotebookCellExecutionSummary.to(r))}setMime(r){}}e.ExtHostCell=k;class t{constructor(r,d,a,l,v,T){this._proxy=r,this._textDocumentsAndEditors=d,this._textDocuments=a,this._emitter=l,this.uri=v,this.handle=t._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=T.viewType,this._metadata=Object.freeze(T.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,T.cells]],!0),this._versionId=T.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const r=this;this._notebook={get uri(){return r.uri},get version(){return r._versionId},get notebookType(){return r._notebookType},get isDirty(){return r._isDirty},get isUntitled(){return r.uri.scheme===h.Schemas.untitled},get isClosed(){return r._disposed},get metadata(){return r._metadata},get cellCount(){return r._cells.length},cellAt(d){return d=r._validateIndex(d),r._cells[d].apiCell},getCells(d){return(d?r._getCells(d):r._cells).map(l=>l.apiCell)},save(){return r._save()}}}return this._notebook}updateBackup(r){this._backup?.delete(),this._backup=r}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(r){r.metadata&&(this._metadata=Object.freeze({...this._metadata,...r.metadata}))}acceptDirty(r){this._isDirty=r}acceptModelChanged(r,d){this._versionId=r.versionId,this._isDirty=d;for(const a of r.rawEvents)a.kind===I.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1):a.kind===I.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx):a.kind===I.NotebookCellsChangeType.Output?this._setCellOutputs(a.index,a.outputs):a.kind===I.NotebookCellsChangeType.OutputItem?this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems):a.kind===I.NotebookCellsChangeType.ChangeLanguage?this._changeCellLanguage(a.index,a.language):a.kind===I.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(a.index,a.mime):a.kind===I.NotebookCellsChangeType.ChangeCellMetadata?this._changeCellMetadata(a.index,a.metadata):a.kind===I.NotebookCellsChangeType.ChangeCellInternalMetadata&&this._changeCellInternalMetadata(a.index,a.internalMetadata)}_validateIndex(r){return r=r|0,r<0?0:r>=this._cells.length?this._cells.length-1:r}_validateRange(r){let d=r.start|0,a=r.end|0;return d<0&&(d=0),a>this._cells.length&&(a=this._cells.length),r.with({start:d,end:a})}_getCells(r){r=this._validateRange(r);const d=[];for(let a=r.start;a<r.end;a++)d.push(this._cells[a]);return d}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(r,d){if(this._disposed)return;const a=[],l=[],v=[];r.reverse().forEach(T=>{const c=T[2].map(i=>{const s=new k(this,this._textDocumentsAndEditors,i);return d||l.push(k.asModelAddData(this.apiNotebook,i)),s}),g=new y(T[0],T[1],[],c),S=this._cells.splice(T[0],T[1],...c);for(const i of S)v.push(i.uri),g.deletedItems.push(i.apiCell);a.push(g)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:l,removedDocuments:v}),d||this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(a)}))}_moveCell(r,d){const a=this._cells.splice(r,1);this._cells.splice(d,0,...a);const l=[new y(r,1,a.map(v=>v.apiCell),[]),new y(d,0,[],a)];this._emitter.emitModelChange((0,F.deepFreeze)({document:this.apiNotebook,changes:y.asApiEvents(l)}))}_setCellOutputs(r,d){const a=this._cells[r];a.setOutputs(d),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[a.apiCell]}))}_setCellOutputItems(r,d,a,l){const v=this._cells[r];v.setOutputItems(d,a,l),this._emitter.emitCellOutputsChange((0,F.deepFreeze)({document:this.apiNotebook,cells:[v.apiCell]}))}_changeCellLanguage(r,d){const a=this._cells[r];a.apiCell.document.languageId!==d&&this._textDocuments.$acceptModelModeChanged(a.uri,d)}_changeCellMime(r,d){const a=this._cells[r];a.apiCell.mime=d}_changeCellMetadata(r,d){const a=this._cells[r],l=a.apiCell.metadata;a.setMetadata(d);const v=a.apiCell.metadata;(0,F.equals)(l,v)||this._emitter.emitCellMetadataChange((0,F.deepFreeze)({document:this.apiNotebook,cell:a.apiCell}))}_changeCellInternalMetadata(r,d){const a=this._cells[r],l=a.internalMetadata;if(a.setInternalMetadata(d),l.runState!==d.runState){const v=d.runState??R.NotebookCellExecutionState.Idle;this._emitter.emitCellExecutionStateChange((0,F.deepFreeze)({document:this.apiNotebook,cell:a.apiCell,state:v}))}}getCellFromApiCell(r){return this._cells.find(d=>d.apiCell===r)}getCellFromIndex(r){return this._cells[r]}getCell(r){return this._cells.find(d=>d.handle===r)}getCellIndex(r){return this._cells.indexOf(r)}}e.ExtHostNotebookDocument=t,t._handlePool=0}),define(be[93],Ee([0,1,6,8,15]),function(re,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class A{constructor(y){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=y}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(y){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:y})}replaceCellMetadata(y,k){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:y,metadata:k})}replaceCells(y,k,t){this._throwIfFinalized(),!(y===k&&t.length===0)&&this._collectedEdits.push({editType:1,index:y,count:k-y,cells:t.map(F.NotebookCellData.from)})}}class R{constructor(y,k,t,_,r,d){this.id=y,this._proxy=k,this.notebookData=t,this._selections=[],this._visibleRanges=[],this._visible=!1,this._hasDecorationsForKey=new Set,this._selections=r,this._visibleRanges=_,this._viewColumn=d}get apiEditor(){if(!this._editor){const y=this;this._editor={get document(){return y.notebookData.apiNotebook},get selections(){return y._selections},set selections(k){if(!Array.isArray(k)||!k.every(h.NotebookRange.isNotebookRange))throw(0,E.illegalArgument)("selections");y._selections=k,y._trySetSelections(k)},get visibleRanges(){return y._visibleRanges},revealRange(k,t){y._proxy.$tryRevealRange(y.id,F.NotebookRange.from(k),t??h.NotebookEditorRevealType.Default)},get viewColumn(){return y._viewColumn},edit(k){const t=new A(this.document.version);return k(t),y._applyEdit(t.finalize())},setDecorations(k,t){return y.setDecorations(k,t)}},R.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(y){this._visible=y}_acceptVisibleRanges(y){this._visibleRanges=y}_acceptSelections(y){this._selections=y}_trySetSelections(y){this._proxy.$trySetSelections(this.id,y.map(F.NotebookRange.from))}_acceptViewColumn(y){this._viewColumn=y}_applyEdit(y){if(y.cellEdits.length===0)return Promise.resolve(!0);const k=[];let t=-1;for(let _=0;_<y.cellEdits.length;_++){if(t<0){k.push(y.cellEdits[_]),t++;continue}const d=k[t],a=y.cellEdits[_];if(d.editType===1&&a.editType===1&&d.index===a.index){d.cells.push(...y.cellEdits[_].cells),d.count+=y.cellEdits[_].count;continue}k.push(y.cellEdits[_]),t++}return this._proxy.$tryApplyEdits(this.id,y.documentVersionId,k)}setDecorations(y,k){if(!(k.isEmpty&&!this._hasDecorationsForKey.has(y.key)))return k.isEmpty?this._hasDecorationsForKey.delete(y.key):this._hasDecorationsForKey.add(y.key),this._proxy.$trySetDecorations(this.id,F.NotebookRange.from(k),y.key)}}e.ExtHostNotebookEditor=R,R.apiEditorsToExtHost=new WeakMap}),define(be[171],Ee([0,1,8,146,125,21,51]),function(re,e,h,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class I{constructor(_){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=_}withProgress(_,r,d){const a=this._handles++,{title:l,location:v,cancellable:T}=r,b={label:(0,E.localize)(0,null,_.displayName||_.name),id:_.identifier.value};return this._proxy.$startProgress(a,{location:h.ProgressLocation.from(v),title:l,source:b,cancellable:T},_),this._withProgress(a,d,!!T)}_withProgress(_,r,d){let a;d&&(a=new A.CancellationTokenSource,this._mapHandleToCancellationSource.set(_,a));const l=T=>{this._proxy.$progressEnd(T),this._mapHandleToCancellationSource.delete(T),a&&a.dispose()};let v;try{v=r(new k(this._proxy,_),d&&a?a.token:A.CancellationToken.None)}catch(T){throw l(_),T}return v.then(T=>l(_),T=>l(_)),v}$acceptProgressCanceled(_){const r=this._mapHandleToCancellationSource.get(_);r&&(r.cancel(),this._mapHandleToCancellationSource.delete(_))}}e.ExtHostProgress=I;function y(t,_){return t.message=_.message,typeof _.increment=="number"&&(typeof t.increment=="number"?t.increment+=_.increment:t.increment=_.increment),t}class k extends F.Progress{constructor(_,r){super(d=>this.throttledReport(d));this._proxy=_,this._handle=r}throttledReport(_){this._proxy.$progressReport(this._handle,_)}}Be([(0,R.throttle)(100,(t,_)=>y(t,_),()=>Object.create(null))],k.prototype,"throttledReport",null)}),define(be[94],Ee([0,1,39,15,52,8,6]),function(re,e,h,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class I{constructor(r,d,a){const l=I._Keys.nextId();r.$registerTextEditorDecorationType(d.identifier,l,A.DecorationRenderOptions.from(a)),this.value=Object.freeze({key:l,dispose(){r.$removeTextEditorDecorationType(l)}})}}e.TextEditorDecorationType=I,I._Keys=new E.IdGenerator("TextEditorDecorationType");class y{constructor(r,d){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=r,this._documentVersionId=r.version,this._undoStopBefore=d.undoStopBefore,this._undoStopAfter=d.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(r,d){this._throwIfFinalized();let a=null;if(r instanceof R.Position)a=new R.Range(r,r);else if(r instanceof R.Range)a=r;else throw new Error("Unrecognized location");this._pushEdit(a,d,!1)}insert(r,d){this._throwIfFinalized(),this._pushEdit(new R.Range(r,r),d,!0)}delete(r){this._throwIfFinalized();let d=null;if(r instanceof R.Range)d=r;else throw new Error("Unrecognized location");this._pushEdit(d,null,!0)}_pushEdit(r,d,a){const l=this._document.validateRange(r);this._collectedEdits.push({range:l,text:d,forceMoveMarkers:a})}setEndOfLine(r){if(this._throwIfFinalized(),r!==R.EndOfLine.LF&&r!==R.EndOfLine.CRLF)throw(0,F.illegalArgument)("endOfLine");this._setEndOfLine=r}}e.TextEditorEdit=y;class k{constructor(r,d,a,l){this._proxy=r,this._id=d,this._accept(a),this._logService=l;const v=this;this.value={get tabSize(){return v._tabSize},set tabSize(T){v._setTabSize(T)},get insertSpaces(){return v._insertSpaces},set insertSpaces(T){v._setInsertSpaces(T)},get cursorStyle(){return v._cursorStyle},set cursorStyle(T){v._setCursorStyle(T)},get lineNumbers(){return v._lineNumbers},set lineNumbers(T){v._setLineNumbers(T)}}}_accept(r){this._tabSize=r.tabSize,this._insertSpaces=r.insertSpaces,this._cursorStyle=r.cursorStyle,this._lineNumbers=A.TextEditorLineNumbersStyle.to(r.lineNumbers)}_validateTabSize(r){if(r==="auto")return"auto";if(typeof r=="number"){const d=Math.floor(r);return d>0?d:null}if(typeof r=="string"){const d=parseInt(r,10);return isNaN(d)?null:d>0?d:null}return null}_setTabSize(r){const d=this._validateTabSize(r);if(d!==null){if(typeof d=="number"){if(this._tabSize===d)return;this._tabSize=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{tabSize:d}))}}_validateInsertSpaces(r){return r==="auto"?"auto":r==="false"?!1:Boolean(r)}_setInsertSpaces(r){const d=this._validateInsertSpaces(r);if(typeof d=="boolean"){if(this._insertSpaces===d)return;this._insertSpaces=d}this._warnOnError(this._proxy.$trySetOptions(this._id,{insertSpaces:d}))}_setCursorStyle(r){this._cursorStyle!==r&&(this._cursorStyle=r,this._warnOnError(this._proxy.$trySetOptions(this._id,{cursorStyle:r})))}_setLineNumbers(r){this._lineNumbers!==r&&(this._lineNumbers=r,this._warnOnError(this._proxy.$trySetOptions(this._id,{lineNumbers:A.TextEditorLineNumbersStyle.from(r)})))}assign(r){const d={};let a=!1;if(typeof r.tabSize!="undefined"){const l=this._validateTabSize(r.tabSize);l==="auto"?(a=!0,d.tabSize=l):typeof l=="number"&&this._tabSize!==l&&(this._tabSize=l,a=!0,d.tabSize=l)}if(typeof r.insertSpaces!="undefined"){const l=this._validateInsertSpaces(r.insertSpaces);l==="auto"?(a=!0,d.insertSpaces=l):this._insertSpaces!==l&&(this._insertSpaces=l,a=!0,d.insertSpaces=l)}typeof r.cursorStyle!="undefined"&&this._cursorStyle!==r.cursorStyle&&(this._cursorStyle=r.cursorStyle,a=!0,d.cursorStyle=r.cursorStyle),typeof r.lineNumbers!="undefined"&&this._lineNumbers!==r.lineNumbers&&(this._lineNumbers=r.lineNumbers,a=!0,d.lineNumbers=A.TextEditorLineNumbersStyle.from(r.lineNumbers)),a&&this._warnOnError(this._proxy.$trySetOptions(this._id,d))}_warnOnError(r){r.catch(d=>this._logService.warn(d))}}e.ExtHostTextEditorOptions=k;class t{constructor(r,d,a,l,v,T,b,c){this.id=r,this._proxy=d,this._logService=a,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=v,this._options=new k(this._proxy,this.id,T,a),this._visibleRanges=b,this._viewColumn=c;const g=this;this.value=Object.freeze({get document(){return l.getValue()},set document(S){throw(0,F.readonly)("document")},get selection(){return g._selections&&g._selections[0]},set selection(S){if(!(S instanceof R.Selection))throw(0,F.illegalArgument)("selection");g._selections=[S],g._trySetSelection()},get selections(){return g._selections},set selections(S){if(!Array.isArray(S)||S.some(i=>!(i instanceof R.Selection)))throw(0,F.illegalArgument)("selections");g._selections=S,g._trySetSelection()},get visibleRanges(){return g._visibleRanges},set visibleRanges(S){throw(0,F.readonly)("visibleRanges")},get options(){return g._options.value},set options(S){g._disposed||g._options.assign(S)},get viewColumn(){return g._viewColumn},set viewColumn(S){throw(0,F.readonly)("viewColumn")},edit(S,i={undoStopBefore:!0,undoStopAfter:!0}){if(g._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const s=new y(l.getValue(),i);return S(s),g._applyEdit(s)},insertSnippet(S,i,s={undoStopBefore:!0,undoStopAfter:!0}){if(g._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let u;if(!i||Array.isArray(i)&&i.length===0)u=g._selections.map(o=>A.Range.from(o));else if(i instanceof R.Position){const{lineNumber:o,column:f}=A.Position.from(i);u=[{startLineNumber:o,startColumn:f,endLineNumber:o,endColumn:f}]}else if(i instanceof R.Range)u=[A.Range.from(i)];else{u=[];for(const o of i)if(o instanceof R.Range)u.push(A.Range.from(o));else{const{lineNumber:f,column:p}=A.Position.from(o);u.push({startLineNumber:f,startColumn:p,endLineNumber:f,endColumn:p})}}return d.$tryInsertSnippet(r,S.value,u,s)},setDecorations(S,i){const s=i.length===0;s&&!g._hasDecorationsForKey.has(S.key)||(s?g._hasDecorationsForKey.delete(S.key):g._hasDecorationsForKey.add(S.key),g._runOnProxy(()=>{if(A.isDecorationOptionsArr(i))return d.$trySetDecorations(r,S.key,A.fromRangeOrRangeWithMessage(i));{const u=new Array(4*i.length);for(let o=0,f=i.length;o<f;o++){const p=i[o];u[4*o]=p.start.line+1,u[4*o+1]=p.start.character+1,u[4*o+2]=p.end.line+1,u[4*o+3]=p.end.character+1}return d.$trySetDecorationsFast(r,S.key,u)}}))},revealRange(S,i){g._runOnProxy(()=>d.$tryRevealRange(r,A.Range.from(S),i||R.TextEditorRevealType.Default))},show(S){d.$tryShowEditor(r,A.ViewColumn.from(S))},hide(){d.$tryHideEditor(r)}})}dispose(){(0,h.ok)(!this._disposed),this._disposed=!0}_acceptOptions(r){(0,h.ok)(!this._disposed),this._options._accept(r)}_acceptVisibleRanges(r){(0,h.ok)(!this._disposed),this._visibleRanges=r}_acceptViewColumn(r){(0,h.ok)(!this._disposed),this._viewColumn=r}_acceptSelections(r){(0,h.ok)(!this._disposed),this._selections=r}async _trySetSelection(){const r=this._selections.map(A.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,r)),this.value}_applyEdit(r){const d=r.finalize();if(d.edits.length===0&&!d.setEndOfLine)return Promise.resolve(!0);const a=d.edits.map(v=>v.range);a.sort((v,T)=>v.end.line===T.end.line?v.end.character===T.end.character?v.start.line===T.start.line?v.start.character-T.start.character:v.start.line-T.start.line:v.end.character-T.end.character:v.end.line-T.end.line);for(let v=0,T=a.length-1;v<T;v++){const b=a[v].end;if(a[v+1].start.isBefore(b))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const l=d.edits.map(v=>({range:A.Range.from(v.range),text:v.text,forceMoveMarkers:v.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,d.documentVersionId,l,{setEndOfLine:typeof d.setEndOfLine=="number"?A.EndOfLine.from(d.setEndOfLine):void 0,undoStopBefore:d.undoStopBefore,undoStopAfter:d.undoStopAfter})}_runOnProxy(r){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):r().then(()=>this,d=>(d instanceof Error&&d.name==="DISPOSED"||this._logService.warn(d),null))}}e.ExtHostTextEditor=t}),define(be[172],Ee([0,1,128,24,2,3,7,160,13,6,10,16,8,21,157]),function(re,e,h,F,E,A,R,I,y,k,t,_,r,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function l(b,c){if((0,t.isString)(b))return{label:b};if(b&&typeof b=="object"&&typeof b.label=="string"){let g;return Array.isArray(b.highlights)&&(g=b.highlights.filter(S=>S.length===2&&typeof S[0]=="number"&&typeof S[1]=="number"),g=g.length?g:void 0),{label:b.label,highlights:g}}}class v{constructor(c,g,S){this._proxy=c,this.commands=g,this.logService=S,this.treeViews=new Map;function i(s){return s&&s.$treeViewId&&s.$treeItemHandle}g.registerArgumentProcessor({processArgument:s=>i(s)?this.convertArgument(s):Array.isArray(s)&&s.length>0?s.map(u=>i(u)?this.convertArgument(u):u):s})}registerTreeDataProvider(c,g,S){const i=this.createTreeView(c,{treeDataProvider:g},S);return{dispose:()=>i.dispose()}}createTreeView(c,g,S){if(!g||!g.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const i=g.dragAndDropController!==void 0,s=this._proxy.$registerTreeViewDataProvider(c,{showCollapseAll:!!g.showCollapseAll,canSelectMany:!!g.canSelectMany,canDragAndDrop:i}),u=this.createExtHostTreeView(c,g,S);return{get onDidCollapseElement(){return u.onDidCollapseElement},get onDidExpandElement(){return u.onDidExpandElement},get selection(){return u.selectedElements},get onDidChangeSelection(){return u.onDidChangeSelection},get visible(){return u.visible},get onDidChangeVisibility(){return u.onDidChangeVisibility},get message(){return u.message},set message(o){u.message=o},get title(){return u.title},set title(o){u.title=o},get description(){return u.description},set description(o){u.description=o},reveal:(o,f)=>u.reveal(o,f),dispose:async()=>{await s,this.treeViews.delete(c),u.dispose()}}}$getChildren(c,g){const S=this.treeViews.get(c);return S?S.getChildren(g):Promise.reject(new Error((0,h.localize)(0,null,c)))}async $onDrop(c,g,S){const i=this.treeViews.get(c);if(!i)return Promise.reject(new Error((0,h.localize)(1,null,c)));const s=a.TreeDataTransferConverter.toITreeDataTransfer(g);if(s.items.has(I.TREE_ITEM_DATA_TRANSFER_TYPE)){const o=JSON.parse(await s.items.get(I.TREE_ITEM_DATA_TRANSFER_TYPE).asString()).map(f=>i.getExtensionElement(f)).filter(f=>!!f);o.length>0?s.items.set(I.TREE_ITEM_DATA_TRANSFER_TYPE,{asString:async()=>JSON.stringify(o)}):s.items.delete(I.TREE_ITEM_DATA_TRANSFER_TYPE)}return i.onDrop(s,S)}async $hasResolve(c){const g=this.treeViews.get(c);if(!g)throw new Error((0,h.localize)(2,null,c));return g.hasResolve}$resolve(c,g,S){const i=this.treeViews.get(c);if(!i)throw new Error((0,h.localize)(3,null,c));return i.resolveTreeItem(g,S)}$setExpanded(c,g,S){const i=this.treeViews.get(c);if(!i)throw new Error((0,h.localize)(4,null,c));i.setExpanded(g,S)}$setSelection(c,g){const S=this.treeViews.get(c);if(!S)throw new Error((0,h.localize)(5,null,c));S.setSelection(g)}$setVisible(c,g){const S=this.treeViews.get(c);if(!S)throw new Error((0,h.localize)(6,null,c));S.setVisible(g)}createExtHostTreeView(c,g,S){const i=new T(c,g,this._proxy,this.commands.converter,this.logService,S);return this.treeViews.set(c,i),i}convertArgument(c){const g=this.treeViews.get(c.$treeViewId);return g?g.getExtensionElement(c.$treeItemHandle):null}}e.ExtHostTreeViews=v;class T extends R.Disposable{constructor(c,g,S,i,s,u){super();if(this.viewId=c,this.proxy=S,this.commands=i,this.logService=s,this.extension=u,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new A.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new A.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new A.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new A.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new A.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new d.CancellationTokenSource,u.contributes&&u.contributes.views)for(const p in u.contributes.views)for(const w of u.contributes.views[p])w.id===c&&(this._title=w.name);this.dataProvider=g.treeDataProvider,this.dndController=g.dragAndDropController,this.dataProvider.onDidChangeTreeData2?this._register(this.dataProvider.onDidChangeTreeData2(p=>this._onDidChangeData.fire({message:!1,element:p}))):this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(p=>this._onDidChangeData.fire({message:!1,element:p})));let o,f;this._register(A.Event.debounce(this._onDidChangeData.event,(p,w)=>(p||(p={message:!1,elements:[]}),w.element!==!1&&(o||(o=new Promise(C=>f=C),this.refreshPromise=this.refreshPromise.then(()=>o)),Array.isArray(w.element)?p.elements.push(...w.element):p.elements.push(w.element)),w.message&&(p.message=!0),p),200,!0)(({message:p,elements:w})=>{w.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const C=f;return o=null,this.refresh(w).then(()=>C())})),p&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(c=>this.getExtensionElement(c)).filter(c=>!(0,t.isUndefinedOrNull)(c))}async getChildren(c){const g=c?this.getExtensionElement(c):void 0;if(c&&!g)return this.logService.error(`No tree item with id '${c}' found.`),Promise.resolve([]);let S=this.getChildrenNodes(c);return S||(S=await this.fetchChildrenNodes(g)),S?S.map(i=>i.item):void 0}getExtensionElement(c){return this.elements.get(c)}reveal(c,g){g=g||{select:!0,focus:!1};const S=(0,t.isUndefinedOrNull)(g.select)?!0:g.select,i=(0,t.isUndefinedOrNull)(g.focus)?!1:g.focus,s=(0,t.isUndefinedOrNull)(g.expand)?!1:g.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):c?this.refreshPromise.then(()=>this.resolveUnknownParentChain(c)).then(u=>this.resolveTreeNode(c,u[u.length-1]).then(o=>this.proxy.$reveal(this.viewId,{item:o.item,parentChain:u.map(f=>f.item)},{select:S,focus:i,expand:s})),u=>this.logService.error(u)):this.proxy.$reveal(this.viewId,void 0,{select:S,focus:i,expand:s})}get message(){return this._message}set message(c){this._message=c,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(c){this._title=c,this.proxy.$setTitle(this.viewId,c,this._description)}get description(){return this._description}set description(c){this._description=c,this.proxy.$setTitle(this.viewId,this._title,c)}setExpanded(c,g){const S=this.getExtensionElement(c);S&&(g?this._onDidExpandElement.fire(Object.freeze({element:S})):this._onDidCollapseElement.fire(Object.freeze({element:S})))}setSelection(c){(0,_.equals)(this._selectedHandles,c)||(this._selectedHandles=c,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(c){c!==this._visible&&(this._visible=c,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async onDrop(c,g){const S=this.getExtensionElement(g);if(!!S)return(0,y.asPromise)(()=>this.dndController?.onDrop(c,S))}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(c,g){if(!this.dataProvider.resolveTreeItem)return;const S=this.elements.get(c);if(S){const i=this.nodes.get(S);if(i){const s=await this.dataProvider.resolveTreeItem(i.extensionItem,S,g)??i.extensionItem;return i.item.tooltip=this.getTooltip(s.tooltip),i.item.command=this.getCommand(i.disposableStore,s.command),i.item}}}resolveUnknownParentChain(c){return this.resolveParent(c).then(g=>g?this.resolveUnknownParentChain(g).then(S=>this.resolveTreeNode(g,S[S.length-1]).then(i=>(S.push(i),S))):Promise.resolve([]))}resolveParent(c){const g=this.nodes.get(c);return g?Promise.resolve(g.parent?this.elements.get(g.parent.item.handle):void 0):(0,y.asPromise)(()=>this.dataProvider.getParent(c))}resolveTreeNode(c,g){const S=this.nodes.get(c);return S?Promise.resolve(S):(0,y.asPromise)(()=>this.dataProvider.getTreeItem(c)).then(i=>this.createHandle(c,i,g,!0)).then(i=>this.getChildren(g?g.item.handle:void 0).then(()=>{const s=this.getExtensionElement(i);if(s){const u=this.nodes.get(s);if(u)return Promise.resolve(u)}throw new Error(`Cannot resolve tree item for element ${i}`)}))}getChildrenNodes(c){if(c){let g;if(typeof c=="string"){const S=this.getExtensionElement(c);g=S?this.nodes.get(S):void 0}else g=c;return g&&g.children||void 0}return this.roots}async fetchChildrenNodes(c){this.clearChildren(c);const g=new d.CancellationTokenSource(this._refreshCancellationSource.token);try{const S=c?this.nodes.get(c):void 0,i=await this.dataProvider.getChildren(c);if(g.token.isCancellationRequested)return;const s=await Promise.all((0,_.coalesce)(i||[]).map(async u=>{const o=await this.dataProvider.getTreeItem(u);return o&&!g.token.isCancellationRequested?this.createAndRegisterTreeNode(u,o,S):null}));return g.token.isCancellationRequested?void 0:(0,_.coalesce)(s)}finally{g.dispose()}}refresh(c){if(c.some(S=>!S))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new d.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const S=this.getHandlesToRefresh(c);if(S.length)return this.refreshHandles(S)}return Promise.resolve(void 0)}getHandlesToRefresh(c){const g=new Set,S=c.map(s=>this.nodes.get(s));for(const s of S)if(s&&!g.has(s.item.handle)){let u=s;for(;u&&u.parent&&S.findIndex(o=>u&&u.parent&&o&&o.item.handle===u.parent.item.handle)===-1;){const o=this.elements.get(u.parent.item.handle);u=o?this.nodes.get(o):void 0}u&&!u.parent&&g.add(s.item.handle)}const i=[];return g.forEach(s=>{const u=this.elements.get(s);if(u){const o=this.nodes.get(u);o&&(!o.parent||!g.has(o.parent.item.handle))&&i.push(s)}}),i}refreshHandles(c){const g={};return Promise.all(c.map(S=>this.refreshNode(S).then(i=>{i&&(g[S]=i.item)}))).then(()=>Object.keys(g).length?this.proxy.$refresh(this.viewId,g):void 0)}refreshNode(c){const g=this.getExtensionElement(c);if(g){const S=this.nodes.get(g);if(S)return this.clearChildren(g),(0,y.asPromise)(()=>this.dataProvider.getTreeItem(g)).then(i=>{if(i){const s=this.createTreeNode(g,i,S.parent);return this.updateNodeCache(g,s,S,S.parent),S.dispose(),s}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(c,g,S){const i=this.createTreeNode(c,g,S);if(g.id&&this.elements.has(i.item.handle))throw new Error((0,h.localize)(7,null,g.id));return this.addNodeToCache(c,i),this.addNodeToParentCache(i,S),i}getTooltip(c){return k.MarkdownString.isMarkdownString(c)?r.MarkdownString.from(c):c}getCommand(c,g){return g?this.commands.toInternal(g,c):void 0}createTreeNode(c,g,S){const i=new R.DisposableStore,s=this.createHandle(c,g,S),u=this.getLightIconPath(g);return{item:{handle:s,parentHandle:S?S.item.handle:void 0,label:l(g.label,this.extension),description:g.description,resourceUri:g.resourceUri,tooltip:this.getTooltip(g.tooltip),command:this.getCommand(i,g.command),contextValue:g.contextValue,icon:u,iconDark:this.getDarkIconPath(g)||u,themeIcon:this.getThemeIcon(g),collapsibleState:(0,t.isUndefinedOrNull)(g.collapsibleState)?k.TreeItemCollapsibleState.None:g.collapsibleState,accessibilityInformation:g.accessibilityInformation},extensionItem:g,parent:S,children:void 0,disposableStore:i,dispose(){i.dispose()}}}getThemeIcon(c){return c.iconPath instanceof k.ThemeIcon?c.iconPath:void 0}createHandle(c,{id:g,label:S,resourceUri:i},s,u){if(g)return`${T.ID_HANDLE_PREFIX}/${g}`;const o=l(S,this.extension),f=s?s.item.handle:T.LABEL_HANDLE_PREFIX;let p=o?o.label:i?(0,F.basename)(i):"";p=p.indexOf("/")!==-1?p.replace("/","//"):p;const w=this.nodes.has(c)?this.nodes.get(c).item.handle:void 0,C=this.getChildrenNodes(s)||[];let P,n=0;do{if(P=`${f}/${n}:${p}`,u||!this.elements.has(P)||w===P)break;n++}while(n<=C.length);return P}getLightIconPath(c){if(c.iconPath&&!(c.iconPath instanceof k.ThemeIcon))return typeof c.iconPath=="string"||E.URI.isUri(c.iconPath)?this.getIconPath(c.iconPath):this.getIconPath(c.iconPath.light)}getDarkIconPath(c){if(c.iconPath&&!(c.iconPath instanceof k.ThemeIcon)&&c.iconPath.dark)return this.getIconPath(c.iconPath.dark)}getIconPath(c){return E.URI.isUri(c)?c:E.URI.file(c)}addNodeToCache(c,g){this.elements.set(g.item.handle,c),this.nodes.set(c,g)}updateNodeCache(c,g,S,i){this.elements.delete(g.item.handle),this.nodes.delete(c),g.item.handle!==S.item.handle&&this.elements.delete(S.item.handle),this.addNodeToCache(c,g);const s=this.getChildrenNodes(i)||[],u=s.filter(o=>o.item.handle===S.item.handle)[0];u&&s.splice(s.indexOf(u),1,g)}addNodeToParentCache(c,g){g?(g.children||(g.children=[]),g.children.push(c)):(this.roots||(this.roots=[]),this.roots.push(c))}clearChildren(c){if(c){const g=this.nodes.get(c);if(g){if(g.children)for(const S of g.children){const i=this.elements.get(S.item.handle);i&&this.clear(i)}g.children=void 0}}else this.clearAll()}clear(c){const g=this.nodes.get(c);if(g){if(g.children)for(const S of g.children){const i=this.elements.get(S.item.handle);i&&this.clear(i)}this.nodes.delete(c),this.elements.delete(g.item.handle),g.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(c=>c.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}T.LABEL_HANDLE_PREFIX="0",T.ID_HANDLE_PREFIX="1"}),define(be[173],Ee([0,1,13,3,7,10,64,8,90,68]),function(re,e,h,F,E,A,R,I,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SingleUseTestCollection=void 0;class t extends E.Disposable{constructor(r){super();this.controllerId=r,this.debounceSendDiff=this._register(new h.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new F.Emitter),this.root=new R.TestItemRootImpl(this.controllerId,this.controllerId),this.tree=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}set resolveHandler(r){this._resolveHandler=r;for(const d of this.tree.values())this.updateExpandability(d)}collectDiff(){const r=this.diff;return this.diff=[],r}*tags(){const r=new Set;for(const d of this.tree.values())for(const a of d.actual.tags)r.has(a.id)||(r.add(a.id),yield a)}pushDiff(r){const d=this.diff[this.diff.length-1];if(d&&r[0]===1){if(d[0]===1&&d[1].extId===r[1].extId){(0,y.applyTestItemUpdate)(d[1],r[1]);return}if(d[0]===0&&d[1].item.extId===r[1].extId){(0,y.applyTestItemUpdate)(d[1],r[1]);return}}this.diff.push(r),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(r,d){const a=this.tree.get(r);if(!!a){if((a.expandLevels===void 0||d>a.expandLevels)&&(a.expandLevels=d),a.expand===1){const l=this.resolveChildren(a);return l.isOpen()?this.expandChildren(a,d-1):l.wait().then(()=>this.expandChildren(a,d-1))}else if(a.expand===3)return a.resolveBarrier?.isOpen()===!1?a.resolveBarrier.wait().then(()=>this.expandChildren(a,d-1)):this.expandChildren(a,d-1)}}dispose(){for(const r of this.tree.values())(0,R.getPrivateApiFor)(r.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(r,d){switch(d.op){case 2:this.pushDiff([4,r.fullId.toString()]);break;case 1:this.removeItem(k.TestId.joinToString(r.fullId,d.id));break;case 0:this.upsertItem(d.item,r);break;case 4:for(const T of d.ops)this.onTestItemEvent(r,T);break;case 3:const{key:a,value:l}=d,v=r.fullId.toString();switch(a){case"canResolveChildren":this.updateExpandability(r);break;case"tags":this.pushDiff([1,{extId:v,item:{tags:l.map(T=>T.id)}}]);break;case"range":this.pushDiff([1,{extId:v,item:{range:I.Range.from(l)}}]);break;case"error":this.pushDiff([1,{extId:v,item:{error:I.MarkdownString.fromStrict(l)||null}}]);break;default:this.pushDiff([1,{extId:v,item:{[a]:l??null}}]);break}break;default:(0,A.assertNever)(d)}}upsertItem(r,d){if(!(r instanceof R.TestItemImpl))throw new Error(`TestItems provided to the VS Code API must extend \`vscode.TestItem\`, but ${r.id} did not`);const a=k.TestId.fromExtHostTestItem(r,this.root.id,d?.actual),l=(0,R.getPrivateApiFor)(r);l.parent&&l.parent!==d?.actual&&l.parent.children.delete(r.id);let v=this.tree.get(a.toString());if(!v){v={fullId:a,actual:r,parent:d?a.parentId:null,expandLevels:d?.expandLevels?d.expandLevels-1:void 0,expand:0},this.tree.set(v.fullId.toString(),v),this.setItemParent(r,d),this.pushDiff([0,{parent:v.parent&&v.parent.toString(),controllerId:this.controllerId,expand:v.expand,item:I.TestItem.from(r)}]),this.connectItemAndChildren(r,v,d);return}if(v.actual===r){this.connectItem(r,v,d);return}const T=v.actual.children,b=v.actual,c=(0,R.diffTestItems)(b,r);(0,R.getPrivateApiFor)(b).listener=void 0,v.actual=r,v.expand=0;for(const[g,S]of c)this.onTestItemEvent(v,{op:3,key:g,value:S});this.connectItemAndChildren(r,v,d);for(const g of T)r.children.get(g.id)||this.removeItem(k.TestId.joinToString(a,g.id))}setItemParent(r,d){(0,R.getPrivateApiFor)(r).parent=d&&d.actual!==this.root?d.actual:void 0}connectItem(r,d,a){this.setItemParent(r,a);const l=(0,R.getPrivateApiFor)(r);l.parent=a?.actual,l.listener=v=>this.onTestItemEvent(d,v),this.updateExpandability(d)}connectItemAndChildren(r,d,a){this.connectItem(r,d,a);for(const l of r.children)this.upsertItem(l,d)}updateExpandability(r){let d;this._resolveHandler?r.resolveBarrier?d=r.resolveBarrier.isOpen()?3:2:d=r.actual.canResolveChildren?1:0:d=0,d!==r.expand&&(r.expand=d,this.pushDiff([1,{extId:r.fullId.toString(),expand:d}]),d===1&&r.expandLevels!==void 0&&this.resolveChildren(r))}expandChildren(r,d){if(d<0)return;const a=[];for(const l of r.actual.children){const v=this.expand(k.TestId.joinToString(r.fullId,l.id),d);(0,h.isThenable)(v)&&a.push(v)}if(a.length)return Promise.all(a).then(()=>{})}resolveChildren(r){if(r.resolveBarrier)return r.resolveBarrier;if(!this._resolveHandler){const v=new h.Barrier;return v.open(),v}r.expand=2,this.pushExpandStateUpdate(r);const d=r.resolveBarrier=new h.Barrier,a=v=>{console.error(`Unhandled error in resolveHandler of test controller "${this.controllerId}"`),r.actual!==this.root&&(r.actual.error=v.stack||v.message||String(v))};let l;try{l=this._resolveHandler(r.actual===this.root?void 0:r.actual)}catch(v){a(v)}return(0,h.isThenable)(l)?l.catch(a).then(()=>{d.open(),this.updateExpandability(r)}):(d.open(),this.updateExpandability(r)),r.resolveBarrier}pushExpandStateUpdate(r){this.pushDiff([1,{extId:r.fullId.toString(),expand:r.expand}])}removeItem(r){const d=this.tree.get(r);if(!d)throw new Error("attempting to remove non-existent child");this.pushDiff([2,r]);const a=[d];for(;a.length;){const l=a.pop();if(!!l){(0,R.getPrivateApiFor)(l.actual).listener=void 0,this.tree.delete(l.fullId.toString());for(const v of l.actual.children)a.push(this.tree.get(k.TestId.joinToString(l.fullId,v.id)))}}}flushDiff(){const r=this.collectDiff();r.length&&this.diffOpEmitter.fire(r)}}e.SingleUseTestCollection=t}),define(be[174],Ee([0,1,4,141]),function(re,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,h.refineServiceDecorator)(F.IEnvironmentService)}),define(be[175],Ee([0,1,25,3,17]),function(re,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class A{constructor(t){this.removedDueToLooping=t}}e.DeltaExtensionsResult=A;class R{constructor(t){this._onDidChange=new F.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=t,this._initialize()}_initialize(){this._extensionDescriptions.sort(y),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const t of this._extensionDescriptions){if(this._extensionsMap.has(h.ExtensionIdentifier.toKey(t.identifier))){console.error("Extension `"+t.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(h.ExtensionIdentifier.toKey(t.identifier),t),this._extensionsArr.push(t),Array.isArray(t.activationEvents))for(let _ of t.activationEvents)_==="onUri"&&(_=`onUri:${h.ExtensionIdentifier.toKey(t.identifier)}`),this._activationMap.has(_)||this._activationMap.set(_,[]),this._activationMap.get(_).push(t)}}keepOnly(t){const _=new Set;t.forEach(r=>_.add(h.ExtensionIdentifier.toKey(r))),this._extensionDescriptions=this._extensionDescriptions.filter(r=>_.has(h.ExtensionIdentifier.toKey(r.identifier))),this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(t,_){t.length>0&&(this._extensionDescriptions=this._extensionDescriptions.concat(t));const r=R._findLoopingExtensions(this._extensionDescriptions);if(_=_.concat(r.map(d=>d.identifier)),_.length>0){const d=new Set;_.forEach(a=>d.add(h.ExtensionIdentifier.toKey(a))),this._extensionDescriptions=this._extensionDescriptions.filter(a=>!d.has(h.ExtensionIdentifier.toKey(a.identifier)))}return this._initialize(),this._onDidChange.fire(void 0),new A(r)}static _findLoopingExtensions(t){const _=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(v){this._nodesSet.has(v)||(this._nodesSet.add(v),this._nodesArr.push(v))}addArc(v,T){this.addNode(v),this.addNode(T),this._arcs.has(v)?this._arcs.get(v).push(T):this._arcs.set(v,[T])}getArcs(v){return this._arcs.has(v)?this._arcs.get(v):[]}hasOnlyGoodArcs(v,T){const b=_.getArcs(v);for(let c=0;c<b.length;c++)if(!T.has(b[c]))return!1;return!0}getNodes(){return this._nodesArr}};let r=new Map;for(let v of t){const T=h.ExtensionIdentifier.toKey(v.identifier);if(r.set(T,v),v.extensionDependencies)for(let b of v.extensionDependencies){const c=h.ExtensionIdentifier.toKey(b);_.addArc(T,c)}}let d=new Set;_.getNodes().filter(v=>_.getArcs(v).length===0).forEach(v=>d.add(v));let a=_.getNodes().filter(v=>!d.has(v)),l;do{l=!1;for(let v=0;v<a.length;v++){const T=a[v];_.hasOnlyGoodArcs(T,d)&&(a.splice(v,1),v--,d.add(T),l=!0)}}while(l);return a.map(v=>r.get(v))}containsActivationEvent(t){return this._activationMap.has(t)}containsExtension(t){return this._extensionsMap.has(h.ExtensionIdentifier.toKey(t))}getExtensionDescriptionsForActivationEvent(t){const _=this._activationMap.get(t);return _?_.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(t){const _=this._extensionsMap.get(h.ExtensionIdentifier.toKey(t));return _||void 0}}e.ExtensionDescriptionRegistry=R;var I;(function(k){k[k.Builtin=0]="Builtin",k[k.User=1]="User",k[k.Dev=2]="Dev"})(I||(I={}));function y(k,t){const _=k.isBuiltin?0:k.isUnderDevelopment?2:1,r=t.isBuiltin?0:t.isUnderDevelopment?2:1;if(_!==r)return _-r;const d=E.posix.basename(k.extensionLocation.path),a=E.posix.basename(t.extensionLocation.path);return d<a?-1:d>a?1:0}}),define(be[176],Ee([0,1,23]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=void 0;var F;(function(I){I[I.VersionMismatch=55]="VersionMismatch",I[I.UnexpectedError=81]="UnexpectedError"})(F=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var E;(function(I){I[I.Initialized=0]="Initialized",I[I.Ready=1]="Ready",I[I.Terminate=2]="Terminate"})(E=e.MessageType||(e.MessageType={}));function A(I){const y=h.VSBuffer.alloc(1);switch(I){case 0:y.writeUInt8(1,0);break;case 1:y.writeUInt8(2,0);break;case 2:y.writeUInt8(3,0);break}return y}e.createMessageOfType=A;function R(I,y){if(I.byteLength!==1)return!1;switch(I.readUInt8(0)){case 1:return y===0;case 2:return y===1;case 3:return y===2;default:return!1}}e.isMessageOfType=R}),define(be[30],Ee([0,1,3,2,4,25,142]),function(re,e,h,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.throwProposedApiError=e.checkProposedApiEnabled=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.ExtensionHostKind=e.MissingExtensionDependency=e.ExtensionRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new A.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",enableProposedApi:!1,engines:{vscode:""},extensionLocation:F.URI.parse("void:location"),isBuiltin:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,E.createDecorator)("extensionService");var I;(function(b){b[b.None=0]="None",b[b.LocalProcess=1]="LocalProcess",b[b.LocalWebWorker=2]="LocalWebWorker",b[b.Remote=3]="Remote"})(I=e.ExtensionRunningLocation||(e.ExtensionRunningLocation={}));class y{constructor(c){this.dependency=c}}e.MissingExtensionDependency=y;var k;(function(b){b[b.LocalProcess=0]="LocalProcess",b[b.LocalWebWorker=1]="LocalWebWorker",b[b.Remote=2]="Remote"})(k=e.ExtensionHostKind||(e.ExtensionHostKind={}));class t{constructor(c,g,S,i){this.codeLoadingTime=c,this.activateCallTime=g,this.activateResolvedTime=S,this.activationReason=i}}e.ActivationTimes=t;class _{constructor(c,g){this.description=c,this.value=g}}e.ExtensionPointContribution=_,e.ExtensionHostLogFileName="exthost";var r;(function(b){b[b.Normal=0]="Normal",b[b.Immediate=1]="Immediate"})(r=e.ActivationKind||(e.ActivationKind={}));function d(b){b.enableProposedApi||a(b)}e.checkProposedApiEnabled=d;function a(b){throw new Error(`[${b.identifier.value}]: Proposed API is only available when running out of dev or with the following command line switch: --enable-proposed-api ${b.identifier.value}`)}e.throwProposedApiError=a;function l(b){return{type:b.isBuiltin?0:1,isBuiltin:b.isBuiltin||b.isUserBuiltin,identifier:{id:(0,R.getGalleryExtensionId)(b.publisher,b.name),uuid:b.uuid},manifest:b,location:b.extensionLocation}}e.toExtension=l;function v(b,c){return{identifier:new A.ExtensionIdentifier(b.identifier.id),isBuiltin:b.type===0,isUserBuiltin:b.type===1&&b.isBuiltin,isUnderDevelopment:!!c,extensionLocation:b.location,...b.manifest,uuid:b.identifier.uuid}}e.toExtensionDescription=v;class T{constructor(){this.onDidRegisterExtensions=h.Event.None,this.onDidChangeExtensionsStatus=h.Event.None,this.onDidChangeExtensions=h.Event.None,this.onWillActivateByEvent=h.Event.None,this.onDidChangeResponsiveChange=h.Event.None}activateByEvent(c){return Promise.resolve(void 0)}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(c){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(c){return Promise.resolve(0)}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(c){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(c,g){return Promise.resolve()}_onWillActivateExtension(c){}_onDidActivateExtension(c,g,S,i,s){}_onDidActivateExtensionError(c,g){}_onExtensionRuntimeError(c,g){}_onExtensionHostExit(c){}}e.NullExtensionService=T}),define(be[177],Ee([0,1,25,30,14]),function(re,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;const A=Promise.resolve(void 0);class R{constructor(a,l,v,T){this.startup=a,this.codeLoadingTime=l,this.activateCallTime=v,this.activateResolvedTime=T}}e.ExtensionActivationTimes=R,R.NONE=new R(!1,-1,-1,-1);class I{constructor(a){this._startup=a,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(a,l){return a===-1||l===-1?-1:l-a}build(){return new R(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=I;class y{constructor(a,l,v,T,b,c){this.activationFailed=a,this.activationFailedError=l,this.activationTimes=v,this.module=T,this.exports=b,this.subscriptions=c}}e.ActivatedExtension=y;class k extends y{constructor(a){super(!1,null,a,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=k;class t extends y{constructor(){super(!1,null,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=t;class _ extends y{constructor(a){super(!0,a,R.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=_;let r=class{constructor(a,l,v,T,b){this._logService=b,this._registry=a,this._resolvedExtensionsSet=new Set,l.forEach(c=>this._resolvedExtensionsSet.add(h.ExtensionIdentifier.toKey(c))),this._hostExtensionsMap=new Map,v.forEach(c=>this._hostExtensionsMap.set(h.ExtensionIdentifier.toKey(c),c)),this._host=T,this._activatingExtensions=new Map,this._activatedExtensions=new Map,this._alreadyActivatedEvents=Object.create(null)}isActivated(a){const l=h.ExtensionIdentifier.toKey(a);return this._activatedExtensions.has(l)}getActivatedExtension(a){const l=h.ExtensionIdentifier.toKey(a),v=this._activatedExtensions.get(l);if(!v)throw new Error("Extension `"+a.value+"` is not known or not activated");return v}activateByEvent(a,l){if(this._alreadyActivatedEvents[a])return A;const v=this._registry.getExtensionDescriptionsForActivationEvent(a);return this._activateExtensions(v.map(T=>({id:T.identifier,reason:{startup:l,extensionId:T.identifier,activationEvent:a}}))).then(()=>{this._alreadyActivatedEvents[a]=!0})}activateById(a,l){const v=this._registry.getExtensionDescription(a);if(!v)throw new Error("Extension `"+a+"` is not known");return this._activateExtensions([{id:v.identifier,reason:l}])}_handleActivateRequest(a,l,v){if(this._hostExtensionsMap.has(h.ExtensionIdentifier.toKey(a.id))){l[h.ExtensionIdentifier.toKey(a.id)]=a;return}const T=this._registry.getExtensionDescription(a.id);if(!T){const g=new Error(`Cannot activate unknown extension '${a.id.value}'`);this._host.onExtensionActivationError(a.id,g,new F.MissingExtensionDependency(a.id.value)),this._activatedExtensions.set(h.ExtensionIdentifier.toKey(a.id),new _(g));return}const b=typeof T.extensionDependencies=="undefined"?[]:T.extensionDependencies;let c=!0;for(let g=0,S=b.length;g<S;g++){const i=b[g];if(this._resolvedExtensionsSet.has(h.ExtensionIdentifier.toKey(i)))continue;const s=this._activatedExtensions.get(h.ExtensionIdentifier.toKey(i));if(s&&!s.activationFailed)continue;if(s&&s.activationFailed){const p=T.displayName||T.identifier.value,w=this._registry.getExtensionDescription(i),C=w&&w.displayName||i,P=new Error(`Cannot activate the '${p}' extension because its dependency '${C}' failed to activate`);P.detail=s.activationFailedError,this._host.onExtensionActivationError(T.identifier,P,null),this._activatedExtensions.set(h.ExtensionIdentifier.toKey(T.identifier),new _(P));return}if(this._hostExtensionsMap.has(h.ExtensionIdentifier.toKey(i))){c=!1,l[h.ExtensionIdentifier.toKey(i)]={id:this._hostExtensionsMap.get(h.ExtensionIdentifier.toKey(i)),reason:a.reason};continue}const u=this._registry.getExtensionDescription(i);if(u){c=!1,l[h.ExtensionIdentifier.toKey(i)]={id:u.identifier,reason:a.reason};continue}const o=T.displayName||T.identifier.value,f=new Error(`Cannot activate the '${o}' extension because it depends on unknown extension '${i}'`);this._host.onExtensionActivationError(T.identifier,f,new F.MissingExtensionDependency(i)),this._activatedExtensions.set(h.ExtensionIdentifier.toKey(T.identifier),new _(f));return}c?l[h.ExtensionIdentifier.toKey(T.identifier)]=a:v.push(a)}_activateExtensions(a){if(a.length===0||(a=a.filter(b=>!this._activatedExtensions.has(h.ExtensionIdentifier.toKey(b.id))),a.length===0))return Promise.resolve(void 0);const l=Object.create(null),v=[];for(let b=0,c=a.length;b<c;b++)this._handleActivateRequest(a[b],l,v);for(let b=0,c=v.length;b<c;b++){const g=h.ExtensionIdentifier.toKey(v[b].id);l[g]&&delete l[g]}const T=Object.keys(l).map(b=>l[b]);return v.length===0?Promise.all(T.map(b=>this._activateExtension(b.id,b.reason))).then(b=>{}):this._activateExtensions(T).then(b=>this._activateExtensions(v))}_activateExtension(a,l){const v=h.ExtensionIdentifier.toKey(a);if(this._activatedExtensions.has(v))return Promise.resolve(void 0);const T=this._activatingExtensions.get(v);if(T)return T;const b=this._host.actualActivateExtension(a,l).then(void 0,c=>{const g=new Error;return c&&c.name&&(g.name=c.name),c&&c.message?g.message=`Activating extension '${a.value}' failed: ${c.message}.`:g.message=`Activating extension '${a.value}' failed: ${c}.`,c&&c.stack&&(g.stack=c.stack),this._host.onExtensionActivationError(a,g,null),this._logService.error(`Activating extension ${a.value} failed due to an error:`),this._logService.error(c),new _(c)}).then(c=>{this._activatedExtensions.set(v,c),this._activatingExtensions.delete(v)});return this._activatingExtensions.set(v,b),b}};r=Be([We(4,E.ILogService)],r),e.ExtensionsActivator=r}),define(be[178],Ee([0,1,15]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LazyPromise=void 0;class F{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((A,R)=>{this._actualOk=A,this._actualErr=R,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(A){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=A,this._actual&&this._actualOk(A))}resolveErr(A){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=A,this._actual?this._actualErr(A):(0,h.onUnexpectedError)(A))}then(A,R){return this._ensureActual().then(A,R)}catch(A){return this._ensureActual().then(void 0,A)}finally(A){return this._ensureActual().finally(A)}}e.LazyPromise=F}),define(be[46],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createExtHostContextProxyIdentifier=e.createMainContextProxyIdentifier=e.ProxyIdentifier=void 0;class h{constructor(k,t){this._proxyIdentifierBrand=void 0,this.isMain=k,this.sid=t,this.nid=++h.count}}e.ProxyIdentifier=h,h.count=0;const F=[];function E(y){const k=new h(!0,y);return F[k.nid]=k,k}e.createMainContextProxyIdentifier=E;function A(y){const k=new h(!1,y);return F[k.nid]=k,k}e.createExtHostContextProxyIdentifier=A;function R(y){return F[y].sid}e.getStringIdentifierForProxy=R;class I{constructor(k){this.value=k}}e.SerializableObjectWithBuffers=I}),define(be[5],Ee([0,1,53,2,46]),function(re,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.WorkspaceEditType=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.ObjectIdentifier=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TextEditorRevealType=e.UIKind=void 0;var A;(function(c){c[c.Desktop=1]="Desktop",c[c.Web=2]="Web"})(A=e.UIKind||(e.UIKind={}));var R;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(R=e.TextEditorRevealType||(e.TextEditorRevealType={}));var I;(function(c){c[c.Editable=0]="Editable",c[c.SupportsHotExit=1]="SupportsHotExit"})(I=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var y;(function(c){c[c.Int8Array=1]="Int8Array",c[c.Uint8Array=2]="Uint8Array",c[c.Uint8ClampedArray=3]="Uint8ClampedArray",c[c.Int16Array=4]="Int16Array",c[c.Uint16Array=5]="Uint16Array",c[c.Int32Array=6]="Int32Array",c[c.Uint32Array=7]="Uint32Array",c[c.Float32Array=8]="Float32Array",c[c.Float64Array=9]="Float64Array",c[c.BigInt64Array=10]="BigInt64Array",c[c.BigUint64Array=11]="BigUint64Array"})(y=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var k;(function(c){c[c.Text=1]="Text",c[c.Error=2]="Error",c[c.Rich=3]="Rich"})(k=e.CellOutputKind||(e.CellOutputKind={}));var t;(function(c){c[c.Default=0]="Default",c[c.InCenter=1]="InCenter",c[c.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",c[c.AtTop=3]="AtTop"})(t=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var _;(function(c){c[c.None=0]="None",c[c.Process=1]="Process",c[c.Output=2]="Output"})(_=e.CandidatePortSource||(e.CandidatePortSource={}));var r;(function(c){c.name="$ident";function g(i,s){return Object.defineProperty(i,c.name,{value:s,enumerable:!0}),i}c.mixin=g;function S(i){return i[c.name]}c.of=S})(r=e.ObjectIdentifier||(e.ObjectIdentifier={}));class d{static mixin(g){return g._id=d._n++,g}}e.IdObject=d,d._n=0;var a;(function(c){c.label="a",c.kind="b",c.detail="c",c.documentation="d",c.sortText="e",c.filterText="f",c.preselect="g",c.insertText="h",c.insertTextRules="i",c.range="j",c.commitCharacters="k",c.additionalTextEdits="l",c.command="m",c.kindModifier="n"})(a=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var l;(function(c){c.defaultRanges="a",c.completions="b",c.isIncomplete="c",c.duration="d"})(l=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));var v;(function(c){c[c.File=1]="File",c[c.Text=2]="Text",c[c.Cell=3]="Cell"})(v=e.WorkspaceEditType||(e.WorkspaceEditType={}));function T(c){if(c&&c.edits)for(const g of c.edits)typeof g.resource=="object"?g.resource=F.URI.revive(g.resource):(g.newUri=F.URI.revive(g.newUri),g.oldUri=F.URI.revive(g.oldUri)),g.metadata&&g.metadata.iconPath&&(g.metadata=(0,h.revive)(g.metadata));return c}e.reviveWorkspaceEditDto=T;var b;(function(c){c[c.Workspace=0]="Workspace",c[c.TextDocument=1]="TextDocument"})(b=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,E.createMainContextProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,E.createMainContextProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,E.createMainContextProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,E.createMainContextProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,E.createMainContextProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,E.createMainContextProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,E.createMainContextProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,E.createMainContextProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,E.createMainContextProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,E.createMainContextProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,E.createMainContextProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,E.createMainContextProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,E.createMainContextProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,E.createMainContextProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,E.createMainContextProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,E.createMainContextProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,E.createMainContextProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,E.createMainContextProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,E.createMainContextProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,E.createMainContextProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,E.createMainContextProxyIdentifier)("MainThreadLanguages"),MainThreadLog:(0,E.createMainContextProxyIdentifier)("MainThread"),MainThreadMessageService:(0,E.createMainContextProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,E.createMainContextProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,E.createMainContextProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,E.createMainContextProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,E.createMainContextProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,E.createMainContextProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,E.createMainContextProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,E.createMainContextProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,E.createMainContextProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,E.createMainContextProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,E.createMainContextProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,E.createMainContextProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,E.createMainContextProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,E.createMainContextProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,E.createMainContextProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,E.createMainContextProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,E.createMainContextProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,E.createMainContextProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,E.createMainContextProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,E.createMainContextProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,E.createMainContextProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,E.createMainContextProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,E.createMainContextProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,E.createMainContextProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,E.createMainContextProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,E.createMainContextProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,E.createMainContextProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,E.createMainContextProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,E.createExtHostContextProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,E.createExtHostContextProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,E.createExtHostContextProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,E.createExtHostContextProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,E.createExtHostContextProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,E.createExtHostContextProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,E.createExtHostContextProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguageFeatures:(0,E.createExtHostContextProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,E.createExtHostContextProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,E.createExtHostContextProxyIdentifier)("ExtHostExtensionService"),ExtHostLogService:(0,E.createExtHostContextProxyIdentifier)("ExtHostLogService"),ExtHostTerminalService:(0,E.createExtHostContextProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,E.createExtHostContextProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,E.createExtHostContextProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,E.createExtHostContextProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,E.createExtHostContextProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,E.createExtHostContextProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,E.createExtHostContextProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,E.createExtHostContextProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,E.createExtHostContextProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,E.createMainContextProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,E.createMainContextProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,E.createMainContextProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,E.createMainContextProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,E.createExtHostContextProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,E.createExtHostContextProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,E.createMainContextProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,E.createMainContextProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,E.createMainContextProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,E.createMainContextProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,E.createMainContextProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,E.createMainContextProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,E.createMainContextProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,E.createMainContextProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,E.createMainContextProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,E.createMainContextProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,E.createMainContextProxyIdentifier)("ExtHostTelemetry")}}),define(be[69],Ee([0,1,5,3,4]),function(re,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class A{constructor(I){this._onDidChangePassword=new F.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=I.getProxy(h.MainContext.MainThreadSecretState)}async $onDidChangePassword(I){this._onDidChangePassword.fire(I)}get(I,y){return this._proxy.$getPassword(I,y)}store(I,y,k){return this._proxy.$setPassword(I,y,k)}delete(I,y){return this._proxy.$deletePassword(I,y)}}e.ExtHostSecretState=A,e.IExtHostSecretState=(0,E.createDecorator)("IExtHostSecretState")}),define(be[70],Ee([0,1,4,14,5,12]),function(re,e,h,F,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,h.createDecorator)("IExtHostApiDeprecationService");let R=class{constructor(y,k){this._extHostLogService=k,this._reportedUsages=new Set,this._telemetryShape=y.getProxy(E.MainContext.MainThreadTelemetry)}report(y,k,t){const _=this.getUsageKey(y,k);this._reportedUsages.has(_)||(this._reportedUsages.add(_),k.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${y}' is deprecated. ${t}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:k.identifier.value,apiId:y}))}getUsageKey(y,k){return`${y}-${k.identifier.value}`}};R=Be([We(0,A.IExtHostRpcService),We(1,F.ILogService)],R),e.ExtHostApiDeprecationService=R,e.NullApiDeprecationService=Object.freeze(new class{report(I,y,k){}})}),define(be[179],Ee([0,1,3,5,6,25]),function(re,e,h,F,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class R{constructor(y){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new h.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=y.getProxy(F.MainContext.MainThreadAuthentication)}$setProviders(y){return this._providers=y,Promise.resolve()}async getSession(y,k,t,_={}){const r=A.ExtensionIdentifier.toKey(y.identifier),d=this._inFlightRequests.get(r)||[],a=[...t].sort().join(" ");let l=d.find(v=>v.scopes===a);if(l)return l.result;{const v=this._getSession(y,r,k,t,_);l={scopes:a,result:v},d.push(l),this._inFlightRequests.set(r,d);try{await v}finally{const T=d.findIndex(b=>b.scopes===a);T>-1&&(d.splice(T),this._inFlightRequests.set(r,d))}return v}}async _getSession(y,k,t,_,r={}){await this._proxy.$ensureProvider(t);const d=y.displayName||y.name;return this._proxy.$getSession(t,_,k,d,r)}async removeSession(y,k){const t=this._authenticationProviders.get(y);return t?t.provider.removeSession(k):this._proxy.$removeSession(y,k)}registerAuthenticationProvider(y,k,t,_){if(this._authenticationProviders.get(y))throw new Error(`An authentication provider with id '${y}' is already registered.`);this._authenticationProviders.set(y,{label:k,provider:t,options:_??{supportsMultipleAccounts:!1}}),this._providers.find(d=>d.id===y)||this._providers.push({id:y,label:k});const r=t.onDidChangeSessions(d=>{this._proxy.$sendDidChangeSessions(y,{added:d.added??[],changed:d.changed??[],removed:d.removed??[]})});return this._proxy.$registerAuthenticationProvider(y,k,_?.supportsMultipleAccounts??!1),new E.Disposable(()=>{r.dispose(),this._authenticationProviders.delete(y);const d=this._providers.findIndex(a=>a.id===y);d>-1&&this._providers.splice(d),this._proxy.$unregisterAuthenticationProvider(y)})}$createSession(y,k){const t=this._authenticationProviders.get(y);if(t)return Promise.resolve(t.provider.createSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$removeSession(y,k){const t=this._authenticationProviders.get(y);if(t)return Promise.resolve(t.provider.removeSession(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$getSessions(y,k){const t=this._authenticationProviders.get(y);if(t)return Promise.resolve(t.provider.getSessions(k));throw new Error(`Unable to find authentication provider with handle: ${y}`)}$onDidChangeAuthenticationSessions(y,k){return this._onDidChangeSessions.fire({provider:{id:y,label:k}}),Promise.resolve()}}e.ExtHostAuthentication=R}),define(be[180],Ee([0,1,5,12,8]),function(re,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let A=class{constructor(I,y){this._extHostDocumentsAndEditors=y,this._proxy=I.getProxy(h.MainContext.MainThreadBulkEdits)}applyWorkspaceEdit(I){const y=E.WorkspaceEdit.from(I,this._extHostDocumentsAndEditors);return this._proxy.$tryApplyWorkspaceEdit(y)}};A=Be([We(0,F.IExtHostRpcService)],A),e.ExtHostBulkEdits=A}),define(be[181],Ee([0,1,5]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class F{constructor(A){const R=A.getProxy(h.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return R.$readText()},writeText(I){return R.$writeText(I)}})}}e.ExtHostClipboard=F}),define(be[47],Ee([0,1,10,6,8,22,5,16,14,53,41,111,2,7,4,12]),function(re,e,h,F,E,A,R,I,y,k,t,_,r,d,a,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let v=class{constructor(i,s){this._commands=new Map,this._apiCommands=new Map,this._proxy=i.getProxy(R.MainContext.MainThreadCommands),this._logService=s,this.converter=new T(this,u=>{const o=this._apiCommands.get(u);return o?.result===c.Void?o:void 0},s),this._argumentProcessors=[{processArgument(u){return(0,k.revive)(u)}},{processArgument(u){return(0,A.cloneAndChange)(u,function(o){if(t.Range.isIRange(o))return E.Range.to(o);if(_.Position.isIPosition(o))return E.Position.to(o);if(t.Range.isIRange(o.range)&&r.URI.isUri(o.uri))return E.location.to(o);if(!Array.isArray(o))return o})}}]}registerArgumentProcessor(i){this._argumentProcessors.push(i)}registerApiCommand(i){const s=this.registerCommand(!1,i.id,async(...u)=>{const o=i.args.map((p,w)=>{if(!p.validate(u[w]))throw new Error(`Invalid argument '${p.name}' when running '${i.id}', received: ${u[w]}`);return p.convert(u[w])}),f=await this.executeCommand(i.internalId,...o);return i.result.convert(f,u,this.converter)},void 0,{description:i.description,args:i.args,returns:i.result.description});return this._apiCommands.set(i.id,i),new F.Disposable(()=>{s.dispose(),this._apiCommands.delete(i.id)})}registerCommand(i,s,u,o,f){if(this._logService.trace("ExtHostCommands#registerCommand",s),!s.trim().length)throw new Error("invalid id");if(this._commands.has(s))throw new Error(`command '${s}' already exists`);return this._commands.set(s,{callback:u,thisArg:o,description:f}),i&&this._proxy.$registerCommand(s),new F.Disposable(()=>{this._commands.delete(s)&&i&&this._proxy.$unregisterCommand(s)})}executeCommand(i,...s){return this._logService.trace("ExtHostCommands#executeCommand",i),this._doExecuteCommand(i,s,!0)}async _doExecuteCommand(i,s,u){if(this._commands.has(i))return this._executeContributedCommand(i,s);{const o=(0,A.cloneAndChange)(s,function(f){if(f instanceof F.Position)return E.Position.from(f);if(f instanceof F.Range)return E.Range.from(f);if(f instanceof F.Location)return E.location.from(f);if(F.NotebookRange.isNotebookRange(f))return E.NotebookRange.from(f);if(!Array.isArray(f))return f});try{const f=await this._proxy.$executeCommand(i,o,u);return(0,k.revive)(f)}catch(f){if(f instanceof Error&&f.message==="$executeCommand:retry")return this._doExecuteCommand(i,s,!1);throw f}}}async _executeContributedCommand(i,s){const u=this._commands.get(i);if(!u)throw new Error("Unknown command");let{callback:o,thisArg:f,description:p}=u;if(p)for(let w=0;w<p.args.length;w++)try{(0,h.validateConstraint)(s[w],p.args[w].constraint)}catch(C){throw new Error(`Running the contributed command: '${i}' failed. Illegal argument '${p.args[w].name}' - ${p.args[w].description}`)}try{return await o.apply(f,s)}catch(w){if(i===this.converter.delegatingCommandId){const C=this.converter.getActualCommand(...s);C&&(i=C.command)}throw this._logService.error(w,i),new Error(`Running the contributed command: '${i}' failed.`)}}$executeContributedCommand(i,...s){return this._logService.trace("ExtHostCommands#$executeContributedCommand",i),this._commands.has(i)?(s=s.map(u=>this._argumentProcessors.reduce((o,f)=>f.processArgument(o),u)),this._executeContributedCommand(i,s)):Promise.reject(new Error(`Contributed command '${i}' does not exist.`))}getCommands(i=!1){return this._logService.trace("ExtHostCommands#getCommands",i),this._proxy.$getCommands().then(s=>(i&&(s=s.filter(u=>u[0]!=="_")),s))}$getContributedCommandHandlerDescriptions(){const i=Object.create(null);for(let[s,u]of this._commands){let{description:o}=u;o&&(i[s]=o)}return Promise.resolve(i)}};v=Be([We(0,l.IExtHostRpcService),We(1,y.ILogService)],v),e.ExtHostCommands=v,e.IExtHostCommands=(0,a.createDecorator)("IExtHostCommands");class T{constructor(i,s,u){this._commands=i,this._lookupApiCommand=s,this._logService=u,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(i,s){if(!i)return;const u={$ident:void 0,id:i.command,title:i.title,tooltip:i.tooltip};if(!i.command)return u;const o=this._lookupApiCommand(i.command);if(o)u.id=o.internalId,u.arguments=o.args.map((f,p)=>f.convert(i.arguments&&i.arguments[p]));else if((0,I.isNonEmptyArray)(i.arguments)){const f=++this._cachIdPool;this._cache.set(f,i),s.add((0,d.toDisposable)(()=>{this._cache.delete(f),this._logService.trace("CommandsConverter#DISPOSE",f)})),u.$ident=f,u.id=this.delegatingCommandId,u.arguments=[f],this._logService.trace("CommandsConverter#CREATE",i.command,f)}return u}fromInternal(i){const s=R.ObjectIdentifier.of(i);return typeof s=="number"?this._cache.get(s):{command:i.id,title:i.title,arguments:i.arguments}}getActualCommand(...i){return this._cache.get(i[0])}_executeConvertedCommand(...i){const s=this.getActualCommand(...i);return this._logService.trace("CommandsConverter#EXECUTE",i[0],s?s.command:"MISSING"),s?this._commands.executeCommand(s.command,...s.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=T;class b{constructor(i,s,u,o){this.name=i,this.description=s,this.validate=u,this.convert=o}optional(){return new b(this.name,`(optional) ${this.description}`,i=>i==null||this.validate(i),i=>i===void 0?void 0:i===null?null:this.convert(i))}with(i,s){return new b(i??this.name,s??this.description,this.validate,this.convert)}}e.ApiCommandArgument=b,b.Uri=new b("uri","Uri of a text document",S=>r.URI.isUri(S),S=>S),b.Position=new b("position","A position in a text document",S=>F.Position.isPosition(S),E.Position.from),b.Range=new b("range","A range in a text document",S=>F.Range.isRange(S),E.Range.from),b.Selection=new b("selection","A selection in a text document",S=>F.Selection.isSelection(S),E.Selection.from),b.Number=new b("number","",S=>typeof S=="number",S=>S),b.String=new b("string","",S=>typeof S=="string",S=>S),b.CallHierarchyItem=new b("item","A call hierarchy item",S=>S instanceof F.CallHierarchyItem,E.CallHierarchyItem.from),b.TypeHierarchyItem=new b("item","A type hierarchy item",S=>S instanceof F.TypeHierarchyItem,E.TypeHierarchyItem.from);class c{constructor(i,s){this.description=i,this.convert=s}}e.ApiCommandResult=c,c.Void=new c("no result",S=>S);class g{constructor(i,s,u,o,f){this.id=i,this.internalId=s,this.description=u,this.args=o,this.result=f}}e.ApiCommand=g}),define(be[182],Ee([0,1,8,6,58,47,16,80]),function(re,e,h,F,E,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new A.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",t(h.DocumentHighlight.to))),new A.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(r,d)=>{if((0,R.isFalsyOrEmpty)(r))return;class a extends F.SymbolInformation{static to(v){const T=new a(v.name,h.SymbolKind.to(v.kind),v.containerName||"",new F.Location(d[0],h.Range.to(v.range)));return T.detail=v.detail,T.range=T.location.range,T.selectionRange=h.Range.to(v.selectionRange),T.children=v.children?v.children.map(a.to):[],T}}return r.map(a.to)})),new A.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(h.TextEdit.to))),new A.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range,new A.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(h.TextEdit.to))),new A.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,new A.ApiCommandArgument("ch","Trigger character",r=>typeof r=="string",r=>r),new A.ApiCommandArgument("options","Formatting options",r=>!0,r=>r)],new A.ApiCommandResult("A promise that resolves to an array of TextEdits.",t(h.TextEdit.to))),new A.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",_)),new A.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Location-instances.",t(h.location.to))),new A.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A promise that resolves to an array of Hover-instances.",t(h.Hover.to))),new A.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("position","A position in a text document",r=>Array.isArray(r)&&r.every(d=>F.Position.isPosition(d)),r=>r.map(h.Position.from))],new A.ApiCommandResult("A promise that resolves to an array of ranges.",r=>r.map(d=>{let a;for(const l of d.reverse())a=new F.SelectionRange(h.Range.to(l),a);return a}))),new A.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[A.ApiCommandArgument.String.with("query","Search string")],new A.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",r=>{const d=[];if(Array.isArray(r))for(let a of r)d.push(...a[1].map(h.WorkspaceSymbol.to));return d})),new A.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(h.CallHierarchyItem.to))),new A.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(h.CallHierarchyIncomingCall.to))),new A.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[A.ApiCommandArgument.CallHierarchyItem],new A.ApiCommandResult("A CallHierarchyItem or undefined",r=>r.map(h.CallHierarchyOutgoingCall.to))),new A.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("newName","The new symbol name")],new A.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",r=>{if(!!r){if(r.rejectReason)throw new Error(r.rejectReason);return h.WorkspaceEdit.to(r)}})),new A.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new A.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",r=>r.map(h.DocumentLink.to))),new A.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new F.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const d=(0,I.decodeSemanticTokensDto)(r);if(d.type==="full")return new F.SemanticTokens(d.data,void 0)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",r=>{if(!!r)return new F.SemanticTokensLegend(r.tokenTypes,r.tokenModifiers)})),new A.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to SemanticTokens.",r=>{if(!r)return;const d=(0,I.decodeSemanticTokensDto)(r);if(d.type==="full")return new F.SemanticTokens(d.data,void 0)})),new A.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new A.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(r,d,a)=>{if(!r)return new F.CompletionList([]);const l=r.suggestions.map(v=>h.CompletionItem.to(v,a));return new F.CompletionList(l,r.incomplete)})),new A.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position,A.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new A.ApiCommandResult("A promise that resolves to SignatureHelp.",r=>{if(r)return h.SignatureHelp.to(r)})),new A.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new A.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(r,d,a)=>t(l=>new F.CodeLens(h.Range.to(l.range),l.command&&a.fromInternal(l.command)))(r))),new A.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",r=>F.Range.isRange(r),r=>F.Selection.isSelection(r)?h.Selection.from(r):h.Range.from(r)),A.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),A.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new A.ApiCommandResult("A promise that resolves to an array of Command-instances.",(r,d,a)=>t(l=>{if(l._isSynthetic){if(!l.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(l.command)}else{const v=new F.CodeAction(l.title,l.kind?new F.CodeActionKind(l.kind):void 0);return l.edit&&(v.edit=h.WorkspaceEdit.to(l.edit)),l.command&&(v.command=a.fromInternal(l.command)),v.isPreferred=l.isPreferred,v}})(r))),new A.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[A.ApiCommandArgument.Uri],new A.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",r=>r?r.map(d=>new F.ColorInformation(h.Range.to(d.range),h.Color.to(d.color))):[])),new A.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new A.ApiCommandArgument("color","The color to show and insert",r=>r instanceof F.Color,h.Color.from),new A.ApiCommandArgument("context","Context object with uri and range",r=>!0,r=>({uri:r.uri,range:h.Range.from(r.range)}))],new A.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",r=>r?r.map(h.ColorPresentation.to):[])),new A.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of Inlay objects",r=>r.map(h.InlayHint.to))),new A.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new A.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",t(r=>({viewType:r.viewType,displayName:r.displayName,options:{transientOutputs:r.options.transientOutputs,transientCellMetadata:r.options.transientCellMetadata,transientDocumentMetadata:r.options.transientDocumentMetadata},filenamePattern:r.filenamePattern.map(d=>h.NotebookExclusiveDocumentPattern.to(d))})))),new A.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Range],new A.ApiCommandResult("A promise that resolves to an array of InlineValue objects",r=>r.map(h.InlineValue.to))),new A.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[A.ApiCommandArgument.Uri,new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[h.ViewColumn.from(r.viewColumn),h.TextEditorOpenOptions.from(r)])).optional(),A.ApiCommandArgument.String.with("label","").optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[A.ApiCommandArgument.Uri.with("resource","Resource to open"),A.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="number"||typeof r=="object",r=>r&&(typeof r=="number"?[r,void 0]:[h.ViewColumn.from(r.viewColumn),h.TextEditorOpenOptions.from(r)])).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[A.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),A.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),A.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new A.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",r=>r===void 0||typeof r=="object",r=>r&&[h.ViewColumn.from(r.viewColumn),h.TextEditorOpenOptions.from(r)]).optional()],A.ApiCommandResult.Void),new A.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[A.ApiCommandArgument.Uri,A.ApiCommandArgument.Position],new A.ApiCommandResult("A TypeHierarchyItem or undefined",r=>r.map(h.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",r=>r.map(h.TypeHierarchyItem.to))),new A.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[A.ApiCommandArgument.TypeHierarchyItem],new A.ApiCommandResult("A TypeHierarchyItem or undefined",r=>r.map(h.TypeHierarchyItem.to)))];class k{static register(d){y.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=k;function t(r){return d=>{if(Array.isArray(d))return d.map(r)}}function _(r){if(!Array.isArray(r))return;const d=[];for(const a of r)E.isLocationLink(a)?d.push(h.DefinitionLink.to(a)):d.push(h.location.to(a));return d}}),define(be[183],Ee([0,1,13,51,3,7,2,58,25,8,6,5]),function(re,e,h,F,E,A,R,I,y,k,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function r(d,a,l){const v=d.getProxy(_.MainContext.MainThreadComments);class T{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,a.registerArgumentProcessor({processArgument:o=>{if(o&&o.$mid===6){const f=this._commentControllers.get(o.handle);return f||o}else if(o&&o.$mid===7){const f=this._commentControllers.get(o.commentControlHandle);if(!f)return o;const p=f.getCommentThread(o.commentThreadHandle);return p||o}else if(o&&o.$mid===8){const f=this._commentControllers.get(o.thread.commentControlHandle);if(!f)return o;const p=f.getCommentThread(o.thread.commentThreadHandle);return p?{thread:p,text:o.text}:o}else if(o&&o.$mid===9){const f=this._commentControllers.get(o.thread.commentControlHandle);if(!f)return o;const p=f.getCommentThread(o.thread.commentThreadHandle);if(!p)return o;let w=o.commentUniqueId,C=p.getCommentByUniqueId(w);return C||o}else if(o&&o.$mid===10){const f=this._commentControllers.get(o.thread.commentControlHandle);if(!f)return o;const p=f.getCommentThread(o.thread.commentThreadHandle);if(!p)return o;let w=o.text,C=o.commentUniqueId,P=p.getCommentByUniqueId(C);return P?(P.body=w,P):o}return o}})}createCommentController(o,f,p){const w=T.handlePool++,C=new c(o,w,f,p);this._commentControllers.set(C.handle,C);const P=this._commentControllersByExtension.get(y.ExtensionIdentifier.toKey(o.identifier))||[];return P.push(C),this._commentControllersByExtension.set(y.ExtensionIdentifier.toKey(o.identifier),P),C.value}$createCommentThreadTemplate(o,f,p){const w=this._commentControllers.get(o);!w||w.$createCommentThreadTemplate(f,p)}async $updateCommentThreadTemplate(o,f,p){const w=this._commentControllers.get(o);!w||w.$updateCommentThreadTemplate(f,p)}$deleteCommentThread(o,f){const p=this._commentControllers.get(o);p&&p.$deleteCommentThread(f)}$provideCommentingRanges(o,f,p){const w=this._commentControllers.get(o);if(!w||!w.commentingRangeProvider)return Promise.resolve(void 0);const C=l.getDocument(R.URI.revive(f));return(0,h.asPromise)(()=>w.commentingRangeProvider.provideCommentingRanges(C,p)).then(P=>P?P.map(n=>k.Range.from(n)):void 0)}$toggleReaction(o,f,p,w,C){const P=this._commentControllers.get(o);return!P||!P.reactionHandler?Promise.resolve(void 0):(0,h.asPromise)(()=>{const n=P.getCommentThread(f);if(n){const m=n.getCommentByUniqueId(w.uniqueIdInThread);if(P!==void 0&&m&&P.reactionHandler)return P.reactionHandler(m,i(C))}return Promise.resolve(void 0)})}dispose(){}}T.handlePool=0;class b{constructor(o,f,p,w,C,P,n){this._commentControllerHandle=f,this._id=p,this._uri=w,this._range=C,this._comments=P,this.handle=b._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new E.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputDisposables.value=new A.DisposableStore,this._id===void 0&&(this._id=`${o}.${this.handle}`),v.$createCommentThread(f,this.handle,this._id,this._uri,k.Range.from(this._range),n),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=P,this._localDisposables.push({dispose:()=>{v.$deleteCommentThread(f,this.handle)}});const m=this;this.value={get uri(){return m.uri},get range(){return m.range},set range(D){m.range=D},get comments(){return m.comments},set comments(D){m.comments=D},get collapsibleState(){return m.collapsibleState},set collapsibleState(D){m.collapsibleState=D},get canReply(){return m.canReply},set canReply(D){m.canReply=D},get contextValue(){return m.contextValue},set contextValue(D){m.contextValue=D},get label(){return m.label},set label(D){m.label=D},dispose:()=>{m.dispose()}}}set threadId(o){this._id=o}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(o){o.isEqual(this._range)||(this._range=o,this.modifications.range=o,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(o){this._canReply!==o&&(this._canReply=o,this.modifications.canReply=o,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(o){this._label=o,this.modifications.label=o,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(o){this._contextValue=o,this.modifications.contextValue=o,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(o){this._comments=o,this.modifications.comments=o,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(o){this._collapseState=o,this.modifications.collapsibleState=o,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new A.DisposableStore);const o=p=>Object.prototype.hasOwnProperty.call(this.modifications,p),f={};o("range")&&(f.range=k.Range.from(this._range)),o("label")&&(f.label=this.label),o("contextValue")&&(f.contextValue=this.contextValue),o("comments")&&(f.comments=this._comments.map(p=>g(this,p,this._commentsMap))),o("collapsibleState")&&(f.collapseState=s(this._collapseState)),o("canReply")&&(f.canReply=this.canReply),this.modifications={},v.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,f)}getCommentByUniqueId(o){for(let f of this._commentsMap){let p=f[0],w=f[1];if(o===w)return p}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(o=>o.dispose())}}b._handlePool=0,Be([(0,F.debounce)(100)],b.prototype,"eventuallyUpdateCommentThread",null);class c{constructor(o,f,p,w){this._extension=o,this._handle=f,this._id=p,this._label=w,this._threads=new Map,v.$registerCommentController(this.handle,p,w);const C=this;this.value=Object.freeze({id:C.id,label:C.label,get options(){return C.options},set options(P){C.options=P},get commentingRangeProvider(){return C.commentingRangeProvider},set commentingRangeProvider(P){C.commentingRangeProvider=P},get reactionHandler(){return C.reactionHandler},set reactionHandler(P){C.reactionHandler=P},createCommentThread(P,n,m){return C.createCommentThread(P,n,m).value},dispose:()=>{C.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{v.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get reactionHandler(){return this._reactionHandler}set reactionHandler(o){this._reactionHandler=o,v.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!o})}get options(){return this._options}set options(o){this._options=o,v.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(o,f,p,w){if(typeof o=="string"){const C=new b(this.id,this.handle,o,f,p,w,this._extension.identifier);return this._threads.set(C.handle,C),C}else{const C=new b(this.id,this.handle,void 0,o,f,p,this._extension.identifier);return this._threads.set(C.handle,C),C}}$createCommentThreadTemplate(o,f){const p=new b(this.id,this.handle,void 0,R.URI.revive(o),k.Range.to(f),[],this._extension.identifier);return p.collapsibleState=I.CommentThreadCollapsibleState.Expanded,this._threads.set(p.handle,p),p}$updateCommentThreadTemplate(o,f){let p=this._threads.get(o);p&&(p.range=k.Range.to(f))}$deleteCommentThread(o){let f=this._threads.get(o);f&&f.dispose(),this._threads.delete(o)}getCommentThread(o){return this._threads.get(o)}dispose(){this._threads.forEach(o=>{o.dispose()}),this._localDisposables.forEach(o=>o.dispose())}}function g(u,o,f){let p=f.get(o);p||(p=++u.commentHandle,f.set(o,p));const w=o.author&&o.author.iconPath?o.author.iconPath.toString():void 0;return{mode:o.mode,contextValue:o.contextValue,uniqueIdInThread:p,body:k.MarkdownString.from(o.body),userName:o.author.name,userIconPath:w,label:o.label,commentReactions:o.reactions?o.reactions.map(C=>S(C)):void 0}}function S(u){return{label:u.label,iconPath:u.iconPath?k.pathOrURIToURI(u.iconPath):void 0,count:u.count,hasReacted:u.authorHasReacted}}function i(u){return{label:u.label||"",count:u.count||0,iconPath:u.iconPath?R.URI.revive(u.iconPath):"",authorHasReacted:u.hasReacted||!1}}function s(u){if(u!==void 0)switch(u){case t.CommentThreadCollapsibleState.Expanded:return I.CommentThreadCollapsibleState.Expanded;case t.CommentThreadCollapsibleState.Collapsed:return I.CommentThreadCollapsibleState.Collapsed}return I.CommentThreadCollapsibleState.Collapsed}return new T}e.createExtHostComments=r}),define(be[95],Ee([0,1,2,5,6,4,12,14,16,9,17]),function(re,e,h,F,E,A,R,I,y,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let _=class bi{constructor(d,a){this._logService=a,this._provider=new Map,this._proxy=d.getProxy(F.MainContext.MainThreadDecorations)}registerFileDecorationProvider(d,a){const l=bi._handlePool++;this._provider.set(l,{provider:d,extensionId:a}),this._proxy.$registerDecorationProvider(l,a.value);const v=d.onDidChangeFileDecorations&&d.onDidChangeFileDecorations(T=>{if(!T){this._proxy.$onDidChange(l,null);return}let b=(0,y.asArray)(T);if(b.length<=bi._maxEventSize){this._proxy.$onDidChange(l,b);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",a.value,b.length);const c=b.map(i=>({uri:i,rank:(0,k.count)(i.path,"/")})),g=(0,y.groupBy)(c,(i,s)=>i.rank-s.rank||(0,k.compare)(i.uri.path,s.uri.path));let S=[];e:for(let i of g){let s;for(let u of i){let o=(0,t.dirname)(u.uri.path);if(s!==o&&(s=o,S.push(u.uri)>=bi._maxEventSize))break e}}this._proxy.$onDidChange(l,S)});return new E.Disposable(()=>{v?.dispose(),this._proxy.$unregisterDecorationProvider(l),this._provider.delete(l)})}async $provideDecorations(d,a,l){if(!this._provider.has(d))return Object.create(null);const v=Object.create(null),{provider:T,extensionId:b}=this._provider.get(d);return await Promise.all(a.map(async c=>{try{const{uri:g,id:S}=c,i=await Promise.resolve(T.provideFileDecoration(h.URI.revive(g),l));if(!i)return;try{E.FileDecoration.validate(i),v[S]=[i.propagate,i.tooltip,i.badge,i.color]}catch(s){this._logService.warn(`INVALID decoration from extension '${b.value}': ${s}`)}}catch(g){this._logService.error(g)}})),v}};_._handlePool=0,_._maxEventSize=250,_=Be([We(0,R.IExtHostRpcService),We(1,I.ILogService)],_),e.ExtHostDecorations=_,e.IExtHostDecorations=(0,A.createDecorator)("IExtHostDecorations")}),define(be[184],Ee([0,1,123,82,2,5,6,8,3,14,20]),function(re,e,h,F,E,A,R,I,y,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class _{constructor(a,l,v,T,b){this._name=a,this._owner=l,this._maxDiagnosticsPerFile=v,this._proxy=T,this._onDidChangeDiagnostics=b,this._isDisposed=!1,this._data=new t.ResourceMap}dispose(){this._isDisposed||(this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._proxy&&this._proxy.$clear(this._owner),this._data=void 0,this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(a,l){if(!a){this.clear();return}this._checkDisposed();let v=[];if(E.URI.isUri(a)){if(!l){this.delete(a);return}this._data.set(a,l.slice()),v=[a]}else if(Array.isArray(a)){v=[];let b;a=[...a].sort(_._compareIndexedTuplesByUri);for(const c of a){const[g,S]=c;if((!b||g.toString()!==b.toString())&&(b&&this._data.get(b).length===0&&this._data.delete(b),b=g,v.push(g),this._data.set(g,[])),S){const i=this._data.get(g);i&&i.push(...S)}else{const i=this._data.get(g);i&&(i.length=0)}}}if(this._onDidChangeDiagnostics.fire(v),!this._proxy)return;const T=[];for(let b of v){let c=[];const g=this._data.get(b);if(g)if(g.length>this._maxDiagnosticsPerFile){c=[];const S=[R.DiagnosticSeverity.Error,R.DiagnosticSeverity.Warning,R.DiagnosticSeverity.Information,R.DiagnosticSeverity.Hint];e:for(let i=0;i<4;i++)for(let s of g)if(s.severity===S[i]&&c.push(I.Diagnostic.from(s))===this._maxDiagnosticsPerFile)break e;c.push({severity:F.MarkerSeverity.Info,message:(0,h.localize)(0,null,g.length-this._maxDiagnosticsPerFile),startLineNumber:c[c.length-1].startLineNumber,startColumn:c[c.length-1].startColumn,endLineNumber:c[c.length-1].endLineNumber,endColumn:c[c.length-1].endColumn})}else c=g.map(S=>I.Diagnostic.from(S));T.push([b,c])}this._proxy.$changeMany(this._owner,T)}delete(a){this._checkDisposed(),this._onDidChangeDiagnostics.fire([a]),this._data.delete(a),this._proxy&&this._proxy.$changeMany(this._owner,[[a,void 0]])}clear(){this._checkDisposed(),this._onDidChangeDiagnostics.fire([...this._data.keys()]),this._data.clear(),this._proxy&&this._proxy.$clear(this._owner)}forEach(a,l){this._checkDisposed();for(let v of this._data.keys())a.apply(l,[v,this.get(v),this])}get(a){this._checkDisposed();const l=this._data.get(a);return Array.isArray(l)?Object.freeze(l.slice(0)):[]}has(a){return this._checkDisposed(),Array.isArray(this._data.get(a))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(a,l){return a[0].toString()<l[0].toString()?-1:a[0].toString()>l[0].toString()?1:0}}e.DiagnosticCollection=_;let r=class Yt{constructor(a,l){this._logService=l,this._collections=new Map,this._onDidChangeDiagnostics=new y.DebounceEmitter({merge:v=>v.flat(),delay:50}),this.onDidChangeDiagnostics=y.Event.map(this._onDidChangeDiagnostics.event,Yt._mapper),this._proxy=a.getProxy(A.MainContext.MainThreadDiagnostics)}static _mapper(a){const l=new t.ResourceMap;for(const v of a)l.set(v,v);return{uris:Object.freeze(Array.from(l.values()))}}createDiagnosticCollection(a,l){const{_collections:v,_proxy:T,_onDidChangeDiagnostics:b,_logService:c}=this,g=new class{$changeMany(s,u){T.$changeMany(s,u),c.trace("[DiagnosticCollection] change many (extension, owner, uris)",a.value,s,u.length===0?"CLEARING":u)}$clear(s){T.$clear(s),c.trace("[DiagnosticCollection] remove all (extension, owner)",a.value,s)}dispose(){T.dispose()}};let S;if(!l)l="_generated_diagnostic_collection_name_#"+Yt._idPool++,S=l;else if(!v.has(l))S=l;else{this._logService.warn(`DiagnosticCollection with name '${l}' does already exist.`);do S=l+Yt._idPool++;while(v.has(S))}return new class extends _{constructor(){super(l,S,Yt._maxDiagnosticsPerFile,g,b);v.set(S,this)}dispose(){super.dispose(),v.delete(S)}}}getDiagnostics(a){if(a)return this._getDiagnostics(a);{const l=new Map,v=[];for(const T of this._collections.values())T.forEach((b,c)=>{let g=l.get(b.toString());typeof g=="undefined"&&(g=v.length,l.set(b.toString(),g),v.push([b,[]])),v[g][1]=v[g][1].concat(...c)});return v}}_getDiagnostics(a){let l=[];for(let v of this._collections.values())v.has(a)&&(l=l.concat(v.get(a)));return l}$acceptMarkersChange(a){if(!this._mirrorCollection){const l="_generated_mirror",v=new _(l,l,Yt._maxDiagnosticsPerFile,void 0,this._onDidChangeDiagnostics);this._collections.set(l,v),this._mirrorCollection=v}for(const[l,v]of a)this._mirrorCollection.set(E.URI.revive(l),v.map(I.Diagnostic.to))}};r._idPool=0,r._maxDiagnosticsPerFile=1e3,r=Be([We(1,k.ILogService)],r),e.ExtHostDiagnostics=r}),define(be[185],Ee([0,1,2,5]),function(re,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class E{constructor(R){this._proxy=R.getProxy(F.MainContext.MainThreadDialogs)}showOpenDialog(R){return this._proxy.$showOpenDialog(R).then(I=>I?I.map(y=>h.URI.revive(y)):void 0)}showSaveDialog(R){return this._proxy.$showSaveDialog(R).then(I=>I?h.URI.revive(I):void 0)}}e.ExtHostDialogs=E}),define(be[186],Ee([0,1,15,2,6,5,11,21,9]),function(re,e,h,F,E,A,R,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class k{constructor(_,r,d){this._documentsAndEditors=r,this._logService=d,this._documentContentProviders=new Map,this._proxy=_.getProxy(A.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(_,r){if(Object.keys(R.Schemas).indexOf(_)>=0)throw new Error(`scheme '${_}' already registered`);const d=k._handlePool++;this._documentContentProviders.set(d,r),this._proxy.$registerTextContentProvider(d,_);let a;return typeof r.onDidChange=="function"&&(a=r.onDidChange(l=>{if(l.scheme!==_){this._logService.warn(`Provider for scheme '${_}' is firing event for schema '${l.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(l)&&this.$provideTextDocumentContent(d,l).then(v=>{if(!v&&typeof v!="string")return;const T=this._documentsAndEditors.getDocument(l);if(!T)return;const b=(0,y.splitLines)(v);if(!T.equalLines(b))return this._proxy.$onVirtualDocumentChange(l,v)},h.onUnexpectedError)})),new E.Disposable(()=>{this._documentContentProviders.delete(d)&&this._proxy.$unregisterTextContentProvider(d),a&&(a.dispose(),a=void 0)})}$provideTextDocumentContent(_,r){const d=this._documentContentProviders.get(_);return d?Promise.resolve(d.provideTextDocumentContent(F.URI.revive(r),I.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${r.scheme}`))}}e.ExtHostDocumentContentProvider=k,k._handlePool=0}),define(be[187],Ee([0,1,3,7,2,5,88,8,10,22,6]),function(re,e,h,F,E,A,R,I,y,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class _{constructor(d,a){this._onDidAddDocument=new h.Emitter,this._onDidRemoveDocument=new h.Emitter,this._onDidChangeDocument=new h.Emitter,this._onDidSaveDocument=new h.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new F.DisposableStore,this._documentLoader=new Map,this._proxy=d.getProxy(A.MainContext.MainThreadDocuments),this._documentsAndEditors=a,this._documentsAndEditors.onDidRemoveDocuments(l=>{for(const v of l)this._onDidRemoveDocument.fire(v.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(l=>{for(const v of l)this._onDidAddDocument.fire(v.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(d){if(!d)return;const a=this._documentsAndEditors.getDocument(d);if(a)return a}getDocument(d){const a=this.getDocumentData(d);if(!a?.document)throw new Error(`Unable to retrieve document from URI '${d}'`);return a.document}ensureDocumentData(d){const a=this._documentsAndEditors.getDocument(d);if(a)return Promise.resolve(a);let l=this._documentLoader.get(d.toString());return l||(l=this._proxy.$tryOpenDocument(d).then(v=>{this._documentLoader.delete(d.toString());const T=E.URI.revive(v);return(0,y.assertIsDefined)(this._documentsAndEditors.getDocument(T))},v=>(this._documentLoader.delete(d.toString()),Promise.reject(v))),this._documentLoader.set(d.toString(),l)),l}createDocumentData(d){return this._proxy.$tryCreateDocument(d).then(a=>E.URI.revive(a))}$acceptModelModeChanged(d,a){const l=E.URI.revive(d),v=this._documentsAndEditors.getDocument(l);if(!v)throw new Error("unknown document");this._onDidRemoveDocument.fire(v.document),v._acceptLanguageId(a),this._onDidAddDocument.fire(v.document)}$acceptModelSaved(d){const a=E.URI.revive(d),l=this._documentsAndEditors.getDocument(a);if(!l)throw new Error("unknown document");this.$acceptDirtyStateChanged(d,!1),this._onDidSaveDocument.fire(l.document)}$acceptDirtyStateChanged(d,a){const l=E.URI.revive(d),v=this._documentsAndEditors.getDocument(l);if(!v)throw new Error("unknown document");v._acceptIsDirty(a),this._onDidChangeDocument.fire({document:v.document,contentChanges:[],reason:void 0})}$acceptModelChanged(d,a,l){const v=E.URI.revive(d),T=this._documentsAndEditors.getDocument(v);if(!T)throw new Error("unknown document");T._acceptIsDirty(l),T.onEvents(a);let b;a.isUndoing?b=t.TextDocumentChangeReason.Undo:a.isRedoing&&(b=t.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,k.deepFreeze)({document:T.document,contentChanges:a.changes.map(c=>({range:I.Range.to(c.range),rangeOffset:c.rangeOffset,rangeLength:c.rangeLength,text:c.text})),reason:b}))}setWordDefinitionFor(d,a){(0,R.setWordDefinitionFor)(d,a)}}e.ExtHostDocuments=_}),define(be[48],Ee([0,1,39,3,7,2,4,5,88,12,94,8,14,20,11,188,103]),function(re,e,h,F,E,A,R,I,y,k,t,_,r,d,a,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class T{constructor(g){this.value=g,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let b=class{constructor(g,S){this._extHostRpc=g,this._logService=S,this._activeEditorId=null,this._editors=new Map,this._documents=new d.ResourceMap,this._onDidAddDocuments=new F.Emitter,this._onDidRemoveDocuments=new F.Emitter,this._onDidChangeVisibleTextEditors=new F.Emitter,this._onDidChangeActiveTextEditor=new F.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(g){this.acceptDocumentsAndEditorsDelta(g)}acceptDocumentsAndEditorsDelta(g){const S=[],i=[],s=[];if(g.removedDocuments)for(const u of g.removedDocuments){const o=A.URI.revive(u),f=this._documents.get(o);f?.unref()&&(this._documents.delete(o),S.push(f.value))}if(g.addedDocuments)for(const u of g.addedDocuments){const o=A.URI.revive(u.uri);let f=this._documents.get(o);if(f&&o.scheme!==a.Schemas.vscodeNotebookCell&&o.scheme!==a.Schemas.vscodeInteractiveInput)throw new Error(`document '${o} already exists!'`);f||(f=new T(new y.ExtHostDocumentData(this._extHostRpc.getProxy(I.MainContext.MainThreadDocuments),o,u.lines,u.EOL,u.versionId,u.modeId,u.isDirty,u.notebook)),this._documents.set(o,f),i.push(f.value)),f.ref()}if(g.removedEditors)for(const u of g.removedEditors){const o=this._editors.get(u);this._editors.delete(u),o&&s.push(o)}if(g.addedEditors)for(const u of g.addedEditors){const o=A.URI.revive(u.documentUri);h.ok(this._documents.has(o),`document '${o}' does not exist`),h.ok(!this._editors.has(u.id),`editor '${u.id}' already exists!`);const f=this._documents.get(o).value,p=new t.ExtHostTextEditor(u.id,this._extHostRpc.getProxy(I.MainContext.MainThreadTextEditors),this._logService,new v.Lazy(()=>f.document),u.selections.map(_.Selection.to),u.options,u.visibleRanges.map(w=>_.Range.to(w)),typeof u.editorPosition=="number"?_.ViewColumn.to(u.editorPosition):void 0);this._editors.set(u.id,p)}g.newActiveEditor!==void 0&&(h.ok(g.newActiveEditor===null||this._editors.has(g.newActiveEditor),`active editor '${g.newActiveEditor}' does not exist`),this._activeEditorId=g.newActiveEditor),(0,E.dispose)(S),(0,E.dispose)(s),g.removedDocuments&&this._onDidRemoveDocuments.fire(S),g.addedDocuments&&this._onDidAddDocuments.fire(i),(g.removedEditors||g.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(u=>u.value)),g.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(g){return this._documents.get(g)?.value}allDocuments(){return l.Iterable.map(this._documents.values(),g=>g.value)}getEditor(g){return this._editors.get(g)}activeEditor(g){if(!this._activeEditorId)return;const S=this._editors.get(this._activeEditorId);return g?S:S?.value}allEditors(){return[...this._editors.values()]}};b=Be([We(0,k.IExtHostRpcService),We(1,r.ILogService)],b),e.ExtHostDocumentsAndEditors=b,e.IExtHostDocumentsAndEditors=(0,R.createDecorator)("IExtHostDocumentsAndEditors")}),define(be[189],Ee([0,1,2,5,7,6,8,231,9,23]),function(re,e,h,F,E,A,R,I,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class t{constructor(){this._schemes=[]}add(d){this._stateMachine=void 0,this._schemes.push(d)}delete(d){const a=this._schemes.indexOf(d);a>=0&&(this._schemes.splice(a,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const d=this._schemes.sort(),a=[];let l,v,T=14,b=14;for(const c of d){let g=l?(0,y.commonPrefixLength)(l,c):0;for(g===0?v=1:v=b;g<c.length;g++)g+1===c.length?(T=b,b=9):b+=1,a.push([v,c.toUpperCase().charCodeAt(g),b]),a.push([v,c.toLowerCase().charCodeAt(g),b]),v=b;l=c,b=T}a.push([9,58,10]),a.push([10,47,12]),this._stateMachine=new I.StateMachine(a)}}provideDocumentLinks(d){this._initStateMachine();const a=[],l=I.LinkComputer.computeLinks({getLineContent(v){return d.lineAt(v-1).text},getLineCount(){return d.lineCount}},this._stateMachine);for(const v of l){const T=R.DocumentLink.to(v);T.target&&a.push(T)}return a}}class _{constructor(d,a){this._extHostLanguageFeatures=a,this._linkProvider=new t,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._enableProposedApi=new Map,this._handlePool=0,this._proxy=d.getProxy(F.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}_registerLinkProviderIfNotYetRegistered(){this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(void 0,"*",this._linkProvider))}registerFileSystemProvider(d,a,l,v={},T){if(this._registeredSchemes.has(a))throw new Error(`a provider for the scheme '${a}' is already registered`);this._registerLinkProviderIfNotYetRegistered();const b=this._handlePool++;this._linkProvider.add(a),this._registeredSchemes.add(a),this._fsProvider.set(b,l),this._enableProposedApi.set(b,T??!1);let c=2;v.isCaseSensitive&&(c+=1024),v.isReadonly&&(c+=2048),typeof l.copy=="function"&&(c+=8),typeof l.open=="function"&&typeof l.close=="function"&&typeof l.read=="function"&&typeof l.write=="function"&&(c+=4),this._proxy.$registerFileSystemProvider(b,a,c).catch(S=>{console.error(`FAILED to register filesystem provider of ${d.value}-extension for the scheme ${a}`),console.error(S)});const g=l.onDidChangeFile(S=>{const i=[];for(const s of S){let{uri:u,type:o}=s;if(u.scheme!==a)continue;let f;switch(o){case A.FileChangeType.Changed:f=0;break;case A.FileChangeType.Created:f=1;break;case A.FileChangeType.Deleted:f=2;break;default:throw new Error("Unknown FileChangeType")}i.push({resource:u,type:f})}this._proxy.$onFileSystemChange(b,i)});return(0,E.toDisposable)(()=>{g.dispose(),this._linkProvider.delete(a),this._registeredSchemes.delete(a),this._fsProvider.delete(b),this._enableProposedApi.delete(b),this._proxy.$unregisterProvider(b)})}static _asIStat(d,a){const{type:l,ctime:v,mtime:T,size:b,permissions:c}=d;return a?{type:l,ctime:v,mtime:T,size:b,permissions:c}:{type:l,ctime:v,mtime:T,size:b}}$stat(d,a){return Promise.resolve(this._getFsProvider(d).stat(h.URI.revive(a))).then(l=>_._asIStat(l,this._enableProposedApi.get(d)??!1))}$readdir(d,a){return Promise.resolve(this._getFsProvider(d).readDirectory(h.URI.revive(a)))}$readFile(d,a){return Promise.resolve(this._getFsProvider(d).readFile(h.URI.revive(a))).then(l=>k.VSBuffer.wrap(l))}$writeFile(d,a,l,v){return Promise.resolve(this._getFsProvider(d).writeFile(h.URI.revive(a),l.buffer,v))}$delete(d,a,l){return Promise.resolve(this._getFsProvider(d).delete(h.URI.revive(a),l))}$rename(d,a,l,v){return Promise.resolve(this._getFsProvider(d).rename(h.URI.revive(a),h.URI.revive(l),v))}$copy(d,a,l,v){const T=this._getFsProvider(d);if(!T.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(T.copy(h.URI.revive(a),h.URI.revive(l),v))}$mkdir(d,a){return Promise.resolve(this._getFsProvider(d).createDirectory(h.URI.revive(a)))}$watch(d,a,l,v){const T=this._getFsProvider(d).watch(h.URI.revive(l),v);this._watches.set(a,T)}$unwatch(d,a){const l=this._watches.get(a);l&&(l.dispose(),this._watches.delete(a))}$open(d,a,l){const v=this._getFsProvider(d);if(!v.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(v.open(h.URI.revive(a),l))}$close(d,a){const l=this._getFsProvider(d);if(!l.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(l.close(a))}$read(d,a,l,v){const T=this._getFsProvider(d);if(!T.read)throw new Error('FileSystemProvider does not implement "read"');const b=k.VSBuffer.alloc(v);return Promise.resolve(T.read(a,l,b.buffer,0,v)).then(c=>b.slice(0,c))}$write(d,a,l,v){const T=this._getFsProvider(d);if(!T.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(T.write(a,l,v.buffer,0,v.byteLength))}_getFsProvider(d){const a=this._fsProvider.get(d);if(!a){const l=new Error;throw l.name="ENOPRO",l.message="no provider",l}return a}}e.ExtHostFileSystem=_}),define(be[71],Ee([0,1,5,59,6,23,4,12,45]),function(re,e,h,F,E,A,R,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let k=class xt{constructor(_,r){const d=_.getProxy(h.MainContext.MainThreadFileSystem);this.value=Object.freeze({stat(a){return d.$stat(a).catch(xt._handleError)},readDirectory(a){return d.$readdir(a).catch(xt._handleError)},createDirectory(a){return d.$mkdir(a).catch(xt._handleError)},async readFile(a){return d.$readFile(a).then(l=>l.buffer).catch(xt._handleError)},writeFile(a,l){return d.$writeFile(a,A.VSBuffer.wrap(l)).catch(xt._handleError)},delete(a,l){return d.$delete(a,{recursive:!1,useTrash:!1,...l}).catch(xt._handleError)},rename(a,l,v){return d.$rename(a,l,{overwrite:!1,...v}).catch(xt._handleError)},copy(a,l,v){return d.$copy(a,l,{overwrite:!1,...v}).catch(xt._handleError)},isWritableFileSystem(a){const l=r.getCapabilities(a);if(typeof l=="number")return!(l&2048)}})}static _handleError(_){if(!(_ instanceof Error))throw new E.FileSystemError(String(_));if(_.name==="ENOPRO")throw E.FileSystemError.Unavailable(_.message);switch(_.name){case F.FileSystemProviderErrorCode.FileExists:throw E.FileSystemError.FileExists(_.message);case F.FileSystemProviderErrorCode.FileNotFound:throw E.FileSystemError.FileNotFound(_.message);case F.FileSystemProviderErrorCode.FileNotADirectory:throw E.FileSystemError.FileNotADirectory(_.message);case F.FileSystemProviderErrorCode.FileIsADirectory:throw E.FileSystemError.FileIsADirectory(_.message);case F.FileSystemProviderErrorCode.NoPermissions:throw E.FileSystemError.NoPermissions(_.message);case F.FileSystemProviderErrorCode.Unavailable:throw E.FileSystemError.Unavailable(_.message);default:throw new E.FileSystemError(_.message,_.name)}}};k=Be([We(0,I.IExtHostRpcService),We(1,y.IExtHostFileSystemInfo)],k),e.ExtHostConsumerFileSystem=k,e.IExtHostConsumerFileSystem=(0,R.createDecorator)("IExtHostConsumerFileSystem")}),define(be[190],Ee([0,1,2,47]),function(re,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class E{constructor(R,I,y,k){this._extHostNotebooks=I,this._textDocumentsAndEditors=y,this._commands=k;const t=new F.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new F.ApiCommandArgument("showOptions","Show Options",_=>!0,_=>_),new F.ApiCommandArgument("resource","Interactive resource Uri",_=>!0,_=>_),new F.ApiCommandArgument("controllerId","Notebook controller Id",_=>!0,_=>_),new F.ApiCommandArgument("title","Interactive editor title",_=>!0,_=>_)],new F.ApiCommandResult("Notebook and input URI",_=>{if(_.notebookEditorId!==void 0){const r=this._extHostNotebooks.getEditorById(_.notebookEditorId);return{notebookUri:h.URI.revive(_.notebookUri),inputUri:h.URI.revive(_.inputUri),notebookEditor:r.apiEditor}}return{notebookUri:h.URI.revive(_.notebookUri),inputUri:h.URI.revive(_.inputUri)}}));this._commands.registerApiCommand(t)}$willAddInteractiveDocument(R,I,y,k){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:I,lines:[""],modeId:y,uri:R,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(h.URI.revive(k))?.apiNotebook}]})}$willRemoveInteractiveDocument(R,I){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[R]})}}e.ExtHostInteractive=E}),define(be[191],Ee([0,1,7,5]),function(re,e,h,F){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class E{constructor(R){this._handlePool=0,this._proxy=R.getProxy(F.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(R){const I=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(I,R),(0,h.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(I)})}}e.ExtHostLabelService=E}),define(be[192],Ee([0,1,2,22,8,6,5,9,41,16,10,232,7,80,52,62,193,15,3]),function(re,e,h,F,E,A,R,I,y,k,t,_,r,d,a,l,v,T,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.InlineCompletionController=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class c{constructor(x,q){this._documents=x,this._provider=q}async provideDocumentSymbols(x,q){const Z=this._documents.getDocument(x),se=await this._provider.provideDocumentSymbols(Z,q);if(!(0,k.isFalsyOrEmpty)(se))return se[0]instanceof A.DocumentSymbol?se.map(E.DocumentSymbol.from):c._asDocumentSymbolTree(se)}static _asDocumentSymbolTree(x){x=x.slice(0).sort((se,H)=>{let ne=se.location.range.start.compareTo(H.location.range.start);return ne===0&&(ne=H.location.range.end.compareTo(se.location.range.end)),ne});const q=[],Z=[];for(const se of x){const H={name:se.name||"!!MISSING: name!!",kind:E.SymbolKind.from(se.kind),tags:se.tags?.map(E.SymbolTag.from)||[],detail:"",containerName:se.containerName,range:E.Range.from(se.location.range),selectionRange:E.Range.from(se.location.range),children:[]};for(;;){if(Z.length===0){Z.push(H),q.push(H);break}const ne=Z[Z.length-1];if(y.Range.containsRange(ne.range,H.range)&&!y.Range.equalsRange(ne.range,H.range)){ne.children&&ne.children.push(H),Z.push(H);break}Z.pop()}}return q}}class g{constructor(x,q,Z){this._documents=x,this._commands=q,this._provider=Z,this._cache=new l.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(x,q){const Z=this._documents.getDocument(x),se=await this._provider.provideCodeLenses(Z,q);if(!se||q.isCancellationRequested)return;const H=this._cache.add(se),ne=new r.DisposableStore;this._disposables.set(H,ne);const fe={cacheId:H,lenses:[]};for(let Te=0;Te<se.length;Te++)fe.lenses.push({cacheId:[H,Te],range:E.Range.from(se[Te].range),command:this._commands.toInternal(se[Te].command,ne)});return fe}async resolveCodeLens(x,q){const Z=x.cacheId&&this._cache.get(...x.cacheId);if(!Z)return;let se;if(typeof this._provider.resolveCodeLens!="function"||Z.isResolved?se=Z:se=await this._provider.resolveCodeLens(Z,q),se||(se=Z),q.isCancellationRequested)return;const H=x.cacheId&&this._disposables.get(x.cacheId[0]);if(!!H)return x.command=this._commands.toInternal(se.command??g._badCmd,H),x}releaseCodeLenses(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}}g._badCmd={command:"missing",title:"!!MISSING: command!!"};function S(Ke){return Array.isArray(Ke)?Ke.map(E.DefinitionLink.from):Ke?[E.DefinitionLink.from(Ke)]:[]}class i{constructor(x,q){this._documents=x,this._provider=q}async provideDefinition(x,q,Z){const se=this._documents.getDocument(x),H=E.Position.to(q),ne=await this._provider.provideDefinition(se,H,Z);return S(ne)}}class s{constructor(x,q){this._documents=x,this._provider=q}async provideDeclaration(x,q,Z){const se=this._documents.getDocument(x),H=E.Position.to(q),ne=await this._provider.provideDeclaration(se,H,Z);return S(ne)}}class u{constructor(x,q){this._documents=x,this._provider=q}async provideImplementation(x,q,Z){const se=this._documents.getDocument(x),H=E.Position.to(q),ne=await this._provider.provideImplementation(se,H,Z);return S(ne)}}class o{constructor(x,q){this._documents=x,this._provider=q}async provideTypeDefinition(x,q,Z){const se=this._documents.getDocument(x),H=E.Position.to(q),ne=await this._provider.provideTypeDefinition(se,H,Z);return S(ne)}}class f{constructor(x,q){this._documents=x,this._provider=q}async provideHover(x,q,Z){const se=this._documents.getDocument(x),H=E.Position.to(q),ne=await this._provider.provideHover(se,H,Z);if(!(!ne||(0,k.isFalsyOrEmpty)(ne.contents)))return ne.range||(ne.range=se.getWordRangeAtPosition(H)),ne.range||(ne.range=new A.Range(H,H)),E.Hover.from(ne)}}class p{constructor(x,q){this._documents=x,this._provider=q}async provideEvaluatableExpression(x,q,Z){const se=this._documents.getDocument(x),H=E.Position.to(q),ne=await this._provider.provideEvaluatableExpression(se,H,Z);if(ne)return E.EvaluatableExpression.from(ne)}}class w{constructor(x,q){this._documents=x,this._provider=q}async provideInlineValues(x,q,Z,se){const H=this._documents.getDocument(x),ne=await this._provider.provideInlineValues(H,E.Range.to(q),E.InlineValueContext.to(Z),se);if(Array.isArray(ne))return ne.map(fe=>E.InlineValue.from(fe))}}class C{constructor(x,q){this._documents=x,this._provider=q}async provideDocumentHighlights(x,q,Z){const se=this._documents.getDocument(x),H=E.Position.to(q),ne=await this._provider.provideDocumentHighlights(se,H,Z);if(Array.isArray(ne))return ne.map(E.DocumentHighlight.from)}}class P{constructor(x,q){this._documents=x,this._provider=q}async provideLinkedEditingRanges(x,q,Z){const se=this._documents.getDocument(x),H=E.Position.to(q),ne=await this._provider.provideLinkedEditingRanges(se,H,Z);if(ne&&Array.isArray(ne.ranges))return{ranges:(0,k.coalesce)(ne.ranges.map(E.Range.from)),wordPattern:ne.wordPattern}}}class n{constructor(x,q){this._documents=x,this._provider=q}async provideReferences(x,q,Z,se){const H=this._documents.getDocument(x),ne=E.Position.to(q),fe=await this._provider.provideReferences(H,ne,Z,se);if(Array.isArray(fe))return fe.map(E.location.from)}}class m{constructor(x,q,Z,se,H,ne,fe){this._documents=x,this._commands=q,this._diagnostics=Z,this._provider=se,this._logService=H,this._extension=ne,this._apiDeprecation=fe,this._cache=new l.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(x,q,Z,se){const H=this._documents.getDocument(x),ne=_.Selection.isISelection(q)?E.Selection.to(q):E.Range.to(q),fe=[];for(const z of this._diagnostics.getDiagnostics(x))if(ne.intersection(z.range)&&fe.push(z)>m._maxCodeActionsPerFile)break;const Te={diagnostics:fe,only:Z.only?new A.CodeActionKind(Z.only):void 0,triggerKind:E.CodeActionTriggerKind.to(Z.trigger)},xe=await this._provider.provideCodeActions(H,ne,Te,se);if(!(0,k.isNonEmptyArray)(xe)||se.isCancellationRequested)return;const $e=this._cache.add(xe),we=new r.DisposableStore;this._disposables.set($e,we);const Xe=[];for(let z=0;z<xe.length;z++){const K=xe[z];!K||(m._isCommand(K)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Xe.push({_isSynthetic:!0,title:K.title,command:this._commands.toInternal(K,we)})):(Te.only&&(K.kind?Te.only.contains(K.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action is of kind '${K.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${Te.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Xe.push({cacheId:[$e,z],title:K.title,command:K.command&&this._commands.toInternal(K.command,we),diagnostics:K.diagnostics&&K.diagnostics.map(E.Diagnostic.from),edit:K.edit&&E.WorkspaceEdit.from(K.edit),kind:K.kind&&K.kind.value,isPreferred:K.isPreferred,disabled:K.disabled?.reason})))}return{cacheId:$e,actions:Xe}}async resolveCodeAction(x,q){const[Z,se]=x,H=this._cache.get(Z,se);if(!H||m._isCommand(H)||!this._provider.resolveCodeAction)return;const ne=await this._provider.resolveCodeAction(H,q)??H;return ne?.edit?E.WorkspaceEdit.from(ne.edit):void 0}releaseCodeActions(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}static _isCommand(x){return typeof x.command=="string"&&typeof x.title=="string"}}m._maxCodeActionsPerFile=1e3;class D{constructor(x,q){this._documents=x,this._provider=q}async provideDocumentFormattingEdits(x,q,Z){const se=this._documents.getDocument(x),H=await this._provider.provideDocumentFormattingEdits(se,q,Z);if(Array.isArray(H))return H.map(E.TextEdit.from)}}class O{constructor(x,q){this._documents=x,this._provider=q}async provideDocumentRangeFormattingEdits(x,q,Z,se){const H=this._documents.getDocument(x),ne=E.Range.to(q),fe=await this._provider.provideDocumentRangeFormattingEdits(H,ne,Z,se);if(Array.isArray(fe))return fe.map(E.TextEdit.from)}}class ${constructor(x,q){this._documents=x,this._provider=q,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(x,q,Z,se,H){const ne=this._documents.getDocument(x),fe=E.Position.to(q),Te=await this._provider.provideOnTypeFormattingEdits(ne,fe,Z,se,H);if(Array.isArray(Te))return Te.map(E.TextEdit.from)}}class Q{constructor(x,q){this._provider=x,this._logService=q,this._symbolCache=new Map,this._resultCache=new Map}async provideWorkspaceSymbols(x,q){const Z=R.IdObject.mixin({symbols:[]}),se=await this._provider.provideWorkspaceSymbols(x,q);if((0,k.isNonEmptyArray)(se))for(const H of se){if(!H)continue;if(!H.name){this._logService.warn("INVALID SymbolInformation, lacks name",H);continue}const ne=R.IdObject.mixin(E.WorkspaceSymbol.from(H));this._symbolCache.set(ne._id,H),Z.symbols.push(ne)}return Z.symbols.length>0&&this._resultCache.set(Z._id,[Z.symbols[0]._id,Z.symbols[Z.symbols.length-1]._id]),Z}async resolveWorkspaceSymbol(x,q){if(typeof this._provider.resolveWorkspaceSymbol!="function")return x;const Z=this._symbolCache.get(x._id);if(Z){const se=await this._provider.resolveWorkspaceSymbol(Z,q);return se&&(0,F.mixin)(x,E.WorkspaceSymbol.from(se),!0)}}releaseWorkspaceSymbols(x){const q=this._resultCache.get(x);if(q){for(let[Z,se]=q;Z<=se;Z++)this._symbolCache.delete(Z);this._resultCache.delete(x)}}}class ie{constructor(x,q,Z){this._documents=x,this._provider=q,this._logService=Z}static supportsResolving(x){return typeof x.prepareRename=="function"}async provideRenameEdits(x,q,Z,se){const H=this._documents.getDocument(x),ne=E.Position.to(q);try{const fe=await this._provider.provideRenameEdits(H,ne,Z,se);return fe?E.WorkspaceEdit.from(fe):void 0}catch(fe){const Te=ie._asMessage(fe);return Te?{rejectReason:Te,edits:void 0}:Promise.reject(fe)}}async resolveRenameLocation(x,q,Z){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const se=this._documents.getDocument(x),H=E.Position.to(q);try{const ne=await this._provider.prepareRename(se,H,Z);let fe,Te;if(A.Range.isRange(ne)?(fe=ne,Te=se.getText(ne)):(0,t.isObject)(ne)&&(fe=ne.range,Te=ne.placeholder),!fe||!Te)return;if(fe.start.line>H.line||fe.end.line<H.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:E.Range.from(fe),text:Te}}catch(ne){const fe=ie._asMessage(ne);return fe?{rejectReason:fe,range:void 0,text:void 0}:Promise.reject(ne)}}static _asMessage(x){return typeof x=="string"?x:x instanceof Error&&typeof x.message=="string"?x.message:void 0}}class V{constructor(x,q){this.resultId=x,this.tokens=q}}class W{constructor(x,q){this._documents=x,this._provider=q,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(x,q,Z){const se=this._documents.getDocument(x),H=q!==0?this._previousResults.get(q):null;let ne=typeof H?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(se,H.resultId,Z):await this._provider.provideDocumentSemanticTokens(se,Z);return H&&this._previousResults.delete(q),ne?(ne=W._fixProvidedSemanticTokens(ne),this._send(W._convertToEdits(H,ne),ne)):null}async releaseDocumentSemanticColoring(x){this._previousResults.delete(x)}static _fixProvidedSemanticTokens(x){return W._isSemanticTokens(x)?W._isCorrectSemanticTokens(x)?x:new A.SemanticTokens(new Uint32Array(x.data),x.resultId):W._isSemanticTokensEdits(x)?W._isCorrectSemanticTokensEdits(x)?x:new A.SemanticTokensEdits(x.edits.map(q=>new A.SemanticTokensEdit(q.start,q.deleteCount,q.data?new Uint32Array(q.data):q.data)),x.resultId):x}static _isSemanticTokens(x){return x&&!!x.data}static _isCorrectSemanticTokens(x){return x.data instanceof Uint32Array}static _isSemanticTokensEdits(x){return x&&Array.isArray(x.edits)}static _isCorrectSemanticTokensEdits(x){for(const q of x.edits)if(!(q.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(x,q){if(!W._isSemanticTokens(q)||!x||!x.tokens)return q;const Z=x.tokens,se=Z.length,H=q.data,ne=H.length;let fe=0;const Te=Math.min(se,ne);for(;fe<Te&&Z[fe]===H[fe];)fe++;if(fe===se&&fe===ne)return new A.SemanticTokensEdits([],q.resultId);let xe=0;const $e=Te-fe;for(;xe<$e&&Z[se-xe-1]===H[ne-xe-1];)xe++;return new A.SemanticTokensEdits([{start:fe,deleteCount:se-fe-xe,data:H.subarray(fe,ne-xe)}],q.resultId)}_send(x,q){if(W._isSemanticTokens(x)){const Z=this._nextResultId++;return this._previousResults.set(Z,new V(x.resultId,x.data)),(0,d.encodeSemanticTokensDto)({id:Z,type:"full",data:x.data})}if(W._isSemanticTokensEdits(x)){const Z=this._nextResultId++;return W._isSemanticTokens(q)?this._previousResults.set(Z,new V(q.resultId,q.data)):this._previousResults.set(Z,new V(x.resultId)),(0,d.encodeSemanticTokensDto)({id:Z,type:"delta",deltas:(x.edits||[]).map(se=>({start:se.start,deleteCount:se.deleteCount,data:se.data}))})}return null}}e.DocumentSemanticTokensAdapter=W;class L{constructor(x,q){this._documents=x,this._provider=q}async provideDocumentRangeSemanticTokens(x,q,Z){const se=this._documents.getDocument(x),H=await this._provider.provideDocumentRangeSemanticTokens(se,E.Range.to(q),Z);return H?this._send(H):null}_send(x){return(0,d.encodeSemanticTokensDto)({id:0,type:"full",data:x.data})}}e.DocumentRangeSemanticTokensAdapter=L;class Y{constructor(x,q,Z,se,H){this._documents=x,this._commands=q,this._provider=Z,this._apiDeprecation=se,this._extension=H,this._cache=new l.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(x){return typeof x.resolveCompletionItem=="function"}async provideCompletionItems(x,q,Z,se){const H=this._documents.getDocument(x),ne=E.Position.to(q),fe=H.getWordRangeAtPosition(ne)||new A.Range(ne,ne),Te=fe.with({end:ne}),xe=new v.StopWatch(!0),$e=await this._provider.provideCompletionItems(H,ne,se,E.CompletionContext.to(Z));if(!$e||se.isCancellationRequested)return;const we=Array.isArray($e)?new A.CompletionList($e):$e,Xe=Y.supportsResolving(this._provider)?this._cache.add(we.items):this._cache.add([]),z=new r.DisposableStore;this._disposables.set(Xe,z);const K=[],he={x:Xe,b:K,a:{replace:E.Range.from(fe),insert:E.Range.from(Te)},c:we.isIncomplete||void 0,d:xe.elapsed()};for(let Le=0;Le<we.items.length;Le++){const Ve=we.items[Le],tt=this._convertCompletionItem(Ve,[Xe,Le],Te,fe);K.push(tt)}return he}async resolveCompletionItem(x,q){if(typeof this._provider.resolveCompletionItem!="function")return;const Z=this._cache.get(...x);if(!Z)return;const se=await this._provider.resolveCompletionItem(Z,q);if(!!se)return this._convertCompletionItem(se,x)}releaseCompletionItems(x){this._disposables.get(x)?.dispose(),this._disposables.delete(x),this._cache.delete(x)}_convertCompletionItem(x,q,Z,se){const H=this._disposables.get(q[0]);if(!H)throw Error("DisposableStore is missing...");const ne={x:q,a:x.label,b:x.kind!==void 0?E.CompletionItemKind.from(x.kind):void 0,n:x.tags&&x.tags.map(E.CompletionItemTag.from),c:x.detail,d:typeof x.documentation=="undefined"?void 0:E.MarkdownString.fromStrict(x.documentation),e:x.sortText!==x.label?x.sortText:void 0,f:x.filterText!==x.label?x.filterText:void 0,g:x.preselect||void 0,i:x.keepWhitespace?1:0,k:x.commitCharacters,l:x.additionalTextEdits&&x.additionalTextEdits.map(E.TextEdit.from),m:this._commands.toInternal(x.command,H)};x.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ne.h=x.textEdit.newText):typeof x.insertText=="string"?ne.h=x.insertText:x.insertText instanceof A.SnippetString&&(ne.h=x.insertText.value,ne.i|=4);let fe;return x.textEdit?fe=x.textEdit.range:x.range&&(fe=x.range),A.Range.isRange(fe)?ne.j=E.Range.from(fe):fe&&(!Z?.isEqual(fe.inserting)||!se?.isEqual(fe.replacing))&&(ne.j={insert:E.Range.from(fe.inserting),replace:E.Range.from(fe.replacing)}),ne}}class B{constructor(x,q,Z){this._documents=x,this._provider=q,this._commands=Z,this._cache=new l.Cache("InlineCompletionItem"),this._disposables=new Map}async provideInlineCompletions(x,q,Z,se){const H=this._documents.getDocument(x),ne=E.Position.to(q),fe=await this._provider.provideInlineCompletionItems(H,ne,Z,se);if(!fe||se.isCancellationRequested)return;const Te=(0,t.isArray)(fe)?{items:fe}:fe,xe=this._cache.add(Te.items);let $e;return{pid:xe,items:Te.items.map((we,Xe)=>{let z;return we.command&&($e||($e=new r.DisposableStore,this._disposables.set(xe,$e)),z=this._commands.toInternal(we.command,$e)),{text:we.text,range:we.range?E.Range.from(we.range):void 0,command:z,idx:Xe}})}}disposeCompletions(x){this._cache.delete(x);const q=this._disposables.get(x);q&&q.clear(),this._disposables.delete(x)}handleDidShowCompletionItem(x,q){const Z=this._cache.get(x,q);Z&&G.get(this._provider).fireOnDidShowCompletionItem({completionItem:Z})}}class G{constructor(){this._onDidShowCompletionItemEmitter=new b.Emitter,this.onDidShowCompletionItem=this._onDidShowCompletionItemEmitter.event}static get(x){let q=G.map.get(x);return q||(q=new G,G.map.set(x,q)),q}fireOnDidShowCompletionItem(x){this._onDidShowCompletionItemEmitter.fire(x)}}e.InlineCompletionController=G,G.map=new WeakMap;class de{constructor(x,q){this._documents=x,this._provider=q,this._cache=new l.Cache("SignatureHelp")}async provideSignatureHelp(x,q,Z,se){const H=this._documents.getDocument(x),ne=E.Position.to(q),fe=this.reviveContext(Z),Te=await this._provider.provideSignatureHelp(H,ne,se,fe);if(Te){const xe=this._cache.add([Te]);return{...E.SignatureHelp.from(Te),id:xe}}}reviveContext(x){let q;if(x.activeSignatureHelp){const Z=E.SignatureHelp.to(x.activeSignatureHelp),se=this._cache.get(x.activeSignatureHelp.id,0);se?(q=se,q.activeSignature=Z.activeSignature,q.activeParameter=Z.activeParameter):q=Z}return{...x,activeSignatureHelp:q}}releaseSignatureHelp(x){this._cache.delete(x)}}class j{constructor(x,q){this._documents=x,this._provider=q}async provideInlayHints(x,q,Z){const se=this._documents.getDocument(x),H=await this._provider.provideInlayHints(se,E.Range.to(q),Z);return H?{hints:H.map(E.InlayHint.from)}:void 0}}class le{constructor(x,q){this._documents=x,this._provider=q,this._cache=new l.Cache("DocumentLink")}async provideLinks(x,q){const Z=this._documents.getDocument(x),se=await this._provider.provideDocumentLinks(Z,q);if(!(!Array.isArray(se)||se.length===0)&&!q.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:se.filter(le._validateLink).map(E.DocumentLink.from)};{const H=this._cache.add(se),ne={links:[],id:H};for(let fe=0;fe<se.length;fe++){if(!le._validateLink(se[fe]))continue;const Te=E.DocumentLink.from(se[fe]);Te.cacheId=[H,fe],ne.links.push(Te)}return ne}}}static _validateLink(x){return x.target&&x.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(x,q){if(typeof this._provider.resolveDocumentLink!="function")return;const Z=this._cache.get(...x);if(!Z)return;const se=await this._provider.resolveDocumentLink(Z,q);if(!(!se||!le._validateLink(se)))return E.DocumentLink.from(se)}releaseLinks(x){this._cache.delete(x)}}class ae{constructor(x,q){this._documents=x,this._provider=q}async provideColors(x,q){const Z=this._documents.getDocument(x),se=await this._provider.provideDocumentColors(Z,q);return Array.isArray(se)?se.map(ne=>({color:E.Color.from(ne.color),range:E.Range.from(ne.range)})):[]}async provideColorPresentations(x,q,Z){const se=this._documents.getDocument(x),H=E.Range.to(q.range),ne=E.Color.to(q.color),fe=await this._provider.provideColorPresentations(ne,{document:se,range:H},Z);if(!!Array.isArray(fe))return fe.map(E.ColorPresentation.from)}}class ve{constructor(x,q){this._documents=x,this._provider=q}async provideFoldingRanges(x,q,Z){const se=this._documents.getDocument(x),H=await this._provider.provideFoldingRanges(se,q,Z);if(!!Array.isArray(H))return H.map(E.FoldingRange.from)}}class Re{constructor(x,q,Z){this._documents=x,this._provider=q,this._logService=Z}async provideSelectionRanges(x,q,Z){const se=this._documents.getDocument(x),H=q.map(E.Position.to),ne=await this._provider.provideSelectionRanges(se,H,Z);if(!(0,k.isNonEmptyArray)(ne))return[];if(ne.length!==H.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const fe=[];for(let Te=0;Te<H.length;Te++){const xe=[];fe.push(xe);let $e=H[Te],we=ne[Te];for(;;){if(!we.range.contains($e))throw new Error("INVALID selection range, must contain the previous range");if(xe.push(E.SelectionRange.from(we)),!we.parent)break;$e=we.range,we=we.parent}}return fe}}class Fe{constructor(x,q){this._documents=x,this._provider=q,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(x,q,Z){const se=this._documents.getDocument(x),H=E.Position.to(q),ne=await this._provider.prepareCallHierarchy(se,H,Z);if(!ne)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(ne)?ne.map(Te=>this._cacheAndConvertItem(fe,Te)):[this._cacheAndConvertItem(fe,ne)]}async provideCallsTo(x,q,Z){const se=this._itemFromCache(x,q);if(!se)throw new Error("missing call hierarchy item");const H=await this._provider.provideCallHierarchyIncomingCalls(se,Z);if(!!H)return H.map(ne=>({from:this._cacheAndConvertItem(x,ne.from),fromRanges:ne.fromRanges.map(fe=>E.Range.from(fe))}))}async provideCallsFrom(x,q,Z){const se=this._itemFromCache(x,q);if(!se)throw new Error("missing call hierarchy item");const H=await this._provider.provideCallHierarchyOutgoingCalls(se,Z);if(!!H)return H.map(ne=>({to:this._cacheAndConvertItem(x,ne.to),fromRanges:ne.fromRanges.map(fe=>E.Range.from(fe))}))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,q){const Z=this._cache.get(x),se=E.CallHierarchyItem.from(q,x,Z.size.toString(36));return Z.set(se._itemId,q),se}_itemFromCache(x,q){return this._cache.get(x)?.get(q)}}class Ne{constructor(x,q){this._documents=x,this._provider=q,this._idPool=new a.IdGenerator(""),this._cache=new Map}async prepareSession(x,q,Z){const se=this._documents.getDocument(x),H=E.Position.to(q),ne=await this._provider.prepareTypeHierarchy(se,H,Z);if(!ne)return;const fe=this._idPool.nextId();return this._cache.set(fe,new Map),Array.isArray(ne)?ne.map(Te=>this._cacheAndConvertItem(fe,Te)):[this._cacheAndConvertItem(fe,ne)]}async provideSupertypes(x,q,Z){const se=this._itemFromCache(x,q);if(!se)throw new Error("missing type hierarchy item");const H=await this._provider.provideTypeHierarchySupertypes(se,Z);if(!!H)return H.map(ne=>this._cacheAndConvertItem(x,ne))}async provideSubtypes(x,q,Z){const se=this._itemFromCache(x,q);if(!se)throw new Error("missing type hierarchy item");const H=await this._provider.provideTypeHierarchySubtypes(se,Z);if(!!H)return H.map(ne=>this._cacheAndConvertItem(x,ne))}releaseSession(x){this._cache.delete(x)}_cacheAndConvertItem(x,q){const Z=this._cache.get(x),se=E.TypeHierarchyItem.from(q,x,Z.size.toString(36));return Z.set(se._itemId,q),se}_itemFromCache(x,q){return this._cache.get(x)?.get(q)}}class Qe{constructor(x,q){this.adapter=x,this.extension=q}}class He{constructor(x,q,Z,se,H,ne,fe){this._adapter=new Map,this._uriTransformer=q,this._proxy=x.getProxy(R.MainContext.MainThreadLanguageFeatures),this._documents=Z,this._commands=se,this._diagnostics=H,this._logService=ne,this._apiDeprecation=fe}_transformDocumentSelector(x){return(0,k.coalesce)((0,k.asArray)(x).map(q=>this._doTransformDocumentSelector(q)))}_doTransformDocumentSelector(x){if(typeof x=="string")return{$serialized:!0,language:x};if(x)return{$serialized:!0,language:x.language,scheme:this._transformScheme(x.scheme),pattern:typeof x.pattern=="undefined"?void 0:E.GlobPattern.from(x.pattern),exclusive:x.exclusive}}_transformScheme(x){return this._uriTransformer&&typeof x=="string"?this._uriTransformer.transformOutgoingScheme(x):x}_createDisposable(x){return new A.Disposable(()=>{this._adapter.delete(x),this._proxy.$unregister(x)})}_nextHandle(){return He._handlePool++}_withAdapter(x,q,Z,se,H=!1){const ne=this._adapter.get(x);if(!ne)return Promise.resolve(se);if(ne.adapter instanceof q){let fe;ne.extension&&(fe=Date.now(),this._logService.trace(`[${ne.extension.identifier.value}] INVOKE provider '${q.name}'`));const Te=Z(ne.adapter,ne.extension),xe=ne.extension;return xe&&Promise.resolve(Te).then(()=>this._logService.trace(`[${xe.identifier.value}] provider DONE after ${Date.now()-fe}ms`),$e=>{H&&$e instanceof T.CancellationError||(this._logService.error(`[${xe.identifier.value}] provider FAILED`),this._logService.error($e))}),Te}return Promise.reject(new Error("no adapter found"))}_addNewAdapter(x,q){const Z=this._nextHandle();return this._adapter.set(Z,new Qe(x,q)),Z}static _extLabel(x){return x.displayName||x.name}registerDocumentSymbolProvider(x,q,Z,se){const H=this._addNewAdapter(new c(this._documents,Z),x),ne=se&&se.label||He._extLabel(x);return this._proxy.$registerDocumentSymbolProvider(H,this._transformDocumentSelector(q),ne),this._createDisposable(H)}$provideDocumentSymbols(x,q,Z){return this._withAdapter(x,c,se=>se.provideDocumentSymbols(h.URI.revive(q),Z),void 0)}registerCodeLensProvider(x,q,Z){const se=this._nextHandle(),H=typeof Z.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(se,new Qe(new g(this._documents,this._commands.converter,Z),x)),this._proxy.$registerCodeLensSupport(se,this._transformDocumentSelector(q),H);let ne=this._createDisposable(se);if(H!==void 0){const fe=Z.onDidChangeCodeLenses(Te=>this._proxy.$emitCodeLensEvent(H));ne=A.Disposable.from(ne,fe)}return ne}$provideCodeLenses(x,q,Z){return this._withAdapter(x,g,se=>se.provideCodeLenses(h.URI.revive(q),Z),void 0)}$resolveCodeLens(x,q,Z){return this._withAdapter(x,g,se=>se.resolveCodeLens(q,Z),void 0)}$releaseCodeLenses(x,q){this._withAdapter(x,g,Z=>Promise.resolve(Z.releaseCodeLenses(q)),void 0)}registerDefinitionProvider(x,q,Z){const se=this._addNewAdapter(new i(this._documents,Z),x);return this._proxy.$registerDefinitionSupport(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideDefinition(x,q,Z,se){return this._withAdapter(x,i,H=>H.provideDefinition(h.URI.revive(q),Z,se),[])}registerDeclarationProvider(x,q,Z){const se=this._addNewAdapter(new s(this._documents,Z),x);return this._proxy.$registerDeclarationSupport(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideDeclaration(x,q,Z,se){return this._withAdapter(x,s,H=>H.provideDeclaration(h.URI.revive(q),Z,se),[])}registerImplementationProvider(x,q,Z){const se=this._addNewAdapter(new u(this._documents,Z),x);return this._proxy.$registerImplementationSupport(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideImplementation(x,q,Z,se){return this._withAdapter(x,u,H=>H.provideImplementation(h.URI.revive(q),Z,se),[])}registerTypeDefinitionProvider(x,q,Z){const se=this._addNewAdapter(new o(this._documents,Z),x);return this._proxy.$registerTypeDefinitionSupport(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideTypeDefinition(x,q,Z,se){return this._withAdapter(x,o,H=>H.provideTypeDefinition(h.URI.revive(q),Z,se),[])}registerHoverProvider(x,q,Z,se){const H=this._addNewAdapter(new f(this._documents,Z),x);return this._proxy.$registerHoverProvider(H,this._transformDocumentSelector(q)),this._createDisposable(H)}$provideHover(x,q,Z,se){return this._withAdapter(x,f,H=>H.provideHover(h.URI.revive(q),Z,se),void 0)}registerEvaluatableExpressionProvider(x,q,Z,se){const H=this._addNewAdapter(new p(this._documents,Z),x);return this._proxy.$registerEvaluatableExpressionProvider(H,this._transformDocumentSelector(q)),this._createDisposable(H)}$provideEvaluatableExpression(x,q,Z,se){return this._withAdapter(x,p,H=>H.provideEvaluatableExpression(h.URI.revive(q),Z,se),void 0)}registerInlineValuesProvider(x,q,Z,se){const H=typeof Z.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ne=this._addNewAdapter(new w(this._documents,Z),x);this._proxy.$registerInlineValuesProvider(ne,this._transformDocumentSelector(q),H);let fe=this._createDisposable(ne);if(H!==void 0){const Te=Z.onDidChangeInlineValues(xe=>this._proxy.$emitInlineValuesEvent(H));fe=A.Disposable.from(fe,Te)}return fe}$provideInlineValues(x,q,Z,se,H){return this._withAdapter(x,w,ne=>ne.provideInlineValues(h.URI.revive(q),Z,se,H),void 0)}registerDocumentHighlightProvider(x,q,Z){const se=this._addNewAdapter(new C(this._documents,Z),x);return this._proxy.$registerDocumentHighlightProvider(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideDocumentHighlights(x,q,Z,se){return this._withAdapter(x,C,H=>H.provideDocumentHighlights(h.URI.revive(q),Z,se),void 0)}registerLinkedEditingRangeProvider(x,q,Z){const se=this._addNewAdapter(new P(this._documents,Z),x);return this._proxy.$registerLinkedEditingRangeProvider(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideLinkedEditingRanges(x,q,Z,se){return this._withAdapter(x,P,async H=>{const ne=await H.provideLinkedEditingRanges(h.URI.revive(q),Z,se);if(ne)return{ranges:ne.ranges,wordPattern:ne.wordPattern?He._serializeRegExp(ne.wordPattern):void 0}},void 0)}registerReferenceProvider(x,q,Z){const se=this._addNewAdapter(new n(this._documents,Z),x);return this._proxy.$registerReferenceSupport(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideReferences(x,q,Z,se,H){return this._withAdapter(x,n,ne=>ne.provideReferences(h.URI.revive(q),Z,se,H),void 0)}registerCodeActionProvider(x,q,Z,se){const H=new r.DisposableStore,ne=this._addNewAdapter(new m(this._documents,this._commands.converter,this._diagnostics,Z,this._logService,x,this._apiDeprecation),x);return this._proxy.$registerQuickFixSupport(ne,this._transformDocumentSelector(q),{providedKinds:se?.providedCodeActionKinds?.map(fe=>fe.value),documentation:se?.documentation?.map(fe=>({kind:fe.kind.value,command:this._commands.converter.toInternal(fe.command,H)}))},He._extLabel(x),Boolean(Z.resolveCodeAction)),H.add(this._createDisposable(ne)),H}$provideCodeActions(x,q,Z,se,H){return this._withAdapter(x,m,ne=>ne.provideCodeActions(h.URI.revive(q),Z,se,H),void 0)}$resolveCodeAction(x,q,Z){return this._withAdapter(x,m,se=>se.resolveCodeAction(q,Z),void 0)}$releaseCodeActions(x,q){this._withAdapter(x,m,Z=>Promise.resolve(Z.releaseCodeActions(q)),void 0)}registerDocumentFormattingEditProvider(x,q,Z){const se=this._addNewAdapter(new D(this._documents,Z),x);return this._proxy.$registerDocumentFormattingSupport(se,this._transformDocumentSelector(q),x.identifier,x.displayName||x.name),this._createDisposable(se)}$provideDocumentFormattingEdits(x,q,Z,se){return this._withAdapter(x,D,H=>H.provideDocumentFormattingEdits(h.URI.revive(q),Z,se),void 0)}registerDocumentRangeFormattingEditProvider(x,q,Z){const se=this._addNewAdapter(new O(this._documents,Z),x);return this._proxy.$registerRangeFormattingSupport(se,this._transformDocumentSelector(q),x.identifier,x.displayName||x.name),this._createDisposable(se)}$provideDocumentRangeFormattingEdits(x,q,Z,se,H){return this._withAdapter(x,O,ne=>ne.provideDocumentRangeFormattingEdits(h.URI.revive(q),Z,se,H),void 0)}registerOnTypeFormattingEditProvider(x,q,Z,se){const H=this._addNewAdapter(new $(this._documents,Z),x);return this._proxy.$registerOnTypeFormattingSupport(H,this._transformDocumentSelector(q),se,x.identifier),this._createDisposable(H)}$provideOnTypeFormattingEdits(x,q,Z,se,H,ne){return this._withAdapter(x,$,fe=>fe.provideOnTypeFormattingEdits(h.URI.revive(q),Z,se,H,ne),void 0)}registerWorkspaceSymbolProvider(x,q){const Z=this._addNewAdapter(new Q(q,this._logService),x);return this._proxy.$registerNavigateTypeSupport(Z),this._createDisposable(Z)}$provideWorkspaceSymbols(x,q,Z){return this._withAdapter(x,Q,se=>se.provideWorkspaceSymbols(q,Z),{symbols:[]})}$resolveWorkspaceSymbol(x,q,Z){return this._withAdapter(x,Q,se=>se.resolveWorkspaceSymbol(q,Z),void 0)}$releaseWorkspaceSymbols(x,q){this._withAdapter(x,Q,Z=>Z.releaseWorkspaceSymbols(q),void 0)}registerRenameProvider(x,q,Z){const se=this._addNewAdapter(new ie(this._documents,Z,this._logService),x);return this._proxy.$registerRenameSupport(se,this._transformDocumentSelector(q),ie.supportsResolving(Z)),this._createDisposable(se)}$provideRenameEdits(x,q,Z,se,H){return this._withAdapter(x,ie,ne=>ne.provideRenameEdits(h.URI.revive(q),Z,se,H),void 0)}$resolveRenameLocation(x,q,Z,se){return this._withAdapter(x,ie,H=>H.resolveRenameLocation(h.URI.revive(q),Z,se),void 0)}registerDocumentSemanticTokensProvider(x,q,Z,se){const H=this._nextHandle(),ne=typeof Z.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._adapter.set(H,new Qe(new W(this._documents,Z),x)),this._proxy.$registerDocumentSemanticTokensProvider(H,this._transformDocumentSelector(q),se,ne);let fe=this._createDisposable(H);if(ne){const Te=Z.onDidChangeSemanticTokens(xe=>this._proxy.$emitDocumentSemanticTokensEvent(ne));fe=A.Disposable.from(fe,Te)}return fe}$provideDocumentSemanticTokens(x,q,Z,se){return this._withAdapter(x,W,H=>H.provideDocumentSemanticTokens(h.URI.revive(q),Z,se),null,!0)}$releaseDocumentSemanticTokens(x,q){this._withAdapter(x,W,Z=>Z.releaseDocumentSemanticColoring(q),void 0)}registerDocumentRangeSemanticTokensProvider(x,q,Z,se){const H=this._addNewAdapter(new L(this._documents,Z),x);return this._proxy.$registerDocumentRangeSemanticTokensProvider(H,this._transformDocumentSelector(q),se),this._createDisposable(H)}$provideDocumentRangeSemanticTokens(x,q,Z,se){return this._withAdapter(x,L,H=>H.provideDocumentRangeSemanticTokens(h.URI.revive(q),Z,se),null,!0)}registerCompletionItemProvider(x,q,Z,se){const H=this._addNewAdapter(new Y(this._documents,this._commands.converter,Z,this._apiDeprecation,x),x);return this._proxy.$registerSuggestSupport(H,this._transformDocumentSelector(q),se,Y.supportsResolving(Z),`${x.identifier.value}(${se.join("")})`),this._createDisposable(H)}$provideCompletionItems(x,q,Z,se,H){return this._withAdapter(x,Y,ne=>ne.provideCompletionItems(h.URI.revive(q),Z,se,H),void 0)}$resolveCompletionItem(x,q,Z){return this._withAdapter(x,Y,se=>se.resolveCompletionItem(q,Z),void 0)}$releaseCompletionItems(x,q){this._withAdapter(x,Y,Z=>Z.releaseCompletionItems(q),void 0)}registerInlineCompletionsProvider(x,q,Z){const se=this._addNewAdapter(new B(this._documents,Z,this._commands.converter),x);return this._proxy.$registerInlineCompletionsSupport(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideInlineCompletions(x,q,Z,se,H){return this._withAdapter(x,B,ne=>ne.provideInlineCompletions(h.URI.revive(q),Z,se,H),void 0)}$handleInlineCompletionDidShow(x,q,Z){this._withAdapter(x,B,async se=>{se.handleDidShowCompletionItem(q,Z)},void 0)}$freeInlineCompletionsList(x,q){this._withAdapter(x,B,async Z=>{Z.disposeCompletions(q)},void 0)}registerSignatureHelpProvider(x,q,Z,se){const H=Array.isArray(se)?{triggerCharacters:se,retriggerCharacters:[]}:se,ne=this._addNewAdapter(new de(this._documents,Z),x);return this._proxy.$registerSignatureHelpProvider(ne,this._transformDocumentSelector(q),H),this._createDisposable(ne)}$provideSignatureHelp(x,q,Z,se,H){return this._withAdapter(x,de,ne=>ne.provideSignatureHelp(h.URI.revive(q),Z,se,H),void 0)}$releaseSignatureHelp(x,q){this._withAdapter(x,de,Z=>Z.releaseSignatureHelp(q),void 0)}registerInlayHintsProvider(x,q,Z){const se=typeof Z.onDidChangeInlayHints=="function"?this._nextHandle():void 0,H=this._addNewAdapter(new j(this._documents,Z),x);this._proxy.$registerInlayHintsProvider(H,this._transformDocumentSelector(q),se);let ne=this._createDisposable(H);if(se!==void 0){const fe=Z.onDidChangeInlayHints(Te=>this._proxy.$emitInlayHintsEvent(se));ne=A.Disposable.from(ne,fe)}return ne}$provideInlayHints(x,q,Z,se){return this._withAdapter(x,j,H=>H.provideInlayHints(h.URI.revive(q),Z,se),void 0)}registerDocumentLinkProvider(x,q,Z){const se=this._addNewAdapter(new le(this._documents,Z),x);return this._proxy.$registerDocumentLinkProvider(se,this._transformDocumentSelector(q),typeof Z.resolveDocumentLink=="function"),this._createDisposable(se)}$provideDocumentLinks(x,q,Z){return this._withAdapter(x,le,se=>se.provideLinks(h.URI.revive(q),Z),void 0)}$resolveDocumentLink(x,q,Z){return this._withAdapter(x,le,se=>se.resolveLink(q,Z),void 0)}$releaseDocumentLinks(x,q){this._withAdapter(x,le,Z=>Z.releaseLinks(q),void 0)}registerColorProvider(x,q,Z){const se=this._addNewAdapter(new ae(this._documents,Z),x);return this._proxy.$registerDocumentColorProvider(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideDocumentColors(x,q,Z){return this._withAdapter(x,ae,se=>se.provideColors(h.URI.revive(q),Z),[])}$provideColorPresentations(x,q,Z,se){return this._withAdapter(x,ae,H=>H.provideColorPresentations(h.URI.revive(q),Z,se),void 0)}registerFoldingRangeProvider(x,q,Z){const se=this._nextHandle(),H=typeof Z.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(se,new Qe(new ve(this._documents,Z),x)),this._proxy.$registerFoldingRangeProvider(se,this._transformDocumentSelector(q),H);let ne=this._createDisposable(se);if(H!==void 0){const fe=Z.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(H));ne=A.Disposable.from(ne,fe)}return ne}$provideFoldingRanges(x,q,Z,se){return this._withAdapter(x,ve,H=>H.provideFoldingRanges(h.URI.revive(q),Z,se),void 0)}registerSelectionRangeProvider(x,q,Z){const se=this._addNewAdapter(new Re(this._documents,Z,this._logService),x);return this._proxy.$registerSelectionRangeProvider(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$provideSelectionRanges(x,q,Z,se){return this._withAdapter(x,Re,H=>H.provideSelectionRanges(h.URI.revive(q),Z,se),[])}registerCallHierarchyProvider(x,q,Z){const se=this._addNewAdapter(new Fe(this._documents,Z),x);return this._proxy.$registerCallHierarchyProvider(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$prepareCallHierarchy(x,q,Z,se){return this._withAdapter(x,Fe,H=>Promise.resolve(H.prepareSession(h.URI.revive(q),Z,se)),void 0)}$provideCallHierarchyIncomingCalls(x,q,Z,se){return this._withAdapter(x,Fe,H=>H.provideCallsTo(q,Z,se),void 0)}$provideCallHierarchyOutgoingCalls(x,q,Z,se){return this._withAdapter(x,Fe,H=>H.provideCallsFrom(q,Z,se),void 0)}$releaseCallHierarchy(x,q){this._withAdapter(x,Fe,Z=>Promise.resolve(Z.releaseSession(q)),void 0)}registerTypeHierarchyProvider(x,q,Z){const se=this._addNewAdapter(new Ne(this._documents,Z),x);return this._proxy.$registerTypeHierarchyProvider(se,this._transformDocumentSelector(q)),this._createDisposable(se)}$prepareTypeHierarchy(x,q,Z,se){return this._withAdapter(x,Ne,H=>Promise.resolve(H.prepareSession(h.URI.revive(q),Z,se)),void 0)}$provideTypeHierarchySupertypes(x,q,Z,se){return this._withAdapter(x,Ne,H=>H.provideSupertypes(q,Z,se),void 0)}$provideTypeHierarchySubtypes(x,q,Z,se){return this._withAdapter(x,Ne,H=>H.provideSubtypes(q,Z,se),void 0)}$releaseTypeHierarchy(x,q){this._withAdapter(x,Ne,Z=>Promise.resolve(Z.releaseSession(q)),void 0)}static _serializeRegExp(x){return{pattern:x.source,flags:(0,I.regExpFlags)(x)}}static _serializeIndentationRule(x){return{decreaseIndentPattern:He._serializeRegExp(x.decreaseIndentPattern),increaseIndentPattern:He._serializeRegExp(x.increaseIndentPattern),indentNextLinePattern:x.indentNextLinePattern?He._serializeRegExp(x.indentNextLinePattern):void 0,unIndentedLinePattern:x.unIndentedLinePattern?He._serializeRegExp(x.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(x){return{beforeText:He._serializeRegExp(x.beforeText),afterText:x.afterText?He._serializeRegExp(x.afterText):void 0,previousLineText:x.previousLineText?He._serializeRegExp(x.previousLineText):void 0,action:x.action}}static _serializeOnEnterRules(x){return x.map(He._serializeOnEnterRule)}setLanguageConfiguration(x,q,Z){let{wordPattern:se}=Z;if(se&&(0,I.regExpLeadsToEndlessLoop)(se))throw new Error(`Invalid language configuration: wordPattern '${se}' is not allowed to match the empty string.`);se?this._documents.setWordDefinitionFor(q,se):this._documents.setWordDefinitionFor(q,void 0),Z.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",x,"Do not use."),Z.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",x,"Do not use.");const H=this._nextHandle(),ne={comments:Z.comments,brackets:Z.brackets,wordPattern:Z.wordPattern?He._serializeRegExp(Z.wordPattern):void 0,indentationRules:Z.indentationRules?He._serializeIndentationRule(Z.indentationRules):void 0,onEnterRules:Z.onEnterRules?He._serializeOnEnterRules(Z.onEnterRules):void 0,__electricCharacterSupport:Z.__electricCharacterSupport,__characterPairSupport:Z.__characterPairSupport};return this._proxy.$setLanguageConfiguration(H,q,ne),this._createDisposable(H)}$setWordDefinitions(x){for(const q of x)this._documents.setWordDefinitionFor(q.languageId,new RegExp(q.regexSource,q.regexFlags))}}e.ExtHostLanguageFeatures=He,He._handlePool=0}),define(be[194],Ee([0,1,5,8,6,35,13]),function(re,e,h,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class I{constructor(k,t){this._handlePool=0,this._proxy=k.getProxy(h.MainContext.MainThreadLanguages),this._documents=t}getLanguages(){return this._proxy.$getLanguages()}async changeLanguage(k,t){await this._proxy.$changeLanguage(k,t);const _=this._documents.getDocumentData(k);if(!_)throw new Error(`document '${k.toString}' NOT found`);return _.document}async tokenAtPosition(k,t){const _=k.version,r=F.Position.from(t),d=await this._proxy.$tokensAtPosition(k.uri,r),a={type:E.StandardTokenType.Other,range:k.getWordRangeAtPosition(t)??new E.Range(t.line,t.character,t.line,t.character)};if(!d)return a;const l={range:F.Range.to(d.range),type:F.TokenType.to(d.type)};return!l.range.contains(t)||_!==k.version?a:l}createLanguageStatusItem(k){const t=this._handlePool++,_=this._proxy,r={selector:k,text:"",detail:"",severity:E.LanguageStatusSeverity.Information};let d;const a=()=>{d?.dispose(),d=(0,R.disposableTimeout)(()=>{this._proxy.$setLanguageStatus(t,{selector:r.selector,text:r.text,message:typeof r.detail=="string"?r.detail:F.MarkdownString.from(r.detail),severity:r.severity===E.LanguageStatusSeverity.Error?A.default.Error:r.severity===E.LanguageStatusSeverity.Warning?A.default.Warning:A.default.Info})},0)},l={get selector(){return r.selector},set selector(v){r.selector=v,a()},get text(){return r.text},set text(v){r.text=v,a()},get detail(){return r.detail},set detail(v){r.detail=v,a()},get severity(){return r.severity},set severity(v){r.severity=v,a()},dispose(){d?.dispose(),_.$removeLanguageStatus(t)}};return a(),l}}e.ExtHostLanguages=I}),define(be[195],Ee([0,1,5,14,30]),function(re,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function A(I){return I&&I.title}let R=class{constructor(y,k){this._logService=k,this._proxy=y.getProxy(h.MainContext.MainThreadMessageService)}showMessage(y,k,t,_,r){const d={extension:y};let a;typeof _=="string"||A(_)?a=[_,...r]:(d.modal=_?.modal,d.useCustom=_?.useCustom,d.detail=_?.detail,a=r),d.useCustom&&(0,E.checkProposedApiEnabled)(y);const l=[];for(let v=0;v<a.length;v++){const T=a[v];if(typeof T=="string")l.push({title:T,handle:v,isCloseAffordance:!1});else if(typeof T=="object"){let{title:b,isCloseAffordance:c}=T;l.push({title:b,isCloseAffordance:!!c,handle:v})}else this._logService.warn("Invalid message item:",T)}return this._proxy.$showMessage(k,t,d,l).then(v=>{if(typeof v=="number")return a[v]})}};R=Be([We(1,F.ILogService)],R),e.ExtHostMessageService=R}),define(be[196],Ee([0,1,23,3,57,7,20,9,10,2,62,5,8,6,46,170,93]),function(re,e,h,F,E,A,R,I,y,k,t,_,r,d,a,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class T{constructor(c,g,S,i,s){this._textDocumentsAndEditors=S,this._textDocuments=i,this._extensionStoragePaths=s,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new R.ResourceMap,this._editors=new Map,this._onDidChangeNotebookCells=new F.Emitter,this.onDidChangeNotebookCells=this._onDidChangeNotebookCells.event,this._onDidChangeCellOutputs=new F.Emitter,this.onDidChangeCellOutputs=this._onDidChangeCellOutputs.event,this._onDidChangeCellMetadata=new F.Emitter,this.onDidChangeCellMetadata=this._onDidChangeCellMetadata.event,this._onDidChangeActiveNotebookEditor=new F.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._onDidChangeCellExecutionState=new F.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new F.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new F.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new F.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new t.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=c.getProxy(_.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=c.getProxy(_.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=c.getProxy(_.MainContext.MainThreadNotebookEditors),this._commandsConverter=g.converter,g.registerArgumentProcessor({processArgument:u=>{if(u&&u.$mid===12){const o=u.notebookEditor?.notebookUri,f=u.cell.handle,w=this._documents.get(o)?.getCell(f);if(w)return w.apiCell}return u}})}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(c=>c.apiEditor)}getEditorById(c){const g=this._editors.get(c);if(!g)throw new Error(`unknown text editor: ${c}. known editors: ${[...this._editors.keys()]} `);return g}getIdByEditor(c){for(const[g,S]of this._editors)if(S.apiEditor===c)return g}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(c,g){const S=this._documents.get(c);if(!S&&!g)throw new Error(`NO notebook document for '${c}'`);return S}_getProviderData(c){const g=this._notebookContentProviders.get(c);if(!g)throw new Error(`NO provider for '${c}'`);return g}registerNotebookContentProvider(c,g,S,i,s){if((0,I.isFalsyOrWhitespace)(g))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(g))throw new Error(`Notebook provider for '${g}' already registered`);this._notebookContentProviders.set(g,{extension:c,provider:S});let u;return S.onDidChangeNotebookContentOptions&&(u=S.onDidChangeNotebookContentOptions(()=>{const o=r.NotebookDocumentContentOptions.from(S.options);this._notebookProxy.$updateNotebookProviderOptions(g,o)})),this._notebookProxy.$registerNotebookProvider({id:c.identifier,location:c.extensionLocation},g,r.NotebookDocumentContentOptions.from(i),T._convertNotebookRegistrationData(c,s)),new d.Disposable(()=>{u?.dispose(),this._notebookContentProviders.delete(g),this._notebookProxy.$unregisterNotebookProvider(g)})}static _convertNotebookRegistrationData(c,g){if(!g)return;const S=g.filenamePattern.map(i=>r.NotebookExclusiveDocumentPattern.from(i)).filter(i=>i!==void 0);if(g.filenamePattern&&!S){console.warn(`Notebook content provider view options file name pattern is invalid ${g.filenamePattern}`);return}return{extension:c.identifier,providerDisplayName:c.displayName||c.name,displayName:g.displayName,filenamePattern:S,exclusive:g.exclusive||!1}}registerNotebookCellStatusBarItemProvider(c,g,S){const i=T._notebookStatusBarItemProviderHandlePool++,s=typeof S.onDidChangeCellStatusBarItems=="function"?T._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(i,S),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(i,s,g);let u;return s!==void 0&&(u=S.onDidChangeCellStatusBarItems(o=>this._notebookProxy.$emitCellStatusBarEvent(s))),new d.Disposable(()=>{this._notebookStatusBarItemProviders.delete(i),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(i,s),u&&u.dispose()})}async createNotebookDocument(c){const g=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:c.viewType,content:c.content&&r.NotebookData.from(c.content)});return k.URI.revive(g)}async openNotebookDocument(c){const g=this._documents.get(c);if(g)return g.apiNotebook;const S=await this._notebookDocumentsProxy.$tryOpenNotebook(c),i=this._documents.get(k.URI.revive(S));return(0,y.assertIsDefined)(i?.apiNotebook)}async showNotebookDocument(c,g){k.URI.isUri(c)&&(c=await this.openNotebookDocument(c));let S;typeof g=="object"?S={position:r.ViewColumn.from(g.viewColumn),preserveFocus:g.preserveFocus,selections:g.selections&&g.selections.map(r.NotebookRange.from),pinned:typeof g.preview=="boolean"?!g.preview:void 0}:S={preserveFocus:!1};const i=await this._notebookEditorsProxy.$tryShowNotebookDocument(c.uri,c.notebookType,S),s=i&&this._editors.get(i)?.apiEditor;if(s)return s;throw i?new Error(`Could NOT open editor for "${c.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${c.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(c,g,S,i){const s=this._notebookStatusBarItemProviders.get(c),u=k.URI.revive(g),o=this._documents.get(u);if(!o||!s)return;const f=o.getCellFromIndex(S);if(!f)return;const p=await s.provideCellStatusBarItems(f.apiCell,i);if(!p)return;const w=new A.DisposableStore,C=this._statusBarCache.add([w]),n=(Array.isArray(p)?p:[p]).map(m=>r.NotebookStatusBarItem.from(m,this._commandsConverter,w));return{cacheId:C,items:n}}$releaseNotebookCellStatusBarItems(c){this._statusBarCache.delete(c)}registerNotebookSerializer(c,g,S,i,s){if((0,I.isFalsyOrWhitespace)(g))throw new Error("viewType cannot be empty or just whitespace");const u=this._handlePool++;return this._notebookSerializer.set(u,S),this._notebookProxy.$registerNotebookSerializer(u,{id:c.identifier,location:c.extensionLocation},g,r.NotebookDocumentContentOptions.from(i),T._convertNotebookRegistrationData(c,s)),(0,A.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(u)})}async $dataToNotebook(c,g,S){const i=this._notebookSerializer.get(c);if(!i)throw new Error("NO serializer found");const s=await i.deserializeNotebook(g.buffer,S);return new a.SerializableObjectWithBuffers(r.NotebookData.from(s))}async $notebookToData(c,g,S){const i=this._notebookSerializer.get(c);if(!i)throw new Error("NO serializer found");const s=await i.serializeNotebook(r.NotebookData.to(g.value),S);return h.VSBuffer.wrap(s)}async $openNotebook(c,g,S,i,s){const{provider:u}=this._getProviderData(c),o=await u.openNotebook(k.URI.revive(g),{backupId:S,untitledDocumentData:i?.buffer},s);return new a.SerializableObjectWithBuffers({metadata:o.metadata??Object.create(null),cells:o.cells.map(r.NotebookCellData.from)})}async $saveNotebook(c,g,S){const i=this.getNotebookDocument(k.URI.revive(g)),{provider:s}=this._getProviderData(c);return await s.saveNotebook(i.apiNotebook,S),!0}async $saveNotebookAs(c,g,S,i){const s=this.getNotebookDocument(k.URI.revive(g)),{provider:u}=this._getProviderData(c);return await u.saveNotebookAs(k.URI.revive(S),s.apiNotebook,i),!0}async $backupNotebook(c,g,S){const i=this.getNotebookDocument(k.URI.revive(g)),s=this._getProviderData(c),u=this._extensionStoragePaths.workspaceValue(s.extension)??this._extensionStoragePaths.globalValue(s.extension),o=String((0,E.hash)([i.uri.toString(),this._backupIdPool++])),f=k.URI.joinPath(u,o),p=await s.provider.backupNotebook(i.apiNotebook,{destination:f},S);return i.updateBackup(p),p.id}_createExtHostEditor(c,g,S){if(this._editors.has(g))throw new Error(`editor with id ALREADY EXSIST: ${g}`);const i=new v.ExtHostNotebookEditor(g,this._notebookEditorsProxy,c,S.visibleRanges.map(r.NotebookRange.to),S.selections.map(r.NotebookRange.to),typeof S.viewColumn=="number"?r.ViewColumn.to(S.viewColumn):void 0);this._editors.set(g,i)}$acceptDocumentAndEditorsDelta(c){if(c.value.removedDocuments)for(const S of c.value.removedDocuments){const i=k.URI.revive(S),s=this._documents.get(i);s&&(s.dispose(),this._documents.delete(i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:s.apiNotebook.getCells().map(u=>u.document.uri)}),this._onDidCloseNotebookDocument.fire(s.apiNotebook));for(const u of this._editors.values())u.notebookData.uri.toString()===i.toString()&&this._editors.delete(u.id)}if(c.value.addedDocuments){const S=[];for(const i of c.value.addedDocuments){const s=k.URI.revive(i.uri);if(this._documents.has(s))throw new Error(`adding EXISTING notebook ${s} `);const u=this,o=new l.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,{emitModelChange(f){u._onDidChangeNotebookCells.fire(f)},emitCellOutputsChange(f){u._onDidChangeCellOutputs.fire(f)},emitCellMetadataChange(f){u._onDidChangeCellMetadata.fire(f)},emitCellExecutionStateChange(f){u._onDidChangeCellExecutionState.fire(f)}},s,i);S.push(...i.cells.map(f=>l.ExtHostCell.asModelAddData(o.apiNotebook,f))),this._documents.get(s)?.dispose(),this._documents.set(s,o),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:S}),this._onDidOpenNotebookDocument.fire(o.apiNotebook)}}if(c.value.addedEditors)for(const S of c.value.addedEditors){if(this._editors.has(S.id))return;const i=k.URI.revive(S.documentUri),s=this._documents.get(i);s&&this._createExtHostEditor(s,S.id,S)}const g=[];if(c.value.removedEditors)for(const S of c.value.removedEditors){const i=this._editors.get(S);i&&(this._editors.delete(S),this._activeNotebookEditor?.id===i.id&&(this._activeNotebookEditor=void 0),g.push(i))}if(c.value.visibleEditors){this._visibleNotebookEditors=c.value.visibleEditors.map(i=>this._editors.get(i)).filter(i=>!!i);const S=new Set;this._visibleNotebookEditors.forEach(i=>S.add(i.id));for(const i of this._editors.values()){const s=S.has(i.id);i._acceptVisibility(s)}this._visibleNotebookEditors=[...this._editors.values()].map(i=>i).filter(i=>i.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}c.value.newActiveEditor===null?this._activeNotebookEditor=void 0:c.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(c.value.newActiveEditor)),c.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}}e.ExtHostNotebookController=T,T._notebookStatusBarItemProviderHandlePool=0}),define(be[197],Ee([0,1,3,52,14,5,12,8]),function(re,e,h,F,E,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;class y{constructor(_,r){const d=y._Keys.nextId();_.$registerNotebookEditorDecorationType(d,I.NotebookDecorationRenderOptions.from(r)),this.value={key:d,dispose(){_.$removeNotebookEditorDecorationType(d)}}}}y._Keys=new F.IdGenerator("NotebookEditorDecorationType");let k=class{constructor(_,r,d){this._logService=_,this._extHostRpc=r,this._notebooksAndEditors=d,this._onDidChangeNotebookEditorSelection=new h.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new h.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}createNotebookEditorDecorationType(_){return new y(this._extHostRpc.getProxy(A.MainContext.MainThreadNotebookEditors),_).value}$acceptEditorPropertiesChanged(_,r){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",_,r);const d=this._notebooksAndEditors.getEditorById(_);r.visibleRanges&&d._acceptVisibleRanges(r.visibleRanges.ranges.map(I.NotebookRange.to)),r.selections&&d._acceptSelections(r.selections.selections.map(I.NotebookRange.to)),r.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:d.apiEditor,visibleRanges:d.apiEditor.visibleRanges}),r.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:d.apiEditor,selections:d.apiEditor.selections}))}$acceptEditorViewColumns(_){for(const r in _)this._notebooksAndEditors.getEditorById(r)._acceptViewColumn(I.ViewColumn.to(_[r]))}};k=Be([We(0,E.ILogService),We(1,R.IExtHostRpcService)],k),e.ExtHostNotebookEditors=k}),define(be[198],Ee([0,1,16,13,21,3,7,20,2,25,14,5,8,6,67,163,30,46]),function(re,e,h,F,E,A,R,I,y,k,t,_,r,d,a,l,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookKernels=void 0;let b=class{constructor(s,u,o,f){this._initData=u,this._extHostNotebook=o,this._logService=f,this._activeExecutions=new I.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._proxy=s.getProxy(_.MainContext.MainThreadNotebookKernels)}createNotebookController(s,u,o,f,p,w){for(let G of this._kernelData.values())if(G.controller.id===u&&k.ExtensionIdentifier.equals(s.identifier,G.extensionId))throw new Error(`notebook controller with id '${u}' ALREADY exist`);const C=this._handlePool++,P=this;this._logService.trace(`NotebookController[${C}], CREATED by ${s.identifier.value}, ${u}`);const n=()=>console.warn(`NO execute handler from notebook controller '${Q.id}' of extension: '${s.identifier}'`);let m=!1;const D=new R.DisposableStore,O=new A.Emitter,$=new A.Emitter,Q={id:`${s.identifier.value}/${u}`,notebookType:o,extensionId:s.identifier,extensionLocation:s.extensionLocation,label:f||s.identifier.value,preloads:w?w.map(r.NotebookRendererScript.from):[]};let ie=p??n,V;this._proxy.$addKernel(C,Q).catch(G=>{console.log(G),m=!0});let W=0;const L=()=>{if(m)return;const G=++W;Promise.resolve().then(()=>{G===W&&this._proxy.$updateKernel(C,Q)})},Y=new I.ResourceMap,B={get id(){return u},get notebookType(){return Q.notebookType},onDidChangeSelectedNotebooks:O.event,get label(){return Q.label},set label(G){Q.label=G??s.displayName??s.name,L()},get detail(){return Q.detail??""},set detail(G){Q.detail=G,L()},get description(){return Q.description??""},set description(G){Q.description=G,L()},get supportedLanguages(){return Q.supportedLanguages},set supportedLanguages(G){Q.supportedLanguages=G,L()},get supportsExecutionOrder(){return Q.supportsExecutionOrder??!1},set supportsExecutionOrder(G){Q.supportsExecutionOrder=G,L()},get rendererScripts(){return Q.preloads?Q.preloads.map(r.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(G){ie=G??n},get interruptHandler(){return V},set interruptHandler(G){V=G,Q.supportsInterrupt=Boolean(G),L()},createNotebookCellExecution(G){if(m)throw new Error("notebook controller is DISPOSED");if(!Y.has(G.notebook.uri))throw P._logService.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(Y.keys()).map(de=>de.toString())),new Error(`notebook controller is NOT associated to notebook: ${G.notebook.uri.toString()}`);return P._createNotebookCellExecution(G)},dispose:()=>{m||(this._logService.trace(`NotebookController[${C}], DISPOSED`),m=!0,this._kernelData.delete(C),D.dispose(),O.dispose(),$.dispose(),this._proxy.$removeKernel(C))},updateNotebookAffinity(G,de){P._proxy.$updateNotebookPriority(C,G.uri,de)},onDidReceiveMessage:$.event,postMessage(G,de){return(0,v.checkProposedApiEnabled)(s),P._proxy.$postMessage(C,de&&P._extHostNotebook.getIdByEditor(de),G)},asWebviewUri(G){return(0,v.checkProposedApiEnabled)(s),(0,a.asWebviewUri)(G,P._initData.remote)}};return this._kernelData.set(C,{extensionId:s.identifier,controller:B,onDidReceiveMessage:$,onDidChangeSelection:O,associatedNotebooks:Y}),B}$acceptNotebookAssociation(s,u,o){const f=this._kernelData.get(s);if(f){const p=this._extHostNotebook.getNotebookDocument(y.URI.revive(u));o?f.associatedNotebooks.set(p.uri,!0):f.associatedNotebooks.delete(p.uri),this._logService.trace(`NotebookController[${s}] ASSOCIATE notebook`,p.uri.toString(),o),f.onDidChangeSelection.fire({selected:o,notebook:p.apiNotebook})}}async $executeCells(s,u,o){const f=this._kernelData.get(s);if(!f)return;const p=this._extHostNotebook.getNotebookDocument(y.URI.revive(u)),w=[];for(let C of o){const P=p.getCell(C);P&&w.push(P.apiCell)}try{this._logService.trace(`NotebookController[${s}] EXECUTE cells`,p.uri.toString(),w.length),await f.controller.executeHandler.call(f.controller,w,p.apiNotebook,f.controller)}catch(C){this._logService.error(`NotebookController[${s}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(s,u,o){const f=this._kernelData.get(s);if(!f)return;const p=this._extHostNotebook.getNotebookDocument(y.URI.revive(u));if(f.controller.interruptHandler)await f.controller.interruptHandler.call(f.controller,p.apiNotebook);else for(let w of o){const C=p.getCell(w);C&&this._activeExecutions.get(C.uri)?.cancel()}}$acceptKernelMessageFromRenderer(s,u,o){const f=this._kernelData.get(s);if(!f)return;const p=this._extHostNotebook.getEditorById(u);f.onDidReceiveMessage.fire(Object.freeze({editor:p.apiEditor,message:o}))}_createNotebookCellExecution(s){if(s.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const o=this._extHostNotebook.getNotebookDocument(s.notebook.uri).getCellFromApiCell(s);if(!o)throw new Error("invalid cell");if(this._activeExecutions.has(o.uri))throw new Error(`duplicate execution for ${o.uri}`);const f=new g(o.notebook,o,this._proxy);this._activeExecutions.set(o.uri,f);const p=f.onDidChangeState(()=>{f.state===c.Resolved&&(f.dispose(),p.dispose(),this._activeExecutions.delete(o.uri))});return f.asApiObject()}};b=Be([We(3,t.ILogService)],b),e.ExtHostNotebookKernels=b;var c;(function(i){i[i.Init=0]="Init",i[i.Started=1]="Started",i[i.Resolved=2]="Resolved"})(c||(c={}));class g extends R.Disposable{constructor(s,u,o){super();this._document=s,this._cell=u,this._proxy=o,this._handle=g.HANDLE++,this._onDidChangeState=new A.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=c.Init,this._tokenSource=this._register(new E.CancellationTokenSource),this._collector=new S(10,f=>this.update(f)),this._executionOrder=u.internalMetadata.executionOrder,this._proxy.$addExecution(this._handle,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(s){await this._collector.addItem(s)}async update(s){const u=Array.isArray(s)?s:[s];return this._proxy.$updateExecutions(new T.SerializableObjectWithBuffers(u))}verifyStateForOutput(){if(this._state===c.Init)throw new Error("Must call start before modifying cell output");if(this._state===c.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(s){let u=this._cell;if(s&&(u=this._document.getCellFromApiCell(s)),!u)throw new Error("INVALID cell");return u.handle}validateAndConvertOutputs(s){return s.map(u=>{const o=d.NotebookCellOutput.ensureUniqueMimeTypes(u.items,!0);return o===u.items?r.NotebookCellOutput.from(u):r.NotebookCellOutput.from({items:o,id:u.id,metadata:u.metadata})})}async updateOutputs(s,u,o){const f=this.cellIndexToHandle(u),p=this.validateAndConvertOutputs((0,h.asArray)(s));return this.updateSoon({editType:l.CellExecutionUpdateType.Output,executionHandle:this._handle,cellHandle:f,append:o,outputs:p})}async updateOutputItems(s,u,o){return s=d.NotebookCellOutput.ensureUniqueMimeTypes((0,h.asArray)(s),!0),this.updateSoon({editType:l.CellExecutionUpdateType.OutputItems,executionHandle:this._handle,items:s.map(r.NotebookCellOutputItem.from),outputId:u.id,append:o})}asApiObject(){const s=this;return Object.freeze({get token(){return s._tokenSource.token},get cell(){return s._cell.apiCell},get executionOrder(){return s._executionOrder},set executionOrder(o){s._executionOrder=o,s.update([{editType:l.CellExecutionUpdateType.ExecutionState,executionHandle:s._handle,executionOrder:s._executionOrder}])},start(o){if(s._state===c.Resolved||s._state===c.Started)throw new Error("Cannot call start again");s._state=c.Started,s._onDidChangeState.fire(),s.update({editType:l.CellExecutionUpdateType.ExecutionState,executionHandle:s._handle,runStartTime:o})},end(o,f){if(s._state===c.Resolved)throw new Error("Cannot call resolve twice");s._state=c.Resolved,s._onDidChangeState.fire(),s.updateSoon({editType:l.CellExecutionUpdateType.Complete,executionHandle:s._handle,runEndTime:f,lastRunSuccess:o}),s._collector.flush(),s._proxy.$removeExecution(s._handle)},clearOutput(o){return s.verifyStateForOutput(),s.updateOutputs([],o,!1)},appendOutput(o,f){return s.verifyStateForOutput(),s.updateOutputs(o,f,!0)},replaceOutput(o,f){return s.verifyStateForOutput(),s.updateOutputs(o,f,!1)},appendOutputItems(o,f){return s.verifyStateForOutput(),s.updateOutputItems(o,f,!0)},replaceOutputItems(o,f){return s.verifyStateForOutput(),s.updateOutputItems(o,f,!1)}})}}g.HANDLE=0;class S{constructor(s,u){this.delay=s,this.callback=u,this.batch=[]}addItem(s){return this.batch.push(s),this.waitPromise||(this.waitPromise=(0,F.timeout)(this.delay).then(()=>this.flush())),this.waitPromise}flush(){this.waitPromise=void 0;const s=this.batch;return this.batch=[],this.callback(s)}}}),define(be[199],Ee([0,1,3,5,93]),function(re,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class A{constructor(I,y){this._extHostNotebook=y,this._rendererMessageEmitters=new Map,this.proxy=I.getProxy(F.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(I,y,k){const t=this._extHostNotebook.getEditorById(I);this._rendererMessageEmitters.get(y)?.fire({editor:t.apiEditor,message:k})}createRendererMessaging(I,y){if(!I.contributes?.notebookRenderer?.some(r=>r.id===y))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${y})`);const k=!!I.enableProposedApi,t=new WeakMap;return{onDidReceiveMessage:(r,d,a)=>{const l=k?r:v=>{const T={};t.set(T,v.editor),r({editor:T,message:v.message})};return this.getOrCreateEmitterFor(y).event(l,d,a)},postMessage:(r,d)=>{E.ExtHostNotebookEditor.apiEditorsToExtHost.has(r)&&([r,d]=[d,r]);const a=k?d:t.get(d),l=a&&E.ExtHostNotebookEditor.apiEditorsToExtHost.get(a);return this.proxy.$postMessage(l?.id,y,r)}}}getOrCreateEmitterFor(I){let y=this._rendererMessageEmitters.get(I);return y||(y=new h.Emitter({onLastListenerRemove:()=>{y?.dispose(),this._rendererMessageEmitters.delete(I)}}),this._rendererMessageEmitters.set(I,y),y)}}e.ExtHostNotebookRenderers=A}),define(be[96],Ee([0,1,5,3,7,23,4,12]),function(re,e,h,F,E,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.LazyOutputChannel=e.ExtHostPushOutputChannel=e.AbstractExtHostOutputChannel=void 0;class y extends E.Disposable{constructor(a,l,v,T,b){super();this._onDidAppend=this._register(new F.Emitter),this.onDidAppend=this._onDidAppend.event,this._name=a,this._proxy=b,this._id=b.$register(this.name,l,v,T),this._disposed=!1,this._offset=0}get name(){return this._name}append(a){this.validate(),this._offset+=a?A.VSBuffer.fromString(a).byteLength:0}update(){this._id.then(a=>this._proxy.$update(a))}appendLine(a){this.validate(),this.append(a+`
`)}clear(){this.validate();const a=this._offset;this._id.then(l=>this._proxy.$clear(l,a))}show(a,l){this.validate(),this._id.then(v=>this._proxy.$reveal(v,!!(typeof a=="boolean"?a:l)))}hide(){this.validate(),this._id.then(a=>this._proxy.$close(a))}validate(){if(this._disposed)throw new Error("Channel has been closed")}dispose(){super.dispose(),this._disposed||this._id.then(a=>this._proxy.$dispose(a)).then(()=>this._disposed=!0)}}e.AbstractExtHostOutputChannel=y;class k extends y{constructor(a,l,v){super(a,!1,void 0,l,v)}append(a){super.append(a),this._id.then(l=>this._proxy.$append(l,a)),this._onDidAppend.fire()}}e.ExtHostPushOutputChannel=k;class t extends y{constructor(a,l,v){super(a,!0,l,void 0,v)}append(a){throw new Error("Not supported")}}class _{constructor(a,l){this.name=a,this._channel=l}append(a){this._channel.then(l=>l.append(a))}appendLine(a){this._channel.then(l=>l.appendLine(a))}clear(){this._channel.then(a=>a.clear())}show(a,l){this._channel.then(v=>v.show(a,l))}hide(){this._channel.then(a=>a.hide())}dispose(){this._channel.then(a=>a.dispose())}}e.LazyOutputChannel=_;let r=class{constructor(a){this._proxy=a.getProxy(h.MainContext.MainThreadOutputService)}$setVisibleChannel(a){}createOutputChannel(a,l){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");return new k(a,l.identifier.value,this._proxy)}createOutputChannelFromLogFile(a,l){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");if(!l)throw new Error("illegal argument `file`. must not be falsy");return new t(a,l,this._proxy)}};r=Be([We(0,I.IExtHostRpcService)],r),e.ExtHostOutputService=r,e.IExtHostOutputService=(0,R.createDecorator)("IExtHostOutputService")}),define(be[200],Ee([0,1,13,21,3,7,5,2,6,15,16,35,43]),function(re,e,h,F,E,A,R,I,y,k,t,_,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function d(a,l,v){const T=a.getProxy(R.MainContext.MainThreadQuickOpen);class b{constructor(p,w){this._sessions=new Map,this._instances=0,this._workspace=p,this._commands=w}showQuickPick(p,w,C,P=F.CancellationToken.None){this._onDidSelectItem=void 0;const n=Promise.resolve(p),m=++this._instances,D=T.$show(m,{title:C?.title,placeHolder:C?.placeHolder,matchOnDescription:C?.matchOnDescription,matchOnDetail:C?.matchOnDetail,ignoreFocusLost:C?.ignoreFocusOut,canPickMany:C?.canPickMany},P),O={},$=D.then(()=>O);return Promise.race([$,n]).then(Q=>{if(Q!==O)return n.then(ie=>{const V=[];for(let W=0;W<ie.length;W++){const L=ie[W];let Y,B,G,de,j;typeof L=="string"?Y=L:(Y=L.label,B=L.description,G=L.detail,de=L.picked,j=L.alwaysShow),V.push({label:Y,description:B,handle:W,detail:G,picked:de,alwaysShow:j})}return C&&typeof C.onDidSelectItem=="function"&&(this._onDidSelectItem=W=>{C.onDidSelectItem(ie[W])}),T.$setItems(m,V),D.then(W=>{if(typeof W=="number")return ie[W];if(Array.isArray(W))return W.map(L=>ie[L])})})}).then(void 0,Q=>{if(!(0,k.isPromiseCanceledError)(Q))return T.$setError(m,Q),Promise.reject(Q)})}$onItemSelected(p){this._onDidSelectItem&&this._onDidSelectItem(p)}showInput(p,w=F.CancellationToken.None){return this._validateInput=p?p.validateInput:void 0,T.$input(p,typeof this._validateInput=="function",w).then(void 0,C=>{if(!(0,k.isPromiseCanceledError)(C))return Promise.reject(C)})}$validateInput(p){return this._validateInput?(0,h.asPromise)(()=>this._validateInput(p)):Promise.resolve(void 0)}async showWorkspaceFolderPick(p,w=F.CancellationToken.None){const C=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[p]);if(!C)return;const P=await this._workspace.getWorkspaceFolders2();if(!!P)return P.find(n=>n.uri.toString()===C.uri.toString())}createQuickPick(p,w){const C=new u(p,w,()=>this._sessions.delete(C._id));return this._sessions.set(C._id,C),C}createInputBox(p){const w=new o(p,()=>this._sessions.delete(w._id));return this._sessions.set(w._id,w),w}$onDidChangeValue(p,w){const C=this._sessions.get(p);C&&C._fireDidChangeValue(w)}$onDidAccept(p){const w=this._sessions.get(p);w&&w._fireDidAccept()}$onDidChangeActive(p,w){const C=this._sessions.get(p);C instanceof u&&C._fireDidChangeActive(w)}$onDidChangeSelection(p,w){const C=this._sessions.get(p);C instanceof u&&C._fireDidChangeSelection(w)}$onDidTriggerButton(p,w){const C=this._sessions.get(p);C&&C._fireDidTriggerButton(w)}$onDidTriggerItemButton(p,w,C){const P=this._sessions.get(p);P instanceof u&&P._fireDidTriggerItemButton(w,C)}$onDidHide(p){const w=this._sessions.get(p);w&&w._fireDidHide()}}class c{constructor(p,w){this._extensionId=p,this._onDidDispose=w,this._id=u._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new E.Emitter,this._onDidChangeValueEmitter=new E.Emitter,this._onDidTriggerButtonEmitter=new E.Emitter,this._onDidHideEmitter=new E.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(p){this._title=p,this.update({title:p})}get step(){return this._steps}set step(p){this._steps=p,this.update({step:p})}get totalSteps(){return this._totalSteps}set totalSteps(p){this._totalSteps=p,this.update({totalSteps:p})}get enabled(){return this._enabled}set enabled(p){this._enabled=p,this.update({enabled:p})}get busy(){return this._busy}set busy(p){this._busy=p,this.update({busy:p})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(p){this._ignoreFocusOut=p,this.update({ignoreFocusOut:p})}get value(){return this._value}set value(p){this._value=p,this.update({value:p})}get placeholder(){return this._placeholder}set placeholder(p){this._placeholder=p,this.update({placeholder:p})}get buttons(){return this._buttons}set buttons(p){this._buttons=p.slice(),this._handlesToButtons.clear(),p.forEach((w,C)=>{const P=w===y.QuickInputButtons.Back?-1:C;this._handlesToButtons.set(P,w)}),this.update({buttons:p.map((w,C)=>({...s(w),tooltip:w.tooltip,handle:w===y.QuickInputButtons.Back?-1:C}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(p){this._value=p,this._onDidChangeValueEmitter.fire(p)}_fireDidTriggerButton(p){const w=this._handlesToButtons.get(p);w&&this._onDidTriggerButtonEmitter.fire(w)}_fireDidHide(){this._expectingHide&&(this._expectingHide=!1,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,A.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),T.$dispose(this._id))}update(p){if(!this._disposed){for(const w of Object.keys(p)){const C=p[w];this._pendingUpdate[w]=C===void 0?null:C}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){T.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}c._nextId=1;function g(f){if(f instanceof y.ThemeIcon)return{id:f.id};const p=i(f),w=S(f);return{dark:typeof p=="string"?I.URI.file(p):p,light:typeof w=="string"?I.URI.file(w):w}}function S(f){return typeof f=="object"&&"light"in f?f.light:f}function i(f){return typeof f=="object"&&"dark"in f?f.dark:f}function s(f){const p=g(f.iconPath);let w,C;return"id"in p?C=r.ThemeIcon.asClassName(p):w=p,{iconPath:w,iconClass:C}}class u extends c{constructor(p,w,C){super(p,C);this.enableProposedApi=w,this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._activeItems=[],this._onDidChangeActiveEmitter=new E.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new E.Emitter,this._onDidTriggerItemButtonEmitter=new E.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(p){this._items=p.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),p.forEach((w,C)=>{this._handlesToItems.set(C,w),this._itemsToHandles.set(w,C)}),this.update({items:p.map((w,C)=>({label:w.label,description:w.description,handle:C,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,buttons:w.buttons&&this.enableProposedApi?w.buttons.map((P,n)=>({...s(P),tooltip:P.tooltip,handle:n})):void 0}))})}get canSelectMany(){return this._canSelectMany}set canSelectMany(p){this._canSelectMany=p,this.update({canSelectMany:p})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(p){this._matchOnDescription=p,this.update({matchOnDescription:p})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(p){this._matchOnDetail=p,this.update({matchOnDetail:p})}get sortByLabel(){return this._sortByLabel}set sortByLabel(p){this._sortByLabel=p,this.update({sortByLabel:p})}get activeItems(){return this._activeItems}set activeItems(p){this._activeItems=p.filter(w=>this._itemsToHandles.has(w)),this.update({activeItems:this._activeItems.map(w=>this._itemsToHandles.get(w))})}get selectedItems(){return this._selectedItems}set selectedItems(p){this._selectedItems=p.filter(w=>this._itemsToHandles.has(w)),this.update({selectedItems:this._selectedItems.map(w=>this._itemsToHandles.get(w))})}_fireDidChangeActive(p){const w=(0,t.coalesce)(p.map(C=>this._handlesToItems.get(C)));this._activeItems=w,this._onDidChangeActiveEmitter.fire(w)}_fireDidChangeSelection(p){const w=(0,t.coalesce)(p.map(C=>this._handlesToItems.get(C)));this._selectedItems=w,this._onDidChangeSelectionEmitter.fire(w)}_fireDidTriggerItemButton(p,w){const C=this._handlesToItems.get(p);if(!C||!C.buttons||!C.buttons.length)return;const P=C.buttons[w];P&&this._onDidTriggerItemButtonEmitter.fire({button:P,item:C})}}class o extends c{constructor(p,w){super(p,w);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(p){this._password=p,this.update({password:p})}get prompt(){return this._prompt}set prompt(p){this._prompt=p,this.update({prompt:p})}get validationMessage(){return this._validationMessage}set validationMessage(p){this._validationMessage=p,this.update({validationMessage:p,severity:p?_.default.Error:_.default.Ignore})}}return new b(l,v)}e.createExtHostQuickOpen=d}),define(be[201],Ee([0,1,2,3,51,7,13,5,16,107,14,25,30,43,8]),function(re,e,h,F,E,A,R,I,y,k,t,_,r,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function l(p){if(p)return typeof p.iconPath=="string"?h.URI.file(p.iconPath):h.URI.isUri(p.iconPath)||d.ThemeIcon.isThemeIcon(p.iconPath)?p.iconPath:void 0}function v(p,w){if(!p.iconPath&&!w.iconPath)return 0;if(p.iconPath){if(!w.iconPath)return 1}else return-1;const C=typeof p.iconPath=="string"?p.iconPath:h.URI.isUri(p.iconPath)?p.iconPath.fsPath:p.iconPath.id,P=typeof w.iconPath=="string"?w.iconPath:h.URI.isUri(w.iconPath)?w.iconPath.fsPath:w.iconPath.id;return(0,k.comparePaths)(C,P)}function T(p,w){let C=0;if(p.strikeThrough!==w.strikeThrough)return p.strikeThrough?1:-1;if(p.faded!==w.faded)return p.faded?1:-1;if(p.tooltip!==w.tooltip)return(p.tooltip||"").localeCompare(w.tooltip||"");if(C=v(p,w),C!==0)return C;if(p.light&&w.light)C=v(p.light,w.light);else{if(p.light)return 1;if(w.light)return-1}if(C!==0)return C;if(p.dark&&w.dark)C=v(p.dark,w.dark);else{if(p.dark)return 1;if(w.dark)return-1}return C}function b(p,w){if(p.command!==w.command)return p.command<w.command?-1:1;if(p.title!==w.title)return p.title<w.title?-1:1;if(p.tooltip!==w.tooltip){if(p.tooltip!==void 0&&w.tooltip!==void 0)return p.tooltip<w.tooltip?-1:1;if(p.tooltip!==void 0)return 1;if(w.tooltip!==void 0)return-1}if(p.arguments===w.arguments)return 0;if(p.arguments)if(w.arguments){if(p.arguments.length!==w.arguments.length)return p.arguments.length-w.arguments.length}else return 1;else return-1;for(let C=0;C<p.arguments.length;C++){const P=p.arguments[C],n=w.arguments[C];if(P!==n)return P<n?-1:1}return 0}function c(p,w){let C=(0,k.comparePaths)(p.resourceUri.fsPath,w.resourceUri.fsPath,!0);if(C!==0)return C;if(p.command&&w.command)C=b(p.command,w.command);else{if(p.command)return 1;if(w.command)return-1}if(C!==0)return C;if(p.decorations&&w.decorations)C=T(p.decorations,w.decorations);else{if(p.decorations)return 1;if(w.decorations)return-1}return C}function g(p,w){for(let C=0;C<p.length;C++)if(p[C]!==w[C])return!1;return!0}function S(p,w){return p.command===w.command&&p.title===w.title&&p.tooltip===w.tooltip&&(p.arguments&&w.arguments?g(p.arguments,w.arguments):p.arguments===w.arguments)}function i(p,w){return(0,y.equals)(p,w,S)}class s{constructor(w,C,P){this._extension=w,this._proxy=C,this._sourceControlHandle=P,this._value="",this._onDidChange=new F.Emitter,this._placeholder="",this._visible=!0}get value(){return this._value}set value(w){this._proxy.$setInputBoxValue(this._sourceControlHandle,w),this.updateValue(w)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(w){this._proxy.$setInputBoxPlaceholder(this._sourceControlHandle,w),this._placeholder=w}get validateInput(){return(0,r.checkProposedApiEnabled)(this._extension),this._validateInput}set validateInput(w){if((0,r.checkProposedApiEnabled)(this._extension),w&&typeof w!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=w,this._proxy.$setValidationProviderIsEnabled(this._sourceControlHandle,!!w)}get visible(){return this._visible}set visible(w){w=!!w,this._visible!==w&&(this._visible=w,this._proxy.$setInputBoxVisibility(this._sourceControlHandle,w))}focus(){(0,r.checkProposedApiEnabled)(this._extension),this._visible||(this.visible=!0),this._proxy.$setInputBoxFocus(this._sourceControlHandle)}showValidationMessage(w,C){(0,r.checkProposedApiEnabled)(this._extension),this._proxy.$showValidationMessage(this._sourceControlHandle,w,C)}$onInputBoxValueChange(w){this.updateValue(w)}updateValue(w){this._value=w,this._onDidChange.fire(w)}}e.ExtHostSCMInputBox=s;class u{constructor(w,C,P,n,m){this._proxy=w,this._commands=C,this._sourceControlHandle=P,this._id=n,this._label=m,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new F.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new F.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=u._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(w){this._label=w,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,w)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(w){this._hideWhenEmpty=w,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(w){this._resourceStates=[...w],this._onDidUpdateResourceStates.fire()}getResourceState(w){return this._resourceStatesMap.get(w)}$executeResourceCommand(w,C){const P=this._resourceStatesCommandsMap.get(w);return P?(0,R.asPromise)(()=>this._commands.executeCommand(P.command,...P.arguments||[],C)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const w=[...this._resourceStates].sort(c),P=(0,y.sortedDiff)(this._resourceSnapshot,w,c).map(D=>{const O=D.toInsert.map($=>{const Q=this._resourceHandlePool++;this._resourceStatesMap.set(Q,$);const ie=$.resourceUri;let V;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const ve=new A.DisposableStore;V=this._commands.converter.toInternal($.command,ve),this._resourceStatesDisposablesMap.set(Q,ve)}else this._resourceStatesCommandsMap.set(Q,$.command);const W=l($.decorations),L=$.decorations&&l($.decorations.light)||W,Y=$.decorations&&l($.decorations.dark)||W,B=[L,Y],G=$.decorations&&$.decorations.tooltip||"",de=$.decorations&&!!$.decorations.strikeThrough,j=$.decorations&&!!$.decorations.faded,le=$.contextValue||"";return{rawResource:[Q,ie,B,G,de,j,le,V],handle:Q}});return{start:D.start,deleteCount:D.deleteCount,toInsert:O}}),n=P.map(({start:D,deleteCount:O,toInsert:$})=>[D,O,$.map(Q=>Q.rawResource)]),m=P.reverse();for(const{start:D,deleteCount:O,toInsert:$}of m){const Q=$.map(V=>V.handle),ie=this._handlesSnapshot.splice(D,O,...Q);for(const V of ie)this._resourceStatesMap.delete(V),this._resourceStatesCommandsMap.delete(V),this._resourceStatesDisposablesMap.get(V)?.dispose(),this._resourceStatesDisposablesMap.delete(V)}return this._resourceSnapshot=w,n}dispose(){this._disposed=!0,this._onDidDispose.fire()}}u._handlePool=0;class o{constructor(w,C,P,n,m,D){this._proxy=C,this._commands=P,this._id=n,this._label=m,this._rootUri=D,this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new A.MutableDisposable,this._acceptInputCommand=void 0,this._statusBarDisposables=new A.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new F.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=o._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,this._inputBox=new s(w,this._proxy,this.handle),this._proxy.$registerSourceControl(this.handle,n,m,D)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(w){this._count!==w&&(this._count=w,this._proxy.$updateSourceControl(this.handle,{count:w}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(w){this._quickDiffProvider=w,this._proxy.$updateSourceControl(this.handle,{hasQuickDiffProvider:!!w})}get commitTemplate(){return this._commitTemplate}set commitTemplate(w){w!==this._commitTemplate&&(this._commitTemplate=w,this._proxy.$updateSourceControl(this.handle,{commitTemplate:w}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(w){this._acceptInputDisposables.value=new A.DisposableStore,this._acceptInputCommand=w;const C=this._commands.converter.toInternal(w,this._acceptInputDisposables.value);this._proxy.$updateSourceControl(this.handle,{acceptInputCommand:C})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(w){if(this._statusBarCommands&&w&&i(this._statusBarCommands,w))return;this._statusBarDisposables.value=new A.DisposableStore,this._statusBarCommands=w;const C=(w||[]).map(P=>this._commands.converter.toInternal(P,this._statusBarDisposables.value));this._proxy.$updateSourceControl(this.handle,{statusBarCommands:C})}get selected(){return this._selected}createResourceGroup(w,C){const P=new u(this._proxy,this._commands,this.handle,w,C),n=F.Event.once(P.onDidDispose)(()=>this.createdResourceGroups.delete(P));return this.createdResourceGroups.set(P,n),this.eventuallyAddResourceGroups(),P}eventuallyAddResourceGroups(){const w=[],C=[];for(const[P,n]of this.createdResourceGroups){n.dispose();const m=P.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(P),this.eventuallyUpdateResourceStates()});F.Event.once(P.onDidDispose)(()=>{this.updatedResourceGroups.delete(P),m.dispose(),this._groups.delete(P.handle),this._proxy.$unregisterGroup(this.handle,P.handle)}),w.push([P.handle,P.id,P.label,P.features]);const D=P._takeResourceStateSnapshot();D.length>0&&C.push([P.handle,D]),this._groups.set(P.handle,P)}this._proxy.$registerGroups(this.handle,w,C),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const w=[];this.updatedResourceGroups.forEach(C=>{const P=C._takeResourceStateSnapshot();P.length!==0&&w.push([C.handle,P])}),w.length>0&&this._proxy.$spliceResourceStates(this.handle,w),this.updatedResourceGroups.clear()}getResourceGroup(w){return this._groups.get(w)}setSelectionState(w){this._selected=w,this._onDidChangeSelection.fire(w)}dispose(){this._acceptInputDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(w=>w.dispose()),this._proxy.$unregisterSourceControl(this.handle)}}o._handlePool=0,Be([(0,E.debounce)(100)],o.prototype,"eventuallyAddResourceGroups",null),Be([(0,E.debounce)(100)],o.prototype,"eventuallyUpdateResourceStates",null);let f=class xi{constructor(w,C,P){this._commands=C,this.logService=P,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new F.Emitter,this._proxy=w.getProxy(I.MainContext.MainThreadSCM),this._telemetry=w.getProxy(I.MainContext.MainThreadTelemetry),C.registerArgumentProcessor({processArgument:n=>{if(n&&n.$mid===3){const m=this._sourceControls.get(n.sourceControlHandle);if(!m)return n;const D=m.getResourceGroup(n.groupHandle);return D?D.getResourceState(n.handle):n}else if(n&&n.$mid===4){const m=this._sourceControls.get(n.sourceControlHandle);return m?m.getResourceGroup(n.groupHandle):n}else if(n&&n.$mid===5){const m=this._sourceControls.get(n.handle);return m||n}return n}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(w,C,P,n){this.logService.trace("ExtHostSCM#createSourceControl",w.identifier.value,C,P,n),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:w.identifier.value});const m=xi._handlePool++,D=new o(w,this._proxy,this._commands,C,P,n);this._sourceControls.set(m,D);const O=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(w.identifier))||[];return O.push(D),this._sourceControlsByExtension.set(_.ExtensionIdentifier.toKey(w.identifier),O),D}getLastInputBox(w){this.logService.trace("ExtHostSCM#getLastInputBox",w.identifier.value);const C=this._sourceControlsByExtension.get(_.ExtensionIdentifier.toKey(w.identifier)),P=C&&C[C.length-1];return P&&P.inputBox}$provideOriginalResource(w,C,P){const n=h.URI.revive(C);this.logService.trace("ExtHostSCM#$provideOriginalResource",w,n.toString());const m=this._sourceControls.get(w);return!m||!m.quickDiffProvider||!m.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,R.asPromise)(()=>m.quickDiffProvider.provideOriginalResource(n,P)).then(D=>D||null)}$onInputBoxValueChange(w,C){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",w);const P=this._sourceControls.get(w);return P&&P.inputBox.$onInputBoxValueChange(C),Promise.resolve(void 0)}$executeResourceCommand(w,C,P,n){this.logService.trace("ExtHostSCM#$executeResourceCommand",w,C,P);const m=this._sourceControls.get(w);if(!m)return Promise.resolve(void 0);const D=m.getResourceGroup(C);return D?D.$executeResourceCommand(P,n):Promise.resolve(void 0)}$validateInput(w,C,P){this.logService.trace("ExtHostSCM#$validateInput",w);const n=this._sourceControls.get(w);return!n||!n.inputBox.validateInput?Promise.resolve(void 0):(0,R.asPromise)(()=>n.inputBox.validateInput(C,P)).then(m=>{if(!m)return Promise.resolve(void 0);const D=a.MarkdownString.fromStrict(m.message);return D?Promise.resolve([D,m.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(w){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",w),w!==void 0&&this._sourceControls.get(w)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=w,Promise.resolve(void 0)}};f._handlePool=0,f=Be([We(2,t.ILogService)],f),e.ExtHostSCM=f});var et=this&&this.__classPrivateFieldSet||function(re,e,h,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(re,h):E?E.value=h:e.set(re,h),h},Oe=this&&this.__classPrivateFieldGet||function(re,e,h,F){if(h==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!F:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?F:h==="a"?F.call(re):F?F.value:e.get(re)};define(be[202],Ee([0,1,6,5,126,7,8]),function(re,e,h,F,E,A,R){"use strict";var I,y;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class k{constructor(d,a,l,v,T=h.StatusBarAlignment.Left,b){I.set(this,void 0),y.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new A.DisposableStore,et(this,I,d,"f"),et(this,y,a,"f"),this._entryId=k.ID_GEN++,this._extension=l,this._id=v,this._alignment=T,this._priority=b}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(d){this._text=d,this.update()}set name(d){this._name=d,this.update()}set tooltip(d){this._tooltip=d,this.update()}set color(d){this._color=d,this.update()}set backgroundColor(d){d&&!k.ALLOWED_BACKGROUND_COLORS.has(d.id)&&(d=void 0),this._backgroundColor=d,this.update()}set command(d){this._command?.fromApi!==d&&(this._internalCommandRegistration.clear(),typeof d=="string"?this._command={fromApi:d,internal:Oe(this,y,"f").toInternal({title:"",command:d},this._internalCommandRegistration)}:d?this._command={fromApi:d,internal:Oe(this,y,"f").toInternal(d,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(d){this._accessibilityInformation=d,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,I,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let d;this._extension?this._id?d=`${this._extension.identifier.value}.${this._id}`:d=this._extension.identifier.value:d=this._id;let a;this._name?a=this._name:a=(0,E.localize)(0,null,this._extension.displayName||this._extension.name);let l=this._color;this._backgroundColor&&(l=k.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const v=this._tooltip?R.MarkdownString.fromStrict(this._tooltip):void 0;Oe(this,I,"f").$setEntry(this._entryId,d,a,this._text,v,this._command?.internal,l,this._backgroundColor,this._alignment===h.StatusBarAlignment.Left?0:1,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=k,I=new WeakMap,y=new WeakMap,k.ID_GEN=0,k.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new h.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new h.ThemeColor("statusBarItem.warningForeground")]]);class t{constructor(d){this._messages=[],this._item=d.createStatusBarEntry(void 0,"status.extensionMessage",h.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,E.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(d){const a={message:d};return this._messages.unshift(a),this._update(),new h.Disposable(()=>{const l=this._messages.indexOf(a);l>=0&&(this._messages.splice(l,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class _{constructor(d,a){this._proxy=d.getProxy(F.MainContext.MainThreadStatusBar),this._commands=a,this._statusMessage=new t(this)}createStatusBarEntry(d,a,l,v){return new k(this._proxy,this._commands,d,a,l,v)}setStatusBarMessage(d,a){const l=this._statusMessage.setMessage(d);let v;return typeof a=="number"?v=setTimeout(()=>l.dispose(),a):typeof a!="undefined"&&a.then(()=>l.dispose(),()=>l.dispose()),new h.Disposable(()=>{l.dispose(),clearTimeout(v)})}}e.ExtHostStatusBar=_}),define(be[72],Ee([0,1,5,3,4]),function(re,e,h,F,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class A{constructor(I){this._onDidChangeStorage=new F.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=I.getProxy(h.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(I,y){this._proxy.$registerExtensionStorageKeysToSync(I,y)}getValue(I,y,k){return this._proxy.$getValue(I,y).then(t=>t||k)}setValue(I,y,k){return this._proxy.$setValue(I,y,k)}$acceptValue(I,y,k){this._onDidChangeStorage.fire({shared:I,key:y,value:k})}}e.ExtHostStorage=A,e.IExtHostStorage=(0,E.createDecorator)("IExtHostStorage")}),define(be[73],Ee([0,1,4,29,14,71,2]),function(re,e,h,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,h.createDecorator)("IExtensionStoragePaths");let I=class{constructor(k,t,_){this._logService=t,this._extHostFileSystem=_,this._workspace=k.workspace??void 0,this._environment=k.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(r=>this._value=r)}async _getWorkspaceStorageURI(k){return R.URI.joinPath(this._environment.workspaceStorageHome,k)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const k=this._workspace.id,t=await this._getWorkspaceStorageURI(k);try{return await this._extHostFileSystem.value.stat(t),this._logService.trace("[ExtHostStorage] storage dir already exists",t),t}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",t),await this._extHostFileSystem.value.createDirectory(t),await this._extHostFileSystem.value.writeFile(R.URI.joinPath(t,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:R.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),t}catch(_){this._logService.error("[ExtHostStorage]",_);return}}workspaceValue(k){if(this._value)return R.URI.joinPath(this._value,k.identifier.value)}globalValue(k){return R.URI.joinPath(this._environment.globalStorageHome,k.identifier.value.toLowerCase())}onWillDeactivateAll(){}};I=Be([We(0,F.IExtHostInitDataService),We(1,E.ILogService),We(2,A.IExtHostConsumerFileSystem)],I),e.ExtensionStoragePaths=I}),define(be[37],Ee([0,1,3,5,4,2,12,7,6,127,15,165,21,36,148,43,10]),function(re,e,h,F,E,A,R,I,y,k,t,_,r,d,a,l,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,E.createDecorator)("IExtHostTerminalService");class T{constructor(f,p,w,C){this._proxy=f,this._id=p,this._creationOptions=w,this._name=C,this._disposed=!1,this._state={interactedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(n=>this._pidPromiseComplete=n);const P=this;this.value={get name(){return P._name||""},get processId(){return P._pidPromise},get creationOptions(){return P._creationOptions},get exitStatus(){return P._exitStatus},get state(){return P._state},sendText(n,m=!0){P._checkDisposed(),P._proxy.$sendText(P._id,n,m)},show(n){P._checkDisposed(),P._proxy.$show(P._id,n)},hide(){P._checkDisposed(),P._proxy.$hide(P._id)},dispose(){P._disposed||(P._disposed=!0,P._proxy.$dispose(P._id))},get dimensions(){if(!(P._cols===void 0||P._rows===void 0))return{columns:P._cols,rows:P._rows}}}}async create(f,p){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:f.name,shellPath:(0,v.withNullAsUndefined)(f.shellPath),shellArgs:(0,v.withNullAsUndefined)(f.shellArgs),cwd:(0,v.withNullAsUndefined)(f.cwd),env:(0,v.withNullAsUndefined)(f.env),icon:(0,v.withNullAsUndefined)(s(f.iconPath)),color:l.ThemeColor.isThemeColor(f.color)?f.color.id:void 0,initialText:(0,v.withNullAsUndefined)(f.message),strictEnv:(0,v.withNullAsUndefined)(f.strictEnv),hideFromUser:(0,v.withNullAsUndefined)(f.hideFromUser),isFeatureTerminal:(0,v.withNullAsUndefined)(p?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,v.withNullAsUndefined)(p?.useShellEnvironment),isSplitTerminal:p?.isSplitTerminal,target:p?.target})}async createExtensionTerminal(f,p,w,C){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:w,color:l.ThemeColor.isThemeColor(C)?C.id:void 0,isSplitTerminal:f,target:p}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(f){this._name=f}setExitCode(f){this._exitStatus=Object.freeze({code:f})}setDimensions(f,p){return f===this._cols&&p===this._rows||f===0||p===0?!1:(this._cols=f,this._rows=p,!0)}setInteractedWith(){return this._state.interactedWith?!1:(this._state={interactedWith:!0},!0)}_setProcessId(f){this._pidPromiseComplete?(this._pidPromiseComplete(f),this._pidPromiseComplete=void 0):this._pidPromise.then(p=>{p!==f&&(this._pidPromise=Promise.resolve(f))})}}e.ExtHostTerminal=T;class b{constructor(f){this._pty=f,this.id=0,this.shouldPersist=!1,this._onProcessData=new h.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessExit=new h.Emitter,this.onProcessExit=this._onProcessExit.event,this._onProcessReady=new h.Emitter,this._onProcessTitleChanged=new h.Emitter,this.onProcessTitleChanged=this._onProcessTitleChanged.event,this._onProcessOverrideDimensions=new h.Emitter,this._onProcessShellTypeChanged=new h.Emitter,this.onProcessShellTypeChanged=this._onProcessShellTypeChanged.event}get onProcessReady(){return this._onProcessReady.event}get onProcessOverrideDimensions(){return this._onProcessOverrideDimensions.event}async start(){}shutdown(){this._pty.close()}input(f){this._pty.handleInput&&this._pty.handleInput(f)}resize(f,p){this._pty.setDimensions&&this._pty.setDimensions({columns:f,rows:p})}async processBinary(f){}acknowledgeDataEvent(f){}async setUnicodeVersion(f){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(f){this._pty.onDidWrite(p=>this._onProcessData.fire(p)),this._pty.onDidClose&&this._pty.onDidClose((p=void 0)=>{this._onProcessExit.fire(p===void 0?void 0:p)}),this._pty.onDidOverrideDimensions&&this._pty.onDidOverrideDimensions(p=>this._onProcessOverrideDimensions.fire(p&&{cols:p.columns,rows:p.rows})),this._pty.onDidChangeName&&this._pty.onDidChangeName(p=>this._onProcessTitleChanged.fire(p)),this._pty.open(f||void 0),this._pty.setDimensions&&f&&this._pty.setDimensions(f),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=b;let c=1,g=class extends I.Disposable{constructor(f,p){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new h.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new h.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new h.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new h.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new h.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=p.getProxy(F.MainContext.MainThreadTerminalService),this._bufferer=new a.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new h.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(f),this._register({dispose:()=>{for(const[w,C]of this._terminalProcesses)C.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(f=>f.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(f){return(f?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(f,p){const w=new T(this._proxy,(0,d.generateUuid)(),f,f.name),C=new b(f.pty);return w.createExtensionTerminal(p?.isSplitTerminal,p?.target,s(f.iconPath),u(f.color)).then(P=>{const n=this._setupExtHostProcessListeners(P,C);this._terminalProcessDisposables[P]=n}),this._terminals.push(w),w.value}attachPtyToTerminal(f,p){if(!this._getTerminalById(f))throw new Error(`Cannot resolve terminal with id ${f} for virtual process`);const C=new b(p),P=this._setupExtHostProcessListeners(f,C);this._terminalProcessDisposables[f]=P}async $acceptActiveTerminalChanged(f){const p=this._activeTerminal;if(f===null){this._activeTerminal=void 0,p!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const w=this._getTerminalById(f);w&&(this._activeTerminal=w,p!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(f,p){const w=this._getTerminalById(f);w&&this._onDidWriteTerminalData.fire({terminal:w.value,data:p})}async $acceptTerminalDimensions(f,p,w){const C=this._getTerminalById(f);C&&C.setDimensions(p,w)&&this._onDidChangeTerminalDimensions.fire({terminal:C.value,dimensions:C.value.dimensions})}async $acceptTerminalMaximumDimensions(f,p,w){this._terminalProcesses.get(f)?.resize(p,w)}async $acceptTerminalTitleChange(f,p){const w=this._getTerminalById(f);w&&(w.name=p)}async $acceptTerminalClosed(f,p){const w=this._getTerminalObjectIndexById(this._terminals,f);if(w!==null){const C=this._terminals.splice(w,1)[0];C.setExitCode(p),this._onDidCloseTerminal.fire(C.value)}}$acceptTerminalOpened(f,p,w,C){if(p){const m=this._getTerminalObjectIndexById(this._terminals,p);if(m!==null){this._terminals[m]._id=f,this._onDidOpenTerminal.fire(this.terminals[m]),this._terminals[m].isOpen=!0;return}}const P={name:C.name,shellPath:C.executable,shellArgs:C.args,cwd:typeof C.cwd=="string"?C.cwd:A.URI.revive(C.cwd),env:C.env,hideFromUser:C.hideFromUser},n=new T(this._proxy,f,P,w);this._terminals.push(n),this._onDidOpenTerminal.fire(n.value),n.isOpen=!0}async $acceptTerminalProcessId(f,p){const w=this._getTerminalById(f);w&&w._setProcessId(p)}async $startExtensionTerminal(f,p){const w=this._getTerminalById(f);if(!w)return{message:(0,k.localize)(0,null,f)};w.isOpen||await new Promise(P=>{const n=this.onDidOpenTerminal(async m=>{m===w.value&&(n.dispose(),P())})});const C=this._terminalProcesses.get(f);C?C.startSendingEvents(p):this._extensionTerminalAwaitingStart[f]={initialDimensions:p}}_setupExtHostProcessListeners(f,p){const w=new I.DisposableStore;w.add(p.onProcessReady(P=>this._proxy.$sendProcessReady(f,P.pid,P.cwd))),w.add(p.onProcessTitleChanged(P=>this._proxy.$sendProcessTitle(f,P))),this._bufferer.startBuffering(f,p.onProcessData),w.add(p.onProcessExit(P=>this._onProcessExit(f,P))),p.onProcessOverrideDimensions&&w.add(p.onProcessOverrideDimensions(P=>this._proxy.$sendOverrideDimensions(f,P))),this._terminalProcesses.set(f,p);const C=this._extensionTerminalAwaitingStart[f];return C&&p instanceof b&&(p.startSendingEvents(C.initialDimensions),delete this._extensionTerminalAwaitingStart[f]),w}$acceptProcessAckDataEvent(f,p){this._terminalProcesses.get(f)?.acknowledgeDataEvent(p)}$acceptProcessInput(f,p){this._terminalProcesses.get(f)?.input(p)}$acceptTerminalInteraction(f){const p=this._getTerminalById(f);p?.setInteractedWith()&&this._onDidChangeTerminalState.fire({terminal:p.value,state:p.value.state})}$acceptProcessResize(f,p,w){try{this._terminalProcesses.get(f)?.resize(p,w)}catch(C){if(C.code!=="EPIPE"&&C.code!=="ERR_IPC_CHANNEL_CLOSED")throw C}}$acceptProcessShutdown(f,p){this._terminalProcesses.get(f)?.shutdown(p)}$acceptProcessRequestInitialCwd(f){this._terminalProcesses.get(f)?.getInitialCwd().then(p=>this._proxy.$sendProcessInitialCwd(f,p))}$acceptProcessRequestCwd(f){this._terminalProcesses.get(f)?.getCwd().then(p=>this._proxy.$sendProcessCwd(f,p))}$acceptProcessRequestLatency(f){return f}registerLinkProvider(f){return this._linkProviders.add(f),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new y.Disposable(()=>{this._linkProviders.delete(f),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(f,p,w){if(this._profileProviders.has(p))throw new Error(`Terminal profile provider "${p}" already registered`);return this._profileProviders.set(p,w),this._proxy.$registerProfileProvider(p,f.identifier.value),new y.Disposable(()=>{this._profileProviders.delete(p),this._proxy.$unregisterProfileProvider(p)})}async $createContributedProfileTerminal(f,p){const w=new r.CancellationTokenSource().token,C=await this._profileProviders.get(f)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(!C||!("options"in C))throw new Error(`No terminal profile options provided for id "${f}"`);if("pty"in C.options){this.createExtensionTerminal(C.options,p);return}this.createTerminalFromOptions(C.options,p)}}async $provideLinks(f,p){const w=this._getTerminalById(f);if(!w)return[];this._terminalLinkCache.delete(f);const C=this._terminalLinkCancellationSource.get(f);C&&C.dispose(!0);const P=new r.CancellationTokenSource;this._terminalLinkCancellationSource.set(f,P);const n=[],m={terminal:w.value,line:p},D=[];for(const Q of this._linkProviders)D.push(new Promise(async ie=>{P.token.onCancellationRequested(()=>ie({provider:Q,links:[]}));const V=await Q.provideTerminalLinks(m,P.token)||[];P.token.isCancellationRequested||ie({provider:Q,links:V})}));const O=await Promise.all(D);if(P.token.isCancellationRequested)return[];const $=new Map;for(const Q of O)Q&&Q.links.length>0&&n.push(...Q.links.map(ie=>{const V={id:c++,startIndex:ie.startIndex,length:ie.length,label:ie.tooltip};return $.set(V.id,{provider:Q.provider,link:ie}),V}));return this._terminalLinkCache.set(f,$),n}$activateLink(f,p){const w=this._terminalLinkCache.get(f)?.get(p);!w||w.provider.handleTerminalLink(w.link)}_onProcessExit(f,p){this._bufferer.stopBuffering(f),this._terminalProcesses.delete(f),delete this._extensionTerminalAwaitingStart[f];const w=this._terminalProcessDisposables[f];w&&(w.dispose(),delete this._terminalProcessDisposables[f]),this._proxy.$sendProcessExit(f,p)}_getTerminalById(f){return this._getTerminalObjectById(this._terminals,f)}_getTerminalObjectById(f,p){const w=this._getTerminalObjectIndexById(f,p);return w!==null?f[w]:null}_getTerminalObjectIndexById(f,p){let w=null;return f.some((C,P)=>C._id===p?(w=P,!0):!1),w}getEnvironmentVariableCollection(f){let p=this._environmentVariableCollections.get(f.identifier.value);return p||(p=new S,this._setEnvironmentVariableCollection(f.identifier.value,p)),p}_syncEnvironmentVariableCollection(f,p){const w=(0,_.serializeEnvironmentVariableCollection)(p.map);this._proxy.$setEnvironmentVariableCollection(f,p.persistent,w.length===0?void 0:w)}$initEnvironmentVariableCollections(f){f.forEach(p=>{const w=p[0],C=new S(p[1]);this._setEnvironmentVariableCollection(w,C)})}$acceptDefaultProfile(f,p){this._defaultProfile=f,this._defaultAutomationProfile=p}_setEnvironmentVariableCollection(f,p){this._environmentVariableCollections.set(f,p),p.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(f,p)})}};g=Be([We(1,R.IExtHostRpcService)],g),e.BaseExtHostTerminalService=g;class S{constructor(f){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new h.Emitter,this.map=new Map(f)}get persistent(){return this._persistent}set persistent(f){this._persistent=f,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(f,p){this._setIfDiffers(f,{value:p,type:y.EnvironmentVariableMutatorType.Replace})}append(f,p){this._setIfDiffers(f,{value:p,type:y.EnvironmentVariableMutatorType.Append})}prepend(f,p){this._setIfDiffers(f,{value:p,type:y.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(f,p){const w=this.map.get(f);(!w||w.value!==p.value||w.type!==p.type)&&(this.map.set(f,p),this._onDidChangeCollection.fire())}get(f){return this.map.get(f)}forEach(f,p){this.map.forEach((w,C)=>f.call(p,C,w,this))}delete(f){this.map.delete(f),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=S;let i=class extends g{constructor(f){super(!1,f)}createTerminal(f,p,w){throw new t.NotSupportedError}createTerminalFromOptions(f,p){throw new t.NotSupportedError}};i=Be([We(0,R.IExtHostRpcService)],i),e.WorkerExtHostTerminalService=i;function s(o){if(!(!o||typeof o=="string"))return"id"in o?{id:o.id,color:o.color}:o}function u(o){return l.ThemeColor.isThemeColor(o)?o:void 0}});var et=this&&this.__classPrivateFieldSet||function(re,e,h,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(re,h):E?E.value=h:e.set(re,h),h},Oe=this&&this.__classPrivateFieldGet||function(re,e,h,F){if(h==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!F:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?F:h==="a"?F.call(re):F?F.value:e.get(re)};define(be[203],Ee([0,1,23,21,3,233,57,188,7,22,10,36,5,12,64,8,6,173,90,68]),function(re,e,h,F,E,A,R,I,y,k,t,_,r,d,a,l,v,T,b,c){"use strict";var g;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let S=class{constructor(D,O){this.resultsChangedEmitter=new E.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=D.getProxy(r.MainContext.MainThreadTesting),this.observer=new C(this.proxy),this.runTracker=new s(this.proxy),O.registerArgumentProcessor({processArgument:$=>$?.$mid===13?l.TestItem.toItemFromContext($):$})}createTestController(D,O){if(this.controllers.has(D))throw new Error(`Attempt to insert a duplicate controller with ID "${D}"`);const $=new y.DisposableStore,Q=$.add(new T.SingleUseTestCollection(D));Q.root.label=O;const ie=new Map,V=this.proxy,W={items:Q.root.children,get label(){return O},set label(Y){O=Y,Q.root.label=Y,V.$updateControllerLabel(D,O)},get id(){return D},createRunProfile:(Y,B,G,de,j)=>{let le=(0,R.hash)(Y);for(;ie.has(le);)le++;const ae=new P(this.proxy,D,le,Y,B,G,de,j);return ie.set(le,ae),ae},createTestItem(Y,B,G){return new a.TestItemImpl(D,Y,B,G)},createTestRun:(Y,B,G=!0)=>this.runTracker.createTestRun(D,Q,Y,B,G),set resolveHandler(Y){Q.resolveHandler=Y},get resolveHandler(){return Q.resolveHandler},dispose:()=>{$.dispose()}};W.createRunConfiguration=W.createRunProfile,V.$registerTestController(D,O),$.add((0,y.toDisposable)(()=>V.$unregisterTestController(D)));const L={controller:W,collection:Q,profiles:ie};return this.controllers.set(D,L),$.add((0,y.toDisposable)(()=>this.controllers.delete(D))),$.add(Q.onDidGenerateDiff(Y=>V.$publishDiff(D,Y))),W}createTestObserver(){return this.observer.checkout()}async runTests(D,O=F.CancellationToken.None){const $=u(D);if(!$)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const Q=this.controllers.get($.controllerId);if(!Q)throw new Error("Controller not found");await this.proxy.$runTests({targets:[{testIds:D.include?.map(ie=>ie.id)??[Q.collection.root.id],profileGroup:n[$.kind],profileId:$.profileId,controllerId:$.controllerId}],exclude:D.exclude?.map(ie=>ie.id)},O)}$provideFileCoverage(D,O,$){return I.Iterable.find(this.runTracker.trackers,Q=>Q.id===D)?.getCoverage(O)?.provideFileCoverage($)??Promise.resolve([])}$resolveFileCoverage(D,O,$,Q){return I.Iterable.find(this.runTracker.trackers,ie=>ie.id===D)?.getCoverage(O)?.resolveFileCoverage($,Q)??Promise.resolve([])}$configureRunProfile(D,O){this.controllers.get(D)?.profiles.get(O)?.configureHandler?.()}$getTestTags(D){const O=this.controllers.get(D);if(!O)return Promise.resolve([]);const $=new Map;for(const Q of O.profiles.values())if(Q.tag){const ie=l.TestTag.display(D,Q.tag);$.set(ie.id,ie)}for(const Q of O.collection.tags()){const ie=l.TestTag.display(D,Q);$.set(ie.id,ie)}return Promise.resolve([...$.values()])}$publishTestResults(D){this.results=Object.freeze(D.map(O=>(0,k.deepFreeze)(l.TestResults.to(O))).concat(this.results).sort((O,$)=>$.completedAt-O.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(D,O){const $=this.controllers.get(c.TestId.fromString(D).controllerId)?.collection;$&&(await $.expand(D,O<0?Infinity:O),$.flushDiff())}$acceptDiff(D){this.observer.applyDiff(D)}async $runControllerTests(D,O){const $=this.controllers.get(D.controllerId);if(!$)return;const{collection:Q,profiles:ie}=$,V=ie.get(D.profileId);if(!V)return;const W=D.testIds.map(G=>Q.tree.get(G)).filter(t.isDefined),L=D.excludeExtIds.map(G=>$.collection.tree.get(G)).filter(t.isDefined).filter(G=>W.some(de=>de.fullId.compare(G.fullId)===2));if(!W.length)return;const Y=new v.TestRunRequest(W.some(G=>G.actual instanceof a.TestItemRootImpl)?void 0:W.map(G=>G.actual),L.map(G=>G.actual),V),B=this.runTracker.prepareForMainThreadTestRun(Y,o.fromInternal(D,$.collection),O);try{await V.runHandler(Y,O)}finally{B.isRunning&&!O.isCancellationRequested&&await E.Event.toPromise(B.onEnd),this.runTracker.cancelRunById(D.runId)}}$cancelExtensionTestRun(D){D===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(D)}};S=Be([We(0,d.IExtHostRpcService)],S),e.ExtHostTesting=S;class i extends y.Disposable{constructor(D,O,$){super();this.dto=D,this.proxy=O,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new E.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new F.CancellationTokenSource($)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:Q}of this.tasks.values())Q.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(D){return this.tasks.get(D)?.coverage}createRun(D){const O=this.dto.id,$=this.dto.controllerId,Q=(0,_.generateUuid)(),ie=new f(this.proxy,O,Q),V=Y=>(B,...G)=>{if(W){console.warn(`Setting the state of test "${B.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(B)||(this.ensureTestIsKnown(B),Y(B,...G))};let W=!1;const L={isPersisted:this.dto.isPersisted,token:this.cts.token,name:D,get coverageProvider(){return ie.coverageProvider},set coverageProvider(Y){ie.coverageProvider=Y},enqueued:V(Y=>{this.proxy.$updateTestStateInRun(O,Q,c.TestId.fromExtHostTestItem(Y,$).toString(),1)}),skipped:V(Y=>{this.proxy.$updateTestStateInRun(O,Q,c.TestId.fromExtHostTestItem(Y,$).toString(),5)}),started:V(Y=>{this.proxy.$updateTestStateInRun(O,Q,c.TestId.fromExtHostTestItem(Y,$).toString(),2)}),errored:V((Y,B,G)=>{this.proxy.$appendTestMessagesInRun(O,Q,c.TestId.fromExtHostTestItem(Y,$).toString(),B instanceof Array?B.map(l.TestMessage.from):[l.TestMessage.from(B)]),this.proxy.$updateTestStateInRun(O,Q,c.TestId.fromExtHostTestItem(Y,$).toString(),6,G)}),failed:V((Y,B,G)=>{this.proxy.$appendTestMessagesInRun(O,Q,c.TestId.fromExtHostTestItem(Y,$).toString(),B instanceof Array?B.map(l.TestMessage.from):[l.TestMessage.from(B)]),this.proxy.$updateTestStateInRun(O,Q,c.TestId.fromExtHostTestItem(Y,$).toString(),4,G)}),passed:V((Y,B)=>{this.proxy.$updateTestStateInRun(O,Q,c.TestId.fromExtHostTestItem(Y,this.dto.controllerId).toString(),3,B)}),appendOutput:(Y,B,G)=>{W||(G&&(this.dto.isIncluded(G)?this.ensureTestIsKnown(G):G=void 0),this.proxy.$appendOutputToRun(O,Q,h.VSBuffer.fromString(Y),B&&l.location.from(B),G&&c.TestId.fromExtHostTestItem(G,$).toString()))},end:()=>{W||(W=!0,this.proxy.$finishedTestRunTask(O,Q),this.tasks.delete(Q),this.isRunning||this.dispose())}};return this.tasks.set(Q,{run:L,coverage:ie}),this.proxy.$startedTestRunTask(O,{id:Q,name:D,running:!0}),L}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(D){if(!(D instanceof a.TestItemImpl))throw new a.InvalidTestItemError(D.id);if(this.sharedTestIds.has(D.id))return;const O=[];for(;O.unshift(l.TestItem.from(D)),!(this.sharedTestIds.has(D.id)||(this.sharedTestIds.add(D.id),!D.parent));)D=D.parent;const $=this.dto.colllection.root;this.sharedTestIds.has($.id)||(this.sharedTestIds.add($.id),O.unshift(l.TestItem.from($))),this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,O)}}class s{constructor(D){this.proxy=D,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(D,O,$){return this.getTracker(D,O,$)}cancelRunById(D){for(const O of this.tracked.values())if(O.id===D){O.dispose();return}}cancelAllRuns(){for(const D of this.tracked.values())D.dispose()}createTestRun(D,O,$,Q,ie){const V=this.tracked.get($);if(V)return V.createRun(Q);const W=o.fromPublic(D,O,$,ie),L=u($);this.proxy.$startedExtensionTestRun({controllerId:D,profile:L&&{group:n[L.kind],id:L.profileId},exclude:$.exclude?.map(B=>B.id)??[],id:W.id,include:$.include?.map(B=>B.id)??[O.root.id],persist:ie});const Y=this.getTracker($,W);return Y.onEnd(()=>this.proxy.$finishedExtensionTestRun(W.id)),Y.createRun(Q)}getTracker(D,O,$){const Q=new i(O,this.proxy,$);return this.tracked.set(D,Q),Q.onEnd(()=>this.tracked.delete(D)),Q}}e.TestRunCoordinator=s;const u=m=>{if(!!m.profile){if(!(m.profile instanceof P))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return m.profile}};class o{constructor(D,O,$,Q,ie,V){this.controllerId=D,this.id=O,this.isPersisted=ie,this.colllection=V,this.includePrefix=$.map(W=>W+"\0"),this.excludePrefix=Q.map(W=>W+"\0")}static fromPublic(D,O,$,Q){return new o(D,(0,_.generateUuid)(),$.include?.map(ie=>c.TestId.fromExtHostTestItem(ie,D).toString())??[D],$.exclude?.map(ie=>c.TestId.fromExtHostTestItem(ie,D).toString())??[],Q,O)}static fromInternal(D,O){return new o(D.controllerId,D.runId,D.testIds,D.excludeExtIds,!0,O)}isIncluded(D){const O=c.TestId.fromExtHostTestItem(D,this.controllerId).toString()+"\0";for(const $ of this.excludePrefix)if(O===$||O.startsWith($))return!1;for(const $ of this.includePrefix)if(O===$||O.startsWith($))return!0;return!1}}e.TestRunDto=o;class f{constructor(D,O,$){this.proxy=D,this.runId=O,this.taskId=$}set coverageProvider(D){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!D||(this._coverageProvider=D,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(D){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(D))());try{return(await this.fileCoverage)?.map(l.TestCoverage.fromFile)??[]}catch(O){throw this.fileCoverage=void 0,O}}async resolveFileCoverage(D,O){const $=await this.fileCoverage;let Q=$?.[D];return!this._coverageProvider||!$||!Q?[]:(Q.detailedCoverage||(Q=$[D]=await this._coverageProvider.resolveFileCoverage?.(Q,O)??Q),Q.detailedCoverage?.map(l.TestCoverage.fromDetailed)??[])}}class p extends b.IncrementalChangeCollector{constructor(D){super();this.emitter=D,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(D){this.added.add(D)}update(D){Object.assign(D.revived,l.TestItem.toPlain(D.item)),this.added.has(D)||this.updated.add(D)}remove(D){if(this.added.has(D)){this.added.delete(D);return}if(this.updated.delete(D),D.parent&&this.alreadyRemoved.has(D.parent)){this.alreadyRemoved.add(D.item.extId);return}this.removed.add(D)}getChangeEvent(){const{added:D,updated:O,removed:$}=this;return{get added(){return[...D].map(Q=>Q.revived)},get updated(){return[...O].map(Q=>Q.revived)},get removed(){return[...$].map(Q=>Q.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class w extends b.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new E.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(D){return this.items.get(D)}getMirroredTestDataByReference(D){return this.items.get(D.id)}createItem(D,O){return{...D,revived:l.TestItem.toPlain(D.item),depth:O?O.depth+1:0,children:new Set}}createChangeCollector(){return new p(this.changeEmitter)}}e.MirroredTestCollection=w;class C{constructor(D){this.proxy=D}checkout(){this.current||(this.current=this.createObserverData());const D=this.current;return D.observers++,{onDidChangeTest:D.tests.onDidChangeTests,get tests(){return[...D.tests.rootTests].map(O=>O.revived)},dispose:(0,A.once)(()=>{--D.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(D){return this.current?.tests.getMirroredTestDataByReference(D)}applyDiff(D){this.current?.tests.apply(D)}createObserverData(){const D=new w;return this.proxy.$subscribeToDiffs(),{observers:0,tests:D}}}class P{constructor(D,O,$,Q,ie,V,W=!1,L=void 0){this.controllerId=O,this.profileId=$,this._label=Q,this.kind=ie,this.runHandler=V,this._isDefault=W,this._tag=L,g.set(this,void 0),et(this,g,D,"f");const Y=n[ie];if(typeof Y!="number")throw new Error(`Unknown TestRunProfile.group ${ie}`);Oe(this,g,"f").$publishTestRunProfile({profileId:$,controllerId:O,tag:L?l.TestTag.namespace(this.controllerId,L.id):null,label:Q,group:Y,isDefault:W,hasConfigurationHandler:!1})}get label(){return this._label}set label(D){D!==this._label&&(this._label=D,Oe(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:D}))}get isDefault(){return this._isDefault}set isDefault(D){D!==this._isDefault&&(this._isDefault=D,Oe(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:D}))}get tag(){return this._tag}set tag(D){D?.id!==this._tag?.id&&(this._tag=D,Oe(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:D?l.TestTag.namespace(this.controllerId,D.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(D){D!==this._configureHandler&&(this._configureHandler=D,Oe(this,g,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!D}))}dispose(){Oe(this,g,"f").$removeTestProfile(this.controllerId,this.profileId)}}e.TestRunProfileImpl=P,g=new WeakMap;const n={[v.TestRunProfileKind.Coverage]:8,[v.TestRunProfileKind.Debug]:4,[v.TestRunProfileKind.Run]:2}}),define(be[204],Ee([0,1,3,16,5,94,8,6]),function(re,e,h,F,E,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class y{constructor(t,_){this._extHostDocumentsAndEditors=_,this._onDidChangeTextEditorSelection=new h.Emitter,this._onDidChangeTextEditorOptions=new h.Emitter,this._onDidChangeTextEditorVisibleRanges=new h.Emitter,this._onDidChangeTextEditorViewColumn=new h.Emitter,this._onDidChangeActiveTextEditor=new h.Emitter,this._onDidChangeVisibleTextEditors=new h.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=t.getProxy(E.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(r=>this._onDidChangeVisibleTextEditors.fire(r)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(r=>this._onDidChangeActiveTextEditor.fire(r))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(t){const _=this._extHostDocumentsAndEditors.allEditors();return t?_:_.map(r=>r.value)}async showTextDocument(t,_,r){let d;typeof _=="number"?d={position:R.ViewColumn.from(_),preserveFocus:r}:typeof _=="object"?d={position:R.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selection:typeof _.selection=="object"?R.Range.from(_.selection):void 0,pinned:typeof _.preview=="boolean"?!_.preview:void 0}:d={preserveFocus:!1};const a=await this._proxy.$tryShowTextDocument(t.uri,d),l=a&&this._extHostDocumentsAndEditors.getEditor(a);if(l)return l.value;throw a?new Error(`Could NOT open editor for "${t.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${t.uri.toString()}".`)}createTextEditorDecorationType(t,_){return new A.TextEditorDecorationType(this._proxy,t,_).value}$acceptEditorPropertiesChanged(t,_){const r=this._extHostDocumentsAndEditors.getEditor(t);if(!r)throw new Error("unknown text editor");if(_.options&&r._acceptOptions(_.options),_.selections){const d=_.selections.selections.map(R.Selection.to);r._acceptSelections(d)}if(_.visibleRanges){const d=F.coalesce(_.visibleRanges.map(R.Range.to));r._acceptVisibleRanges(d)}if(_.options&&this._onDidChangeTextEditorOptions.fire({textEditor:r.value,options:{..._.options,lineNumbers:R.TextEditorLineNumbersStyle.to(_.options.lineNumbers)}}),_.selections){const d=I.TextEditorSelectionChangeKind.fromValue(_.selections.source),a=_.selections.selections.map(R.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:r.value,selections:a,kind:d})}if(_.visibleRanges){const d=F.coalesce(_.visibleRanges.map(R.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:r.value,visibleRanges:d})}}$acceptEditorPositionData(t){for(const _ in t){const r=this._extHostDocumentsAndEditors.getEditor(_);if(!r)throw new Error("Unknown text editor");const d=R.ViewColumn.to(t[_]);r.value.viewColumn!==d&&(r._acceptViewColumn(d),this._onDidChangeTextEditorViewColumn.fire({textEditor:r.value,viewColumn:d}))}}getDiffInformation(t){return Promise.resolve(this._proxy.$getDiffInformation(t))}}e.ExtHostEditors=y}),define(be[205],Ee([0,1,2,4,5,7,6]),function(re,e,h,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,F.createDecorator)("IExtHostTimeline");class I{constructor(t,_){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadTimeline),_.registerArgumentProcessor({processArgument:r=>{if(r&&r.$mid===11){const d=r.uri===void 0?void 0:h.URI.revive(r.uri);return this._itemsBySourceAndUriMap.get(r.source)?.get(y(d))?.get(r.handle)}return r}})}async $getTimeline(t,_,r,d,a){return this._providers.get(t)?.provideTimeline(h.URI.revive(_),r,d,a)}registerTimelineProvider(t,_,r,d){const a=new A.DisposableStore,l=this.convertTimelineItem(_.id,d,a).bind(this);let v;_.onDidChange&&(v=_.onDidChange(b=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...b,id:_.id}),this));const T=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({..._,scheme:t,onDidChange:void 0,async provideTimeline(b,c,g,S){S?.resetCache&&(a.clear(),T.get(_.id)?.clear());const i=await _.provideTimeline(b,c,g);if(i==null)return;const s=l(b,S);return{...i,source:_.id,items:i.items.map(s)}},dispose(){for(const b of T.values())b.get(_.id)?.clear();v?.dispose(),a.dispose()}})}convertTimelineItem(t,_,r){return(d,a)=>{let l;if(a?.cacheResults){let v=this._itemsBySourceAndUriMap.get(t);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(t,v));const T=y(d);l=v.get(T),l===void 0&&(l=new Map,v.set(T,l))}return v=>{const{iconPath:T,...b}=v,c=`${t}|${v.id??v.timestamp}`;l?.set(c,v);let g,S,i;return v.iconPath&&(T instanceof R.ThemeIcon?i={id:T.id,color:T.color}:h.URI.isUri(T)?(g=T,S=T):{light:g,dark:S}=T),{...b,id:b.id??void 0,handle:c,source:t,command:v.command?_.toInternal(v.command,r):void 0,icon:g,iconDark:S,themeIcon:i,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(t){if(this._providers.get(t.id))throw new Error(`Timeline Provider ${t.id} already exists.`);return this._proxy.$registerTimelineProvider({id:t.id,label:t.label,scheme:t.scheme}),this._providers.set(t.id,t),(0,A.toDisposable)(()=>{for(const r of this._itemsBySourceAndUriMap.values())r.get(t.id)?.clear();this._providers.delete(t.id),this._proxy.$unregisterTimelineProvider(t.id),t.dispose()})}}e.ExtHostTimeline=I;function y(k){return k?.toString()}}),define(be[206],Ee([0,1,7,11,2,5]),function(re,e,h,F,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class R{constructor(y){this._openers=new Map,this._proxy=y.getProxy(A.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(y,k,t,_){if(this._openers.has(k))throw new Error(`Opener with id '${k}' already registered`);const r=_.schemes.find(d=>!R.supportedSchemes.has(d));if(r)throw new Error(`Scheme '${r}' is not supported. Only http and https are currently supported.`);return this._openers.set(k,t),this._proxy.$registerUriOpener(k,_.schemes,y,_.label),(0,h.toDisposable)(()=>{this._openers.delete(k),this._proxy.$unregisterUriOpener(k)})}async $canOpenUri(y,k,t){const _=this._openers.get(y);if(!_)throw new Error(`Unknown opener with id: ${y}`);const r=E.URI.revive(k);return _.canOpenExternalUri(r,t)}async $openUri(y,k,t){const _=this._openers.get(y);if(!_)throw new Error(`Unknown opener id: '${y}'`);return _.openExternalUri(E.URI.revive(k.resolvedUri),{sourceUri:E.URI.revive(k.sourceUri)},t)}}e.ExtHostUriOpeners=R,R.supportedSchemes=new Set([F.Schemas.http,F.Schemas.https])}),define(be[207],Ee([0,1,5,2,7,15,25]),function(re,e,h,F,E,A,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class I{constructor(k){this.handles=new Set,this.handlers=new Map,this._proxy=k.getProxy(h.MainContext.MainThreadUrls)}registerUriHandler(k,t){if(this.handles.has(R.ExtensionIdentifier.toKey(k)))throw new Error(`Protocol handler already registered for extension ${k}`);const _=I.HandlePool++;return this.handles.add(R.ExtensionIdentifier.toKey(k)),this.handlers.set(_,t),this._proxy.$registerUriHandler(_,k),(0,E.toDisposable)(()=>{this.handles.delete(R.ExtensionIdentifier.toKey(k)),this.handlers.delete(_),this._proxy.$unregisterUriHandler(_)})}$handleExternalUri(k,t){const _=this.handlers.get(k);if(!_)return Promise.resolve(void 0);try{_.handleUri(F.URI.revive(t))}catch(r){(0,A.onUnexpectedError)(r)}return Promise.resolve(void 0)}async createAppUri(k){return F.URI.revive(await this._proxy.$createAppUri(k))}}e.ExtHostUrls=I,I.HandlePool=0});var et=this&&this.__classPrivateFieldSet||function(re,e,h,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(re,h):E?E.value=h:e.set(re,h),h},Oe=this&&this.__classPrivateFieldGet||function(re,e,h,F){if(h==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!F:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?F:h==="a"?F.call(re):F?F.value:e.get(re)};define(be[49],Ee([0,1,3,2,137,156,67,5]),function(re,e,h,F,E,A,R,I){"use strict";var y,k,t,_,r,d,a,l,v,T,b,c;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class g{constructor(w,C,P,n,m,D,O){y.set(this,void 0),k.set(this,void 0),t.set(this,void 0),_.set(this,void 0),r.set(this,void 0),d.set(this,void 0),a.set(this,""),l.set(this,void 0),v.set(this,!1),T.set(this,!1),b.set(this,!1),this._onMessageEmitter=new h.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,c.set(this,new h.Emitter),this._onDidDispose=Oe(this,c,"f").event,et(this,y,w,"f"),et(this,k,C,"f"),et(this,l,P,"f"),et(this,_,n,"f"),et(this,r,m,"f"),et(this,d,D,"f"),et(this,b,S(D),"f"),et(this,t,O,"f")}dispose(){et(this,v,!0,"f"),Oe(this,c,"f").fire(),Oe(this,c,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(w){return et(this,T,!0,"f"),(0,R.asWebviewUri)(w,Oe(this,_,"f").remote)}get cspSource(){return R.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,a,"f")}set html(w){this.assertNotDisposed(),Oe(this,a,"f")!==w&&(et(this,a,w,"f"),!Oe(this,T,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(w)&&(et(this,T,!0,"f"),Oe(this,t,"f").report("Webview vscode-resource: uris",Oe(this,d,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,k,"f").$setHtml(Oe(this,y,"f"),w))}get options(){return this.assertNotDisposed(),Oe(this,l,"f")}set options(w){this.assertNotDisposed(),Oe(this,k,"f").$setOptions(Oe(this,y,"f"),u(Oe(this,d,"f"),Oe(this,r,"f"),w)),et(this,l,w,"f")}async postMessage(w){if(Oe(this,v,"f"))return!1;const C=(0,A.serializeWebviewMessage)(w,{serializeBuffersForPostMessage:Oe(this,b,"f")});return Oe(this,k,"f").$postMessage(Oe(this,y,"f"),C.message,...C.buffers)}assertNotDisposed(){if(Oe(this,v,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=g,y=new WeakMap,k=new WeakMap,t=new WeakMap,_=new WeakMap,r=new WeakMap,d=new WeakMap,a=new WeakMap,l=new WeakMap,v=new WeakMap,T=new WeakMap,b=new WeakMap,c=new WeakMap;function S(p){try{const w=(0,E.normalizeVersion)((0,E.parseVersion)(p.engines.vscode));return!!w&&w.majorBase>=1&&w.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=S;class i{constructor(w,C,P,n,m){this.initData=C,this.workspace=P,this._logService=n,this._deprecationService=m,this._webviews=new Map,this._webviewProxy=w.getProxy(I.MainContext.MainThreadWebviews)}$onMessage(w,C,...P){const n=this.getWebview(w);if(n){const{message:m}=(0,A.deserializeWebviewMessage)(C,P);n._onMessageEmitter.fire(m)}}$onMissingCsp(w,C){this._logService.warn(`${C} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(w,C,P){const n=new g(w,this._webviewProxy,o(C),this.initData,this.workspace,P,this._deprecationService);return this._webviews.set(w,n),n._onDidDispose(()=>{this._webviews.delete(w)}),n}deleteWebview(w){this._webviews.delete(w)}getWebview(w){return this._webviews.get(w)}}e.ExtHostWebviews=i;function s(p){return{id:p.identifier,location:p.extensionLocation}}e.toExtensionData=s;function u(p,w,C){return{enableCommandUris:C.enableCommandUris,enableScripts:C.enableScripts,portMapping:C.portMapping,localResourceRoots:C.localResourceRoots||f(p,w)}}e.serializeWebviewOptions=u;function o(p){return{enableCommandUris:p.enableCommandUris,enableScripts:p.enableScripts,portMapping:p.portMapping,localResourceRoots:p.localResourceRoots?.map(w=>F.URI.from(w))}}e.reviveOptions=o;function f(p,w){return[...(w?.getWorkspaceFolders()||[]).map(C=>C.uri),p.extensionLocation]}}),define(be[208],Ee([0,1,21,57,7,11,24,2,8,49,62,5,6]),function(re,e,h,F,E,A,R,I,y,k,t,_,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class d{constructor(i,s){this.document=i,this._storagePath=s,this._backupCounter=1,this._edits=new t.Cache("custom documents")}addEdit(i){return this._edits.add([i])}async undo(i,s){await this.getEdit(i).undo(),s||this.disposeBackup()}async redo(i,s){await this.getEdit(i).redo(),s||this.disposeBackup()}disposeEdits(i){for(const s of i)this._edits.delete(s)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const i=g(this.document.uri)+this._backupCounter++;return(0,R.joinPath)(this._storagePath,i)}updateBackup(i){this._backup?.delete(),this._backup=i}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(i){const s=this._edits.get(i,0);if(!s)throw new Error("No edit found");return s}}class a{constructor(){this._documents=new Map}get(i,s){return this._documents.get(this.key(i,s))}add(i,s,u){const o=this.key(i,s.uri);if(this._documents.has(o))throw new Error(`Document already exists for viewType:${i} resource:${s.uri}`);const f=new d(s,u);return this._documents.set(o,f),f}delete(i,s){const u=this.key(i,s.uri);this._documents.delete(u)}key(i,s){return`${i}@@@${s}`}}var l;(function(S){S[S.Text=0]="Text",S[S.Custom=1]="Custom"})(l||(l={}));class v{constructor(){this._providers=new Map}addTextProvider(i,s,u){return this.add(0,i,s,u)}addCustomProvider(i,s,u){return this.add(1,i,s,u)}get(i){return this._providers.get(i)}add(i,s,u,o){if(this._providers.has(s))throw new Error(`Provider for viewType:${s} already registered`);return this._providers.set(s,{type:i,extension:u,provider:o}),new r.Disposable(()=>this._providers.delete(s))}}class T{constructor(i,s,u,o,f){this._extHostDocuments=s,this._extensionStoragePaths=u,this._extHostWebview=o,this._extHostWebviewPanels=f,this._editorProviders=new v,this._documents=new a,this._proxy=i.getProxy(_.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(i,s,u,o){const f=new E.DisposableStore;return b(u)?(f.add(this._editorProviders.addTextProvider(s,i,u)),this._proxy.$registerTextEditorProvider((0,k.toExtensionData)(i),s,o.webviewOptions||{},{supportsMove:!!u.moveCustomTextEditor},(0,k.shouldSerializeBuffersForPostMessage)(i))):(f.add(this._editorProviders.addCustomProvider(s,i,u)),this.supportEditing(u)&&f.add(u.onDidChangeCustomDocument(p=>{const w=this.getCustomDocumentEntry(s,p.document.uri);if(c(p)){const C=w.addEdit(p);this._proxy.$onDidEdit(p.document.uri,s,C,p.label)}else this._proxy.$onContentChange(p.document.uri,s)})),this._proxy.$registerCustomEditorProvider((0,k.toExtensionData)(i),s,o.webviewOptions||{},!!o.supportsMultipleEditorsPerDocument,(0,k.shouldSerializeBuffersForPostMessage)(i))),r.Disposable.from(f,new r.Disposable(()=>{this._proxy.$unregisterEditorProvider(s)}))}async $createCustomDocument(i,s,u,o,f){const p=this._editorProviders.get(s);if(!p)throw new Error(`No provider found for '${s}'`);if(p.type!==1)throw new Error(`Invalid provide type for '${s}'`);const w=I.URI.revive(i),C=await p.provider.openCustomDocument(w,{backupId:u,untitledDocumentData:o?.buffer},f);let P;return this.supportEditing(p.provider)&&this._extensionStoragePaths&&(P=this._extensionStoragePaths.workspaceValue(p.extension)??this._extensionStoragePaths.globalValue(p.extension)),this._documents.add(s,C,P),{editable:this.supportEditing(p.provider)}}async $disposeCustomDocument(i,s){const u=this._editorProviders.get(s);if(!u)throw new Error(`No provider found for '${s}'`);if(u.type!==1)throw new Error(`Invalid provider type for '${s}'`);const o=I.URI.revive(i),{document:f}=this.getCustomDocumentEntry(s,o);this._documents.delete(s,f),f.dispose()}async $resolveWebviewEditor(i,s,u,o,f,p){const w=this._editorProviders.get(u);if(!w)throw new Error(`No provider found for '${u}'`);const C=y.ViewColumn.to(f),P=this._extHostWebview.createNewWebview(s,o.webviewOptions,w.extension),n=this._extHostWebviewPanels.createNewWebviewPanel(s,u,o.title,C,o.panelOptions,P),m=I.URI.revive(i);switch(w.type){case 1:{const{document:D}=this.getCustomDocumentEntry(u,m);return w.provider.resolveCustomEditor(D,n,p)}case 0:{const D=this._extHostDocuments.getDocument(m);return w.provider.resolveCustomTextEditor(D,n,p)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(i,s,u){this.getCustomDocumentEntry(s,i).disposeEdits(u)}async $onMoveCustomEditor(i,s,u){const o=this._editorProviders.get(u);if(!o)throw new Error(`No provider found for '${u}'`);if(!o.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${u}'`);const f=this._extHostWebviewPanels.getWebviewPanel(i);if(!f)throw new Error("No webview found");const p=I.URI.revive(s),w=this._extHostDocuments.getDocument(p);await o.provider.moveCustomTextEditor(w,f,h.CancellationToken.None)}async $undo(i,s,u,o){return this.getCustomDocumentEntry(s,i).undo(u,o)}async $redo(i,s,u,o){return this.getCustomDocumentEntry(s,i).redo(u,o)}async $revert(i,s,u){const o=this.getCustomDocumentEntry(s,i);await this.getCustomEditorProvider(s).revertCustomDocument(o.document,u),o.disposeBackup()}async $onSave(i,s,u){const o=this.getCustomDocumentEntry(s,i);await this.getCustomEditorProvider(s).saveCustomDocument(o.document,u),o.disposeBackup()}async $onSaveAs(i,s,u,o){const f=this.getCustomDocumentEntry(s,i);return this.getCustomEditorProvider(s).saveCustomDocumentAs(f.document,I.URI.revive(u),o)}async $backup(i,s,u){const o=this.getCustomDocumentEntry(s,i),p=await this.getCustomEditorProvider(s).backupCustomDocument(o.document,{destination:o.getNewBackupUri()},u);return o.updateBackup(p),p.id}getCustomDocumentEntry(i,s){const u=this._documents.get(i,I.URI.revive(s));if(!u)throw new Error("No custom document found");return u}getCustomEditorProvider(i){const u=this._editorProviders.get(i)?.provider;if(!u||!this.supportEditing(u))throw new Error("Custom document is not editable");return u}supportEditing(i){return!!i.onDidChangeCustomDocument}}e.ExtHostCustomEditors=T;function b(S){return typeof S.resolveCustomTextEditor=="function"}function c(S){return typeof S.undo=="function"&&typeof S.redo=="function"}function g(S){const i=S.scheme===A.Schemas.file||S.scheme===A.Schemas.untitled?S.fsPath:S.toString();return(0,F.hash)(i)+""}});var et=this&&this.__classPrivateFieldSet||function(re,e,h,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(re,h):E?E.value=h:e.set(re,h),h},Oe=this&&this.__classPrivateFieldGet||function(re,e,h,F){if(h==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!F:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?F:h==="a"?F.call(re):F?F.value:e.get(re)};define(be[209],Ee([0,1,3,7,2,36,8,49,5,6]),function(re,e,h,F,E,A,R,I,y,k){"use strict";var t,_,r,d,a,l,v,T,b,c,g,S,i;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class s extends F.Disposable{constructor(p,w,C,P,n,m,D){super();t.set(this,void 0),_.set(this,void 0),r.set(this,void 0),d.set(this,void 0),a.set(this,void 0),l.set(this,void 0),v.set(this,void 0),T.set(this,void 0),b.set(this,!0),c.set(this,!0),g.set(this,!1),S.set(this,this._register(new h.Emitter)),this.onDidDispose=Oe(this,S,"f").event,i.set(this,this._register(new h.Emitter)),this.onDidChangeViewState=Oe(this,i,"f").event,et(this,t,p,"f"),et(this,_,w,"f"),et(this,r,C,"f"),et(this,a,m,"f"),et(this,T,n,"f"),et(this,l,P,"f"),et(this,d,D,"f")}dispose(){Oe(this,g,"f")||(et(this,g,!0,"f"),Oe(this,S,"f").fire(),Oe(this,_,"f").$disposeWebview(Oe(this,t,"f")),Oe(this,d,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,d,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,r,"f")}get title(){return this.assertNotDisposed(),Oe(this,l,"f")}set title(p){this.assertNotDisposed(),Oe(this,l,"f")!==p&&(et(this,l,p,"f"),Oe(this,_,"f").$setTitle(Oe(this,t,"f"),p))}get iconPath(){return this.assertNotDisposed(),Oe(this,v,"f")}set iconPath(p){this.assertNotDisposed(),Oe(this,v,"f")!==p&&(et(this,v,p,"f"),Oe(this,_,"f").$setIconPath(Oe(this,t,"f"),E.URI.isUri(p)?{light:p,dark:p}:p))}get options(){return Oe(this,a,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,T,"f")=="number"&&Oe(this,T,"f")<0))return Oe(this,T,"f")}get active(){return this.assertNotDisposed(),Oe(this,c,"f")}get visible(){return this.assertNotDisposed(),Oe(this,b,"f")}_updateViewState(p){Oe(this,g,"f")||(this.active!==p.active||this.visible!==p.visible||this.viewColumn!==p.viewColumn)&&(et(this,c,p.active,"f"),et(this,b,p.visible,"f"),et(this,T,p.viewColumn,"f"),Oe(this,i,"f").fire({webviewPanel:this}))}reveal(p,w){this.assertNotDisposed(),Oe(this,_,"f").$reveal(Oe(this,t,"f"),{viewColumn:p?R.ViewColumn.from(p):void 0,preserveFocus:!!w})}assertNotDisposed(){if(Oe(this,g,"f"))throw new Error("Webview is disposed")}}t=new WeakMap,_=new WeakMap,r=new WeakMap,d=new WeakMap,a=new WeakMap,l=new WeakMap,v=new WeakMap,T=new WeakMap,b=new WeakMap,c=new WeakMap,g=new WeakMap,S=new WeakMap,i=new WeakMap;class u{constructor(p,w,C){this.webviews=w,this.workspace=C,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=p.getProxy(y.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,A.generateUuid)()}createWebviewPanel(p,w,C,P,n={}){const m=typeof P=="object"?P.viewColumn:P,D={viewColumn:R.ViewColumn.from(m),preserveFocus:typeof P=="object"&&!!P.preserveFocus},O=(0,I.shouldSerializeBuffersForPostMessage)(p),$=u.newHandle();this._proxy.$createWebviewPanel((0,I.toExtensionData)(p),$,w,{title:C,panelOptions:o(n),webviewOptions:(0,I.serializeWebviewOptions)(p,this.workspace,n),serializeBuffersForPostMessage:O},D);const Q=this.webviews.createNewWebview($,n,p);return this.createNewWebviewPanel($,w,C,m,n,Q)}$onDidChangeWebviewPanelViewStates(p){const w=Object.keys(p);w.sort((C,P)=>{const n=p[C],m=p[P];return n.active?1:m.active?-1:+n.visible-+m.visible});for(const C of w){const P=this.getWebviewPanel(C);if(!P)continue;const n=p[C];P._updateViewState({active:n.active,visible:n.visible,viewColumn:R.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(p){this.getWebviewPanel(p)?.dispose(),this._webviewPanels.delete(p),this.webviews.deleteWebview(p)}registerWebviewPanelSerializer(p,w,C){if(this._serializers.has(w))throw new Error(`Serializer for '${w}' already registered`);return this._serializers.set(w,{serializer:C,extension:p}),this._proxy.$registerSerializer(w,{serializeBuffersForPostMessage:(0,I.shouldSerializeBuffersForPostMessage)(p)}),new k.Disposable(()=>{this._serializers.delete(w),this._proxy.$unregisterSerializer(w)})}async $deserializeWebviewPanel(p,w,C,P){const n=this._serializers.get(w);if(!n)throw new Error(`No serializer found for '${w}'`);const{serializer:m,extension:D}=n,O=this.webviews.createNewWebview(p,C.webviewOptions,D),$=this.createNewWebviewPanel(p,w,C.title,P,C.panelOptions,O);await m.deserializeWebviewPanel($,C.state)}createNewWebviewPanel(p,w,C,P,n,m){const D=new s(p,this._proxy,w,C,P,n,m);return this._webviewPanels.set(p,D),D}getWebviewPanel(p){return this._webviewPanels.get(p)}}e.ExtHostWebviewPanels=u;function o(f){return{enableFindWidget:f.enableFindWidget,retainContextWhenHidden:f.retainContextWhenHidden}}});var et=this&&this.__classPrivateFieldSet||function(re,e,h,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(re,h):E?E.value=h:e.set(re,h),h},Oe=this&&this.__classPrivateFieldGet||function(re,e,h,F){if(h==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!F:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?F:h==="a"?F.call(re):F?F.value:e.get(re)};define(be[210],Ee([0,1,3,7,49,5,6]),function(re,e,h,F,E,A,R){"use strict";var I,y,k,t,_,r,d,a,l,v;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class T extends F.Disposable{constructor(g,S,i,s,u,o){super();I.set(this,void 0),y.set(this,void 0),k.set(this,void 0),t.set(this,void 0),_.set(this,!1),r.set(this,void 0),d.set(this,void 0),a.set(this,void 0),l.set(this,this._register(new h.Emitter)),this.onDidChangeVisibility=Oe(this,l,"f").event,v.set(this,this._register(new h.Emitter)),this.onDidDispose=Oe(this,v,"f").event,et(this,k,i,"f"),et(this,d,s,"f"),et(this,I,g,"f"),et(this,y,S,"f"),et(this,t,u,"f"),et(this,r,o,"f")}dispose(){Oe(this,_,"f")||(et(this,_,!0,"f"),Oe(this,v,"f").fire(),Oe(this,t,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,d,"f")}set title(g){this.assertNotDisposed(),Oe(this,d,"f")!==g&&(et(this,d,g,"f"),Oe(this,y,"f").$setWebviewViewTitle(Oe(this,I,"f"),g))}get description(){return this.assertNotDisposed(),Oe(this,a,"f")}set description(g){this.assertNotDisposed(),Oe(this,a,"f")!==g&&(et(this,a,g,"f"),Oe(this,y,"f").$setWebviewViewDescription(Oe(this,I,"f"),g))}get visible(){return Oe(this,r,"f")}get webview(){return Oe(this,t,"f")}get viewType(){return Oe(this,k,"f")}_setVisible(g){g===Oe(this,r,"f")||Oe(this,_,"f")||(et(this,r,g,"f"),Oe(this,l,"f").fire())}show(g){this.assertNotDisposed(),Oe(this,y,"f").$show(Oe(this,I,"f"),!!g)}assertNotDisposed(){if(Oe(this,_,"f"))throw new Error("Webview is disposed")}}I=new WeakMap,y=new WeakMap,k=new WeakMap,t=new WeakMap,_=new WeakMap,r=new WeakMap,d=new WeakMap,a=new WeakMap,l=new WeakMap,v=new WeakMap;class b{constructor(g,S){this._extHostWebview=S,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=g.getProxy(A.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(g,S,i,s){if(this._viewProviders.has(S))throw new Error(`View provider for '${S}' already registered`);return this._viewProviders.set(S,{provider:i,extension:g}),this._proxy.$registerWebviewViewProvider((0,E.toExtensionData)(g),S,{retainContextWhenHidden:s?.retainContextWhenHidden,serializeBuffersForPostMessage:!1}),new R.Disposable(()=>{this._viewProviders.delete(S),this._proxy.$unregisterWebviewViewProvider(S)})}async $resolveWebviewView(g,S,i,s,u){const o=this._viewProviders.get(S);if(!o)throw new Error(`No view provider found for '${S}'`);const{provider:f,extension:p}=o,w=this._extHostWebview.createNewWebview(g,{},p),C=new T(g,this._proxy,S,i,w,!0);this._webviewViews.set(g,C),await f.resolveWebviewView(C,{state:s},u)}async $onDidChangeWebviewViewVisibility(g,S){this.getWebviewView(g)._setVisible(S)}async $disposeWebviewView(g){const S=this.getWebviewView(g);this._webviewViews.delete(g),S.dispose(),this._extHostWebview.deleteWebview(g)}getWebviewView(g){const S=this._webviewViews.get(g);if(!S)throw new Error("No webview found");return S}}e.ExtHostWebviewViews=b}),define(be[97],Ee([0,1,3,5,2,11,9,4,12]),function(re,e,h,F,E,A,R,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let k=class Ui{constructor(_){this._onDidChangeWindowState=new h.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Ui.InitialState,this._proxy=_.getProxy(F.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(r=>this.$onDidChangeWindowFocus(r))}get state(){return this._state}$onDidChangeWindowFocus(_){_!==this._state.focused&&(this._state={...this._state,focused:_},this._onDidChangeWindowState.fire(this._state))}openUri(_,r){let d;if(typeof _=="string"){d=_;try{_=E.URI.parse(_)}catch(a){return Promise.reject(`Invalid uri - '${_}'`)}}return(0,R.isFalsyOrWhitespace)(_.scheme)?Promise.reject("Invalid scheme - cannot be empty"):_.scheme===A.Schemas.command?Promise.reject(`Invalid scheme '${_.scheme}'`):this._proxy.$openUri(_,d,r)}async asExternalUri(_,r){if((0,R.isFalsyOrWhitespace)(_.scheme))return Promise.reject("Invalid scheme - cannot be empty");const d=await this._proxy.$asExternalUri(_,r);return E.URI.from(d)}};k.InitialState={focused:!0},k=Be([We(0,y.IExtHostRpcService)],k),e.ExtHostWindow=k,e.IExtHostWindow=(0,I.createDecorator)("IExtHostWindow")}),define(be[211],Ee([0,1,14,5,29,12]),function(re,e,h,F,E,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let R=class extends h.AbstractLogger{constructor(y,k){super();this._proxy=y.getProxy(F.MainContext.MainThreadLog),this._logFile=k.logFile.toJSON(),this.setLevel(k.logLevel)}$setLevel(y){this.setLevel(y)}trace(y,...k){this.getLevel()<=h.LogLevel.Trace&&this._proxy.$log(this._logFile,h.LogLevel.Trace,Array.from(arguments))}debug(y,...k){this.getLevel()<=h.LogLevel.Debug&&this._proxy.$log(this._logFile,h.LogLevel.Debug,Array.from(arguments))}info(y,...k){this.getLevel()<=h.LogLevel.Info&&this._proxy.$log(this._logFile,h.LogLevel.Info,Array.from(arguments))}warn(y,...k){this.getLevel()<=h.LogLevel.Warning&&this._proxy.$log(this._logFile,h.LogLevel.Warning,Array.from(arguments))}error(y,...k){this.getLevel()<=h.LogLevel.Error&&this._proxy.$log(this._logFile,h.LogLevel.Error,Array.from(arguments))}critical(y,...k){this.getLevel()<=h.LogLevel.Critical&&this._proxy.$log(this._logFile,h.LogLevel.Critical,Array.from(arguments))}flush(){}};R=Be([We(0,A.IExtHostRpcService),We(1,E.IExtHostInitDataService)],R),e.ExtHostLogService=R}),define(be[212],Ee([0,1,13,23,21,15,3,7,108,178,46]),function(re,e,h,F,E,A,R,I,y,k,t){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function r(n,m){try{return JSON.stringify(n,m)}catch(D){return"null"}}const d="$$ref$$",a={[d]:-1};class l{constructor(m,D){this.jsonString=m,this.referencedBuffers=D}}function v(n,m=null,D=!1){const O=[];return{jsonString:(D?r:JSON.stringify)(n,(Q,ie)=>{if(typeof ie=="undefined")return a;if(typeof ie=="object"){if(ie instanceof F.VSBuffer){const V=O.push(ie)-1;return{[d]:V}}if(m)return m(Q,ie)}return ie}),referencedBuffers:O}}e.stringifyJsonWithBufferRefs=v;function T(n,m,D){return JSON.parse(n,(O,$)=>{if($){const Q=$[d];if(typeof Q=="number")return m[Q];if(D&&$.$mid===1)return D.transformIncoming($)}return $})}e.parseJsonAndRestoreBufferRefs=T;function b(n,m){return JSON.stringify(n,m)}function c(n){return n?(m,D)=>D&&D.$mid===1?n.transformOutgoing(D):D:null}var g;(function(n){n[n.LocalSide=0]="LocalSide",n[n.OtherSide=1]="OtherSide"})(g=e.RequestInitiator||(e.RequestInitiator={}));var S;(function(n){n[n.Responsive=0]="Responsive",n[n.Unresponsive=1]="Unresponsive"})(S=e.ResponsiveState||(e.ResponsiveState={}));const i=()=>{},s=Symbol.for("rpcProtocol"),u=Symbol.for("rpcProxy");class o extends I.Disposable{constructor(m,D=null,O=null){super();this[_]=!0,this._onDidChangeResponsiveState=this._register(new R.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=m,this._logger=D,this._uriTransformer=O,this._uriReplacer=c(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let $=0,Q=t.ProxyIdentifier.count;$<Q;$++)this._locals[$]=null,this._proxies[$]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new h.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage($=>this._receiveOneMessage($))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(m=>{this._pendingRPCReplies[m].resolveErr(A.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(m){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(m){this._unresponsiveTime=Date.now()+o.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(m){this._responsiveState!==m&&(this._responsiveState=m,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(m){return this._uriTransformer?(0,y.transformIncomingURIs)(m,this._uriTransformer):m}getProxy(m){const{nid:D,sid:O}=m;return this._proxies[D]||(this._proxies[D]=this._createProxy(D,O)),this._proxies[D]}_createProxy(m,D){let O={get:($,Q)=>(typeof Q=="string"&&!$[Q]&&Q.charCodeAt(0)===36&&($[Q]=(...ie)=>this._remoteCall(m,Q,ie)),Q===u?D:$[Q])};return new Proxy(Object.create(null),O)}set(m,D){return this._locals[m.nid]=D,D}assertRegistered(m){for(let D=0,O=m.length;D<O;D++){const $=m[D];if(!this._locals[$.nid])throw new Error(`Missing actor ${$.sid} (isMain: ${$.isMain})`)}}_receiveOneMessage(m){if(this._isDisposed)return;const D=m.byteLength,O=f.read(m,0),$=O.readUInt8(),Q=O.readUInt32();switch($){case 1:case 2:{let{rpcId:ie,method:V,args:W}=w.deserializeRequestJSONArgs(O);this._uriTransformer&&(W=(0,y.transformIncomingURIs)(W,this._uriTransformer)),this._receiveRequest(D,Q,ie,V,W,$===2);break}case 3:case 4:{let{rpcId:ie,method:V,args:W}=w.deserializeRequestMixedArgs(O);this._uriTransformer&&(W=(0,y.transformIncomingURIs)(W,this._uriTransformer)),this._receiveRequest(D,Q,ie,V,W,$===4);break}case 5:{this._logger&&this._logger.logIncoming(D,Q,0,"ack"),this._onDidReceiveAcknowledge(Q);break}case 6:{this._receiveCancel(D,Q);break}case 7:{this._receiveReply(D,Q,void 0);break}case 9:{let ie=w.deserializeReplyOKJSON(O);this._uriTransformer&&(ie=(0,y.transformIncomingURIs)(ie,this._uriTransformer)),this._receiveReply(D,Q,ie);break}case 10:{const ie=w.deserializeReplyOKJSONWithBuffers(O,this._uriTransformer);this._receiveReply(D,Q,ie);break}case 8:{let ie=w.deserializeReplyOKVSBuffer(O);this._receiveReply(D,Q,ie);break}case 11:{let ie=w.deserializeReplyErrError(O);this._uriTransformer&&(ie=(0,y.transformIncomingURIs)(ie,this._uriTransformer)),this._receiveReplyErr(D,Q,ie);break}case 12:{this._receiveReplyErr(D,Q,void 0);break}default:console.error("received unexpected message"),console.error(m)}}_receiveRequest(m,D,O,$,Q,ie){this._logger&&this._logger.logIncoming(m,D,1,`receiveRequest ${(0,t.getStringIdentifierForProxy)(O)}.${$}(`,Q);const V=String(D);let W,L;if(ie){const B=new E.CancellationTokenSource;Q.push(B.token),W=this._invokeHandler(O,$,Q),L=()=>B.cancel()}else W=this._invokeHandler(O,$,Q),L=i;this._cancelInvokedHandlers[V]=L;const Y=w.serializeAcknowledged(D);this._logger&&this._logger.logOutgoing(Y.byteLength,D,1,"ack"),this._protocol.send(Y),W.then(B=>{delete this._cancelInvokedHandlers[V];const G=w.serializeReplyOK(D,B,this._uriReplacer);this._logger&&this._logger.logOutgoing(G.byteLength,D,1,"reply:",B),this._protocol.send(G)},B=>{delete this._cancelInvokedHandlers[V];const G=w.serializeReplyErr(D,B);this._logger&&this._logger.logOutgoing(G.byteLength,D,1,"replyErr:",B),this._protocol.send(G)})}_receiveCancel(m,D){this._logger&&this._logger.logIncoming(m,D,1,"receiveCancel");const O=String(D);this._cancelInvokedHandlers[O]&&this._cancelInvokedHandlers[O]()}_receiveReply(m,D,O){this._logger&&this._logger.logIncoming(m,D,0,"receiveReply:",O);const $=String(D);if(!this._pendingRPCReplies.hasOwnProperty($))return;const Q=this._pendingRPCReplies[$];delete this._pendingRPCReplies[$],Q.resolveOk(O)}_receiveReplyErr(m,D,O){this._logger&&this._logger.logIncoming(m,D,0,"receiveReplyErr:",O);const $=String(D);if(!this._pendingRPCReplies.hasOwnProperty($))return;const Q=this._pendingRPCReplies[$];delete this._pendingRPCReplies[$];let ie;O&&(O.$isError?(ie=new Error,ie.name=O.name,ie.message=O.message,ie.stack=O.stack):ie=O),Q.resolveErr(ie)}_invokeHandler(m,D,O){try{return Promise.resolve(this._doInvokeHandler(m,D,O))}catch($){return Promise.reject($)}}_doInvokeHandler(m,D,O){const $=this._locals[m];if(!$)throw new Error("Unknown actor "+(0,t.getStringIdentifierForProxy)(m));let Q=$[D];if(typeof Q!="function")throw new Error("Unknown method "+D+" on actor "+(0,t.getStringIdentifierForProxy)(m));return Q.apply($,O)}_remoteCall(m,D,O){if(this._isDisposed)return Promise.reject(A.canceled());let $=null;if(O.length>0&&E.CancellationToken.isCancellationToken(O[O.length-1])&&($=O.pop()),$&&$.isCancellationRequested)return Promise.reject(A.canceled());const Q=w.serializeRequestArguments(O,this._uriReplacer),ie=++this._lastMessageId,V=String(ie),W=new k.LazyPromise;$&&$.onCancellationRequested(()=>{const Y=w.serializeCancel(ie);this._logger&&this._logger.logOutgoing(Y.byteLength,ie,0,"cancel"),this._protocol.send(w.serializeCancel(ie))}),this._pendingRPCReplies[V]=W,this._onWillSendRequest(ie);const L=w.serializeRequest(ie,m,D,Q,!!$);return this._logger&&this._logger.logOutgoing(L.byteLength,ie,0,`request: ${(0,t.getStringIdentifierForProxy)(m)}.${D}(`,O),this._protocol.send(L),W}}e.RPCProtocol=o,_=s,o.UNRESPONSIVE_TIME=3*1e3;class f{constructor(m,D){this._buff=m,this._offset=D}static alloc(m,D,O){let $=new f(F.VSBuffer.alloc(O+1+4),0);return $.writeUInt8(m),$.writeUInt32(D),$}static read(m,D){return new f(m,D)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(m){this._buff.writeUInt8(m,this._offset),this._offset+=1}readUInt8(){const m=this._buff.readUInt8(this._offset);return this._offset+=1,m}writeUInt32(m){this._buff.writeUInt32BE(m,this._offset),this._offset+=4}readUInt32(){const m=this._buff.readUInt32BE(this._offset);return this._offset+=4,m}static sizeShortString(m){return 1+m.byteLength}writeShortString(m){this._buff.writeUInt8(m.byteLength,this._offset),this._offset+=1,this._buff.set(m,this._offset),this._offset+=m.byteLength}readShortString(){const m=this._buff.readUInt8(this._offset);this._offset+=1;const O=this._buff.slice(this._offset,this._offset+m).toString();return this._offset+=m,O}static sizeLongString(m){return 4+m.byteLength}writeLongString(m){this._buff.writeUInt32BE(m.byteLength,this._offset),this._offset+=4,this._buff.set(m,this._offset),this._offset+=m.byteLength}readLongString(){const m=this._buff.readUInt32BE(this._offset);this._offset+=4;const O=this._buff.slice(this._offset,this._offset+m).toString();return this._offset+=m,O}writeBuffer(m){this._buff.writeUInt32BE(m.byteLength,this._offset),this._offset+=4,this._buff.set(m,this._offset),this._offset+=m.byteLength}static sizeVSBuffer(m){return 4+m.byteLength}writeVSBuffer(m){this._buff.writeUInt32BE(m.byteLength,this._offset),this._offset+=4,this._buff.set(m,this._offset),this._offset+=m.byteLength}readVSBuffer(){const m=this._buff.readUInt32BE(this._offset);this._offset+=4;const D=this._buff.slice(this._offset,this._offset+m);return this._offset+=m,D}static sizeMixedArray(m){let D=0;D+=1;for(let O=0,$=m.length;O<$;O++){const Q=m[O];switch(D+=1,Q.type){case 1:D+=this.sizeLongString(Q.value);break;case 2:D+=this.sizeVSBuffer(Q.value);break;case 3:D+=this.sizeUInt8(),D+=this.sizeLongString(Q.value);for(let ie=0;ie<Q.buffers.length;++ie)D+=this.sizeVSBuffer(Q.buffers[ie]);break;case 4:break}}return D}writeMixedArray(m){this._buff.writeUInt8(m.length,this._offset),this._offset+=1;for(let D=0,O=m.length;D<O;D++){const $=m[D];switch($.type){case 1:this.writeUInt8(1),this.writeLongString($.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer($.value);break;case 3:this.writeUInt8(3),this.writeUInt8($.buffers.length),this.writeLongString($.value);for(let Q=0;Q<$.buffers.length;++Q)this.writeBuffer($.buffers[Q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const m=this._buff.readUInt8(this._offset);this._offset+=1;let D=new Array(m);for(let O=0;O<m;O++)switch(this.readUInt8()){case 1:D[O]=this.readLongString();break;case 2:D[O]=this.readVSBuffer();break;case 3:const Q=this.readUInt8(),ie=this.readLongString(),V=[];for(let W=0;W<Q;++W)V.push(this.readVSBuffer());D[O]=new t.SerializableObjectWithBuffers(T(ie,V,null));break;case 4:D[O]=void 0;break}return D}}var p;(function(n){n[n.Simple=0]="Simple",n[n.Mixed=1]="Mixed"})(p||(p={}));class w{static _useMixedArgSerialization(m){for(let D=0,O=m.length;D<O;D++)if(m[D]instanceof F.VSBuffer||m[D]instanceof t.SerializableObjectWithBuffers||typeof m[D]=="undefined")return!0;return!1}static serializeRequestArguments(m,D){if(this._useMixedArgSerialization(m)){const O=[];for(let $=0,Q=m.length;$<Q;$++){const ie=m[$];if(ie instanceof F.VSBuffer)O[$]={type:2,value:ie};else if(typeof ie=="undefined")O[$]={type:4};else if(ie instanceof t.SerializableObjectWithBuffers){const{jsonString:V,referencedBuffers:W}=v(ie.value,D);O[$]={type:3,value:F.VSBuffer.fromString(V),buffers:W}}else O[$]={type:1,value:F.VSBuffer.fromString(b(ie,D))}}return{type:1,args:O}}return{type:0,args:b(m,D)}}static serializeRequest(m,D,O,$,Q){switch($.type){case 0:return this._requestJSONArgs(m,D,O,$.args,Q);case 1:return this._requestMixedArgs(m,D,O,$.args,Q)}}static _requestJSONArgs(m,D,O,$,Q){const ie=F.VSBuffer.fromString(O),V=F.VSBuffer.fromString($);let W=0;W+=f.sizeUInt8(),W+=f.sizeShortString(ie),W+=f.sizeLongString(V);let L=f.alloc(Q?2:1,m,W);return L.writeUInt8(D),L.writeShortString(ie),L.writeLongString(V),L.buffer}static deserializeRequestJSONArgs(m){const D=m.readUInt8(),O=m.readShortString(),$=m.readLongString();return{rpcId:D,method:O,args:JSON.parse($)}}static _requestMixedArgs(m,D,O,$,Q){const ie=F.VSBuffer.fromString(O);let V=0;V+=f.sizeUInt8(),V+=f.sizeShortString(ie),V+=f.sizeMixedArray($);let W=f.alloc(Q?4:3,m,V);return W.writeUInt8(D),W.writeShortString(ie),W.writeMixedArray($),W.buffer}static deserializeRequestMixedArgs(m){const D=m.readUInt8(),O=m.readShortString(),$=m.readMixedArray(),Q=new Array($.length);for(let ie=0,V=$.length;ie<V;ie++){const W=$[ie];typeof W=="string"?Q[ie]=JSON.parse(W):Q[ie]=W}return{rpcId:D,method:O,args:Q}}static serializeAcknowledged(m){return f.alloc(5,m,0).buffer}static serializeCancel(m){return f.alloc(6,m,0).buffer}static serializeReplyOK(m,D,O){if(typeof D=="undefined")return this._serializeReplyOKEmpty(m);if(D instanceof F.VSBuffer)return this._serializeReplyOKVSBuffer(m,D);if(D instanceof t.SerializableObjectWithBuffers){const{jsonString:$,referencedBuffers:Q}=v(D.value,O,!0);return this._serializeReplyOKJSONWithBuffers(m,$,Q)}else return this._serializeReplyOKJSON(m,r(D,O))}static _serializeReplyOKEmpty(m){return f.alloc(7,m,0).buffer}static _serializeReplyOKVSBuffer(m,D){let O=0;O+=f.sizeVSBuffer(D);let $=f.alloc(8,m,O);return $.writeVSBuffer(D),$.buffer}static deserializeReplyOKVSBuffer(m){return m.readVSBuffer()}static _serializeReplyOKJSON(m,D){const O=F.VSBuffer.fromString(D);let $=0;$+=f.sizeLongString(O);let Q=f.alloc(9,m,$);return Q.writeLongString(O),Q.buffer}static _serializeReplyOKJSONWithBuffers(m,D,O){const $=F.VSBuffer.fromString(D);let Q=0;Q+=f.sizeUInt8(),Q+=f.sizeLongString($);for(const V of O)Q+=f.sizeVSBuffer(V);let ie=f.alloc(10,m,Q);ie.writeUInt8(O.length),ie.writeLongString($);for(const V of O)ie.writeBuffer(V);return ie.buffer}static deserializeReplyOKJSON(m){const D=m.readLongString();return JSON.parse(D)}static deserializeReplyOKJSONWithBuffers(m,D){const O=m.readUInt8(),$=m.readLongString(),Q=[];for(let ie=0;ie<O;++ie)Q.push(m.readVSBuffer());return new t.SerializableObjectWithBuffers(T($,Q,D))}static serializeReplyErr(m,D){return D?this._serializeReplyErrEror(m,D):this._serializeReplyErrEmpty(m)}static _serializeReplyErrEror(m,D){const O=F.VSBuffer.fromString(r(A.transformErrorForSerialization(D),null));let $=0;$+=f.sizeLongString(O);let Q=f.alloc(11,m,$);return Q.writeLongString(O),Q.buffer}static deserializeReplyErrError(m){const D=m.readLongString();return JSON.parse(D)}static _serializeReplyErrEmpty(m){return f.alloc(12,m,0).buffer}}var C;(function(n){n[n.RequestJSONArgs=1]="RequestJSONArgs",n[n.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",n[n.RequestMixedArgs=3]="RequestMixedArgs",n[n.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",n[n.Acknowledged=5]="Acknowledged",n[n.Cancel=6]="Cancel",n[n.ReplyOKEmpty=7]="ReplyOKEmpty",n[n.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",n[n.ReplyOKJSON=9]="ReplyOKJSON",n[n.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",n[n.ReplyErrError=11]="ReplyErrError",n[n.ReplyErrEmpty=12]="ReplyErrEmpty"})(C||(C={}));var P;(function(n){n[n.String=1]="String",n[n.VSBuffer=2]="VSBuffer",n[n.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",n[n.Undefined=4]="Undefined"})(P||(P={}))}),define(be[213],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const h=function(A){const R=I=>{self.removeEventListener("message",R);const y=I.data;Object.defineProperties(self,{postMessage:{value(k,t){y.postMessage(k,t)}},onmessage:{get(){return y.onmessage},set(k){y.onmessage=k}}}),y.addEventListener("message",k=>{self.dispatchEvent(new MessageEvent("message",{data:k.data}))}),y.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(A)};self.addEventListener("message",R)}.toString();class F extends EventTarget{constructor(A,R,I){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const y=`((${h})('${R}'))`,k=new Blob([y],{type:"application/javascript"}),t=URL.createObjectURL(k),_=new MessageChannel,r=t,d={type:"_newWorker",id:r,port:_.port2,url:t,options:I};A(d,[_.port2]),this.postMessage=_.port1.postMessage.bind(_.port1),this.terminate=()=>{const a={type:"_terminateWorker",id:r};_.port1.postMessage(a),URL.revokeObjectURL(t),_.port1.close(),_.port2.close()},Object.defineProperties(this,{onmessage:{get(){return _.port1.onmessage},set(a){_.port1.onmessage=a}},onmessageerror:{get(){return _.port1.onmessageerror},set(a){_.port1.onmessageerror=a}}}),_.port1.addEventListener("messageerror",a=>{const l=new MessageEvent("messageerror",{data:a.data});this.dispatchEvent(l)}),_.port1.addEventListener("message",a=>{const l=new MessageEvent("message",{data:a.data});this.dispatchEvent(l)}),_.port1.start()}}e.NestedWorker=F}),define(be[214],Ee([0,1,4]),function(re,e,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,h.createDecorator)("remoteAgentService")}),define(be[215],Ee([0,1,11,17,26,2,4,86,44,174,214]),function(re,e,h,F,E,A,R,I,y,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,R.createDecorator)("pathService");let _=class Bi{constructor(d,a,l,v){this.localUserHome=d,this.remoteAgentService=a,this.environmentService=l,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||E.OS)(),this.resolveUserHome=(async()=>{const T=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=T?.userHome||d})()}get defaultUriScheme(){return Bi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(d,a){if(d.remoteAuthority)return h.Schemas.vscodeRemote;const l=(0,I.getVirtualWorkspaceScheme)(a.getWorkspace());if(l)return l;const v=a.getWorkspace().folders[0];if(v)return v.uri.scheme;const T=a.getWorkspace().configuration;return T?T.scheme:h.Schemas.file}async userHome(d){return d?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(d=>d===1?F.win32:F.posix)}async fileURI(d){let a="";if(await this.resolveOS===1&&(d=d.replace(/\\/g,"/")),d[0]==="/"&&d[1]==="/"){const v=d.indexOf("/",2);v===-1?(a=d.substring(2),d="/"):(a=d.substring(2,v),d=d.substring(v)||"/")}return A.URI.from({scheme:h.Schemas.file,authority:a,path:d,query:"",fragment:""})}};_=Be([We(1,t.IRemoteAgentService),We(2,k.IWorkbenchEnvironmentService),We(3,y.IWorkspaceContextService)],_),e.AbstractPathService=_}),define(be[98],Ee([0,1]),function(re,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class h{constructor(R,I){this.line=R,this.character=I}isBefore(R){return!1}isBeforeOrEqual(R){return!1}isAfter(R){return!1}isAfterOrEqual(R){return!1}isEqual(R){return!1}compareTo(R){return 0}translate(R,I){return new h(0,0)}with(R){return new h(0,0)}}e.Position=h;class F{constructor(R,I,y,k){this.isEmpty=!1,this.isSingleLine=!1,this.start=new h(R,I),this.end=new h(y,k)}contains(R){return!1}isEqual(R){return!1}intersection(R){}union(R){return new F(0,0,0,0)}with(R){return new F(0,0,0,0)}}e.Range=F;var E;(function(A){A[A.Information=1]="Information",A[A.Warning=2]="Warning"})(E=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(be[38],Ee([0,1,16,27,22,40,9,4,17,15,98]),function(re,e,h,F,E,A,R,I,y,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return t.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const _="\u27EA ",r=" characters skipped \u27EB",d=(_.length+r.length+5)*2;e.ISearchService=(0,I.createDecorator)("searchService");var a;(function(L){L[L.file=0]="file",L[L.text=1]="text"})(a=e.SearchProviderType||(e.SearchProviderType={}));var l;(function(L){L[L.File=1]="File",L[L.Text=2]="Text"})(l=e.QueryType||(e.QueryType={}));function v(L){return!!L.preview}e.resultIsMatch=v;function T(L){return!!L.resource}e.isFileMatch=T;function b(L){return!!L.message}e.isProgressMessage=b;var c;(function(L){L[L.Normal=0]="Normal",L[L.NewSearchStarted=1]="NewSearchStarted"})(c=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class g{constructor(Y){this.resource=Y,this.results=[]}}e.FileMatch=g;class S{constructor(Y,B,G){this.ranges=B;const de=Array.isArray(B)?B:[B];if(G&&G.matchLines===1&&i(de)){Y=(0,R.getNLines)(Y,G.matchLines);let j="",le=0,ae=0;const ve=Math.floor(G.charsPerLine/5),Re=[];for(const Fe of de){const Ne=Math.max(Fe.startColumn-ve,0),Qe=Fe.startColumn+G.charsPerLine;if(Ne>ae+ve+d){const He=_+(Ne-ae)+r;j+=He+Y.slice(Ne,Qe),le+=Ne-(ae+He.length)}else j+=Y.slice(ae,Qe);Re.push(new u(0,Fe.startColumn-le,Fe.endColumn-le)),ae=Qe}this.preview={text:j,matches:Array.isArray(this.ranges)?Re:Re[0]}}else{const j=Array.isArray(B)?B[0].startLineNumber:B.startLineNumber;this.preview={text:Y,matches:(0,h.mapArrayOrNot)(B,le=>new s(le.startLineNumber-j,le.startColumn,le.endLineNumber-j,le.endColumn))}}}}e.TextSearchMatch=S;function i(L){const Y=L[0].startLineNumber;for(const B of L)if(B.startLineNumber!==Y||B.endLineNumber!==Y)return!1;return!0}class s{constructor(Y,B,G,de){this.startLineNumber=Y,this.startColumn=B,this.endLineNumber=G,this.endColumn=de}}e.SearchRange=s;class u extends s{constructor(Y,B,G){super(Y,B,Y,G)}}e.OneLineRange=u;var o;(function(L){L.Default="default",L.FileNames="fileNames",L.Type="type",L.Modified="modified",L.CountDescending="countDescending",L.CountAscending="countAscending"})(o=e.SearchSortOrder||(e.SearchSortOrder={}));function f(L,Y=!0){const B=L&&L.files&&L.files.exclude,G=Y&&L&&L.search&&L.search.exclude;if(!B&&!G)return;if(!B||!G)return B||G;let de=Object.create(null);return de=E.mixin(de,E.deepClone(B)),de=E.mixin(de,E.deepClone(G),!0),de}e.getExcludes=f;function p(L,Y){return L.excludePattern&&F.match(L.excludePattern,Y)?!1:L.includePattern||L.usingSearchPaths?L.includePattern&&F.match(L.includePattern,Y)?!0:L.usingSearchPaths?!!L.folderQueries&&L.folderQueries.some(B=>{const G=B.folder.fsPath;if(A.isEqualOrParent(Y,G)){const de=y.relative(G,Y);return!B.includePattern||!!F.match(B.includePattern,de)}else return!1}):!1:!0}e.pathIncludedInQuery=p;var w;(function(L){L[L.unknownEncoding=1]="unknownEncoding",L[L.regexParseError=2]="regexParseError",L[L.globParseError=3]="globParseError",L[L.invalidLiteral=4]="invalidLiteral",L[L.rgProcessError=5]="rgProcessError",L[L.other=6]="other",L[L.canceled=7]="canceled"})(w=e.SearchErrorCode||(e.SearchErrorCode={}));class C extends Error{constructor(Y,B){super(Y);this.code=B}}e.SearchError=C;function P(L){const Y=L.message;if((0,k.isPromiseCanceledError)(L))return new C(Y,w.canceled);try{const B=JSON.parse(Y);return new C(B.message,B.code)}catch(B){return new C(Y,w.other)}}e.deserializeSearchError=P;function n(L){const Y={message:L.message,code:L.code};return new Error(JSON.stringify(Y))}e.serializeSearchError=n;function m(L){return L.type==="error"?!0:L.type==="success"}e.isSerializedSearchComplete=m;function D(L){return L.type==="success"}e.isSerializedSearchSuccess=D;function O(L){return!!L.path}e.isSerializedFileMatch=O;function $(L,Y){const B=L.searchPath?L.searchPath:L.relativePath;return(0,R.fuzzyContains)(B,Y)}e.isFilePatternMatch=$;class Q{constructor(Y){this.path=Y,this.results=[]}addMatch(Y){this.results.push(Y)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=Q;function ie(L,Y){const B={...L||{},...Y||{}};return Object.keys(B).filter(G=>{const de=B[G];return typeof de=="boolean"&&de})}e.resolvePatternsForProvider=ie;class V{constructor(Y,B){this._parsedIncludeExpression=null,this._excludeExpression={...Y.excludePattern||{},...B.excludePattern||{}},this._parsedExcludeExpression=F.parse(this._excludeExpression);let G=Y.includePattern;B.includePattern&&(G?G={...G,...B.includePattern}:G=B.includePattern),G&&(this._parsedIncludeExpression=F.parse(G))}includedInQuerySync(Y,B,G){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(Y,B,G)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(Y,B,G))}includedInQuery(Y,B,G){return Promise.resolve(this._parsedExcludeExpression(Y,B,G)).then(j=>!!j).then(j=>j?!1:this._parsedIncludeExpression?Promise.resolve(this._parsedIncludeExpression(Y,B,G)).then(le=>!!le):Promise.resolve(!0)).then(j=>j)}hasSiblingExcludeClauses(){return W(this._excludeExpression)}}e.QueryGlobTester=V;function W(L){for(const Y in L)if(typeof L[Y]!="boolean")return!0;return!1}}),define(be[31],Ee([0,1,16,13,21,3,20,11,75,24,9,10,2,129,4,14,144,44,45,29,12,6,38,5]),function(re,e,h,F,E,A,R,I,y,k,t,_,r,d,a,l,v,T,b,c,g,S,i,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function u(m,D,O){return new k.ExtUri($=>w($,O)).isEqual(m,D)}function o(m,D,O){return u(m.uri,D.uri,O)?0:(0,t.compare)(m.uri.toString(),D.uri.toString())}function f(m,D,O){return m.index!==D.index?m.index<D.index?-1:1:u(m.uri,D.uri,O)?(0,t.compare)(m.name,D.name):(0,t.compare)(m.uri.toString(),D.uri.toString())}function p(m,D,O,$){const Q=m.slice(0).sort((V,W)=>O(V,W,$)),ie=D.slice(0).sort((V,W)=>O(V,W,$));return(0,h.delta)(Q,ie,(V,W)=>O(V,W,$))}function w(m,D){const O=D.getCapabilities(m.scheme);return!(O&&O&1024)}class C extends T.Workspace{constructor(D,O,$,Q,ie,V){super(D,$.map(W=>new T.WorkspaceFolder(W)),Q,V);this._name=O,this._isUntitled=ie,this._workspaceFolders=[],this._structure=R.TernarySearchTree.forUris(V),$.forEach(W=>{this._workspaceFolders.push(W),this._structure.set(W.uri,W)})}static toExtHostWorkspace(D,O,$,Q){if(!D)return{workspace:null,added:[],removed:[]};const{id:ie,name:V,folders:W,configuration:L,isUntitled:Y}=D,B=[],G=O;O?W.forEach((ae,ve)=>{const Re=r.URI.revive(ae.uri),Fe=C._findFolder($||O,Re,Q);Fe?(Fe.name=ae.name,Fe.index=ae.index,B.push(Fe)):B.push({uri:Re,name:ae.name,index:ve})}):B.push(...W.map(({uri:ae,name:ve,index:Re})=>({uri:r.URI.revive(ae),name:ve,index:Re}))),B.sort((ae,ve)=>ae.index<ve.index?-1:1);const de=new C(ie,V,B,L?r.URI.revive(L):null,!!Y,ae=>w(ae,Q)),{added:j,removed:le}=p(G?G.workspaceFolders:[],de.workspaceFolders,o,Q);return{workspace:de,added:j,removed:le}}static _findFolder(D,O,$){for(let Q=0;Q<D.folders.length;Q++){const ie=D.workspaceFolders[Q];if(u(ie.uri,O,$))return ie}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(D,O){return O&&this._structure.get(D)&&(D=(0,k.dirname)(D)),this._structure.findSubstr(D)}resolveWorkspaceFolder(D){return this._structure.get(D)}}let P=class{constructor(D,O,$,Q){this._onDidChangeWorkspace=new A.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new A.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=Q,this._extHostFileSystemInfo=$,this._requestIdProvider=new y.Counter,this._barrier=new F.Barrier,this._proxy=D.getProxy(s.MainContext.MainThreadWorkspace),this._messageService=D.getProxy(s.MainContext.MainThreadMessageService);const ie=O.workspace;this._confirmedWorkspace=ie?new C(ie.id,ie.name,[],ie.configuration?r.URI.revive(ie.configuration):null,!!ie.isUntitled,V=>w(V,$)):void 0}$initializeWorkspace(D,O){this._trusted=O,this.$acceptWorkspaceData(D),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?r.URI.from({scheme:I.Schemas.untitled,path:(0,k.basename)((0,k.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(D,O,$,...Q){const ie=[];if(Array.isArray(Q)&&Q.forEach(B=>{r.URI.isUri(B.uri)&&!ie.some(G=>u(G.uri,B.uri,this._extHostFileSystemInfo))&&ie.push({uri:B.uri,name:B.name||(0,k.basenameOrAuthority)(B.uri)})}),this._unconfirmedWorkspace||[O,$].some(B=>typeof B!="number"||B<0)||$===0&&ie.length===0)return!1;const V=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(O+$>V.length)return!1;const W=V.slice(0);W.splice(O,$,...ie.map(B=>({uri:B.uri,name:B.name||(0,k.basenameOrAuthority)(B.uri),index:void 0})));for(let B=0;B<W.length;B++){const G=W[B];if(W.some((de,j)=>j!==B&&u(G.uri,de.uri,this._extHostFileSystemInfo)))return!1}W.forEach((B,G)=>B.index=G);const{added:L,removed:Y}=p(V,W,f,this._extHostFileSystemInfo);if(L.length===0&&Y.length===0)return!1;if(this._proxy){const B=D.displayName||D.name;this._proxy.$updateWorkspaceFolders(B,O,$,ie).then(void 0,G=>{this._unconfirmedWorkspace=void 0,this._messageService.$showMessage(v.Severity.Error,(0,d.localize)(0,null,B,G.toString()),{extension:D},[])})}return this.trySetWorkspaceFolders(W),!0}getWorkspaceFolder(D,O){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(D,O)}async getWorkspaceFolder2(D,O){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(D,O)}async resolveWorkspaceFolder(D){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(D)}getPath(){if(!this._actualWorkspace)return;const{folders:D}=this._actualWorkspace;if(D.length!==0)return D[0].uri.fsPath}getRelativePath(D,O){let $,Q="";if(typeof D=="string"?($=r.URI.file(D),Q=D):typeof D!="undefined"&&($=D,Q=D.fsPath),!$)return Q;const ie=this.getWorkspaceFolder($,!0);if(!ie)return Q;typeof O=="undefined"&&this._actualWorkspace&&(O=this._actualWorkspace.folders.length>1);let V=(0,k.relativePath)(ie.uri,$);return O&&ie.name&&(V=`${ie.name}/${V}`),V}trySetWorkspaceFolders(D){this._actualWorkspace&&(this._unconfirmedWorkspace=C.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:D,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(D){const{workspace:O,added:$,removed:Q}=C.toExtHostWorkspace(D,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=O||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:$,removed:Q}))}findFiles(D,O,$,Q,ie=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${Q.value}, entryPoint: findFiles`);let V;if(O===null?V=!1:O&&(typeof O=="string"?V=O:V=O.pattern),ie&&ie.isCancellationRequested)return Promise.resolve([]);const{includePattern:W,folder:L}=n(D);return this._proxy.$startFileSearch((0,_.withUndefinedAsNull)(W),(0,_.withUndefinedAsNull)(L),(0,_.withUndefinedAsNull)(V),(0,_.withUndefinedAsNull)($),ie).then(Y=>Array.isArray(Y)?Y.map(B=>r.URI.revive(B)):[])}async findTextInFiles(D,O,$,Q,ie=E.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${Q.value}, entryPoint: findTextInFiles`);const V=this._requestIdProvider.getNext(),W=typeof O.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:O.previewOptions,{includePattern:L,folder:Y}=n(O.include),B=typeof O.exclude=="string"?O.exclude:O.exclude?O.exclude.pattern:void 0,G={ignoreSymlinks:typeof O.followSymlinks=="boolean"?!O.followSymlinks:void 0,disregardIgnoreFiles:typeof O.useIgnoreFiles=="boolean"?!O.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof O.useGlobalIgnoreFiles=="boolean"?!O.useGlobalIgnoreFiles:void 0,disregardExcludeSettings:typeof O.useDefaultExcludes=="boolean"?!O.useDefaultExcludes:!0,fileEncoding:O.encoding,maxResults:O.maxResults,previewOptions:W,afterContext:O.afterContext,beforeContext:O.beforeContext,includePattern:L,excludePattern:B},de=!1;if(this._activeSearchCallbacks[V]=j=>{if(de)return;const le=r.URI.revive(j.resource);j.results.forEach(ae=>{(0,i.resultIsMatch)(ae)?$({uri:le,preview:{text:ae.preview.text,matches:(0,h.mapArrayOrNot)(ae.preview.matches,ve=>new S.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))},ranges:(0,h.mapArrayOrNot)(ae.ranges,ve=>new S.Range(ve.startLineNumber,ve.startColumn,ve.endLineNumber,ve.endColumn))}):$({uri:le,text:ae.text,lineNumber:ae.lineNumber})})},ie.isCancellationRequested)return{};try{const j=await this._proxy.$startTextSearch(D,(0,_.withUndefinedAsNull)(Y),G,V,ie);return delete this._activeSearchCallbacks[V],j||{}}catch(j){throw delete this._activeSearchCallbacks[V],j}}$handleTextSearchResult(D,O){this._activeSearchCallbacks[O]&&this._activeSearchCallbacks[O](D)}saveAll(D){return this._proxy.$saveAll(D)}resolveProxy(D){return this._proxy.$resolveProxy(D)}get trusted(){return this._trusted}requestWorkspaceTrust(D){return this._proxy.$requestWorkspaceTrust(D)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};P=Be([We(0,g.IExtHostRpcService),We(1,c.IExtHostInitDataService),We(2,b.IExtHostFileSystemInfo),We(3,l.ILogService)],P),e.ExtHostWorkspace=P,e.IExtHostWorkspace=(0,a.createDecorator)("IExtHostWorkspace");function n(m){let D,O;return m&&(typeof m=="string"?D=m:(D=m.pattern,O=m.baseFolder||r.URI.file(m.base))),{includePattern:D,folder:O}}}),define(be[32],Ee([0,1,22,3,31,5,6,147,61,10,13,4,12,14,2]),function(re,e,h,F,E,A,R,I,y,k,t,_,r,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function l(s,u){if(u){const o=u.split(".");let f=s;for(let p=0;f&&p<o.length;p++)f=f[o[p]];return f}}function v(s){return s instanceof a.URI}function T(s){return s&&s.uri instanceof a.URI&&s.languageId&&typeof s.languageId=="string"}function b(s){return s&&!s.uri&&s.languageId&&typeof s.languageId=="string"}function c(s){return s&&s.uri instanceof a.URI&&(!s.name||typeof s.name=="string")&&(!s.index||typeof s.index=="number")}function g(s){if(v(s))return{resource:s};if(T(s))return{resource:s.uri,overrideIdentifier:s.languageId};if(b(s))return{overrideIdentifier:s.languageId};if(c(s))return{resource:s.uri};if(s===null)return{resource:null}}let S=class{constructor(u,o,f){this._proxy=u.getProxy(A.MainContext.MainThreadConfiguration),this._extHostWorkspace=o,this._logService=f,this._barrier=new t.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(u=>this._actual)}$initializeConfiguration(u){this._actual=new i(this._proxy,this._extHostWorkspace,u,this._logService),this._barrier.open()}$acceptConfigurationChanged(u,o){this.getConfigProvider().then(f=>f.$acceptConfigurationChanged(u,o))}};S=Be([We(0,r.IExtHostRpcService),We(1,E.IExtHostWorkspace),We(2,d.ILogService)],S),e.ExtHostConfiguration=S;class i{constructor(u,o,f,p){this._onDidChangeConfiguration=new F.Emitter,this._proxy=u,this._logService=p,this._extHostWorkspace=o,this._configuration=I.Configuration.parse(f),this._configurationScopes=this._toMap(f.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(u,o){const f={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=I.Configuration.parse(u),this._configurationScopes=this._toMap(u.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(o,f))}getConfiguration(u,o,f){const p=g(o)||{},w=this._toReadonlyValue(u?l(this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace),u):this._configuration.getValue(void 0,p,this._extHostWorkspace.workspace));u&&this._validateConfigurationAccess(u,p,f?.identifier);function C(n){if(n==null)return null;if(typeof n=="boolean")return n?1:4;switch(n){case R.ConfigurationTarget.Global:return 1;case R.ConfigurationTarget.Workspace:return 4;case R.ConfigurationTarget.WorkspaceFolder:return 5}}const P={has(n){return typeof l(w,n)!="undefined"},get:(n,m)=>{this._validateConfigurationAccess(u?`${u}.${n}`:n,p,f?.identifier);let D=l(w,n);if(typeof D=="undefined")D=m;else{let O;const $=(Q,ie)=>{let V;const W=()=>{O=O||(0,h.deepClone)(w),V=V||l(O,ie)};return(0,k.isObject)(Q)?new Proxy(Q,{get:(L,Y)=>{if(typeof Y=="string"&&Y.toLowerCase()==="tojson")return W(),()=>V;if(O)return V=V||l(O,ie),V[Y];const B=L[Y];return typeof Y=="string"?$(B,`${ie}.${Y}`):B},set:(L,Y,B)=>(W(),V&&(V[Y]=B),!0),deleteProperty:(L,Y)=>(W(),V&&delete V[Y],!0),defineProperty:(L,Y,B)=>(W(),V&&Object.defineProperty(V,Y,B),!0)}):Q};D=$(D,n)}return D},update:(n,m,D,O)=>{n=u?`${u}.${n}`:n;const $=C(D);return m!==void 0?this._proxy.$updateConfigurationOption($,n,m,p,O):this._proxy.$removeConfigurationOption($,n,p,O)},inspect:n=>{n=u?`${u}.${n}`:n;const m=(0,h.deepClone)(this._configuration.inspect(n,p,this._extHostWorkspace.workspace));if(m)return{key:n,defaultValue:m.default?.value,globalValue:m.user?.value,workspaceValue:m.workspace?.value,workspaceFolderValue:m.workspaceFolder?.value,defaultLanguageValue:m.default?.override,globalLanguageValue:m.user?.override,workspaceLanguageValue:m.workspace?.override,workspaceFolderLanguageValue:m.workspaceFolder?.override,languageIds:m.overrideIdentifiers}}};return typeof w=="object"&&(0,h.mixin)(P,w,!1),Object.freeze(P)}_toReadonlyValue(u){const o=f=>(0,k.isObject)(f)?new Proxy(f,{get:(p,w)=>o(p[w]),set:(p,w,C)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(w)}' of object`)},deleteProperty:(p,w)=>{throw new Error(`TypeError: Cannot delete read only property '${String(w)}' of object`)},defineProperty:(p,w)=>{throw new Error(`TypeError: Cannot define property '${String(w)}' for a readonly object`)},setPrototypeOf:p=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):f;return o(u)}_validateConfigurationAccess(u,o,f){const p=y.OVERRIDE_PROPERTY_PATTERN.test(u)?4:this._configurationScopes.get(u),w=f?`[${f.value}] `:"";if(p===4){typeof o?.resource=="undefined"&&this._logService.warn(`${w}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${u}', provide the URI of a resource or 'null' for any resource.`);return}if(p===3){o?.resource&&this._logService.warn(`${w}Accessing a window scoped configuration for a resource is not expected. To associate '${u}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(u,o){const f=new I.ConfigurationChangeEvent(u,o,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(p,w)=>f.affectsConfiguration(p,g(w))})}_toMap(u){return u.reduce((o,f)=>(o.set(f[0],f[1]),o),new Map)}}e.ExtHostConfigProvider=i,e.IExtHostConfiguration=(0,_.createDecorator)("IExtHostConfiguration")});var et=this&&this.__classPrivateFieldSet||function(re,e,h,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(re,h):E?E.value=h:e.set(re,h),h},Oe=this&&this.__classPrivateFieldGet||function(re,e,h,F){if(h==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!F:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?F:h==="a"?F.call(re):F?F.value:e.get(re)};define(be[99],Ee([0,1,2,13,3,5,22,6,31,48,32,21,37,12,29,4,11,26,14,70,164,15]),function(re,e,h,F,E,A,R,I,y,k,t,_,r,d,a,l,v,T,b,c,g,S){"use strict";var i;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var s;(function(V){function W(Y){if(Y!=null)return Y}V.from=W;function L(Y){if(Y!=null)return Y}V.to=L})(s=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var u;(function(V){function W(Y){if(Y!=null)return Y}V.from=W;function L(Y){if(Y!=null)return Y}V.to=L})(u=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var o;(function(V){function W(Y){if(Y!=null)return Y}V.from=W;function L(Y){if(Y!=null)return Y}V.to=L})(o=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var f;(function(V){function W(B){if(B){const G=B;return G&&!!G.process}else return!1}V.is=W;function L(B){if(B==null)return;const G={process:B.process,args:B.args};return B.options&&(G.options=o.from(B.options)),G}V.from=L;function Y(B){if(B!=null)return new I.ProcessExecution(B.process,B.args,B.options)}V.to=Y})(f=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var p;(function(V){function W(Y){if(Y!=null)return Y}V.from=W;function L(Y){if(Y!=null)return Y}V.to=L})(p=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var w;(function(V){function W(B){if(B){const G=B;return G&&(!!G.commandLine||!!G.command)}else return!1}V.is=W;function L(B){if(B==null)return;const G={};return B.commandLine!==void 0?G.commandLine=B.commandLine:(G.command=B.command,G.args=B.args),B.options&&(G.options=p.from(B.options)),G}V.from=L;function Y(B){if(!(B==null||B.command===void 0&&B.commandLine===void 0))return B.commandLine?new I.ShellExecution(B.commandLine,B.options):new I.ShellExecution(B.command,B.args?B.args:[],B.options)}V.to=Y})(w=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var C;(function(V){function W(B){if(B){let G=B;return G&&G.customExecution==="customExecution"}else return!1}V.is=W;function L(B){return{customExecution:"customExecution"}}V.from=L;function Y(B,G){return G.get(B)}V.to=Y})(C=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var P;(function(V){function W(L,Y){let B;return L.scope!==void 0&&typeof L.scope!="number"?B=L.scope.uri:L.scope!==void 0&&typeof L.scope=="number"&&(L.scope===I.TaskScope.Workspace&&Y&&Y.workspaceFile?B=Y.workspaceFile:B=g.USER_TASKS_GROUP_KEY),{id:L._id,workspaceFolder:B}}V.from=W})(P=e.TaskHandleDTO||(e.TaskHandleDTO={}));var n;(function(V){function W(L){if(L!=null)return{_id:L.id,isDefault:L.isDefault}}V.from=W})(n=e.TaskGroupDTO||(e.TaskGroupDTO={}));var m;(function(V){function W(B,G){if(B==null)return[];const de=[];for(let j of B){const le=L(j,G);le&&de.push(le)}return de}V.fromMany=W;function L(B,G){if(B==null)return;let de;B.execution instanceof I.ProcessExecution?de=f.from(B.execution):B.execution instanceof I.ShellExecution?de=w.from(B.execution):B.execution&&B.execution instanceof I.CustomExecution&&(de=C.from(B.execution));const j=s.from(B.definition);let le;return B.scope?typeof B.scope=="number"?le=B.scope:le=B.scope.uri:le=I.TaskScope.Workspace,!j||!le?void 0:{_id:B._id,definition:j,name:B.name,source:{extensionId:G.identifier.value,label:B.source,scope:le},execution:de,isBackground:B.isBackground,group:n.from(B.group),presentationOptions:u.from(B.presentationOptions),problemMatchers:B.problemMatchers,hasDefinedMatchers:B.hasDefinedMatchers,runOptions:B.runOptions?B.runOptions:{reevaluateOnRerun:!0},detail:B.detail}}V.from=L;async function Y(B,G,de){if(B==null)return;let j;f.is(B.execution)?j=f.to(B.execution):w.is(B.execution)?j=w.to(B.execution):C.is(B.execution)&&(j=C.to(B._id,de));const le=s.to(B.definition);let ae;if(B.source&&(B.source.scope!==void 0?typeof B.source.scope=="number"?ae=B.source.scope:ae=await G.resolveWorkspaceFolder(h.URI.revive(B.source.scope)):ae=I.TaskScope.Workspace),!le||!ae)return;const ve=new I.Task(le,ae,B.name,B.source.label,j,B.problemMatchers);return B.isBackground!==void 0&&(ve.isBackground=B.isBackground),B.group!==void 0&&(ve.group=I.TaskGroup.from(B.group._id),ve.group&&(ve.group=R.deepClone(ve.group),B.group.isDefault&&(ve.group.isDefault=B.group.isDefault))),B.presentationOptions&&(ve.presentationOptions=u.to(B.presentationOptions)),B._id&&(ve._id=B._id),B.detail&&(ve.detail=B.detail),ve}V.to=Y})(m=e.TaskDTO||(e.TaskDTO={}));var D;(function(V){function W(Y){return Y}V.from=W;function L(Y){if(!!Y)return Object.assign(Object.create(null),Y)}V.to=L})(D=e.TaskFilterDTO||(e.TaskFilterDTO={}));class O{constructor(W,L,Y){this._id=L,this._task=Y,i.set(this,void 0),et(this,i,W,"f")}get task(){return this._task}terminate(){Oe(this,i,"f").terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}i=new WeakMap;var $;(function(V){function W(L){return{id:L._id,task:void 0}}V.from=W})($=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let Q=class{constructor(W,L,Y,B,G,de,j,le){this._onDidExecuteTask=new E.Emitter,this._onDidTerminateTask=new E.Emitter,this._onDidTaskProcessStarted=new E.Emitter,this._onDidTaskProcessEnded=new E.Emitter,this._proxy=W.getProxy(A.MainContext.MainThreadTask),this._workspaceProvider=Y,this._editorService=B,this._configurationService=G,this._terminalService=de,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=j,this._deprecationService=le,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(W,L,Y){if(!Y)return new I.Disposable(()=>{});const B=this.nextHandle();return this._handlers.set(B,{type:L,provider:Y,extension:W}),this._proxy.$registerTaskProvider(B,L),new I.Disposable(()=>{this._handlers.delete(B),this._proxy.$unregisterTaskProvider(B)})}registerTaskSystem(W,L){this._proxy.$registerTaskSystem(W,L)}fetchTasks(W){return this._proxy.$fetchTasks(D.from(W)).then(async L=>{const Y=[];for(let B of L){const G=await m.to(B,this._workspaceProvider,this._providedCustomExecutions2);G&&Y.push(G)}return Y})}get taskExecutions(){const W=[];return this._taskExecutions.forEach(L=>W.push(L)),W}terminateTask(W){if(!(W instanceof O))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(W._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(W,L,Y){const B=this._providedCustomExecutions2.get(W.id);if(B){if(this._activeCustomExecutions2.get(W.id)!==void 0)throw new Error("We should not be trying to start the same custom task executions twice.");this._activeCustomExecutions2.set(W.id,B),this._terminalService.attachPtyToTerminal(L,await B.callback(Y))}this._lastStartedTask=W.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(W)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(W){const L=await this.getTaskExecution(W);this._taskExecutionPromises.delete(W.id),this._taskExecutions.delete(W.id),this.customExecutionComplete(W),this._onDidTerminateTask.fire({execution:L})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(W){const L=await this.getTaskExecution(W.id);this._onDidTaskProcessStarted.fire({execution:L,processId:W.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(W){const L=await this.getTaskExecution(W.id);this._onDidTaskProcessEnded.fire({execution:L,exitCode:W.exitCode})}$provideTasks(W,L){const Y=this._handlers.get(W);if(!Y)return Promise.reject(new Error("no handler found"));const B=[],G=(0,F.asPromise)(()=>Y.provider.provideTasks(_.CancellationToken.None)).then(de=>this.provideTasksInternal(L,B,Y,de));return new Promise(de=>{G.then(j=>{Promise.all(B).then(()=>{de(j)})})})}async $resolveTask(W,L){const Y=this._handlers.get(W);if(!Y)return Promise.reject(new Error("no handler found"));if(L.definition.type!==Y.type)throw new Error(`Unexpected: Task of type [${L.definition.type}] cannot be resolved by provider of type [${Y.type}].`);const B=await m.to(L,this._workspaceProvider,this._providedCustomExecutions2);if(!B)throw new Error("Unexpected: Task cannot be resolved.");const G=await Y.provider.resolveTask(B,_.CancellationToken.None);if(!G)return;this.checkDeprecation(G,Y);const de=m.from(G,Y.extension);if(!de)throw new Error("Unexpected: Task cannot be resolved.");if(G.definition!==B.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return C.is(de.execution)&&await this.addCustomExecution(de,G,!0),await this.resolveTaskInternal(de)}nextHandle(){return this._handleCounter++}async addCustomExecution(W,L,Y){const B=await this._proxy.$createTaskId(W);!Y&&!this._providedCustomExecutions2.has(B)&&this._notProvidedCustomExecutions.add(B),this._providedCustomExecutions2.set(B,L.execution)}async getTaskExecution(W,L){if(typeof W=="string"){const G=this._taskExecutionPromises.get(W);if(!G)throw new Error("Unexpected: The specified task is missing an execution");return G}let Y=this._taskExecutionPromises.get(W.id);if(Y)return Y;const B=new Promise(async(G,de)=>{const j=L||await m.to(W.task,this._workspaceProvider,this._providedCustomExecutions2);j?G(new O(this,W.id,j)):de("Unexpected: Task does not exist.")});return this._taskExecutionPromises.set(W.id,B),B.then(G=>(this._taskExecutions.set(W.id,G),G),G=>Promise.reject(G))}checkDeprecation(W,L){W._deprecated&&this._deprecationService.report("Task.constructor",L.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(W){this._activeCustomExecutions2.get(W.id)&&this._activeCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.has(W.id)&&this._lastStartedTask!==W.id&&(this._providedCustomExecutions2.delete(W.id),this._notProvidedCustomExecutions.delete(W.id));let Y=this._notProvidedCustomExecutions.values(),B=Y.next();for(;!B.done;)!this._activeCustomExecutions2.has(B.value)&&this._lastStartedTask!==B.value&&(this._providedCustomExecutions2.delete(B.value),this._notProvidedCustomExecutions.delete(B.value)),B=Y.next()}};Q=Be([We(0,d.IExtHostRpcService),We(1,a.IExtHostInitDataService),We(2,y.IExtHostWorkspace),We(3,k.IExtHostDocumentsAndEditors),We(4,t.IExtHostConfiguration),We(5,r.IExtHostTerminalService),We(6,b.ILogService),We(7,c.IExtHostApiDeprecationService)],Q),e.ExtHostTaskBase=Q;let ie=class extends Q{constructor(W,L,Y,B,G,de,j,le){super(W,L,Y,B,G,de,j,le);this.registerTaskSystem(v.Schemas.vscodeRemote,{scheme:v.Schemas.vscodeRemote,authority:"",platform:T.PlatformToString(0)})}async executeTask(W,L){if(!L.execution)throw new Error("Tasks to execute must include an execution");const Y=m.from(L,W);if(Y===void 0)throw new Error("Task is not valid");if(C.is(Y.execution))await this.addCustomExecution(Y,L,!1);else throw new S.NotSupportedError;const B=await this.getTaskExecution(await this._proxy.$getTaskExecution(Y),L);return this._proxy.$executeTask(Y).catch(G=>{throw new Error(G)}),B}provideTasksInternal(W,L,Y,B){const G=[];if(B)for(let de of B){this.checkDeprecation(de,Y),(!de.definition||!W[de.definition.type])&&this._logService.warn(`The task [${de.source}, ${de.name}] uses an undefined task type. The task will be ignored in the future.`);const j=m.from(de,Y.extension);j&&C.is(j.execution)?(G.push(j),L.push(this.addCustomExecution(j,de,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:G,extension:Y.extension}}async resolveTaskInternal(W){if(C.is(W.execution))return W;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(W,L){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,L,Y){}};ie=Be([We(0,d.IExtHostRpcService),We(1,a.IExtHostInitDataService),We(2,y.IExtHostWorkspace),We(3,k.IExtHostDocumentsAndEditors),We(4,t.IExtHostConfiguration),We(5,r.IExtHostTerminalService),We(6,b.ILogService),We(7,c.IExtHostApiDeprecationService)],ie),e.WorkerExtHostTask=ie,e.IExtHostTask=(0,l.createDecorator)("IExtHostTask")}),define(be[216],Ee([0,1,16,50,27,77,20,11,17,24,9,10,2,110,133,84,44,92,215,38]),function(re,e,h,F,E,A,R,I,y,k,t,_,r,d,a,l,v,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let g=class{constructor(C,P,n,m){this.configurationService=C,this.workspaceContextService=P,this.editorGroupsService=n,this.pathService=m}text(C,P,n={}){C=this.getContentPattern(C,n);const m=this.configurationService.getValue(),D=P&&P.some($=>!this.configurationService.getValue({resource:$}).search.useRipgrep);return{...this.commonQuery(P?.map(v.toWorkspaceFolder),n),type:2,contentPattern:C,previewOptions:n.previewOptions,maxFileSize:n.maxFileSize,usePCRE2:m.search.usePCRE2||D||!1,beforeContext:n.beforeContext,afterContext:n.afterContext,userDisabledExcludesAndIgnoreFiles:n.disregardExcludeSettings&&n.disregardIgnoreFiles}}getContentPattern(C,P){const n=this.configurationService.getValue();C.isRegExp&&(C.pattern=C.pattern.replace(/\r?\n/g,"\\n"));const m={...C,wordSeparators:n.editor.wordSeparators};return this.isCaseSensitive(C,P)&&(m.isCaseSensitive=!0),this.isMultiline(C)&&(m.isMultiline=!0),m}file(C,P={}){return{...this.commonQuery(C,P),type:1,filePattern:P.filePattern?P.filePattern.trim():P.filePattern,exists:P.exists,sortByScore:P.sortByScore,cacheKey:P.cacheKey}}handleIncludeExclude(C,P){return C?(C=Array.isArray(C)?C.map(o):o(C),P?this.parseSearchPaths(C):{pattern:i(...Array.isArray(C)?C:[C])}):{}}commonQuery(C=[],P={}){const n=this.handleIncludeExclude(P.includePattern,P.expandPatterns),m=this.handleIncludeExclude(P.excludePattern,P.expandPatterns),D=C.length>1,O=(n.searchPaths&&n.searchPaths.length?n.searchPaths.map(ie=>this.getFolderQueryForSearchPath(ie,P,m)):C.map(ie=>this.getFolderQueryForRoot(ie,P,m,D))).filter(ie=>!!ie),$={_reason:P._reason,folderQueries:O,usingSearchPaths:!!(n.searchPaths&&n.searchPaths.length),extraFileResources:P.extraFileResources,excludePattern:m.pattern,includePattern:n.pattern,onlyOpenEditors:P.onlyOpenEditors,maxResults:P.maxResults};if(P.onlyOpenEditors){const V=h.coalesce(h.flatten(this.editorGroupsService.groups.map(L=>L.editors.map(Y=>Y.resource)))).filter(L=>(0,c.pathIncludedInQuery)($,L.fsPath)),W=this.commonQueryFromFileList(V);return{...$,...W}}const Q=P.extraFileResources&&P.extraFileResources.filter(ie=>(0,c.pathIncludedInQuery)($,ie.fsPath));return $.extraFileResources=Q&&Q.length?Q:void 0,$}commonQueryFromFileList(C){const P=[],n=new R.ResourceMap,m={};let D=!1;return C.forEach(O=>{if(O.scheme===I.Schemas.walkThrough)return;if((0,k.isAbsolutePath)(O)){const Q=this.workspaceContextService.getWorkspaceFolder(O)?.uri??O.with({path:y.dirname(O.fsPath)});let ie=n.get(Q);ie||(D=!0,ie={folder:Q,includePattern:{}},P.push(ie),n.set(Q,ie));const V=y.relative(Q.fsPath,O.fsPath);(0,_.assertIsDefined)(ie.includePattern)[V.replace(/\\/g,"/")]=!0}else O.fsPath&&(D=!0,m[O.fsPath]=!0)}),{folderQueries:P,includePattern:m,usingSearchPaths:!0,excludePattern:D?void 0:{"**/*":!0}}}isCaseSensitive(C,P){if(P.isSmartCase){if(C.isRegExp){if(t.containsUppercaseCharacter(C.pattern,!0))return!0}else if(t.containsUppercaseCharacter(C.pattern))return!0}return!!C.isCaseSensitive}isMultiline(C){return C.isMultiline||C.isRegExp&&(0,d.isMultilineRegexSource)(C.pattern)||C.pattern.indexOf(`
`)>=0?!0:!!C.isMultiline}parseSearchPaths(C){const P=W=>y.isAbsolute(W)||/^\.\.?([\/\\]|$)/.test(W),m=(Array.isArray(C)?C:s(C)).map(W=>{const L=this.pathService.resolvedUserHome;return L?(0,A.untildify)(W,L.scheme===I.Schemas.file?L.fsPath:L.path):W}),D=F.groupBy(m,W=>P(W)?"searchPaths":"exprSegments"),O=(D.exprSegments||[]).map(W=>t.rtrim(W,"/")).map(W=>t.rtrim(W,"\\")).map(W=>(W[0]==="."&&(W="*"+W),u(W))),$={},Q=this.expandSearchPathPatterns(D.searchPaths||[]);Q&&Q.length&&($.searchPaths=Q);const ie=h.flatten(O),V=i(...ie);return V&&($.pattern=V),$}getExcludesForFolder(C,P){return P.disregardExcludeSettings?void 0:(0,c.getExcludes)(C,!P.disregardSearchExcludeSettings)}expandSearchPathPatterns(C){if(!C||!C.length)return[];const P=h.flatten(C.map(m=>{let{pathPortion:D,globPortion:O}=S(m);O&&(O=f(O));const $=this.expandOneSearchPath(D);return h.flatten($.map(Q=>this.resolveOneSearchPathPattern(Q,O)))})),n=new Map;return P.forEach(m=>{const D=m.searchPath.toString(),O=n.get(D);O?m.pattern&&(O.pattern=O.pattern||{},O.pattern[m.pattern]=!0):n.set(D,{searchPath:m.searchPath,pattern:m.pattern?i(m.pattern):void 0})}),Array.from(n.values())}expandOneSearchPath(C){if(y.isAbsolute(C)){const P=this.workspaceContextService.getWorkspace().folders;return P[0]&&P[0].uri.scheme!==I.Schemas.file?[{searchPath:P[0].uri.with({path:C})}]:[{searchPath:r.URI.file(y.normalize(C))}]}if(this.workspaceContextService.getWorkbenchState()===2){const P=this.workspaceContextService.getWorkspace().folders[0].uri;if(C=o(C),C.startsWith("../")||C===".."){const m=y.posix.resolve(P.path,C);return[{searchPath:P.with({path:m})}]}const n=f(C);return[{searchPath:P,pattern:n}]}else{if(C==="./"||C===".\\")return[];{const P=C.replace(/^\.[\/\\]/,""),m=this.workspaceContextService.getWorkspace().folders.map(D=>{const O=P.match(new RegExp(`^${t.escapeRegExpCharacters(D.name)}(?:/(.*)|$)`));return O?{match:O,folder:D}:null}).filter(_.isDefined);if(m.length)return m.map(D=>{const O=D.match[1];return{searchPath:D.folder.uri,pattern:O&&f(O)}});{const D=C.match(/\.[\/\\](.+)[\/\\]?/),O=D?D[1]:C,$=a.localize(0,null,O);throw new Error($)}}}}resolveOneSearchPathPattern(C,P){const n=C.pattern&&P?`${C.pattern}/${P}`:C.pattern||P,m=[{searchPath:C.searchPath,pattern:n}];return n&&!n.endsWith("**")&&m.push({searchPath:C.searchPath,pattern:n+"/**"}),m}getFolderQueryForSearchPath(C,P,n){const m=this.getFolderQueryForRoot((0,v.toWorkspaceFolder)(C.searchPath),P,n,!1);return m?{...m,includePattern:C.pattern}:null}getFolderQueryForRoot(C,P,n,m){let D;const O=r.URI.isUri(C)?C:C.uri;if(n.searchPaths){const W=n.searchPaths.filter(L=>(0,k.isEqual)(L.searchPath,O))[0];if(W&&!W.pattern)return null;W&&(D=W.pattern)}const $=this.configurationService.getValue({resource:O}),ie={...this.getExcludesForFolder($,P)||{},...D||{}},V=r.URI.isUri(C)?(0,k.basename)(C):C.name;return{folder:O,folderName:m?V:void 0,excludePattern:Object.keys(ie).length>0?ie:void 0,fileEncoding:$.files&&$.files.encoding,disregardIgnoreFiles:typeof P.disregardIgnoreFiles=="boolean"?P.disregardIgnoreFiles:!$.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof P.disregardGlobalIgnoreFiles=="boolean"?P.disregardGlobalIgnoreFiles:!$.search.useGlobalIgnoreFiles,ignoreSymlinks:typeof P.ignoreSymlinks=="boolean"?P.ignoreSymlinks:!$.search.followSymlinks}}};g=Be([We(0,l.IConfigurationService),We(1,v.IWorkspaceContextService),We(2,T.IEditorGroupsService),We(3,b.IPathService)],g),e.QueryBuilder=g;function S(w){const C=w.match(/[\*\{\}\(\)\[\]\?]/);if(C){const P=C.index,n=w.substr(0,P).match(/[/|\\][^/\\]*$/);if(n){let m=w.substr(0,n.index);return m.match(/[/\\]/)||(m+="/"),{pathPortion:m,globPortion:w.substr((n.index||0)+1)}}}return{pathPortion:w}}function i(...w){return w.length?w.reduce((C,P)=>(C[P]=!0,C),Object.create(null)):void 0}function s(w){return E.splitGlobAware(w,",").map(C=>C.trim()).filter(C=>!!C.length)}function u(w){return[`**/${w}/**`,`**/${w}`].map(P=>P.replace(/\*\*\/\*\*/g,"**"))}function o(w){return w.replace(/\\/g,"/")}function f(w){return o(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function p(w,C){w=h.distinct(w,m=>m.toString());const P=[],n=C.getWorkspace();return w&&w.forEach(m=>{let D;if(C.getWorkbenchState()===2)D=(0,k.relativePath)(n.folders[0].uri,m),D&&D!=="."&&(D="./"+D);else{const O=C.getWorkspaceFolder(m);if(O){const $=O.name;if(n.folders.filter(ie=>ie.name===$).length===1){const ie=(0,k.relativePath)(O.uri,m);ie===""?D=`./${O.name}`:D=`./${O.name}/${ie}`}else D=m.fsPath}}D&&P.push(D)}),P}e.resolveResourcesForSearchIncludes=p}),define(be[217],Ee([0,1,24,2,21,15,4,216,38,44]),function(re,e,h,F,E,A,R,I,y,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const t=7e3;function _(l,v){const T=v.activationEvents;if(!T)return Promise.resolve(void 0);const b=[],c=[];for(const o of T)if(/^workspaceContains:/.test(o)){const f=o.substr("workspaceContains:".length);f.indexOf("*")>=0||f.indexOf("?")>=0||l.forceUsingSearch?c.push(f):b.push(f)}if(b.length===0&&c.length===0)return Promise.resolve(void 0);let g;const S=new Promise((o,f)=>{g=o}),i=o=>g({activationEvent:o}),s=Promise.all(b.map(o=>r(l,o,i))).then(()=>{}),u=d(l,v.identifier,c,i);return Promise.all([s,u]).then(()=>{g(void 0)}),S}e.checkActivateWorkspaceContainsExtension=_;async function r(l,v,T){for(const b of l.folders)if(await l.exists(h.joinPath(F.URI.revive(b),v))){T(`workspaceContains:${v}`);return}}async function d(l,v,T,b){if(T.length===0)return Promise.resolve(void 0);const c=new E.CancellationTokenSource,g=l.checkExists(l.folders,T,c.token),S=setTimeout(async()=>{c.cancel(),b(`workspaceContainsTimeout:${T.join(",")}`)},t);let i=!1;try{i=await g}catch(s){A.isPromiseCanceledError(s)||A.onUnexpectedError(s)}c.dispose(),clearTimeout(S),i&&b(`workspaceContains:${T.join(",")}`)}function a(l,v,T,b){const c=l.get(R.IInstantiationService),g=l.get(y.ISearchService),i=c.createInstance(I.QueryBuilder).file(v.map(s=>(0,k.toWorkspaceFolder)(F.URI.revive(s))),{_reason:"checkExists",includePattern:T,exists:!0});return g.fileSearch(i,b).then(s=>!!s.limitHit,s=>A.isPromiseCanceledError(s)?!1:Promise.reject(s))}e.checkGlobFileExists=a});var et=this&&this.__classPrivateFieldSet||function(re,e,h,F,E){if(F==="m")throw new TypeError("Private method is not writable");if(F==="a"&&!E)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?re!==e||!E:!e.has(re))throw new TypeError("Cannot write private member to an object whose class did not declare it");return F==="a"?E.call(re,h):E?E.value=h:e.set(re,h),h},Oe=this&&this.__classPrivateFieldGet||function(re,e,h,F){if(h==="a"&&!F)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?re!==e||!F:!e.has(re))throw new TypeError("Cannot read private member from an object whose class did not declare it");return h==="m"?F:h==="a"?F.call(re):F?F.value:e.get(re)};define(be[33],Ee([0,1,124,17,74,24,13,7,20,2,14,5,32,177,72,31,30,175,15,25,23,151,6,85,4,29,73,12,60,65,37,3,217,69,153]),function(re,e,h,F,E,A,R,I,y,k,t,_,r,d,a,l,v,T,b,c,g,S,i,s,u,o,f,p,w,C,P,n,m,D,O){"use strict";var $,Q,ie;Object.defineProperty(e,"__esModule",{value:!0}),e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,u.createDecorator)("IHostUtils");let V=class $i extends I.Disposable{constructor(B,G,de,j,le,ae,ve,Re,Fe,Ne){super();this._onDidChangeRemoteConnectionData=this._register(new n.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._hostUtils=G,this._extHostContext=de,this._initData=ve,this._extHostWorkspace=j,this._extHostConfiguration=le,this._logService=ae,this._extHostTunnelService=Fe,this._extHostTerminalService=Ne,this._disposables=new I.DisposableStore,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(_.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(_.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(_.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new R.Barrier,this._readyToStartExtensionHost=new R.Barrier,this._readyToRunExtensions=new R.Barrier,this._eagerExtensionsActivated=new R.Barrier,this._registry=new T.ExtensionDescriptionRegistry(this._initData.extensions),this._storage=new a.ExtHostStorage(this._extHostContext),this._secretState=new D.ExtHostSecretState(this._extHostContext),this._storagePath=Re,this._instaService=B.createChild(new w.ServiceCollection([a.IExtHostStorage,this._storage],[D.IExtHostSecretState,this._secretState]));const Qe=new Set;this._initData.hostExtensions.forEach(He=>Qe.add(c.ExtensionIdentifier.toKey(He))),this._activator=new d.ExtensionsActivator(this._registry,this._initData.resolvedExtensions,this._initData.hostExtensions,{onExtensionActivationError:(He,Ke,x)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(He,b.transformErrorForSerialization(Ke),x)},actualActivateExtension:async(He,Ke)=>{if(Qe.has(c.ExtensionIdentifier.toKey(He)))return await this._mainThreadExtensionsProxy.$activateExtension(He,Ke),new d.HostExtension;const x=this._registry.getExtensionDescription(He);return this._activateExtension(x,Ke)}},this._logService),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),E.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(B){b.onUnexpectedError(B)}}async deactivateAll(){this._storagePath.onWillDeactivateAll();let B=[];try{B=this._registry.getAllExtensionDescriptions().map(le=>le.identifier).filter(le=>this.isActivated(le)).map(le=>this._deactivate(le))}catch(G){}await Promise.all(B)}isActivated(B){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(B):!1}_activateByEvent(B,G){return this._activator.activateByEvent(B,G)}_activateById(B,G){return this._activator.activateById(B,G)}activateByIdWithErrors(B,G){return this._activateById(B,G).then(()=>{const de=this._activator.getActivatedExtension(B);if(de.activationFailed)return Promise.reject(de.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(B=>this._registry)}getExtensionExports(B){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(B).exports:null}getExtensionPathIndex(){if(!this._extensionPathIndex){const B=y.TernarySearchTree.forPaths(),G=this._registry.getAllExtensionDescriptions().map(de=>{if(!!this._getEntryPoint(de))return this._hostUtils.realpath(de.extensionLocation.fsPath).then(j=>B.set(k.URI.file(j).fsPath,de))});this._extensionPathIndex=Promise.all(G).then(()=>B)}return this._extensionPathIndex}_deactivate(B){let G=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(B))return G;const de=this._activator.getActivatedExtension(B);if(!de)return G;try{typeof de.module.deactivate=="function"&&(G=Promise.resolve(de.module.deactivate()).then(void 0,j=>(this._logService.error(j),Promise.resolve(void 0))))}catch(j){this._logService.error(j)}try{(0,I.dispose)(de.subscriptions)}catch(j){this._logService.error(j)}return G}async _activateExtension(B,G){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(B.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(B.identifier),this._doActivateExtension(B,G).then(de=>{const j=de.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(B.identifier,j.codeLoadingTime,j.activateCallTime,j.activateResolvedTime,G),this._logExtensionActivationTimes(B,G,"success",j),de},de=>{throw this._logExtensionActivationTimes(B,G,"failure"),de})}_logExtensionActivationTimes(B,G,de,j){const le=W(B,G);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...le,...j||{},outcome:de})}_doActivateExtension(B,G){const de=W(B,G);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",de);const j=this._getEntryPoint(B);if(!j)return Promise.resolve(new d.EmptyExtension(d.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${B.identifier.value} ${JSON.stringify(G)}`),this._logService.flush();const le=new d.ExtensionActivationTimesBuilder(G.startup);return Promise.all([this._loadCommonJSModule(B.identifier,(0,A.joinPath)(B.extensionLocation,j),le),this._loadExtensionContext(B)]).then(ae=>(E.mark(`code/extHost/willActivateExtension/${B.identifier.value}`),$i._callActivate(this._logService,B.identifier,ae[0],ae[1],le))).then(ae=>(E.mark(`code/extHost/didActivateExtension/${B.identifier.value}`),ae))}_loadExtensionContext(B){const G=new S.ExtensionGlobalMemento(B,this._storage),de=new S.ExtensionMemento(B.identifier.value,!1,this._storage),j=new O.ExtensionSecrets(B,this._secretState),le=B.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,ae=this._initData.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${B.identifier.value}`),Promise.all([G.whenReady,de.whenReady,this._storagePath.whenReady]).then(()=>{const ve=this;let Re;return Object.freeze({globalState:G,workspaceState:de,secrets:j,subscriptions:[],get extensionUri(){return B.extensionLocation},get extensionPath(){return B.extensionLocation.fsPath},asAbsolutePath(Fe){return F.join(B.extensionLocation.fsPath,Fe)},get storagePath(){return ve._storagePath.workspaceValue(B)?.fsPath},get globalStoragePath(){return ve._storagePath.globalValue(B).fsPath},get logPath(){return F.join(ve._initData.logsLocation.fsPath,B.identifier.value)},get logUri(){return k.URI.joinPath(ve._initData.logsLocation,B.identifier.value)},get storageUri(){return ve._storagePath.workspaceValue(B)},get globalStorageUri(){return ve._storagePath.globalValue(B)},get extensionMode(){return le},get extension(){return Re===void 0&&(Re=new L(ve,B.identifier,B,ae)),Re},get extensionRuntime(){return(0,v.checkProposedApiEnabled)(B),ve.extensionRuntime},get environmentVariableCollection(){return ve._extHostTerminalService.getEnvironmentVariableCollection(B)}})})}static _callActivate(B,G,de,j,le){return de=de||{activate:void 0,deactivate:void 0},this._callActivateOptional(B,G,de,j,le).then(ae=>new d.ActivatedExtension(!1,null,le.build(),de,ae,j.subscriptions))}static _callActivateOptional(B,G,de,j,le){if(typeof de.activate=="function")try{le.activateCallStart(),B.trace(`ExtensionService#_callActivateOptional ${G.value}`);const ae=typeof global=="object"?global:self,ve=de.activate.apply(ae,[j]);return le.activateCallStop(),le.activateResolveStart(),Promise.resolve(ve).then(Re=>(le.activateResolveStop(),Re))}catch(ae){return Promise.reject(ae)}else return Promise.resolve(de)}_activateOneStartupFinished(B,G){this._activateById(B.identifier,{startup:!1,extensionId:B.identifier,activationEvent:G}).then(void 0,de=>{this._logService.error(de)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(E.getMarks());for(const B of this._registry.getAllExtensionDescriptions())if(B.activationEvents)for(const G of B.activationEvents)G==="onStartupFinished"&&this._activateOneStartupFinished(B,G)}_handleEagerExtensions(){const B=this._activateByEvent("*",!0).then(void 0,le=>{this._logService.error(le)});this._disposables.add(this._extHostWorkspace.onDidChangeWorkspace(le=>this._handleWorkspaceContainsEagerExtensions(le.added)));const G=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],de=this._handleWorkspaceContainsEagerExtensions(G),j=Promise.all([B,de]).then(()=>{});return Promise.race([j,(0,R.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),j}_handleWorkspaceContainsEagerExtensions(B){return B.length===0?Promise.resolve(void 0):Promise.all(this._registry.getAllExtensionDescriptions().map(G=>this._handleWorkspaceContainsEagerExtension(B,G))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(B,G){if(this.isActivated(G.identifier))return;const de=!this._initData.remote.isRemote&&!!this._initData.remote.authority,j={folders:B.map(ae=>ae.uri),forceUsingSearch:de,exists:ae=>this._hostUtils.exists(ae.fsPath),checkExists:(ae,ve,Re)=>this._mainThreadWorkspaceProxy.$checkExists(ae,ve,Re)},le=await(0,m.checkActivateWorkspaceContainsExtension)(j,G);if(!!le)return this._activateById(G.identifier,{startup:!0,extensionId:G.identifier,activationEvent:le.activationEvent}).then(void 0,ae=>this._logService.error(ae))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(B){throw console.error(B),B}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:B,extensionTestsLocationURI:G}=this._initData.environment;if(!B||!G)throw new Error(h.localize(0,null));const de=await this._loadCommonJSModule(null,G,new d.ExtensionActivationTimesBuilder(!1));if(!de||typeof de.run!="function")throw new Error(h.localize(1,null,G.toString()));return new Promise((j,le)=>{const ae=(Fe,Ne)=>{Fe?le(Fe):j(typeof Ne=="number"&&Ne>0?1:0)},ve=(0,A.originalFSPath)(G),Re=de.run(ve,ae);Re&&Re.then&&Re.then(()=>{j(0)}).catch(Fe=>{le(Fe.toString())})})}async $extensionTestsExit(B){this._logService.info(`extension host terminating: test runner requested exit with code ${B}`),this._logService.info(`exiting with code ${B}`),this._logService.flush(),this._hostUtils.exit(B)}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("eager extensions activated")})}registerRemoteAuthorityResolver(B,G){return this._resolvers[B]=G,(0,I.toDisposable)(()=>{delete this._resolvers[B]})}async _activateAndGetResolver(B){const G=B.indexOf("+");if(G===-1)throw new Error("Not an authority that can be resolved!");const de=B.substr(0,G);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${de}`,!1),{authorityPrefix:de,resolver:this._resolvers[de]}}async $resolveAuthority(B,G){const{authorityPrefix:de,resolver:j}=await this._activateAndGetResolver(B);if(!j)return{type:"error",error:{code:s.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${de}.`,detail:void 0}};try{this._disposables.add(await this._extHostTunnelService.setTunnelExtensionFunctions(j)),E.mark(`code/extHost/willResolveAuthority/${de}`);const le=await j.resolve(B,{resolveAttempt:G});E.mark(`code/extHost/didResolveAuthorityOK/${de}`);const ae={authority:B,host:le.host,port:le.port,connectionToken:le.connectionToken},ve={extensionHostEnv:le.extensionHostEnv,isTrusted:le.isTrusted};return{type:"ok",value:{authority:ae,options:ve,tunnelInformation:{environmentTunnels:le.environmentTunnels}}}}catch(le){if(E.mark(`code/extHost/didResolveAuthorityError/${de}`),le instanceof i.RemoteAuthorityResolverError)return{type:"error",error:{code:le._code,message:le._message,detail:le._detail}};throw le}}async $getCanonicalURI(B,G){const{authorityPrefix:de,resolver:j}=await this._activateAndGetResolver(B);if(!j)throw new Error(`Cannot get canonical URI because no remote extension is installed to resolve ${de}`);const le=k.URI.revive(G);if(typeof j.getCanonicalURI=="undefined")return le;const ae=await(0,R.asPromise)(()=>j.getCanonicalURI(le));return ae||le}$startExtensionHost(B){return this._registry.keepOnly(B),this._startExtensionHost()}$activateByEvent(B,G){return G===1?this._activateByEvent(B,!1):this._readyToRunExtensions.wait().then(de=>this._activateByEvent(B,!1))}async $activate(B,G){return await this._readyToRunExtensions.wait(),this._registry.getExtensionDescription(B)?(await this._activateById(B,G),!0):!1}async $deltaExtensions(B,G){B.forEach(j=>j.extensionLocation=k.URI.revive(j.extensionLocation));const de=await this.getExtensionPathIndex();return await Promise.all(G.map(async j=>{const le=this._registry.getExtensionDescription(j);if(!le)return;const ae=await this._hostUtils.realpath(le.extensionLocation.fsPath);de.delete(k.URI.file(ae).fsPath)})),await Promise.all(B.map(async j=>{const le=await this._hostUtils.realpath(j.extensionLocation.fsPath);de.set(k.URI.file(le).fsPath,j)})),this._registry.deltaExtensions(B,G),Promise.resolve(void 0)}async $test_latency(B){return B}async $test_up(B){return B.byteLength}async $test_down(B){let G=g.VSBuffer.alloc(B),de=Math.random()%256;for(let j=0;j<B;j++)G.writeUInt8(de,j);return G}async $updateRemoteConnectionData(B){this._remoteConnectionData=B,this._onDidChangeRemoteConnectionData.fire()}};V=Be([We(0,u.IInstantiationService),We(1,e.IHostUtils),We(2,p.IExtHostRpcService),We(3,l.IExtHostWorkspace),We(4,r.IExtHostConfiguration),We(5,t.ILogService),We(6,o.IExtHostInitDataService),We(7,f.IExtensionStoragePaths),We(8,C.IExtHostTunnelService),We(9,P.IExtHostTerminalService)],V),e.AbstractExtHostExtensionService=V;function W(Y,B){return{id:Y.identifier.value,name:Y.name,extensionVersion:Y.version,publisherDisplayName:Y.publisher,activationEvents:Y.activationEvents?Y.activationEvents.join(","):null,isBuiltin:Y.isBuiltin,reason:B.activationEvent,reasonId:B.extensionId.value}}e.IExtHostExtensionService=(0,u.createDecorator)("IExtHostExtensionService");class L{constructor(B,G,de,j){$.set(this,void 0),Q.set(this,void 0),ie.set(this,void 0),et(this,$,B,"f"),et(this,Q,G,"f"),et(this,ie,de.identifier,"f"),this.id=de.identifier.value,this.extensionUri=de.extensionLocation,this.extensionPath=F.normalize((0,A.originalFSPath)(de.extensionLocation)),this.packageJSON=de,this.extensionKind=j}get isActive(){return Oe(this,$,"f").isActivated(Oe(this,ie,"f"))}get exports(){if(this.packageJSON.api!=="none")return Oe(this,$,"f").getExtensionExports(Oe(this,ie,"f"))}activate(){return Oe(this,$,"f").activateByIdWithErrors(Oe(this,ie,"f"),{startup:!1,extensionId:Oe(this,Q,"f"),activationEvent:"api"}).then(()=>this.exports)}}e.Extension=L,$=new WeakMap,Q=new WeakMap,ie=new WeakMap}),define(be[100],Ee([0,1,17,2,3,13,5,6,161,31,33,48,166,32,162,12,4,10,91,63]),function(re,e,h,F,E,A,R,I,y,k,t,_,r,d,a,l,v,T,b,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostVariableResolverService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,v.createDecorator)("IExtHostDebugService");let g=class{constructor(w,C,P,n,m,D){this._workspaceService=C,this._extensionService=P,this._editorsService=n,this._configurationService=m,this._editorTabs=D,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new E.Emitter,this._onDidTerminateDebugSession=new E.Emitter,this._onDidChangeActiveDebugSession=new E.Emitter,this._onDidReceiveDebugSessionCustomEvent=new E.Emitter,this._debugServiceProxy=w.getProxy(R.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new E.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new i(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(O=>{O.onDidChange($=>{this.registerAllDebugTypes(O)}),this.registerAllDebugTypes(O)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(w,C){const P=w;if(typeof P.sourceReference=="number"&&P.sourceReference>0){let n=`debug:${encodeURIComponent(P.path||"")}`,m="?";return C&&(n+=`${m}session=${encodeURIComponent(C.id)}`,m="&"),n+=`${m}ref=${P.sourceReference}`,F.URI.parse(n)}else{if(P.path)return F.URI.file(P.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(w){const C=[];for(const P of w.getAllExtensionDescriptions())if(P.contributes){const n=P.contributes.debuggers;if(n&&n.length>0)for(const m of n)(0,a.isDebuggerMainContribution)(m)&&C.push(m.type)}this._debugServiceProxy.$registerDebugTypes(C)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const w=[];return this._breakpoints.forEach(C=>w.push(C)),w}addBreakpoints(w){this.startBreakpoints();const C=w.filter(m=>{const D=m.id;return this._breakpoints.has(D)?!1:(this._breakpoints.set(D,m),!0)});this.fireBreakpointChanges(C,[],[]);const P=[],n=new Map;for(const m of C)if(m instanceof I.SourceBreakpoint){let D=n.get(m.location.uri.toString());D||(D={type:"sourceMulti",uri:m.location.uri,lines:[]},n.set(m.location.uri.toString(),D),P.push(D)),D.lines.push({id:m.id,enabled:m.enabled,condition:m.condition,hitCondition:m.hitCondition,logMessage:m.logMessage,line:m.location.range.start.line,character:m.location.range.start.character})}else m instanceof I.FunctionBreakpoint&&P.push({type:"function",id:m.id,enabled:m.enabled,hitCondition:m.hitCondition,logMessage:m.logMessage,condition:m.condition,functionName:m.functionName});return this._debugServiceProxy.$registerBreakpoints(P)}removeBreakpoints(w){this.startBreakpoints();const C=w.filter(D=>this._breakpoints.delete(D.id));this.fireBreakpointChanges([],C,[]);const P=C.filter(D=>D instanceof I.SourceBreakpoint).map(D=>D.id),n=C.filter(D=>D instanceof I.FunctionBreakpoint).map(D=>D.id),m=C.filter(D=>D instanceof I.DataBreakpoint).map(D=>D.id);return this._debugServiceProxy.$unregisterBreakpoints(P,n,m)}startDebugging(w,C,P){return this._debugServiceProxy.$startDebugging(w?w.uri:void 0,C,{parentSessionID:P.parentSession?P.parentSession.id:void 0,lifecycleManagedByParent:P.lifecycleManagedByParent,repl:P.consoleMode===I.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:P.noDebug,compact:P.compact,debugUI:P.debugUI})}stopDebugging(w){return this._debugServiceProxy.$stopDebugging(w?w.id:void 0)}registerDebugConfigurationProvider(w,C,P){if(!C)return new I.Disposable(()=>{});const n=this._configProviderHandleCounter++;return this._configProviders.push({type:w,handle:n,provider:C}),this._debugServiceProxy.$registerDebugConfigurationProvider(w,P,!!C.provideDebugConfigurations,!!C.resolveDebugConfiguration,!!C.resolveDebugConfigurationWithSubstitutedVariables,n),new I.Disposable(()=>{this._configProviders=this._configProviders.filter(m=>m.provider!==C),this._debugServiceProxy.$unregisterDebugConfigurationProvider(n)})}registerDebugAdapterDescriptorFactory(w,C,P){if(!P)return new I.Disposable(()=>{});if(!this.definesDebugType(w,C))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${C}' debugger.`);if(this.getAdapterDescriptorFactoryByType(C))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const n=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:C,handle:n,factory:P}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(C,n),new I.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(m=>m.factory!==P),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(n)})}registerDebugAdapterTrackerFactory(w,C){if(!C)return new I.Disposable(()=>{});const P=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:w,handle:P,factory:C}),new I.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(n=>n.factory!==C)})}async $runInTerminal(w,C){return Promise.resolve(void 0)}async $substituteVariables(w,C){if(!this._variableResolver){const[m,D]=await Promise.all([this._workspaceService.getWorkspaceFolders2(),this._configurationService.getConfigProvider()]);this._variableResolver=this.createVariableResolver(m||[],this._editorsService,D)}let P;const n=await this.getFolder(w);return n&&(P={uri:n.uri,name:n.name,index:n.index,toResource:()=>{throw new Error("Not implemented")}}),this._variableResolver.resolveAnyAsync(P,C)}createDebugAdapter(w,C){if(w.type==="implementation")return new o(w.implementation)}createSignService(){}async $startDASession(w,C){const P=this,n=await this.getSession(C);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(n.type),n).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${n.type}' (extension might have failed to activate)`);const D=this.convertToDto(m),O=this.createDebugAdapter(D,n);if(!O)throw new Error(`Couldn't create a debug adapter for type '${n.type}'.`);const $=O;return this._debugAdapters.set(w,$),this.getDebugAdapterTrackers(n).then(Q=>(Q&&this._debugAdaptersTrackers.set(w,Q),$.onMessage(async ie=>{if(ie.type==="request"&&ie.command==="handshake"){const V=ie,W={type:"response",seq:0,command:V.command,request_seq:V.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const L=await this._signService.sign(V.arguments.value);W.body={signature:L},$.sendResponse(W)}else throw new Error("no signer")}catch(L){W.success=!1,W.message=L.message,$.sendResponse(W)}}else Q&&Q.onDidSendMessage&&Q.onDidSendMessage(ie),ie=(0,a.convertToVSCPaths)(ie,!0),P._debugServiceProxy.$acceptDAMessage(w,ie)}),$.onError(ie=>{Q&&Q.onError&&Q.onError(ie),this._debugServiceProxy.$acceptDAError(w,ie.name,ie.message,ie.stack)}),$.onExit(ie=>{Q&&Q.onExit&&Q.onExit((0,T.withNullAsUndefined)(ie),void 0),this._debugServiceProxy.$acceptDAExit(w,(0,T.withNullAsUndefined)(ie),void 0)}),Q&&Q.onWillStartSession&&Q.onWillStartSession(),$.startSession()))})}$sendDAMessage(w,C){C=(0,a.convertToDAPaths)(C,!1);const P=this._debugAdaptersTrackers.get(w);P&&P.onWillReceiveMessage&&P.onWillReceiveMessage(C);const n=this._debugAdapters.get(w);n&&n.sendMessage(C)}$stopDASession(w){const C=this._debugAdaptersTrackers.get(w);this._debugAdaptersTrackers.delete(w),C&&C.onWillStopSession&&C.onWillStopSession();const P=this._debugAdapters.get(w);return this._debugAdapters.delete(w),P?P.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(w){const C=[],P=[],n=[];if(w.added)for(const m of w.added){const D=m.id;if(D&&!this._breakpoints.has(D)){let O;if(m.type==="function")O=new I.FunctionBreakpoint(m.functionName,m.enabled,m.condition,m.hitCondition,m.logMessage);else if(m.type==="data")O=new I.DataBreakpoint(m.label,m.dataId,m.canPersist,m.enabled,m.hitCondition,m.condition,m.logMessage);else{const $=F.URI.revive(m.uri);O=new I.SourceBreakpoint(new I.Location($,new I.Position(m.line,m.character)),m.enabled,m.condition,m.hitCondition,m.logMessage)}O._id=D,this._breakpoints.set(D,O),C.push(O)}}if(w.removed)for(const m of w.removed){const D=this._breakpoints.get(m);D&&(this._breakpoints.delete(m),P.push(D))}if(w.changed){for(const m of w.changed)if(m.id){const D=this._breakpoints.get(m.id);if(D){if(D instanceof I.FunctionBreakpoint&&m.type==="function"){const O=D;O.enabled=m.enabled,O.condition=m.condition,O.hitCondition=m.hitCondition,O.logMessage=m.logMessage,O.functionName=m.functionName}else if(D instanceof I.SourceBreakpoint&&m.type==="source"){const O=D;O.enabled=m.enabled,O.condition=m.condition,O.hitCondition=m.hitCondition,O.logMessage=m.logMessage,O.location=new I.Location(F.URI.revive(m.uri),new I.Position(m.line,m.character))}n.push(D)}}}this.fireBreakpointChanges(C,P,n)}$provideDebugConfigurations(w,C,P){return(0,A.asPromise)(async()=>{const n=this.getConfigProviderByHandle(w);if(!n)throw new Error("no DebugConfigurationProvider found");if(!n.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const m=await this.getFolder(C);return n.provideDebugConfigurations(m,P)}).then(n=>{if(!n)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return n})}$resolveDebugConfiguration(w,C,P,n){return(0,A.asPromise)(async()=>{const m=this.getConfigProviderByHandle(w);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const D=await this.getFolder(C);return m.resolveDebugConfiguration(D,P,n)})}$resolveDebugConfigurationWithSubstitutedVariables(w,C,P,n){return(0,A.asPromise)(async()=>{const m=this.getConfigProviderByHandle(w);if(!m)throw new Error("no DebugConfigurationProvider found");if(!m.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const D=await this.getFolder(C);return m.resolveDebugConfigurationWithSubstitutedVariables(D,P,n)})}async $provideDebugAdapter(w,C){const P=this.getAdapterDescriptorFactoryByHandle(w);if(!P)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const n=await this.getSession(C);return this.getAdapterDescriptor(P,n).then(m=>{if(!m)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${n.type}'`);return this.convertToDto(m)})}async $acceptDebugSessionStarted(w){const C=await this.getSession(w);this._onDidStartDebugSession.fire(C)}async $acceptDebugSessionTerminated(w){const C=await this.getSession(w);C&&(this._onDidTerminateDebugSession.fire(C),this._debugSessions.delete(C.id))}async $acceptDebugSessionActiveChanged(w){this._activeDebugSession=w?await this.getSession(w):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(w,C){const P=await this.getSession(w);P&&P._acceptNameChanged(C)}async $acceptDebugSessionCustomEvent(w,C){const n={session:await this.getSession(w),event:C.event,body:C.body};this._onDidReceiveDebugSessionCustomEvent.fire(n)}convertToDto(w){if(w instanceof I.DebugAdapterExecutable)return{type:"executable",command:w.command,args:w.args,options:w.options};if(w instanceof I.DebugAdapterServer)return{type:"server",port:w.port,host:w.host};if(w instanceof I.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:w.path};if(w instanceof I.DebugAdapterInlineImplementation)return{type:"implementation",implementation:w.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(w){const C=this._adapterFactories.filter(P=>P.type===w);if(C.length>0)return C[0].factory}getAdapterDescriptorFactoryByHandle(w){const C=this._adapterFactories.filter(P=>P.handle===w);if(C.length>0)return C[0].factory}getConfigProviderByHandle(w){const C=this._configProviders.filter(P=>P.handle===w);if(C.length>0)return C[0].provider}definesDebugType(w,C){if(w.contributes){const P=w.contributes.debuggers;if(P&&P.length>0){for(const n of P)if(n.label&&n.type&&n.type===C)return!0}}return!1}getDebugAdapterTrackers(w){const P=w.configuration.type,n=this._trackerFactories.filter(m=>m.type===P||m.type==="*").map(m=>(0,A.asPromise)(()=>m.factory.createDebugAdapterTracker(w)).then(D=>D,D=>null));return Promise.race([Promise.all(n).then(m=>{const D=m.filter(O=>!!O);if(D.length>0)return new u(D)}),new Promise((m,D)=>{const O=setTimeout(()=>{clearTimeout(O),D(new Error("timeout"))},1e3)})]).catch(m=>{})}async getAdapterDescriptor(w,C){const P=C.configuration.debugServer;if(typeof P=="number")return Promise.resolve(new I.DebugAdapterServer(P));if(w){const m=await this._extensionService.getExtensionRegistry();return(0,A.asPromise)(()=>w.createDebugAdapterDescriptor(C,this.daExecutableFromPackage(C,m))).then(D=>{if(D)return D})}const n=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(C,n))}daExecutableFromPackage(w,C){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(w,C,P){(w.length>0||C.length>0||P.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:w,removed:C,changed:P}))}async getSession(w){if(w)if(typeof w=="string"){const C=this._debugSessions.get(w);if(C)return C}else{let C=this._debugSessions.get(w.id);if(!C){const P=await this.getFolder(w.folderUri),n=w.parent?this._debugSessions.get(w.parent):void 0;C=new S(this._debugServiceProxy,w.id,w.type,w.name,P,w.configuration,n),this._debugSessions.set(C.id,C),this._debugServiceProxy.$sessionCached(C.id)}return C}throw new Error("cannot find session")}getFolder(w){if(w){const C=F.URI.revive(w);return this._workspaceService.resolveWorkspaceFolder(C)}return Promise.resolve(void 0)}};g=Be([We(0,l.IExtHostRpcService),We(1,k.IExtHostWorkspace),We(2,t.IExtHostExtensionService),We(3,_.IExtHostDocumentsAndEditors),We(4,d.IExtHostConfiguration),We(5,c.IExtHostEditorTabs)],g),e.ExtHostDebugServiceBase=g;class S{constructor(w,C,P,n,m,D,O){this._debugServiceProxy=w,this._id=C,this._type=P,this._name=n,this._workspaceFolder=m,this._configuration=D,this._parentSession=O}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(w){this._name=w,this._debugServiceProxy.$setDebugSessionName(this._id,w)}get parentSession(){return this._parentSession}_acceptNameChanged(w){this._name=w}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(w,C){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,w,C)}getDebugProtocolBreakpoint(w){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,w.id)}}e.ExtHostDebugSession=S;class i{constructor(w){this.value=Object.freeze({append(C){w.$appendDebugConsole(C)},appendLine(C){this.append(C+`
`)}})}}e.ExtHostDebugConsole=i;class s extends r.AbstractVariableResolverService{constructor(w,C,P,n,m){function D(){if(C){const O=C.activeEditor();if(O)return O.document.uri;const $=n.tabs.filter(Q=>Q.isActive);if($.length>0)return $[0].resource}}super({getFolderUri:O=>{const $=w.filter(Q=>Q.name===O);if($&&$.length>0)return $[0].uri},getWorkspaceFolderCount:()=>w.length,getConfigurationValue:(O,$)=>P.getConfiguration(void 0,O).get($),getAppRoot:()=>b.cwd(),getExecPath:()=>b.env.VSCODE_EXEC_PATH,getFilePath:()=>{const O=D();if(O)return h.normalize(O.fsPath)},getWorkspaceFolderPathForFile:()=>{if(m){const O=D();if(O){const $=m.getWorkspaceFolder(O);if($)return h.normalize($.uri.fsPath)}}},getSelectedText:()=>{if(C){const O=C.activeEditor();if(O&&!O.selection.isEmpty)return O.document.getText(O.selection)}},getLineNumber:()=>{if(C){const O=C.activeEditor();if(O)return String(O.selection.end.line+1)}}},void 0,Promise.resolve(b.env))}}e.ExtHostVariableResolverService=s;class u{constructor(w){this.trackers=w}onWillStartSession(){this.trackers.forEach(w=>w.onWillStartSession?w.onWillStartSession():void 0)}onWillReceiveMessage(w){this.trackers.forEach(C=>C.onWillReceiveMessage?C.onWillReceiveMessage(w):void 0)}onDidSendMessage(w){this.trackers.forEach(C=>C.onDidSendMessage?C.onDidSendMessage(w):void 0)}onWillStopSession(){this.trackers.forEach(w=>w.onWillStopSession?w.onWillStopSession():void 0)}onError(w){this.trackers.forEach(C=>C.onError?C.onError(w):void 0)}onExit(w,C){this.trackers.forEach(P=>P.onExit?P.onExit(w,C):void 0)}}class o extends y.AbstractDebugAdapter{constructor(w){super();this.implementation=w,w.onDidSendMessage(C=>{this.acceptMessage(C)})}startSession(){return Promise.resolve(void 0)}sendMessage(w){this.implementation.handleMessage(w)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let f=class extends g{constructor(w,C,P,n,m,D){super(w,C,P,n,m,D)}createVariableResolver(w,C,P){return new s(w,C,P,this._editorTabs)}};f=Be([We(0,l.IExtHostRpcService),We(1,k.IExtHostWorkspace),We(2,t.IExtHostExtensionService),We(3,_.IExtHostDocumentsAndEditors),We(4,d.IExtHostConfiguration),We(5,c.IExtHostEditorTabs)],f),e.WorkerExtHostDebugService=f}),define(be[218],Ee([0,1,74,2,5,32,30,25,12,29,4,33,91,14]),function(re,e,h,F,E,A,R,I,y,k,t,_,r,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let a=class{constructor(c,g,S,i,s,u,o){this._apiFactory=c,this._extensionRegistry=g,this._instaService=S,this._extHostConfiguration=i,this._extHostExtensionService=s,this._initData=u,this._logService=o,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),h.mark("code/extHost/willWaitForConfig");const c=await this._extHostConfiguration.getConfigProvider();h.mark("code/extHost/didWaitForConfig");const g=await this._extHostExtensionService.getExtensionPathIndex();this.register(new l(this._apiFactory,g,this._extensionRegistry,c,this._logService)),this.register(this._instaService.createInstance(v)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(T,g,this._initData.environment.appUriScheme))}register(c){if(Array.isArray(c.nodeModuleName))for(let g of c.nodeModuleName)this._factories.set(g,c);else this._factories.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this._alternatives.push(g=>c.alternativeModuleName(g))}};a=Be([We(2,t.IInstantiationService),We(3,A.IExtHostConfiguration),We(4,_.IExtHostExtensionService),We(5,k.IExtHostInitDataService),We(6,d.ILogService)],a),e.RequireInterceptor=a;class l{constructor(c,g,S,i,s){this._apiFactory=c,this._extensionPaths=g,this._extensionRegistry=S,this._configProvider=i,this._logService=s,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(c,g){const S=this._extensionPaths.findSubstr(g.fsPath);if(S){let i=this._extApiImpl.get(I.ExtensionIdentifier.toKey(S.identifier));return i||(i=this._apiFactory(S,this._extensionRegistry,this._configProvider),this._extApiImpl.set(I.ExtensionIdentifier.toKey(S.identifier),i)),i}if(!this._defaultApiImpl){let i="";this._extensionPaths.forEach((s,u)=>i+=`	${u} -> ${s.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${g.fsPath}. These are the extension path mappings: 
${i}`),this._defaultApiImpl=this._apiFactory(R.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(c,g){this.nodeModuleName="keytar";const{environment:S}=g,i=c.getProxy(E.MainContext.MainThreadKeytar);if(S.appRoot){let s=S.appRoot.fsPath;r.platform==="win32"&&(s=s.replace(/\\/g,"/")),s[s.length-1]==="/"&&(s=s.substr(0,s.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${s}/node_modules.asar/keytar`),this.alternativeNames.add(`${s}/node_modules/keytar`)}this._impl={getPassword:(s,u)=>i.$getPassword(s,u),setPassword:(s,u,o)=>i.$setPassword(s,u,o),deletePassword:(s,u)=>i.$deletePassword(s,u),findPassword:s=>i.$findPassword(s),findCredentials(s){return i.$findCredentials(s)}}}load(c,g){return this._impl}alternativeModuleName(c){const g=c.length;if(g<=7||!this.alternativeNames)return;const S=g-7;if((c.charAt(S)==="/"||c.charAt(S)==="\\")&&c.endsWith("keytar")&&(c=c.replace(/\\/g,"/"),this.alternativeNames.has(c)))return"keytar"}};v=Be([We(0,y.IExtHostRpcService),We(1,k.IExtHostInitDataService)],v);let T=class{constructor(c,g,S){this._extensionPaths=c,this._appUriScheme=g,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=S.getProxy(E.MainContext.MainThreadTelemetry);const i=S.getProxy(E.MainContext.MainThreadWindow);this._impl=(s,u)=>{const o=F.URI.parse(s);return u?this.callOriginal(s,u):o.scheme==="http"||o.scheme==="https"?i.$openUri(o,s,{allowTunneling:!0}):o.scheme==="mailto"||o.scheme===this._appUriScheme?i.$openUri(o,s,{}):this.callOriginal(s,u)}}load(c,g,S){const i=this._extensionPaths.findSubstr(g.fsPath);return i&&(this._extensionId=i.identifier.value,this.sendShimmingTelemetry()),this._original=S(c),this._impl}callOriginal(c,g){return this.sendNoForwardTelemetry(),this._original(c,g)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};T=Be([We(2,y.IExtHostRpcService)],T)}),define(be[219],Ee([0,1,13,15,74,7,2,5,212,14,56,60,29,143,12,66,33,37]),function(re,e,h,F,E,A,R,I,y,k,t,_,r,d,a,l,v,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class b{constructor(g,S,i,s){this._disposables=new A.DisposableStore,this._isTerminating=!1,this._hostUtils=i,this._rpcProtocol=new y.RPCProtocol(g,null,s),S=b._transform(S,this._rpcProtocol);const u=new _.ServiceCollection(...(0,t.getSingletonServiceDescriptors)());u.set(r.IExtHostInitDataService,{_serviceBrand:void 0,...S}),u.set(a.IExtHostRpcService,new a.ExtHostRpcService(this._rpcProtocol)),u.set(l.IURITransformerService,new l.URITransformerService(s)),u.set(v.IHostUtils,i);const o=new d.InstantiationService(u,!0),f=o.invokeFunction(P=>P.get(T.IExtHostTerminalService));this._disposables.add(f),this._logService=o.invokeFunction(P=>P.get(k.ILogService)),E.mark("code/extHost/didCreateServices"),this._logService.info("extension host started"),this._logService.trace("initData",S),this._extensionService=o.invokeFunction(P=>P.get(v.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const p=new WeakMap;this._extensionService.getExtensionPathIndex().then(P=>{Error.prepareStackTrace=(n,m)=>{let D="",O,$;for(const Q of m)D+=`
	at ${Q.toString()}`,$=Q.getFileName(),!O&&$&&(O=P.findSubstr($));return p.set(n,O),`${n.name||"Error"}: ${n.message||""}${D}`}});const w=this._rpcProtocol.getProxy(I.MainContext.MainThreadExtensionService),C=this._rpcProtocol.getProxy(I.MainContext.MainThreadErrors);F.setUnexpectedErrorHandler(P=>{const n=F.transformErrorForSerialization(P),m=p.get(P);m?w.$onExtensionRuntimeError(m.identifier,n):C.$onUnexpectedError(n)})}terminate(g){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`extension host terminating: ${g}`),this._logService.flush(),this._disposables.dispose(),F.setUnexpectedErrorHandler(i=>{this._logService.error(i)}),this._rpcProtocol.dispose();const S=this._extensionService.deactivateAll();setTimeout(()=>{Promise.race([(0,h.timeout)(4e3),S]).finally(()=>{this._logService.info("exiting with code 0"),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(0)})},1e3)}static _transform(g,S){g.extensions.forEach(s=>s.extensionLocation=R.URI.revive(S.transformIncomingURIs(s.extensionLocation))),g.environment.appRoot=R.URI.revive(S.transformIncomingURIs(g.environment.appRoot));const i=g.environment.extensionDevelopmentLocationURI;return i&&(g.environment.extensionDevelopmentLocationURI=i.map(s=>R.URI.revive(S.transformIncomingURIs(s)))),g.environment.extensionTestsLocationURI=R.URI.revive(S.transformIncomingURIs(g.environment.extensionTestsLocationURI)),g.environment.globalStorageHome=R.URI.revive(S.transformIncomingURIs(g.environment.globalStorageHome)),g.environment.workspaceStorageHome=R.URI.revive(S.transformIncomingURIs(g.environment.workspaceStorageHome)),g.logsLocation=R.URI.revive(S.transformIncomingURIs(g.logsLocation)),g.logFile=R.URI.revive(S.transformIncomingURIs(g.logFile)),g.workspace=S.transformIncomingURIs(g.workspace),g}}e.ExtensionHostMain=b}),define(be[220],Ee([0,1,17,21,55,27,24,193,38]),function(re,e,h,F,E,A,R,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class k{constructor(r,d,a){this.config=r,this.provider=d,this.sessionToken=a,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=r.filePattern,this.includePattern=r.includePattern&&A.parse(r.includePattern),this.maxResults=r.maxResults||void 0,this.exists=r.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=r.excludePattern&&A.parse(r.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(r=>r.cancel()),this.activeCancellationTokens=new Set}search(r){const d=this.config.folderQueries||[];return new Promise((a,l)=>{const v=T=>{this.resultCount++,r(T)};if(this.isCanceled)return a({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(T=>{const b=T.toString(),c=h.basename(b);this.globalExcludePattern&&this.globalExcludePattern(b,c)||this.matchFile(v,{base:T,basename:c})}),Promise.all(d.map(T=>this.searchInFolder(T,v))).then(T=>{a({limitHit:this.isLimitHit,stats:T[0]||void 0})},T=>{l(new Error((0,E.toErrorMessage)(T)))})})}async searchInFolder(r,d){const a=new F.CancellationTokenSource,l=this.getSearchOptionsForFolder(r),v=this.initDirectoryTree(),T=new y.QueryGlobTester(this.config,r),b=!T.hasSiblingExcludeClauses();let c;try{this.activeCancellationTokens.add(a),c=I.StopWatch.create();const g=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},l,a.token),S=c.elapsed(),i=I.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(g&&g.forEach(s=>{const u=h.posix.relative(r.folder.path,s.path);if(b){const o=h.basename(s.path);this.matchFile(d,{base:r.folder,relativePath:u,basename:o});return}this.addDirectoryEntries(v,r.folder,u,d)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(v,T,d),{providerTime:S,postProcessTime:i.elapsed()})}finally{a.dispose(),this.activeCancellationTokens.delete(a)}}getSearchOptionsForFolder(r){const d=(0,y.resolvePatternsForProvider)(this.config.includePattern,r.includePattern),a=(0,y.resolvePatternsForProvider)(this.config.excludePattern,r.excludePattern);return{folder:r.folder,excludes:a,includes:d,useIgnoreFiles:!r.disregardIgnoreFiles,useGlobalIgnoreFiles:!r.disregardGlobalIgnoreFiles,followSymlinks:!r.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const r={rootEntries:[],pathToEntries:Object.create(null)};return r.pathToEntries["."]=r.rootEntries,r}addDirectoryEntries({pathToEntries:r},d,a,l){if(a===this.filePattern){const T=h.basename(this.filePattern);this.matchFile(l,{base:d,relativePath:this.filePattern,basename:T})}function v(T){const b=h.basename(T),c=h.dirname(T);let g=r[c];g||(g=r[c]=[],v(c)),g.push({base:d,relativePath:T,basename:b})}v(a)}matchDirectoryTree({rootEntries:r,pathToEntries:d},a,l){const v=this,T=this.filePattern;function b(c){const g=A.hasSiblingFn(()=>c.map(S=>S.basename));for(let S=0,i=c.length;S<i;S++){const s=c[S],{relativePath:u,basename:o}=s;if(!a.includedInQuerySync(u,o,T!==o?g:void 0))continue;const f=d[u];if(f)b(f);else{if(u===T)continue;v.matchFile(l,s)}if(v.isLimitHit)break}}b(r)}matchFile(r,d){(!this.includePattern||d.relativePath&&this.includePattern(d.relativePath,d.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||r(d))}}class t{constructor(){this.sessions=new Map}fileSearch(r,d,a,l){const v=this.getSessionTokenSource(r.cacheKey),T=new k(r,d,v&&v.token);let b=0;const c=g=>{b+=g.length,a(g.map(S=>this.rawMatchToSearchItem(S)))};return this.doSearch(T,t.BATCH_SIZE,c,l).then(g=>({limitHit:g.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:b,detailStats:g.stats}}))}clearCache(r){const d=this.getSessionTokenSource(r);d&&d.cancel()}getSessionTokenSource(r){if(!!r)return this.sessions.has(r)||this.sessions.set(r,new F.CancellationTokenSource),this.sessions.get(r)}rawMatchToSearchItem(r){return r.relativePath?{resource:R.joinPath(r.base,r.relativePath)}:{resource:r.base}}doSearch(r,d,a,l){l.onCancellationRequested(()=>{r.cancel()});const v=b=>{b&&(T.push(b),d>0&&T.length>=d&&(a(T),T=[]))};let T=[];return r.search(v).then(b=>(T.length&&a(T),b),b=>(T.length&&a(T),Promise.reject(b)))}}e.FileSearchManager=t,t.BATCH_SIZE=512}),define(be[221],Ee([0,1,17,16,21,55,24,27,2,38,11,10]),function(re,e,h,F,E,A,R,I,y,k,t,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class r{constructor(c,g,S){this.query=c,this.provider=g,this.fileUtils=S,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(c,g){const S=this.query.folderQueries||[],i=new E.CancellationTokenSource;return g.onCancellationRequested(()=>i.cancel()),new Promise((s,u)=>{this.collector=new a(c);let o=!1;const f=(p,w)=>{if(!o&&!this.isLimitHit){const C=this.resultSize(p);v(p)&&typeof this.query.maxResults=="number"&&this.resultCount+C>this.query.maxResults&&(this.isLimitHit=!0,o=!0,i.cancel(),p=this.trimResultToSize(p,this.query.maxResults-this.resultCount));const P=this.resultSize(p);this.resultCount+=P,(P>0||!v(p))&&this.collector.add(p,w)}};Promise.all(S.map((p,w)=>this.searchInFolder(p,C=>f(C,w),i.token))).then(p=>{i.dispose(),this.collector.flush();const w=p.some(C=>!!C&&!!C.limitHit);s({limitHit:this.isLimitHit||w,messages:(0,F.flatten)(p.map(C=>C?.message?(0,_.isArray)(C.message)?C.message:[C.message]:[])),stats:{type:"textSearchProvider"}})},p=>{i.dispose();const w=(0,A.toErrorMessage)(p);u(new Error(w))})})}resultSize(c){return v(c)?Array.isArray(c.ranges)?c.ranges.length:1:0}trimResultToSize(c,g){const S=Array.isArray(c.ranges)?c.ranges:[c.ranges],i=Array.isArray(c.preview.matches)?c.preview.matches:[c.preview.matches];return{ranges:S.slice(0,g),preview:{matches:i.slice(0,g),text:c.preview.text},uri:c.uri}}async searchInFolder(c,g,S){const i=new k.QueryGlobTester(this.query,c),s=[],u={report:p=>{if(!this.validateProviderResult(p))return;const w=c.folder.scheme===t.Schemas.file?I.hasSiblingPromiseFn(()=>this.fileUtils.readdir(R.dirname(p.uri))):void 0,C=R.relativePath(c.folder,p.uri);C&&s.push(i.includedInQuery(C,h.basename(C),w).then(P=>{P&&g(p)}))}},o=this.getSearchOptionsForFolder(c),f=await this.provider.provideTextSearchResults(d(this.query.contentPattern),o,u,S);return await Promise.all(s),f}validateProviderResult(c){if(v(c)){if(Array.isArray(c.ranges)){if(!Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(c.preview.matches.length!==c.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(c.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(c){const g=(0,k.resolvePatternsForProvider)(this.query.includePattern,c.includePattern),S=(0,k.resolvePatternsForProvider)(this.query.excludePattern,c.excludePattern),i={folder:y.URI.from(c.folder),excludes:S,includes:g,useIgnoreFiles:!c.disregardIgnoreFiles,useGlobalIgnoreFiles:!c.disregardGlobalIgnoreFiles,followSymlinks:!c.ignoreSymlinks,encoding:c.fileEncoding&&this.fileUtils.toCanonicalName(c.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return i.usePCRE2=this.query.usePCRE2,i}}e.TextSearchManager=r;function d(b){return{isCaseSensitive:b.isCaseSensitive||!1,isRegExp:b.isRegExp||!1,isWordMatch:b.isWordMatch||!1,isMultiline:b.isMultiline||!1,pattern:b.pattern}}class a{constructor(c){this._onResult=c,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new T(512,g=>this.sendItems(g))}add(c,g){this._currentFileMatch&&(this._currentFolderIdx!==g||!R.isEqual(this._currentUri,c.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=g,this._currentFileMatch={resource:c.uri,results:[]}),this._currentFileMatch.results.push(l(c))}pushToCollector(){const c=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,c)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(c){this._onResult(c)}}e.TextSearchResultsCollector=a;function l(b){return v(b)?{preview:{matches:(0,F.mapArrayOrNot)(b.preview.matches,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character})),text:b.preview.text},ranges:(0,F.mapArrayOrNot)(b.ranges,c=>({startLineNumber:c.start.line,startColumn:c.start.character,endLineNumber:c.end.line,endColumn:c.end.character}))}:{text:b.text,lineNumber:b.lineNumber}}function v(b){return!!b.preview}e.extensionResultIsMatch=v;class T{constructor(c,g){this.maxBatchSize=c,this.cb=g,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(c,g){!c||this.addItemToBatch(c,g)}addItems(c,g){!c||this.addItemsToBatch(c,g)}addItemToBatch(c,g){this.batch.push(c),this.batchSize+=g,this.onUpdate()}addItemsToBatch(c,g){this.batch=this.batch.concat(c),this.batchSize+=g,this.onUpdate()}onUpdate(){this.totalNumberCompleted<T.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},T.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=T,T.TIMEOUT=4e3,T.START_BATCH_AFTER_COUNT=50}),define(be[101],Ee([0,1,7,5,4,220,12,66,14,2,221]),function(re,e,h,F,E,A,R,I,y,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,E.createDecorator)("IExtHostSearch");let _=class{constructor(l,v,T){this.extHostRpc=l,this._uriTransformer=v,this._logService=T,this._proxy=this.extHostRpc.getProxy(F.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new A.FileSearchManager}_transformScheme(l){return this._uriTransformer.transformOutgoingScheme(l)}registerTextSearchProvider(l,v){if(this._textSearchUsedSchemes.has(l))throw new Error(`a text search provider for the scheme '${l}' is already registered`);this._textSearchUsedSchemes.add(l);const T=this._handlePool++;return this._textSearchProvider.set(T,v),this._proxy.$registerTextSearchProvider(T,this._transformScheme(l)),(0,h.toDisposable)(()=>{this._textSearchUsedSchemes.delete(l),this._textSearchProvider.delete(T),this._proxy.$unregisterProvider(T)})}registerFileSearchProvider(l,v){if(this._fileSearchUsedSchemes.has(l))throw new Error(`a file search provider for the scheme '${l}' is already registered`);this._fileSearchUsedSchemes.add(l);const T=this._handlePool++;return this._fileSearchProvider.set(T,v),this._proxy.$registerFileSearchProvider(T,this._transformScheme(l)),(0,h.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(l),this._fileSearchProvider.delete(T),this._proxy.$unregisterProvider(T)})}$provideFileSearchResults(l,v,T,b){const c=r(T),g=this._fileSearchProvider.get(l);if(g)return this._fileSearchManager.fileSearch(c,g,S=>{this._proxy.$handleFileMatch(l,v,S.map(i=>i.resource))},b);throw new Error("unknown provider: "+l)}$clearCache(l){return this._fileSearchManager.clearCache(l),Promise.resolve(void 0)}$provideTextSearchResults(l,v,T,b){const c=this._textSearchProvider.get(l);if(!c||!c.provideTextSearchResults)throw new Error(`Unknown provider ${l}`);const g=r(T);return this.createTextSearchManager(g,c).search(i=>this._proxy.$handleTextMatch(l,v,i),b)}createTextSearchManager(l,v){return new t.TextSearchManager(l,v,{readdir:T=>Promise.resolve([]),toCanonicalName:T=>T})}};_=Be([We(0,R.IExtHostRpcService),We(1,I.IURITransformerService),We(2,y.ILogService)],_),e.ExtHostSearch=_;function r(a){return{...a,folderQueries:a.folderQueries&&a.folderQueries.map(d),extraFileResources:a.extraFileResources&&a.extraFileResources.map(l=>k.URI.revive(l))}}e.reviveQuery=r;function d(a){return{...a,folder:k.URI.revive(a.folder)}}}),define(be[222],Ee([0,1,21,15,3,35,2,116,79,112,54,59,5,182,181,47,183,32,184,185,186,168,187,48,33,189,169,192,194,195,96,171,200,201,202,72,37,204,172,8,6,207,49,97,31,30,50,158,191,86,95,99,100,101,14,66,12,29,196,155,65,70,179,205,154,73,71,210,208,209,180,45,203,206,69,63,87,198,98,199,11,145,197,152,190]),function(re,e,h,F,E,A,R,I,y,k,t,_,r,d,a,l,v,T,b,c,g,S,i,s,u,o,f,p,w,C,P,n,m,D,O,$,Q,ie,V,W,L,Y,B,G,de,j,le,ae,ve,Re,Fe,Ne,Qe,He,Ke,x,q,Z,se,H,ne,fe,Te,xe,$e,we,Xe,z,K,he,Le,Ve,tt,lt,ft,St,Pt,dt,bt,mt,Et,Ye,Ct,Pe,ye){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function ke(X){const ue=X.get(Z.IExtHostInitDataService),ge=X.get(Ve.IExtHostFileSystemInfo),me=X.get(Xe.IExtHostConsumerFileSystem),Ie=X.get(u.IExtHostExtensionService),Ue=X.get(de.IExtHostWorkspace),Me=X.get(Pt.IExtHostTelemetry),je=X.get(T.IExtHostConfiguration),Je=X.get(x.IURITransformerService),te=X.get(q.IExtHostRpcService),pe=X.get($.IExtHostStorage),oe=X.get(we.IExtensionStoragePaths),U=X.get(Ke.ILogService),De=X.get(ne.IExtHostTunnelService),Se=X.get(fe.IExtHostApiDeprecationService),qe=X.get(G.IExtHostWindow),ze=X.get(ft.IExtHostSecretState),it=X.get(St.IExtHostEditorTabs);te.set(r.ExtHostContext.ExtHostFileSystemInfo,ge),te.set(r.ExtHostContext.ExtHostLogService,U),te.set(r.ExtHostContext.ExtHostWorkspace,Ue),te.set(r.ExtHostContext.ExtHostConfiguration,je),te.set(r.ExtHostContext.ExtHostExtensionService,Ie),te.set(r.ExtHostContext.ExtHostStorage,pe),te.set(r.ExtHostContext.ExtHostTunnelService,De),te.set(r.ExtHostContext.ExtHostWindow,qe),te.set(r.ExtHostContext.ExtHostSecretState,ze),te.set(r.ExtHostContext.ExtHostTelemetry,Me),te.set(r.ExtHostContext.ExtHostEditorTabs,it);const vt=te.set(r.ExtHostContext.ExtHostDecorations,X.get(Fe.IExtHostDecorations)),ht=te.set(r.ExtHostContext.ExtHostDocumentsAndEditors,X.get(s.IExtHostDocumentsAndEditors)),ot=te.set(r.ExtHostContext.ExtHostCommands,X.get(l.IExtHostCommands)),st=te.set(r.ExtHostContext.ExtHostTerminalService,X.get(Q.IExtHostTerminalService)),ut=te.set(r.ExtHostContext.ExtHostDebugService,X.get(Qe.IExtHostDebugService)),kt=te.set(r.ExtHostContext.ExtHostSearch,X.get(He.IExtHostSearch)),Tt=te.set(r.ExtHostContext.ExtHostTask,X.get(Ne.IExtHostTask)),Wt=te.set(r.ExtHostContext.ExtHostOutputService,X.get(P.IExtHostOutputService)),jt=te.set(r.ExtHostContext.ExtHostUrls,new Y.ExtHostUrls(te)),_t=te.set(r.ExtHostContext.ExtHostDocuments,new i.ExtHostDocuments(te,ht)),Jt=te.set(r.ExtHostContext.ExtHostDocumentContentProviders,new g.ExtHostDocumentContentProvider(te,ht,U)),Xt=te.set(r.ExtHostContext.ExtHostDocumentSaveParticipant,new S.ExtHostDocumentSaveParticipant(U,_t,te.getProxy(r.MainContext.MainThreadBulkEdits))),gt=te.set(r.ExtHostContext.ExtHostNotebook,new se.ExtHostNotebookController(te,ot,ht,_t,oe)),qt=te.set(r.ExtHostContext.ExtHostNotebookDocuments,new Pe.ExtHostNotebookDocuments(U,gt)),zt=te.set(r.ExtHostContext.ExtHostNotebookEditors,new Ct.ExtHostNotebookEditors(U,te,gt)),Zt=te.set(r.ExtHostContext.ExtHostNotebookKernels,new dt.ExtHostNotebookKernels(te,ue,gt,U)),ei=te.set(r.ExtHostContext.ExtHostNotebookRenderers,new mt.ExtHostNotebookRenderers(te,gt)),It=te.set(r.ExtHostContext.ExtHostEditors,new ie.ExtHostEditors(te,ht)),hi=te.set(r.ExtHostContext.ExtHostTreeViews,new V.ExtHostTreeViews(te.getProxy(r.MainContext.MainThreadTreeViews),ot,U)),ti=te.set(r.ExtHostContext.ExtHostEditorInsets,new ae.ExtHostEditorInsets(te.getProxy(r.MainContext.MainThreadEditorInsets),It,ue)),Ut=te.set(r.ExtHostContext.ExtHostDiagnostics,new b.ExtHostDiagnostics(te,U)),ct=te.set(r.ExtHostContext.ExtHostLanguageFeatures,new p.ExtHostLanguageFeatures(te,Je,_t,ot,Ut,U,Se)),ii=te.set(r.ExtHostContext.ExtHostFileSystem,new o.ExtHostFileSystem(te,ct)),Lt=te.set(r.ExtHostContext.ExtHostFileSystemEventService,new f.ExtHostFileSystemEventService(te,U,ht)),Ot=te.set(r.ExtHostContext.ExtHostQuickOpen,(0,m.createExtHostQuickOpen)(te,Ue,ot)),Gt=te.set(r.ExtHostContext.ExtHostSCM,new D.ExtHostSCM(te,ot,U)),Ei=te.set(r.ExtHostContext.ExtHostComments,(0,v.createExtHostComments)(te,ot,_t)),fi=te.set(r.ExtHostContext.ExtHostProgress,new n.ExtHostProgress(te.getProxy(r.MainContext.MainThreadProgress))),_i=te.set(r.ExtHostContext.ExtHosLabelService,new ve.ExtHostLabelService(te)),mi=te.set(r.ExtHostContext.ExtHostTheming,new H.ExtHostTheming(te)),ni=te.set(r.ExtHostContext.ExtHostAuthentication,new Te.ExtHostAuthentication(te)),ri=te.set(r.ExtHostContext.ExtHostTimeline,new xe.ExtHostTimeline(te,ot)),Ht=te.set(r.ExtHostContext.ExtHostWebviews,new B.ExtHostWebviews(te,{remote:ue.remote},Ue,U,Se)),si=te.set(r.ExtHostContext.ExtHostWebviewPanels,new he.ExtHostWebviewPanels(te,Ht,Ue)),yi=te.set(r.ExtHostContext.ExtHostCustomEditors,new K.ExtHostCustomEditors(te,_t,oe,Ht,si)),Si=te.set(r.ExtHostContext.ExtHostWebviewViews,new z.ExtHostWebviewViews(te,Ht)),Vt=te.set(r.ExtHostContext.ExtHostTesting,new tt.ExtHostTesting(te,ot)),Kt=te.set(r.ExtHostContext.ExtHostUriOpeners,new lt.ExtHostUriOpeners(te));te.set(r.ExtHostContext.ExtHostInteractive,new ye.ExtHostInteractive(te,gt,ht,ot));const Di=(0,le.values)(r.ExtHostContext);te.assertRegistered(Di);const Ci=new Le.ExtHostBulkEdits(te,ht),oi=new a.ExtHostClipboard(te),ai=new C.ExtHostMessageService(te,U),Bt=new c.ExtHostDialogs(te),Ft=new O.ExtHostStatusBar(te,ot.converter),Qt=new w.ExtHostLanguages(te,_t);return d.ExtHostApiCommands.register(ot),function(Ae,$t,gi){const pt=function(){let J=!Ae.isUnderDevelopment;function ce(Ce){J||(U.info(`Extension '${Ae.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),J=!0)}return function Ce(rt){if(Array.isArray(rt))rt.forEach(Ce);else if(typeof rt=="string")ce(rt);else{const wt=rt;typeof wt.scheme=="undefined"&&ce(rt),!Ae.enableProposedApi&&typeof wt.exclusive=="boolean"&&(0,j.throwProposedApiError)(Ae)}return rt}}(),ki={getSession(J,ce,Ce){return Ce?.forceNewSession&&(0,j.checkProposedApiEnabled)(Ae),ni.getSession(Ae,J,ce,Ce)},get onDidChangeSessions(){return ni.onDidChangeSessions},registerAuthenticationProvider(J,ce,Ce,rt){return ni.registerAuthenticationProvider(J,ce,Ce,rt)}},Ii={registerCommand(J,ce,Ce){return ot.registerCommand(!0,J,ce,Ce)},registerTextEditorCommand(J,ce,Ce){return ot.registerCommand(!0,J,(...rt)=>{const wt=It.getActiveTextEditor();if(!wt){U.warn("Cannot execute "+J+" because there is no active text editor.");return}return wt.edit(Dt=>{ce.apply(Ce,[wt,Dt,...rt])}).then(Dt=>{Dt||U.warn("Edits from command "+J+" were not applied.")},Dt=>{U.warn("An error occurred while running command "+J,Dt)})})},registerDiffInformationCommand:(J,ce,Ce)=>((0,j.checkProposedApiEnabled)(Ae),ot.registerCommand(!0,J,async(...rt)=>{const wt=ht.activeEditor(!0);if(!wt){U.warn("Cannot execute "+J+" because there is no active text editor.");return}const Dt=await It.getDiffInformation(wt.id);ce.apply(Ce,[Dt,...rt])})),executeCommand(J,...ce){return ot.executeCommand(J,...ce)},getCommands(J=!1){return ot.getCommands(J)}},pi={get machineId(){return ue.telemetryInfo.machineId},get sessionId(){return ue.telemetryInfo.sessionId},get language(){return ue.environment.appLanguage},get appName(){return ue.environment.appName},get appRoot(){return ue.environment.appRoot?.fsPath??""},get embedderIdentifier(){return ue.environment.embedderIdentifier},get uriScheme(){return ue.environment.appUriScheme},get clipboard(){return oi.value},get shell(){return st.getDefaultShell(!1)},get isTelemetryEnabled(){return Me.getTelemetryEnabled()},get onDidChangeTelemetryEnabled(){return Me.onDidChangeTelemetryEnabled},get isNewAppInstall(){const J=Date.now()-new Date(ue.telemetryInfo.firstSessionDate).getTime();return isNaN(J)?!1:J<1e3*60*60*24},openExternal(J,ce){return qe.openUri(J,{allowTunneling:!!ue.remote.authority,allowContributedOpeners:ce?.allowContributedOpeners})},async asExternalUri(J){if(J.scheme===ue.environment.appUriScheme)return jt.createAppUri(J);try{return await qe.asExternalUri(J,{allowTunneling:!!ue.remote.authority})}catch(ce){if((0,Ye.matchesScheme)(J,Et.Schemas.http)||(0,Ye.matchesScheme)(J,Et.Schemas.https))return J;throw ce}},get remoteName(){return(0,Re.getRemoteName)(ue.remote.authority)},get uiKind(){return ue.uiKind}};ue.environment.extensionTestsLocationURI||Object.freeze(pi);const vi=ue.remote.isRemote?L.ExtensionKind.Workspace:L.ExtensionKind.UI,Pi={createTestController(J,ce){return Vt.createTestController(J,ce)},createTestObserver(){return(0,j.checkProposedApiEnabled)(Ae),Vt.createTestObserver()},runTests(J){return(0,j.checkProposedApiEnabled)(Ae),Vt.runTests(J)},get onDidChangeTestResults(){return(0,j.checkProposedApiEnabled)(Ae),Vt.onResultsChanged},get testResults(){return(0,j.checkProposedApiEnabled)(Ae),Vt.results}},li={getExtension(J){const ce=$t.getExtensionDescription(J);if(ce)return new u.Extension(Ie,Ae.identifier,ce,vi)},get all(){return $t.getAllExtensionDescriptions().map(J=>new u.Extension(Ie,Ae.identifier,J,vi))},get onDidChange(){return $t.onDidChange}},Ti={createDiagnosticCollection(J){return Ut.createDiagnosticCollection(Ae.identifier,J)},get onDidChangeDiagnostics(){return Ut.onDidChangeDiagnostics},getDiagnostics:J=>Ut.getDiagnostics(J),getLanguages(){return Qt.getLanguages()},setTextDocumentLanguage(J,ce){return Qt.changeLanguage(J.uri,ce)},match(J,ce){return(0,t.score)(W.LanguageSelector.from(J),ce.uri,ce.languageId,!0)},registerCodeActionsProvider(J,ce,Ce){return ct.registerCodeActionProvider(Ae,pt(J),ce,Ce)},registerCodeLensProvider(J,ce){return ct.registerCodeLensProvider(Ae,pt(J),ce)},registerDefinitionProvider(J,ce){return ct.registerDefinitionProvider(Ae,pt(J),ce)},registerDeclarationProvider(J,ce){return ct.registerDeclarationProvider(Ae,pt(J),ce)},registerImplementationProvider(J,ce){return ct.registerImplementationProvider(Ae,pt(J),ce)},registerTypeDefinitionProvider(J,ce){return ct.registerTypeDefinitionProvider(Ae,pt(J),ce)},registerHoverProvider(J,ce){return ct.registerHoverProvider(Ae,pt(J),ce,Ae.identifier)},registerEvaluatableExpressionProvider(J,ce){return ct.registerEvaluatableExpressionProvider(Ae,pt(J),ce,Ae.identifier)},registerInlineValuesProvider(J,ce){return ct.registerInlineValuesProvider(Ae,pt(J),ce,Ae.identifier)},registerDocumentHighlightProvider(J,ce){return ct.registerDocumentHighlightProvider(Ae,pt(J),ce)},registerLinkedEditingRangeProvider(J,ce){return ct.registerLinkedEditingRangeProvider(Ae,pt(J),ce)},registerReferenceProvider(J,ce){return ct.registerReferenceProvider(Ae,pt(J),ce)},registerRenameProvider(J,ce){return ct.registerRenameProvider(Ae,pt(J),ce)},registerDocumentSymbolProvider(J,ce,Ce){return ct.registerDocumentSymbolProvider(Ae,pt(J),ce,Ce)},registerWorkspaceSymbolProvider(J){return ct.registerWorkspaceSymbolProvider(Ae,J)},registerDocumentFormattingEditProvider(J,ce){return ct.registerDocumentFormattingEditProvider(Ae,pt(J),ce)},registerDocumentRangeFormattingEditProvider(J,ce){return ct.registerDocumentRangeFormattingEditProvider(Ae,pt(J),ce)},registerOnTypeFormattingEditProvider(J,ce,Ce,...rt){return ct.registerOnTypeFormattingEditProvider(Ae,pt(J),ce,[Ce].concat(rt))},registerDocumentSemanticTokensProvider(J,ce,Ce){return ct.registerDocumentSemanticTokensProvider(Ae,pt(J),ce,Ce)},registerDocumentRangeSemanticTokensProvider(J,ce,Ce){return ct.registerDocumentRangeSemanticTokensProvider(Ae,pt(J),ce,Ce)},registerSignatureHelpProvider(J,ce,Ce,...rt){return typeof Ce=="object"?ct.registerSignatureHelpProvider(Ae,pt(J),ce,Ce):ct.registerSignatureHelpProvider(Ae,pt(J),ce,typeof Ce=="undefined"?[]:[Ce,...rt])},registerCompletionItemProvider(J,ce,...Ce){return ct.registerCompletionItemProvider(Ae,pt(J),ce,Ce)},registerInlineCompletionItemProvider(J,ce){return(0,j.checkProposedApiEnabled)(Ae),ct.registerInlineCompletionsProvider(Ae,pt(J),ce)},registerDocumentLinkProvider(J,ce){return ct.registerDocumentLinkProvider(Ae,pt(J),ce)},registerColorProvider(J,ce){return ct.registerColorProvider(Ae,pt(J),ce)},registerFoldingRangeProvider(J,ce){return ct.registerFoldingRangeProvider(Ae,pt(J),ce)},registerSelectionRangeProvider(J,ce){return ct.registerSelectionRangeProvider(Ae,J,ce)},registerCallHierarchyProvider(J,ce){return ct.registerCallHierarchyProvider(Ae,J,ce)},setLanguageConfiguration:(J,ce)=>ct.setLanguageConfiguration(Ae,J,ce),getTokenInformationAtPosition(J,ce){return(0,j.checkProposedApiEnabled)(Ae),Qt.tokenAtPosition(J,ce)},registerInlayHintsProvider(J,ce){return(0,j.checkProposedApiEnabled)(Ae),ct.registerInlayHintsProvider(Ae,J,ce)},registerTypeHierarchyProvider(J,ce){return(0,j.checkProposedApiEnabled)(Ae),ct.registerTypeHierarchyProvider(Ae,J,ce)},createLanguageStatusItem(J){return(0,j.checkProposedApiEnabled)(Ae),Qt.createLanguageStatusItem(J)}},Ai={get activeTextEditor(){return It.getActiveTextEditor()},get visibleTextEditors(){return It.getVisibleTextEditors()},get activeTerminal(){return st.activeTerminal},get terminals(){return st.terminals},async showTextDocument(J,ce,Ce){const rt=await(R.URI.isUri(J)?Promise.resolve(wi.openTextDocument(J)):Promise.resolve(J));return It.showTextDocument(rt,ce,Ce)},createTextEditorDecorationType(J){return It.createTextEditorDecorationType(Ae,J)},onDidChangeActiveTextEditor(J,ce,Ce){return It.onDidChangeActiveTextEditor(J,ce,Ce)},onDidChangeVisibleTextEditors(J,ce,Ce){return It.onDidChangeVisibleTextEditors(J,ce,Ce)},onDidChangeTextEditorSelection(J,ce,Ce){return It.onDidChangeTextEditorSelection(J,ce,Ce)},onDidChangeTextEditorOptions(J,ce,Ce){return It.onDidChangeTextEditorOptions(J,ce,Ce)},onDidChangeTextEditorVisibleRanges(J,ce,Ce){return It.onDidChangeTextEditorVisibleRanges(J,ce,Ce)},onDidChangeTextEditorViewColumn(J,ce,Ce){return It.onDidChangeTextEditorViewColumn(J,ce,Ce)},onDidCloseTerminal(J,ce,Ce){return st.onDidCloseTerminal(J,ce,Ce)},onDidOpenTerminal(J,ce,Ce){return st.onDidOpenTerminal(J,ce,Ce)},onDidChangeActiveTerminal(J,ce,Ce){return st.onDidChangeActiveTerminal(J,ce,Ce)},onDidChangeTerminalDimensions(J,ce,Ce){return(0,j.checkProposedApiEnabled)(Ae),st.onDidChangeTerminalDimensions(J,ce,Ce)},onDidChangeTerminalState(J,ce,Ce){return(0,j.checkProposedApiEnabled)(Ae),st.onDidChangeTerminalState(J,ce,Ce)},onDidWriteTerminalData(J,ce,Ce){return(0,j.checkProposedApiEnabled)(Ae),st.onDidWriteTerminalData(J,ce,Ce)},get state(){return qe.state},onDidChangeWindowState(J,ce,Ce){return qe.onDidChangeWindowState(J,ce,Ce)},showInformationMessage(J,...ce){return ai.showMessage(Ae,A.default.Info,J,ce[0],ce.slice(1))},showWarningMessage(J,...ce){return ai.showMessage(Ae,A.default.Warning,J,ce[0],ce.slice(1))},showErrorMessage(J,...ce){return ai.showMessage(Ae,A.default.Error,J,ce[0],ce.slice(1))},showQuickPick(J,ce,Ce){return Ot.showQuickPick(J,!!Ae.enableProposedApi,ce,Ce)},showWorkspaceFolderPick(J){return Ot.showWorkspaceFolderPick(J)},showInputBox(J,ce){return Ot.showInput(J,ce)},showOpenDialog(J){return Bt.showOpenDialog(J)},showSaveDialog(J){return Bt.showSaveDialog(J)},createStatusBarItem(J,ce,Ce){let rt,wt,Dt;return typeof J=="string"?(rt=J,wt=ce,Dt=Ce):(wt=J,Dt=ce),Ft.createStatusBarEntry(Ae,rt,wt,Dt)},setStatusBarMessage(J,ce){return Ft.setStatusBarMessage(J,ce)},withScmProgress(J){return Se.report("window.withScmProgress",Ae,"Use 'withProgress' instead."),fi.withProgress(Ae,{location:L.ProgressLocation.SourceControl},(ce,Ce)=>J({report(rt){}}))},withProgress(J,ce){return fi.withProgress(Ae,J,ce)},createOutputChannel(J){return Wt.createOutputChannel(J,Ae)},createWebviewPanel(J,ce,Ce,rt){return si.createWebviewPanel(Ae,J,ce,Ce,rt)},createWebviewTextEditorInset(J,ce,Ce,rt){return(0,j.checkProposedApiEnabled)(Ae),ti.createWebviewEditorInset(J,ce,Ce,rt,Ae)},createTerminal(J,ce,Ce){return typeof J=="object"?"pty"in J?st.createExtensionTerminal(J):st.createTerminalFromOptions(J):st.createTerminal(J,ce,Ce)},registerTerminalLinkProvider(J){return st.registerLinkProvider(J)},registerTerminalProfileProvider(J,ce){return st.registerProfileProvider(Ae,J,ce)},registerTreeDataProvider(J,ce){return hi.registerTreeDataProvider(J,ce,Ae)},createTreeView(J,ce){return hi.createTreeView(J,ce,Ae)},registerWebviewPanelSerializer:(J,ce)=>si.registerWebviewPanelSerializer(Ae,J,ce),registerCustomEditorProvider:(J,ce,Ce={})=>yi.registerCustomEditorProvider(Ae,J,ce,Ce),registerFileDecorationProvider(J){return vt.registerFileDecorationProvider(J,Ae.identifier)},registerUriHandler(J){return jt.registerUriHandler(Ae.identifier,J)},createQuickPick(){return Ot.createQuickPick(Ae.identifier,!!Ae.enableProposedApi)},createInputBox(){return Ot.createInputBox(Ae.identifier)},get activeColorTheme(){return mi.activeColorTheme},onDidChangeActiveColorTheme(J,ce,Ce){return mi.onDidChangeActiveColorTheme(J,ce,Ce)},registerWebviewViewProvider(J,ce,Ce){return Si.registerWebviewViewProvider(Ae,J,ce,Ce?.webviewOptions)},get activeNotebookEditor(){return(0,j.checkProposedApiEnabled)(Ae),gt.activeNotebookEditor},onDidChangeActiveNotebookEditor(J,ce,Ce){return(0,j.checkProposedApiEnabled)(Ae),gt.onDidChangeActiveNotebookEditor(J,ce,Ce)},get visibleNotebookEditors(){return(0,j.checkProposedApiEnabled)(Ae),gt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return(0,j.checkProposedApiEnabled)(Ae),gt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(J,ce,Ce){return(0,j.checkProposedApiEnabled)(Ae),zt.onDidChangeNotebookEditorSelection(J,ce,Ce)},onDidChangeNotebookEditorVisibleRanges(J,ce,Ce){return(0,j.checkProposedApiEnabled)(Ae),zt.onDidChangeNotebookEditorVisibleRanges(J,ce,Ce)},showNotebookDocument(J,ce){return(0,j.checkProposedApiEnabled)(Ae),gt.showNotebookDocument(J,ce)},registerExternalUriOpener(J,ce,Ce){return(0,j.checkProposedApiEnabled)(Ae),Kt.registerExternalUriOpener(Ae.identifier,J,ce,Ce)},get openEditors(){return(0,j.checkProposedApiEnabled)(Ae),it.tabs},get onDidChangeOpenEditors(){return(0,j.checkProposedApiEnabled)(Ae),it.onDidChangeTabs},getInlineCompletionItemController(J){return(0,j.checkProposedApiEnabled)(Ae),p.InlineCompletionController.get(J)}},wi={get rootPath(){return Se.report("workspace.rootPath",Ae,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),Ue.getPath()},set rootPath(J){throw F.readonly()},getWorkspaceFolder(J){return Ue.getWorkspaceFolder(J)},get workspaceFolders(){return Ue.getWorkspaceFolders()},get name(){return Ue.name},set name(J){throw F.readonly()},get workspaceFile(){return Ue.workspaceFile},set workspaceFile(J){throw F.readonly()},updateWorkspaceFolders:(J,ce,...Ce)=>Ue.updateWorkspaceFolders(Ae,J,ce||0,...Ce),onDidChangeWorkspaceFolders:function(J,ce,Ce){return Ue.onDidChangeWorkspace(J,ce,Ce)},asRelativePath:(J,ce)=>Ue.getRelativePath(J,ce),findFiles:(J,ce,Ce,rt)=>Ue.findFiles(W.GlobPattern.from(J),W.GlobPattern.from(ce),Ce,Ae.identifier,rt),findTextInFiles:(J,ce,Ce,rt)=>{let wt,Dt;return typeof ce=="object"?(wt=ce,Dt=Ce):(wt={},Dt=ce,rt=Ce),Ue.findTextInFiles(J,wt||{},Dt,Ae.identifier,rt)},saveAll:J=>Ue.saveAll(J),applyEdit(J){return Ci.applyWorkspaceEdit(J)},createFileSystemWatcher:(J,ce,Ce,rt)=>Lt.createFileSystemWatcher(W.GlobPattern.from(J),ce,Ce,rt),get textDocuments(){return _t.getAllDocumentData().map(J=>J.document)},set textDocuments(J){throw F.readonly()},openTextDocument(J){let ce;const Ce=J;if(typeof J=="string")ce=Promise.resolve(R.URI.file(J));else if(R.URI.isUri(J))ce=Promise.resolve(J);else if(!Ce||typeof Ce=="object")ce=_t.createDocumentData(Ce);else throw new Error("illegal argument - uriOrFileNameOrOptions");return ce.then(rt=>_t.ensureDocumentData(rt).then(wt=>wt.document))},onDidOpenTextDocument:(J,ce,Ce)=>_t.onDidAddDocument(J,ce,Ce),onDidCloseTextDocument:(J,ce,Ce)=>_t.onDidRemoveDocument(J,ce,Ce),onDidChangeTextDocument:(J,ce,Ce)=>_t.onDidChangeDocument(J,ce,Ce),onDidSaveTextDocument:(J,ce,Ce)=>_t.onDidSaveDocument(J,ce,Ce),onWillSaveTextDocument:(J,ce,Ce)=>Xt.getOnWillSaveTextDocumentEvent(Ae)(J,ce,Ce),get notebookDocuments(){return gt.notebookDocuments.map(J=>J.apiNotebook)},async openNotebookDocument(J,ce){let Ce;if(R.URI.isUri(J))Ce=J,await gt.openNotebookDocument(J);else if(typeof J=="string")Ce=R.URI.revive(await gt.createNotebookDocument({viewType:J,content:ce}));else throw new Error("Invalid arguments");return gt.getNotebookDocument(Ce).apiNotebook},get onDidOpenNotebookDocument(){return gt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return gt.onDidCloseNotebookDocument},registerNotebookSerializer(J,ce,Ce,rt){return gt.registerNotebookSerializer(Ae,J,ce,Ce,Ae.enableProposedApi?rt:void 0)},registerNotebookContentProvider:(J,ce,Ce,rt)=>((0,j.checkProposedApiEnabled)(Ae),gt.registerNotebookContentProvider(Ae,J,ce,Ce,Ae.enableProposedApi?rt:void 0)),onDidChangeConfiguration:(J,ce,Ce)=>gi.onDidChangeConfiguration(J,ce,Ce),getConfiguration(J,ce){return ce=arguments.length===1?void 0:ce,gi.getConfiguration(J,ce,Ae)},registerTextDocumentContentProvider(J,ce){return Jt.registerTextDocumentContentProvider(J,ce)},registerTaskProvider:(J,ce)=>(Se.report("window.registerTaskProvider",Ae,"Use the corresponding function on the 'tasks' namespace instead"),Tt.registerTaskProvider(Ae,J,ce)),registerFileSystemProvider(J,ce,Ce){return ii.registerFileSystemProvider(Ae.identifier,J,ce,Ce,Ae.enableProposedApi)},get fs(){return me.value},registerFileSearchProvider:(J,ce)=>((0,j.checkProposedApiEnabled)(Ae),kt.registerFileSearchProvider(J,ce)),registerTextSearchProvider:(J,ce)=>((0,j.checkProposedApiEnabled)(Ae),kt.registerTextSearchProvider(J,ce)),registerRemoteAuthorityResolver:(J,ce)=>((0,j.checkProposedApiEnabled)(Ae),Ie.registerRemoteAuthorityResolver(J,ce)),registerResourceLabelFormatter:J=>((0,j.checkProposedApiEnabled)(Ae),_i.$registerResourceLabelFormatter(J)),onDidCreateFiles:(J,ce,Ce)=>Lt.onDidCreateFile(J,ce,Ce),onDidDeleteFiles:(J,ce,Ce)=>Lt.onDidDeleteFile(J,ce,Ce),onDidRenameFiles:(J,ce,Ce)=>Lt.onDidRenameFile(J,ce,Ce),onWillCreateFiles:(J,ce,Ce)=>Lt.getOnWillCreateFileEvent(Ae)(J,ce,Ce),onWillDeleteFiles:(J,ce,Ce)=>Lt.getOnWillDeleteFileEvent(Ae)(J,ce,Ce),onWillRenameFiles:(J,ce,Ce)=>Lt.getOnWillRenameFileEvent(Ae)(J,ce,Ce),openTunnel:J=>((0,j.checkProposedApiEnabled)(Ae),De.openTunnel(Ae,J).then(ce=>{if(!ce)throw new Error("cannot open tunnel");return ce})),get tunnels(){return(0,j.checkProposedApiEnabled)(Ae),De.getTunnels()},onDidChangeTunnels:(J,ce,Ce)=>((0,j.checkProposedApiEnabled)(Ae),De.onDidChangeTunnels(J,ce,Ce)),registerPortAttributesProvider:(J,ce)=>((0,j.checkProposedApiEnabled)(Ae),De.registerPortsAttributesProvider(J,ce)),registerTimelineProvider:(J,ce)=>((0,j.checkProposedApiEnabled)(Ae),ri.registerTimelineProvider(J,ce,Ae.identifier,ot.converter)),get isTrusted(){return Ue.trusted},requestWorkspaceTrust:J=>((0,j.checkProposedApiEnabled)(Ae),Ue.requestWorkspaceTrust(J)),onDidGrantWorkspaceTrust:(J,ce,Ce)=>Ue.onDidGrantWorkspaceTrust(J,ce,Ce)},Ri={get inputBox(){return Se.report("scm.inputBox",Ae,"Use 'SourceControl.inputBox' instead"),Gt.getLastInputBox(Ae)},createSourceControl(J,ce,Ce){return Gt.createSourceControl(Ae,J,ce,Ce)}},Fi={createCommentController(J,ce){return Ei.createCommentController(Ae,J,ce)}},Mi={get activeDebugSession(){return ut.activeDebugSession},get activeDebugConsole(){return ut.activeDebugConsole},get breakpoints(){return ut.breakpoints},onDidStartDebugSession(J,ce,Ce){return ut.onDidStartDebugSession(J,ce,Ce)},onDidTerminateDebugSession(J,ce,Ce){return ut.onDidTerminateDebugSession(J,ce,Ce)},onDidChangeActiveDebugSession(J,ce,Ce){return ut.onDidChangeActiveDebugSession(J,ce,Ce)},onDidReceiveDebugSessionCustomEvent(J,ce,Ce){return ut.onDidReceiveDebugSessionCustomEvent(J,ce,Ce)},onDidChangeBreakpoints(J,ce,Ce){return ut.onDidChangeBreakpoints(J,ce,Ce)},registerDebugConfigurationProvider(J,ce,Ce){return ut.registerDebugConfigurationProvider(J,ce,Ce||L.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(J,ce){return ut.registerDebugAdapterDescriptorFactory(Ae,J,ce)},registerDebugAdapterTrackerFactory(J,ce){return ut.registerDebugAdapterTrackerFactory(J,ce)},startDebugging(J,ce,Ce){return!Ce||typeof Ce=="object"&&"configuration"in Ce?ut.startDebugging(J,ce,{parentSession:Ce}):ut.startDebugging(J,ce,Ce||{})},stopDebugging(J){return ut.stopDebugging(J)},addBreakpoints(J){return ut.addBreakpoints(J)},removeBreakpoints(J){return ut.removeBreakpoints(J)},asDebugSourceUri(J,ce){return ut.asDebugSourceUri(J,ce)}},Li={registerTaskProvider:(J,ce)=>Tt.registerTaskProvider(Ae,J,ce),fetchTasks:J=>Tt.fetchTasks(J),executeTask:J=>Tt.executeTask(Ae,J),get taskExecutions(){return Tt.taskExecutions},onDidStartTask:(J,ce,Ce)=>Tt.onDidStartTask(J,ce,Ce),onDidEndTask:(J,ce,Ce)=>Tt.onDidEndTask(J,ce,Ce),onDidStartTaskProcess:(J,ce,Ce)=>Tt.onDidStartTaskProcess(J,ce,Ce),onDidEndTaskProcess:(J,ce,Ce)=>Tt.onDidEndTaskProcess(J,ce,Ce)},ui={createNotebookController(J,ce,Ce,rt,wt){return Zt.createNotebookController(Ae,J,ce,Ce,rt,Ae.enableProposedApi?wt:void 0)},registerNotebookCellStatusBarItemProvider:(J,ce)=>gt.registerNotebookCellStatusBarItemProvider(Ae,J,ce),get onDidSaveNotebookDocument(){return(0,j.checkProposedApiEnabled)(Ae),qt.onDidSaveNotebookDocument},createNotebookEditorDecorationType(J){return(0,j.checkProposedApiEnabled)(Ae),zt.createNotebookEditorDecorationType(J)},createRendererMessaging(J){return ei.createRendererMessaging(Ae,J)},onDidChangeNotebookDocumentMetadata(J,ce,Ce){return(0,j.checkProposedApiEnabled)(Ae),qt.onDidChangeNotebookDocumentMetadata(J,ce,Ce)},onDidChangeNotebookCells(J,ce,Ce){return(0,j.checkProposedApiEnabled)(Ae),gt.onDidChangeNotebookCells(J,ce,Ce)},onDidChangeNotebookCellExecutionState(J,ce,Ce){return(0,j.checkProposedApiEnabled)(Ae),gt.onDidChangeNotebookCellExecutionState(J,ce,Ce)},onDidChangeCellOutputs(J,ce,Ce){return(0,j.checkProposedApiEnabled)(Ae),gt.onDidChangeCellOutputs(J,ce,Ce)},onDidChangeCellMetadata(J,ce,Ce){return(0,j.checkProposedApiEnabled)(Ae),gt.onDidChangeCellMetadata(J,ce,Ce)},createConcatTextDocument(J,ce){return(0,j.checkProposedApiEnabled)(Ae),new $e.ExtHostNotebookConcatDocument(gt,_t,J,ce)}};return{version:ue.version,authentication:ki,commands:Ii,comments:Fi,debug:Mi,env:pi,extensions:li,languages:Ti,notebooks:ui,scm:Ri,tasks:Li,tests:Pi,window:Ai,workspace:wi,Breakpoint:L.Breakpoint,CallHierarchyIncomingCall:L.CallHierarchyIncomingCall,CallHierarchyItem:L.CallHierarchyItem,CallHierarchyOutgoingCall:L.CallHierarchyOutgoingCall,CancellationError:F.CancellationError,CancellationTokenSource:h.CancellationTokenSource,CandidatePortSource:r.CandidatePortSource,CodeAction:L.CodeAction,CodeActionKind:L.CodeActionKind,CodeActionTriggerKind:L.CodeActionTriggerKind,CodeLens:L.CodeLens,Color:L.Color,ColorInformation:L.ColorInformation,ColorPresentation:L.ColorPresentation,ColorThemeKind:L.ColorThemeKind,CommentMode:L.CommentMode,CommentThreadCollapsibleState:L.CommentThreadCollapsibleState,CompletionItem:L.CompletionItem,CompletionItemKind:L.CompletionItemKind,CompletionItemTag:L.CompletionItemTag,CompletionList:L.CompletionList,CompletionTriggerKind:L.CompletionTriggerKind,ConfigurationTarget:L.ConfigurationTarget,CustomExecution:L.CustomExecution,DebugAdapterExecutable:L.DebugAdapterExecutable,DebugAdapterInlineImplementation:L.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:L.DebugAdapterNamedPipeServer,DebugAdapterServer:L.DebugAdapterServer,DebugConfigurationProviderTriggerKind:L.DebugConfigurationProviderTriggerKind,DebugConsoleMode:L.DebugConsoleMode,DecorationRangeBehavior:L.DecorationRangeBehavior,Diagnostic:L.Diagnostic,DiagnosticRelatedInformation:L.DiagnosticRelatedInformation,DiagnosticSeverity:L.DiagnosticSeverity,DiagnosticTag:L.DiagnosticTag,Disposable:L.Disposable,DocumentHighlight:L.DocumentHighlight,DocumentHighlightKind:L.DocumentHighlightKind,DocumentLink:L.DocumentLink,DocumentSymbol:L.DocumentSymbol,EndOfLine:L.EndOfLine,EnvironmentVariableMutatorType:L.EnvironmentVariableMutatorType,EvaluatableExpression:L.EvaluatableExpression,InlineValueText:L.InlineValueText,InlineValueVariableLookup:L.InlineValueVariableLookup,InlineValueEvaluatableExpression:L.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:L.InlineCompletionTriggerKind,EventEmitter:E.Emitter,ExtensionKind:L.ExtensionKind,ExtensionMode:L.ExtensionMode,ExternalUriOpenerPriority:L.ExternalUriOpenerPriority,FileChangeType:L.FileChangeType,FileDecoration:L.FileDecoration,FileSystemError:L.FileSystemError,FileType:_.FileType,FilePermission:_.FilePermission,FoldingRange:L.FoldingRange,FoldingRangeKind:L.FoldingRangeKind,FunctionBreakpoint:L.FunctionBreakpoint,InlineCompletionItem:L.InlineSuggestion,InlineCompletionList:L.InlineSuggestions,Hover:L.Hover,IndentAction:k.IndentAction,Location:L.Location,MarkdownString:L.MarkdownString,OverviewRulerLane:y.OverviewRulerLane,ParameterInformation:L.ParameterInformation,PortAutoForwardAction:L.PortAutoForwardAction,Position:L.Position,ProcessExecution:L.ProcessExecution,ProgressLocation:L.ProgressLocation,QuickInputButtons:L.QuickInputButtons,Range:L.Range,RelativePattern:L.RelativePattern,Selection:L.Selection,SelectionRange:L.SelectionRange,SemanticTokens:L.SemanticTokens,SemanticTokensBuilder:L.SemanticTokensBuilder,SemanticTokensEdit:L.SemanticTokensEdit,SemanticTokensEdits:L.SemanticTokensEdits,SemanticTokensLegend:L.SemanticTokensLegend,ShellExecution:L.ShellExecution,ShellQuoting:L.ShellQuoting,SignatureHelp:L.SignatureHelp,SignatureHelpTriggerKind:L.SignatureHelpTriggerKind,SignatureInformation:L.SignatureInformation,SnippetString:L.SnippetString,SourceBreakpoint:L.SourceBreakpoint,StandardTokenType:L.StandardTokenType,StatusBarAlignment:L.StatusBarAlignment,SymbolInformation:L.SymbolInformation,SymbolKind:L.SymbolKind,SymbolTag:L.SymbolTag,Task:L.Task,TaskGroup:L.TaskGroup,TaskPanelKind:L.TaskPanelKind,TaskRevealKind:L.TaskRevealKind,TaskScope:L.TaskScope,TerminalLink:L.TerminalLink,TerminalProfile:L.TerminalProfile,TextDocumentSaveReason:L.TextDocumentSaveReason,TextEdit:L.TextEdit,TextEditorCursorStyle:I.TextEditorCursorStyle,TextEditorLineNumbersStyle:L.TextEditorLineNumbersStyle,TextEditorRevealType:L.TextEditorRevealType,TextEditorSelectionChangeKind:L.TextEditorSelectionChangeKind,TextDocumentChangeReason:L.TextDocumentChangeReason,ThemeColor:L.ThemeColor,ThemeIcon:L.ThemeIcon,TreeItem:L.TreeItem,TreeItemCollapsibleState:L.TreeItemCollapsibleState,TypeHierarchyItem:L.TypeHierarchyItem,UIKind:r.UIKind,Uri:R.URI,ViewColumn:L.ViewColumn,WorkspaceEdit:L.WorkspaceEdit,InlayHint:L.InlayHint,InlayHintKind:L.InlayHintKind,RemoteAuthorityResolverError:L.RemoteAuthorityResolverError,ResolvedAuthority:L.ResolvedAuthority,SourceControlInputBoxValidationType:L.SourceControlInputBoxValidationType,ExtensionRuntime:L.ExtensionRuntime,TimelineItem:L.TimelineItem,NotebookRange:L.NotebookRange,NotebookCellKind:L.NotebookCellKind,NotebookCellExecutionState:L.NotebookCellExecutionState,NotebookCellData:L.NotebookCellData,NotebookData:L.NotebookData,NotebookRendererScript:L.NotebookRendererScript,NotebookCellStatusBarAlignment:L.NotebookCellStatusBarAlignment,NotebookEditorRevealType:L.NotebookEditorRevealType,NotebookCellOutput:L.NotebookCellOutput,NotebookCellOutputItem:L.NotebookCellOutputItem,NotebookCellStatusBarItem:L.NotebookCellStatusBarItem,NotebookControllerAffinity:L.NotebookControllerAffinity,PortAttributes:L.PortAttributes,LinkedEditingRanges:L.LinkedEditingRanges,TestResultState:L.TestResultState,TestRunRequest:L.TestRunRequest,TestMessage:L.TestMessage,TestTag:L.TestTag,TestRunProfileKind:L.TestRunProfileKind,TextSearchCompleteMessageType:bt.TextSearchCompleteMessageType,CoveredCount:L.CoveredCount,FileCoverage:L.FileCoverage,StatementCoverage:L.StatementCoverage,BranchCoverage:L.BranchCoverage,FunctionCoverage:L.FunctionCoverage,WorkspaceTrustState:L.WorkspaceTrustState,LanguageStatusSeverity:L.LanguageStatusSeverity}}}e.createApiFactoryAndRegisterActors=ke}),define(be[223],Ee([0,1,56,96,31,95,32,47,48,37,99,100,101,72,65,70,97,71,45,69,87,63]),function(re,e,h,F,E,A,R,I,y,k,t,_,r,d,a,l,v,T,b,c,g,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(l.IExtHostApiDeprecationService,l.ExtHostApiDeprecationService),(0,h.registerSingleton)(I.IExtHostCommands,I.ExtHostCommands),(0,h.registerSingleton)(R.IExtHostConfiguration,R.ExtHostConfiguration),(0,h.registerSingleton)(T.IExtHostConsumerFileSystem,T.ExtHostConsumerFileSystem),(0,h.registerSingleton)(_.IExtHostDebugService,_.WorkerExtHostDebugService),(0,h.registerSingleton)(A.IExtHostDecorations,A.ExtHostDecorations),(0,h.registerSingleton)(y.IExtHostDocumentsAndEditors,y.ExtHostDocumentsAndEditors),(0,h.registerSingleton)(b.IExtHostFileSystemInfo,b.ExtHostFileSystemInfo),(0,h.registerSingleton)(F.IExtHostOutputService,F.ExtHostOutputService),(0,h.registerSingleton)(r.IExtHostSearch,r.ExtHostSearch),(0,h.registerSingleton)(d.IExtHostStorage,d.ExtHostStorage),(0,h.registerSingleton)(t.IExtHostTask,t.WorkerExtHostTask),(0,h.registerSingleton)(k.IExtHostTerminalService,k.WorkerExtHostTerminalService),(0,h.registerSingleton)(a.IExtHostTunnelService,a.ExtHostTunnelService),(0,h.registerSingleton)(v.IExtHostWindow,v.ExtHostWindow),(0,h.registerSingleton)(E.IExtHostWorkspace,E.ExtHostWorkspace),(0,h.registerSingleton)(c.IExtHostSecretState,c.ExtHostSecretState),(0,h.registerSingleton)(g.IExtHostTelemetry,g.ExtHostTelemetry),(0,h.registerSingleton)(S.IExtHostEditorTabs,S.ExtHostEditorTabs)}),define(be[224],Ee([0,1,222,33,218,6,13,5,11]),function(re,e,h,F,E,A,R,I,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;var k;(function(a){const l=self.trustedTypes?.createPolicy("TrustedFunctionWorkaround",{createScript:(T,...b)=>{b.forEach(i=>{if(!self.trustedTypes?.isScript(i))throw new Error("TrustedScripts only, please")});const c=b.slice(0,-1).join(","),g=b.pop().toString();return`(function anonymous(${c}) {
${g}
})`}});function v(...T){return l?self.eval(l.createScript("",...T)):new Function(...T)}a.create=v})(k||(k={}));class t extends E.RequireInterceptor{_installInterceptor(){}getModule(l,v){for(let T of this._alternatives){let b=T(l);if(b){l=b;break}}if(this._factories.has(l))return this._factories.get(l).load(l,v,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class _ extends F.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=A.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){const l=this._extHostContext.getProxy(I.MainContext.MainThreadConsole);d(l,this._initData.environment.isExtensionDevelopmentDebug);const v=this._instaService.invokeFunction(h.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(t,v,this._registry),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(l){return l.browser}async _loadCommonJSModule(l,v,T){v=v.with({path:r(v.path,".js")}),l&&performance.mark(`code/extHost/willFetchExtensionCode/${l.value}`);const b=await fetch(y.FileAccess.asBrowserUri(v).toString(!0));if(l&&performance.mark(`code/extHost/didFetchExtensionCode/${l.value}`),b.status!==200)throw new Error(b.statusText);const c=await b.text(),g=`${v.toString(!0)}#vscode-extension`,S=`${c}
//# sourceURL=${g}`;let i;try{i=k.create(_._ttpExtensionScripts?.createScript("module")??"module",_._ttpExtensionScripts?.createScript("exports")??"exports",_._ttpExtensionScripts?.createScript("require")??"require",_._ttpExtensionScripts?.createScript(S)??S)}catch(f){throw console.error(l?`Loading code for extension ${l.value} failed: ${f.message}`:`Loading code failed: ${f.message}`),console.error(`${v.toString(!0)}${typeof f.line=="number"?` line ${f.line}`:""}${typeof f.column=="number"?` column ${f.column}`:""}`),console.error(f),f}const s={},u={exports:s},o=f=>{const p=this._fakeModules.getModule(f,v);if(p===void 0)throw new Error(`Cannot load module '${f}'`);return p};try{return T.codeLoadingStart(),l&&performance.mark(`code/extHost/willLoadExtensionCode/${l.value}`),i(u,s,o),u.exports!==s?u.exports:s}finally{l&&performance.mark(`code/extHost/didLoadExtensionCode/${l.value}`),T.codeLoadingStop()}}async $setRemoteEnvironment(l){throw new Error("Not supported")}async _waitForDebuggerAttachment(l=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const v=Date.now()+l;for(;Date.now()<v&&!("__jsDebugIsReady"in globalThis);)await(0,R.timeout)(10)}}e.ExtHostExtensionService=_,_._ttpExtensionScripts=self.trustedTypes?.createPolicy("ExtensionScripts",{createScript:a=>a});function r(a,l){return a.endsWith(l)?a:a+l}function d(a,l){v("info","log"),v("log","log"),v("warn","warn"),v("error","error");function v(c,g){const S=console[c];console[c]=function(){a.$logExtensionHostMessage({type:"__$console",severity:g,arguments:b(arguments)}),l&&S.apply(console,arguments)}}const T=1e5;function b(c){const g=[],S=[];if(c.length)for(let i=0;i<c.length;i++){if(typeof c[i]=="undefined")c[i]="undefined";else if(c[i]instanceof Error){const s=c[i];s.stack?c[i]=s.stack:c[i]=s.toString()}S.push(c[i])}try{const i=JSON.stringify(S,function(s,u){if(u&&typeof u=="object"){if(g.indexOf(u)!==-1)return"[Circular]";g.push(u)}return u});return i.length>T?"Output omitted for a large object that exceeds the limits":i}catch(i){return`Output omitted for an object that cannot be inspected ('${i.toString()}')`}}}}),define(be[225],Ee([0,1,56,14,33,73,224,211]),function(re,e,h,F,E,A,R,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,h.registerSingleton)(E.IExtHostExtensionService,R.ExtHostExtensionService),(0,h.registerSingleton)(F.ILogService,I.ExtHostLogService),(0,h.registerSingleton)(A.IExtensionStoragePaths,A.ExtensionStoragePaths)}),define(be[234],Ee([0,1,23,3,176,219,213,17,74,11,2,223,225]),function(re,e,h,F,E,A,R,I,y,k,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const _=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const r=postMessage.bind(self);if(self.postMessage=()=>console.trace("'postMessage' has been blocked"),self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const b=self.trustedTypes?.createPolicy("extensionHostWorker",{createScriptURL:g=>g}),c=self.Worker;Worker=function(g,S){/^file:/i.test(g.toString())&&(g=k.FileAccess.asBrowserUri(t.URI.parse(g.toString())).toString(!0));const i=`(function() {
	const ttPolicy = self.trustedTypes ? self.trustedTypes.createPolicy('extensionHostWorker', { createScriptURL: (value) => value }) : undefined;
	const stringUrl = '${g}';
	importScripts(ttPolicy ? ttPolicy.createScriptURL(stringUrl) : stringUrl);
})();
`;S=S||{},S.name=S.name||I.basename(g.toString());const s=new Blob([i],{type:"application/javascript"}),u=URL.createObjectURL(s);return new c(b?b.createScriptURL(u):u,S)}}else self.Worker=class extends R.NestedWorker{constructor(b,c){super(r,b,{name:I.basename(b.toString()),...c})}};const d=new class{exit(b){_()}async exists(b){return!0}async realpath(b){return b}};class a{constructor(){const c=new MessageChannel,g=new F.Emitter;let S=!1;r(c.port2,[c.port2]),c.port1.onmessage=i=>{const{data:s}=i;if(!(s instanceof ArrayBuffer)){console.warn("UNKNOWN data received",s);return}const u=h.VSBuffer.wrap(new Uint8Array(s,0,s.byteLength));if((0,E.isMessageOfType)(u,2)){S=!0,v("received terminate message from renderer");return}g.fire(u)},this.protocol={onMessage:g.event,send:i=>{if(!S){const s=i.buffer.buffer.slice(i.buffer.byteOffset,i.buffer.byteOffset+i.buffer.byteLength);c.port1.postMessage(s,[s])}}}}}function l(b){return new Promise(c=>{const g=b.onMessage(S=>{g.dispose();const i=JSON.parse(S.toString());b.send((0,E.createMessageOfType)(0)),c({protocol:b,initData:i})});b.send((0,E.createMessageOfType)(1))})}let v=b=>_();function T(){const b=new a;y.mark("code/extHost/willConnectToRenderer"),l(b.protocol).then(c=>{y.mark("code/extHost/didWaitForInitData");const g=new A.ExtensionHostMain(c.protocol,c.initData,d,null);v=S=>g.terminate(S)})}e.create=T})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/af770c2dc85ef6835197a8bd7eb416fe0a022c44/core/vs/workbench/services/extensions/worker/extensionHostWorker.js.map
